/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>BWR Steam Supply</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getHighPowerLimit <em>High Power Limit</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getInCoreThermalTC <em>In Core Thermal TC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getIntegralGain <em>Integral Gain</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowerLimit <em>Lower Limit</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowPowerLimit <em>Low Power Limit</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureLimit <em>Pressure Limit</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointGA <em>Pressure Setpoint GA</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC1 <em>Pressure Setpoint TC1</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC2 <em>Pressure Setpoint TC2</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getProportionalGain <em>Proportional Gain</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux1 <em>Rf Aux1</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux2 <em>Rf Aux2</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux3 <em>Rf Aux3</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux4 <em>Rf Aux4</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux5 <em>Rf Aux5</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux6 <em>Rf Aux6</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux7 <em>Rf Aux7</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux8 <em>Rf Aux8</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPattern <em>Rod Pattern</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPatternConstant <em>Rod Pattern Constant</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getUpperLimit <em>Upper Limit</em>}</li>
 * </ul>
 *
 * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply()
 * @model
 * @generated
 */
public interface BWRSteamSupply extends SteamSupply {
    /**
     * Returns the value of the '<em><b>High Power Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>High Power Limit</em>' attribute.
     * @see #isSetHighPowerLimit()
     * @see #unsetHighPowerLimit()
     * @see #setHighPowerLimit(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_HighPowerLimit()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.highPowerLimit' kind='element'"
     * @generated
     */
    Float getHighPowerLimit();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getHighPowerLimit <em>High Power Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>High Power Limit</em>' attribute.
     * @see #isSetHighPowerLimit()
     * @see #unsetHighPowerLimit()
     * @see #getHighPowerLimit()
     * @generated
     */
    void setHighPowerLimit( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getHighPowerLimit <em>High Power Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetHighPowerLimit()
     * @see #getHighPowerLimit()
     * @see #setHighPowerLimit(Float)
     * @generated
     */
    void unsetHighPowerLimit();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getHighPowerLimit <em>High Power Limit</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>High Power Limit</em>' attribute is set.
     * @see #unsetHighPowerLimit()
     * @see #getHighPowerLimit()
     * @see #setHighPowerLimit(Float)
     * @generated
     */
    boolean isSetHighPowerLimit();

    /**
     * Returns the value of the '<em><b>In Core Thermal TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>In Core Thermal TC</em>' attribute.
     * @see #isSetInCoreThermalTC()
     * @see #unsetInCoreThermalTC()
     * @see #setInCoreThermalTC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_InCoreThermalTC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.inCoreThermalTC' kind='element'"
     * @generated
     */
    Float getInCoreThermalTC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getInCoreThermalTC <em>In Core Thermal TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>In Core Thermal TC</em>' attribute.
     * @see #isSetInCoreThermalTC()
     * @see #unsetInCoreThermalTC()
     * @see #getInCoreThermalTC()
     * @generated
     */
    void setInCoreThermalTC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getInCoreThermalTC <em>In Core Thermal TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetInCoreThermalTC()
     * @see #getInCoreThermalTC()
     * @see #setInCoreThermalTC(Float)
     * @generated
     */
    void unsetInCoreThermalTC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getInCoreThermalTC <em>In Core Thermal TC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>In Core Thermal TC</em>' attribute is set.
     * @see #unsetInCoreThermalTC()
     * @see #getInCoreThermalTC()
     * @see #setInCoreThermalTC(Float)
     * @generated
     */
    boolean isSetInCoreThermalTC();

    /**
     * Returns the value of the '<em><b>Integral Gain</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Integral Gain</em>' attribute.
     * @see #isSetIntegralGain()
     * @see #unsetIntegralGain()
     * @see #setIntegralGain(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_IntegralGain()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.integralGain' kind='element'"
     * @generated
     */
    Float getIntegralGain();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getIntegralGain <em>Integral Gain</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Integral Gain</em>' attribute.
     * @see #isSetIntegralGain()
     * @see #unsetIntegralGain()
     * @see #getIntegralGain()
     * @generated
     */
    void setIntegralGain( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getIntegralGain <em>Integral Gain</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetIntegralGain()
     * @see #getIntegralGain()
     * @see #setIntegralGain(Float)
     * @generated
     */
    void unsetIntegralGain();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getIntegralGain <em>Integral Gain</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Integral Gain</em>' attribute is set.
     * @see #unsetIntegralGain()
     * @see #getIntegralGain()
     * @see #setIntegralGain(Float)
     * @generated
     */
    boolean isSetIntegralGain();

    /**
     * Returns the value of the '<em><b>Lower Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Lower Limit</em>' attribute.
     * @see #isSetLowerLimit()
     * @see #unsetLowerLimit()
     * @see #setLowerLimit(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_LowerLimit()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.lowerLimit' kind='element'"
     * @generated
     */
    Float getLowerLimit();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowerLimit <em>Lower Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Lower Limit</em>' attribute.
     * @see #isSetLowerLimit()
     * @see #unsetLowerLimit()
     * @see #getLowerLimit()
     * @generated
     */
    void setLowerLimit( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowerLimit <em>Lower Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetLowerLimit()
     * @see #getLowerLimit()
     * @see #setLowerLimit(Float)
     * @generated
     */
    void unsetLowerLimit();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowerLimit <em>Lower Limit</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Lower Limit</em>' attribute is set.
     * @see #unsetLowerLimit()
     * @see #getLowerLimit()
     * @see #setLowerLimit(Float)
     * @generated
     */
    boolean isSetLowerLimit();

    /**
     * Returns the value of the '<em><b>Low Power Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Low Power Limit</em>' attribute.
     * @see #isSetLowPowerLimit()
     * @see #unsetLowPowerLimit()
     * @see #setLowPowerLimit(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_LowPowerLimit()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.lowPowerLimit' kind='element'"
     * @generated
     */
    Float getLowPowerLimit();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowPowerLimit <em>Low Power Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Low Power Limit</em>' attribute.
     * @see #isSetLowPowerLimit()
     * @see #unsetLowPowerLimit()
     * @see #getLowPowerLimit()
     * @generated
     */
    void setLowPowerLimit( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowPowerLimit <em>Low Power Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetLowPowerLimit()
     * @see #getLowPowerLimit()
     * @see #setLowPowerLimit(Float)
     * @generated
     */
    void unsetLowPowerLimit();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowPowerLimit <em>Low Power Limit</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Low Power Limit</em>' attribute is set.
     * @see #unsetLowPowerLimit()
     * @see #getLowPowerLimit()
     * @see #setLowPowerLimit(Float)
     * @generated
     */
    boolean isSetLowPowerLimit();

    /**
     * Returns the value of the '<em><b>Pressure Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pressure Limit</em>' attribute.
     * @see #isSetPressureLimit()
     * @see #unsetPressureLimit()
     * @see #setPressureLimit(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_PressureLimit()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.pressureLimit' kind='element'"
     * @generated
     */
    Float getPressureLimit();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureLimit <em>Pressure Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pressure Limit</em>' attribute.
     * @see #isSetPressureLimit()
     * @see #unsetPressureLimit()
     * @see #getPressureLimit()
     * @generated
     */
    void setPressureLimit( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureLimit <em>Pressure Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPressureLimit()
     * @see #getPressureLimit()
     * @see #setPressureLimit(Float)
     * @generated
     */
    void unsetPressureLimit();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureLimit <em>Pressure Limit</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pressure Limit</em>' attribute is set.
     * @see #unsetPressureLimit()
     * @see #getPressureLimit()
     * @see #setPressureLimit(Float)
     * @generated
     */
    boolean isSetPressureLimit();

    /**
     * Returns the value of the '<em><b>Pressure Setpoint GA</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pressure Setpoint GA</em>' attribute.
     * @see #isSetPressureSetpointGA()
     * @see #unsetPressureSetpointGA()
     * @see #setPressureSetpointGA(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_PressureSetpointGA()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.pressureSetpointGA' kind='element'"
     * @generated
     */
    Float getPressureSetpointGA();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointGA <em>Pressure Setpoint GA</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pressure Setpoint GA</em>' attribute.
     * @see #isSetPressureSetpointGA()
     * @see #unsetPressureSetpointGA()
     * @see #getPressureSetpointGA()
     * @generated
     */
    void setPressureSetpointGA( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointGA <em>Pressure Setpoint GA</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPressureSetpointGA()
     * @see #getPressureSetpointGA()
     * @see #setPressureSetpointGA(Float)
     * @generated
     */
    void unsetPressureSetpointGA();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointGA <em>Pressure Setpoint GA</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pressure Setpoint GA</em>' attribute is set.
     * @see #unsetPressureSetpointGA()
     * @see #getPressureSetpointGA()
     * @see #setPressureSetpointGA(Float)
     * @generated
     */
    boolean isSetPressureSetpointGA();

    /**
     * Returns the value of the '<em><b>Pressure Setpoint TC1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pressure Setpoint TC1</em>' attribute.
     * @see #isSetPressureSetpointTC1()
     * @see #unsetPressureSetpointTC1()
     * @see #setPressureSetpointTC1(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_PressureSetpointTC1()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.pressureSetpointTC1' kind='element'"
     * @generated
     */
    Float getPressureSetpointTC1();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC1 <em>Pressure Setpoint TC1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pressure Setpoint TC1</em>' attribute.
     * @see #isSetPressureSetpointTC1()
     * @see #unsetPressureSetpointTC1()
     * @see #getPressureSetpointTC1()
     * @generated
     */
    void setPressureSetpointTC1( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC1 <em>Pressure Setpoint TC1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPressureSetpointTC1()
     * @see #getPressureSetpointTC1()
     * @see #setPressureSetpointTC1(Float)
     * @generated
     */
    void unsetPressureSetpointTC1();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC1 <em>Pressure Setpoint TC1</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pressure Setpoint TC1</em>' attribute is set.
     * @see #unsetPressureSetpointTC1()
     * @see #getPressureSetpointTC1()
     * @see #setPressureSetpointTC1(Float)
     * @generated
     */
    boolean isSetPressureSetpointTC1();

    /**
     * Returns the value of the '<em><b>Pressure Setpoint TC2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pressure Setpoint TC2</em>' attribute.
     * @see #isSetPressureSetpointTC2()
     * @see #unsetPressureSetpointTC2()
     * @see #setPressureSetpointTC2(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_PressureSetpointTC2()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.pressureSetpointTC2' kind='element'"
     * @generated
     */
    Float getPressureSetpointTC2();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC2 <em>Pressure Setpoint TC2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pressure Setpoint TC2</em>' attribute.
     * @see #isSetPressureSetpointTC2()
     * @see #unsetPressureSetpointTC2()
     * @see #getPressureSetpointTC2()
     * @generated
     */
    void setPressureSetpointTC2( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC2 <em>Pressure Setpoint TC2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPressureSetpointTC2()
     * @see #getPressureSetpointTC2()
     * @see #setPressureSetpointTC2(Float)
     * @generated
     */
    void unsetPressureSetpointTC2();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC2 <em>Pressure Setpoint TC2</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pressure Setpoint TC2</em>' attribute is set.
     * @see #unsetPressureSetpointTC2()
     * @see #getPressureSetpointTC2()
     * @see #setPressureSetpointTC2(Float)
     * @generated
     */
    boolean isSetPressureSetpointTC2();

    /**
     * Returns the value of the '<em><b>Proportional Gain</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Proportional Gain</em>' attribute.
     * @see #isSetProportionalGain()
     * @see #unsetProportionalGain()
     * @see #setProportionalGain(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_ProportionalGain()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.proportionalGain' kind='element'"
     * @generated
     */
    Float getProportionalGain();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getProportionalGain <em>Proportional Gain</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Proportional Gain</em>' attribute.
     * @see #isSetProportionalGain()
     * @see #unsetProportionalGain()
     * @see #getProportionalGain()
     * @generated
     */
    void setProportionalGain( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getProportionalGain <em>Proportional Gain</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetProportionalGain()
     * @see #getProportionalGain()
     * @see #setProportionalGain(Float)
     * @generated
     */
    void unsetProportionalGain();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getProportionalGain <em>Proportional Gain</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Proportional Gain</em>' attribute is set.
     * @see #unsetProportionalGain()
     * @see #getProportionalGain()
     * @see #setProportionalGain(Float)
     * @generated
     */
    boolean isSetProportionalGain();

    /**
     * Returns the value of the '<em><b>Rf Aux1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rf Aux1</em>' attribute.
     * @see #isSetRfAux1()
     * @see #unsetRfAux1()
     * @see #setRfAux1(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RfAux1()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rfAux1' kind='element'"
     * @generated
     */
    Float getRfAux1();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux1 <em>Rf Aux1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rf Aux1</em>' attribute.
     * @see #isSetRfAux1()
     * @see #unsetRfAux1()
     * @see #getRfAux1()
     * @generated
     */
    void setRfAux1( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux1 <em>Rf Aux1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRfAux1()
     * @see #getRfAux1()
     * @see #setRfAux1(Float)
     * @generated
     */
    void unsetRfAux1();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux1 <em>Rf Aux1</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rf Aux1</em>' attribute is set.
     * @see #unsetRfAux1()
     * @see #getRfAux1()
     * @see #setRfAux1(Float)
     * @generated
     */
    boolean isSetRfAux1();

    /**
     * Returns the value of the '<em><b>Rf Aux2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rf Aux2</em>' attribute.
     * @see #isSetRfAux2()
     * @see #unsetRfAux2()
     * @see #setRfAux2(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RfAux2()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rfAux2' kind='element'"
     * @generated
     */
    Float getRfAux2();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux2 <em>Rf Aux2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rf Aux2</em>' attribute.
     * @see #isSetRfAux2()
     * @see #unsetRfAux2()
     * @see #getRfAux2()
     * @generated
     */
    void setRfAux2( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux2 <em>Rf Aux2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRfAux2()
     * @see #getRfAux2()
     * @see #setRfAux2(Float)
     * @generated
     */
    void unsetRfAux2();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux2 <em>Rf Aux2</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rf Aux2</em>' attribute is set.
     * @see #unsetRfAux2()
     * @see #getRfAux2()
     * @see #setRfAux2(Float)
     * @generated
     */
    boolean isSetRfAux2();

    /**
     * Returns the value of the '<em><b>Rf Aux3</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rf Aux3</em>' attribute.
     * @see #isSetRfAux3()
     * @see #unsetRfAux3()
     * @see #setRfAux3(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RfAux3()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rfAux3' kind='element'"
     * @generated
     */
    Float getRfAux3();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux3 <em>Rf Aux3</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rf Aux3</em>' attribute.
     * @see #isSetRfAux3()
     * @see #unsetRfAux3()
     * @see #getRfAux3()
     * @generated
     */
    void setRfAux3( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux3 <em>Rf Aux3</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRfAux3()
     * @see #getRfAux3()
     * @see #setRfAux3(Float)
     * @generated
     */
    void unsetRfAux3();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux3 <em>Rf Aux3</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rf Aux3</em>' attribute is set.
     * @see #unsetRfAux3()
     * @see #getRfAux3()
     * @see #setRfAux3(Float)
     * @generated
     */
    boolean isSetRfAux3();

    /**
     * Returns the value of the '<em><b>Rf Aux4</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rf Aux4</em>' attribute.
     * @see #isSetRfAux4()
     * @see #unsetRfAux4()
     * @see #setRfAux4(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RfAux4()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rfAux4' kind='element'"
     * @generated
     */
    Float getRfAux4();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux4 <em>Rf Aux4</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rf Aux4</em>' attribute.
     * @see #isSetRfAux4()
     * @see #unsetRfAux4()
     * @see #getRfAux4()
     * @generated
     */
    void setRfAux4( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux4 <em>Rf Aux4</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRfAux4()
     * @see #getRfAux4()
     * @see #setRfAux4(Float)
     * @generated
     */
    void unsetRfAux4();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux4 <em>Rf Aux4</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rf Aux4</em>' attribute is set.
     * @see #unsetRfAux4()
     * @see #getRfAux4()
     * @see #setRfAux4(Float)
     * @generated
     */
    boolean isSetRfAux4();

    /**
     * Returns the value of the '<em><b>Rf Aux5</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rf Aux5</em>' attribute.
     * @see #isSetRfAux5()
     * @see #unsetRfAux5()
     * @see #setRfAux5(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RfAux5()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rfAux5' kind='element'"
     * @generated
     */
    Float getRfAux5();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux5 <em>Rf Aux5</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rf Aux5</em>' attribute.
     * @see #isSetRfAux5()
     * @see #unsetRfAux5()
     * @see #getRfAux5()
     * @generated
     */
    void setRfAux5( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux5 <em>Rf Aux5</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRfAux5()
     * @see #getRfAux5()
     * @see #setRfAux5(Float)
     * @generated
     */
    void unsetRfAux5();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux5 <em>Rf Aux5</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rf Aux5</em>' attribute is set.
     * @see #unsetRfAux5()
     * @see #getRfAux5()
     * @see #setRfAux5(Float)
     * @generated
     */
    boolean isSetRfAux5();

    /**
     * Returns the value of the '<em><b>Rf Aux6</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rf Aux6</em>' attribute.
     * @see #isSetRfAux6()
     * @see #unsetRfAux6()
     * @see #setRfAux6(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RfAux6()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rfAux6' kind='element'"
     * @generated
     */
    Float getRfAux6();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux6 <em>Rf Aux6</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rf Aux6</em>' attribute.
     * @see #isSetRfAux6()
     * @see #unsetRfAux6()
     * @see #getRfAux6()
     * @generated
     */
    void setRfAux6( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux6 <em>Rf Aux6</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRfAux6()
     * @see #getRfAux6()
     * @see #setRfAux6(Float)
     * @generated
     */
    void unsetRfAux6();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux6 <em>Rf Aux6</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rf Aux6</em>' attribute is set.
     * @see #unsetRfAux6()
     * @see #getRfAux6()
     * @see #setRfAux6(Float)
     * @generated
     */
    boolean isSetRfAux6();

    /**
     * Returns the value of the '<em><b>Rf Aux7</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rf Aux7</em>' attribute.
     * @see #isSetRfAux7()
     * @see #unsetRfAux7()
     * @see #setRfAux7(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RfAux7()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rfAux7' kind='element'"
     * @generated
     */
    Float getRfAux7();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux7 <em>Rf Aux7</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rf Aux7</em>' attribute.
     * @see #isSetRfAux7()
     * @see #unsetRfAux7()
     * @see #getRfAux7()
     * @generated
     */
    void setRfAux7( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux7 <em>Rf Aux7</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRfAux7()
     * @see #getRfAux7()
     * @see #setRfAux7(Float)
     * @generated
     */
    void unsetRfAux7();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux7 <em>Rf Aux7</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rf Aux7</em>' attribute is set.
     * @see #unsetRfAux7()
     * @see #getRfAux7()
     * @see #setRfAux7(Float)
     * @generated
     */
    boolean isSetRfAux7();

    /**
     * Returns the value of the '<em><b>Rf Aux8</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rf Aux8</em>' attribute.
     * @see #isSetRfAux8()
     * @see #unsetRfAux8()
     * @see #setRfAux8(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RfAux8()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rfAux8' kind='element'"
     * @generated
     */
    Float getRfAux8();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux8 <em>Rf Aux8</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rf Aux8</em>' attribute.
     * @see #isSetRfAux8()
     * @see #unsetRfAux8()
     * @see #getRfAux8()
     * @generated
     */
    void setRfAux8( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux8 <em>Rf Aux8</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRfAux8()
     * @see #getRfAux8()
     * @see #setRfAux8(Float)
     * @generated
     */
    void unsetRfAux8();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux8 <em>Rf Aux8</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rf Aux8</em>' attribute is set.
     * @see #unsetRfAux8()
     * @see #getRfAux8()
     * @see #setRfAux8(Float)
     * @generated
     */
    boolean isSetRfAux8();

    /**
     * Returns the value of the '<em><b>Rod Pattern</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rod Pattern</em>' attribute.
     * @see #isSetRodPattern()
     * @see #unsetRodPattern()
     * @see #setRodPattern(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RodPattern()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rodPattern' kind='element'"
     * @generated
     */
    Float getRodPattern();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPattern <em>Rod Pattern</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rod Pattern</em>' attribute.
     * @see #isSetRodPattern()
     * @see #unsetRodPattern()
     * @see #getRodPattern()
     * @generated
     */
    void setRodPattern( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPattern <em>Rod Pattern</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRodPattern()
     * @see #getRodPattern()
     * @see #setRodPattern(Float)
     * @generated
     */
    void unsetRodPattern();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPattern <em>Rod Pattern</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rod Pattern</em>' attribute is set.
     * @see #unsetRodPattern()
     * @see #getRodPattern()
     * @see #setRodPattern(Float)
     * @generated
     */
    boolean isSetRodPattern();

    /**
     * Returns the value of the '<em><b>Rod Pattern Constant</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rod Pattern Constant</em>' attribute.
     * @see #isSetRodPatternConstant()
     * @see #unsetRodPatternConstant()
     * @see #setRodPatternConstant(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_RodPatternConstant()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.rodPatternConstant' kind='element'"
     * @generated
     */
    Float getRodPatternConstant();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPatternConstant <em>Rod Pattern Constant</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rod Pattern Constant</em>' attribute.
     * @see #isSetRodPatternConstant()
     * @see #unsetRodPatternConstant()
     * @see #getRodPatternConstant()
     * @generated
     */
    void setRodPatternConstant( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPatternConstant <em>Rod Pattern Constant</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRodPatternConstant()
     * @see #getRodPatternConstant()
     * @see #setRodPatternConstant(Float)
     * @generated
     */
    void unsetRodPatternConstant();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPatternConstant <em>Rod Pattern Constant</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rod Pattern Constant</em>' attribute is set.
     * @see #unsetRodPatternConstant()
     * @see #getRodPatternConstant()
     * @see #setRodPatternConstant(Float)
     * @generated
     */
    boolean isSetRodPatternConstant();

    /**
     * Returns the value of the '<em><b>Upper Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Upper Limit</em>' attribute.
     * @see #isSetUpperLimit()
     * @see #unsetUpperLimit()
     * @see #setUpperLimit(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBWRSteamSupply_UpperLimit()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='BWRSteamSupply.upperLimit' kind='element'"
     * @generated
     */
    Float getUpperLimit();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getUpperLimit <em>Upper Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Upper Limit</em>' attribute.
     * @see #isSetUpperLimit()
     * @see #unsetUpperLimit()
     * @see #getUpperLimit()
     * @generated
     */
    void setUpperLimit( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getUpperLimit <em>Upper Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetUpperLimit()
     * @see #getUpperLimit()
     * @see #setUpperLimit(Float)
     * @generated
     */
    void unsetUpperLimit();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getUpperLimit <em>Upper Limit</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Upper Limit</em>' attribute is set.
     * @see #unsetUpperLimit()
     * @see #getUpperLimit()
     * @see #setUpperLimit(Float)
     * @generated
     */
    boolean isSetUpperLimit();

} // BWRSteamSupply
