/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Breaker</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker#getInTransitTime <em>In Transit Time</em>}</li>
 * </ul>
 *
 * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBreaker()
 * @model
 * @generated
 */
public interface Breaker extends ProtectedSwitch {
    /**
     * Returns the value of the '<em><b>In Transit Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>In Transit Time</em>' attribute.
     * @see #isSetInTransitTime()
     * @see #unsetInTransitTime()
     * @see #setInTransitTime(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getBreaker_InTransitTime()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='Breaker.inTransitTime' kind='element'"
     * @generated
     */
    Float getInTransitTime();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker#getInTransitTime <em>In Transit Time</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>In Transit Time</em>' attribute.
     * @see #isSetInTransitTime()
     * @see #unsetInTransitTime()
     * @see #getInTransitTime()
     * @generated
     */
    void setInTransitTime( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker#getInTransitTime <em>In Transit Time</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetInTransitTime()
     * @see #getInTransitTime()
     * @see #setInTransitTime(Float)
     * @generated
     */
    void unsetInTransitTime();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker#getInTransitTime <em>In Transit Time</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>In Transit Time</em>' attribute is set.
     * @see #unsetInTransitTime()
     * @see #getInTransitTime()
     * @see #setInTransitTime(Float)
     * @generated
     */
    boolean isSetInTransitTime();

} // Breaker
