/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CAES Plant</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getEnergyStorageCapacity <em>Energy Storage Capacity</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getRatedCapacityP <em>Rated Capacity P</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getAirCompressor <em>Air Compressor</em>}</li>
 * </ul>
 *
 * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getCAESPlant()
 * @model
 * @generated
 */
public interface CAESPlant extends PowerSystemResource {
    /**
     * Returns the value of the '<em><b>Energy Storage Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Energy Storage Capacity</em>' attribute.
     * @see #isSetEnergyStorageCapacity()
     * @see #unsetEnergyStorageCapacity()
     * @see #setEnergyStorageCapacity(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getCAESPlant_EnergyStorageCapacity()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='CAESPlant.energyStorageCapacity' kind='element'"
     * @generated
     */
    Float getEnergyStorageCapacity();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getEnergyStorageCapacity <em>Energy Storage Capacity</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Energy Storage Capacity</em>' attribute.
     * @see #isSetEnergyStorageCapacity()
     * @see #unsetEnergyStorageCapacity()
     * @see #getEnergyStorageCapacity()
     * @generated
     */
    void setEnergyStorageCapacity( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getEnergyStorageCapacity <em>Energy Storage Capacity</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetEnergyStorageCapacity()
     * @see #getEnergyStorageCapacity()
     * @see #setEnergyStorageCapacity(Float)
     * @generated
     */
    void unsetEnergyStorageCapacity();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getEnergyStorageCapacity <em>Energy Storage Capacity</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Energy Storage Capacity</em>' attribute is set.
     * @see #unsetEnergyStorageCapacity()
     * @see #getEnergyStorageCapacity()
     * @see #setEnergyStorageCapacity(Float)
     * @generated
     */
    boolean isSetEnergyStorageCapacity();

    /**
     * Returns the value of the '<em><b>Rated Capacity P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Rated Capacity P</em>' attribute.
     * @see #isSetRatedCapacityP()
     * @see #unsetRatedCapacityP()
     * @see #setRatedCapacityP(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getCAESPlant_RatedCapacityP()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='CAESPlant.ratedCapacityP' kind='element'"
     * @generated
     */
    Float getRatedCapacityP();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getRatedCapacityP <em>Rated Capacity P</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Rated Capacity P</em>' attribute.
     * @see #isSetRatedCapacityP()
     * @see #unsetRatedCapacityP()
     * @see #getRatedCapacityP()
     * @generated
     */
    void setRatedCapacityP( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getRatedCapacityP <em>Rated Capacity P</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetRatedCapacityP()
     * @see #getRatedCapacityP()
     * @see #setRatedCapacityP(Float)
     * @generated
     */
    void unsetRatedCapacityP();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getRatedCapacityP <em>Rated Capacity P</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Rated Capacity P</em>' attribute is set.
     * @see #unsetRatedCapacityP()
     * @see #getRatedCapacityP()
     * @see #setRatedCapacityP(Float)
     * @generated
     */
    boolean isSetRatedCapacityP();

    /**
     * Returns the value of the '<em><b>Air Compressor</b></em>' reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor#getCAESPlant <em>CAES Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Air Compressor</em>' reference.
     * @see #isSetAirCompressor()
     * @see #unsetAirCompressor()
     * @see #setAirCompressor(AirCompressor)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getCAESPlant_AirCompressor()
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor#getCAESPlant
     * @model opposite="CAESPlant" resolveProxies="false" unsettable="true" ordered="false"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='CAESPlant.AirCompressor' kind='element'"
     * @generated
     */
    AirCompressor getAirCompressor();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getAirCompressor <em>Air Compressor</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Air Compressor</em>' reference.
     * @see #isSetAirCompressor()
     * @see #unsetAirCompressor()
     * @see #getAirCompressor()
     * @generated
     */
    void setAirCompressor( AirCompressor value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getAirCompressor <em>Air Compressor</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetAirCompressor()
     * @see #getAirCompressor()
     * @see #setAirCompressor(AirCompressor)
     * @generated
     */
    void unsetAirCompressor();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getAirCompressor <em>Air Compressor</em>}' reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Air Compressor</em>' reference is set.
     * @see #unsetAirCompressor()
     * @see #getAirCompressor()
     * @see #setAirCompressor(AirCompressor)
     * @generated
     */
    boolean isSetAirCompressor();

    /**
     * Returns the value of the '<em><b>Thermal Generating Unit</b></em>' reference.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getCAESPlant <em>CAES Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Thermal Generating Unit</em>' reference.
     * @see #isSetThermalGeneratingUnit()
     * @see #unsetThermalGeneratingUnit()
     * @see #setThermalGeneratingUnit(ThermalGeneratingUnit)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getCAESPlant_ThermalGeneratingUnit()
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getCAESPlant
     * @model opposite="CAESPlant" unsettable="true" transient="true" ordered="false"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='CAESPlant.ThermalGeneratingUnit' kind='element'"
     * @generated
     */
    ThermalGeneratingUnit getThermalGeneratingUnit();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Thermal Generating Unit</em>' reference.
     * @see #isSetThermalGeneratingUnit()
     * @see #unsetThermalGeneratingUnit()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    void setThermalGeneratingUnit( ThermalGeneratingUnit value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetThermalGeneratingUnit()
     * @see #getThermalGeneratingUnit()
     * @see #setThermalGeneratingUnit(ThermalGeneratingUnit)
     * @generated
     */
    void unsetThermalGeneratingUnit();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}' reference is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Thermal Generating Unit</em>' reference is set.
     * @see #unsetThermalGeneratingUnit()
     * @see #getThermalGeneratingUnit()
     * @see #setThermalGeneratingUnit(ThermalGeneratingUnit)
     * @generated
     */
    boolean isSetThermalGeneratingUnit();

} // CAESPlant
