/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Fossil Steam Supply</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusFrequency <em>Aux Power Versus Frequency</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusVoltage <em>Aux Power Versus Voltage</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getBoilerControlMode <em>Boiler Control Mode</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlErrorBiasP <em>Control Error Bias P</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlIC <em>Control IC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPC <em>Control PC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPEB <em>Control PEB</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPED <em>Control PED</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlTC <em>Control TC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterIG <em>Feed Water IG</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterPG <em>Feed Water PG</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterTC <em>Feed Water TC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelDemandLimit <em>Fuel Demand Limit</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyDelay <em>Fuel Supply Delay</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyTC <em>Fuel Supply TC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMaxErrorRateP <em>Max Error Rate P</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMechPowerSensorLag <em>Mech Power Sensor Lag</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMinErrorRateP <em>Min Error Rate P</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlDG <em>Pressure Ctrl DG</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlIG <em>Pressure Ctrl IG</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlPG <em>Pressure Ctrl PG</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureFeedback <em>Pressure Feedback</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater1Capacity <em>Super Heater1 Capacity</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater2Capacity <em>Super Heater2 Capacity</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeaterPipePD <em>Super Heater Pipe PD</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}</li>
 * </ul>
 *
 * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply()
 * @model
 * @generated
 */
public interface FossilSteamSupply extends SteamSupply {
    /**
     * Returns the value of the '<em><b>Aux Power Versus Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Aux Power Versus Frequency</em>' attribute.
     * @see #isSetAuxPowerVersusFrequency()
     * @see #unsetAuxPowerVersusFrequency()
     * @see #setAuxPowerVersusFrequency(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_AuxPowerVersusFrequency()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.auxPowerVersusFrequency' kind='element'"
     * @generated
     */
    Float getAuxPowerVersusFrequency();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusFrequency <em>Aux Power Versus Frequency</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Aux Power Versus Frequency</em>' attribute.
     * @see #isSetAuxPowerVersusFrequency()
     * @see #unsetAuxPowerVersusFrequency()
     * @see #getAuxPowerVersusFrequency()
     * @generated
     */
    void setAuxPowerVersusFrequency( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusFrequency <em>Aux Power Versus Frequency</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetAuxPowerVersusFrequency()
     * @see #getAuxPowerVersusFrequency()
     * @see #setAuxPowerVersusFrequency(Float)
     * @generated
     */
    void unsetAuxPowerVersusFrequency();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusFrequency <em>Aux Power Versus Frequency</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Aux Power Versus Frequency</em>' attribute is set.
     * @see #unsetAuxPowerVersusFrequency()
     * @see #getAuxPowerVersusFrequency()
     * @see #setAuxPowerVersusFrequency(Float)
     * @generated
     */
    boolean isSetAuxPowerVersusFrequency();

    /**
     * Returns the value of the '<em><b>Aux Power Versus Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Aux Power Versus Voltage</em>' attribute.
     * @see #isSetAuxPowerVersusVoltage()
     * @see #unsetAuxPowerVersusVoltage()
     * @see #setAuxPowerVersusVoltage(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_AuxPowerVersusVoltage()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.auxPowerVersusVoltage' kind='element'"
     * @generated
     */
    Float getAuxPowerVersusVoltage();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusVoltage <em>Aux Power Versus Voltage</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Aux Power Versus Voltage</em>' attribute.
     * @see #isSetAuxPowerVersusVoltage()
     * @see #unsetAuxPowerVersusVoltage()
     * @see #getAuxPowerVersusVoltage()
     * @generated
     */
    void setAuxPowerVersusVoltage( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusVoltage <em>Aux Power Versus Voltage</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetAuxPowerVersusVoltage()
     * @see #getAuxPowerVersusVoltage()
     * @see #setAuxPowerVersusVoltage(Float)
     * @generated
     */
    void unsetAuxPowerVersusVoltage();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusVoltage <em>Aux Power Versus Voltage</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Aux Power Versus Voltage</em>' attribute is set.
     * @see #unsetAuxPowerVersusVoltage()
     * @see #getAuxPowerVersusVoltage()
     * @see #setAuxPowerVersusVoltage(Float)
     * @generated
     */
    boolean isSetAuxPowerVersusVoltage();

    /**
     * Returns the value of the '<em><b>Boiler Control Mode</b></em>' attribute.
     * The literals are from the enumeration {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BoilerControlMode}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Boiler Control Mode</em>' attribute.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BoilerControlMode
     * @see #isSetBoilerControlMode()
     * @see #unsetBoilerControlMode()
     * @see #setBoilerControlMode(BoilerControlMode)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_BoilerControlMode()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.boilerControlMode' kind='element'"
     * @generated
     */
    BoilerControlMode getBoilerControlMode();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getBoilerControlMode <em>Boiler Control Mode</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Boiler Control Mode</em>' attribute.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BoilerControlMode
     * @see #isSetBoilerControlMode()
     * @see #unsetBoilerControlMode()
     * @see #getBoilerControlMode()
     * @generated
     */
    void setBoilerControlMode( BoilerControlMode value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getBoilerControlMode <em>Boiler Control Mode</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetBoilerControlMode()
     * @see #getBoilerControlMode()
     * @see #setBoilerControlMode(BoilerControlMode)
     * @generated
     */
    void unsetBoilerControlMode();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getBoilerControlMode <em>Boiler Control Mode</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Boiler Control Mode</em>' attribute is set.
     * @see #unsetBoilerControlMode()
     * @see #getBoilerControlMode()
     * @see #setBoilerControlMode(BoilerControlMode)
     * @generated
     */
    boolean isSetBoilerControlMode();

    /**
     * Returns the value of the '<em><b>Control Error Bias P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Control Error Bias P</em>' attribute.
     * @see #isSetControlErrorBiasP()
     * @see #unsetControlErrorBiasP()
     * @see #setControlErrorBiasP(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_ControlErrorBiasP()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.controlErrorBiasP' kind='element'"
     * @generated
     */
    Float getControlErrorBiasP();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlErrorBiasP <em>Control Error Bias P</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Control Error Bias P</em>' attribute.
     * @see #isSetControlErrorBiasP()
     * @see #unsetControlErrorBiasP()
     * @see #getControlErrorBiasP()
     * @generated
     */
    void setControlErrorBiasP( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlErrorBiasP <em>Control Error Bias P</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetControlErrorBiasP()
     * @see #getControlErrorBiasP()
     * @see #setControlErrorBiasP(Float)
     * @generated
     */
    void unsetControlErrorBiasP();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlErrorBiasP <em>Control Error Bias P</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Control Error Bias P</em>' attribute is set.
     * @see #unsetControlErrorBiasP()
     * @see #getControlErrorBiasP()
     * @see #setControlErrorBiasP(Float)
     * @generated
     */
    boolean isSetControlErrorBiasP();

    /**
     * Returns the value of the '<em><b>Control IC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Control IC</em>' attribute.
     * @see #isSetControlIC()
     * @see #unsetControlIC()
     * @see #setControlIC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_ControlIC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.controlIC' kind='element'"
     * @generated
     */
    Float getControlIC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlIC <em>Control IC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Control IC</em>' attribute.
     * @see #isSetControlIC()
     * @see #unsetControlIC()
     * @see #getControlIC()
     * @generated
     */
    void setControlIC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlIC <em>Control IC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetControlIC()
     * @see #getControlIC()
     * @see #setControlIC(Float)
     * @generated
     */
    void unsetControlIC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlIC <em>Control IC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Control IC</em>' attribute is set.
     * @see #unsetControlIC()
     * @see #getControlIC()
     * @see #setControlIC(Float)
     * @generated
     */
    boolean isSetControlIC();

    /**
     * Returns the value of the '<em><b>Control PC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Control PC</em>' attribute.
     * @see #isSetControlPC()
     * @see #unsetControlPC()
     * @see #setControlPC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_ControlPC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.controlPC' kind='element'"
     * @generated
     */
    Float getControlPC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPC <em>Control PC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Control PC</em>' attribute.
     * @see #isSetControlPC()
     * @see #unsetControlPC()
     * @see #getControlPC()
     * @generated
     */
    void setControlPC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPC <em>Control PC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetControlPC()
     * @see #getControlPC()
     * @see #setControlPC(Float)
     * @generated
     */
    void unsetControlPC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPC <em>Control PC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Control PC</em>' attribute is set.
     * @see #unsetControlPC()
     * @see #getControlPC()
     * @see #setControlPC(Float)
     * @generated
     */
    boolean isSetControlPC();

    /**
     * Returns the value of the '<em><b>Control PEB</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Control PEB</em>' attribute.
     * @see #isSetControlPEB()
     * @see #unsetControlPEB()
     * @see #setControlPEB(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_ControlPEB()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.controlPEB' kind='element'"
     * @generated
     */
    Float getControlPEB();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPEB <em>Control PEB</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Control PEB</em>' attribute.
     * @see #isSetControlPEB()
     * @see #unsetControlPEB()
     * @see #getControlPEB()
     * @generated
     */
    void setControlPEB( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPEB <em>Control PEB</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetControlPEB()
     * @see #getControlPEB()
     * @see #setControlPEB(Float)
     * @generated
     */
    void unsetControlPEB();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPEB <em>Control PEB</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Control PEB</em>' attribute is set.
     * @see #unsetControlPEB()
     * @see #getControlPEB()
     * @see #setControlPEB(Float)
     * @generated
     */
    boolean isSetControlPEB();

    /**
     * Returns the value of the '<em><b>Control PED</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Control PED</em>' attribute.
     * @see #isSetControlPED()
     * @see #unsetControlPED()
     * @see #setControlPED(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_ControlPED()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.controlPED' kind='element'"
     * @generated
     */
    Float getControlPED();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPED <em>Control PED</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Control PED</em>' attribute.
     * @see #isSetControlPED()
     * @see #unsetControlPED()
     * @see #getControlPED()
     * @generated
     */
    void setControlPED( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPED <em>Control PED</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetControlPED()
     * @see #getControlPED()
     * @see #setControlPED(Float)
     * @generated
     */
    void unsetControlPED();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPED <em>Control PED</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Control PED</em>' attribute is set.
     * @see #unsetControlPED()
     * @see #getControlPED()
     * @see #setControlPED(Float)
     * @generated
     */
    boolean isSetControlPED();

    /**
     * Returns the value of the '<em><b>Control TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Control TC</em>' attribute.
     * @see #isSetControlTC()
     * @see #unsetControlTC()
     * @see #setControlTC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_ControlTC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.controlTC' kind='element'"
     * @generated
     */
    Float getControlTC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlTC <em>Control TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Control TC</em>' attribute.
     * @see #isSetControlTC()
     * @see #unsetControlTC()
     * @see #getControlTC()
     * @generated
     */
    void setControlTC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlTC <em>Control TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetControlTC()
     * @see #getControlTC()
     * @see #setControlTC(Float)
     * @generated
     */
    void unsetControlTC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlTC <em>Control TC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Control TC</em>' attribute is set.
     * @see #unsetControlTC()
     * @see #getControlTC()
     * @see #setControlTC(Float)
     * @generated
     */
    boolean isSetControlTC();

    /**
     * Returns the value of the '<em><b>Feed Water IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Feed Water IG</em>' attribute.
     * @see #isSetFeedWaterIG()
     * @see #unsetFeedWaterIG()
     * @see #setFeedWaterIG(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_FeedWaterIG()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.feedWaterIG' kind='element'"
     * @generated
     */
    Float getFeedWaterIG();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterIG <em>Feed Water IG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Feed Water IG</em>' attribute.
     * @see #isSetFeedWaterIG()
     * @see #unsetFeedWaterIG()
     * @see #getFeedWaterIG()
     * @generated
     */
    void setFeedWaterIG( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterIG <em>Feed Water IG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetFeedWaterIG()
     * @see #getFeedWaterIG()
     * @see #setFeedWaterIG(Float)
     * @generated
     */
    void unsetFeedWaterIG();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterIG <em>Feed Water IG</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Feed Water IG</em>' attribute is set.
     * @see #unsetFeedWaterIG()
     * @see #getFeedWaterIG()
     * @see #setFeedWaterIG(Float)
     * @generated
     */
    boolean isSetFeedWaterIG();

    /**
     * Returns the value of the '<em><b>Feed Water PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Feed Water PG</em>' attribute.
     * @see #isSetFeedWaterPG()
     * @see #unsetFeedWaterPG()
     * @see #setFeedWaterPG(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_FeedWaterPG()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.feedWaterPG' kind='element'"
     * @generated
     */
    Float getFeedWaterPG();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterPG <em>Feed Water PG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Feed Water PG</em>' attribute.
     * @see #isSetFeedWaterPG()
     * @see #unsetFeedWaterPG()
     * @see #getFeedWaterPG()
     * @generated
     */
    void setFeedWaterPG( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterPG <em>Feed Water PG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetFeedWaterPG()
     * @see #getFeedWaterPG()
     * @see #setFeedWaterPG(Float)
     * @generated
     */
    void unsetFeedWaterPG();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterPG <em>Feed Water PG</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Feed Water PG</em>' attribute is set.
     * @see #unsetFeedWaterPG()
     * @see #getFeedWaterPG()
     * @see #setFeedWaterPG(Float)
     * @generated
     */
    boolean isSetFeedWaterPG();

    /**
     * Returns the value of the '<em><b>Feed Water TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Feed Water TC</em>' attribute.
     * @see #isSetFeedWaterTC()
     * @see #unsetFeedWaterTC()
     * @see #setFeedWaterTC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_FeedWaterTC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.feedWaterTC' kind='element'"
     * @generated
     */
    Float getFeedWaterTC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterTC <em>Feed Water TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Feed Water TC</em>' attribute.
     * @see #isSetFeedWaterTC()
     * @see #unsetFeedWaterTC()
     * @see #getFeedWaterTC()
     * @generated
     */
    void setFeedWaterTC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterTC <em>Feed Water TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetFeedWaterTC()
     * @see #getFeedWaterTC()
     * @see #setFeedWaterTC(Float)
     * @generated
     */
    void unsetFeedWaterTC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterTC <em>Feed Water TC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Feed Water TC</em>' attribute is set.
     * @see #unsetFeedWaterTC()
     * @see #getFeedWaterTC()
     * @see #setFeedWaterTC(Float)
     * @generated
     */
    boolean isSetFeedWaterTC();

    /**
     * Returns the value of the '<em><b>Fuel Demand Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Fuel Demand Limit</em>' attribute.
     * @see #isSetFuelDemandLimit()
     * @see #unsetFuelDemandLimit()
     * @see #setFuelDemandLimit(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_FuelDemandLimit()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.fuelDemandLimit' kind='element'"
     * @generated
     */
    Float getFuelDemandLimit();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelDemandLimit <em>Fuel Demand Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Fuel Demand Limit</em>' attribute.
     * @see #isSetFuelDemandLimit()
     * @see #unsetFuelDemandLimit()
     * @see #getFuelDemandLimit()
     * @generated
     */
    void setFuelDemandLimit( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelDemandLimit <em>Fuel Demand Limit</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetFuelDemandLimit()
     * @see #getFuelDemandLimit()
     * @see #setFuelDemandLimit(Float)
     * @generated
     */
    void unsetFuelDemandLimit();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelDemandLimit <em>Fuel Demand Limit</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Fuel Demand Limit</em>' attribute is set.
     * @see #unsetFuelDemandLimit()
     * @see #getFuelDemandLimit()
     * @see #setFuelDemandLimit(Float)
     * @generated
     */
    boolean isSetFuelDemandLimit();

    /**
     * Returns the value of the '<em><b>Fuel Supply Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Fuel Supply Delay</em>' attribute.
     * @see #isSetFuelSupplyDelay()
     * @see #unsetFuelSupplyDelay()
     * @see #setFuelSupplyDelay(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_FuelSupplyDelay()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.fuelSupplyDelay' kind='element'"
     * @generated
     */
    Float getFuelSupplyDelay();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyDelay <em>Fuel Supply Delay</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Fuel Supply Delay</em>' attribute.
     * @see #isSetFuelSupplyDelay()
     * @see #unsetFuelSupplyDelay()
     * @see #getFuelSupplyDelay()
     * @generated
     */
    void setFuelSupplyDelay( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyDelay <em>Fuel Supply Delay</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetFuelSupplyDelay()
     * @see #getFuelSupplyDelay()
     * @see #setFuelSupplyDelay(Float)
     * @generated
     */
    void unsetFuelSupplyDelay();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyDelay <em>Fuel Supply Delay</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Fuel Supply Delay</em>' attribute is set.
     * @see #unsetFuelSupplyDelay()
     * @see #getFuelSupplyDelay()
     * @see #setFuelSupplyDelay(Float)
     * @generated
     */
    boolean isSetFuelSupplyDelay();

    /**
     * Returns the value of the '<em><b>Fuel Supply TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Fuel Supply TC</em>' attribute.
     * @see #isSetFuelSupplyTC()
     * @see #unsetFuelSupplyTC()
     * @see #setFuelSupplyTC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_FuelSupplyTC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.fuelSupplyTC' kind='element'"
     * @generated
     */
    Float getFuelSupplyTC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyTC <em>Fuel Supply TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Fuel Supply TC</em>' attribute.
     * @see #isSetFuelSupplyTC()
     * @see #unsetFuelSupplyTC()
     * @see #getFuelSupplyTC()
     * @generated
     */
    void setFuelSupplyTC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyTC <em>Fuel Supply TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetFuelSupplyTC()
     * @see #getFuelSupplyTC()
     * @see #setFuelSupplyTC(Float)
     * @generated
     */
    void unsetFuelSupplyTC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyTC <em>Fuel Supply TC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Fuel Supply TC</em>' attribute is set.
     * @see #unsetFuelSupplyTC()
     * @see #getFuelSupplyTC()
     * @see #setFuelSupplyTC(Float)
     * @generated
     */
    boolean isSetFuelSupplyTC();

    /**
     * Returns the value of the '<em><b>Max Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Max Error Rate P</em>' attribute.
     * @see #isSetMaxErrorRateP()
     * @see #unsetMaxErrorRateP()
     * @see #setMaxErrorRateP(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_MaxErrorRateP()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.maxErrorRateP' kind='element'"
     * @generated
     */
    Float getMaxErrorRateP();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMaxErrorRateP <em>Max Error Rate P</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Max Error Rate P</em>' attribute.
     * @see #isSetMaxErrorRateP()
     * @see #unsetMaxErrorRateP()
     * @see #getMaxErrorRateP()
     * @generated
     */
    void setMaxErrorRateP( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMaxErrorRateP <em>Max Error Rate P</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetMaxErrorRateP()
     * @see #getMaxErrorRateP()
     * @see #setMaxErrorRateP(Float)
     * @generated
     */
    void unsetMaxErrorRateP();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMaxErrorRateP <em>Max Error Rate P</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Max Error Rate P</em>' attribute is set.
     * @see #unsetMaxErrorRateP()
     * @see #getMaxErrorRateP()
     * @see #setMaxErrorRateP(Float)
     * @generated
     */
    boolean isSetMaxErrorRateP();

    /**
     * Returns the value of the '<em><b>Mech Power Sensor Lag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Mech Power Sensor Lag</em>' attribute.
     * @see #isSetMechPowerSensorLag()
     * @see #unsetMechPowerSensorLag()
     * @see #setMechPowerSensorLag(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_MechPowerSensorLag()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.mechPowerSensorLag' kind='element'"
     * @generated
     */
    Float getMechPowerSensorLag();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMechPowerSensorLag <em>Mech Power Sensor Lag</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Mech Power Sensor Lag</em>' attribute.
     * @see #isSetMechPowerSensorLag()
     * @see #unsetMechPowerSensorLag()
     * @see #getMechPowerSensorLag()
     * @generated
     */
    void setMechPowerSensorLag( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMechPowerSensorLag <em>Mech Power Sensor Lag</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetMechPowerSensorLag()
     * @see #getMechPowerSensorLag()
     * @see #setMechPowerSensorLag(Float)
     * @generated
     */
    void unsetMechPowerSensorLag();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMechPowerSensorLag <em>Mech Power Sensor Lag</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Mech Power Sensor Lag</em>' attribute is set.
     * @see #unsetMechPowerSensorLag()
     * @see #getMechPowerSensorLag()
     * @see #setMechPowerSensorLag(Float)
     * @generated
     */
    boolean isSetMechPowerSensorLag();

    /**
     * Returns the value of the '<em><b>Min Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Min Error Rate P</em>' attribute.
     * @see #isSetMinErrorRateP()
     * @see #unsetMinErrorRateP()
     * @see #setMinErrorRateP(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_MinErrorRateP()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.minErrorRateP' kind='element'"
     * @generated
     */
    Float getMinErrorRateP();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMinErrorRateP <em>Min Error Rate P</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Min Error Rate P</em>' attribute.
     * @see #isSetMinErrorRateP()
     * @see #unsetMinErrorRateP()
     * @see #getMinErrorRateP()
     * @generated
     */
    void setMinErrorRateP( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMinErrorRateP <em>Min Error Rate P</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetMinErrorRateP()
     * @see #getMinErrorRateP()
     * @see #setMinErrorRateP(Float)
     * @generated
     */
    void unsetMinErrorRateP();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMinErrorRateP <em>Min Error Rate P</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Min Error Rate P</em>' attribute is set.
     * @see #unsetMinErrorRateP()
     * @see #getMinErrorRateP()
     * @see #setMinErrorRateP(Float)
     * @generated
     */
    boolean isSetMinErrorRateP();

    /**
     * Returns the value of the '<em><b>Pressure Ctrl DG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pressure Ctrl DG</em>' attribute.
     * @see #isSetPressureCtrlDG()
     * @see #unsetPressureCtrlDG()
     * @see #setPressureCtrlDG(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_PressureCtrlDG()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.pressureCtrlDG' kind='element'"
     * @generated
     */
    Float getPressureCtrlDG();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlDG <em>Pressure Ctrl DG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pressure Ctrl DG</em>' attribute.
     * @see #isSetPressureCtrlDG()
     * @see #unsetPressureCtrlDG()
     * @see #getPressureCtrlDG()
     * @generated
     */
    void setPressureCtrlDG( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlDG <em>Pressure Ctrl DG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPressureCtrlDG()
     * @see #getPressureCtrlDG()
     * @see #setPressureCtrlDG(Float)
     * @generated
     */
    void unsetPressureCtrlDG();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlDG <em>Pressure Ctrl DG</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pressure Ctrl DG</em>' attribute is set.
     * @see #unsetPressureCtrlDG()
     * @see #getPressureCtrlDG()
     * @see #setPressureCtrlDG(Float)
     * @generated
     */
    boolean isSetPressureCtrlDG();

    /**
     * Returns the value of the '<em><b>Pressure Ctrl IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pressure Ctrl IG</em>' attribute.
     * @see #isSetPressureCtrlIG()
     * @see #unsetPressureCtrlIG()
     * @see #setPressureCtrlIG(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_PressureCtrlIG()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.pressureCtrlIG' kind='element'"
     * @generated
     */
    Float getPressureCtrlIG();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlIG <em>Pressure Ctrl IG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pressure Ctrl IG</em>' attribute.
     * @see #isSetPressureCtrlIG()
     * @see #unsetPressureCtrlIG()
     * @see #getPressureCtrlIG()
     * @generated
     */
    void setPressureCtrlIG( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlIG <em>Pressure Ctrl IG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPressureCtrlIG()
     * @see #getPressureCtrlIG()
     * @see #setPressureCtrlIG(Float)
     * @generated
     */
    void unsetPressureCtrlIG();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlIG <em>Pressure Ctrl IG</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pressure Ctrl IG</em>' attribute is set.
     * @see #unsetPressureCtrlIG()
     * @see #getPressureCtrlIG()
     * @see #setPressureCtrlIG(Float)
     * @generated
     */
    boolean isSetPressureCtrlIG();

    /**
     * Returns the value of the '<em><b>Pressure Ctrl PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pressure Ctrl PG</em>' attribute.
     * @see #isSetPressureCtrlPG()
     * @see #unsetPressureCtrlPG()
     * @see #setPressureCtrlPG(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_PressureCtrlPG()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.pressureCtrlPG' kind='element'"
     * @generated
     */
    Float getPressureCtrlPG();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlPG <em>Pressure Ctrl PG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pressure Ctrl PG</em>' attribute.
     * @see #isSetPressureCtrlPG()
     * @see #unsetPressureCtrlPG()
     * @see #getPressureCtrlPG()
     * @generated
     */
    void setPressureCtrlPG( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlPG <em>Pressure Ctrl PG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPressureCtrlPG()
     * @see #getPressureCtrlPG()
     * @see #setPressureCtrlPG(Float)
     * @generated
     */
    void unsetPressureCtrlPG();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlPG <em>Pressure Ctrl PG</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pressure Ctrl PG</em>' attribute is set.
     * @see #unsetPressureCtrlPG()
     * @see #getPressureCtrlPG()
     * @see #setPressureCtrlPG(Float)
     * @generated
     */
    boolean isSetPressureCtrlPG();

    /**
     * Returns the value of the '<em><b>Pressure Feedback</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pressure Feedback</em>' attribute.
     * @see #isSetPressureFeedback()
     * @see #unsetPressureFeedback()
     * @see #setPressureFeedback(Integer)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_PressureFeedback()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.pressureFeedback' kind='element'"
     * @generated
     */
    Integer getPressureFeedback();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureFeedback <em>Pressure Feedback</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pressure Feedback</em>' attribute.
     * @see #isSetPressureFeedback()
     * @see #unsetPressureFeedback()
     * @see #getPressureFeedback()
     * @generated
     */
    void setPressureFeedback( Integer value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureFeedback <em>Pressure Feedback</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPressureFeedback()
     * @see #getPressureFeedback()
     * @see #setPressureFeedback(Integer)
     * @generated
     */
    void unsetPressureFeedback();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureFeedback <em>Pressure Feedback</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pressure Feedback</em>' attribute is set.
     * @see #unsetPressureFeedback()
     * @see #getPressureFeedback()
     * @see #setPressureFeedback(Integer)
     * @generated
     */
    boolean isSetPressureFeedback();

    /**
     * Returns the value of the '<em><b>Super Heater1 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Super Heater1 Capacity</em>' attribute.
     * @see #isSetSuperHeater1Capacity()
     * @see #unsetSuperHeater1Capacity()
     * @see #setSuperHeater1Capacity(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_SuperHeater1Capacity()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.superHeater1Capacity' kind='element'"
     * @generated
     */
    Float getSuperHeater1Capacity();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater1Capacity <em>Super Heater1 Capacity</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Super Heater1 Capacity</em>' attribute.
     * @see #isSetSuperHeater1Capacity()
     * @see #unsetSuperHeater1Capacity()
     * @see #getSuperHeater1Capacity()
     * @generated
     */
    void setSuperHeater1Capacity( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater1Capacity <em>Super Heater1 Capacity</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSuperHeater1Capacity()
     * @see #getSuperHeater1Capacity()
     * @see #setSuperHeater1Capacity(Float)
     * @generated
     */
    void unsetSuperHeater1Capacity();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater1Capacity <em>Super Heater1 Capacity</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Super Heater1 Capacity</em>' attribute is set.
     * @see #unsetSuperHeater1Capacity()
     * @see #getSuperHeater1Capacity()
     * @see #setSuperHeater1Capacity(Float)
     * @generated
     */
    boolean isSetSuperHeater1Capacity();

    /**
     * Returns the value of the '<em><b>Super Heater2 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Super Heater2 Capacity</em>' attribute.
     * @see #isSetSuperHeater2Capacity()
     * @see #unsetSuperHeater2Capacity()
     * @see #setSuperHeater2Capacity(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_SuperHeater2Capacity()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.superHeater2Capacity' kind='element'"
     * @generated
     */
    Float getSuperHeater2Capacity();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater2Capacity <em>Super Heater2 Capacity</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Super Heater2 Capacity</em>' attribute.
     * @see #isSetSuperHeater2Capacity()
     * @see #unsetSuperHeater2Capacity()
     * @see #getSuperHeater2Capacity()
     * @generated
     */
    void setSuperHeater2Capacity( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater2Capacity <em>Super Heater2 Capacity</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSuperHeater2Capacity()
     * @see #getSuperHeater2Capacity()
     * @see #setSuperHeater2Capacity(Float)
     * @generated
     */
    void unsetSuperHeater2Capacity();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater2Capacity <em>Super Heater2 Capacity</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Super Heater2 Capacity</em>' attribute is set.
     * @see #unsetSuperHeater2Capacity()
     * @see #getSuperHeater2Capacity()
     * @see #setSuperHeater2Capacity(Float)
     * @generated
     */
    boolean isSetSuperHeater2Capacity();

    /**
     * Returns the value of the '<em><b>Super Heater Pipe PD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Super Heater Pipe PD</em>' attribute.
     * @see #isSetSuperHeaterPipePD()
     * @see #unsetSuperHeaterPipePD()
     * @see #setSuperHeaterPipePD(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_SuperHeaterPipePD()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.superHeaterPipePD' kind='element'"
     * @generated
     */
    Float getSuperHeaterPipePD();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeaterPipePD <em>Super Heater Pipe PD</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Super Heater Pipe PD</em>' attribute.
     * @see #isSetSuperHeaterPipePD()
     * @see #unsetSuperHeaterPipePD()
     * @see #getSuperHeaterPipePD()
     * @generated
     */
    void setSuperHeaterPipePD( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeaterPipePD <em>Super Heater Pipe PD</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSuperHeaterPipePD()
     * @see #getSuperHeaterPipePD()
     * @see #setSuperHeaterPipePD(Float)
     * @generated
     */
    void unsetSuperHeaterPipePD();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeaterPipePD <em>Super Heater Pipe PD</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Super Heater Pipe PD</em>' attribute is set.
     * @see #unsetSuperHeaterPipePD()
     * @see #getSuperHeaterPipePD()
     * @see #setSuperHeaterPipePD(Float)
     * @generated
     */
    boolean isSetSuperHeaterPipePD();

    /**
     * Returns the value of the '<em><b>Throttle Pressure SP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Throttle Pressure SP</em>' attribute.
     * @see #isSetThrottlePressureSP()
     * @see #unsetThrottlePressureSP()
     * @see #setThrottlePressureSP(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getFossilSteamSupply_ThrottlePressureSP()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='FossilSteamSupply.throttlePressureSP' kind='element'"
     * @generated
     */
    Float getThrottlePressureSP();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Throttle Pressure SP</em>' attribute.
     * @see #isSetThrottlePressureSP()
     * @see #unsetThrottlePressureSP()
     * @see #getThrottlePressureSP()
     * @generated
     */
    void setThrottlePressureSP( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetThrottlePressureSP()
     * @see #getThrottlePressureSP()
     * @see #setThrottlePressureSP(Float)
     * @generated
     */
    void unsetThrottlePressureSP();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Throttle Pressure SP</em>' attribute is set.
     * @see #unsetThrottlePressureSP()
     * @see #getThrottlePressureSP()
     * @see #setThrottlePressureSP(Float)
     * @generated
     */
    boolean isSetThrottlePressureSP();

} // FossilSteamSupply
