/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>PWR Steam Supply</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLagTC <em>Cold Leg FB Lag TC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC1 <em>Cold Leg FB Lead TC1</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC2 <em>Cold Leg FB Lead TC2</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG1 <em>Cold Leg FG1</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG2 <em>Cold Leg FG2</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegLagTC <em>Cold Leg Lag TC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC1 <em>Core HT Lag TC1</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC2 <em>Core HT Lag TC2</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsEffTC <em>Core Neutronics Eff TC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsHT <em>Core Neutronics HT</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getFeedbackFactor <em>Feedback Factor</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegLagTC <em>Hot Leg Lag TC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegSteamGain <em>Hot Leg Steam Gain</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegToColdLegGain <em>Hot Leg To Cold Leg Gain</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getPressureCG <em>Pressure CG</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamFlowFG <em>Steam Flow FG</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureDropLagTC <em>Steam Pressure Drop Lag TC</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureFG <em>Steam Pressure FG</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureFactor <em>Throttle Pressure Factor</em>}</li>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}</li>
 * </ul>
 *
 * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply()
 * @model
 * @generated
 */
public interface PWRSteamSupply extends SteamSupply {
    /**
     * Returns the value of the '<em><b>Cold Leg FB Lag TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Cold Leg FB Lag TC</em>' attribute.
     * @see #isSetColdLegFBLagTC()
     * @see #unsetColdLegFBLagTC()
     * @see #setColdLegFBLagTC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_ColdLegFBLagTC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coldLegFBLagTC' kind='element'"
     * @generated
     */
    Float getColdLegFBLagTC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLagTC <em>Cold Leg FB Lag TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Cold Leg FB Lag TC</em>' attribute.
     * @see #isSetColdLegFBLagTC()
     * @see #unsetColdLegFBLagTC()
     * @see #getColdLegFBLagTC()
     * @generated
     */
    void setColdLegFBLagTC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLagTC <em>Cold Leg FB Lag TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetColdLegFBLagTC()
     * @see #getColdLegFBLagTC()
     * @see #setColdLegFBLagTC(Float)
     * @generated
     */
    void unsetColdLegFBLagTC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLagTC <em>Cold Leg FB Lag TC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Cold Leg FB Lag TC</em>' attribute is set.
     * @see #unsetColdLegFBLagTC()
     * @see #getColdLegFBLagTC()
     * @see #setColdLegFBLagTC(Float)
     * @generated
     */
    boolean isSetColdLegFBLagTC();

    /**
     * Returns the value of the '<em><b>Cold Leg FB Lead TC1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Cold Leg FB Lead TC1</em>' attribute.
     * @see #isSetColdLegFBLeadTC1()
     * @see #unsetColdLegFBLeadTC1()
     * @see #setColdLegFBLeadTC1(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_ColdLegFBLeadTC1()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coldLegFBLeadTC1' kind='element'"
     * @generated
     */
    Float getColdLegFBLeadTC1();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC1 <em>Cold Leg FB Lead TC1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Cold Leg FB Lead TC1</em>' attribute.
     * @see #isSetColdLegFBLeadTC1()
     * @see #unsetColdLegFBLeadTC1()
     * @see #getColdLegFBLeadTC1()
     * @generated
     */
    void setColdLegFBLeadTC1( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC1 <em>Cold Leg FB Lead TC1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetColdLegFBLeadTC1()
     * @see #getColdLegFBLeadTC1()
     * @see #setColdLegFBLeadTC1(Float)
     * @generated
     */
    void unsetColdLegFBLeadTC1();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC1 <em>Cold Leg FB Lead TC1</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Cold Leg FB Lead TC1</em>' attribute is set.
     * @see #unsetColdLegFBLeadTC1()
     * @see #getColdLegFBLeadTC1()
     * @see #setColdLegFBLeadTC1(Float)
     * @generated
     */
    boolean isSetColdLegFBLeadTC1();

    /**
     * Returns the value of the '<em><b>Cold Leg FB Lead TC2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Cold Leg FB Lead TC2</em>' attribute.
     * @see #isSetColdLegFBLeadTC2()
     * @see #unsetColdLegFBLeadTC2()
     * @see #setColdLegFBLeadTC2(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_ColdLegFBLeadTC2()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coldLegFBLeadTC2' kind='element'"
     * @generated
     */
    Float getColdLegFBLeadTC2();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC2 <em>Cold Leg FB Lead TC2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Cold Leg FB Lead TC2</em>' attribute.
     * @see #isSetColdLegFBLeadTC2()
     * @see #unsetColdLegFBLeadTC2()
     * @see #getColdLegFBLeadTC2()
     * @generated
     */
    void setColdLegFBLeadTC2( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC2 <em>Cold Leg FB Lead TC2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetColdLegFBLeadTC2()
     * @see #getColdLegFBLeadTC2()
     * @see #setColdLegFBLeadTC2(Float)
     * @generated
     */
    void unsetColdLegFBLeadTC2();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC2 <em>Cold Leg FB Lead TC2</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Cold Leg FB Lead TC2</em>' attribute is set.
     * @see #unsetColdLegFBLeadTC2()
     * @see #getColdLegFBLeadTC2()
     * @see #setColdLegFBLeadTC2(Float)
     * @generated
     */
    boolean isSetColdLegFBLeadTC2();

    /**
     * Returns the value of the '<em><b>Cold Leg FG1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Cold Leg FG1</em>' attribute.
     * @see #isSetColdLegFG1()
     * @see #unsetColdLegFG1()
     * @see #setColdLegFG1(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_ColdLegFG1()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coldLegFG1' kind='element'"
     * @generated
     */
    Float getColdLegFG1();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG1 <em>Cold Leg FG1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Cold Leg FG1</em>' attribute.
     * @see #isSetColdLegFG1()
     * @see #unsetColdLegFG1()
     * @see #getColdLegFG1()
     * @generated
     */
    void setColdLegFG1( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG1 <em>Cold Leg FG1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetColdLegFG1()
     * @see #getColdLegFG1()
     * @see #setColdLegFG1(Float)
     * @generated
     */
    void unsetColdLegFG1();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG1 <em>Cold Leg FG1</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Cold Leg FG1</em>' attribute is set.
     * @see #unsetColdLegFG1()
     * @see #getColdLegFG1()
     * @see #setColdLegFG1(Float)
     * @generated
     */
    boolean isSetColdLegFG1();

    /**
     * Returns the value of the '<em><b>Cold Leg FG2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Cold Leg FG2</em>' attribute.
     * @see #isSetColdLegFG2()
     * @see #unsetColdLegFG2()
     * @see #setColdLegFG2(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_ColdLegFG2()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coldLegFG2' kind='element'"
     * @generated
     */
    Float getColdLegFG2();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG2 <em>Cold Leg FG2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Cold Leg FG2</em>' attribute.
     * @see #isSetColdLegFG2()
     * @see #unsetColdLegFG2()
     * @see #getColdLegFG2()
     * @generated
     */
    void setColdLegFG2( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG2 <em>Cold Leg FG2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetColdLegFG2()
     * @see #getColdLegFG2()
     * @see #setColdLegFG2(Float)
     * @generated
     */
    void unsetColdLegFG2();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG2 <em>Cold Leg FG2</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Cold Leg FG2</em>' attribute is set.
     * @see #unsetColdLegFG2()
     * @see #getColdLegFG2()
     * @see #setColdLegFG2(Float)
     * @generated
     */
    boolean isSetColdLegFG2();

    /**
     * Returns the value of the '<em><b>Cold Leg Lag TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Cold Leg Lag TC</em>' attribute.
     * @see #isSetColdLegLagTC()
     * @see #unsetColdLegLagTC()
     * @see #setColdLegLagTC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_ColdLegLagTC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coldLegLagTC' kind='element'"
     * @generated
     */
    Float getColdLegLagTC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegLagTC <em>Cold Leg Lag TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Cold Leg Lag TC</em>' attribute.
     * @see #isSetColdLegLagTC()
     * @see #unsetColdLegLagTC()
     * @see #getColdLegLagTC()
     * @generated
     */
    void setColdLegLagTC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegLagTC <em>Cold Leg Lag TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetColdLegLagTC()
     * @see #getColdLegLagTC()
     * @see #setColdLegLagTC(Float)
     * @generated
     */
    void unsetColdLegLagTC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegLagTC <em>Cold Leg Lag TC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Cold Leg Lag TC</em>' attribute is set.
     * @see #unsetColdLegLagTC()
     * @see #getColdLegLagTC()
     * @see #setColdLegLagTC(Float)
     * @generated
     */
    boolean isSetColdLegLagTC();

    /**
     * Returns the value of the '<em><b>Core HT Lag TC1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Core HT Lag TC1</em>' attribute.
     * @see #isSetCoreHTLagTC1()
     * @see #unsetCoreHTLagTC1()
     * @see #setCoreHTLagTC1(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_CoreHTLagTC1()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coreHTLagTC1' kind='element'"
     * @generated
     */
    Float getCoreHTLagTC1();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC1 <em>Core HT Lag TC1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Core HT Lag TC1</em>' attribute.
     * @see #isSetCoreHTLagTC1()
     * @see #unsetCoreHTLagTC1()
     * @see #getCoreHTLagTC1()
     * @generated
     */
    void setCoreHTLagTC1( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC1 <em>Core HT Lag TC1</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetCoreHTLagTC1()
     * @see #getCoreHTLagTC1()
     * @see #setCoreHTLagTC1(Float)
     * @generated
     */
    void unsetCoreHTLagTC1();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC1 <em>Core HT Lag TC1</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Core HT Lag TC1</em>' attribute is set.
     * @see #unsetCoreHTLagTC1()
     * @see #getCoreHTLagTC1()
     * @see #setCoreHTLagTC1(Float)
     * @generated
     */
    boolean isSetCoreHTLagTC1();

    /**
     * Returns the value of the '<em><b>Core HT Lag TC2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Core HT Lag TC2</em>' attribute.
     * @see #isSetCoreHTLagTC2()
     * @see #unsetCoreHTLagTC2()
     * @see #setCoreHTLagTC2(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_CoreHTLagTC2()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coreHTLagTC2' kind='element'"
     * @generated
     */
    Float getCoreHTLagTC2();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC2 <em>Core HT Lag TC2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Core HT Lag TC2</em>' attribute.
     * @see #isSetCoreHTLagTC2()
     * @see #unsetCoreHTLagTC2()
     * @see #getCoreHTLagTC2()
     * @generated
     */
    void setCoreHTLagTC2( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC2 <em>Core HT Lag TC2</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetCoreHTLagTC2()
     * @see #getCoreHTLagTC2()
     * @see #setCoreHTLagTC2(Float)
     * @generated
     */
    void unsetCoreHTLagTC2();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC2 <em>Core HT Lag TC2</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Core HT Lag TC2</em>' attribute is set.
     * @see #unsetCoreHTLagTC2()
     * @see #getCoreHTLagTC2()
     * @see #setCoreHTLagTC2(Float)
     * @generated
     */
    boolean isSetCoreHTLagTC2();

    /**
     * Returns the value of the '<em><b>Core Neutronics Eff TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Core Neutronics Eff TC</em>' attribute.
     * @see #isSetCoreNeutronicsEffTC()
     * @see #unsetCoreNeutronicsEffTC()
     * @see #setCoreNeutronicsEffTC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_CoreNeutronicsEffTC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coreNeutronicsEffTC' kind='element'"
     * @generated
     */
    Float getCoreNeutronicsEffTC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsEffTC <em>Core Neutronics Eff TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Core Neutronics Eff TC</em>' attribute.
     * @see #isSetCoreNeutronicsEffTC()
     * @see #unsetCoreNeutronicsEffTC()
     * @see #getCoreNeutronicsEffTC()
     * @generated
     */
    void setCoreNeutronicsEffTC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsEffTC <em>Core Neutronics Eff TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetCoreNeutronicsEffTC()
     * @see #getCoreNeutronicsEffTC()
     * @see #setCoreNeutronicsEffTC(Float)
     * @generated
     */
    void unsetCoreNeutronicsEffTC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsEffTC <em>Core Neutronics Eff TC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Core Neutronics Eff TC</em>' attribute is set.
     * @see #unsetCoreNeutronicsEffTC()
     * @see #getCoreNeutronicsEffTC()
     * @see #setCoreNeutronicsEffTC(Float)
     * @generated
     */
    boolean isSetCoreNeutronicsEffTC();

    /**
     * Returns the value of the '<em><b>Core Neutronics HT</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Core Neutronics HT</em>' attribute.
     * @see #isSetCoreNeutronicsHT()
     * @see #unsetCoreNeutronicsHT()
     * @see #setCoreNeutronicsHT(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_CoreNeutronicsHT()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.coreNeutronicsHT' kind='element'"
     * @generated
     */
    Float getCoreNeutronicsHT();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsHT <em>Core Neutronics HT</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Core Neutronics HT</em>' attribute.
     * @see #isSetCoreNeutronicsHT()
     * @see #unsetCoreNeutronicsHT()
     * @see #getCoreNeutronicsHT()
     * @generated
     */
    void setCoreNeutronicsHT( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsHT <em>Core Neutronics HT</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetCoreNeutronicsHT()
     * @see #getCoreNeutronicsHT()
     * @see #setCoreNeutronicsHT(Float)
     * @generated
     */
    void unsetCoreNeutronicsHT();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsHT <em>Core Neutronics HT</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Core Neutronics HT</em>' attribute is set.
     * @see #unsetCoreNeutronicsHT()
     * @see #getCoreNeutronicsHT()
     * @see #setCoreNeutronicsHT(Float)
     * @generated
     */
    boolean isSetCoreNeutronicsHT();

    /**
     * Returns the value of the '<em><b>Feedback Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Feedback Factor</em>' attribute.
     * @see #isSetFeedbackFactor()
     * @see #unsetFeedbackFactor()
     * @see #setFeedbackFactor(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_FeedbackFactor()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.feedbackFactor' kind='element'"
     * @generated
     */
    Float getFeedbackFactor();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getFeedbackFactor <em>Feedback Factor</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Feedback Factor</em>' attribute.
     * @see #isSetFeedbackFactor()
     * @see #unsetFeedbackFactor()
     * @see #getFeedbackFactor()
     * @generated
     */
    void setFeedbackFactor( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getFeedbackFactor <em>Feedback Factor</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetFeedbackFactor()
     * @see #getFeedbackFactor()
     * @see #setFeedbackFactor(Float)
     * @generated
     */
    void unsetFeedbackFactor();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getFeedbackFactor <em>Feedback Factor</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Feedback Factor</em>' attribute is set.
     * @see #unsetFeedbackFactor()
     * @see #getFeedbackFactor()
     * @see #setFeedbackFactor(Float)
     * @generated
     */
    boolean isSetFeedbackFactor();

    /**
     * Returns the value of the '<em><b>Hot Leg Lag TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Hot Leg Lag TC</em>' attribute.
     * @see #isSetHotLegLagTC()
     * @see #unsetHotLegLagTC()
     * @see #setHotLegLagTC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_HotLegLagTC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.hotLegLagTC' kind='element'"
     * @generated
     */
    Float getHotLegLagTC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegLagTC <em>Hot Leg Lag TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Hot Leg Lag TC</em>' attribute.
     * @see #isSetHotLegLagTC()
     * @see #unsetHotLegLagTC()
     * @see #getHotLegLagTC()
     * @generated
     */
    void setHotLegLagTC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegLagTC <em>Hot Leg Lag TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetHotLegLagTC()
     * @see #getHotLegLagTC()
     * @see #setHotLegLagTC(Float)
     * @generated
     */
    void unsetHotLegLagTC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegLagTC <em>Hot Leg Lag TC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Hot Leg Lag TC</em>' attribute is set.
     * @see #unsetHotLegLagTC()
     * @see #getHotLegLagTC()
     * @see #setHotLegLagTC(Float)
     * @generated
     */
    boolean isSetHotLegLagTC();

    /**
     * Returns the value of the '<em><b>Hot Leg Steam Gain</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Hot Leg Steam Gain</em>' attribute.
     * @see #isSetHotLegSteamGain()
     * @see #unsetHotLegSteamGain()
     * @see #setHotLegSteamGain(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_HotLegSteamGain()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.hotLegSteamGain' kind='element'"
     * @generated
     */
    Float getHotLegSteamGain();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegSteamGain <em>Hot Leg Steam Gain</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Hot Leg Steam Gain</em>' attribute.
     * @see #isSetHotLegSteamGain()
     * @see #unsetHotLegSteamGain()
     * @see #getHotLegSteamGain()
     * @generated
     */
    void setHotLegSteamGain( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegSteamGain <em>Hot Leg Steam Gain</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetHotLegSteamGain()
     * @see #getHotLegSteamGain()
     * @see #setHotLegSteamGain(Float)
     * @generated
     */
    void unsetHotLegSteamGain();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegSteamGain <em>Hot Leg Steam Gain</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Hot Leg Steam Gain</em>' attribute is set.
     * @see #unsetHotLegSteamGain()
     * @see #getHotLegSteamGain()
     * @see #setHotLegSteamGain(Float)
     * @generated
     */
    boolean isSetHotLegSteamGain();

    /**
     * Returns the value of the '<em><b>Hot Leg To Cold Leg Gain</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Hot Leg To Cold Leg Gain</em>' attribute.
     * @see #isSetHotLegToColdLegGain()
     * @see #unsetHotLegToColdLegGain()
     * @see #setHotLegToColdLegGain(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_HotLegToColdLegGain()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.hotLegToColdLegGain' kind='element'"
     * @generated
     */
    Float getHotLegToColdLegGain();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegToColdLegGain <em>Hot Leg To Cold Leg Gain</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Hot Leg To Cold Leg Gain</em>' attribute.
     * @see #isSetHotLegToColdLegGain()
     * @see #unsetHotLegToColdLegGain()
     * @see #getHotLegToColdLegGain()
     * @generated
     */
    void setHotLegToColdLegGain( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegToColdLegGain <em>Hot Leg To Cold Leg Gain</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetHotLegToColdLegGain()
     * @see #getHotLegToColdLegGain()
     * @see #setHotLegToColdLegGain(Float)
     * @generated
     */
    void unsetHotLegToColdLegGain();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegToColdLegGain <em>Hot Leg To Cold Leg Gain</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Hot Leg To Cold Leg Gain</em>' attribute is set.
     * @see #unsetHotLegToColdLegGain()
     * @see #getHotLegToColdLegGain()
     * @see #setHotLegToColdLegGain(Float)
     * @generated
     */
    boolean isSetHotLegToColdLegGain();

    /**
     * Returns the value of the '<em><b>Pressure CG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pressure CG</em>' attribute.
     * @see #isSetPressureCG()
     * @see #unsetPressureCG()
     * @see #setPressureCG(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_PressureCG()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.pressureCG' kind='element'"
     * @generated
     */
    Float getPressureCG();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getPressureCG <em>Pressure CG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pressure CG</em>' attribute.
     * @see #isSetPressureCG()
     * @see #unsetPressureCG()
     * @see #getPressureCG()
     * @generated
     */
    void setPressureCG( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getPressureCG <em>Pressure CG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPressureCG()
     * @see #getPressureCG()
     * @see #setPressureCG(Float)
     * @generated
     */
    void unsetPressureCG();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getPressureCG <em>Pressure CG</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pressure CG</em>' attribute is set.
     * @see #unsetPressureCG()
     * @see #getPressureCG()
     * @see #setPressureCG(Float)
     * @generated
     */
    boolean isSetPressureCG();

    /**
     * Returns the value of the '<em><b>Steam Flow FG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Steam Flow FG</em>' attribute.
     * @see #isSetSteamFlowFG()
     * @see #unsetSteamFlowFG()
     * @see #setSteamFlowFG(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_SteamFlowFG()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.steamFlowFG' kind='element'"
     * @generated
     */
    Float getSteamFlowFG();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamFlowFG <em>Steam Flow FG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Steam Flow FG</em>' attribute.
     * @see #isSetSteamFlowFG()
     * @see #unsetSteamFlowFG()
     * @see #getSteamFlowFG()
     * @generated
     */
    void setSteamFlowFG( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamFlowFG <em>Steam Flow FG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSteamFlowFG()
     * @see #getSteamFlowFG()
     * @see #setSteamFlowFG(Float)
     * @generated
     */
    void unsetSteamFlowFG();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamFlowFG <em>Steam Flow FG</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Steam Flow FG</em>' attribute is set.
     * @see #unsetSteamFlowFG()
     * @see #getSteamFlowFG()
     * @see #setSteamFlowFG(Float)
     * @generated
     */
    boolean isSetSteamFlowFG();

    /**
     * Returns the value of the '<em><b>Steam Pressure Drop Lag TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Steam Pressure Drop Lag TC</em>' attribute.
     * @see #isSetSteamPressureDropLagTC()
     * @see #unsetSteamPressureDropLagTC()
     * @see #setSteamPressureDropLagTC(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_SteamPressureDropLagTC()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.steamPressureDropLagTC' kind='element'"
     * @generated
     */
    Float getSteamPressureDropLagTC();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureDropLagTC <em>Steam Pressure Drop Lag TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Steam Pressure Drop Lag TC</em>' attribute.
     * @see #isSetSteamPressureDropLagTC()
     * @see #unsetSteamPressureDropLagTC()
     * @see #getSteamPressureDropLagTC()
     * @generated
     */
    void setSteamPressureDropLagTC( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureDropLagTC <em>Steam Pressure Drop Lag TC</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSteamPressureDropLagTC()
     * @see #getSteamPressureDropLagTC()
     * @see #setSteamPressureDropLagTC(Float)
     * @generated
     */
    void unsetSteamPressureDropLagTC();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureDropLagTC <em>Steam Pressure Drop Lag TC</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Steam Pressure Drop Lag TC</em>' attribute is set.
     * @see #unsetSteamPressureDropLagTC()
     * @see #getSteamPressureDropLagTC()
     * @see #setSteamPressureDropLagTC(Float)
     * @generated
     */
    boolean isSetSteamPressureDropLagTC();

    /**
     * Returns the value of the '<em><b>Steam Pressure FG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Steam Pressure FG</em>' attribute.
     * @see #isSetSteamPressureFG()
     * @see #unsetSteamPressureFG()
     * @see #setSteamPressureFG(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_SteamPressureFG()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.steamPressureFG' kind='element'"
     * @generated
     */
    Float getSteamPressureFG();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureFG <em>Steam Pressure FG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Steam Pressure FG</em>' attribute.
     * @see #isSetSteamPressureFG()
     * @see #unsetSteamPressureFG()
     * @see #getSteamPressureFG()
     * @generated
     */
    void setSteamPressureFG( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureFG <em>Steam Pressure FG</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetSteamPressureFG()
     * @see #getSteamPressureFG()
     * @see #setSteamPressureFG(Float)
     * @generated
     */
    void unsetSteamPressureFG();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureFG <em>Steam Pressure FG</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Steam Pressure FG</em>' attribute is set.
     * @see #unsetSteamPressureFG()
     * @see #getSteamPressureFG()
     * @see #setSteamPressureFG(Float)
     * @generated
     */
    boolean isSetSteamPressureFG();

    /**
     * Returns the value of the '<em><b>Throttle Pressure Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Throttle Pressure Factor</em>' attribute.
     * @see #isSetThrottlePressureFactor()
     * @see #unsetThrottlePressureFactor()
     * @see #setThrottlePressureFactor(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_ThrottlePressureFactor()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.throttlePressureFactor' kind='element'"
     * @generated
     */
    Float getThrottlePressureFactor();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureFactor <em>Throttle Pressure Factor</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Throttle Pressure Factor</em>' attribute.
     * @see #isSetThrottlePressureFactor()
     * @see #unsetThrottlePressureFactor()
     * @see #getThrottlePressureFactor()
     * @generated
     */
    void setThrottlePressureFactor( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureFactor <em>Throttle Pressure Factor</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetThrottlePressureFactor()
     * @see #getThrottlePressureFactor()
     * @see #setThrottlePressureFactor(Float)
     * @generated
     */
    void unsetThrottlePressureFactor();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureFactor <em>Throttle Pressure Factor</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Throttle Pressure Factor</em>' attribute is set.
     * @see #unsetThrottlePressureFactor()
     * @see #getThrottlePressureFactor()
     * @see #setThrottlePressureFactor(Float)
     * @generated
     */
    boolean isSetThrottlePressureFactor();

    /**
     * Returns the value of the '<em><b>Throttle Pressure SP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>Throttle Pressure SP</em>' attribute.
     * @see #isSetThrottlePressureSP()
     * @see #unsetThrottlePressureSP()
     * @see #setThrottlePressureSP(Float)
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPWRSteamSupply_ThrottlePressureSP()
     * @model unsettable="true"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PWRSteamSupply.throttlePressureSP' kind='element'"
     * @generated
     */
    Float getThrottlePressureSP();

    /**
     * Sets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Throttle Pressure SP</em>' attribute.
     * @see #isSetThrottlePressureSP()
     * @see #unsetThrottlePressureSP()
     * @see #getThrottlePressureSP()
     * @generated
     */
    void setThrottlePressureSP( Float value );

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetThrottlePressureSP()
     * @see #getThrottlePressureSP()
     * @see #setThrottlePressureSP(Float)
     * @generated
     */
    void unsetThrottlePressureSP();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Throttle Pressure SP</em>' attribute is set.
     * @see #unsetThrottlePressureSP()
     * @see #getThrottlePressureSP()
     * @see #setThrottlePressureSP(Float)
     * @generated
     */
    boolean isSetThrottlePressureSP();

} // PWRSteamSupply
