/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Per Length Impedance</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthImpedance#getACLineSegments <em>AC Line Segments</em>}</li>
 * </ul>
 *
 * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPerLengthImpedance()
 * @model
 * @generated
 */
public interface PerLengthImpedance extends PerLengthLineParameter {
    /**
     * Returns the value of the '<em><b>AC Line Segments</b></em>' reference list.
     * The list contents are of type {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment}.
     * It is bidirectional and its opposite is '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getPerLengthImpedance <em>Per Length Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the value of the '<em>AC Line Segments</em>' reference list.
     * @see #isSetACLineSegments()
     * @see #unsetACLineSegments()
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPerLengthImpedance_ACLineSegments()
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getPerLengthImpedance
     * @model opposite="PerLengthImpedance" unsettable="true" transient="true" ordered="false"
     *        extendedMetaData="namespace='http://iec.ch/TC57/2013/CIM-schema-cim16' name='PerLengthImpedance.ACLineSegments' kind='element'"
     * @generated
     */
    EList< ACLineSegment > getACLineSegments();

    /**
     * Unsets the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthImpedance#getACLineSegments <em>AC Line Segments</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetACLineSegments()
     * @see #getACLineSegments()
     * @generated
     */
    void unsetACLineSegments();

    /**
     * Returns whether the value of the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthImpedance#getACLineSegments <em>AC Line Segments</em>}' reference list is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>AC Line Segments</em>' reference list is set.
     * @see #unsetACLineSegments()
     * @see #getACLineSegments()
     * @generated
     */
    boolean isSetACLineSegments();

} // PerLengthImpedance
