/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Phase Code</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getPhaseCode()
 * @model
 * @generated
 */
public enum PhaseCode implements Enumerator {
    /**
     * The '<em><b>ABCN</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ABCN_VALUE
     * @generated
     * @ordered
     */
    ABCN( 0, "ABCN", "ABCN" ),

    /**
     * The '<em><b>ABC</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ABC_VALUE
     * @generated
     * @ordered
     */
    ABC( 1, "ABC", "ABC" ),

    /**
     * The '<em><b>ABN</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ABN_VALUE
     * @generated
     * @ordered
     */
    ABN( 2, "ABN", "ABN" ),

    /**
     * The '<em><b>ACN</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ACN_VALUE
     * @generated
     * @ordered
     */
    ACN( 3, "ACN", "ACN" ),

    /**
     * The '<em><b>BCN</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #BCN_VALUE
     * @generated
     * @ordered
     */
    BCN( 4, "BCN", "BCN" ),

    /**
     * The '<em><b>AB</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #AB_VALUE
     * @generated
     * @ordered
     */
    AB( 5, "AB", "AB" ),

    /**
     * The '<em><b>AC</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #AC_VALUE
     * @generated
     * @ordered
     */
    AC( 6, "AC", "AC" ),

    /**
     * The '<em><b>BC</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #BC_VALUE
     * @generated
     * @ordered
     */
    BC( 7, "BC", "BC" ),

    /**
     * The '<em><b>AN</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #AN_VALUE
     * @generated
     * @ordered
     */
    AN( 8, "AN", "AN" ),

    /**
     * The '<em><b>BN</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #BN_VALUE
     * @generated
     * @ordered
     */
    BN( 9, "BN", "BN" ),

    /**
     * The '<em><b>CN</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #CN_VALUE
     * @generated
     * @ordered
     */
    CN( 10, "CN", "CN" ),

    /**
     * The '<em><b>A</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #A_VALUE
     * @generated
     * @ordered
     */
    A( 11, "A", "A" ),

    /**
     * The '<em><b>B</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #B_VALUE
     * @generated
     * @ordered
     */
    B( 12, "B", "B" ),

    /**
     * The '<em><b>C</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #C_VALUE
     * @generated
     * @ordered
     */
    C( 13, "C", "C" ),

    /**
     * The '<em><b>N</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #N_VALUE
     * @generated
     * @ordered
     */
    N( 14, "N", "N" ),

    /**
     * The '<em><b>S1N</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S1_N_VALUE
     * @generated
     * @ordered
     */
    S1_N( 15, "s1N", "s1N" ),

    /**
     * The '<em><b>S2N</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S2_N_VALUE
     * @generated
     * @ordered
     */
    S2_N( 16, "s2N", "s2N" ),

    /**
     * The '<em><b>S12N</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S12_N_VALUE
     * @generated
     * @ordered
     */
    S12_N( 17, "s12N", "s12N" ),

    /**
     * The '<em><b>S1</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S1_VALUE
     * @generated
     * @ordered
     */
    S1( 18, "s1", "s1" ),

    /**
     * The '<em><b>S2</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S2_VALUE
     * @generated
     * @ordered
     */
    S2( 19, "s2", "s2" ),

    /**
     * The '<em><b>S12</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S12_VALUE
     * @generated
     * @ordered
     */
    S12( 20, "s12", "s12" );

    /**
     * The '<em><b>ABCN</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ABCN
     * @model
     * @generated
     * @ordered
     */
    public static final int ABCN_VALUE = 0;

    /**
     * The '<em><b>ABC</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ABC
     * @model
     * @generated
     * @ordered
     */
    public static final int ABC_VALUE = 1;

    /**
     * The '<em><b>ABN</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ABN
     * @model
     * @generated
     * @ordered
     */
    public static final int ABN_VALUE = 2;

    /**
     * The '<em><b>ACN</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ACN
     * @model
     * @generated
     * @ordered
     */
    public static final int ACN_VALUE = 3;

    /**
     * The '<em><b>BCN</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #BCN
     * @model
     * @generated
     * @ordered
     */
    public static final int BCN_VALUE = 4;

    /**
     * The '<em><b>AB</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #AB
     * @model
     * @generated
     * @ordered
     */
    public static final int AB_VALUE = 5;

    /**
     * The '<em><b>AC</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #AC
     * @model
     * @generated
     * @ordered
     */
    public static final int AC_VALUE = 6;

    /**
     * The '<em><b>BC</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #BC
     * @model
     * @generated
     * @ordered
     */
    public static final int BC_VALUE = 7;

    /**
     * The '<em><b>AN</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #AN
     * @model
     * @generated
     * @ordered
     */
    public static final int AN_VALUE = 8;

    /**
     * The '<em><b>BN</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #BN
     * @model
     * @generated
     * @ordered
     */
    public static final int BN_VALUE = 9;

    /**
     * The '<em><b>CN</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #CN
     * @model
     * @generated
     * @ordered
     */
    public static final int CN_VALUE = 10;

    /**
     * The '<em><b>A</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #A
     * @model
     * @generated
     * @ordered
     */
    public static final int A_VALUE = 11;

    /**
     * The '<em><b>B</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #B
     * @model
     * @generated
     * @ordered
     */
    public static final int B_VALUE = 12;

    /**
     * The '<em><b>C</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #C
     * @model
     * @generated
     * @ordered
     */
    public static final int C_VALUE = 13;

    /**
     * The '<em><b>N</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #N
     * @model
     * @generated
     * @ordered
     */
    public static final int N_VALUE = 14;

    /**
     * The '<em><b>S1N</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S1_N
     * @model name="s1N"
     * @generated
     * @ordered
     */
    public static final int S1_N_VALUE = 15;

    /**
     * The '<em><b>S2N</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S2_N
     * @model name="s2N"
     * @generated
     * @ordered
     */
    public static final int S2_N_VALUE = 16;

    /**
     * The '<em><b>S12N</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S12_N
     * @model name="s12N"
     * @generated
     * @ordered
     */
    public static final int S12_N_VALUE = 17;

    /**
     * The '<em><b>S1</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S1
     * @model name="s1"
     * @generated
     * @ordered
     */
    public static final int S1_VALUE = 18;

    /**
     * The '<em><b>S2</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S2
     * @model name="s2"
     * @generated
     * @ordered
     */
    public static final int S2_VALUE = 19;

    /**
     * The '<em><b>S12</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S12
     * @model name="s12"
     * @generated
     * @ordered
     */
    public static final int S12_VALUE = 20;

    /**
     * An array of all the '<em><b>Phase Code</b></em>' enumerators.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private static final PhaseCode[] VALUES_ARRAY = new PhaseCode[] {
            ABCN,
            ABC,
            ABN,
            ACN,
            BCN,
            AB,
            AC,
            BC,
            AN,
            BN,
            CN,
            A,
            B,
            C,
            N,
            S1_N,
            S2_N,
            S12_N,
            S1,
            S2,
            S12,
    };

    /**
     * A public read-only list of all the '<em><b>Phase Code</b></em>' enumerators.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final List< PhaseCode > VALUES = Collections.unmodifiableList( Arrays.asList( VALUES_ARRAY ) );

    /**
     * Returns the '<em><b>Phase Code</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param literal the literal.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static PhaseCode get( String literal ) {
        for( int i = 0; i < VALUES_ARRAY.length; ++i ) {
            PhaseCode result = VALUES_ARRAY[i];
            if( result.toString().equals( literal ) ) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Phase Code</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param name the name.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static PhaseCode getByName( String name ) {
        for( int i = 0; i < VALUES_ARRAY.length; ++i ) {
            PhaseCode result = VALUES_ARRAY[i];
            if( result.getName().equals( name ) ) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Phase Code</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the integer value.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static PhaseCode get( int value ) {
        switch( value ) {
        case ABCN_VALUE:
            return ABCN;
        case ABC_VALUE:
            return ABC;
        case ABN_VALUE:
            return ABN;
        case ACN_VALUE:
            return ACN;
        case BCN_VALUE:
            return BCN;
        case AB_VALUE:
            return AB;
        case AC_VALUE:
            return AC;
        case BC_VALUE:
            return BC;
        case AN_VALUE:
            return AN;
        case BN_VALUE:
            return BN;
        case CN_VALUE:
            return CN;
        case A_VALUE:
            return A;
        case B_VALUE:
            return B;
        case C_VALUE:
            return C;
        case N_VALUE:
            return N;
        case S1_N_VALUE:
            return S1_N;
        case S2_N_VALUE:
            return S2_N;
        case S12_N_VALUE:
            return S12_N;
        case S1_VALUE:
            return S1;
        case S2_VALUE:
            return S2;
        case S12_VALUE:
            return S12;
        }
        return null;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private final int value;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private final String name;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private final String literal;

    /**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private PhaseCode( int value, String name, String literal ) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public int getValue() {
        return value;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getName() {
        return name;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getLiteral() {
        return literal;
    }

    /**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString() {
        return literal;
    }

} //PhaseCode
