/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Unit Symbol</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimPackage#getUnitSymbol()
 * @model
 * @generated
 */
public enum UnitSymbol implements Enumerator {
    /**
     * The '<em><b>VA</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #VA_VALUE
     * @generated
     * @ordered
     */
    VA( 0, "VA", "VA" ),

    /**
     * The '<em><b>W</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #W_VALUE
     * @generated
     * @ordered
     */
    W( 1, "W", "W" ),

    /**
     * The '<em><b>VAr</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #VAR_VALUE
     * @generated
     * @ordered
     */
    VAR( 2, "VAr", "VAr" ),

    /**
     * The '<em><b>VAh</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #VAH_VALUE
     * @generated
     * @ordered
     */
    VAH( 3, "VAh", "VAh" ),

    /**
     * The '<em><b>Wh</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #WH_VALUE
     * @generated
     * @ordered
     */
    WH( 4, "Wh", "Wh" ),

    /**
     * The '<em><b>VArh</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #VARH_VALUE
     * @generated
     * @ordered
     */
    VARH( 5, "VArh", "VArh" ),

    /**
     * The '<em><b>V</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #V_VALUE
     * @generated
     * @ordered
     */
    V( 6, "V", "V" ),

    /**
     * The '<em><b>Ohm</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #OHM_VALUE
     * @generated
     * @ordered
     */
    OHM( 7, "ohm", "ohm" ),

    /**
     * The '<em><b>A</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #A_VALUE
     * @generated
     * @ordered
     */
    A( 8, "A", "A" ),

    /**
     * The '<em><b>F</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #F_VALUE
     * @generated
     * @ordered
     */
    F( 9, "F", "F" ),

    /**
     * The '<em><b>Henri</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #HENRI_VALUE
     * @generated
     * @ordered
     */
    HENRI( 10, "Henri", "Henri" ),

    /**
     * The '<em><b>Deg C</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #DEG_C_VALUE
     * @generated
     * @ordered
     */
    DEG_C( 11, "degC", "degC" ),

    /**
     * The '<em><b>S</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S_VALUE
     * @generated
     * @ordered
     */
    S( 12, "s", "s" ),

    /**
     * The '<em><b>Min</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #MIN_VALUE
     * @generated
     * @ordered
     */
    MIN( 13, "min", "min" ),

    /**
     * The '<em><b>H</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #H_VALUE
     * @generated
     * @ordered
     */
    H( 14, "h", "h" ),

    /**
     * The '<em><b>Deg</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #DEG_VALUE
     * @generated
     * @ordered
     */
    DEG( 15, "deg", "deg" ),

    /**
     * The '<em><b>Rad</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #RAD_VALUE
     * @generated
     * @ordered
     */
    RAD( 16, "rad", "rad" ),

    /**
     * The '<em><b>J</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #J_VALUE
     * @generated
     * @ordered
     */
    J( 17, "J", "J" ),

    /**
     * The '<em><b>N</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #N_VALUE
     * @generated
     * @ordered
     */
    N( 18, "N", "N" ),

    /**
     * The '<em><b>Siemens</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #SIEMENS_VALUE
     * @generated
     * @ordered
     */
    SIEMENS( 19, "Siemens", "Siemens" ),

    /**
     * The '<em><b>None</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #NONE_VALUE
     * @generated
     * @ordered
     */
    NONE( 20, "none", "none" ),

    /**
     * The '<em><b>Hz</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #HZ_VALUE
     * @generated
     * @ordered
     */
    HZ( 21, "Hz", "Hz" ),

    /**
     * The '<em><b>G</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #G_VALUE
     * @generated
     * @ordered
     */
    G( 22, "g", "g" ),

    /**
     * The '<em><b>Pa</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #PA_VALUE
     * @generated
     * @ordered
     */
    PA( 23, "Pa", "Pa" ),

    /**
     * The '<em><b>Milli</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #MILLI_VALUE
     * @generated
     * @ordered
     */
    MILLI( 24, "milli", "milli" ),

    /**
     * The '<em><b>M2</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #M2_VALUE
     * @generated
     * @ordered
     */
    M2( 25, "m2", "m2" ),

    /**
     * The '<em><b>M3</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #M3_VALUE
     * @generated
     * @ordered
     */
    M3( 26, "m3", "m3" );

    /**
     * The '<em><b>VA</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #VA
     * @model
     * @generated
     * @ordered
     */
    public static final int VA_VALUE = 0;

    /**
     * The '<em><b>W</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #W
     * @model
     * @generated
     * @ordered
     */
    public static final int W_VALUE = 1;

    /**
     * The '<em><b>VAr</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #VAR
     * @model name="VAr"
     * @generated
     * @ordered
     */
    public static final int VAR_VALUE = 2;

    /**
     * The '<em><b>VAh</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #VAH
     * @model name="VAh"
     * @generated
     * @ordered
     */
    public static final int VAH_VALUE = 3;

    /**
     * The '<em><b>Wh</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #WH
     * @model name="Wh"
     * @generated
     * @ordered
     */
    public static final int WH_VALUE = 4;

    /**
     * The '<em><b>VArh</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #VARH
     * @model name="VArh"
     * @generated
     * @ordered
     */
    public static final int VARH_VALUE = 5;

    /**
     * The '<em><b>V</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #V
     * @model
     * @generated
     * @ordered
     */
    public static final int V_VALUE = 6;

    /**
     * The '<em><b>Ohm</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #OHM
     * @model name="ohm"
     * @generated
     * @ordered
     */
    public static final int OHM_VALUE = 7;

    /**
     * The '<em><b>A</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #A
     * @model
     * @generated
     * @ordered
     */
    public static final int A_VALUE = 8;

    /**
     * The '<em><b>F</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #F
     * @model
     * @generated
     * @ordered
     */
    public static final int F_VALUE = 9;

    /**
     * The '<em><b>Henri</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #HENRI
     * @model name="Henri"
     * @generated
     * @ordered
     */
    public static final int HENRI_VALUE = 10;

    /**
     * The '<em><b>Deg C</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #DEG_C
     * @model name="degC"
     * @generated
     * @ordered
     */
    public static final int DEG_C_VALUE = 11;

    /**
     * The '<em><b>S</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #S
     * @model name="s"
     * @generated
     * @ordered
     */
    public static final int S_VALUE = 12;

    /**
     * The '<em><b>Min</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #MIN
     * @model name="min"
     * @generated
     * @ordered
     */
    public static final int MIN_VALUE = 13;

    /**
     * The '<em><b>H</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #H
     * @model name="h"
     * @generated
     * @ordered
     */
    public static final int H_VALUE = 14;

    /**
     * The '<em><b>Deg</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #DEG
     * @model name="deg"
     * @generated
     * @ordered
     */
    public static final int DEG_VALUE = 15;

    /**
     * The '<em><b>Rad</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #RAD
     * @model name="rad"
     * @generated
     * @ordered
     */
    public static final int RAD_VALUE = 16;

    /**
     * The '<em><b>J</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #J
     * @model
     * @generated
     * @ordered
     */
    public static final int J_VALUE = 17;

    /**
     * The '<em><b>N</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #N
     * @model
     * @generated
     * @ordered
     */
    public static final int N_VALUE = 18;

    /**
     * The '<em><b>Siemens</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #SIEMENS
     * @model name="Siemens"
     * @generated
     * @ordered
     */
    public static final int SIEMENS_VALUE = 19;

    /**
     * The '<em><b>None</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #NONE
     * @model name="none"
     * @generated
     * @ordered
     */
    public static final int NONE_VALUE = 20;

    /**
     * The '<em><b>Hz</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #HZ
     * @model name="Hz"
     * @generated
     * @ordered
     */
    public static final int HZ_VALUE = 21;

    /**
     * The '<em><b>G</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #G
     * @model name="g"
     * @generated
     * @ordered
     */
    public static final int G_VALUE = 22;

    /**
     * The '<em><b>Pa</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #PA
     * @model name="Pa"
     * @generated
     * @ordered
     */
    public static final int PA_VALUE = 23;

    /**
     * The '<em><b>Milli</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #MILLI
     * @model name="milli"
     * @generated
     * @ordered
     */
    public static final int MILLI_VALUE = 24;

    /**
     * The '<em><b>M2</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #M2
     * @model name="m2"
     * @generated
     * @ordered
     */
    public static final int M2_VALUE = 25;

    /**
     * The '<em><b>M3</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #M3
     * @model name="m3"
     * @generated
     * @ordered
     */
    public static final int M3_VALUE = 26;

    /**
     * An array of all the '<em><b>Unit Symbol</b></em>' enumerators.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private static final UnitSymbol[] VALUES_ARRAY = new UnitSymbol[] {
            VA,
            W,
            VAR,
            VAH,
            WH,
            VARH,
            V,
            OHM,
            A,
            F,
            HENRI,
            DEG_C,
            S,
            MIN,
            H,
            DEG,
            RAD,
            J,
            N,
            SIEMENS,
            NONE,
            HZ,
            G,
            PA,
            MILLI,
            M2,
            M3,
    };

    /**
     * A public read-only list of all the '<em><b>Unit Symbol</b></em>' enumerators.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final List< UnitSymbol > VALUES = Collections.unmodifiableList( Arrays.asList( VALUES_ARRAY ) );

    /**
     * Returns the '<em><b>Unit Symbol</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param literal the literal.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static UnitSymbol get( String literal ) {
        for( int i = 0; i < VALUES_ARRAY.length; ++i ) {
            UnitSymbol result = VALUES_ARRAY[i];
            if( result.toString().equals( literal ) ) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Unit Symbol</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param name the name.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static UnitSymbol getByName( String name ) {
        for( int i = 0; i < VALUES_ARRAY.length; ++i ) {
            UnitSymbol result = VALUES_ARRAY[i];
            if( result.getName().equals( name ) ) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Unit Symbol</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the integer value.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static UnitSymbol get( int value ) {
        switch( value ) {
        case VA_VALUE:
            return VA;
        case W_VALUE:
            return W;
        case VAR_VALUE:
            return VAR;
        case VAH_VALUE:
            return VAH;
        case WH_VALUE:
            return WH;
        case VARH_VALUE:
            return VARH;
        case V_VALUE:
            return V;
        case OHM_VALUE:
            return OHM;
        case A_VALUE:
            return A;
        case F_VALUE:
            return F;
        case HENRI_VALUE:
            return HENRI;
        case DEG_C_VALUE:
            return DEG_C;
        case S_VALUE:
            return S;
        case MIN_VALUE:
            return MIN;
        case H_VALUE:
            return H;
        case DEG_VALUE:
            return DEG;
        case RAD_VALUE:
            return RAD;
        case J_VALUE:
            return J;
        case N_VALUE:
            return N;
        case SIEMENS_VALUE:
            return SIEMENS;
        case NONE_VALUE:
            return NONE;
        case HZ_VALUE:
            return HZ;
        case G_VALUE:
            return G;
        case PA_VALUE:
            return PA;
        case MILLI_VALUE:
            return MILLI;
        case M2_VALUE:
            return M2;
        case M3_VALUE:
            return M3;
        }
        return null;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private final int value;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private final String name;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private final String literal;

    /**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private UnitSymbol( int value, String name, String literal ) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public int getValue() {
        return value;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getName() {
        return name;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getLiteral() {
        return literal;
    }

    /**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString() {
        return literal;
    }

} //UnitSymbol
