/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.provider;

import fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.util.CimAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CimItemProviderAdapterFactory extends CimAdapterFactory
        implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
    /**
     * This keeps track of the root adapter factory that delegates to this adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Collection< Object > supportedTypes = new ArrayList< Object >();

    /**
     * This constructs an instance.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public CimItemProviderAdapterFactory() {
        supportedTypes.add( IEditingDomainItemProvider.class );
        supportedTypes.add( IStructuredItemContentProvider.class );
        supportedTypes.add( ITreeItemContentProvider.class );
        supportedTypes.add( IItemLabelProvider.class );
        supportedTypes.add( IItemPropertySource.class );
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateTimeInterval} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DateTimeIntervalItemProvider dateTimeIntervalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateTimeInterval}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDateTimeIntervalAdapter() {
        if( dateTimeIntervalItemProvider == null ) {
            dateTimeIntervalItemProvider = new DateTimeIntervalItemProvider( this );
        }

        return dateTimeIntervalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IntegerQuantityItemProvider integerQuantityItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createIntegerQuantityAdapter() {
        if( integerQuantityItemProvider == null ) {
            integerQuantityItemProvider = new IntegerQuantityItemProvider( this );
        }

        return integerQuantityItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TimeInterval} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TimeIntervalItemProvider timeIntervalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TimeInterval}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTimeIntervalAdapter() {
        if( timeIntervalItemProvider == null ) {
            timeIntervalItemProvider = new TimeIntervalItemProvider( this );
        }

        return timeIntervalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FaultImpedanceItemProvider faultImpedanceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFaultImpedanceAdapter() {
        if( faultImpedanceItemProvider == null ) {
            faultImpedanceItemProvider = new FaultImpedanceItemProvider( this );
        }

        return faultImpedanceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DecimalQuantityItemProvider decimalQuantityItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDecimalQuantityAdapter() {
        if( decimalQuantityItemProvider == null ) {
            decimalQuantityItemProvider = new DecimalQuantityItemProvider( this );
        }

        return decimalQuantityItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StringQuantityItemProvider stringQuantityItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStringQuantityAdapter() {
        if( stringQuantityItemProvider == null ) {
            stringQuantityItemProvider = new StringQuantityItemProvider( this );
        }

        return stringQuantityItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateInterval} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DateIntervalItemProvider dateIntervalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateInterval}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDateIntervalAdapter() {
        if( dateIntervalItemProvider == null ) {
            dateIntervalItemProvider = new DateIntervalItemProvider( this );
        }

        return dateIntervalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FloatQuantityItemProvider floatQuantityItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFloatQuantityAdapter() {
        if( floatQuantityItemProvider == null ) {
            floatQuantityItemProvider = new FloatQuantityItemProvider( this );
        }

        return floatQuantityItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MonthDayInterval} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected MonthDayIntervalItemProvider monthDayIntervalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MonthDayInterval}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createMonthDayIntervalAdapter() {
        if( monthDayIntervalItemProvider == null ) {
            monthDayIntervalItemProvider = new MonthDayIntervalItemProvider( this );
        }

        return monthDayIntervalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PowerSystemResourceItemProvider powerSystemResourceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPowerSystemResourceAdapter() {
        if( powerSystemResourceItemProvider == null ) {
            powerSystemResourceItemProvider = new PowerSystemResourceItemProvider( this );
        }

        return powerSystemResourceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SvVoltageItemProvider svVoltageItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSvVoltageAdapter() {
        if( svVoltageItemProvider == null ) {
            svVoltageItemProvider = new SvVoltageItemProvider( this );
        }

        return svVoltageItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoad} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NonConformLoadItemProvider nonConformLoadItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoad}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNonConformLoadAdapter() {
        if( nonConformLoadItemProvider == null ) {
            nonConformLoadItemProvider = new NonConformLoadItemProvider( this );
        }

        return nonConformLoadItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SubGeographicalRegionItemProvider subGeographicalRegionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSubGeographicalRegionAdapter() {
        if( subGeographicalRegionItemProvider == null ) {
            subGeographicalRegionItemProvider = new SubGeographicalRegionItemProvider( this );
        }

        return subGeographicalRegionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DiscreteValueItemProvider discreteValueItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDiscreteValueAdapter() {
        if( discreteValueItemProvider == null ) {
            discreteValueItemProvider = new DiscreteValueItemProvider( this );
        }

        return discreteValueItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimitSet} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AccumulatorLimitSetItemProvider accumulatorLimitSetItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimitSet}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAccumulatorLimitSetAdapter() {
        if( accumulatorLimitSetItemProvider == null ) {
            accumulatorLimitSetItemProvider = new AccumulatorLimitSetItemProvider( this );
        }

        return accumulatorLimitSetItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ReservoirItemProvider reservoirItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createReservoirAdapter() {
        if( reservoirItemProvider == null ) {
            reservoirItemProvider = new ReservoirItemProvider( this );
        }

        return reservoirItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PhaseImpedanceDataItemProvider phaseImpedanceDataItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPhaseImpedanceDataAdapter() {
        if( phaseImpedanceDataItemProvider == null ) {
            phaseImpedanceDataItemProvider = new PhaseImpedanceDataItemProvider( this );
        }

        return phaseImpedanceDataItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSupply} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SteamSupplyItemProvider steamSupplyItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSupply}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSteamSupplyAdapter() {
        if( steamSupplyItemProvider == null ) {
            steamSupplyItemProvider = new SteamSupplyItemProvider( this );
        }

        return steamSupplyItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PSRType} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PSRTypeItemProvider psrTypeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PSRType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPSRTypeAdapter() {
        if( psrTypeItemProvider == null ) {
            psrTypeItemProvider = new PSRTypeItemProvider( this );
        }

        return psrTypeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvStatus} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SvStatusItemProvider svStatusItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvStatus}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSvStatusAdapter() {
        if( svStatusItemProvider == null ) {
            svStatusItemProvider = new SvStatusItemProvider( this );
        }

        return svStatusItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteCommand} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DiscreteCommandItemProvider discreteCommandItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDiscreteCommandAdapter() {
        if( discreteCommandItemProvider == null ) {
            discreteCommandItemProvider = new DiscreteCommandItemProvider( this );
        }

        return discreteCommandItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSendoutSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SteamSendoutScheduleItemProvider steamSendoutScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSendoutSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSteamSendoutScheduleAdapter() {
        if( steamSendoutScheduleItemProvider == null ) {
            steamSendoutScheduleItemProvider = new SteamSendoutScheduleItemProvider( this );
        }

        return steamSendoutScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EnergyConsumerPhaseItemProvider energyConsumerPhaseItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEnergyConsumerPhaseAdapter() {
        if( energyConsumerPhaseItemProvider == null ) {
            energyConsumerPhaseItemProvider = new EnergyConsumerPhaseItemProvider( this );
        }

        return energyConsumerPhaseItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBusbar} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCBusbarItemProvider dcBusbarItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBusbar}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCBusbarAdapter() {
        if( dcBusbarItemProvider == null ) {
            dcBusbarItemProvider = new DCBusbarItemProvider( this );
        }

        return dcBusbarItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LinearShuntCompensatorItemProvider linearShuntCompensatorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLinearShuntCompensatorAdapter() {
        if( linearShuntCompensatorItemProvider == null ) {
            linearShuntCompensatorItemProvider = new LinearShuntCompensatorItemProvider( this );
        }

        return linearShuntCompensatorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PerLengthDCLineParameterItemProvider perLengthDCLineParameterItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPerLengthDCLineParameterAdapter() {
        if( perLengthDCLineParameterItemProvider == null ) {
            perLengthDCLineParameterItemProvider = new PerLengthDCLineParameterItemProvider( this );
        }

        return perLengthDCLineParameterItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected OperationalLimitItemProvider operationalLimitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createOperationalLimitAdapter() {
        if( operationalLimitItemProvider == null ) {
            operationalLimitItemProvider = new OperationalLimitItemProvider( this );
        }

        return operationalLimitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SurgeArrester} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SurgeArresterItemProvider surgeArresterItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SurgeArrester}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSurgeArresterAdapter() {
        if( surgeArresterItemProvider == null ) {
            surgeArresterItemProvider = new SurgeArresterItemProvider( this );
        }

        return surgeArresterItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ACLineSegmentItemProvider acLineSegmentItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createACLineSegmentAdapter() {
        if( acLineSegmentItemProvider == null ) {
            acLineSegmentItemProvider = new ACLineSegmentItemProvider( this );
        }

        return acLineSegmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Recloser} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RecloserItemProvider recloserItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Recloser}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRecloserAdapter() {
        if( recloserItemProvider == null ) {
            recloserItemProvider = new RecloserItemProvider( this );
        }

        return recloserItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageControlZone} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected VoltageControlZoneItemProvider voltageControlZoneItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageControlZone}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createVoltageControlZoneAdapter() {
        if( voltageControlZoneItemProvider == null ) {
            voltageControlZoneItemProvider = new VoltageControlZoneItemProvider( this );
        }

        return voltageControlZoneItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGeneratingUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected WindGeneratingUnitItemProvider windGeneratingUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGeneratingUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createWindGeneratingUnitAdapter() {
        if( windGeneratingUnitItemProvider == null ) {
            windGeneratingUnitItemProvider = new WindGeneratingUnitItemProvider( this );
        }

        return windGeneratingUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected VoltageLevelItemProvider voltageLevelItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createVoltageLevelAdapter() {
        if( voltageLevelItemProvider == null ) {
            voltageLevelItemProvider = new VoltageLevelItemProvider( this );
        }

        return voltageLevelItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PowerTransformerEndItemProvider powerTransformerEndItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPowerTransformerEndAdapter() {
        if( powerTransformerEndItemProvider == null ) {
            powerTransformerEndItemProvider = new PowerTransformerEndItemProvider( this );
        }

        return powerTransformerEndItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IEC61970CIMVersion} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IEC61970CIMVersionItemProvider iec61970CIMVersionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IEC61970CIMVersion}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createIEC61970CIMVersionAdapter() {
        if( iec61970CIMVersionItemProvider == null ) {
            iec61970CIMVersionItemProvider = new IEC61970CIMVersionItemProvider( this );
        }

        return iec61970CIMVersionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SynchronousMachineItemProvider synchronousMachineItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSynchronousMachineAdapter() {
        if( synchronousMachineItemProvider == null ) {
            synchronousMachineItemProvider = new SynchronousMachineItemProvider( this );
        }

        return synchronousMachineItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EnergySourceItemProvider energySourceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEnergySourceAdapter() {
        if( energySourceItemProvider == null ) {
            energySourceItemProvider = new EnergySourceItemProvider( this );
        }

        return energySourceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PowerCutZoneItemProvider powerCutZoneItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPowerCutZoneAdapter() {
        if( powerCutZoneItemProvider == null ) {
            powerCutZoneItemProvider = new PowerCutZoneItemProvider( this );
        }

        return powerCutZoneItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverterDCTerminal} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ACDCConverterDCTerminalItemProvider acdcConverterDCTerminalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverterDCTerminal}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createACDCConverterDCTerminalAdapter() {
        if( acdcConverterDCTerminalItemProvider == null ) {
            acdcConverterDCTerminalItemProvider = new ACDCConverterDCTerminalItemProvider( this );
        }

        return acdcConverterDCTerminalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StateVariable} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StateVariableItemProvider stateVariableItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StateVariable}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStateVariableAdapter() {
        if( stateVariableItemProvider == null ) {
            stateVariableItemProvider = new StateVariableItemProvider( this );
        }

        return stateVariableItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegmentPhase} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ACLineSegmentPhaseItemProvider acLineSegmentPhaseItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegmentPhase}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createACLineSegmentPhaseAdapter() {
        if( acLineSegmentPhaseItemProvider == null ) {
            acLineSegmentPhaseItemProvider = new ACLineSegmentPhaseItemProvider( this );
        }

        return acLineSegmentPhaseItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ProtectedSwitchItemProvider protectedSwitchItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createProtectedSwitchAdapter() {
        if( protectedSwitchItemProvider == null ) {
            protectedSwitchItemProvider = new ProtectedSwitchItemProvider( this );
        }

        return protectedSwitchItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyArea} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EnergyAreaItemProvider energyAreaItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyArea}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEnergyAreaAdapter() {
        if( energyAreaItemProvider == null ) {
            energyAreaItemProvider = new EnergyAreaItemProvider( this );
        }

        return energyAreaItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StartupModelItemProvider startupModelItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStartupModelAdapter() {
        if( startupModelItemProvider == null ) {
            startupModelItemProvider = new StartupModelItemProvider( this );
        }

        return startupModelItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombinedCyclePlant} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CombinedCyclePlantItemProvider combinedCyclePlantItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombinedCyclePlant}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCombinedCyclePlantAdapter() {
        if( combinedCyclePlantItemProvider == null ) {
            combinedCyclePlantItemProvider = new CombinedCyclePlantItemProvider( this );
        }

        return combinedCyclePlantItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Plant} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PlantItemProvider plantItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Plant}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPlantAdapter() {
        if( plantItemProvider == null ) {
            plantItemProvider = new PlantItemProvider( this );
        }

        return plantItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected OperationalLimitSetItemProvider operationalLimitSetItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createOperationalLimitSetAdapter() {
        if( operationalLimitSetItemProvider == null ) {
            operationalLimitSetItemProvider = new OperationalLimitSetItemProvider( this );
        }

        return operationalLimitSetItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Contingency} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ContingencyItemProvider contingencyItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Contingency}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createContingencyAdapter() {
        if( contingencyItemProvider == null ) {
            contingencyItemProvider = new ContingencyItemProvider( this );
        }

        return contingencyItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCShuntItemProvider dcShuntItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCShuntAdapter() {
        if( dcShuntItemProvider == null ) {
            dcShuntItemProvider = new DCShuntItemProvider( this );
        }

        return dcShuntItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeasonDayTypeSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SeasonDayTypeScheduleItemProvider seasonDayTypeScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeasonDayTypeSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSeasonDayTypeScheduleAdapter() {
        if( seasonDayTypeScheduleItemProvider == null ) {
            seasonDayTypeScheduleItemProvider = new SeasonDayTypeScheduleItemProvider( this );
        }

        return seasonDayTypeScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Line} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LineItemProvider lineItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Line}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLineAdapter() {
        if( lineItemProvider == null ) {
            lineItemProvider = new LineItemProvider( this );
        }

        return lineItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvShuntCompensatorSections} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SvShuntCompensatorSectionsItemProvider svShuntCompensatorSectionsItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvShuntCompensatorSections}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSvShuntCompensatorSectionsAdapter() {
        if( svShuntCompensatorSectionsItemProvider == null ) {
            svShuntCompensatorSectionsItemProvider = new SvShuntCompensatorSectionsItemProvider( this );
        }

        return svShuntCompensatorSectionsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensator} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NonlinearShuntCompensatorItemProvider nonlinearShuntCompensatorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensator}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNonlinearShuntCompensatorAdapter() {
        if( nonlinearShuntCompensatorItemProvider == null ) {
            nonlinearShuntCompensatorItemProvider = new NonlinearShuntCompensatorItemProvider( this );
        }

        return nonlinearShuntCompensatorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected MeasurementItemProvider measurementItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createMeasurementAdapter() {
        if( measurementItemProvider == null ) {
            measurementItemProvider = new MeasurementItemProvider( this );
        }

        return measurementItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPumpOpSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HydroPumpOpScheduleItemProvider hydroPumpOpScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPumpOpSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHydroPumpOpScheduleAdapter() {
        if( hydroPumpOpScheduleItemProvider == null ) {
            hydroPumpOpScheduleItemProvider = new HydroPumpOpScheduleItemProvider( this );
        }

        return hydroPumpOpScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTablePoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RatioTapChangerTablePointItemProvider ratioTapChangerTablePointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTablePoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRatioTapChangerTablePointAdapter() {
        if( ratioTapChangerTablePointItemProvider == null ) {
            ratioTapChangerTablePointItemProvider = new RatioTapChangerTablePointItemProvider( this );
        }

        return ratioTapChangerTablePointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TerminalItemProvider terminalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTerminalAdapter() {
        if( terminalItemProvider == null ) {
            terminalItemProvider = new TerminalItemProvider( this );
        }

        return terminalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TransformerStarImpedanceItemProvider transformerStarImpedanceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTransformerStarImpedanceAdapter() {
        if( transformerStarImpedanceItemProvider == null ) {
            transformerStarImpedanceItemProvider = new TransformerStarImpedanceItemProvider( this );
        }

        return transformerStarImpedanceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemotePoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RemotePointItemProvider remotePointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemotePoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRemotePointAdapter() {
        if( remotePointItemProvider == null ) {
            remotePointItemProvider = new RemotePointItemProvider( this );
        }

        return remotePointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SwitchScheduleItemProvider switchScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSwitchScheduleAdapter() {
        if( switchScheduleItemProvider == null ) {
            switchScheduleItemProvider = new SwitchScheduleItemProvider( this );
        }

        return switchScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AnalogItemProvider analogItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAnalogAdapter() {
        if( analogItemProvider == null ) {
            analogItemProvider = new AnalogItemProvider( this );
        }

        return analogItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EarthFaultCompensator} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EarthFaultCompensatorItemProvider earthFaultCompensatorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EarthFaultCompensator}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEarthFaultCompensatorAdapter() {
        if( earthFaultCompensatorItemProvider == null ) {
            earthFaultCompensatorItemProvider = new EarthFaultCompensatorItemProvider( this );
        }

        return earthFaultCompensatorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BWRSteamSupplyItemProvider bwrSteamSupplyItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBWRSteamSupplyAdapter() {
        if( bwrSteamSupplyItemProvider == null ) {
            bwrSteamSupplyItemProvider = new BWRSteamSupplyItemProvider( this );
        }

        return bwrSteamSupplyItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PWRSteamSupplyItemProvider pwrSteamSupplyItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPWRSteamSupplyAdapter() {
        if( pwrSteamSupplyItemProvider == null ) {
            pwrSteamSupplyItemProvider = new PWRSteamSupplyItemProvider( this );
        }

        return pwrSteamSupplyItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramStyle} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DiagramStyleItemProvider diagramStyleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramStyle}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDiagramStyleAdapter() {
        if( diagramStyleItemProvider == null ) {
            diagramStyleItemProvider = new DiagramStyleItemProvider( this );
        }

        return diagramStyleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RemoteSourceItemProvider remoteSourceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRemoteSourceAdapter() {
        if( remoteSourceItemProvider == null ) {
            remoteSourceItemProvider = new RemoteSourceItemProvider( this );
        }

        return remoteSourceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasePower} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BasePowerItemProvider basePowerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasePower}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBasePowerAdapter() {
        if( basePowerItemProvider == null ) {
            basePowerItemProvider = new BasePowerItemProvider( this );
        }

        return basePowerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NameTypeAuthorityItemProvider nameTypeAuthorityItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNameTypeAuthorityAdapter() {
        if( nameTypeAuthorityItemProvider == null ) {
            nameTypeAuthorityItemProvider = new NameTypeAuthorityItemProvider( this );
        }

        return nameTypeAuthorityItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AnalogLimitItemProvider analogLimitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAnalogLimitAdapter() {
        if( analogLimitItemProvider == null ) {
            analogLimitItemProvider = new AnalogLimitItemProvider( this );
        }

        return analogLimitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCGround} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCGroundItemProvider dcGroundItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCGround}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCGroundAdapter() {
        if( dcGroundItemProvider == null ) {
            dcGroundItemProvider = new DCGroundItemProvider( this );
        }

        return dcGroundItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EquipmentItemProvider equipmentItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEquipmentAdapter() {
        if( equipmentItemProvider == null ) {
            equipmentItemProvider = new EquipmentItemProvider( this );
        }

        return equipmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SubstationItemProvider substationItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSubstationAdapter() {
        if( substationItemProvider == null ) {
            substationItemProvider = new SubstationItemProvider( this );
        }

        return substationItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CommandItemProvider commandItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCommandAdapter() {
        if( commandItemProvider == null ) {
            commandItemProvider = new CommandItemProvider( this );
        }

        return commandItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TieFlowItemProvider tieFlowItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTieFlowAdapter() {
        if( tieFlowItemProvider == null ) {
            tieFlowItemProvider = new TieFlowItemProvider( this );
        }

        return tieFlowItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PhaseTapChangerLinearItemProvider phaseTapChangerLinearItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPhaseTapChangerLinearAdapter() {
        if( phaseTapChangerLinearItemProvider == null ) {
            phaseTapChangerLinearItemProvider = new PhaseTapChangerLinearItemProvider( this );
        }

        return phaseTapChangerLinearItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NuclearGeneratingUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NuclearGeneratingUnitItemProvider nuclearGeneratingUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NuclearGeneratingUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNuclearGeneratingUnitAdapter() {
        if( nuclearGeneratingUnitItemProvider == null ) {
            nuclearGeneratingUnitItemProvider = new NuclearGeneratingUnitItemProvider( this );
        }

        return nuclearGeneratingUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HydroTurbineItemProvider hydroTurbineItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHydroTurbineAdapter() {
        if( hydroTurbineItemProvider == null ) {
            hydroTurbineItemProvider = new HydroTurbineItemProvider( this );
        }

        return hydroTurbineItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BranchGroupTerminalItemProvider branchGroupTerminalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBranchGroupTerminalAdapter() {
        if( branchGroupTerminalItemProvider == null ) {
            branchGroupTerminalItemProvider = new BranchGroupTerminalItemProvider( this );
        }

        return branchGroupTerminalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBaseTerminal} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCBaseTerminalItemProvider dcBaseTerminalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBaseTerminal}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCBaseTerminalAdapter() {
        if( dcBaseTerminalItemProvider == null ) {
            dcBaseTerminalItemProvider = new DCBaseTerminalItemProvider( this );
        }

        return dcBaseTerminalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentLimit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CurrentLimitItemProvider currentLimitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentLimit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCurrentLimitAdapter() {
        if( currentLimitItemProvider == null ) {
            currentLimitItemProvider = new CurrentLimitItemProvider( this );
        }

        return currentLimitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RegulatingControlItemProvider regulatingControlItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRegulatingControlAdapter() {
        if( regulatingControlItemProvider == null ) {
            regulatingControlItemProvider = new RegulatingControlItemProvider( this );
        }

        return regulatingControlItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubLoadArea} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SubLoadAreaItemProvider subLoadAreaItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubLoadArea}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSubLoadAreaAdapter() {
        if( subLoadAreaItemProvider == null ) {
            subLoadAreaItemProvider = new SubLoadAreaItemProvider( this );
        }

        return subLoadAreaItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseFrequency} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BaseFrequencyItemProvider baseFrequencyItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseFrequency}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBaseFrequencyAdapter() {
        if( baseFrequencyItemProvider == null ) {
            baseFrequencyItemProvider = new BaseFrequencyItemProvider( this );
        }

        return baseFrequencyItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TextDiagramObject} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TextDiagramObjectItemProvider textDiagramObjectItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TextDiagramObject}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTextDiagramObjectAdapter() {
        if( textDiagramObjectItemProvider == null ) {
            textDiagramObjectItemProvider = new TextDiagramObjectItemProvider( this );
        }

        return textDiagramObjectItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartMainFuelCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StartMainFuelCurveItemProvider startMainFuelCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartMainFuelCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStartMainFuelCurveAdapter() {
        if( startMainFuelCurveItemProvider == null ) {
            startMainFuelCurveItemProvider = new StartMainFuelCurveItemProvider( this );
        }

        return startMainFuelCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ControlAreaGeneratingUnitItemProvider controlAreaGeneratingUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createControlAreaGeneratingUnitAdapter() {
        if( controlAreaGeneratingUnitItemProvider == null ) {
            controlAreaGeneratingUnitItemProvider = new ControlAreaGeneratingUnitItemProvider( this );
        }

        return controlAreaGeneratingUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NonlinearShuntCompensatorPointItemProvider nonlinearShuntCompensatorPointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNonlinearShuntCompensatorPointAdapter() {
        if( nonlinearShuntCompensatorPointItemProvider == null ) {
            nonlinearShuntCompensatorPointItemProvider = new NonlinearShuntCompensatorPointItemProvider( this );
        }

        return nonlinearShuntCompensatorPointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Disconnector} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DisconnectorItemProvider disconnectorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Disconnector}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDisconnectorAdapter() {
        if( disconnectorItemProvider == null ) {
            disconnectorItemProvider = new DisconnectorItemProvider( this );
        }

        return disconnectorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TapChangerTablePointItemProvider tapChangerTablePointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTapChangerTablePointAdapter() {
        if( tapChangerTablePointItemProvider == null ) {
            tapChangerTablePointItemProvider = new TapChangerTablePointItemProvider( this );
        }

        return tapChangerTablePointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Ground} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected GroundItemProvider groundItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Ground}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createGroundAdapter() {
        if( groundItemProvider == null ) {
            groundItemProvider = new GroundItemProvider( this );
        }

        return groundItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsWindUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PowerElectronicsWindUnitItemProvider powerElectronicsWindUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsWindUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPowerElectronicsWindUnitAdapter() {
        if( powerElectronicsWindUnitItemProvider == null ) {
            powerElectronicsWindUnitItemProvider = new PowerElectronicsWindUnitItemProvider( this );
        }

        return powerElectronicsWindUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RemoteControlItemProvider remoteControlItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRemoteControlAdapter() {
        if( remoteControlItemProvider == null ) {
            remoteControlItemProvider = new RemoteControlItemProvider( this );
        }

        return remoteControlItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTable} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PhaseTapChangerTableItemProvider phaseTapChangerTableItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTable}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPhaseTapChangerTableAdapter() {
        if( phaseTapChangerTableItemProvider == null ) {
            phaseTapChangerTableItemProvider = new PhaseTapChangerTableItemProvider( this );
        }

        return phaseTapChangerTableItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalIsland} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TopologicalIslandItemProvider topologicalIslandItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalIsland}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTopologicalIslandAdapter() {
        if( topologicalIslandItemProvider == null ) {
            topologicalIslandItemProvider = new TopologicalIslandItemProvider( this );
        }

        return topologicalIslandItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FuelAllocationScheduleItemProvider fuelAllocationScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFuelAllocationScheduleAdapter() {
        if( fuelAllocationScheduleItemProvider == null ) {
            fuelAllocationScheduleItemProvider = new FuelAllocationScheduleItemProvider( this );
        }

        return fuelAllocationScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvTapStep} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SvTapStepItemProvider svTapStepItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvTapStep}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSvTapStepAdapter() {
        if( svTapStepItemProvider == null ) {
            svTapStepItemProvider = new SvTapStepItemProvider( this );
        }

        return svTapStepItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AccumulatorLimitItemProvider accumulatorLimitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAccumulatorLimitAdapter() {
        if( accumulatorLimitItemProvider == null ) {
            accumulatorLimitItemProvider = new AccumulatorLimitItemProvider( this );
        }

        return accumulatorLimitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Clamp} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ClampItemProvider clampItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Clamp}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createClampAdapter() {
        if( clampItemProvider == null ) {
            clampItemProvider = new ClampItemProvider( this );
        }

        return clampItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorReset} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AccumulatorResetItemProvider accumulatorResetItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorReset}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAccumulatorResetAdapter() {
        if( accumulatorResetItemProvider == null ) {
            accumulatorResetItemProvider = new AccumulatorResetItemProvider( this );
        }

        return accumulatorResetItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PowerElectronicsUnitItemProvider powerElectronicsUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPowerElectronicsUnitAdapter() {
        if( powerElectronicsUnitItemProvider == null ) {
            powerElectronicsUnitItemProvider = new PowerElectronicsUnitItemProvider( this );
        }

        return powerElectronicsUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PrimeMover} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PrimeMoverItemProvider primeMoverItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PrimeMover}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPrimeMoverAdapter() {
        if( primeMoverItemProvider == null ) {
            primeMoverItemProvider = new PrimeMoverItemProvider( this );
        }

        return primeMoverItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AsynchronousMachineItemProvider asynchronousMachineItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAsynchronousMachineAdapter() {
        if( asynchronousMachineItemProvider == null ) {
            asynchronousMachineItemProvider = new AsynchronousMachineItemProvider( this );
        }

        return asynchronousMachineItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRateCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HeatRateCurveItemProvider heatRateCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRateCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHeatRateCurveAdapter() {
        if( heatRateCurveItemProvider == null ) {
            heatRateCurveItemProvider = new HeatRateCurveItemProvider( this );
        }

        return heatRateCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.InflowForecast} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected InflowForecastItemProvider inflowForecastItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.InflowForecast}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createInflowForecastAdapter() {
        if( inflowForecastItemProvider == null ) {
            inflowForecastItemProvider = new InflowForecastItemProvider( this );
        }

        return inflowForecastItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CurveDataItemProvider curveDataItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCurveDataAdapter() {
        if( curveDataItemProvider == null ) {
            curveDataItemProvider = new CurveDataItemProvider( this );
        }

        return curveDataItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLine} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCLineItemProvider dcLineItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLine}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCLineAdapter() {
        if( dcLineItemProvider == null ) {
            dcLineItemProvider = new DCLineItemProvider( this );
        }

        return dcLineItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DayType} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DayTypeItemProvider dayTypeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DayType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDayTypeAdapter() {
        if( dayTypeItemProvider == null ) {
            dayTypeItemProvider = new DayTypeItemProvider( this );
        }

        return dayTypeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthPhaseImpedance} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PerLengthPhaseImpedanceItemProvider perLengthPhaseImpedanceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthPhaseImpedance}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPerLengthPhaseImpedanceAdapter() {
        if( perLengthPhaseImpedanceItemProvider == null ) {
            perLengthPhaseImpedanceItemProvider = new PerLengthPhaseImpedanceItemProvider( this );
        }

        return perLengthPhaseImpedanceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ACDCTerminalItemProvider acdcTerminalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createACDCTerminalAdapter() {
        if( acdcTerminalItemProvider == null ) {
            acdcTerminalItemProvider = new ACDCTerminalItemProvider( this );
        }

        return acdcTerminalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DiagramObjectPointItemProvider diagramObjectPointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDiagramObjectPointAdapter() {
        if( diagramObjectPointItemProvider == null ) {
            diagramObjectPointItemProvider = new DiagramObjectPointItemProvider( this );
        }

        return diagramObjectPointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AccumulatorItemProvider accumulatorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAccumulatorAdapter() {
        if( accumulatorItemProvider == null ) {
            accumulatorItemProvider = new AccumulatorItemProvider( this );
        }

        return accumulatorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CommunicationLink} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CommunicationLinkItemProvider communicationLinkItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CommunicationLink}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCommunicationLinkAdapter() {
        if( communicationLinkItemProvider == null ) {
            communicationLinkItemProvider = new CommunicationLinkItemProvider( this );
        }

        return communicationLinkItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentShunt} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EquivalentShuntItemProvider equivalentShuntItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentShunt}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEquivalentShuntAdapter() {
        if( equivalentShuntItemProvider == null ) {
            equivalentShuntItemProvider = new EquivalentShuntItemProvider( this );
        }

        return equivalentShuntItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTable} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RatioTapChangerTableItemProvider ratioTapChangerTableItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTable}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRatioTapChangerTableAdapter() {
        if( ratioTapChangerTableItemProvider == null ) {
            ratioTapChangerTableItemProvider = new RatioTapChangerTableItemProvider( this );
        }

        return ratioTapChangerTableItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FossilSteamSupplyItemProvider fossilSteamSupplyItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFossilSteamSupplyAdapter() {
        if( fossilSteamSupplyItemProvider == null ) {
            fossilSteamSupplyItemProvider = new FossilSteamSupplyItemProvider( this );
        }

        return fossilSteamSupplyItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TargetLevelScheduleItemProvider targetLevelScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTargetLevelScheduleAdapter() {
        if( targetLevelScheduleItemProvider == null ) {
            targetLevelScheduleItemProvider = new TargetLevelScheduleItemProvider( this );
        }

        return targetLevelScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VisibilityLayer} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected VisibilityLayerItemProvider visibilityLayerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VisibilityLayer}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createVisibilityLayerAdapter() {
        if( visibilityLayerItemProvider == null ) {
            visibilityLayerItemProvider = new VisibilityLayerItemProvider( this );
        }

        return visibilityLayerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueQuality} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected MeasurementValueQualityItemProvider measurementValueQualityItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueQuality}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createMeasurementValueQualityAdapter() {
        if( measurementValueQualityItemProvider == null ) {
            measurementValueQualityItemProvider = new MeasurementValueQualityItemProvider( this );
        }

        return measurementValueQualityItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpCostCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected GenUnitOpCostCurveItemProvider genUnitOpCostCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpCostCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createGenUnitOpCostCurveAdapter() {
        if( genUnitOpCostCurveItemProvider == null ) {
            genUnitOpCostCurveItemProvider = new GenUnitOpCostCurveItemProvider( this );
        }

        return genUnitOpCostCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LoadResponseCharacteristicItemProvider loadResponseCharacteristicItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLoadResponseCharacteristicAdapter() {
        if( loadResponseCharacteristicItemProvider == null ) {
            loadResponseCharacteristicItemProvider = new LoadResponseCharacteristicItemProvider( this );
        }

        return loadResponseCharacteristicItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StaticVarCompensatorItemProvider staticVarCompensatorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStaticVarCompensatorAdapter() {
        if( staticVarCompensatorItemProvider == null ) {
            staticVarCompensatorItemProvider = new StaticVarCompensatorItemProvider( this );
        }

        return staticVarCompensatorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ProtectionEquipmentItemProvider protectionEquipmentItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createProtectionEquipmentAdapter() {
        if( protectionEquipmentItemProvider == null ) {
            protectionEquipmentItemProvider = new ProtectionEquipmentItemProvider( this );
        }

        return protectionEquipmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LimitSet} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LimitSetItemProvider limitSetItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LimitSet}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLimitSetAdapter() {
        if( limitSetItemProvider == null ) {
            limitSetItemProvider = new LimitSetItemProvider( this );
        }

        return limitSetItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PotentialTransformerItemProvider potentialTransformerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPotentialTransformerAdapter() {
        if( potentialTransformerItemProvider == null ) {
            potentialTransformerItemProvider = new PotentialTransformerItemProvider( this );
        }

        return potentialTransformerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NonConformLoadScheduleItemProvider nonConformLoadScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNonConformLoadScheduleAdapter() {
        if( nonConformLoadScheduleItemProvider == null ) {
            nonConformLoadScheduleItemProvider = new NonConformLoadScheduleItemProvider( this );
        }

        return nonConformLoadScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ReactiveCapabilityCurveItemProvider reactiveCapabilityCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createReactiveCapabilityCurveAdapter() {
        if( reactiveCapabilityCurveItemProvider == null ) {
            reactiveCapabilityCurveItemProvider = new ReactiveCapabilityCurveItemProvider( this );
        }

        return reactiveCapabilityCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhase} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NonlinearShuntCompensatorPhaseItemProvider nonlinearShuntCompensatorPhaseItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhase}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNonlinearShuntCompensatorPhaseAdapter() {
        if( nonlinearShuntCompensatorPhaseItemProvider == null ) {
            nonlinearShuntCompensatorPhaseItemProvider = new NonlinearShuntCompensatorPhaseItemProvider( this );
        }

        return nonlinearShuntCompensatorPhaseItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DiagramItemProvider diagramItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDiagramAdapter() {
        if( diagramItemProvider == null ) {
            diagramItemProvider = new DiagramItemProvider( this );
        }

        return diagramItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerSymmetrical} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PhaseTapChangerSymmetricalItemProvider phaseTapChangerSymmetricalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerSymmetrical}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPhaseTapChangerSymmetricalAdapter() {
        if( phaseTapChangerSymmetricalItemProvider == null ) {
            phaseTapChangerSymmetricalItemProvider = new PhaseTapChangerSymmetricalItemProvider( this );
        }

        return phaseTapChangerSymmetricalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CompositeSwitch} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CompositeSwitchItemProvider compositeSwitchItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CompositeSwitch}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCompositeSwitchAdapter() {
        if( compositeSwitchItemProvider == null ) {
            compositeSwitchItemProvider = new CompositeSwitchItemProvider( this );
        }

        return compositeSwitchItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BayItemProvider bayItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBayAdapter() {
        if( bayItemProvider == null ) {
            bayItemProvider = new BayItemProvider( this );
        }

        return bayItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ApparentPowerLimit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ApparentPowerLimitItemProvider apparentPowerLimitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ApparentPowerLimit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createApparentPowerLimitAdapter() {
        if( apparentPowerLimitItemProvider == null ) {
            apparentPowerLimitItemProvider = new ApparentPowerLimitItemProvider( this );
        }

        return apparentPowerLimitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultIndicator} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FaultIndicatorItemProvider faultIndicatorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultIndicator}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFaultIndicatorAdapter() {
        if( faultIndicatorItemProvider == null ) {
            faultIndicatorItemProvider = new FaultIndicatorItemProvider( this );
        }

        return faultIndicatorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AltGeneratingUnitMeasItemProvider altGeneratingUnitMeasItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAltGeneratingUnitMeasAdapter() {
        if( altGeneratingUnitMeasItemProvider == null ) {
            altGeneratingUnitMeasItemProvider = new AltGeneratingUnitMeasItemProvider( this );
        }

        return altGeneratingUnitMeasItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RemoteUnitItemProvider remoteUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRemoteUnitAdapter() {
        if( remoteUnitItemProvider == null ) {
            remoteUnitItemProvider = new RemoteUnitItemProvider( this );
        }

        return remoteUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadGroup} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NonConformLoadGroupItemProvider nonConformLoadGroupItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadGroup}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNonConformLoadGroupAdapter() {
        if( nonConformLoadGroupItemProvider == null ) {
            nonConformLoadGroupItemProvider = new NonConformLoadGroupItemProvider( this );
        }

        return nonConformLoadGroupItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLimit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected VoltageLimitItemProvider voltageLimitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLimit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createVoltageLimitAdapter() {
        if( voltageLimitItemProvider == null ) {
            voltageLimitItemProvider = new VoltageLimitItemProvider( this );
        }

        return voltageLimitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadGroup} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConformLoadGroupItemProvider conformLoadGroupItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadGroup}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConformLoadGroupAdapter() {
        if( conformLoadGroupItemProvider == null ) {
            conformLoadGroupItemProvider = new ConformLoadGroupItemProvider( this );
        }

        return conformLoadGroupItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCLineSegmentItemProvider dcLineSegmentItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCLineSegmentAdapter() {
        if( dcLineSegmentItemProvider == null ) {
            dcLineSegmentItemProvider = new DCLineSegmentItemProvider( this );
        }

        return dcLineSegmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurement} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StringMeasurementItemProvider stringMeasurementItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurement}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStringMeasurementAdapter() {
        if( stringMeasurementItemProvider == null ) {
            stringMeasurementItemProvider = new StringMeasurementItemProvider( this );
        }

        return stringMeasurementItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartIgnFuelCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StartIgnFuelCurveItemProvider startIgnFuelCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartIgnFuelCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStartIgnFuelCurveAdapter() {
        if( startIgnFuelCurveItemProvider == null ) {
            startIgnFuelCurveItemProvider = new StartIgnFuelCurveItemProvider( this );
        }

        return startIgnFuelCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Limit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LimitItemProvider limitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Limit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLimitAdapter() {
        if( limitItemProvider == null ) {
            limitItemProvider = new LimitItemProvider( this );
        }

        return limitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingEfficiencyCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HydroGeneratingEfficiencyCurveItemProvider hydroGeneratingEfficiencyCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingEfficiencyCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHydroGeneratingEfficiencyCurveAdapter() {
        if( hydroGeneratingEfficiencyCurveItemProvider == null ) {
            hydroGeneratingEfficiencyCurveItemProvider = new HydroGeneratingEfficiencyCurveItemProvider( this );
        }

        return hydroGeneratingEfficiencyCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IncrementalHeatRateCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IncrementalHeatRateCurveItemProvider incrementalHeatRateCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IncrementalHeatRateCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createIncrementalHeatRateCurveAdapter() {
        if( incrementalHeatRateCurveItemProvider == null ) {
            incrementalHeatRateCurveItemProvider = new IncrementalHeatRateCurveItemProvider( this );
        }

        return incrementalHeatRateCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PenstockLossCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PenstockLossCurveItemProvider penstockLossCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PenstockLossCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPenstockLossCurveAdapter() {
        if( penstockLossCurveItemProvider == null ) {
            penstockLossCurveItemProvider = new PenstockLossCurveItemProvider( this );
        }

        return penstockLossCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSwitch} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCSwitchItemProvider dcSwitchItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSwitch}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCSwitchAdapter() {
        if( dcSwitchItemProvider == null ) {
            dcSwitchItemProvider = new DCSwitchItemProvider( this );
        }

        return dcSwitchItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularIntervalSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IrregularIntervalScheduleItemProvider irregularIntervalScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularIntervalSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createIrregularIntervalScheduleAdapter() {
        if( irregularIntervalScheduleItemProvider == null ) {
            irregularIntervalScheduleItemProvider = new IrregularIntervalScheduleItemProvider( this );
        }

        return irregularIntervalScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CAESPlantItemProvider caesPlantItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCAESPlantAdapter() {
        if( caesPlantItemProvider == null ) {
            caesPlantItemProvider = new CAESPlantItemProvider( this );
        }

        return caesPlantItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DiagramObjectItemProvider diagramObjectItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDiagramObjectAdapter() {
        if( diagramObjectItemProvider == null ) {
            diagramObjectItemProvider = new DiagramObjectItemProvider( this );
        }

        return diagramObjectItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PetersenCoilItemProvider petersenCoilItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPetersenCoilAdapter() {
        if( petersenCoilItemProvider == null ) {
            petersenCoilItemProvider = new PetersenCoilItemProvider( this );
        }

        return petersenCoilItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCNodeItemProvider dcNodeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCNodeAdapter() {
        if( dcNodeItemProvider == null ) {
            dcNodeItemProvider = new DCNodeItemProvider( this );
        }

        return dcNodeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConformLoadScheduleItemProvider conformLoadScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConformLoadScheduleAdapter() {
        if( conformLoadScheduleItemProvider == null ) {
            conformLoadScheduleItemProvider = new ConformLoadScheduleItemProvider( this );
        }

        return conformLoadScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentFault} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EquipmentFaultItemProvider equipmentFaultItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentFault}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEquipmentFaultAdapter() {
        if( equipmentFaultItemProvider == null ) {
            equipmentFaultItemProvider = new EquipmentFaultItemProvider( this );
        }

        return equipmentFaultItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SynchrocheckRelayItemProvider synchrocheckRelayItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSynchrocheckRelayAdapter() {
        if( synchrocheckRelayItemProvider == null ) {
            synchrocheckRelayItemProvider = new SynchrocheckRelayItemProvider( this );
        }

        return synchrocheckRelayItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectStyle} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DiagramObjectStyleItemProvider diagramObjectStyleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectStyle}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDiagramObjectStyleAdapter() {
        if( diagramObjectStyleItemProvider == null ) {
            diagramObjectStyleItemProvider = new DiagramObjectStyleItemProvider( this );
        }

        return diagramObjectStyleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Quality61850ItemProvider quality61850ItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createQuality61850Adapter() {
        if( quality61850ItemProvider == null ) {
            quality61850ItemProvider = new Quality61850ItemProvider( this );
        }

        return quality61850ItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTablePoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PhaseTapChangerTablePointItemProvider phaseTapChangerTablePointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTablePoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPhaseTapChangerTablePointAdapter() {
        if( phaseTapChangerTablePointItemProvider == null ) {
            phaseTapChangerTablePointItemProvider = new PhaseTapChangerTablePointItemProvider( this );
        }

        return phaseTapChangerTablePointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundDisconnector} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected GroundDisconnectorItemProvider groundDisconnectorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundDisconnector}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createGroundDisconnectorAdapter() {
        if( groundDisconnectorItemProvider == null ) {
            groundDisconnectorItemProvider = new GroundDisconnectorItemProvider( this );
        }

        return groundDisconnectorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTankEnd} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TransformerTankEndItemProvider transformerTankEndItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTankEnd}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTransformerTankEndAdapter() {
        if( transformerTankEndItemProvider == null ) {
            transformerTankEndItemProvider = new TransformerTankEndItemProvider( this );
        }

        return transformerTankEndItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensatorPhase} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LinearShuntCompensatorPhaseItemProvider linearShuntCompensatorPhaseItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensatorPhase}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLinearShuntCompensatorPhaseAdapter() {
        if( linearShuntCompensatorPhaseItemProvider == null ) {
            linearShuntCompensatorPhaseItemProvider = new LinearShuntCompensatorPhaseItemProvider( this );
        }

        return linearShuntCompensatorPhaseItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ShuntCompensatorItemProvider shuntCompensatorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createShuntCompensatorAdapter() {
        if( shuntCompensatorItemProvider == null ) {
            shuntCompensatorItemProvider = new ShuntCompensatorItemProvider( this );
        }

        return shuntCompensatorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RecloseSequenceItemProvider recloseSequenceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRecloseSequenceAdapter() {
        if( recloseSequenceItemProvider == null ) {
            recloseSequenceItemProvider = new RecloseSequenceItemProvider( this );
        }

        return recloseSequenceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SeriesCompensatorItemProvider seriesCompensatorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSeriesCompensatorAdapter() {
        if( seriesCompensatorItemProvider == null ) {
            seriesCompensatorItemProvider = new SeriesCompensatorItemProvider( this );
        }

        return seriesCompensatorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NameTypeItemProvider nameTypeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNameTypeAdapter() {
        if( nameTypeItemProvider == null ) {
            nameTypeItemProvider = new NameTypeItemProvider( this );
        }

        return nameTypeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TransformerMeshImpedanceItemProvider transformerMeshImpedanceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTransformerMeshImpedanceAdapter() {
        if( transformerMeshImpedanceItemProvider == null ) {
            transformerMeshImpedanceItemProvider = new TransformerMeshImpedanceItemProvider( this );
        }

        return transformerMeshImpedanceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DrumBoiler} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DrumBoilerItemProvider drumBoilerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DrumBoiler}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDrumBoilerAdapter() {
        if( drumBoilerItemProvider == null ) {
            drumBoilerItemProvider = new DrumBoilerItemProvider( this );
        }

        return drumBoilerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected MeasurementValueItemProvider measurementValueItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createMeasurementValueAdapter() {
        if( measurementValueItemProvider == null ) {
            measurementValueItemProvider = new MeasurementValueItemProvider( this );
        }

        return measurementValueItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SetPoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SetPointItemProvider setPointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SetPoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSetPointAdapter() {
        if( setPointItemProvider == null ) {
            setPointItemProvider = new SetPointItemProvider( this );
        }

        return setPointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FaultItemProvider faultItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFaultAdapter() {
        if( faultItemProvider == null ) {
            faultItemProvider = new FaultItemProvider( this );
        }

        return faultItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SteamTurbineItemProvider steamTurbineItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSteamTurbineAdapter() {
        if( steamTurbineItemProvider == null ) {
            steamTurbineItemProvider = new SteamTurbineItemProvider( this );
        }

        return steamTurbineItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RotatingMachineItemProvider rotatingMachineItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRotatingMachineAdapter() {
        if( rotatingMachineItemProvider == null ) {
            rotatingMachineItemProvider = new RotatingMachineItemProvider( this );
        }

        return rotatingMachineItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRecoveryBoiler} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HeatRecoveryBoilerItemProvider heatRecoveryBoilerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRecoveryBoiler}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHeatRecoveryBoilerAdapter() {
        if( heatRecoveryBoilerItemProvider == null ) {
            heatRecoveryBoilerItemProvider = new HeatRecoveryBoilerItemProvider( this );
        }

        return heatRecoveryBoilerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConnectivityNodeItemProvider connectivityNodeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConnectivityNodeAdapter() {
        if( connectivityNodeItemProvider == null ) {
            connectivityNodeItemProvider = new ConnectivityNodeItemProvider( this );
        }

        return connectivityNodeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Cut} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CutItemProvider cutItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Cut}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCutAdapter() {
        if( cutItemProvider == null ) {
            cutItemProvider = new CutItemProvider( this );
        }

        return cutItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected OperationalLimitTypeItemProvider operationalLimitTypeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createOperationalLimitTypeAdapter() {
        if( operationalLimitTypeItemProvider == null ) {
            operationalLimitTypeItemProvider = new OperationalLimitTypeItemProvider( this );
        }

        return operationalLimitTypeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IrregularTimePointItemProvider irregularTimePointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createIrregularTimePointAdapter() {
        if( irregularTimePointItemProvider == null ) {
            irregularTimePointItemProvider = new IrregularTimePointItemProvider( this );
        }

        return irregularTimePointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fuse} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FuseItemProvider fuseItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fuse}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFuseAdapter() {
        if( fuseItemProvider == null ) {
            fuseItemProvider = new FuseItemProvider( this );
        }

        return fuseItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IdentifiedObjectItemProvider identifiedObjectItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createIdentifiedObjectAdapter() {
        if( identifiedObjectItemProvider == null ) {
            identifiedObjectItemProvider = new IdentifiedObjectItemProvider( this );
        }

        return identifiedObjectItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConductingEquipmentItemProvider conductingEquipmentItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConductingEquipmentAdapter() {
        if( conductingEquipmentItemProvider == null ) {
            conductingEquipmentItemProvider = new ConductingEquipmentItemProvider( this );
        }

        return conductingEquipmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundingImpedance} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected GroundingImpedanceItemProvider groundingImpedanceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundingImpedance}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createGroundingImpedanceAdapter() {
        if( groundingImpedanceItemProvider == null ) {
            groundingImpedanceItemProvider = new GroundingImpedanceItemProvider( this );
        }

        return groundingImpedanceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LineFault} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LineFaultItemProvider lineFaultItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LineFault}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLineFaultAdapter() {
        if( lineFaultItemProvider == null ) {
            lineFaultItemProvider = new LineFaultItemProvider( this );
        }

        return lineFaultItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AirCompressorItemProvider airCompressorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAirCompressorAdapter() {
        if( airCompressorItemProvider == null ) {
            airCompressorItemProvider = new AirCompressorItemProvider( this );
        }

        return airCompressorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusNameMarker} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BusNameMarkerItemProvider busNameMarkerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusNameMarker}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBusNameMarkerAdapter() {
        if( busNameMarkerItemProvider == null ) {
            busNameMarkerItemProvider = new BusNameMarkerItemProvider( this );
        }

        return busNameMarkerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ShuntCompensatorPhaseItemProvider shuntCompensatorPhaseItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createShuntCompensatorPhaseAdapter() {
        if( shuntCompensatorPhaseItemProvider == null ) {
            shuntCompensatorPhaseItemProvider = new ShuntCompensatorPhaseItemProvider( this );
        }

        return shuntCompensatorPhaseItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyElement} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ContingencyElementItemProvider contingencyElementItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyElement}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createContingencyElementAdapter() {
        if( contingencyElementItemProvider == null ) {
            contingencyElementItemProvider = new ContingencyElementItemProvider( this );
        }

        return contingencyElementItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingCondEq} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RegulatingCondEqItemProvider regulatingCondEqItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingCondEq}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRegulatingCondEqAdapter() {
        if( regulatingCondEqItemProvider == null ) {
            regulatingCondEqItemProvider = new RegulatingCondEqItemProvider( this );
        }

        return regulatingCondEqItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AnalogValueItemProvider analogValueItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAnalogValueAdapter() {
        if( analogValueItemProvider == null ) {
            analogValueItemProvider = new AnalogValueItemProvider( this );
        }

        return analogValueItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimitSet} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AnalogLimitSetItemProvider analogLimitSetItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimitSet}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAnalogLimitSetAdapter() {
        if( analogLimitSetItemProvider == null ) {
            analogLimitSetItemProvider = new AnalogLimitSetItemProvider( this );
        }

        return analogLimitSetItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CurrentRelayItemProvider currentRelayItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCurrentRelayAdapter() {
        if( currentRelayItemProvider == null ) {
            currentRelayItemProvider = new CurrentRelayItemProvider( this );
        }

        return currentRelayItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HeatInputCurveItemProvider heatInputCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHeatInputCurveAdapter() {
        if( heatInputCurveItemProvider == null ) {
            heatInputCurveItemProvider = new HeatInputCurveItemProvider( this );
        }

        return heatInputCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ControlItemProvider controlItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createControlAdapter() {
        if( controlItemProvider == null ) {
            controlItemProvider = new ControlItemProvider( this );
        }

        return controlItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HydroPumpItemProvider hydroPumpItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHydroPumpAdapter() {
        if( hydroPumpItemProvider == null ) {
            hydroPumpItemProvider = new HydroPumpItemProvider( this );
        }

        return hydroPumpItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AuxiliaryEquipment} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AuxiliaryEquipmentItemProvider auxiliaryEquipmentItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AuxiliaryEquipment}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAuxiliaryEquipmentAdapter() {
        if( auxiliaryEquipmentItemProvider == null ) {
            auxiliaryEquipmentItemProvider = new AuxiliaryEquipmentItemProvider( this );
        }

        return auxiliaryEquipmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNodeContainer} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConnectivityNodeContainerItemProvider connectivityNodeContainerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNodeContainer}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConnectivityNodeContainerAdapter() {
        if( connectivityNodeContainerItemProvider == null ) {
            connectivityNodeContainerItemProvider = new ConnectivityNodeContainerItemProvider( this );
        }

        return connectivityNodeContainerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AltTieMeasItemProvider altTieMeasItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAltTieMeasAdapter() {
        if( altTieMeasItemProvider == null ) {
            altTieMeasItemProvider = new AltTieMeasItemProvider( this );
        }

        return altTieMeasItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SwitchPhaseItemProvider switchPhaseItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSwitchPhaseAdapter() {
        if( switchPhaseItemProvider == null ) {
            switchPhaseItemProvider = new SwitchPhaseItemProvider( this );
        }

        return switchPhaseItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Supercritical} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SupercriticalItemProvider supercriticalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Supercritical}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSupercriticalAdapter() {
        if( supercriticalItemProvider == null ) {
            supercriticalItemProvider = new SupercriticalItemProvider( this );
        }

        return supercriticalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultCauseType} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FaultCauseTypeItemProvider faultCauseTypeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultCauseType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFaultCauseTypeAdapter() {
        if( faultCauseTypeItemProvider == null ) {
            faultCauseTypeItemProvider = new FaultCauseTypeItemProvider( this );
        }

        return faultCauseTypeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CurrentTransformerItemProvider currentTransformerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCurrentTransformerAdapter() {
        if( currentTransformerItemProvider == null ) {
            currentTransformerItemProvider = new CurrentTransformerItemProvider( this );
        }

        return currentTransformerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsCapabilityCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected VsCapabilityCurveItemProvider vsCapabilityCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsCapabilityCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createVsCapabilityCurveAdapter() {
        if( vsCapabilityCurveItemProvider == null ) {
            vsCapabilityCurveItemProvider = new VsCapabilityCurveItemProvider( this );
        }

        return vsCapabilityCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RegularTimePointItemProvider regularTimePointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRegularTimePointAdapter() {
        if( regularTimePointItemProvider == null ) {
            regularTimePointItemProvider = new RegularTimePointItemProvider( this );
        }

        return regularTimePointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FrequencyConverterItemProvider frequencyConverterItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFrequencyConverterAdapter() {
        if( frequencyConverterItemProvider == null ) {
            frequencyConverterItemProvider = new FrequencyConverterItemProvider( this );
        }

        return frequencyConverterItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoad} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConformLoadItemProvider conformLoadItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoad}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConformLoadAdapter() {
        if( conformLoadItemProvider == null ) {
            conformLoadItemProvider = new ConformLoadItemProvider( this );
        }

        return conformLoadItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HydroPowerPlantItemProvider hydroPowerPlantItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHydroPowerPlantAdapter() {
        if( hydroPowerPlantItemProvider == null ) {
            hydroPowerPlantItemProvider = new HydroPowerPlantItemProvider( this );
        }

        return hydroPowerPlantItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GrossToNetActivePowerCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected GrossToNetActivePowerCurveItemProvider grossToNetActivePowerCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GrossToNetActivePowerCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createGrossToNetActivePowerCurveAdapter() {
        if( grossToNetActivePowerCurveItemProvider == null ) {
            grossToNetActivePowerCurveItemProvider = new GrossToNetActivePowerCurveItemProvider( this );
        }

        return grossToNetActivePowerCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FossilFuelItemProvider fossilFuelItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFossilFuelAdapter() {
        if( fossilFuelItemProvider == null ) {
            fossilFuelItemProvider = new FossilFuelItemProvider( this );
        }

        return fossilFuelItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueSource} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected MeasurementValueSourceItemProvider measurementValueSourceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueSource}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createMeasurementValueSourceAdapter() {
        if( measurementValueSourceItemProvider == null ) {
            measurementValueSourceItemProvider = new MeasurementValueSourceItemProvider( this );
        }

        return measurementValueSourceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ShutdownCurveItemProvider shutdownCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createShutdownCurveAdapter() {
        if( shutdownCurveItemProvider == null ) {
            shutdownCurveItemProvider = new ShutdownCurveItemProvider( this );
        }

        return shutdownCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TransformerCoreAdmittanceItemProvider transformerCoreAdmittanceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTransformerCoreAdmittanceAdapter() {
        if( transformerCoreAdmittanceItemProvider == null ) {
            transformerCoreAdmittanceItemProvider = new TransformerCoreAdmittanceItemProvider( this );
        }

        return transformerCoreAdmittanceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EnergyConsumerItemProvider energyConsumerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEnergyConsumerAdapter() {
        if( energyConsumerItemProvider == null ) {
            energyConsumerItemProvider = new EnergyConsumerItemProvider( this );
        }

        return energyConsumerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarSection} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BusbarSectionItemProvider busbarSectionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarSection}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBusbarSectionAdapter() {
        if( busbarSectionItemProvider == null ) {
            busbarSectionItemProvider = new BusbarSectionItemProvider( this );
        }

        return busbarSectionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentContainer} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EquipmentContainerItemProvider equipmentContainerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentContainer}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEquipmentContainerAdapter() {
        if( equipmentContainerItemProvider == null ) {
            equipmentContainerItemProvider = new EquipmentContainerItemProvider( this );
        }

        return equipmentContainerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBreaker} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCBreakerItemProvider dcBreakerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBreaker}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCBreakerAdapter() {
        if( dcBreakerItemProvider == null ) {
            dcBreakerItemProvider = new DCBreakerItemProvider( this );
        }

        return dcBreakerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurementValue} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StringMeasurementValueItemProvider stringMeasurementValueItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurementValue}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStringMeasurementValueAdapter() {
        if( stringMeasurementValueItemProvider == null ) {
            stringMeasurementValueItemProvider = new StringMeasurementValueItemProvider( this );
        }

        return stringMeasurementValueItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RaiseLowerCommand} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RaiseLowerCommandItemProvider raiseLowerCommandItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RaiseLowerCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRaiseLowerCommandAdapter() {
        if( raiseLowerCommandItemProvider == null ) {
            raiseLowerCommandItemProvider = new RaiseLowerCommandItemProvider( this );
        }

        return raiseLowerCommandItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TapScheduleItemProvider tapScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTapScheduleAdapter() {
        if( tapScheduleItemProvider == null ) {
            tapScheduleItemProvider = new TapScheduleItemProvider( this );
        }

        return tapScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueToAlias} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ValueToAliasItemProvider valueToAliasItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueToAlias}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createValueToAliasAdapter() {
        if( valueToAliasItemProvider == null ) {
            valueToAliasItemProvider = new ValueToAliasItemProvider( this );
        }

        return valueToAliasItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectGluePoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DiagramObjectGluePointItemProvider diagramObjectGluePointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectGluePoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDiagramObjectGluePointAdapter() {
        if( diagramObjectGluePointItemProvider == null ) {
            diagramObjectGluePointItemProvider = new DiagramObjectGluePointItemProvider( this );
        }

        return diagramObjectGluePointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SwitchItemProvider switchItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSwitchAdapter() {
        if( switchItemProvider == null ) {
            switchItemProvider = new SwitchItemProvider( this );
        }

        return switchItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BreakerItemProvider breakerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBreakerAdapter() {
        if( breakerItemProvider == null ) {
            breakerItemProvider = new BreakerItemProvider( this );
        }

        return breakerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTerminal} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCTerminalItemProvider dcTerminalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTerminal}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCTerminalAdapter() {
        if( dcTerminalItemProvider == null ) {
            dcTerminalItemProvider = new DCTerminalItemProvider( this );
        }

        return dcTerminalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Sectionaliser} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SectionaliserItemProvider sectionaliserItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Sectionaliser}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSectionaliserAdapter() {
        if( sectionaliserItemProvider == null ) {
            sectionaliserItemProvider = new SectionaliserItemProvider( this );
        }

        return sectionaliserItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SvInjectionItemProvider svInjectionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSvInjectionAdapter() {
        if( svInjectionItemProvider == null ) {
            svInjectionItemProvider = new SvInjectionItemProvider( this );
        }

        return svInjectionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected GenUnitOpScheduleItemProvider genUnitOpScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createGenUnitOpScheduleAdapter() {
        if( genUnitOpScheduleItemProvider == null ) {
            genUnitOpScheduleItemProvider = new GenUnitOpScheduleItemProvider( this );
        }

        return genUnitOpScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TransformerEndItemProvider transformerEndItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTransformerEndAdapter() {
        if( transformerEndItemProvider == null ) {
            transformerEndItemProvider = new TransformerEndItemProvider( this );
        }

        return transformerEndItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadGroup} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LoadGroupItemProvider loadGroupItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadGroup}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLoadGroupAdapter() {
        if( loadGroupItemProvider == null ) {
            loadGroupItemProvider = new LoadGroupItemProvider( this );
        }

        return loadGroupItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AnalogControlItemProvider analogControlItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAnalogControlAdapter() {
        if( analogControlItemProvider == null ) {
            analogControlItemProvider = new AnalogControlItemProvider( this );
        }

        return analogControlItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCConverterUnitItemProvider dcConverterUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCConverterUnitAdapter() {
        if( dcConverterUnitItemProvider == null ) {
            dcConverterUnitItemProvider = new DCConverterUnitItemProvider( this );
        }

        return dcConverterUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TapChangerItemProvider tapChangerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTapChangerAdapter() {
        if( tapChangerItemProvider == null ) {
            tapChangerItemProvider = new TapChangerItemProvider( this );
        }

        return tapChangerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CsConverterItemProvider csConverterItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCsConverterAdapter() {
        if( csConverterItemProvider == null ) {
            csConverterItemProvider = new CsConverterItemProvider( this );
        }

        return csConverterItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ValueAliasSetItemProvider valueAliasSetItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createValueAliasSetAdapter() {
        if( valueAliasSetItemProvider == null ) {
            valueAliasSetItemProvider = new ValueAliasSetItemProvider( this );
        }

        return valueAliasSetItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCSeriesDeviceItemProvider dcSeriesDeviceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCSeriesDeviceAdapter() {
        if( dcSeriesDeviceItemProvider == null ) {
            dcSeriesDeviceItemProvider = new DCSeriesDeviceItemProvider( this );
        }

        return dcSeriesDeviceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WaveTrap} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected WaveTrapItemProvider waveTrapItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WaveTrap}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createWaveTrapAdapter() {
        if( waveTrapItemProvider == null ) {
            waveTrapItemProvider = new WaveTrapItemProvider( this );
        }

        return waveTrapItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NameItemProvider nameItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNameAdapter() {
        if( nameItemProvider == null ) {
            nameItemProvider = new NameItemProvider( this );
        }

        return nameItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ControlAreaItemProvider controlAreaItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createControlAreaAdapter() {
        if( controlAreaItemProvider == null ) {
            controlAreaItemProvider = new ControlAreaItemProvider( this );
        }

        return controlAreaItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EquivalentInjectionItemProvider equivalentInjectionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEquivalentInjectionAdapter() {
        if( equivalentInjectionItemProvider == null ) {
            equivalentInjectionItemProvider = new EquivalentInjectionItemProvider( this );
        }

        return equivalentInjectionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCTopologicalNodeItemProvider dcTopologicalNodeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCTopologicalNodeAdapter() {
        if( dcTopologicalNodeItemProvider == null ) {
            dcTopologicalNodeItemProvider = new DCTopologicalNodeItemProvider( this );
        }

        return dcTopologicalNodeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCChopper} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCChopperItemProvider dcChopperItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCChopper}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCChopperAdapter() {
        if( dcChopperItemProvider == null ) {
            dcChopperItemProvider = new DCChopperItemProvider( this );
        }

        return dcChopperItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PerLengthSequenceImpedanceItemProvider perLengthSequenceImpedanceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPerLengthSequenceImpedanceAdapter() {
        if( perLengthSequenceImpedanceItemProvider == null ) {
            perLengthSequenceImpedanceItemProvider = new PerLengthSequenceImpedanceItemProvider( this );
        }

        return perLengthSequenceImpedanceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartRampCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StartRampCurveItemProvider startRampCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartRampCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStartRampCurveAdapter() {
        if( startRampCurveItemProvider == null ) {
            startRampCurveItemProvider = new StartRampCurveItemProvider( this );
        }

        return startRampCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ACDCConverterItemProvider acdcConverterItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createACDCConverterAdapter() {
        if( acdcConverterItemProvider == null ) {
            acdcConverterItemProvider = new ACDCConverterItemProvider( this );
        }

        return acdcConverterItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PowerTransformerItemProvider powerTransformerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPowerTransformerAdapter() {
        if( powerTransformerItemProvider == null ) {
            powerTransformerItemProvider = new PowerTransformerItemProvider( this );
        }

        return powerTransformerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ActivePowerLimit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ActivePowerLimitItemProvider activePowerLimitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ActivePowerLimit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createActivePowerLimitAdapter() {
        if( activePowerLimitItemProvider == null ) {
            activePowerLimitItemProvider = new ActivePowerLimitItemProvider( this );
        }

        return activePowerLimitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EmissionAccountItemProvider emissionAccountItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEmissionAccountAdapter() {
        if( emissionAccountItemProvider == null ) {
            emissionAccountItemProvider = new EmissionAccountItemProvider( this );
        }

        return emissionAccountItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CurveItemProvider curveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCurveAdapter() {
        if( curveItemProvider == null ) {
            curveItemProvider = new CurveItemProvider( this );
        }

        return curveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PowerElectronicsConnectionItemProvider powerElectronicsConnectionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPowerElectronicsConnectionAdapter() {
        if( powerElectronicsConnectionItemProvider == null ) {
            powerElectronicsConnectionItemProvider = new PowerElectronicsConnectionItemProvider( this );
        }

        return powerElectronicsConnectionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LevelVsVolumeCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LevelVsVolumeCurveItemProvider levelVsVolumeCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LevelVsVolumeCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLevelVsVolumeCurveAdapter() {
        if( levelVsVolumeCurveItemProvider == null ) {
            levelVsVolumeCurveItemProvider = new LevelVsVolumeCurveItemProvider( this );
        }

        return levelVsVolumeCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RatioTapChangerItemProvider ratioTapChangerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRatioTapChangerAdapter() {
        if( ratioTapChangerItemProvider == null ) {
            ratioTapChangerItemProvider = new RatioTapChangerItemProvider( this );
        }

        return ratioTapChangerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HydroGeneratingUnitItemProvider hydroGeneratingUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHydroGeneratingUnitAdapter() {
        if( hydroGeneratingUnitItemProvider == null ) {
            hydroGeneratingUnitItemProvider = new HydroGeneratingUnitItemProvider( this );
        }

        return hydroGeneratingUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingParticipant} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected OperatingParticipantItemProvider operatingParticipantItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingParticipant}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createOperatingParticipantAdapter() {
        if( operatingParticipantItemProvider == null ) {
            operatingParticipantItemProvider = new OperatingParticipantItemProvider( this );
        }

        return operatingParticipantItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthImpedance} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PerLengthImpedanceItemProvider perLengthImpedanceItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthImpedance}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPerLengthImpedanceAdapter() {
        if( perLengthImpedanceItemProvider == null ) {
            perLengthImpedanceItemProvider = new PerLengthImpedanceItemProvider( this );
        }

        return perLengthImpedanceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BaseVoltageItemProvider baseVoltageItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBaseVoltageAdapter() {
        if( baseVoltageItemProvider == null ) {
            baseVoltageItemProvider = new BaseVoltageItemProvider( this );
        }

        return baseVoltageItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SeasonItemProvider seasonItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSeasonAdapter() {
        if( seasonItemProvider == null ) {
            seasonItemProvider = new SeasonItemProvider( this );
        }

        return seasonItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadArea} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LoadAreaItemProvider loadAreaItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadArea}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLoadAreaAdapter() {
        if( loadAreaItemProvider == null ) {
            loadAreaItemProvider = new LoadAreaItemProvider( this );
        }

        return loadAreaItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipment} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ContingencyEquipmentItemProvider contingencyEquipmentItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipment}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createContingencyEquipmentAdapter() {
        if( contingencyEquipmentItemProvider == null ) {
            contingencyEquipmentItemProvider = new ContingencyEquipmentItemProvider( this );
        }

        return contingencyEquipmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CombustionTurbineItemProvider combustionTurbineItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCombustionTurbineAdapter() {
        if( combustionTurbineItemProvider == null ) {
            combustionTurbineItemProvider = new CombustionTurbineItemProvider( this );
        }

        return combustionTurbineItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeographicalRegion} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected GeographicalRegionItemProvider geographicalRegionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeographicalRegion}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createGeographicalRegionAdapter() {
        if( geographicalRegionItemProvider == null ) {
            geographicalRegionItemProvider = new GeographicalRegionItemProvider( this );
        }

        return geographicalRegionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BasicIntervalScheduleItemProvider basicIntervalScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBasicIntervalScheduleAdapter() {
        if( basicIntervalScheduleItemProvider == null ) {
            basicIntervalScheduleItemProvider = new BasicIntervalScheduleItemProvider( this );
        }

        return basicIntervalScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCDisconnector} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCDisconnectorItemProvider dcDisconnectorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCDisconnector}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCDisconnectorAdapter() {
        if( dcDisconnectorItemProvider == null ) {
            dcDisconnectorItemProvider = new DCDisconnectorItemProvider( this );
        }

        return dcDisconnectorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CogenerationPlantItemProvider cogenerationPlantItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCogenerationPlantAdapter() {
        if( cogenerationPlantItemProvider == null ) {
            cogenerationPlantItemProvider = new CogenerationPlantItemProvider( this );
        }

        return cogenerationPlantItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PhaseTapChangerNonLinearItemProvider phaseTapChangerNonLinearItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPhaseTapChangerNonLinearAdapter() {
        if( phaseTapChangerNonLinearItemProvider == null ) {
            phaseTapChangerNonLinearItemProvider = new PhaseTapChangerNonLinearItemProvider( this );
        }

        return phaseTapChangerNonLinearItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EmissionCurveItemProvider emissionCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEmissionCurveAdapter() {
        if( emissionCurveItemProvider == null ) {
            emissionCurveItemProvider = new EmissionCurveItemProvider( this );
        }

        return emissionCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EquivalentBranchItemProvider equivalentBranchItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEquivalentBranchAdapter() {
        if( equivalentBranchItemProvider == null ) {
            equivalentBranchItemProvider = new EquivalentBranchItemProvider( this );
        }

        return equivalentBranchItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PostLineSensor} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PostLineSensorItemProvider postLineSensorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PostLineSensor}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPostLineSensorAdapter() {
        if( postLineSensorItemProvider == null ) {
            postLineSensorItemProvider = new PostLineSensorItemProvider( this );
        }

        return postLineSensorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulationSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RegulationScheduleItemProvider regulationScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulationSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRegulationScheduleAdapter() {
        if( regulationScheduleItemProvider == null ) {
            regulationScheduleItemProvider = new RegulationScheduleItemProvider( this );
        }

        return regulationScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ThermalGeneratingUnitItemProvider thermalGeneratingUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createThermalGeneratingUnitAdapter() {
        if( thermalGeneratingUnitItemProvider == null ) {
            thermalGeneratingUnitItemProvider = new ThermalGeneratingUnitItemProvider( this );
        }

        return thermalGeneratingUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected GeneratingUnitItemProvider generatingUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createGeneratingUnitAdapter() {
        if( generatingUnitItemProvider == null ) {
            generatingUnitItemProvider = new GeneratingUnitItemProvider( this );
        }

        return generatingUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TapChangerControlItemProvider tapChangerControlItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTapChangerControlAdapter() {
        if( tapChangerControlItemProvider == null ) {
            tapChangerControlItemProvider = new TapChangerControlItemProvider( this );
        }

        return tapChangerControlItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentEquipment} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EquivalentEquipmentItemProvider equivalentEquipmentItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentEquipment}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEquivalentEquipmentAdapter() {
        if( equivalentEquipmentItemProvider == null ) {
            equivalentEquipmentItemProvider = new EquivalentEquipmentItemProvider( this );
        }

        return equivalentEquipmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Connector} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConnectorItemProvider connectorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Connector}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConnectorAdapter() {
        if( connectorItemProvider == null ) {
            connectorItemProvider = new ConnectorItemProvider( this );
        }

        return connectorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected RegularIntervalScheduleItemProvider regularIntervalScheduleItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createRegularIntervalScheduleAdapter() {
        if( regularIntervalScheduleItemProvider == null ) {
            regularIntervalScheduleItemProvider = new RegularIntervalScheduleItemProvider( this );
        }

        return regularIntervalScheduleItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChanger} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PhaseTapChangerItemProvider phaseTapChangerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChanger}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPhaseTapChangerAdapter() {
        if( phaseTapChangerItemProvider == null ) {
            phaseTapChangerItemProvider = new PhaseTapChangerItemProvider( this );
        }

        return phaseTapChangerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DiscreteItemProvider discreteItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDiscreteAdapter() {
        if( discreteItemProvider == null ) {
            discreteItemProvider = new DiscreteItemProvider( this );
        }

        return discreteItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalIsland} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCTopologicalIslandItemProvider dcTopologicalIslandItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalIsland}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCTopologicalIslandAdapter() {
        if( dcTopologicalIslandItemProvider == null ) {
            dcTopologicalIslandItemProvider = new DCTopologicalIslandItemProvider( this );
        }

        return dcTopologicalIslandItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Sensor} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SensorItemProvider sensorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Sensor}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSensorAdapter() {
        if( sensorItemProvider == null ) {
            sensorItemProvider = new SensorItemProvider( this );
        }

        return sensorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SvPowerFlowItemProvider svPowerFlowItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSvPowerFlowAdapter() {
        if( svPowerFlowItemProvider == null ) {
            svPowerFlowItemProvider = new SvPowerFlowItemProvider( this );
        }

        return svPowerFlowItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BranchGroupItemProvider branchGroupItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBranchGroupAdapter() {
        if( branchGroupItemProvider == null ) {
            branchGroupItemProvider = new BranchGroupItemProvider( this );
        }

        return branchGroupItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TopologicalNodeItemProvider topologicalNodeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTopologicalNodeAdapter() {
        if( topologicalNodeItemProvider == null ) {
            topologicalNodeItemProvider = new TopologicalNodeItemProvider( this );
        }

        return topologicalNodeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Subcritical} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SubcriticalItemProvider subcriticalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Subcritical}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSubcriticalAdapter() {
        if( subcriticalItemProvider == null ) {
            subcriticalItemProvider = new SubcriticalItemProvider( this );
        }

        return subcriticalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AccumulatorValueItemProvider accumulatorValueItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAccumulatorValueAdapter() {
        if( accumulatorValueItemProvider == null ) {
            accumulatorValueItemProvider = new AccumulatorValueItemProvider( this );
        }

        return accumulatorValueItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StationSupply} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StationSupplyItemProvider stationSupplyItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StationSupply}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStationSupplyAdapter() {
        if( stationSupplyItemProvider == null ) {
            stationSupplyItemProvider = new StationSupplyItemProvider( this );
        }

        return stationSupplyItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentNetwork} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EquivalentNetworkItemProvider equivalentNetworkItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentNetwork}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEquivalentNetworkAdapter() {
        if( equivalentNetworkItemProvider == null ) {
            equivalentNetworkItemProvider = new EquivalentNetworkItemProvider( this );
        }

        return equivalentNetworkItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SolarGeneratingUnit} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SolarGeneratingUnitItemProvider solarGeneratingUnitItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SolarGeneratingUnit}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSolarGeneratingUnitAdapter() {
        if( solarGeneratingUnitItemProvider == null ) {
            solarGeneratingUnitItemProvider = new SolarGeneratingUnitItemProvider( this );
        }

        return solarGeneratingUnitItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCEquipmentContainer} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCEquipmentContainerItemProvider dcEquipmentContainerItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCEquipmentContainer}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCEquipmentContainerAdapter() {
        if( dcEquipmentContainerItemProvider == null ) {
            dcEquipmentContainerItemProvider = new DCEquipmentContainerItemProvider( this );
        }

        return dcEquipmentContainerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConductingEquipment} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DCConductingEquipmentItemProvider dcConductingEquipmentItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConductingEquipment}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDCConductingEquipmentAdapter() {
        if( dcConductingEquipmentItemProvider == null ) {
            dcConductingEquipmentItemProvider = new DCConductingEquipmentItemProvider( this );
        }

        return dcConductingEquipmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Jumper} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected JumperItemProvider jumperItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Jumper}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createJumperAdapter() {
        if( jumperItemProvider == null ) {
            jumperItemProvider = new JumperItemProvider( this );
        }

        return jumperItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthLineParameter} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PerLengthLineParameterItemProvider perLengthLineParameterItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthLineParameter}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPerLengthLineParameterAdapter() {
        if( perLengthLineParameterItemProvider == null ) {
            perLengthLineParameterItemProvider = new PerLengthLineParameterItemProvider( this );
        }

        return perLengthLineParameterItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerAsymmetrical} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PhaseTapChangerAsymmetricalItemProvider phaseTapChangerAsymmetricalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerAsymmetrical}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPhaseTapChangerAsymmetricalAdapter() {
        if( phaseTapChangerAsymmetricalItemProvider == null ) {
            phaseTapChangerAsymmetricalItemProvider = new PhaseTapChangerAsymmetricalItemProvider( this );
        }

        return phaseTapChangerAsymmetricalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReportingSuperGroup} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ReportingSuperGroupItemProvider reportingSuperGroupItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReportingSuperGroup}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createReportingSuperGroupAdapter() {
        if( reportingSuperGroupItemProvider == null ) {
            reportingSuperGroupItemProvider = new ReportingSuperGroupItemProvider( this );
        }

        return reportingSuperGroupItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected VsConverterItemProvider vsConverterItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createVsConverterAdapter() {
        if( vsConverterItemProvider == null ) {
            vsConverterItemProvider = new VsConverterItemProvider( this );
        }

        return vsConverterItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CTTempActivePowerCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CTTempActivePowerCurveItemProvider ctTempActivePowerCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CTTempActivePowerCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCTTempActivePowerCurveAdapter() {
        if( ctTempActivePowerCurveItemProvider == null ) {
            ctTempActivePowerCurveItemProvider = new CTTempActivePowerCurveItemProvider( this );
        }

        return ctTempActivePowerCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected OperatingShareItemProvider operatingShareItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createOperatingShareAdapter() {
        if( operatingShareItemProvider == null ) {
            operatingShareItemProvider = new OperatingShareItemProvider( this );
        }

        return operatingShareItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTabular} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PhaseTapChangerTabularItemProvider phaseTapChangerTabularItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTabular}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPhaseTapChangerTabularAdapter() {
        if( phaseTapChangerTabularItemProvider == null ) {
            phaseTapChangerTabularItemProvider = new PhaseTapChangerTabularItemProvider( this );
        }

        return phaseTapChangerTabularItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NonlinearShuntCompensatorPhasePointItemProvider nonlinearShuntCompensatorPhasePointItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNonlinearShuntCompensatorPhasePointAdapter() {
        if( nonlinearShuntCompensatorPhasePointItemProvider == null ) {
            nonlinearShuntCompensatorPhasePointItemProvider = new NonlinearShuntCompensatorPhasePointItemProvider(
                    this );
        }

        return nonlinearShuntCompensatorPhasePointItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Junction} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected JunctionItemProvider junctionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Junction}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createJunctionAdapter() {
        if( junctionItemProvider == null ) {
            junctionItemProvider = new JunctionItemProvider( this );
        }

        return junctionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTank} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TransformerTankItemProvider transformerTankItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTank}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTransformerTankAdapter() {
        if( transformerTankItemProvider == null ) {
            transformerTankItemProvider = new TransformerTankItemProvider( this );
        }

        return transformerTankItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TailbayLossCurve} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TailbayLossCurveItemProvider tailbayLossCurveItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TailbayLossCurve}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTailbayLossCurveAdapter() {
        if( tailbayLossCurveItemProvider == null ) {
            tailbayLossCurveItemProvider = new TailbayLossCurveItemProvider( this );
        }

        return tailbayLossCurveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected MutualCouplingItemProvider mutualCouplingItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createMutualCouplingAdapter() {
        if( mutualCouplingItemProvider == null ) {
            mutualCouplingItemProvider = new MutualCouplingItemProvider( this );
        }

        return mutualCouplingItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadBreakSwitch} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LoadBreakSwitchItemProvider loadBreakSwitchItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadBreakSwitch}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLoadBreakSwitchAdapter() {
        if( loadBreakSwitchItemProvider == null ) {
            loadBreakSwitchItemProvider = new LoadBreakSwitchItemProvider( this );
        }

        return loadBreakSwitchItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Conductor} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConductorItemProvider conductorItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Conductor}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConductorAdapter() {
        if( conductorItemProvider == null ) {
            conductorItemProvider = new ConductorItemProvider( this );
        }

        return conductorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ExternalNetworkInjectionItemProvider externalNetworkInjectionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createExternalNetworkInjectionAdapter() {
        if( externalNetworkInjectionItemProvider == null ) {
            externalNetworkInjectionItemProvider = new ExternalNetworkInjectionItemProvider( this );
        }

        return externalNetworkInjectionItemProvider;
    }

    /**
     * This returns the root adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ComposeableAdapterFactory getRootAdapterFactory() {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void setParentAdapterFactory( ComposedAdapterFactory parentAdapterFactory ) {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean isFactoryForType( Object type ) {
        return supportedTypes.contains( type ) || super.isFactoryForType( type );
    }

    /**
     * This implementation substitutes the factory itself as the key for the adapter.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter adapt( Notifier notifier, Object type ) {
        return super.adapt( notifier, this );
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object adapt( Object object, Object type ) {
        if( isFactoryForType( type ) ) {
            Object adapter = super.adapt( object, type );
            if( !( type instanceof Class< ? > ) || ( ( ( Class< ? > ) type ).isInstance( adapter ) ) ) {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void addListener( INotifyChangedListener notifyChangedListener ) {
        changeNotifier.addListener( notifyChangedListener );
    }

    /**
     * This removes a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void removeListener( INotifyChangedListener notifyChangedListener ) {
        changeNotifier.removeListener( notifyChangedListener );
    }

    /**
     * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void fireNotifyChanged( Notification notification ) {
        changeNotifier.fireNotifyChanged( notification );

        if( parentAdapterFactory != null ) {
            parentAdapterFactory.fireNotifyChanged( notification );
        }
    }

    /**
     * This disposes all of the item providers created by this factory. 
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void dispose() {
        if( faultImpedanceItemProvider != null ) faultImpedanceItemProvider.dispose();
        if( floatQuantityItemProvider != null ) floatQuantityItemProvider.dispose();
        if( dateTimeIntervalItemProvider != null ) dateTimeIntervalItemProvider.dispose();
        if( timeIntervalItemProvider != null ) timeIntervalItemProvider.dispose();
        if( decimalQuantityItemProvider != null ) decimalQuantityItemProvider.dispose();
        if( stringQuantityItemProvider != null ) stringQuantityItemProvider.dispose();
        if( monthDayIntervalItemProvider != null ) monthDayIntervalItemProvider.dispose();
        if( dateIntervalItemProvider != null ) dateIntervalItemProvider.dispose();
        if( integerQuantityItemProvider != null ) integerQuantityItemProvider.dispose();
        if( loadResponseCharacteristicItemProvider != null ) loadResponseCharacteristicItemProvider.dispose();
        if( genUnitOpCostCurveItemProvider != null ) genUnitOpCostCurveItemProvider.dispose();
        if( potentialTransformerItemProvider != null ) potentialTransformerItemProvider.dispose();
        if( dcConductingEquipmentItemProvider != null ) dcConductingEquipmentItemProvider.dispose();
        if( recloseSequenceItemProvider != null ) recloseSequenceItemProvider.dispose();
        if( ratioTapChangerItemProvider != null ) ratioTapChangerItemProvider.dispose();
        if( phaseTapChangerTablePointItemProvider != null ) phaseTapChangerTablePointItemProvider.dispose();
        if( tieFlowItemProvider != null ) tieFlowItemProvider.dispose();
        if( voltageControlZoneItemProvider != null ) voltageControlZoneItemProvider.dispose();
        if( analogItemProvider != null ) analogItemProvider.dispose();
        if( junctionItemProvider != null ) junctionItemProvider.dispose();
        if( controlAreaItemProvider != null ) controlAreaItemProvider.dispose();
        if( valueToAliasItemProvider != null ) valueToAliasItemProvider.dispose();
        if( hydroTurbineItemProvider != null ) hydroTurbineItemProvider.dispose();
        if( waveTrapItemProvider != null ) waveTrapItemProvider.dispose();
        if( altTieMeasItemProvider != null ) altTieMeasItemProvider.dispose();
        if( psrTypeItemProvider != null ) psrTypeItemProvider.dispose();
        if( remoteSourceItemProvider != null ) remoteSourceItemProvider.dispose();
        if( equivalentInjectionItemProvider != null ) equivalentInjectionItemProvider.dispose();
        if( svTapStepItemProvider != null ) svTapStepItemProvider.dispose();
        if( protectionEquipmentItemProvider != null ) protectionEquipmentItemProvider.dispose();
        if( measurementItemProvider != null ) measurementItemProvider.dispose();
        if( powerSystemResourceItemProvider != null ) powerSystemResourceItemProvider.dispose();
        if( bwrSteamSupplyItemProvider != null ) bwrSteamSupplyItemProvider.dispose();
        if( dcBusbarItemProvider != null ) dcBusbarItemProvider.dispose();
        if( discreteItemProvider != null ) discreteItemProvider.dispose();
        if( connectivityNodeContainerItemProvider != null ) connectivityNodeContainerItemProvider.dispose();
        if( phaseTapChangerAsymmetricalItemProvider != null ) phaseTapChangerAsymmetricalItemProvider.dispose();
        if( phaseTapChangerNonLinearItemProvider != null ) phaseTapChangerNonLinearItemProvider.dispose();
        if( primeMoverItemProvider != null ) primeMoverItemProvider.dispose();
        if( nonConformLoadScheduleItemProvider != null ) nonConformLoadScheduleItemProvider.dispose();
        if( dcLineItemProvider != null ) dcLineItemProvider.dispose();
        if( currentTransformerItemProvider != null ) currentTransformerItemProvider.dispose();
        if( remoteUnitItemProvider != null ) remoteUnitItemProvider.dispose();
        if( hydroGeneratingUnitItemProvider != null ) hydroGeneratingUnitItemProvider.dispose();
        if( branchGroupItemProvider != null ) branchGroupItemProvider.dispose();
        if( remotePointItemProvider != null ) remotePointItemProvider.dispose();
        if( powerElectronicsWindUnitItemProvider != null ) powerElectronicsWindUnitItemProvider.dispose();
        if( bayItemProvider != null ) bayItemProvider.dispose();
        if( nameItemProvider != null ) nameItemProvider.dispose();
        if( loadBreakSwitchItemProvider != null ) loadBreakSwitchItemProvider.dispose();
        if( baseFrequencyItemProvider != null ) baseFrequencyItemProvider.dispose();
        if( transformerCoreAdmittanceItemProvider != null ) transformerCoreAdmittanceItemProvider.dispose();
        if( dcSeriesDeviceItemProvider != null ) dcSeriesDeviceItemProvider.dispose();
        if( voltageLevelItemProvider != null ) voltageLevelItemProvider.dispose();
        if( dcGroundItemProvider != null ) dcGroundItemProvider.dispose();
        if( subGeographicalRegionItemProvider != null ) subGeographicalRegionItemProvider.dispose();
        if( cogenerationPlantItemProvider != null ) cogenerationPlantItemProvider.dispose();
        if( faultCauseTypeItemProvider != null ) faultCauseTypeItemProvider.dispose();
        if( dcLineSegmentItemProvider != null ) dcLineSegmentItemProvider.dispose();
        if( equipmentContainerItemProvider != null ) equipmentContainerItemProvider.dispose();
        if( conductorItemProvider != null ) conductorItemProvider.dispose();
        if( windGeneratingUnitItemProvider != null ) windGeneratingUnitItemProvider.dispose();
        if( penstockLossCurveItemProvider != null ) penstockLossCurveItemProvider.dispose();
        if( visibilityLayerItemProvider != null ) visibilityLayerItemProvider.dispose();
        if( dcTopologicalIslandItemProvider != null ) dcTopologicalIslandItemProvider.dispose();
        if( combinedCyclePlantItemProvider != null ) combinedCyclePlantItemProvider.dispose();
        if( compositeSwitchItemProvider != null ) compositeSwitchItemProvider.dispose();
        if( auxiliaryEquipmentItemProvider != null ) auxiliaryEquipmentItemProvider.dispose();
        if( limitSetItemProvider != null ) limitSetItemProvider.dispose();
        if( nonConformLoadItemProvider != null ) nonConformLoadItemProvider.dispose();
        if( equipmentItemProvider != null ) equipmentItemProvider.dispose();
        if( quality61850ItemProvider != null ) quality61850ItemProvider.dispose();
        if( transformerTankEndItemProvider != null ) transformerTankEndItemProvider.dispose();
        if( equivalentEquipmentItemProvider != null ) equivalentEquipmentItemProvider.dispose();
        if( tapChangerControlItemProvider != null ) tapChangerControlItemProvider.dispose();
        if( remoteControlItemProvider != null ) remoteControlItemProvider.dispose();
        if( conductingEquipmentItemProvider != null ) conductingEquipmentItemProvider.dispose();
        if( ctTempActivePowerCurveItemProvider != null ) ctTempActivePowerCurveItemProvider.dispose();
        if( irregularIntervalScheduleItemProvider != null ) irregularIntervalScheduleItemProvider.dispose();
        if( analogControlItemProvider != null ) analogControlItemProvider.dispose();
        if( currentLimitItemProvider != null ) currentLimitItemProvider.dispose();
        if( phaseTapChangerItemProvider != null ) phaseTapChangerItemProvider.dispose();
        if( airCompressorItemProvider != null ) airCompressorItemProvider.dispose();
        if( svInjectionItemProvider != null ) svInjectionItemProvider.dispose();
        if( setPointItemProvider != null ) setPointItemProvider.dispose();
        if( regulatingControlItemProvider != null ) regulatingControlItemProvider.dispose();
        if( accumulatorLimitItemProvider != null ) accumulatorLimitItemProvider.dispose();
        if( fuelAllocationScheduleItemProvider != null ) fuelAllocationScheduleItemProvider.dispose();
        if( synchronousMachineItemProvider != null ) synchronousMachineItemProvider.dispose();
        if( sectionaliserItemProvider != null ) sectionaliserItemProvider.dispose();
        if( dcBaseTerminalItemProvider != null ) dcBaseTerminalItemProvider.dispose();
        if( reportingSuperGroupItemProvider != null ) reportingSuperGroupItemProvider.dispose();
        if( regulatingCondEqItemProvider != null ) regulatingCondEqItemProvider.dispose();
        if( stateVariableItemProvider != null ) stateVariableItemProvider.dispose();
        if( powerElectronicsConnectionItemProvider != null ) powerElectronicsConnectionItemProvider.dispose();
        if( perLengthSequenceImpedanceItemProvider != null ) perLengthSequenceImpedanceItemProvider.dispose();
        if( commandItemProvider != null ) commandItemProvider.dispose();
        if( fuseItemProvider != null ) fuseItemProvider.dispose();
        if( powerCutZoneItemProvider != null ) powerCutZoneItemProvider.dispose();
        if( nonConformLoadGroupItemProvider != null ) nonConformLoadGroupItemProvider.dispose();
        if( accumulatorResetItemProvider != null ) accumulatorResetItemProvider.dispose();
        if( equipmentFaultItemProvider != null ) equipmentFaultItemProvider.dispose();
        if( tapChangerItemProvider != null ) tapChangerItemProvider.dispose();
        if( reactiveCapabilityCurveItemProvider != null ) reactiveCapabilityCurveItemProvider.dispose();
        if( acdcConverterItemProvider != null ) acdcConverterItemProvider.dispose();
        if( nuclearGeneratingUnitItemProvider != null ) nuclearGeneratingUnitItemProvider.dispose();
        if( contingencyEquipmentItemProvider != null ) contingencyEquipmentItemProvider.dispose();
        if( svStatusItemProvider != null ) svStatusItemProvider.dispose();
        if( phaseTapChangerTabularItemProvider != null ) phaseTapChangerTabularItemProvider.dispose();
        if( sensorItemProvider != null ) sensorItemProvider.dispose();
        if( shuntCompensatorPhaseItemProvider != null ) shuntCompensatorPhaseItemProvider.dispose();
        if( conformLoadGroupItemProvider != null ) conformLoadGroupItemProvider.dispose();
        if( operatingParticipantItemProvider != null ) operatingParticipantItemProvider.dispose();
        if( accumulatorLimitSetItemProvider != null ) accumulatorLimitSetItemProvider.dispose();
        if( dcNodeItemProvider != null ) dcNodeItemProvider.dispose();
        if( transformerStarImpedanceItemProvider != null ) transformerStarImpedanceItemProvider.dispose();
        if( subcriticalItemProvider != null ) subcriticalItemProvider.dispose();
        if( activePowerLimitItemProvider != null ) activePowerLimitItemProvider.dispose();
        if( regulationScheduleItemProvider != null ) regulationScheduleItemProvider.dispose();
        if( groundItemProvider != null ) groundItemProvider.dispose();
        if( petersenCoilItemProvider != null ) petersenCoilItemProvider.dispose();
        if( loadGroupItemProvider != null ) loadGroupItemProvider.dispose();
        if( grossToNetActivePowerCurveItemProvider != null ) grossToNetActivePowerCurveItemProvider.dispose();
        if( vsCapabilityCurveItemProvider != null ) vsCapabilityCurveItemProvider.dispose();
        if( acdcTerminalItemProvider != null ) acdcTerminalItemProvider.dispose();
        if( clampItemProvider != null ) clampItemProvider.dispose();
        if( targetLevelScheduleItemProvider != null ) targetLevelScheduleItemProvider.dispose();
        if( transformerTankItemProvider != null ) transformerTankItemProvider.dispose();
        if( genUnitOpScheduleItemProvider != null ) genUnitOpScheduleItemProvider.dispose();
        if( acdcConverterDCTerminalItemProvider != null ) acdcConverterDCTerminalItemProvider.dispose();
        if( textDiagramObjectItemProvider != null ) textDiagramObjectItemProvider.dispose();
        if( svShuntCompensatorSectionsItemProvider != null ) svShuntCompensatorSectionsItemProvider.dispose();
        if( protectedSwitchItemProvider != null ) protectedSwitchItemProvider.dispose();
        if( startIgnFuelCurveItemProvider != null ) startIgnFuelCurveItemProvider.dispose();
        if( diagramObjectPointItemProvider != null ) diagramObjectPointItemProvider.dispose();
        if( operatingShareItemProvider != null ) operatingShareItemProvider.dispose();
        if( nonlinearShuntCompensatorPointItemProvider != null ) nonlinearShuntCompensatorPointItemProvider.dispose();
        if( analogLimitSetItemProvider != null ) analogLimitSetItemProvider.dispose();
        if( contingencyItemProvider != null ) contingencyItemProvider.dispose();
        if( dcTerminalItemProvider != null ) dcTerminalItemProvider.dispose();
        if( phaseTapChangerSymmetricalItemProvider != null ) phaseTapChangerSymmetricalItemProvider.dispose();
        if( transformerEndItemProvider != null ) transformerEndItemProvider.dispose();
        if( branchGroupTerminalItemProvider != null ) branchGroupTerminalItemProvider.dispose();
        if( discreteValueItemProvider != null ) discreteValueItemProvider.dispose();
        if( staticVarCompensatorItemProvider != null ) staticVarCompensatorItemProvider.dispose();
        if( altGeneratingUnitMeasItemProvider != null ) altGeneratingUnitMeasItemProvider.dispose();
        if( limitItemProvider != null ) limitItemProvider.dispose();
        if( nonlinearShuntCompensatorItemProvider != null ) nonlinearShuntCompensatorItemProvider.dispose();
        if( conformLoadScheduleItemProvider != null ) conformLoadScheduleItemProvider.dispose();
        if( diagramObjectStyleItemProvider != null ) diagramObjectStyleItemProvider.dispose();
        if( busbarSectionItemProvider != null ) busbarSectionItemProvider.dispose();
        if( equivalentNetworkItemProvider != null ) equivalentNetworkItemProvider.dispose();
        if( energyConsumerItemProvider != null ) energyConsumerItemProvider.dispose();
        if( currentRelayItemProvider != null ) currentRelayItemProvider.dispose();
        if( levelVsVolumeCurveItemProvider != null ) levelVsVolumeCurveItemProvider.dispose();
        if( nameTypeAuthorityItemProvider != null ) nameTypeAuthorityItemProvider.dispose();
        if( plantItemProvider != null ) plantItemProvider.dispose();
        if( curveDataItemProvider != null ) curveDataItemProvider.dispose();
        if( phaseTapChangerLinearItemProvider != null ) phaseTapChangerLinearItemProvider.dispose();
        if( perLengthLineParameterItemProvider != null ) perLengthLineParameterItemProvider.dispose();
        if( raiseLowerCommandItemProvider != null ) raiseLowerCommandItemProvider.dispose();
        if( dcConverterUnitItemProvider != null ) dcConverterUnitItemProvider.dispose();
        if( regularTimePointItemProvider != null ) regularTimePointItemProvider.dispose();
        if( valueAliasSetItemProvider != null ) valueAliasSetItemProvider.dispose();
        if( accumulatorValueItemProvider != null ) accumulatorValueItemProvider.dispose();
        if( measurementValueItemProvider != null ) measurementValueItemProvider.dispose();
        if( hydroPumpItemProvider != null ) hydroPumpItemProvider.dispose();
        if( dcSwitchItemProvider != null ) dcSwitchItemProvider.dispose();
        if( svPowerFlowItemProvider != null ) svPowerFlowItemProvider.dispose();
        if( switchScheduleItemProvider != null ) switchScheduleItemProvider.dispose();
        if( ratioTapChangerTablePointItemProvider != null ) ratioTapChangerTablePointItemProvider.dispose();
        if( reservoirItemProvider != null ) reservoirItemProvider.dispose();
        if( equivalentShuntItemProvider != null ) equivalentShuntItemProvider.dispose();
        if( seasonItemProvider != null ) seasonItemProvider.dispose();
        if( seriesCompensatorItemProvider != null ) seriesCompensatorItemProvider.dispose();
        if( heatRecoveryBoilerItemProvider != null ) heatRecoveryBoilerItemProvider.dispose();
        if( externalNetworkInjectionItemProvider != null ) externalNetworkInjectionItemProvider.dispose();
        if( transformerMeshImpedanceItemProvider != null ) transformerMeshImpedanceItemProvider.dispose();
        if( svVoltageItemProvider != null ) svVoltageItemProvider.dispose();
        if( iec61970CIMVersionItemProvider != null ) iec61970CIMVersionItemProvider.dispose();
        if( stringMeasurementValueItemProvider != null ) stringMeasurementValueItemProvider.dispose();
        if( analogValueItemProvider != null ) analogValueItemProvider.dispose();
        if( ratioTapChangerTableItemProvider != null ) ratioTapChangerTableItemProvider.dispose();
        if( irregularTimePointItemProvider != null ) irregularTimePointItemProvider.dispose();
        if( acLineSegmentPhaseItemProvider != null ) acLineSegmentPhaseItemProvider.dispose();
        if( conformLoadItemProvider != null ) conformLoadItemProvider.dispose();
        if( acLineSegmentItemProvider != null ) acLineSegmentItemProvider.dispose();
        if( startupModelItemProvider != null ) startupModelItemProvider.dispose();
        if( equivalentBranchItemProvider != null ) equivalentBranchItemProvider.dispose();
        if( lineItemProvider != null ) lineItemProvider.dispose();
        if( busNameMarkerItemProvider != null ) busNameMarkerItemProvider.dispose();
        if( dcTopologicalNodeItemProvider != null ) dcTopologicalNodeItemProvider.dispose();
        if( dcDisconnectorItemProvider != null ) dcDisconnectorItemProvider.dispose();
        if( dcShuntItemProvider != null ) dcShuntItemProvider.dispose();
        if( phaseImpedanceDataItemProvider != null ) phaseImpedanceDataItemProvider.dispose();
        if( incrementalHeatRateCurveItemProvider != null ) incrementalHeatRateCurveItemProvider.dispose();
        if( subLoadAreaItemProvider != null ) subLoadAreaItemProvider.dispose();
        if( dayTypeItemProvider != null ) dayTypeItemProvider.dispose();
        if( combustionTurbineItemProvider != null ) combustionTurbineItemProvider.dispose();
        if( breakerItemProvider != null ) breakerItemProvider.dispose();
        if( generatingUnitItemProvider != null ) generatingUnitItemProvider.dispose();
        if( emissionAccountItemProvider != null ) emissionAccountItemProvider.dispose();
        if( asynchronousMachineItemProvider != null ) asynchronousMachineItemProvider.dispose();
        if( stationSupplyItemProvider != null ) stationSupplyItemProvider.dispose();
        if( accumulatorItemProvider != null ) accumulatorItemProvider.dispose();
        if( caesPlantItemProvider != null ) caesPlantItemProvider.dispose();
        if( perLengthPhaseImpedanceItemProvider != null ) perLengthPhaseImpedanceItemProvider.dispose();
        if( shuntCompensatorItemProvider != null ) shuntCompensatorItemProvider.dispose();
        if( linearShuntCompensatorPhaseItemProvider != null ) linearShuntCompensatorPhaseItemProvider.dispose();
        if( analogLimitItemProvider != null ) analogLimitItemProvider.dispose();
        if( nonlinearShuntCompensatorPhaseItemProvider != null ) nonlinearShuntCompensatorPhaseItemProvider.dispose();
        if( basicIntervalScheduleItemProvider != null ) basicIntervalScheduleItemProvider.dispose();
        if( baseVoltageItemProvider != null ) baseVoltageItemProvider.dispose();
        if( tapScheduleItemProvider != null ) tapScheduleItemProvider.dispose();
        if( disconnectorItemProvider != null ) disconnectorItemProvider.dispose();
        if( synchrocheckRelayItemProvider != null ) synchrocheckRelayItemProvider.dispose();
        if( geographicalRegionItemProvider != null ) geographicalRegionItemProvider.dispose();
        if( phaseTapChangerTableItemProvider != null ) phaseTapChangerTableItemProvider.dispose();
        if( communicationLinkItemProvider != null ) communicationLinkItemProvider.dispose();
        if( frequencyConverterItemProvider != null ) frequencyConverterItemProvider.dispose();
        if( operationalLimitTypeItemProvider != null ) operationalLimitTypeItemProvider.dispose();
        if( measurementValueQualityItemProvider != null ) measurementValueQualityItemProvider.dispose();
        if( connectorItemProvider != null ) connectorItemProvider.dispose();
        if( supercriticalItemProvider != null ) supercriticalItemProvider.dispose();
        if( diagramStyleItemProvider != null ) diagramStyleItemProvider.dispose();
        if( emissionCurveItemProvider != null ) emissionCurveItemProvider.dispose();
        if( tailbayLossCurveItemProvider != null ) tailbayLossCurveItemProvider.dispose();
        if( apparentPowerLimitItemProvider != null ) apparentPowerLimitItemProvider.dispose();
        if( fossilSteamSupplyItemProvider != null ) fossilSteamSupplyItemProvider.dispose();
        if( energySourceItemProvider != null ) energySourceItemProvider.dispose();
        if( diagramItemProvider != null ) diagramItemProvider.dispose();
        if( stringMeasurementItemProvider != null ) stringMeasurementItemProvider.dispose();
        if( shutdownCurveItemProvider != null ) shutdownCurveItemProvider.dispose();
        if( hydroPumpOpScheduleItemProvider != null ) hydroPumpOpScheduleItemProvider.dispose();
        if( startRampCurveItemProvider != null ) startRampCurveItemProvider.dispose();
        if( vsConverterItemProvider != null ) vsConverterItemProvider.dispose();
        if( thermalGeneratingUnitItemProvider != null ) thermalGeneratingUnitItemProvider.dispose();
        if( dcBreakerItemProvider != null ) dcBreakerItemProvider.dispose();
        if( regularIntervalScheduleItemProvider != null ) regularIntervalScheduleItemProvider.dispose();
        if( energyConsumerPhaseItemProvider != null ) energyConsumerPhaseItemProvider.dispose();
        if( faultIndicatorItemProvider != null ) faultIndicatorItemProvider.dispose();
        if( hydroGeneratingEfficiencyCurveItemProvider != null ) hydroGeneratingEfficiencyCurveItemProvider.dispose();
        if( earthFaultCompensatorItemProvider != null ) earthFaultCompensatorItemProvider.dispose();
        if( dcEquipmentContainerItemProvider != null ) dcEquipmentContainerItemProvider.dispose();
        if( substationItemProvider != null ) substationItemProvider.dispose();
        if( operationalLimitSetItemProvider != null ) operationalLimitSetItemProvider.dispose();
        if( curveItemProvider != null ) curveItemProvider.dispose();
        if( hydroPowerPlantItemProvider != null ) hydroPowerPlantItemProvider.dispose();
        if( surgeArresterItemProvider != null ) surgeArresterItemProvider.dispose();
        if( mutualCouplingItemProvider != null ) mutualCouplingItemProvider.dispose();
        if( diagramObjectGluePointItemProvider != null ) diagramObjectGluePointItemProvider.dispose();
        if( controlAreaGeneratingUnitItemProvider != null ) controlAreaGeneratingUnitItemProvider.dispose();
        if( heatRateCurveItemProvider != null ) heatRateCurveItemProvider.dispose();
        if( jumperItemProvider != null ) jumperItemProvider.dispose();
        if( inflowForecastItemProvider != null ) inflowForecastItemProvider.dispose();
        if( cutItemProvider != null ) cutItemProvider.dispose();
        if( connectivityNodeItemProvider != null ) connectivityNodeItemProvider.dispose();
        if( topologicalNodeItemProvider != null ) topologicalNodeItemProvider.dispose();
        if( pwrSteamSupplyItemProvider != null ) pwrSteamSupplyItemProvider.dispose();
        if( fossilFuelItemProvider != null ) fossilFuelItemProvider.dispose();
        if( groundingImpedanceItemProvider != null ) groundingImpedanceItemProvider.dispose();
        if( loadAreaItemProvider != null ) loadAreaItemProvider.dispose();
        if( solarGeneratingUnitItemProvider != null ) solarGeneratingUnitItemProvider.dispose();
        if( energyAreaItemProvider != null ) energyAreaItemProvider.dispose();
        if( topologicalIslandItemProvider != null ) topologicalIslandItemProvider.dispose();
        if( discreteCommandItemProvider != null ) discreteCommandItemProvider.dispose();
        if( nonlinearShuntCompensatorPhasePointItemProvider != null )
            nonlinearShuntCompensatorPhasePointItemProvider.dispose();
        if( measurementValueSourceItemProvider != null ) measurementValueSourceItemProvider.dispose();
        if( steamSendoutScheduleItemProvider != null ) steamSendoutScheduleItemProvider.dispose();
        if( terminalItemProvider != null ) terminalItemProvider.dispose();
        if( identifiedObjectItemProvider != null ) identifiedObjectItemProvider.dispose();
        if( seasonDayTypeScheduleItemProvider != null ) seasonDayTypeScheduleItemProvider.dispose();
        if( dcChopperItemProvider != null ) dcChopperItemProvider.dispose();
        if( lineFaultItemProvider != null ) lineFaultItemProvider.dispose();
        if( csConverterItemProvider != null ) csConverterItemProvider.dispose();
        if( perLengthImpedanceItemProvider != null ) perLengthImpedanceItemProvider.dispose();
        if( basePowerItemProvider != null ) basePowerItemProvider.dispose();
        if( powerElectronicsUnitItemProvider != null ) powerElectronicsUnitItemProvider.dispose();
        if( diagramObjectItemProvider != null ) diagramObjectItemProvider.dispose();
        if( drumBoilerItemProvider != null ) drumBoilerItemProvider.dispose();
        if( faultItemProvider != null ) faultItemProvider.dispose();
        if( rotatingMachineItemProvider != null ) rotatingMachineItemProvider.dispose();
        if( powerTransformerEndItemProvider != null ) powerTransformerEndItemProvider.dispose();
        if( steamSupplyItemProvider != null ) steamSupplyItemProvider.dispose();
        if( postLineSensorItemProvider != null ) postLineSensorItemProvider.dispose();
        if( steamTurbineItemProvider != null ) steamTurbineItemProvider.dispose();
        if( recloserItemProvider != null ) recloserItemProvider.dispose();
        if( switchPhaseItemProvider != null ) switchPhaseItemProvider.dispose();
        if( switchItemProvider != null ) switchItemProvider.dispose();
        if( groundDisconnectorItemProvider != null ) groundDisconnectorItemProvider.dispose();
        if( nameTypeItemProvider != null ) nameTypeItemProvider.dispose();
        if( contingencyElementItemProvider != null ) contingencyElementItemProvider.dispose();
        if( heatInputCurveItemProvider != null ) heatInputCurveItemProvider.dispose();
        if( operationalLimitItemProvider != null ) operationalLimitItemProvider.dispose();
        if( startMainFuelCurveItemProvider != null ) startMainFuelCurveItemProvider.dispose();
        if( perLengthDCLineParameterItemProvider != null ) perLengthDCLineParameterItemProvider.dispose();
        if( powerTransformerItemProvider != null ) powerTransformerItemProvider.dispose();
        if( controlItemProvider != null ) controlItemProvider.dispose();
        if( linearShuntCompensatorItemProvider != null ) linearShuntCompensatorItemProvider.dispose();
        if( tapChangerTablePointItemProvider != null ) tapChangerTablePointItemProvider.dispose();
        if( voltageLimitItemProvider != null ) voltageLimitItemProvider.dispose();
    }

}
