/*
*************************************************************************
**  Copyright (c) 2020 CentraleSupélec & EDF.
**  All rights reserved. This program and the accompanying materials
**  are made available under the terms of the Eclipse Public License v2.0
**  which accompanies this distribution, and is available at
**  https://www.eclipse.org/legal/epl-v20.html
** 
**  This file is part of the RiseClipse tool
**  
**  Contributors:
**      Computer Science Department, CentraleSupélec
**      EDF R&D
**  Contacts:
**      dominique.marcadet@centralesupelec.fr
**      aurelie.dehouck-neveu@edf.fr
**  Web site:
**      http://wdi.supelec.fr/software/RiseClipse/
*************************************************************************
*/
package fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimFactory
 * @model kind="package"
 * @generated
 */
public interface CimPackage extends EPackage {
    /**
     * The package name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNAME = "cim";

    /**
     * The package namespace URI.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_URI = "http://iec.ch/TC57/2013/CIM-schema-cim16";

    /**
     * The package namespace name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_PREFIX = "cim";

    /**
     * The singleton instance of the package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    CimPackage eINSTANCE = fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl.init();

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimObjectWithIDImpl <em>Object With ID</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimObjectWithIDImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCimObjectWithID()
     * @generated
     */
    int CIM_OBJECT_WITH_ID = 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CIM_OBJECT_WITH_ID__ID = 0;

    /**
     * The number of structural features of the '<em>Object With ID</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CIM_OBJECT_WITH_ID_FEATURE_COUNT = 1;

    /**
     * The number of operations of the '<em>Object With ID</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CIM_OBJECT_WITH_ID_OPERATION_COUNT = 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DateTimeIntervalImpl <em>Date Time Interval</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DateTimeIntervalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDateTimeInterval()
     * @generated
     */
    int DATE_TIME_INTERVAL = 3;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IntegerQuantityImpl <em>Integer Quantity</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IntegerQuantityImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getIntegerQuantity()
     * @generated
     */
    int INTEGER_QUANTITY = 9;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TimeIntervalImpl <em>Time Interval</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TimeIntervalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTimeInterval()
     * @generated
     */
    int TIME_INTERVAL = 4;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FaultImpedanceImpl <em>Fault Impedance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FaultImpedanceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFaultImpedance()
     * @generated
     */
    int FAULT_IMPEDANCE = 1;

    /**
     * The feature id for the '<em><b>RGround</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_IMPEDANCE__RGROUND = 0;

    /**
     * The feature id for the '<em><b>RLine To Line</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_IMPEDANCE__RLINE_TO_LINE = 1;

    /**
     * The feature id for the '<em><b>XGround</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_IMPEDANCE__XGROUND = 2;

    /**
     * The feature id for the '<em><b>XLine To Line</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_IMPEDANCE__XLINE_TO_LINE = 3;

    /**
     * The number of structural features of the '<em>Fault Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_IMPEDANCE_FEATURE_COUNT = 4;

    /**
     * The number of operations of the '<em>Fault Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_IMPEDANCE_OPERATION_COUNT = 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DecimalQuantityImpl <em>Decimal Quantity</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DecimalQuantityImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDecimalQuantity()
     * @generated
     */
    int DECIMAL_QUANTITY = 5;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StringQuantityImpl <em>String Quantity</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StringQuantityImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStringQuantity()
     * @generated
     */
    int STRING_QUANTITY = 6;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DateIntervalImpl <em>Date Interval</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DateIntervalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDateInterval()
     * @generated
     */
    int DATE_INTERVAL = 8;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FloatQuantityImpl <em>Float Quantity</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FloatQuantityImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFloatQuantity()
     * @generated
     */
    int FLOAT_QUANTITY = 2;

    /**
     * The feature id for the '<em><b>Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FLOAT_QUANTITY__MULTIPLIER = 0;

    /**
     * The feature id for the '<em><b>Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FLOAT_QUANTITY__UNIT = 1;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FLOAT_QUANTITY__VALUE = 2;

    /**
     * The number of structural features of the '<em>Float Quantity</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FLOAT_QUANTITY_FEATURE_COUNT = 3;

    /**
     * The number of operations of the '<em>Float Quantity</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FLOAT_QUANTITY_OPERATION_COUNT = 0;

    /**
     * The feature id for the '<em><b>End</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATE_TIME_INTERVAL__END = 0;

    /**
     * The feature id for the '<em><b>Start</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATE_TIME_INTERVAL__START = 1;

    /**
     * The number of structural features of the '<em>Date Time Interval</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATE_TIME_INTERVAL_FEATURE_COUNT = 2;

    /**
     * The number of operations of the '<em>Date Time Interval</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATE_TIME_INTERVAL_OPERATION_COUNT = 0;

    /**
     * The feature id for the '<em><b>End</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIME_INTERVAL__END = 0;

    /**
     * The feature id for the '<em><b>Start</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIME_INTERVAL__START = 1;

    /**
     * The number of structural features of the '<em>Time Interval</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIME_INTERVAL_FEATURE_COUNT = 2;

    /**
     * The number of operations of the '<em>Time Interval</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIME_INTERVAL_OPERATION_COUNT = 0;

    /**
     * The feature id for the '<em><b>Currency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DECIMAL_QUANTITY__CURRENCY = 0;

    /**
     * The feature id for the '<em><b>Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DECIMAL_QUANTITY__MULTIPLIER = 1;

    /**
     * The feature id for the '<em><b>Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DECIMAL_QUANTITY__UNIT = 2;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DECIMAL_QUANTITY__VALUE = 3;

    /**
     * The number of structural features of the '<em>Decimal Quantity</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DECIMAL_QUANTITY_FEATURE_COUNT = 4;

    /**
     * The number of operations of the '<em>Decimal Quantity</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DECIMAL_QUANTITY_OPERATION_COUNT = 0;

    /**
     * The feature id for the '<em><b>Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_QUANTITY__MULTIPLIER = 0;

    /**
     * The feature id for the '<em><b>Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_QUANTITY__UNIT = 1;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_QUANTITY__VALUE = 2;

    /**
     * The number of structural features of the '<em>String Quantity</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_QUANTITY_FEATURE_COUNT = 3;

    /**
     * The number of operations of the '<em>String Quantity</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_QUANTITY_OPERATION_COUNT = 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MonthDayIntervalImpl <em>Month Day Interval</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MonthDayIntervalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getMonthDayInterval()
     * @generated
     */
    int MONTH_DAY_INTERVAL = 7;

    /**
     * The feature id for the '<em><b>End</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MONTH_DAY_INTERVAL__END = 0;

    /**
     * The feature id for the '<em><b>Start</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MONTH_DAY_INTERVAL__START = 1;

    /**
     * The number of structural features of the '<em>Month Day Interval</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MONTH_DAY_INTERVAL_FEATURE_COUNT = 2;

    /**
     * The number of operations of the '<em>Month Day Interval</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MONTH_DAY_INTERVAL_OPERATION_COUNT = 0;

    /**
     * The feature id for the '<em><b>End</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATE_INTERVAL__END = 0;

    /**
     * The feature id for the '<em><b>Start</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATE_INTERVAL__START = 1;

    /**
     * The number of structural features of the '<em>Date Interval</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATE_INTERVAL_FEATURE_COUNT = 2;

    /**
     * The number of operations of the '<em>Date Interval</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATE_INTERVAL_OPERATION_COUNT = 0;

    /**
     * The feature id for the '<em><b>Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INTEGER_QUANTITY__MULTIPLIER = 0;

    /**
     * The feature id for the '<em><b>Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INTEGER_QUANTITY__UNIT = 1;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INTEGER_QUANTITY__VALUE = 2;

    /**
     * The number of structural features of the '<em>Integer Quantity</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INTEGER_QUANTITY_FEATURE_COUNT = 3;

    /**
     * The number of operations of the '<em>Integer Quantity</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INTEGER_QUANTITY_OPERATION_COUNT = 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IdentifiedObjectImpl <em>Identified Object</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IdentifiedObjectImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getIdentifiedObject()
     * @generated
     */
    int IDENTIFIED_OBJECT = 271;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IDENTIFIED_OBJECT__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IDENTIFIED_OBJECT__ALIAS_NAME = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IDENTIFIED_OBJECT__DESCRIPTION = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IDENTIFIED_OBJECT__MRID = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IDENTIFIED_OBJECT__NAME = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IDENTIFIED_OBJECT__NAMES = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IDENTIFIED_OBJECT__DIAGRAM_OBJECTS = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Identified Object</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IDENTIFIED_OBJECT_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Identified Object</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IDENTIFIED_OBJECT_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerSystemResourceImpl <em>Power System Resource</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerSystemResourceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPowerSystemResource()
     * @generated
     */
    int POWER_SYSTEM_RESOURCE = 32;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StateVariableImpl <em>State Variable</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StateVariableImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStateVariable()
     * @generated
     */
    int STATE_VARIABLE = 94;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvVoltageImpl <em>Sv Voltage</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvVoltageImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSvVoltage()
     * @generated
     */
    int SV_VOLTAGE = 179;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquipmentImpl <em>Equipment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquipmentImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEquipment()
     * @generated
     */
    int EQUIPMENT = 71;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConductingEquipmentImpl <em>Conducting Equipment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConductingEquipmentImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getConductingEquipment()
     * @generated
     */
    int CONDUCTING_EQUIPMENT = 77;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EnergyConsumerImpl <em>Energy Consumer</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EnergyConsumerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEnergyConsumer()
     * @generated
     */
    int ENERGY_CONSUMER = 153;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonConformLoadImpl <em>Non Conform Load</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonConformLoadImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNonConformLoad()
     * @generated
     */
    int NON_CONFORM_LOAD = 70;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SubGeographicalRegionImpl <em>Sub Geographical Region</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SubGeographicalRegionImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSubGeographicalRegion()
     * @generated
     */
    int SUB_GEOGRAPHICAL_REGION = 56;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MeasurementValueImpl <em>Measurement Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MeasurementValueImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getMeasurementValue()
     * @generated
     */
    int MEASUREMENT_VALUE = 166;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiscreteValueImpl <em>Discrete Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiscreteValueImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDiscreteValue()
     * @generated
     */
    int DISCRETE_VALUE = 144;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LimitSetImpl <em>Limit Set</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LimitSetImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLimitSet()
     * @generated
     */
    int LIMIT_SET = 69;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorLimitSetImpl <em>Accumulator Limit Set</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorLimitSetImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAccumulatorLimitSet()
     * @generated
     */
    int ACCUMULATOR_LIMIT_SET = 114;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ReservoirImpl <em>Reservoir</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ReservoirImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getReservoir()
     * @generated
     */
    int RESERVOIR = 172;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseImpedanceDataImpl <em>Phase Impedance Data</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseImpedanceDataImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseImpedanceData()
     * @generated
     */
    int PHASE_IMPEDANCE_DATA = 195;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SteamSupplyImpl <em>Steam Supply</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SteamSupplyImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSteamSupply()
     * @generated
     */
    int STEAM_SUPPLY = 284;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PSRTypeImpl <em>PSR Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PSRTypeImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPSRType()
     * @generated
     */
    int PSR_TYPE = 26;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvStatusImpl <em>Sv Status</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvStatusImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSvStatus()
     * @generated
     */
    int SV_STATUS = 108;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ControlImpl <em>Control</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ControlImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getControl()
     * @generated
     */
    int CONTROL = 298;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CommandImpl <em>Command</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CommandImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCommand()
     * @generated
     */
    int COMMAND = 97;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiscreteCommandImpl <em>Discrete Command</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiscreteCommandImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDiscreteCommand()
     * @generated
     */
    int DISCRETE_COMMAND = 266;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BasicIntervalScheduleImpl <em>Basic Interval Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BasicIntervalScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBasicIntervalSchedule()
     * @generated
     */
    int BASIC_INTERVAL_SCHEDULE = 212;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegularIntervalScheduleImpl <em>Regular Interval Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegularIntervalScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRegularIntervalSchedule()
     * @generated
     */
    int REGULAR_INTERVAL_SCHEDULE = 239;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SteamSendoutScheduleImpl <em>Steam Sendout Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SteamSendoutScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSteamSendoutSchedule()
     * @generated
     */
    int STEAM_SENDOUT_SCHEDULE = 269;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EnergyConsumerPhaseImpl <em>Energy Consumer Phase</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EnergyConsumerPhaseImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEnergyConsumerPhase()
     * @generated
     */
    int ENERGY_CONSUMER_PHASE = 240;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCConductingEquipmentImpl <em>DC Conducting Equipment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCConductingEquipmentImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCConductingEquipment()
     * @generated
     */
    int DC_CONDUCTING_EQUIPMENT = 13;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCBusbarImpl <em>DC Busbar</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCBusbarImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCBusbar()
     * @generated
     */
    int DC_BUSBAR = 34;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegulatingCondEqImpl <em>Regulating Cond Eq</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegulatingCondEqImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRegulatingCondEq()
     * @generated
     */
    int REGULATING_COND_EQ = 93;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ShuntCompensatorImpl <em>Shunt Compensator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ShuntCompensatorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getShuntCompensator()
     * @generated
     */
    int SHUNT_COMPENSATOR = 208;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LinearShuntCompensatorImpl <em>Linear Shunt Compensator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LinearShuntCompensatorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLinearShuntCompensator()
     * @generated
     */
    int LINEAR_SHUNT_COMPENSATOR = 299;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthLineParameterImpl <em>Per Length Line Parameter</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthLineParameterImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPerLengthLineParameter()
     * @generated
     */
    int PER_LENGTH_LINE_PARAMETER = 160;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthDCLineParameterImpl <em>Per Length DC Line Parameter</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthDCLineParameterImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPerLengthDCLineParameter()
     * @generated
     */
    int PER_LENGTH_DC_LINE_PARAMETER = 296;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperationalLimitImpl <em>Operational Limit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperationalLimitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getOperationalLimit()
     * @generated
     */
    int OPERATIONAL_LIMIT = 294;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AuxiliaryEquipmentImpl <em>Auxiliary Equipment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AuxiliaryEquipmentImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAuxiliaryEquipment()
     * @generated
     */
    int AUXILIARY_EQUIPMENT = 68;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SurgeArresterImpl <em>Surge Arrester</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SurgeArresterImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSurgeArrester()
     * @generated
     */
    int SURGE_ARRESTER = 249;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConductorImpl <em>Conductor</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConductorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getConductor()
     * @generated
     */
    int CONDUCTOR = 61;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACLineSegmentImpl <em>AC Line Segment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACLineSegmentImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getACLineSegment()
     * @generated
     */
    int AC_LINE_SEGMENT = 187;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SwitchImpl <em>Switch</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SwitchImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSwitch()
     * @generated
     */
    int SWITCH = 289;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ProtectedSwitchImpl <em>Protected Switch</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ProtectedSwitchImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getProtectedSwitch()
     * @generated
     */
    int PROTECTED_SWITCH = 133;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RecloserImpl <em>Recloser</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RecloserImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRecloser()
     * @generated
     */
    int RECLOSER = 287;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VoltageControlZoneImpl <em>Voltage Control Zone</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VoltageControlZoneImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getVoltageControlZone()
     * @generated
     */
    int VOLTAGE_CONTROL_ZONE = 18;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GeneratingUnitImpl <em>Generating Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GeneratingUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGeneratingUnit()
     * @generated
     */
    int GENERATING_UNIT = 201;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.WindGeneratingUnitImpl <em>Wind Generating Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.WindGeneratingUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getWindGeneratingUnit()
     * @generated
     */
    int WIND_GENERATING_UNIT = 62;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConnectivityNodeContainerImpl <em>Connectivity Node Container</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConnectivityNodeContainerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getConnectivityNodeContainer()
     * @generated
     */
    int CONNECTIVITY_NODE_CONTAINER = 36;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquipmentContainerImpl <em>Equipment Container</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquipmentContainerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEquipmentContainer()
     * @generated
     */
    int EQUIPMENT_CONTAINER = 60;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VoltageLevelImpl <em>Voltage Level</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VoltageLevelImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getVoltageLevel()
     * @generated
     */
    int VOLTAGE_LEVEL = 54;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerEndImpl <em>Transformer End</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerEndImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTransformerEnd()
     * @generated
     */
    int TRANSFORMER_END = 142;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerTransformerEndImpl <em>Power Transformer End</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerTransformerEndImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPowerTransformerEnd()
     * @generated
     */
    int POWER_TRANSFORMER_END = 283;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IEC61970CIMVersionImpl <em>IEC61970CIM Version</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IEC61970CIMVersionImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getIEC61970CIMVersion()
     * @generated
     */
    int IEC61970CIM_VERSION = 180;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RotatingMachineImpl <em>Rotating Machine</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RotatingMachineImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRotatingMachine()
     * @generated
     */
    int ROTATING_MACHINE = 282;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SynchronousMachineImpl <em>Synchronous Machine</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SynchronousMachineImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSynchronousMachine()
     * @generated
     */
    int SYNCHRONOUS_MACHINE = 89;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EnergySourceImpl <em>Energy Source</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EnergySourceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEnergySource()
     * @generated
     */
    int ENERGY_SOURCE = 230;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerCutZoneImpl <em>Power Cut Zone</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerCutZoneImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPowerCutZone()
     * @generated
     */
    int POWER_CUT_ZONE = 99;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACDCTerminalImpl <em>ACDC Terminal</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACDCTerminalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getACDCTerminal()
     * @generated
     */
    int ACDC_TERMINAL = 125;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCBaseTerminalImpl <em>DC Base Terminal</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCBaseTerminalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCBaseTerminal()
     * @generated
     */
    int DC_BASE_TERMINAL = 91;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACDCConverterDCTerminalImpl <em>ACDC Converter DC Terminal</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACDCConverterDCTerminalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getACDCConverterDCTerminal()
     * @generated
     */
    int ACDC_CONVERTER_DC_TERMINAL = 130;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACLineSegmentPhaseImpl <em>AC Line Segment Phase</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACLineSegmentPhaseImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getACLineSegmentPhase()
     * @generated
     */
    int AC_LINE_SEGMENT_PHASE = 185;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EnergyAreaImpl <em>Energy Area</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EnergyAreaImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEnergyArea()
     * @generated
     */
    int ENERGY_AREA = 264;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StartupModelImpl <em>Startup Model</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StartupModelImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStartupModel()
     * @generated
     */
    int STARTUP_MODEL = 188;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CombinedCyclePlantImpl <em>Combined Cycle Plant</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CombinedCyclePlantImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCombinedCyclePlant()
     * @generated
     */
    int COMBINED_CYCLE_PLANT = 66;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PlantImpl <em>Plant</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PlantImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPlant()
     * @generated
     */
    int PLANT = 157;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperationalLimitSetImpl <em>Operational Limit Set</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperationalLimitSetImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getOperationalLimitSet()
     * @generated
     */
    int OPERATIONAL_LIMIT_SET = 246;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ContingencyImpl <em>Contingency</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ContingencyImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getContingency()
     * @generated
     */
    int CONTINGENCY = 139;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCShuntImpl <em>DC Shunt</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCShuntImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCShunt()
     * @generated
     */
    int DC_SHUNT = 194;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SeasonDayTypeScheduleImpl <em>Season Day Type Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SeasonDayTypeScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSeasonDayTypeSchedule()
     * @generated
     */
    int SEASON_DAY_TYPE_SCHEDULE = 272;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LineImpl <em>Line</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LineImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLine()
     * @generated
     */
    int LINE = 190;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvShuntCompensatorSectionsImpl <em>Sv Shunt Compensator Sections</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvShuntCompensatorSectionsImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSvShuntCompensatorSections()
     * @generated
     */
    int SV_SHUNT_COMPENSATOR_SECTIONS = 132;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonlinearShuntCompensatorImpl <em>Nonlinear Shunt Compensator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonlinearShuntCompensatorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNonlinearShuntCompensator()
     * @generated
     */
    int NONLINEAR_SHUNT_COMPENSATOR = 148;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MeasurementImpl <em>Measurement</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MeasurementImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getMeasurement()
     * @generated
     */
    int MEASUREMENT = 31;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroPumpOpScheduleImpl <em>Hydro Pump Op Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroPumpOpScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHydroPumpOpSchedule()
     * @generated
     */
    int HYDRO_PUMP_OP_SCHEDULE = 234;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TapChangerTablePointImpl <em>Tap Changer Table Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TapChangerTablePointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTapChangerTablePoint()
     * @generated
     */
    int TAP_CHANGER_TABLE_POINT = 300;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RatioTapChangerTablePointImpl <em>Ratio Tap Changer Table Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RatioTapChangerTablePointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRatioTapChangerTablePoint()
     * @generated
     */
    int RATIO_TAP_CHANGER_TABLE_POINT = 171;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TerminalImpl <em>Terminal</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TerminalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTerminal()
     * @generated
     */
    int TERMINAL = 270;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerStarImpedanceImpl <em>Transformer Star Impedance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerStarImpedanceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTransformerStarImpedance()
     * @generated
     */
    int TRANSFORMER_STAR_IMPEDANCE = 116;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RemotePointImpl <em>Remote Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RemotePointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRemotePoint()
     * @generated
     */
    int REMOTE_POINT = 46;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SwitchScheduleImpl <em>Switch Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SwitchScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSwitchSchedule()
     * @generated
     */
    int SWITCH_SCHEDULE = 170;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogImpl <em>Analog</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAnalog()
     * @generated
     */
    int ANALOG = 19;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EarthFaultCompensatorImpl <em>Earth Fault Compensator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EarthFaultCompensatorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEarthFaultCompensator()
     * @generated
     */
    int EARTH_FAULT_COMPENSATOR = 243;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BWRSteamSupplyImpl <em>BWR Steam Supply</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BWRSteamSupplyImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBWRSteamSupply()
     * @generated
     */
    int BWR_STEAM_SUPPLY = 33;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PWRSteamSupplyImpl <em>PWR Steam Supply</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PWRSteamSupplyImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPWRSteamSupply()
     * @generated
     */
    int PWR_STEAM_SUPPLY = 259;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramStyleImpl <em>Diagram Style</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramStyleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDiagramStyle()
     * @generated
     */
    int DIAGRAM_STYLE = 225;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RemoteSourceImpl <em>Remote Source</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RemoteSourceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRemoteSource()
     * @generated
     */
    int REMOTE_SOURCE = 27;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BasePowerImpl <em>Base Power</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BasePowerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBasePower()
     * @generated
     */
    int BASE_POWER = 277;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NameTypeAuthorityImpl <em>Name Type Authority</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NameTypeAuthorityImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNameTypeAuthority()
     * @generated
     */
    int NAME_TYPE_AUTHORITY = 156;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LimitImpl <em>Limit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LimitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLimit()
     * @generated
     */
    int LIMIT = 147;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogLimitImpl <em>Analog Limit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogLimitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAnalogLimit()
     * @generated
     */
    int ANALOG_LIMIT = 210;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCGroundImpl <em>DC Ground</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCGroundImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCGround()
     * @generated
     */
    int DC_GROUND = 55;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SubstationImpl <em>Substation</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SubstationImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSubstation()
     * @generated
     */
    int SUBSTATION = 245;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TieFlowImpl <em>Tie Flow</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TieFlowImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTieFlow()
     * @generated
     */
    int TIE_FLOW = 17;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TapChangerImpl <em>Tap Changer</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TapChangerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTapChanger()
     * @generated
     */
    int TAP_CHANGER = 103;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerImpl <em>Phase Tap Changer</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseTapChanger()
     * @generated
     */
    int PHASE_TAP_CHANGER = 82;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerLinearImpl <em>Phase Tap Changer Linear</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerLinearImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseTapChangerLinear()
     * @generated
     */
    int PHASE_TAP_CHANGER_LINEAR = 159;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NuclearGeneratingUnitImpl <em>Nuclear Generating Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NuclearGeneratingUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNuclearGeneratingUnit()
     * @generated
     */
    int NUCLEAR_GENERATING_UNIT = 106;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PrimeMoverImpl <em>Prime Mover</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PrimeMoverImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPrimeMover()
     * @generated
     */
    int PRIME_MOVER = 39;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroTurbineImpl <em>Hydro Turbine</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroTurbineImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHydroTurbine()
     * @generated
     */
    int HYDRO_TURBINE = 23;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BranchGroupTerminalImpl <em>Branch Group Terminal</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BranchGroupTerminalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBranchGroupTerminal()
     * @generated
     */
    int BRANCH_GROUP_TERMINAL = 143;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurrentLimitImpl <em>Current Limit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurrentLimitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCurrentLimit()
     * @generated
     */
    int CURRENT_LIMIT = 81;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegulatingControlImpl <em>Regulating Control</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegulatingControlImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRegulatingControl()
     * @generated
     */
    int REGULATING_CONTROL = 86;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SubLoadAreaImpl <em>Sub Load Area</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SubLoadAreaImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSubLoadArea()
     * @generated
     */
    int SUB_LOAD_AREA = 197;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BaseFrequencyImpl <em>Base Frequency</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BaseFrequencyImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBaseFrequency()
     * @generated
     */
    int BASE_FREQUENCY = 51;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramObjectImpl <em>Diagram Object</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramObjectImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDiagramObject()
     * @generated
     */
    int DIAGRAM_OBJECT = 279;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TextDiagramObjectImpl <em>Text Diagram Object</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TextDiagramObjectImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTextDiagramObject()
     * @generated
     */
    int TEXT_DIAGRAM_OBJECT = 131;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurveImpl <em>Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCurve()
     * @generated
     */
    int CURVE = 247;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StartMainFuelCurveImpl <em>Start Main Fuel Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StartMainFuelCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStartMainFuelCurve()
     * @generated
     */
    int START_MAIN_FUEL_CURVE = 295;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ControlAreaGeneratingUnitImpl <em>Control Area Generating Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ControlAreaGeneratingUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getControlAreaGeneratingUnit()
     * @generated
     */
    int CONTROL_AREA_GENERATING_UNIT = 252;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonlinearShuntCompensatorPointImpl <em>Nonlinear Shunt Compensator Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonlinearShuntCompensatorPointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNonlinearShuntCompensatorPoint()
     * @generated
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT = 137;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DisconnectorImpl <em>Disconnector</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DisconnectorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDisconnector()
     * @generated
     */
    int DISCONNECTOR = 215;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GroundImpl <em>Ground</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GroundImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGround()
     * @generated
     */
    int GROUND = 120;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerElectronicsUnitImpl <em>Power Electronics Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerElectronicsUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPowerElectronicsUnit()
     * @generated
     */
    int POWER_ELECTRONICS_UNIT = 278;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerElectronicsWindUnitImpl <em>Power Electronics Wind Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerElectronicsWindUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPowerElectronicsWindUnit()
     * @generated
     */
    int POWER_ELECTRONICS_WIND_UNIT = 47;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RemoteControlImpl <em>Remote Control</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RemoteControlImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRemoteControl()
     * @generated
     */
    int REMOTE_CONTROL = 76;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerTableImpl <em>Phase Tap Changer Table</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerTableImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseTapChangerTable()
     * @generated
     */
    int PHASE_TAP_CHANGER_TABLE = 218;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TopologicalIslandImpl <em>Topological Island</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TopologicalIslandImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTopologicalIsland()
     * @generated
     */
    int TOPOLOGICAL_ISLAND = 265;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FuelAllocationScheduleImpl <em>Fuel Allocation Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FuelAllocationScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFuelAllocationSchedule()
     * @generated
     */
    int FUEL_ALLOCATION_SCHEDULE = 88;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvTapStepImpl <em>Sv Tap Step</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvTapStepImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSvTapStep()
     * @generated
     */
    int SV_TAP_STEP = 29;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorLimitImpl <em>Accumulator Limit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorLimitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAccumulatorLimit()
     * @generated
     */
    int ACCUMULATOR_LIMIT = 87;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ClampImpl <em>Clamp</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ClampImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getClamp()
     * @generated
     */
    int CLAMP = 126;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorResetImpl <em>Accumulator Reset</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorResetImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAccumulatorReset()
     * @generated
     */
    int ACCUMULATOR_RESET = 101;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AsynchronousMachineImpl <em>Asynchronous Machine</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AsynchronousMachineImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAsynchronousMachine()
     * @generated
     */
    int ASYNCHRONOUS_MACHINE = 203;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HeatRateCurveImpl <em>Heat Rate Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HeatRateCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHeatRateCurve()
     * @generated
     */
    int HEAT_RATE_CURVE = 253;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.InflowForecastImpl <em>Inflow Forecast</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.InflowForecastImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getInflowForecast()
     * @generated
     */
    int INFLOW_FORECAST = 255;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurveDataImpl <em>Curve Data</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurveDataImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCurveData()
     * @generated
     */
    int CURVE_DATA = 158;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCEquipmentContainerImpl <em>DC Equipment Container</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCEquipmentContainerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCEquipmentContainer()
     * @generated
     */
    int DC_EQUIPMENT_CONTAINER = 244;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCLineImpl <em>DC Line</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCLineImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCLine()
     * @generated
     */
    int DC_LINE = 41;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DayTypeImpl <em>Day Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DayTypeImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDayType()
     * @generated
     */
    int DAY_TYPE = 198;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthImpedanceImpl <em>Per Length Impedance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthImpedanceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPerLengthImpedance()
     * @generated
     */
    int PER_LENGTH_IMPEDANCE = 276;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthPhaseImpedanceImpl <em>Per Length Phase Impedance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthPhaseImpedanceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPerLengthPhaseImpedance()
     * @generated
     */
    int PER_LENGTH_PHASE_IMPEDANCE = 207;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramObjectPointImpl <em>Diagram Object Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramObjectPointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDiagramObjectPoint()
     * @generated
     */
    int DIAGRAM_OBJECT_POINT = 135;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorImpl <em>Accumulator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAccumulator()
     * @generated
     */
    int ACCUMULATOR = 205;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CommunicationLinkImpl <em>Communication Link</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CommunicationLinkImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCommunicationLink()
     * @generated
     */
    int COMMUNICATION_LINK = 219;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentEquipmentImpl <em>Equivalent Equipment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentEquipmentImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEquivalentEquipment()
     * @generated
     */
    int EQUIVALENT_EQUIPMENT = 74;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentShuntImpl <em>Equivalent Shunt</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentShuntImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEquivalentShunt()
     * @generated
     */
    int EQUIVALENT_SHUNT = 173;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RatioTapChangerTableImpl <em>Ratio Tap Changer Table</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RatioTapChangerTableImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRatioTapChangerTable()
     * @generated
     */
    int RATIO_TAP_CHANGER_TABLE = 183;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FossilSteamSupplyImpl <em>Fossil Steam Supply</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FossilSteamSupplyImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFossilSteamSupply()
     * @generated
     */
    int FOSSIL_STEAM_SUPPLY = 229;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TargetLevelScheduleImpl <em>Target Level Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TargetLevelScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTargetLevelSchedule()
     * @generated
     */
    int TARGET_LEVEL_SCHEDULE = 127;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VisibilityLayerImpl <em>Visibility Layer</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VisibilityLayerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getVisibilityLayer()
     * @generated
     */
    int VISIBILITY_LAYER = 64;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.Quality61850Impl <em>Quality61850</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.Quality61850Impl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getQuality61850()
     * @generated
     */
    int QUALITY61850 = 72;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MeasurementValueQualityImpl <em>Measurement Value Quality</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MeasurementValueQualityImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getMeasurementValueQuality()
     * @generated
     */
    int MEASUREMENT_VALUE_QUALITY = 222;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GenUnitOpCostCurveImpl <em>Gen Unit Op Cost Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GenUnitOpCostCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGenUnitOpCostCurve()
     * @generated
     */
    int GEN_UNIT_OP_COST_CURVE = 11;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LoadResponseCharacteristicImpl <em>Load Response Characteristic</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LoadResponseCharacteristicImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLoadResponseCharacteristic()
     * @generated
     */
    int LOAD_RESPONSE_CHARACTERISTIC = 10;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Exponent Model</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__EXPONENT_MODEL = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>PConstant Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__PCONSTANT_CURRENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>PConstant Impedance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__PCONSTANT_IMPEDANCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>PConstant Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__PCONSTANT_POWER = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>PFrequency Exponent</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__PFREQUENCY_EXPONENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>PVoltage Exponent</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__PVOLTAGE_EXPONENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>QConstant Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__QCONSTANT_CURRENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>QConstant Impedance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__QCONSTANT_IMPEDANCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>QConstant Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__QCONSTANT_POWER = IDENTIFIED_OBJECT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>QFrequency Exponent</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__QFREQUENCY_EXPONENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>QVoltage Exponent</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__QVOLTAGE_EXPONENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Energy Consumer</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC__ENERGY_CONSUMER = IDENTIFIED_OBJECT_FEATURE_COUNT + 11;

    /**
     * The number of structural features of the '<em>Load Response Characteristic</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 12;

    /**
     * The number of operations of the '<em>Load Response Characteristic</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_RESPONSE_CHARACTERISTIC_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__CURVE_STYLE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__XMULTIPLIER = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__XUNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__Y1_MULTIPLIER = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__Y1_UNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__Y2_MULTIPLIER = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__Y2_UNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__Y3_MULTIPLIER = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__Y3_UNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE__CURVE_DATAS = IDENTIFIED_OBJECT_FEATURE_COUNT + 9;

    /**
     * The number of structural features of the '<em>Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 10;

    /**
     * The number of operations of the '<em>Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Is Net Gross P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__IS_NET_GROSS_P = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE__GENERATING_UNIT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Gen Unit Op Cost Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Gen Unit Op Cost Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_COST_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__MEASUREMENTS = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__CONTROLS = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__OPERATING_SHARE = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE__PSR_TYPE = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Power System Resource</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Power System Resource</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_SYSTEM_RESOURCE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__AGGREGATE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__NORMALLY_IN_SERVICE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__CONTINGENCY_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__OPERATIONAL_LIMIT_SET = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__FAULTS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT__EQUIPMENT_CONTAINER = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__ID = EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__ALIAS_NAME = EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__DESCRIPTION = EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__MRID = EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__NAME = EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__NAMES = EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__DIAGRAM_OBJECTS = EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__MEASUREMENTS = EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__CONTROLS = EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__OPERATING_SHARE = EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__PSR_TYPE = EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__AGGREGATE = EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__NORMALLY_IN_SERVICE = EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__CONTINGENCY_EQUIPMENT = EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__OPERATIONAL_LIMIT_SET = EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__FAULTS = EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__EQUIPMENT_CONTAINER = EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT__TERMINAL = EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Auxiliary Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Auxiliary Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUXILIARY_EQUIPMENT_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StaticVarCompensatorImpl <em>Static Var Compensator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StaticVarCompensatorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStaticVarCompensator()
     * @generated
     */
    int STATIC_VAR_COMPENSATOR = 145;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ProtectionEquipmentImpl <em>Protection Equipment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ProtectionEquipmentImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getProtectionEquipment()
     * @generated
     */
    int PROTECTION_EQUIPMENT = 30;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SensorImpl <em>Sensor</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SensorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSensor()
     * @generated
     */
    int SENSOR = 110;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__ID = AUXILIARY_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__ALIAS_NAME = AUXILIARY_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__DESCRIPTION = AUXILIARY_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__MRID = AUXILIARY_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__NAME = AUXILIARY_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__NAMES = AUXILIARY_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__DIAGRAM_OBJECTS = AUXILIARY_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__MEASUREMENTS = AUXILIARY_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__CONTROLS = AUXILIARY_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__OPERATING_SHARE = AUXILIARY_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__PSR_TYPE = AUXILIARY_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__AGGREGATE = AUXILIARY_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__NORMALLY_IN_SERVICE = AUXILIARY_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__CONTINGENCY_EQUIPMENT = AUXILIARY_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__OPERATIONAL_LIMIT_SET = AUXILIARY_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__FAULTS = AUXILIARY_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__EQUIPMENT_CONTAINER = AUXILIARY_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR__TERMINAL = AUXILIARY_EQUIPMENT__TERMINAL;

    /**
     * The number of structural features of the '<em>Sensor</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR_FEATURE_COUNT = AUXILIARY_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Sensor</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SENSOR_OPERATION_COUNT = AUXILIARY_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PotentialTransformerImpl <em>Potential Transformer</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PotentialTransformerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPotentialTransformer()
     * @generated
     */
    int POTENTIAL_TRANSFORMER = 12;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__ID = SENSOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__ALIAS_NAME = SENSOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__DESCRIPTION = SENSOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__MRID = SENSOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__NAME = SENSOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__NAMES = SENSOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__DIAGRAM_OBJECTS = SENSOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__MEASUREMENTS = SENSOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__CONTROLS = SENSOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__OPERATING_SHARE = SENSOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__PSR_TYPE = SENSOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__AGGREGATE = SENSOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__NORMALLY_IN_SERVICE = SENSOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__CONTINGENCY_EQUIPMENT = SENSOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__OPERATIONAL_LIMIT_SET = SENSOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__FAULTS = SENSOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__EQUIPMENT_CONTAINER = SENSOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__TERMINAL = SENSOR__TERMINAL;

    /**
     * The feature id for the '<em><b>Accuracy Class</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__ACCURACY_CLASS = SENSOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Nominal Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__NOMINAL_RATIO = SENSOR_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Pt Class</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__PT_CLASS = SENSOR_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER__TYPE = SENSOR_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Potential Transformer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER_FEATURE_COUNT = SENSOR_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Potential Transformer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POTENTIAL_TRANSFORMER_OPERATION_COUNT = SENSOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__ID = EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__ALIAS_NAME = EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__DESCRIPTION = EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__MRID = EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__NAME = EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__NAMES = EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS = EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__MEASUREMENTS = EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__CONTROLS = EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__OPERATING_SHARE = EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__PSR_TYPE = EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__AGGREGATE = EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE = EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT = EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET = EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__FAULTS = EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER = EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT__DC_TERMINALS = EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>DC Conducting Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>DC Conducting Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONDUCTING_EQUIPMENT_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonConformLoadScheduleImpl <em>Non Conform Load Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonConformLoadScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNonConformLoadSchedule()
     * @generated
     */
    int NON_CONFORM_LOAD_SCHEDULE = 40;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ReactiveCapabilityCurveImpl <em>Reactive Capability Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ReactiveCapabilityCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getReactiveCapabilityCurve()
     * @generated
     */
    int REACTIVE_CAPABILITY_CURVE = 104;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ShuntCompensatorPhaseImpl <em>Shunt Compensator Phase</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ShuntCompensatorPhaseImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getShuntCompensatorPhase()
     * @generated
     */
    int SHUNT_COMPENSATOR_PHASE = 111;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonlinearShuntCompensatorPhaseImpl <em>Nonlinear Shunt Compensator Phase</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonlinearShuntCompensatorPhaseImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNonlinearShuntCompensatorPhase()
     * @generated
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE = 211;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramImpl <em>Diagram</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDiagram()
     * @generated
     */
    int DIAGRAM = 231;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerNonLinearImpl <em>Phase Tap Changer Non Linear</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerNonLinearImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseTapChangerNonLinear()
     * @generated
     */
    int PHASE_TAP_CHANGER_NON_LINEAR = 38;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerSymmetricalImpl <em>Phase Tap Changer Symmetrical</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerSymmetricalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseTapChangerSymmetrical()
     * @generated
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL = 141;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CompositeSwitchImpl <em>Composite Switch</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CompositeSwitchImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCompositeSwitch()
     * @generated
     */
    int COMPOSITE_SWITCH = 67;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BayImpl <em>Bay</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BayImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBay()
     * @generated
     */
    int BAY = 48;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ApparentPowerLimitImpl <em>Apparent Power Limit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ApparentPowerLimitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getApparentPowerLimit()
     * @generated
     */
    int APPARENT_POWER_LIMIT = 228;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FaultIndicatorImpl <em>Fault Indicator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FaultIndicatorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFaultIndicator()
     * @generated
     */
    int FAULT_INDICATOR = 241;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AltGeneratingUnitMeasImpl <em>Alt Generating Unit Meas</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AltGeneratingUnitMeasImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAltGeneratingUnitMeas()
     * @generated
     */
    int ALT_GENERATING_UNIT_MEAS = 146;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RemoteUnitImpl <em>Remote Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RemoteUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRemoteUnit()
     * @generated
     */
    int REMOTE_UNIT = 43;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LoadGroupImpl <em>Load Group</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LoadGroupImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLoadGroup()
     * @generated
     */
    int LOAD_GROUP = 122;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonConformLoadGroupImpl <em>Non Conform Load Group</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonConformLoadGroupImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNonConformLoadGroup()
     * @generated
     */
    int NON_CONFORM_LOAD_GROUP = 100;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VoltageLimitImpl <em>Voltage Limit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VoltageLimitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getVoltageLimit()
     * @generated
     */
    int VOLTAGE_LIMIT = 301;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConformLoadGroupImpl <em>Conform Load Group</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConformLoadGroupImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getConformLoadGroup()
     * @generated
     */
    int CONFORM_LOAD_GROUP = 112;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCLineSegmentImpl <em>DC Line Segment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCLineSegmentImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCLineSegment()
     * @generated
     */
    int DC_LINE_SEGMENT = 59;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StringMeasurementImpl <em>String Measurement</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StringMeasurementImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStringMeasurement()
     * @generated
     */
    int STRING_MEASUREMENT = 232;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StartIgnFuelCurveImpl <em>Start Ign Fuel Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StartIgnFuelCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStartIgnFuelCurve()
     * @generated
     */
    int START_IGN_FUEL_CURVE = 134;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroGeneratingEfficiencyCurveImpl <em>Hydro Generating Efficiency Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroGeneratingEfficiencyCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHydroGeneratingEfficiencyCurve()
     * @generated
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE = 242;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IncrementalHeatRateCurveImpl <em>Incremental Heat Rate Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IncrementalHeatRateCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getIncrementalHeatRateCurve()
     * @generated
     */
    int INCREMENTAL_HEAT_RATE_CURVE = 196;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PenstockLossCurveImpl <em>Penstock Loss Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PenstockLossCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPenstockLossCurve()
     * @generated
     */
    int PENSTOCK_LOSS_CURVE = 63;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCSwitchImpl <em>DC Switch</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCSwitchImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCSwitch()
     * @generated
     */
    int DC_SWITCH = 168;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IrregularIntervalScheduleImpl <em>Irregular Interval Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IrregularIntervalScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getIrregularIntervalSchedule()
     * @generated
     */
    int IRREGULAR_INTERVAL_SCHEDULE = 79;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CAESPlantImpl <em>CAES Plant</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CAESPlantImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCAESPlant()
     * @generated
     */
    int CAES_PLANT = 206;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PetersenCoilImpl <em>Petersen Coil</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PetersenCoilImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPetersenCoil()
     * @generated
     */
    int PETERSEN_COIL = 121;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCNodeImpl <em>DC Node</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCNodeImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCNode()
     * @generated
     */
    int DC_NODE = 115;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConformLoadScheduleImpl <em>Conform Load Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConformLoadScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getConformLoadSchedule()
     * @generated
     */
    int CONFORM_LOAD_SCHEDULE = 149;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FaultImpl <em>Fault</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FaultImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFault()
     * @generated
     */
    int FAULT = 281;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquipmentFaultImpl <em>Equipment Fault</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquipmentFaultImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEquipmentFault()
     * @generated
     */
    int EQUIPMENT_FAULT = 102;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SynchrocheckRelayImpl <em>Synchrocheck Relay</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SynchrocheckRelayImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSynchrocheckRelay()
     * @generated
     */
    int SYNCHROCHECK_RELAY = 216;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramObjectStyleImpl <em>Diagram Object Style</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramObjectStyleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDiagramObjectStyle()
     * @generated
     */
    int DIAGRAM_OBJECT_STYLE = 150;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerTablePointImpl <em>Phase Tap Changer Table Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerTablePointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseTapChangerTablePoint()
     * @generated
     */
    int PHASE_TAP_CHANGER_TABLE_POINT = 16;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GroundDisconnectorImpl <em>Ground Disconnector</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GroundDisconnectorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGroundDisconnector()
     * @generated
     */
    int GROUND_DISCONNECTOR = 290;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerTankEndImpl <em>Transformer Tank End</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerTankEndImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTransformerTankEnd()
     * @generated
     */
    int TRANSFORMER_TANK_END = 73;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LinearShuntCompensatorPhaseImpl <em>Linear Shunt Compensator Phase</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LinearShuntCompensatorPhaseImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLinearShuntCompensatorPhase()
     * @generated
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE = 209;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RecloseSequenceImpl <em>Reclose Sequence</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RecloseSequenceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRecloseSequence()
     * @generated
     */
    int RECLOSE_SEQUENCE = 14;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Reclose Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__RECLOSE_DELAY = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Reclose Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__RECLOSE_STEP = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Protected Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE__PROTECTED_SWITCH = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Reclose Sequence</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Reclose Sequence</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSE_SEQUENCE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__CONTROL_ENABLED = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>High Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__HIGH_STEP = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Initial Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__INITIAL_DELAY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Low Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__LOW_STEP = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Ltc Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__LTC_FLAG = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Neutral Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__NEUTRAL_STEP = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Neutral U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__NEUTRAL_U = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Normal Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__NORMAL_STEP = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__STEP = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Subsequent Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__SUBSEQUENT_DELAY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Sv Tap Step</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__SV_TAP_STEP = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Tap Changer Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__TAP_CHANGER_CONTROL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Tap Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER__TAP_SCHEDULES = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 12;

    /**
     * The number of structural features of the '<em>Tap Changer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 13;

    /**
     * The number of operations of the '<em>Tap Changer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SeriesCompensatorImpl <em>Series Compensator</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SeriesCompensatorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSeriesCompensator()
     * @generated
     */
    int SERIES_COMPENSATOR = 175;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NameTypeImpl <em>Name Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NameTypeImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNameType()
     * @generated
     */
    int NAME_TYPE = 291;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerMeshImpedanceImpl <em>Transformer Mesh Impedance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerMeshImpedanceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTransformerMeshImpedance()
     * @generated
     */
    int TRANSFORMER_MESH_IMPEDANCE = 178;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DrumBoilerImpl <em>Drum Boiler</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DrumBoilerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDrumBoiler()
     * @generated
     */
    int DRUM_BOILER = 280;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogControlImpl <em>Analog Control</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogControlImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAnalogControl()
     * @generated
     */
    int ANALOG_CONTROL = 80;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SetPointImpl <em>Set Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SetPointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSetPoint()
     * @generated
     */
    int SET_POINT = 85;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SteamTurbineImpl <em>Steam Turbine</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SteamTurbineImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSteamTurbine()
     * @generated
     */
    int STEAM_TURBINE = 286;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HeatRecoveryBoilerImpl <em>Heat Recovery Boiler</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HeatRecoveryBoilerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHeatRecoveryBoiler()
     * @generated
     */
    int HEAT_RECOVERY_BOILER = 176;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConnectivityNodeImpl <em>Connectivity Node</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConnectivityNodeImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getConnectivityNode()
     * @generated
     */
    int CONNECTIVITY_NODE = 257;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CutImpl <em>Cut</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CutImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCut()
     * @generated
     */
    int CUT = 256;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperationalLimitTypeImpl <em>Operational Limit Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperationalLimitTypeImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getOperationalLimitType()
     * @generated
     */
    int OPERATIONAL_LIMIT_TYPE = 221;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IrregularTimePointImpl <em>Irregular Time Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.IrregularTimePointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getIrregularTimePoint()
     * @generated
     */
    int IRREGULAR_TIME_POINT = 184;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FuseImpl <em>Fuse</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FuseImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFuse()
     * @generated
     */
    int FUSE = 98;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GroundingImpedanceImpl <em>Grounding Impedance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GroundingImpedanceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGroundingImpedance()
     * @generated
     */
    int GROUNDING_IMPEDANCE = 261;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LineFaultImpl <em>Line Fault</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LineFaultImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLineFault()
     * @generated
     */
    int LINE_FAULT = 274;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AirCompressorImpl <em>Air Compressor</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AirCompressorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAirCompressor()
     * @generated
     */
    int AIR_COMPRESSOR = 83;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BusNameMarkerImpl <em>Bus Name Marker</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BusNameMarkerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBusNameMarker()
     * @generated
     */
    int BUS_NAME_MARKER = 191;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ContingencyElementImpl <em>Contingency Element</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ContingencyElementImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getContingencyElement()
     * @generated
     */
    int CONTINGENCY_ELEMENT = 292;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogValueImpl <em>Analog Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogValueImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAnalogValue()
     * @generated
     */
    int ANALOG_VALUE = 182;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogLimitSetImpl <em>Analog Limit Set</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AnalogLimitSetImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAnalogLimitSet()
     * @generated
     */
    int ANALOG_LIMIT_SET = 138;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurrentRelayImpl <em>Current Relay</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurrentRelayImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCurrentRelay()
     * @generated
     */
    int CURRENT_RELAY = 154;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HeatInputCurveImpl <em>Heat Input Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HeatInputCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHeatInputCurve()
     * @generated
     */
    int HEAT_INPUT_CURVE = 293;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroPumpImpl <em>Hydro Pump</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroPumpImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHydroPump()
     * @generated
     */
    int HYDRO_PUMP = 167;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AltTieMeasImpl <em>Alt Tie Meas</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AltTieMeasImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAltTieMeas()
     * @generated
     */
    int ALT_TIE_MEAS = 25;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SwitchPhaseImpl <em>Switch Phase</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SwitchPhaseImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSwitchPhase()
     * @generated
     */
    int SWITCH_PHASE = 288;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SupercriticalImpl <em>Supercritical</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SupercriticalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSupercritical()
     * @generated
     */
    int SUPERCRITICAL = 224;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FaultCauseTypeImpl <em>Fault Cause Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FaultCauseTypeImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFaultCauseType()
     * @generated
     */
    int FAULT_CAUSE_TYPE = 58;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurrentTransformerImpl <em>Current Transformer</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CurrentTransformerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCurrentTransformer()
     * @generated
     */
    int CURRENT_TRANSFORMER = 42;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VsCapabilityCurveImpl <em>Vs Capability Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VsCapabilityCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getVsCapabilityCurve()
     * @generated
     */
    int VS_CAPABILITY_CURVE = 124;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegularTimePointImpl <em>Regular Time Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegularTimePointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRegularTimePoint()
     * @generated
     */
    int REGULAR_TIME_POINT = 163;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FrequencyConverterImpl <em>Frequency Converter</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FrequencyConverterImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFrequencyConverter()
     * @generated
     */
    int FREQUENCY_CONVERTER = 220;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConformLoadImpl <em>Conform Load</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConformLoadImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getConformLoad()
     * @generated
     */
    int CONFORM_LOAD = 186;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroPowerPlantImpl <em>Hydro Power Plant</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroPowerPlantImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHydroPowerPlant()
     * @generated
     */
    int HYDRO_POWER_PLANT = 248;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GrossToNetActivePowerCurveImpl <em>Gross To Net Active Power Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GrossToNetActivePowerCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGrossToNetActivePowerCurve()
     * @generated
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE = 123;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FossilFuelImpl <em>Fossil Fuel</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.FossilFuelImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFossilFuel()
     * @generated
     */
    int FOSSIL_FUEL = 260;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MeasurementValueSourceImpl <em>Measurement Value Source</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MeasurementValueSourceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getMeasurementValueSource()
     * @generated
     */
    int MEASUREMENT_VALUE_SOURCE = 268;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ShutdownCurveImpl <em>Shutdown Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ShutdownCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getShutdownCurve()
     * @generated
     */
    int SHUTDOWN_CURVE = 233;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerCoreAdmittanceImpl <em>Transformer Core Admittance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerCoreAdmittanceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTransformerCoreAdmittance()
     * @generated
     */
    int TRANSFORMER_CORE_ADMITTANCE = 52;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConnectorImpl <em>Connector</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ConnectorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getConnector()
     * @generated
     */
    int CONNECTOR = 223;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BusbarSectionImpl <em>Busbar Section</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BusbarSectionImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBusbarSection()
     * @generated
     */
    int BUSBAR_SECTION = 151;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCBreakerImpl <em>DC Breaker</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCBreakerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCBreaker()
     * @generated
     */
    int DC_BREAKER = 238;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StringMeasurementValueImpl <em>String Measurement Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StringMeasurementValueImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStringMeasurementValue()
     * @generated
     */
    int STRING_MEASUREMENT_VALUE = 181;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RaiseLowerCommandImpl <em>Raise Lower Command</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RaiseLowerCommandImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRaiseLowerCommand()
     * @generated
     */
    int RAISE_LOWER_COMMAND = 161;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TapScheduleImpl <em>Tap Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TapScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTapSchedule()
     * @generated
     */
    int TAP_SCHEDULE = 214;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ValueToAliasImpl <em>Value To Alias</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ValueToAliasImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getValueToAlias()
     * @generated
     */
    int VALUE_TO_ALIAS = 22;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramObjectGluePointImpl <em>Diagram Object Glue Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiagramObjectGluePointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDiagramObjectGluePoint()
     * @generated
     */
    int DIAGRAM_OBJECT_GLUE_POINT = 251;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BreakerImpl <em>Breaker</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BreakerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBreaker()
     * @generated
     */
    int BREAKER = 200;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCTerminalImpl <em>DC Terminal</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCTerminalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCTerminal()
     * @generated
     */
    int DC_TERMINAL = 140;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SectionaliserImpl <em>Sectionaliser</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SectionaliserImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSectionaliser()
     * @generated
     */
    int SECTIONALISER = 90;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvInjectionImpl <em>Sv Injection</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvInjectionImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSvInjection()
     * @generated
     */
    int SV_INJECTION = 84;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GenUnitOpScheduleImpl <em>Gen Unit Op Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GenUnitOpScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGenUnitOpSchedule()
     * @generated
     */
    int GEN_UNIT_OP_SCHEDULE = 129;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCConverterUnitImpl <em>DC Converter Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCConverterUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCConverterUnit()
     * @generated
     */
    int DC_CONVERTER_UNIT = 162;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACDCConverterImpl <em>ACDC Converter</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ACDCConverterImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getACDCConverter()
     * @generated
     */
    int ACDC_CONVERTER = 105;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CsConverterImpl <em>Cs Converter</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CsConverterImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCsConverter()
     * @generated
     */
    int CS_CONVERTER = 275;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ValueAliasSetImpl <em>Value Alias Set</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ValueAliasSetImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getValueAliasSet()
     * @generated
     */
    int VALUE_ALIAS_SET = 164;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCSeriesDeviceImpl <em>DC Series Device</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCSeriesDeviceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCSeriesDevice()
     * @generated
     */
    int DC_SERIES_DEVICE = 53;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.WaveTrapImpl <em>Wave Trap</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.WaveTrapImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getWaveTrap()
     * @generated
     */
    int WAVE_TRAP = 24;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NameImpl <em>Name</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NameImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getName_()
     * @generated
     */
    int NAME = 49;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ControlAreaImpl <em>Control Area</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ControlAreaImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getControlArea()
     * @generated
     */
    int CONTROL_AREA = 21;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentInjectionImpl <em>Equivalent Injection</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentInjectionImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEquivalentInjection()
     * @generated
     */
    int EQUIVALENT_INJECTION = 28;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCTopologicalNodeImpl <em>DC Topological Node</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCTopologicalNodeImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCTopologicalNode()
     * @generated
     */
    int DC_TOPOLOGICAL_NODE = 192;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCChopperImpl <em>DC Chopper</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCChopperImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCChopper()
     * @generated
     */
    int DC_CHOPPER = 273;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthSequenceImpedanceImpl <em>Per Length Sequence Impedance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PerLengthSequenceImpedanceImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPerLengthSequenceImpedance()
     * @generated
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE = 96;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StartRampCurveImpl <em>Start Ramp Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StartRampCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStartRampCurve()
     * @generated
     */
    int START_RAMP_CURVE = 235;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerTransformerImpl <em>Power Transformer</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerTransformerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPowerTransformer()
     * @generated
     */
    int POWER_TRANSFORMER = 297;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ActivePowerLimitImpl <em>Active Power Limit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ActivePowerLimitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getActivePowerLimit()
     * @generated
     */
    int ACTIVE_POWER_LIMIT = 118;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EmissionAccountImpl <em>Emission Account</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EmissionAccountImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEmissionAccount()
     * @generated
     */
    int EMISSION_ACCOUNT = 202;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerElectronicsConnectionImpl <em>Power Electronics Connection</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PowerElectronicsConnectionImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPowerElectronicsConnection()
     * @generated
     */
    int POWER_ELECTRONICS_CONNECTION = 95;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LevelVsVolumeCurveImpl <em>Level Vs Volume Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LevelVsVolumeCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLevelVsVolumeCurve()
     * @generated
     */
    int LEVEL_VS_VOLUME_CURVE = 155;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RatioTapChangerImpl <em>Ratio Tap Changer</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RatioTapChangerImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRatioTapChanger()
     * @generated
     */
    int RATIO_TAP_CHANGER = 15;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__ID = TAP_CHANGER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__ALIAS_NAME = TAP_CHANGER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__DESCRIPTION = TAP_CHANGER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__MRID = TAP_CHANGER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__NAME = TAP_CHANGER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__NAMES = TAP_CHANGER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__DIAGRAM_OBJECTS = TAP_CHANGER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__MEASUREMENTS = TAP_CHANGER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__CONTROLS = TAP_CHANGER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__OPERATING_SHARE = TAP_CHANGER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__PSR_TYPE = TAP_CHANGER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__CONTROL_ENABLED = TAP_CHANGER__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>High Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__HIGH_STEP = TAP_CHANGER__HIGH_STEP;

    /**
     * The feature id for the '<em><b>Initial Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__INITIAL_DELAY = TAP_CHANGER__INITIAL_DELAY;

    /**
     * The feature id for the '<em><b>Low Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__LOW_STEP = TAP_CHANGER__LOW_STEP;

    /**
     * The feature id for the '<em><b>Ltc Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__LTC_FLAG = TAP_CHANGER__LTC_FLAG;

    /**
     * The feature id for the '<em><b>Neutral Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__NEUTRAL_STEP = TAP_CHANGER__NEUTRAL_STEP;

    /**
     * The feature id for the '<em><b>Neutral U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__NEUTRAL_U = TAP_CHANGER__NEUTRAL_U;

    /**
     * The feature id for the '<em><b>Normal Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__NORMAL_STEP = TAP_CHANGER__NORMAL_STEP;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__STEP = TAP_CHANGER__STEP;

    /**
     * The feature id for the '<em><b>Subsequent Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__SUBSEQUENT_DELAY = TAP_CHANGER__SUBSEQUENT_DELAY;

    /**
     * The feature id for the '<em><b>Sv Tap Step</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__SV_TAP_STEP = TAP_CHANGER__SV_TAP_STEP;

    /**
     * The feature id for the '<em><b>Tap Changer Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__TAP_CHANGER_CONTROL = TAP_CHANGER__TAP_CHANGER_CONTROL;

    /**
     * The feature id for the '<em><b>Tap Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__TAP_SCHEDULES = TAP_CHANGER__TAP_SCHEDULES;

    /**
     * The feature id for the '<em><b>Step Voltage Increment</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__STEP_VOLTAGE_INCREMENT = TAP_CHANGER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Tcul Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__TCUL_CONTROL_MODE = TAP_CHANGER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Ratio Tap Changer Table</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__RATIO_TAP_CHANGER_TABLE = TAP_CHANGER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER__TRANSFORMER_END = TAP_CHANGER_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Ratio Tap Changer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_FEATURE_COUNT = TAP_CHANGER_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Ratio Tap Changer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_OPERATION_COUNT = TAP_CHANGER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_TABLE_POINT__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>B</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_TABLE_POINT__B = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>G</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_TABLE_POINT__G = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_TABLE_POINT__R = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_TABLE_POINT__RATIO = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_TABLE_POINT__STEP = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_TABLE_POINT__X = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Tap Changer Table Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_TABLE_POINT_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Tap Changer Table Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_TABLE_POINT_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT__ID = TAP_CHANGER_TABLE_POINT__ID;

    /**
     * The feature id for the '<em><b>B</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT__B = TAP_CHANGER_TABLE_POINT__B;

    /**
     * The feature id for the '<em><b>G</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT__G = TAP_CHANGER_TABLE_POINT__G;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT__R = TAP_CHANGER_TABLE_POINT__R;

    /**
     * The feature id for the '<em><b>Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT__RATIO = TAP_CHANGER_TABLE_POINT__RATIO;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT__STEP = TAP_CHANGER_TABLE_POINT__STEP;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT__X = TAP_CHANGER_TABLE_POINT__X;

    /**
     * The feature id for the '<em><b>Angle</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT__ANGLE = TAP_CHANGER_TABLE_POINT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Phase Tap Changer Table</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT__PHASE_TAP_CHANGER_TABLE = TAP_CHANGER_TABLE_POINT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Phase Tap Changer Table Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT_FEATURE_COUNT = TAP_CHANGER_TABLE_POINT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Phase Tap Changer Table Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_POINT_OPERATION_COUNT = TAP_CHANGER_TABLE_POINT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIE_FLOW__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Positive Flow In</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIE_FLOW__POSITIVE_FLOW_IN = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Control Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIE_FLOW__CONTROL_AREA = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIE_FLOW__TERMINAL = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Alt Tie Meas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIE_FLOW__ALT_TIE_MEAS = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Tie Flow</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIE_FLOW_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Tie Flow</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TIE_FLOW_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Regulation Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__REGULATION_SCHEDULE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Busbar Section</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE__BUSBAR_SECTION = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Voltage Control Zone</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Voltage Control Zone</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_CONTROL_ZONE_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurement Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__MEASUREMENT_TYPE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__PHASES = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__UNIT_MULTIPLIER = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__UNIT_SYMBOL = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__TERMINAL = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT__POWER_SYSTEM_RESOURCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Measurement</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Measurement</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__ID = MEASUREMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__ALIAS_NAME = MEASUREMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__DESCRIPTION = MEASUREMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__MRID = MEASUREMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__NAME = MEASUREMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__NAMES = MEASUREMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__DIAGRAM_OBJECTS = MEASUREMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurement Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__MEASUREMENT_TYPE = MEASUREMENT__MEASUREMENT_TYPE;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__PHASES = MEASUREMENT__PHASES;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__UNIT_MULTIPLIER = MEASUREMENT__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__UNIT_SYMBOL = MEASUREMENT__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__TERMINAL = MEASUREMENT__TERMINAL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__POWER_SYSTEM_RESOURCE = MEASUREMENT__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>Max Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__MAX_VALUE = MEASUREMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Min Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__MIN_VALUE = MEASUREMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Normal Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__NORMAL_VALUE = MEASUREMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Positive Flow In</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__POSITIVE_FLOW_IN = MEASUREMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Analog Values</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__ANALOG_VALUES = MEASUREMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Limit Sets</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG__LIMIT_SETS = MEASUREMENT_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Analog</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_FEATURE_COUNT = MEASUREMENT_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Analog</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_OPERATION_COUNT = MEASUREMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__ID = EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__ALIAS_NAME = EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__DESCRIPTION = EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__MRID = EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__NAME = EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__NAMES = EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS = EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__MEASUREMENTS = EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__CONTROLS = EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__OPERATING_SHARE = EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__PSR_TYPE = EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__AGGREGATE = EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE = EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT = EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET = EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__FAULTS = EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER = EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS = EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__BASE_VOLTAGE = EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__SV_STATUS = EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT__TERMINALS = EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Conducting Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Conducting Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTING_EQUIPMENT_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The number of structural features of the '<em>Connector</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Connector</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTOR_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroGeneratingUnitImpl <em>Hydro Generating Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.HydroGeneratingUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHydroGeneratingUnit()
     * @generated
     */
    int HYDRO_GENERATING_UNIT = 44;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperatingParticipantImpl <em>Operating Participant</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperatingParticipantImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getOperatingParticipant()
     * @generated
     */
    int OPERATING_PARTICIPANT = 113;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BaseVoltageImpl <em>Base Voltage</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BaseVoltageImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBaseVoltage()
     * @generated
     */
    int BASE_VOLTAGE = 213;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SeasonImpl <em>Season</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SeasonImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSeason()
     * @generated
     */
    int SEASON = 174;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LoadAreaImpl <em>Load Area</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LoadAreaImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLoadArea()
     * @generated
     */
    int LOAD_AREA = 262;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ContingencyEquipmentImpl <em>Contingency Equipment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ContingencyEquipmentImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getContingencyEquipment()
     * @generated
     */
    int CONTINGENCY_EQUIPMENT = 107;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CombustionTurbineImpl <em>Combustion Turbine</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CombustionTurbineImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCombustionTurbine()
     * @generated
     */
    int COMBUSTION_TURBINE = 199;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GeographicalRegionImpl <em>Geographical Region</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.GeographicalRegionImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGeographicalRegion()
     * @generated
     */
    int GEOGRAPHICAL_REGION = 217;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCDisconnectorImpl <em>DC Disconnector</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCDisconnectorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCDisconnector()
     * @generated
     */
    int DC_DISCONNECTOR = 193;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CogenerationPlantImpl <em>Cogeneration Plant</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CogenerationPlantImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCogenerationPlant()
     * @generated
     */
    int COGENERATION_PLANT = 57;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EmissionCurveImpl <em>Emission Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EmissionCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEmissionCurve()
     * @generated
     */
    int EMISSION_CURVE = 226;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentBranchImpl <em>Equivalent Branch</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentBranchImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEquivalentBranch()
     * @generated
     */
    int EQUIVALENT_BRANCH = 189;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PostLineSensorImpl <em>Post Line Sensor</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PostLineSensorImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPostLineSensor()
     * @generated
     */
    int POST_LINE_SENSOR = 285;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegulationScheduleImpl <em>Regulation Schedule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.RegulationScheduleImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRegulationSchedule()
     * @generated
     */
    int REGULATION_SCHEDULE = 119;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ThermalGeneratingUnitImpl <em>Thermal Generating Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ThermalGeneratingUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getThermalGeneratingUnit()
     * @generated
     */
    int THERMAL_GENERATING_UNIT = 237;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TapChangerControlImpl <em>Tap Changer Control</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TapChangerControlImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTapChangerControl()
     * @generated
     */
    int TAP_CHANGER_CONTROL = 75;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiscreteImpl <em>Discrete</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DiscreteImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDiscrete()
     * @generated
     */
    int DISCRETE = 35;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCTopologicalIslandImpl <em>DC Topological Island</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.DCTopologicalIslandImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCTopologicalIsland()
     * @generated
     */
    int DC_TOPOLOGICAL_ISLAND = 65;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvPowerFlowImpl <em>Sv Power Flow</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SvPowerFlowImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSvPowerFlow()
     * @generated
     */
    int SV_POWER_FLOW = 169;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BranchGroupImpl <em>Branch Group</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.BranchGroupImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBranchGroup()
     * @generated
     */
    int BRANCH_GROUP = 45;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TopologicalNodeImpl <em>Topological Node</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TopologicalNodeImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTopologicalNode()
     * @generated
     */
    int TOPOLOGICAL_NODE = 258;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SubcriticalImpl <em>Subcritical</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SubcriticalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSubcritical()
     * @generated
     */
    int SUBCRITICAL = 117;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorValueImpl <em>Accumulator Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.AccumulatorValueImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAccumulatorValue()
     * @generated
     */
    int ACCUMULATOR_VALUE = 165;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StationSupplyImpl <em>Station Supply</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.StationSupplyImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getStationSupply()
     * @generated
     */
    int STATION_SUPPLY = 204;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentNetworkImpl <em>Equivalent Network</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.EquivalentNetworkImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEquivalentNetwork()
     * @generated
     */
    int EQUIVALENT_NETWORK = 152;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SolarGeneratingUnitImpl <em>Solar Generating Unit</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.SolarGeneratingUnitImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSolarGeneratingUnit()
     * @generated
     */
    int SOLAR_GENERATING_UNIT = 263;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.JumperImpl <em>Jumper</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.JumperImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getJumper()
     * @generated
     */
    int JUMPER = 254;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerAsymmetricalImpl <em>Phase Tap Changer Asymmetrical</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerAsymmetricalImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseTapChangerAsymmetrical()
     * @generated
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL = 37;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ReportingSuperGroupImpl <em>Reporting Super Group</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ReportingSuperGroupImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getReportingSuperGroup()
     * @generated
     */
    int REPORTING_SUPER_GROUP = 92;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VsConverterImpl <em>Vs Converter</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.VsConverterImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getVsConverter()
     * @generated
     */
    int VS_CONVERTER = 236;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CTTempActivePowerCurveImpl <em>CT Temp Active Power Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CTTempActivePowerCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCTTempActivePowerCurve()
     * @generated
     */
    int CT_TEMP_ACTIVE_POWER_CURVE = 78;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperatingShareImpl <em>Operating Share</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.OperatingShareImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getOperatingShare()
     * @generated
     */
    int OPERATING_SHARE = 136;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerTabularImpl <em>Phase Tap Changer Tabular</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.PhaseTapChangerTabularImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseTapChangerTabular()
     * @generated
     */
    int PHASE_TAP_CHANGER_TABULAR = 109;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonlinearShuntCompensatorPhasePointImpl <em>Nonlinear Shunt Compensator Phase Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.NonlinearShuntCompensatorPhasePointImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getNonlinearShuntCompensatorPhasePoint()
     * @generated
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_POINT = 267;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.JunctionImpl <em>Junction</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.JunctionImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getJunction()
     * @generated
     */
    int JUNCTION = 20;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__ID = CONNECTOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__ALIAS_NAME = CONNECTOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__DESCRIPTION = CONNECTOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__MRID = CONNECTOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__NAME = CONNECTOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__NAMES = CONNECTOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__DIAGRAM_OBJECTS = CONNECTOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__MEASUREMENTS = CONNECTOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__CONTROLS = CONNECTOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__OPERATING_SHARE = CONNECTOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__PSR_TYPE = CONNECTOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__AGGREGATE = CONNECTOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__NORMALLY_IN_SERVICE = CONNECTOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__CONTINGENCY_EQUIPMENT = CONNECTOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__OPERATIONAL_LIMIT_SET = CONNECTOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__FAULTS = CONNECTOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__EQUIPMENT_CONTAINER = CONNECTOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__PROTECTION_EQUIPMENTS = CONNECTOR__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__BASE_VOLTAGE = CONNECTOR__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__SV_STATUS = CONNECTOR__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION__TERMINALS = CONNECTOR__TERMINALS;

    /**
     * The number of structural features of the '<em>Junction</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION_FEATURE_COUNT = CONNECTOR_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Junction</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUNCTION_OPERATION_COUNT = CONNECTOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Net Interchange</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__NET_INTERCHANGE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>PTolerance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__PTOLERANCE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__TYPE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Control Area Generating Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__CONTROL_AREA_GENERATING_UNIT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Tie Flow</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__TIE_FLOW = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Energy Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA__ENERGY_AREA = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Control Area</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Control Area</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS__VALUE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Value Alias Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS__VALUE_ALIAS_SET = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Value To Alias</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Value To Alias</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_TO_ALIAS_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Prime Mover Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__PRIME_MOVER_RATING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Synchronous Machines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER__SYNCHRONOUS_MACHINES = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Prime Mover</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Prime Mover</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIME_MOVER_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__ID = PRIME_MOVER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__ALIAS_NAME = PRIME_MOVER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__DESCRIPTION = PRIME_MOVER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__MRID = PRIME_MOVER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__NAME = PRIME_MOVER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__NAMES = PRIME_MOVER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__DIAGRAM_OBJECTS = PRIME_MOVER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__MEASUREMENTS = PRIME_MOVER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__CONTROLS = PRIME_MOVER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__OPERATING_SHARE = PRIME_MOVER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__PSR_TYPE = PRIME_MOVER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Prime Mover Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__PRIME_MOVER_RATING = PRIME_MOVER__PRIME_MOVER_RATING;

    /**
     * The feature id for the '<em><b>Synchronous Machines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__SYNCHRONOUS_MACHINES = PRIME_MOVER__SYNCHRONOUS_MACHINES;

    /**
     * The feature id for the '<em><b>Gate Rate Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__GATE_RATE_LIMIT = PRIME_MOVER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Gate Upper Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__GATE_UPPER_LIMIT = PRIME_MOVER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Max Head Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__MAX_HEAD_MAX_P = PRIME_MOVER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Min Head Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__MIN_HEAD_MAX_P = PRIME_MOVER_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Speed Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__SPEED_RATING = PRIME_MOVER_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Speed Regulation</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__SPEED_REGULATION = PRIME_MOVER_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Transient Droop Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__TRANSIENT_DROOP_TIME = PRIME_MOVER_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Transient Regulation</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__TRANSIENT_REGULATION = PRIME_MOVER_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Turbine Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__TURBINE_RATING = PRIME_MOVER_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Turbine Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__TURBINE_TYPE = PRIME_MOVER_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Water Starting Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE__WATER_STARTING_TIME = PRIME_MOVER_FEATURE_COUNT + 10;

    /**
     * The number of structural features of the '<em>Hydro Turbine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE_FEATURE_COUNT = PRIME_MOVER_FEATURE_COUNT + 11;

    /**
     * The number of operations of the '<em>Hydro Turbine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_TURBINE_OPERATION_COUNT = PRIME_MOVER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__ID = AUXILIARY_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__ALIAS_NAME = AUXILIARY_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__DESCRIPTION = AUXILIARY_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__MRID = AUXILIARY_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__NAME = AUXILIARY_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__NAMES = AUXILIARY_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__DIAGRAM_OBJECTS = AUXILIARY_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__MEASUREMENTS = AUXILIARY_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__CONTROLS = AUXILIARY_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__OPERATING_SHARE = AUXILIARY_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__PSR_TYPE = AUXILIARY_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__AGGREGATE = AUXILIARY_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__NORMALLY_IN_SERVICE = AUXILIARY_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__CONTINGENCY_EQUIPMENT = AUXILIARY_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__OPERATIONAL_LIMIT_SET = AUXILIARY_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__FAULTS = AUXILIARY_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__EQUIPMENT_CONTAINER = AUXILIARY_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP__TERMINAL = AUXILIARY_EQUIPMENT__TERMINAL;

    /**
     * The number of structural features of the '<em>Wave Trap</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP_FEATURE_COUNT = AUXILIARY_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Wave Trap</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WAVE_TRAP_OPERATION_COUNT = AUXILIARY_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_TIE_MEAS__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Priority</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_TIE_MEAS__PRIORITY = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Analog Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_TIE_MEAS__ANALOG_VALUE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Tie Flow</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_TIE_MEAS__TIE_FLOW = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Alt Tie Meas</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_TIE_MEAS_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Alt Tie Meas</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_TIE_MEAS_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Power System Resources</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE__POWER_SYSTEM_RESOURCES = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>PSR Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>PSR Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PSR_TYPE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Remote Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT__REMOTE_UNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Remote Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Remote Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_POINT_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__ID = REMOTE_POINT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__ALIAS_NAME = REMOTE_POINT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__DESCRIPTION = REMOTE_POINT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__MRID = REMOTE_POINT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__NAME = REMOTE_POINT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__NAMES = REMOTE_POINT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__DIAGRAM_OBJECTS = REMOTE_POINT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Remote Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__REMOTE_UNIT = REMOTE_POINT__REMOTE_UNIT;

    /**
     * The feature id for the '<em><b>Deadband</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__DEADBAND = REMOTE_POINT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Scan Interval</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__SCAN_INTERVAL = REMOTE_POINT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Sensor Maximum</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__SENSOR_MAXIMUM = REMOTE_POINT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Sensor Minimum</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__SENSOR_MINIMUM = REMOTE_POINT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Measurement Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE__MEASUREMENT_VALUE = REMOTE_POINT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Remote Source</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE_FEATURE_COUNT = REMOTE_POINT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Remote Source</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_SOURCE_OPERATION_COUNT = REMOTE_POINT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Equivalent Network</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT__EQUIVALENT_NETWORK = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Equivalent Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Equivalent Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_EQUIPMENT_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__ID = EQUIVALENT_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__ALIAS_NAME = EQUIVALENT_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__DESCRIPTION = EQUIVALENT_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__MRID = EQUIVALENT_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__NAME = EQUIVALENT_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__NAMES = EQUIVALENT_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__DIAGRAM_OBJECTS = EQUIVALENT_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__MEASUREMENTS = EQUIVALENT_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__CONTROLS = EQUIVALENT_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__OPERATING_SHARE = EQUIVALENT_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__PSR_TYPE = EQUIVALENT_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__AGGREGATE = EQUIVALENT_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__NORMALLY_IN_SERVICE = EQUIVALENT_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__CONTINGENCY_EQUIPMENT = EQUIVALENT_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__OPERATIONAL_LIMIT_SET = EQUIVALENT_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__FAULTS = EQUIVALENT_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__EQUIPMENT_CONTAINER = EQUIVALENT_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__PROTECTION_EQUIPMENTS = EQUIVALENT_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__BASE_VOLTAGE = EQUIVALENT_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__SV_STATUS = EQUIVALENT_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__TERMINALS = EQUIVALENT_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Equivalent Network</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__EQUIVALENT_NETWORK = EQUIVALENT_EQUIPMENT__EQUIVALENT_NETWORK;

    /**
     * The feature id for the '<em><b>Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__MAX_P = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Max Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__MAX_Q = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__MIN_P = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Min Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__MIN_Q = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__P = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__Q = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__R = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__R0 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>R2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__R2 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Regulation Capability</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__REGULATION_CAPABILITY = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Regulation Status</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__REGULATION_STATUS = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Regulation Target</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__REGULATION_TARGET = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__X = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__X0 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>X2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__X2 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Reactive Capability Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION__REACTIVE_CAPABILITY_CURVE = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 15;

    /**
     * The number of structural features of the '<em>Equivalent Injection</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION_FEATURE_COUNT = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 16;

    /**
     * The number of operations of the '<em>Equivalent Injection</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_INJECTION_OPERATION_COUNT = EQUIVALENT_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATE_VARIABLE__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The number of structural features of the '<em>State Variable</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATE_VARIABLE_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>State Variable</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATE_VARIABLE_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_TAP_STEP__ID = STATE_VARIABLE__ID;

    /**
     * The feature id for the '<em><b>Position</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_TAP_STEP__POSITION = STATE_VARIABLE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Tap Changer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_TAP_STEP__TAP_CHANGER = STATE_VARIABLE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Sv Tap Step</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_TAP_STEP_FEATURE_COUNT = STATE_VARIABLE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Sv Tap Step</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_TAP_STEP_OPERATION_COUNT = STATE_VARIABLE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__ID = EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__ALIAS_NAME = EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__DESCRIPTION = EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__MRID = EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__NAME = EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__NAMES = EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__DIAGRAM_OBJECTS = EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__MEASUREMENTS = EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__CONTROLS = EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__OPERATING_SHARE = EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__PSR_TYPE = EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__AGGREGATE = EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__NORMALLY_IN_SERVICE = EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__CONTINGENCY_EQUIPMENT = EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__OPERATIONAL_LIMIT_SET = EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__FAULTS = EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__EQUIPMENT_CONTAINER = EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>High Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__HIGH_LIMIT = EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Low Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__LOW_LIMIT = EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Power Direction Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__POWER_DIRECTION_FLAG = EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Relay Delay Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__RELAY_DELAY_TIME = EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__UNIT_MULTIPLIER = EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__UNIT_SYMBOL = EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Conducting Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__CONDUCTING_EQUIPMENTS = EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Protected Switches</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT__PROTECTED_SWITCHES = EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The number of structural features of the '<em>Protection Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 8;

    /**
     * The number of operations of the '<em>Protection Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTION_EQUIPMENT_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Steam Supply Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__STEAM_SUPPLY_RATING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Steam Turbines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY__STEAM_TURBINES = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Steam Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Steam Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SUPPLY_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__ID = STEAM_SUPPLY__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__ALIAS_NAME = STEAM_SUPPLY__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__DESCRIPTION = STEAM_SUPPLY__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__MRID = STEAM_SUPPLY__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__NAME = STEAM_SUPPLY__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__NAMES = STEAM_SUPPLY__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__DIAGRAM_OBJECTS = STEAM_SUPPLY__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__MEASUREMENTS = STEAM_SUPPLY__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__CONTROLS = STEAM_SUPPLY__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__OPERATING_SHARE = STEAM_SUPPLY__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__PSR_TYPE = STEAM_SUPPLY__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Steam Supply Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__STEAM_SUPPLY_RATING = STEAM_SUPPLY__STEAM_SUPPLY_RATING;

    /**
     * The feature id for the '<em><b>Steam Turbines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__STEAM_TURBINES = STEAM_SUPPLY__STEAM_TURBINES;

    /**
     * The feature id for the '<em><b>High Power Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__HIGH_POWER_LIMIT = STEAM_SUPPLY_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>In Core Thermal TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__IN_CORE_THERMAL_TC = STEAM_SUPPLY_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Integral Gain</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__INTEGRAL_GAIN = STEAM_SUPPLY_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Lower Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__LOWER_LIMIT = STEAM_SUPPLY_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Low Power Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__LOW_POWER_LIMIT = STEAM_SUPPLY_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Pressure Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__PRESSURE_LIMIT = STEAM_SUPPLY_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Pressure Setpoint GA</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__PRESSURE_SETPOINT_GA = STEAM_SUPPLY_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Pressure Setpoint TC1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__PRESSURE_SETPOINT_TC1 = STEAM_SUPPLY_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Pressure Setpoint TC2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__PRESSURE_SETPOINT_TC2 = STEAM_SUPPLY_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Proportional Gain</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__PROPORTIONAL_GAIN = STEAM_SUPPLY_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Rf Aux1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__RF_AUX1 = STEAM_SUPPLY_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Rf Aux2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__RF_AUX2 = STEAM_SUPPLY_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Rf Aux3</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__RF_AUX3 = STEAM_SUPPLY_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Rf Aux4</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__RF_AUX4 = STEAM_SUPPLY_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Rf Aux5</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__RF_AUX5 = STEAM_SUPPLY_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Rf Aux6</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__RF_AUX6 = STEAM_SUPPLY_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Rf Aux7</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__RF_AUX7 = STEAM_SUPPLY_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>Rf Aux8</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__RF_AUX8 = STEAM_SUPPLY_FEATURE_COUNT + 17;

    /**
     * The feature id for the '<em><b>Rod Pattern</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__ROD_PATTERN = STEAM_SUPPLY_FEATURE_COUNT + 18;

    /**
     * The feature id for the '<em><b>Rod Pattern Constant</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__ROD_PATTERN_CONSTANT = STEAM_SUPPLY_FEATURE_COUNT + 19;

    /**
     * The feature id for the '<em><b>Upper Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY__UPPER_LIMIT = STEAM_SUPPLY_FEATURE_COUNT + 20;

    /**
     * The number of structural features of the '<em>BWR Steam Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY_FEATURE_COUNT = STEAM_SUPPLY_FEATURE_COUNT + 21;

    /**
     * The number of operations of the '<em>BWR Steam Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BWR_STEAM_SUPPLY_OPERATION_COUNT = STEAM_SUPPLY_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__ID = DC_CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__ALIAS_NAME = DC_CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__DESCRIPTION = DC_CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__MRID = DC_CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__NAME = DC_CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__NAMES = DC_CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__DIAGRAM_OBJECTS = DC_CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__MEASUREMENTS = DC_CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__CONTROLS = DC_CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__OPERATING_SHARE = DC_CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__PSR_TYPE = DC_CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__AGGREGATE = DC_CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__NORMALLY_IN_SERVICE = DC_CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__CONTINGENCY_EQUIPMENT = DC_CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__OPERATIONAL_LIMIT_SET = DC_CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__FAULTS = DC_CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__EQUIPMENT_CONTAINER = DC_CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR__DC_TERMINALS = DC_CONDUCTING_EQUIPMENT__DC_TERMINALS;

    /**
     * The number of structural features of the '<em>DC Busbar</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR_FEATURE_COUNT = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>DC Busbar</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BUSBAR_OPERATION_COUNT = DC_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__ID = MEASUREMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__ALIAS_NAME = MEASUREMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__DESCRIPTION = MEASUREMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__MRID = MEASUREMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__NAME = MEASUREMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__NAMES = MEASUREMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__DIAGRAM_OBJECTS = MEASUREMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurement Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__MEASUREMENT_TYPE = MEASUREMENT__MEASUREMENT_TYPE;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__PHASES = MEASUREMENT__PHASES;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__UNIT_MULTIPLIER = MEASUREMENT__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__UNIT_SYMBOL = MEASUREMENT__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__TERMINAL = MEASUREMENT__TERMINAL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__POWER_SYSTEM_RESOURCE = MEASUREMENT__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>Max Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__MAX_VALUE = MEASUREMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Min Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__MIN_VALUE = MEASUREMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Normal Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__NORMAL_VALUE = MEASUREMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Discrete Values</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__DISCRETE_VALUES = MEASUREMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Value Alias Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE__VALUE_ALIAS_SET = MEASUREMENT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Discrete</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_FEATURE_COUNT = MEASUREMENT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Discrete</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_OPERATION_COUNT = MEASUREMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__CONNECTIVITY_NODES = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER__TOPOLOGICAL_NODE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Connectivity Node Container</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Connectivity Node Container</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_CONTAINER_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__ID = TAP_CHANGER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__ALIAS_NAME = TAP_CHANGER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__DESCRIPTION = TAP_CHANGER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__MRID = TAP_CHANGER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__NAME = TAP_CHANGER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__NAMES = TAP_CHANGER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__DIAGRAM_OBJECTS = TAP_CHANGER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__MEASUREMENTS = TAP_CHANGER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__CONTROLS = TAP_CHANGER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__OPERATING_SHARE = TAP_CHANGER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__PSR_TYPE = TAP_CHANGER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__CONTROL_ENABLED = TAP_CHANGER__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>High Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__HIGH_STEP = TAP_CHANGER__HIGH_STEP;

    /**
     * The feature id for the '<em><b>Initial Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__INITIAL_DELAY = TAP_CHANGER__INITIAL_DELAY;

    /**
     * The feature id for the '<em><b>Low Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__LOW_STEP = TAP_CHANGER__LOW_STEP;

    /**
     * The feature id for the '<em><b>Ltc Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__LTC_FLAG = TAP_CHANGER__LTC_FLAG;

    /**
     * The feature id for the '<em><b>Neutral Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__NEUTRAL_STEP = TAP_CHANGER__NEUTRAL_STEP;

    /**
     * The feature id for the '<em><b>Neutral U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__NEUTRAL_U = TAP_CHANGER__NEUTRAL_U;

    /**
     * The feature id for the '<em><b>Normal Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__NORMAL_STEP = TAP_CHANGER__NORMAL_STEP;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__STEP = TAP_CHANGER__STEP;

    /**
     * The feature id for the '<em><b>Subsequent Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__SUBSEQUENT_DELAY = TAP_CHANGER__SUBSEQUENT_DELAY;

    /**
     * The feature id for the '<em><b>Sv Tap Step</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__SV_TAP_STEP = TAP_CHANGER__SV_TAP_STEP;

    /**
     * The feature id for the '<em><b>Tap Changer Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__TAP_CHANGER_CONTROL = TAP_CHANGER__TAP_CHANGER_CONTROL;

    /**
     * The feature id for the '<em><b>Tap Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__TAP_SCHEDULES = TAP_CHANGER__TAP_SCHEDULES;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER__TRANSFORMER_END = TAP_CHANGER_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Phase Tap Changer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_FEATURE_COUNT = TAP_CHANGER_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Phase Tap Changer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_OPERATION_COUNT = TAP_CHANGER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__ID = PHASE_TAP_CHANGER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__ALIAS_NAME = PHASE_TAP_CHANGER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__DESCRIPTION = PHASE_TAP_CHANGER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__MRID = PHASE_TAP_CHANGER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__NAME = PHASE_TAP_CHANGER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__NAMES = PHASE_TAP_CHANGER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__DIAGRAM_OBJECTS = PHASE_TAP_CHANGER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__MEASUREMENTS = PHASE_TAP_CHANGER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__CONTROLS = PHASE_TAP_CHANGER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__OPERATING_SHARE = PHASE_TAP_CHANGER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__PSR_TYPE = PHASE_TAP_CHANGER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__CONTROL_ENABLED = PHASE_TAP_CHANGER__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>High Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__HIGH_STEP = PHASE_TAP_CHANGER__HIGH_STEP;

    /**
     * The feature id for the '<em><b>Initial Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__INITIAL_DELAY = PHASE_TAP_CHANGER__INITIAL_DELAY;

    /**
     * The feature id for the '<em><b>Low Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__LOW_STEP = PHASE_TAP_CHANGER__LOW_STEP;

    /**
     * The feature id for the '<em><b>Ltc Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__LTC_FLAG = PHASE_TAP_CHANGER__LTC_FLAG;

    /**
     * The feature id for the '<em><b>Neutral Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__NEUTRAL_STEP = PHASE_TAP_CHANGER__NEUTRAL_STEP;

    /**
     * The feature id for the '<em><b>Neutral U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__NEUTRAL_U = PHASE_TAP_CHANGER__NEUTRAL_U;

    /**
     * The feature id for the '<em><b>Normal Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__NORMAL_STEP = PHASE_TAP_CHANGER__NORMAL_STEP;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__STEP = PHASE_TAP_CHANGER__STEP;

    /**
     * The feature id for the '<em><b>Subsequent Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__SUBSEQUENT_DELAY = PHASE_TAP_CHANGER__SUBSEQUENT_DELAY;

    /**
     * The feature id for the '<em><b>Sv Tap Step</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__SV_TAP_STEP = PHASE_TAP_CHANGER__SV_TAP_STEP;

    /**
     * The feature id for the '<em><b>Tap Changer Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__TAP_CHANGER_CONTROL = PHASE_TAP_CHANGER__TAP_CHANGER_CONTROL;

    /**
     * The feature id for the '<em><b>Tap Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__TAP_SCHEDULES = PHASE_TAP_CHANGER__TAP_SCHEDULES;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__TRANSFORMER_END = PHASE_TAP_CHANGER__TRANSFORMER_END;

    /**
     * The feature id for the '<em><b>Voltage Step Increment</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__VOLTAGE_STEP_INCREMENT = PHASE_TAP_CHANGER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>XMax</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__XMAX = PHASE_TAP_CHANGER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>XMin</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR__XMIN = PHASE_TAP_CHANGER_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Phase Tap Changer Non Linear</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR_FEATURE_COUNT = PHASE_TAP_CHANGER_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Phase Tap Changer Non Linear</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_NON_LINEAR_OPERATION_COUNT = PHASE_TAP_CHANGER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__ID = PHASE_TAP_CHANGER_NON_LINEAR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__ALIAS_NAME = PHASE_TAP_CHANGER_NON_LINEAR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__DESCRIPTION = PHASE_TAP_CHANGER_NON_LINEAR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__MRID = PHASE_TAP_CHANGER_NON_LINEAR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__NAME = PHASE_TAP_CHANGER_NON_LINEAR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__NAMES = PHASE_TAP_CHANGER_NON_LINEAR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__DIAGRAM_OBJECTS = PHASE_TAP_CHANGER_NON_LINEAR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__MEASUREMENTS = PHASE_TAP_CHANGER_NON_LINEAR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__CONTROLS = PHASE_TAP_CHANGER_NON_LINEAR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__OPERATING_SHARE = PHASE_TAP_CHANGER_NON_LINEAR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__PSR_TYPE = PHASE_TAP_CHANGER_NON_LINEAR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__CONTROL_ENABLED = PHASE_TAP_CHANGER_NON_LINEAR__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>High Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__HIGH_STEP = PHASE_TAP_CHANGER_NON_LINEAR__HIGH_STEP;

    /**
     * The feature id for the '<em><b>Initial Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__INITIAL_DELAY = PHASE_TAP_CHANGER_NON_LINEAR__INITIAL_DELAY;

    /**
     * The feature id for the '<em><b>Low Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__LOW_STEP = PHASE_TAP_CHANGER_NON_LINEAR__LOW_STEP;

    /**
     * The feature id for the '<em><b>Ltc Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__LTC_FLAG = PHASE_TAP_CHANGER_NON_LINEAR__LTC_FLAG;

    /**
     * The feature id for the '<em><b>Neutral Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__NEUTRAL_STEP = PHASE_TAP_CHANGER_NON_LINEAR__NEUTRAL_STEP;

    /**
     * The feature id for the '<em><b>Neutral U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__NEUTRAL_U = PHASE_TAP_CHANGER_NON_LINEAR__NEUTRAL_U;

    /**
     * The feature id for the '<em><b>Normal Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__NORMAL_STEP = PHASE_TAP_CHANGER_NON_LINEAR__NORMAL_STEP;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__STEP = PHASE_TAP_CHANGER_NON_LINEAR__STEP;

    /**
     * The feature id for the '<em><b>Subsequent Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__SUBSEQUENT_DELAY = PHASE_TAP_CHANGER_NON_LINEAR__SUBSEQUENT_DELAY;

    /**
     * The feature id for the '<em><b>Sv Tap Step</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__SV_TAP_STEP = PHASE_TAP_CHANGER_NON_LINEAR__SV_TAP_STEP;

    /**
     * The feature id for the '<em><b>Tap Changer Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__TAP_CHANGER_CONTROL = PHASE_TAP_CHANGER_NON_LINEAR__TAP_CHANGER_CONTROL;

    /**
     * The feature id for the '<em><b>Tap Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__TAP_SCHEDULES = PHASE_TAP_CHANGER_NON_LINEAR__TAP_SCHEDULES;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__TRANSFORMER_END = PHASE_TAP_CHANGER_NON_LINEAR__TRANSFORMER_END;

    /**
     * The feature id for the '<em><b>Voltage Step Increment</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__VOLTAGE_STEP_INCREMENT = PHASE_TAP_CHANGER_NON_LINEAR__VOLTAGE_STEP_INCREMENT;

    /**
     * The feature id for the '<em><b>XMax</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__XMAX = PHASE_TAP_CHANGER_NON_LINEAR__XMAX;

    /**
     * The feature id for the '<em><b>XMin</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__XMIN = PHASE_TAP_CHANGER_NON_LINEAR__XMIN;

    /**
     * The feature id for the '<em><b>Winding Connection Angle</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL__WINDING_CONNECTION_ANGLE = PHASE_TAP_CHANGER_NON_LINEAR_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Phase Tap Changer Asymmetrical</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL_FEATURE_COUNT = PHASE_TAP_CHANGER_NON_LINEAR_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Phase Tap Changer Asymmetrical</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_ASYMMETRICAL_OPERATION_COUNT = PHASE_TAP_CHANGER_NON_LINEAR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__START_TIME = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__VALUE1_UNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE__VALUE2_UNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Basic Interval Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Basic Interval Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASIC_INTERVAL_SCHEDULE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__ID = BASIC_INTERVAL_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__ALIAS_NAME = BASIC_INTERVAL_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__DESCRIPTION = BASIC_INTERVAL_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__MRID = BASIC_INTERVAL_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__NAME = BASIC_INTERVAL_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__NAMES = BASIC_INTERVAL_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS = BASIC_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__START_TIME = BASIC_INTERVAL_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER = BASIC_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__VALUE1_UNIT = BASIC_INTERVAL_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER = BASIC_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__VALUE2_UNIT = BASIC_INTERVAL_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__END_TIME = BASIC_INTERVAL_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__TIME_STEP = BASIC_INTERVAL_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE__TIME_POINTS = BASIC_INTERVAL_SCHEDULE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Regular Interval Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT = BASIC_INTERVAL_SCHEDULE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Regular Interval Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_INTERVAL_SCHEDULE_OPERATION_COUNT = BASIC_INTERVAL_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__ID = REGULAR_INTERVAL_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__ALIAS_NAME = REGULAR_INTERVAL_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__DESCRIPTION = REGULAR_INTERVAL_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__MRID = REGULAR_INTERVAL_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__NAME = REGULAR_INTERVAL_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__NAMES = REGULAR_INTERVAL_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__DIAGRAM_OBJECTS = REGULAR_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__START_TIME = REGULAR_INTERVAL_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__VALUE1_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__VALUE1_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__VALUE2_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__VALUE2_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__END_TIME = REGULAR_INTERVAL_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__TIME_STEP = REGULAR_INTERVAL_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__TIME_POINTS = REGULAR_INTERVAL_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Day Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__DAY_TYPE = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Season</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE__SEASON = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Season Day Type Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Season Day Type Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_DAY_TYPE_SCHEDULE_OPERATION_COUNT = REGULAR_INTERVAL_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__ID = SEASON_DAY_TYPE_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__ALIAS_NAME = SEASON_DAY_TYPE_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__DESCRIPTION = SEASON_DAY_TYPE_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__MRID = SEASON_DAY_TYPE_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__NAME = SEASON_DAY_TYPE_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__NAMES = SEASON_DAY_TYPE_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__DIAGRAM_OBJECTS = SEASON_DAY_TYPE_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__START_TIME = SEASON_DAY_TYPE_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__VALUE1_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__VALUE1_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__VALUE2_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__VALUE2_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__END_TIME = SEASON_DAY_TYPE_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__TIME_STEP = SEASON_DAY_TYPE_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__TIME_POINTS = SEASON_DAY_TYPE_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Day Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__DAY_TYPE = SEASON_DAY_TYPE_SCHEDULE__DAY_TYPE;

    /**
     * The feature id for the '<em><b>Season</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__SEASON = SEASON_DAY_TYPE_SCHEDULE__SEASON;

    /**
     * The feature id for the '<em><b>Non Conform Load Group</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE__NON_CONFORM_LOAD_GROUP = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Non Conform Load Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE_FEATURE_COUNT = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Non Conform Load Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_SCHEDULE_OPERATION_COUNT = SEASON_DAY_TYPE_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__ID = CONNECTIVITY_NODE_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__ALIAS_NAME = CONNECTIVITY_NODE_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__DESCRIPTION = CONNECTIVITY_NODE_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__MRID = CONNECTIVITY_NODE_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__NAME = CONNECTIVITY_NODE_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__NAMES = CONNECTIVITY_NODE_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS = CONNECTIVITY_NODE_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__MEASUREMENTS = CONNECTIVITY_NODE_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__CONTROLS = CONNECTIVITY_NODE_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__OPERATING_SHARE = CONNECTIVITY_NODE_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__PSR_TYPE = CONNECTIVITY_NODE_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__CONNECTIVITY_NODES = CONNECTIVITY_NODE_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE = CONNECTIVITY_NODE_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER__EQUIPMENTS = CONNECTIVITY_NODE_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Equipment Container</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER_FEATURE_COUNT = CONNECTIVITY_NODE_CONTAINER_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Equipment Container</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_CONTAINER_OPERATION_COUNT = CONNECTIVITY_NODE_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__ID = EQUIPMENT_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__ALIAS_NAME = EQUIPMENT_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__DESCRIPTION = EQUIPMENT_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__MRID = EQUIPMENT_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__NAME = EQUIPMENT_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__NAMES = EQUIPMENT_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS = EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__MEASUREMENTS = EQUIPMENT_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__CONTROLS = EQUIPMENT_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__OPERATING_SHARE = EQUIPMENT_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__PSR_TYPE = EQUIPMENT_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__CONNECTIVITY_NODES = EQUIPMENT_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE = EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__EQUIPMENTS = EQUIPMENT_CONTAINER__EQUIPMENTS;

    /**
     * The feature id for the '<em><b>DC Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__DC_NODES = EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>DC Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER__DC_TOPOLOGICAL_NODE = EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>DC Equipment Container</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER_FEATURE_COUNT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>DC Equipment Container</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_EQUIPMENT_CONTAINER_OPERATION_COUNT = EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__ID = DC_EQUIPMENT_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__ALIAS_NAME = DC_EQUIPMENT_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__DESCRIPTION = DC_EQUIPMENT_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__MRID = DC_EQUIPMENT_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__NAME = DC_EQUIPMENT_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__NAMES = DC_EQUIPMENT_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__DIAGRAM_OBJECTS = DC_EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__MEASUREMENTS = DC_EQUIPMENT_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__CONTROLS = DC_EQUIPMENT_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__OPERATING_SHARE = DC_EQUIPMENT_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__PSR_TYPE = DC_EQUIPMENT_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__CONNECTIVITY_NODES = DC_EQUIPMENT_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__TOPOLOGICAL_NODE = DC_EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__EQUIPMENTS = DC_EQUIPMENT_CONTAINER__EQUIPMENTS;

    /**
     * The feature id for the '<em><b>DC Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__DC_NODES = DC_EQUIPMENT_CONTAINER__DC_NODES;

    /**
     * The feature id for the '<em><b>DC Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__DC_TOPOLOGICAL_NODE = DC_EQUIPMENT_CONTAINER__DC_TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Region</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE__REGION = DC_EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>DC Line</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_FEATURE_COUNT = DC_EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>DC Line</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_OPERATION_COUNT = DC_EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__ID = SENSOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__ALIAS_NAME = SENSOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__DESCRIPTION = SENSOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__MRID = SENSOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__NAME = SENSOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__NAMES = SENSOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__DIAGRAM_OBJECTS = SENSOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__MEASUREMENTS = SENSOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__CONTROLS = SENSOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__OPERATING_SHARE = SENSOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__PSR_TYPE = SENSOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__AGGREGATE = SENSOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__NORMALLY_IN_SERVICE = SENSOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__CONTINGENCY_EQUIPMENT = SENSOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__OPERATIONAL_LIMIT_SET = SENSOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__FAULTS = SENSOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__EQUIPMENT_CONTAINER = SENSOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__TERMINAL = SENSOR__TERMINAL;

    /**
     * The feature id for the '<em><b>Accuracy Class</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__ACCURACY_CLASS = SENSOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Accuracy Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__ACCURACY_LIMIT = SENSOR_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Core Burden</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__CORE_BURDEN = SENSOR_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Ct Class</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__CT_CLASS = SENSOR_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Usage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER__USAGE = SENSOR_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Current Transformer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER_FEATURE_COUNT = SENSOR_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Current Transformer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_TRANSFORMER_OPERATION_COUNT = SENSOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Remote Unit Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__REMOTE_UNIT_TYPE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Remote Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__REMOTE_POINTS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Communication Links</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT__COMMUNICATION_LINKS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Remote Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Remote Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_UNIT_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__ID = EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__ALIAS_NAME = EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__DESCRIPTION = EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__MRID = EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__NAME = EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__NAMES = EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__DIAGRAM_OBJECTS = EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__MEASUREMENTS = EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__CONTROLS = EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__OPERATING_SHARE = EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__PSR_TYPE = EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__AGGREGATE = EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__NORMALLY_IN_SERVICE = EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__CONTINGENCY_EQUIPMENT = EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__OPERATIONAL_LIMIT_SET = EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__FAULTS = EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__EQUIPMENT_CONTAINER = EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Alloc Spin Res P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__ALLOC_SPIN_RES_P = EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Auto Cntrl Margin P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__AUTO_CNTRL_MARGIN_P = EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Base P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__BASE_P = EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Control Deadband</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__CONTROL_DEADBAND = EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Control Pulse High</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__CONTROL_PULSE_HIGH = EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Control Pulse Low</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__CONTROL_PULSE_LOW = EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Control Response Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__CONTROL_RESPONSE_RATE = EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__EFFICIENCY = EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Gen Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__GEN_CONTROL_MODE = EQUIPMENT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Gen Control Source</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__GEN_CONTROL_SOURCE = EQUIPMENT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Governor MPL</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__GOVERNOR_MPL = EQUIPMENT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Governor SCD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__GOVERNOR_SCD = EQUIPMENT_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>High Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__HIGH_CONTROL_LIMIT = EQUIPMENT_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Initial P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__INITIAL_P = EQUIPMENT_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Long PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__LONG_PF = EQUIPMENT_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Low Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__LOW_CONTROL_LIMIT = EQUIPMENT_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Lower Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__LOWER_RAMP_RATE = EQUIPMENT_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>Max Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__MAX_ECONOMIC_P = EQUIPMENT_FEATURE_COUNT + 17;

    /**
     * The feature id for the '<em><b>Maximum Allowable Spinning Reserve</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE = EQUIPMENT_FEATURE_COUNT + 18;

    /**
     * The feature id for the '<em><b>Max Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__MAX_OPERATING_P = EQUIPMENT_FEATURE_COUNT + 19;

    /**
     * The feature id for the '<em><b>Min Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__MIN_ECONOMIC_P = EQUIPMENT_FEATURE_COUNT + 20;

    /**
     * The feature id for the '<em><b>Minimum Off Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__MINIMUM_OFF_TIME = EQUIPMENT_FEATURE_COUNT + 21;

    /**
     * The feature id for the '<em><b>Min Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__MIN_OPERATING_P = EQUIPMENT_FEATURE_COUNT + 22;

    /**
     * The feature id for the '<em><b>Model Detail</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__MODEL_DETAIL = EQUIPMENT_FEATURE_COUNT + 23;

    /**
     * The feature id for the '<em><b>Nominal P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__NOMINAL_P = EQUIPMENT_FEATURE_COUNT + 24;

    /**
     * The feature id for the '<em><b>Normal PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__NORMAL_PF = EQUIPMENT_FEATURE_COUNT + 25;

    /**
     * The feature id for the '<em><b>Penalty Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__PENALTY_FACTOR = EQUIPMENT_FEATURE_COUNT + 26;

    /**
     * The feature id for the '<em><b>Raise Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__RAISE_RAMP_RATE = EQUIPMENT_FEATURE_COUNT + 27;

    /**
     * The feature id for the '<em><b>Rated Gross Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__RATED_GROSS_MAX_P = EQUIPMENT_FEATURE_COUNT + 28;

    /**
     * The feature id for the '<em><b>Rated Gross Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__RATED_GROSS_MIN_P = EQUIPMENT_FEATURE_COUNT + 29;

    /**
     * The feature id for the '<em><b>Rated Net Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__RATED_NET_MAX_P = EQUIPMENT_FEATURE_COUNT + 30;

    /**
     * The feature id for the '<em><b>Short PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__SHORT_PF = EQUIPMENT_FEATURE_COUNT + 31;

    /**
     * The feature id for the '<em><b>Startup Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__STARTUP_COST = EQUIPMENT_FEATURE_COUNT + 32;

    /**
     * The feature id for the '<em><b>Startup Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__STARTUP_TIME = EQUIPMENT_FEATURE_COUNT + 33;

    /**
     * The feature id for the '<em><b>Tie Line PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__TIE_LINE_PF = EQUIPMENT_FEATURE_COUNT + 34;

    /**
     * The feature id for the '<em><b>Total Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__TOTAL_EFFICIENCY = EQUIPMENT_FEATURE_COUNT + 35;

    /**
     * The feature id for the '<em><b>Variable Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__VARIABLE_COST = EQUIPMENT_FEATURE_COUNT + 36;

    /**
     * The feature id for the '<em><b>Gross To Net Active Power Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES = EQUIPMENT_FEATURE_COUNT + 37;

    /**
     * The feature id for the '<em><b>Rotating Machine</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__ROTATING_MACHINE = EQUIPMENT_FEATURE_COUNT + 38;

    /**
     * The feature id for the '<em><b>Control Area Generating Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT = EQUIPMENT_FEATURE_COUNT + 39;

    /**
     * The feature id for the '<em><b>Gen Unit Op Cost Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES = EQUIPMENT_FEATURE_COUNT + 40;

    /**
     * The feature id for the '<em><b>Gen Unit Op Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE = EQUIPMENT_FEATURE_COUNT + 41;

    /**
     * The number of structural features of the '<em>Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 42;

    /**
     * The number of operations of the '<em>Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GENERATING_UNIT_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__ID = GENERATING_UNIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__ALIAS_NAME = GENERATING_UNIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__DESCRIPTION = GENERATING_UNIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__MRID = GENERATING_UNIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__NAME = GENERATING_UNIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__NAMES = GENERATING_UNIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__DIAGRAM_OBJECTS = GENERATING_UNIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__MEASUREMENTS = GENERATING_UNIT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__CONTROLS = GENERATING_UNIT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__OPERATING_SHARE = GENERATING_UNIT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__PSR_TYPE = GENERATING_UNIT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__AGGREGATE = GENERATING_UNIT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__NORMALLY_IN_SERVICE = GENERATING_UNIT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__CONTINGENCY_EQUIPMENT = GENERATING_UNIT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__OPERATIONAL_LIMIT_SET = GENERATING_UNIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__FAULTS = GENERATING_UNIT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__EQUIPMENT_CONTAINER = GENERATING_UNIT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Alloc Spin Res P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__ALLOC_SPIN_RES_P = GENERATING_UNIT__ALLOC_SPIN_RES_P;

    /**
     * The feature id for the '<em><b>Auto Cntrl Margin P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__AUTO_CNTRL_MARGIN_P = GENERATING_UNIT__AUTO_CNTRL_MARGIN_P;

    /**
     * The feature id for the '<em><b>Base P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__BASE_P = GENERATING_UNIT__BASE_P;

    /**
     * The feature id for the '<em><b>Control Deadband</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__CONTROL_DEADBAND = GENERATING_UNIT__CONTROL_DEADBAND;

    /**
     * The feature id for the '<em><b>Control Pulse High</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__CONTROL_PULSE_HIGH = GENERATING_UNIT__CONTROL_PULSE_HIGH;

    /**
     * The feature id for the '<em><b>Control Pulse Low</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__CONTROL_PULSE_LOW = GENERATING_UNIT__CONTROL_PULSE_LOW;

    /**
     * The feature id for the '<em><b>Control Response Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__CONTROL_RESPONSE_RATE = GENERATING_UNIT__CONTROL_RESPONSE_RATE;

    /**
     * The feature id for the '<em><b>Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__EFFICIENCY = GENERATING_UNIT__EFFICIENCY;

    /**
     * The feature id for the '<em><b>Gen Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__GEN_CONTROL_MODE = GENERATING_UNIT__GEN_CONTROL_MODE;

    /**
     * The feature id for the '<em><b>Gen Control Source</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__GEN_CONTROL_SOURCE = GENERATING_UNIT__GEN_CONTROL_SOURCE;

    /**
     * The feature id for the '<em><b>Governor MPL</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__GOVERNOR_MPL = GENERATING_UNIT__GOVERNOR_MPL;

    /**
     * The feature id for the '<em><b>Governor SCD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__GOVERNOR_SCD = GENERATING_UNIT__GOVERNOR_SCD;

    /**
     * The feature id for the '<em><b>High Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__HIGH_CONTROL_LIMIT = GENERATING_UNIT__HIGH_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Initial P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__INITIAL_P = GENERATING_UNIT__INITIAL_P;

    /**
     * The feature id for the '<em><b>Long PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__LONG_PF = GENERATING_UNIT__LONG_PF;

    /**
     * The feature id for the '<em><b>Low Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__LOW_CONTROL_LIMIT = GENERATING_UNIT__LOW_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Lower Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__LOWER_RAMP_RATE = GENERATING_UNIT__LOWER_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Max Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__MAX_ECONOMIC_P = GENERATING_UNIT__MAX_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Maximum Allowable Spinning Reserve</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE = GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE;

    /**
     * The feature id for the '<em><b>Max Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__MAX_OPERATING_P = GENERATING_UNIT__MAX_OPERATING_P;

    /**
     * The feature id for the '<em><b>Min Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__MIN_ECONOMIC_P = GENERATING_UNIT__MIN_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Minimum Off Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__MINIMUM_OFF_TIME = GENERATING_UNIT__MINIMUM_OFF_TIME;

    /**
     * The feature id for the '<em><b>Min Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__MIN_OPERATING_P = GENERATING_UNIT__MIN_OPERATING_P;

    /**
     * The feature id for the '<em><b>Model Detail</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__MODEL_DETAIL = GENERATING_UNIT__MODEL_DETAIL;

    /**
     * The feature id for the '<em><b>Nominal P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__NOMINAL_P = GENERATING_UNIT__NOMINAL_P;

    /**
     * The feature id for the '<em><b>Normal PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__NORMAL_PF = GENERATING_UNIT__NORMAL_PF;

    /**
     * The feature id for the '<em><b>Penalty Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__PENALTY_FACTOR = GENERATING_UNIT__PENALTY_FACTOR;

    /**
     * The feature id for the '<em><b>Raise Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__RAISE_RAMP_RATE = GENERATING_UNIT__RAISE_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Rated Gross Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__RATED_GROSS_MAX_P = GENERATING_UNIT__RATED_GROSS_MAX_P;

    /**
     * The feature id for the '<em><b>Rated Gross Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__RATED_GROSS_MIN_P = GENERATING_UNIT__RATED_GROSS_MIN_P;

    /**
     * The feature id for the '<em><b>Rated Net Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__RATED_NET_MAX_P = GENERATING_UNIT__RATED_NET_MAX_P;

    /**
     * The feature id for the '<em><b>Short PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__SHORT_PF = GENERATING_UNIT__SHORT_PF;

    /**
     * The feature id for the '<em><b>Startup Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__STARTUP_COST = GENERATING_UNIT__STARTUP_COST;

    /**
     * The feature id for the '<em><b>Startup Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__STARTUP_TIME = GENERATING_UNIT__STARTUP_TIME;

    /**
     * The feature id for the '<em><b>Tie Line PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__TIE_LINE_PF = GENERATING_UNIT__TIE_LINE_PF;

    /**
     * The feature id for the '<em><b>Total Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__TOTAL_EFFICIENCY = GENERATING_UNIT__TOTAL_EFFICIENCY;

    /**
     * The feature id for the '<em><b>Variable Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__VARIABLE_COST = GENERATING_UNIT__VARIABLE_COST;

    /**
     * The feature id for the '<em><b>Gross To Net Active Power Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES = GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES;

    /**
     * The feature id for the '<em><b>Rotating Machine</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__ROTATING_MACHINE = GENERATING_UNIT__ROTATING_MACHINE;

    /**
     * The feature id for the '<em><b>Control Area Generating Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT = GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT;

    /**
     * The feature id for the '<em><b>Gen Unit Op Cost Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES = GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES;

    /**
     * The feature id for the '<em><b>Gen Unit Op Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE = GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE;

    /**
     * The feature id for the '<em><b>Energy Conversion Capability</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__ENERGY_CONVERSION_CAPABILITY = GENERATING_UNIT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Hydro Unit Water Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__HYDRO_UNIT_WATER_COST = GENERATING_UNIT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Hydro Generating Efficiency Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__HYDRO_GENERATING_EFFICIENCY_CURVES = GENERATING_UNIT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Tailbay Loss Curve</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__TAILBAY_LOSS_CURVE = GENERATING_UNIT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Penstock Loss Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__PENSTOCK_LOSS_CURVE = GENERATING_UNIT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Hydro Power Plant</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT__HYDRO_POWER_PLANT = GENERATING_UNIT_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Hydro Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT_FEATURE_COUNT = GENERATING_UNIT_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Hydro Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_UNIT_OPERATION_COUNT = GENERATING_UNIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Maximum Active Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__MAXIMUM_ACTIVE_POWER = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Maximum Reactive Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__MAXIMUM_REACTIVE_POWER = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Minimum Active Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__MINIMUM_ACTIVE_POWER = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Minimum Reactive Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__MINIMUM_REACTIVE_POWER = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Monitor Active Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__MONITOR_ACTIVE_POWER = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Monitor Reactive Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__MONITOR_REACTIVE_POWER = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Branch Group Terminal</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP__BRANCH_GROUP_TERMINAL = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Branch Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Branch Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__ID = EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__ALIAS_NAME = EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__DESCRIPTION = EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__MRID = EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__NAME = EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__NAMES = EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__DIAGRAM_OBJECTS = EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__MEASUREMENTS = EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__CONTROLS = EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__OPERATING_SHARE = EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__PSR_TYPE = EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__AGGREGATE = EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__NORMALLY_IN_SERVICE = EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__CONTINGENCY_EQUIPMENT = EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__OPERATIONAL_LIMIT_SET = EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__FAULTS = EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__EQUIPMENT_CONTAINER = EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__MAX_P = EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__MIN_P = EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Power Electronics Connection</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT__POWER_ELECTRONICS_CONNECTION = EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Power Electronics Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Power Electronics Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_UNIT_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__ID = POWER_ELECTRONICS_UNIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__ALIAS_NAME = POWER_ELECTRONICS_UNIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__DESCRIPTION = POWER_ELECTRONICS_UNIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__MRID = POWER_ELECTRONICS_UNIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__NAME = POWER_ELECTRONICS_UNIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__NAMES = POWER_ELECTRONICS_UNIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__DIAGRAM_OBJECTS = POWER_ELECTRONICS_UNIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__MEASUREMENTS = POWER_ELECTRONICS_UNIT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__CONTROLS = POWER_ELECTRONICS_UNIT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__OPERATING_SHARE = POWER_ELECTRONICS_UNIT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__PSR_TYPE = POWER_ELECTRONICS_UNIT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__AGGREGATE = POWER_ELECTRONICS_UNIT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__NORMALLY_IN_SERVICE = POWER_ELECTRONICS_UNIT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__CONTINGENCY_EQUIPMENT = POWER_ELECTRONICS_UNIT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__OPERATIONAL_LIMIT_SET = POWER_ELECTRONICS_UNIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__FAULTS = POWER_ELECTRONICS_UNIT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__EQUIPMENT_CONTAINER = POWER_ELECTRONICS_UNIT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__MAX_P = POWER_ELECTRONICS_UNIT__MAX_P;

    /**
     * The feature id for the '<em><b>Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__MIN_P = POWER_ELECTRONICS_UNIT__MIN_P;

    /**
     * The feature id for the '<em><b>Power Electronics Connection</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT__POWER_ELECTRONICS_CONNECTION = POWER_ELECTRONICS_UNIT__POWER_ELECTRONICS_CONNECTION;

    /**
     * The number of structural features of the '<em>Power Electronics Wind Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT_FEATURE_COUNT = POWER_ELECTRONICS_UNIT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Power Electronics Wind Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_WIND_UNIT_OPERATION_COUNT = POWER_ELECTRONICS_UNIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__ID = EQUIPMENT_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__ALIAS_NAME = EQUIPMENT_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__DESCRIPTION = EQUIPMENT_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__MRID = EQUIPMENT_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__NAME = EQUIPMENT_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__NAMES = EQUIPMENT_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__DIAGRAM_OBJECTS = EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__MEASUREMENTS = EQUIPMENT_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__CONTROLS = EQUIPMENT_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__OPERATING_SHARE = EQUIPMENT_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__PSR_TYPE = EQUIPMENT_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__CONNECTIVITY_NODES = EQUIPMENT_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__TOPOLOGICAL_NODE = EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__EQUIPMENTS = EQUIPMENT_CONTAINER__EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Bay Energy Meas Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__BAY_ENERGY_MEAS_FLAG = EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Bay Power Meas Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__BAY_POWER_MEAS_FLAG = EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Breaker Configuration</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__BREAKER_CONFIGURATION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Bus Bar Configuration</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__BUS_BAR_CONFIGURATION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Voltage Level</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__VOLTAGE_LEVEL = EQUIPMENT_CONTAINER_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Substation</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY__SUBSTATION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Bay</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY_FEATURE_COUNT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Bay</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BAY_OPERATION_COUNT = EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME__NAME = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Identified Object</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME__IDENTIFIED_OBJECT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Name Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME__NAME_TYPE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Name</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Name</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__NORMAL_OPEN = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__OPEN = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__RATED_CURRENT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__RETAINED = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__SWITCH_ON_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__SWITCH_ON_DATE = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__COMPOSITE_SWITCH = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__SWITCH_SCHEDULES = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH__SWITCH_PHASE = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 8;

    /**
     * The number of structural features of the '<em>Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 9;

    /**
     * The number of operations of the '<em>Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__ID = SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__ALIAS_NAME = SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__DESCRIPTION = SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__MRID = SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__NAME = SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__NAMES = SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__DIAGRAM_OBJECTS = SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__MEASUREMENTS = SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__CONTROLS = SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__OPERATING_SHARE = SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__PSR_TYPE = SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__AGGREGATE = SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__NORMALLY_IN_SERVICE = SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__CONTINGENCY_EQUIPMENT = SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__OPERATIONAL_LIMIT_SET = SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__FAULTS = SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__EQUIPMENT_CONTAINER = SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__PROTECTION_EQUIPMENTS = SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__BASE_VOLTAGE = SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__SV_STATUS = SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__TERMINALS = SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__NORMAL_OPEN = SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__OPEN = SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__RATED_CURRENT = SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__RETAINED = SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__SWITCH_ON_COUNT = SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__SWITCH_ON_DATE = SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__COMPOSITE_SWITCH = SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__SWITCH_SCHEDULES = SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__SWITCH_PHASE = SWITCH__SWITCH_PHASE;

    /**
     * The feature id for the '<em><b>Breaking Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__BREAKING_CAPACITY = SWITCH_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Reclose Sequences</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__RECLOSE_SEQUENCES = SWITCH_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Operated By Protection Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH__OPERATED_BY_PROTECTION_EQUIPMENT = SWITCH_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Protected Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH_FEATURE_COUNT = SWITCH_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Protected Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PROTECTED_SWITCH_OPERATION_COUNT = SWITCH_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerTankImpl <em>Transformer Tank</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TransformerTankImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTransformerTank()
     * @generated
     */
    int TRANSFORMER_TANK = 128;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TailbayLossCurveImpl <em>Tailbay Loss Curve</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.TailbayLossCurveImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTailbayLossCurve()
     * @generated
     */
    int TAILBAY_LOSS_CURVE = 227;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MutualCouplingImpl <em>Mutual Coupling</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.MutualCouplingImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getMutualCoupling()
     * @generated
     */
    int MUTUAL_COUPLING = 250;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LoadBreakSwitchImpl <em>Load Break Switch</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.LoadBreakSwitchImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getLoadBreakSwitch()
     * @generated
     */
    int LOAD_BREAK_SWITCH = 50;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__ID = PROTECTED_SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__ALIAS_NAME = PROTECTED_SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__DESCRIPTION = PROTECTED_SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__MRID = PROTECTED_SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__NAME = PROTECTED_SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__NAMES = PROTECTED_SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__DIAGRAM_OBJECTS = PROTECTED_SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__MEASUREMENTS = PROTECTED_SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__CONTROLS = PROTECTED_SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__OPERATING_SHARE = PROTECTED_SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__PSR_TYPE = PROTECTED_SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__AGGREGATE = PROTECTED_SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__NORMALLY_IN_SERVICE = PROTECTED_SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__CONTINGENCY_EQUIPMENT = PROTECTED_SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__OPERATIONAL_LIMIT_SET = PROTECTED_SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__FAULTS = PROTECTED_SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__EQUIPMENT_CONTAINER = PROTECTED_SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__PROTECTION_EQUIPMENTS = PROTECTED_SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__BASE_VOLTAGE = PROTECTED_SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__SV_STATUS = PROTECTED_SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__TERMINALS = PROTECTED_SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__NORMAL_OPEN = PROTECTED_SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__OPEN = PROTECTED_SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__RATED_CURRENT = PROTECTED_SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__RETAINED = PROTECTED_SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__SWITCH_ON_COUNT = PROTECTED_SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__SWITCH_ON_DATE = PROTECTED_SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__COMPOSITE_SWITCH = PROTECTED_SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__SWITCH_SCHEDULES = PROTECTED_SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__SWITCH_PHASE = PROTECTED_SWITCH__SWITCH_PHASE;

    /**
     * The feature id for the '<em><b>Breaking Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__BREAKING_CAPACITY = PROTECTED_SWITCH__BREAKING_CAPACITY;

    /**
     * The feature id for the '<em><b>Reclose Sequences</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__RECLOSE_SEQUENCES = PROTECTED_SWITCH__RECLOSE_SEQUENCES;

    /**
     * The feature id for the '<em><b>Operated By Protection Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH__OPERATED_BY_PROTECTION_EQUIPMENT = PROTECTED_SWITCH__OPERATED_BY_PROTECTION_EQUIPMENT;

    /**
     * The number of structural features of the '<em>Load Break Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH_FEATURE_COUNT = PROTECTED_SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Load Break Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_BREAK_SWITCH_OPERATION_COUNT = PROTECTED_SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY__FREQUENCY = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Base Frequency</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Base Frequency</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_FREQUENCY_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>B</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__B = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>B0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__B0 = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>G</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__G = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>G0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__G0 = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE__TRANSFORMER_END = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Transformer Core Admittance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Transformer Core Admittance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_CORE_ADMITTANCE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__ID = DC_CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__ALIAS_NAME = DC_CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__DESCRIPTION = DC_CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__MRID = DC_CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__NAME = DC_CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__NAMES = DC_CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__DIAGRAM_OBJECTS = DC_CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__MEASUREMENTS = DC_CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__CONTROLS = DC_CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__OPERATING_SHARE = DC_CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__PSR_TYPE = DC_CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__AGGREGATE = DC_CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__NORMALLY_IN_SERVICE = DC_CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__CONTINGENCY_EQUIPMENT = DC_CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__OPERATIONAL_LIMIT_SET = DC_CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__FAULTS = DC_CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__EQUIPMENT_CONTAINER = DC_CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__DC_TERMINALS = DC_CONDUCTING_EQUIPMENT__DC_TERMINALS;

    /**
     * The feature id for the '<em><b>Inductance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__INDUCTANCE = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Rated Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__RATED_UDC = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Resistance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE__RESISTANCE = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>DC Series Device</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE_FEATURE_COUNT = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>DC Series Device</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SERIES_DEVICE_OPERATION_COUNT = DC_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__ID = EQUIPMENT_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__ALIAS_NAME = EQUIPMENT_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__DESCRIPTION = EQUIPMENT_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__MRID = EQUIPMENT_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__NAME = EQUIPMENT_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__NAMES = EQUIPMENT_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__DIAGRAM_OBJECTS = EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__MEASUREMENTS = EQUIPMENT_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__CONTROLS = EQUIPMENT_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__OPERATING_SHARE = EQUIPMENT_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__PSR_TYPE = EQUIPMENT_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__CONNECTIVITY_NODES = EQUIPMENT_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__TOPOLOGICAL_NODE = EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__EQUIPMENTS = EQUIPMENT_CONTAINER__EQUIPMENTS;

    /**
     * The feature id for the '<em><b>High Voltage Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__HIGH_VOLTAGE_LIMIT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Low Voltage Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__LOW_VOLTAGE_LIMIT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Bays</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__BAYS = EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__BASE_VOLTAGE = EQUIPMENT_CONTAINER_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Substation</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL__SUBSTATION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Voltage Level</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL_FEATURE_COUNT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Voltage Level</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LEVEL_OPERATION_COUNT = EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__ID = DC_CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__ALIAS_NAME = DC_CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__DESCRIPTION = DC_CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__MRID = DC_CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__NAME = DC_CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__NAMES = DC_CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__DIAGRAM_OBJECTS = DC_CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__MEASUREMENTS = DC_CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__CONTROLS = DC_CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__OPERATING_SHARE = DC_CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__PSR_TYPE = DC_CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__AGGREGATE = DC_CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__NORMALLY_IN_SERVICE = DC_CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__CONTINGENCY_EQUIPMENT = DC_CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__OPERATIONAL_LIMIT_SET = DC_CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__FAULTS = DC_CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__EQUIPMENT_CONTAINER = DC_CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__DC_TERMINALS = DC_CONDUCTING_EQUIPMENT__DC_TERMINALS;

    /**
     * The feature id for the '<em><b>Inductance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__INDUCTANCE = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND__R = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>DC Ground</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND_FEATURE_COUNT = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>DC Ground</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_GROUND_OPERATION_COUNT = DC_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Region</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__REGION = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>DC Lines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__DC_LINES = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Lines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__LINES = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Substations</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION__SUBSTATIONS = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Sub Geographical Region</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Sub Geographical Region</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_GEOGRAPHICAL_REGION_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Cogen HP Sendout Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__COGEN_HP_SENDOUT_RATING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Cogen HP Steam Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__COGEN_HP_STEAM_RATING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Cogen LP Sendout Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__COGEN_LP_SENDOUT_RATING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Cogen LP Steam Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__COGEN_LP_STEAM_RATING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Rated P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__RATED_P = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Thermal Generating Units</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__THERMAL_GENERATING_UNITS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Steam Sendout Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT__STEAM_SENDOUT_SCHEDULE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Cogeneration Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Cogeneration Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COGENERATION_PLANT_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE__FAULTS = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Fault Cause Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Fault Cause Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_CAUSE_TYPE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__ID = DC_CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__ALIAS_NAME = DC_CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__DESCRIPTION = DC_CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__MRID = DC_CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__NAME = DC_CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__NAMES = DC_CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__DIAGRAM_OBJECTS = DC_CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__MEASUREMENTS = DC_CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__CONTROLS = DC_CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__OPERATING_SHARE = DC_CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__PSR_TYPE = DC_CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__AGGREGATE = DC_CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__NORMALLY_IN_SERVICE = DC_CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__CONTINGENCY_EQUIPMENT = DC_CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__OPERATIONAL_LIMIT_SET = DC_CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__FAULTS = DC_CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__EQUIPMENT_CONTAINER = DC_CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__DC_TERMINALS = DC_CONDUCTING_EQUIPMENT__DC_TERMINALS;

    /**
     * The feature id for the '<em><b>Capacitance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__CAPACITANCE = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Inductance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__INDUCTANCE = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Length</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__LENGTH = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Resistance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__RESISTANCE = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Per Length Parameter</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT__PER_LENGTH_PARAMETER = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>DC Line Segment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT_FEATURE_COUNT = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>DC Line Segment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_LINE_SEGMENT_OPERATION_COUNT = DC_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Length</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR__LENGTH = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Conductor</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Conductor</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONDUCTOR_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__ID = GENERATING_UNIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__ALIAS_NAME = GENERATING_UNIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__DESCRIPTION = GENERATING_UNIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__MRID = GENERATING_UNIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__NAME = GENERATING_UNIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__NAMES = GENERATING_UNIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__DIAGRAM_OBJECTS = GENERATING_UNIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__MEASUREMENTS = GENERATING_UNIT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__CONTROLS = GENERATING_UNIT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__OPERATING_SHARE = GENERATING_UNIT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__PSR_TYPE = GENERATING_UNIT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__AGGREGATE = GENERATING_UNIT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__NORMALLY_IN_SERVICE = GENERATING_UNIT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__CONTINGENCY_EQUIPMENT = GENERATING_UNIT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__OPERATIONAL_LIMIT_SET = GENERATING_UNIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__FAULTS = GENERATING_UNIT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__EQUIPMENT_CONTAINER = GENERATING_UNIT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Alloc Spin Res P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__ALLOC_SPIN_RES_P = GENERATING_UNIT__ALLOC_SPIN_RES_P;

    /**
     * The feature id for the '<em><b>Auto Cntrl Margin P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__AUTO_CNTRL_MARGIN_P = GENERATING_UNIT__AUTO_CNTRL_MARGIN_P;

    /**
     * The feature id for the '<em><b>Base P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__BASE_P = GENERATING_UNIT__BASE_P;

    /**
     * The feature id for the '<em><b>Control Deadband</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__CONTROL_DEADBAND = GENERATING_UNIT__CONTROL_DEADBAND;

    /**
     * The feature id for the '<em><b>Control Pulse High</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__CONTROL_PULSE_HIGH = GENERATING_UNIT__CONTROL_PULSE_HIGH;

    /**
     * The feature id for the '<em><b>Control Pulse Low</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__CONTROL_PULSE_LOW = GENERATING_UNIT__CONTROL_PULSE_LOW;

    /**
     * The feature id for the '<em><b>Control Response Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__CONTROL_RESPONSE_RATE = GENERATING_UNIT__CONTROL_RESPONSE_RATE;

    /**
     * The feature id for the '<em><b>Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__EFFICIENCY = GENERATING_UNIT__EFFICIENCY;

    /**
     * The feature id for the '<em><b>Gen Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__GEN_CONTROL_MODE = GENERATING_UNIT__GEN_CONTROL_MODE;

    /**
     * The feature id for the '<em><b>Gen Control Source</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__GEN_CONTROL_SOURCE = GENERATING_UNIT__GEN_CONTROL_SOURCE;

    /**
     * The feature id for the '<em><b>Governor MPL</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__GOVERNOR_MPL = GENERATING_UNIT__GOVERNOR_MPL;

    /**
     * The feature id for the '<em><b>Governor SCD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__GOVERNOR_SCD = GENERATING_UNIT__GOVERNOR_SCD;

    /**
     * The feature id for the '<em><b>High Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__HIGH_CONTROL_LIMIT = GENERATING_UNIT__HIGH_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Initial P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__INITIAL_P = GENERATING_UNIT__INITIAL_P;

    /**
     * The feature id for the '<em><b>Long PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__LONG_PF = GENERATING_UNIT__LONG_PF;

    /**
     * The feature id for the '<em><b>Low Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__LOW_CONTROL_LIMIT = GENERATING_UNIT__LOW_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Lower Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__LOWER_RAMP_RATE = GENERATING_UNIT__LOWER_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Max Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__MAX_ECONOMIC_P = GENERATING_UNIT__MAX_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Maximum Allowable Spinning Reserve</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE = GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE;

    /**
     * The feature id for the '<em><b>Max Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__MAX_OPERATING_P = GENERATING_UNIT__MAX_OPERATING_P;

    /**
     * The feature id for the '<em><b>Min Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__MIN_ECONOMIC_P = GENERATING_UNIT__MIN_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Minimum Off Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__MINIMUM_OFF_TIME = GENERATING_UNIT__MINIMUM_OFF_TIME;

    /**
     * The feature id for the '<em><b>Min Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__MIN_OPERATING_P = GENERATING_UNIT__MIN_OPERATING_P;

    /**
     * The feature id for the '<em><b>Model Detail</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__MODEL_DETAIL = GENERATING_UNIT__MODEL_DETAIL;

    /**
     * The feature id for the '<em><b>Nominal P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__NOMINAL_P = GENERATING_UNIT__NOMINAL_P;

    /**
     * The feature id for the '<em><b>Normal PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__NORMAL_PF = GENERATING_UNIT__NORMAL_PF;

    /**
     * The feature id for the '<em><b>Penalty Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__PENALTY_FACTOR = GENERATING_UNIT__PENALTY_FACTOR;

    /**
     * The feature id for the '<em><b>Raise Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__RAISE_RAMP_RATE = GENERATING_UNIT__RAISE_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Rated Gross Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__RATED_GROSS_MAX_P = GENERATING_UNIT__RATED_GROSS_MAX_P;

    /**
     * The feature id for the '<em><b>Rated Gross Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__RATED_GROSS_MIN_P = GENERATING_UNIT__RATED_GROSS_MIN_P;

    /**
     * The feature id for the '<em><b>Rated Net Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__RATED_NET_MAX_P = GENERATING_UNIT__RATED_NET_MAX_P;

    /**
     * The feature id for the '<em><b>Short PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__SHORT_PF = GENERATING_UNIT__SHORT_PF;

    /**
     * The feature id for the '<em><b>Startup Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__STARTUP_COST = GENERATING_UNIT__STARTUP_COST;

    /**
     * The feature id for the '<em><b>Startup Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__STARTUP_TIME = GENERATING_UNIT__STARTUP_TIME;

    /**
     * The feature id for the '<em><b>Tie Line PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__TIE_LINE_PF = GENERATING_UNIT__TIE_LINE_PF;

    /**
     * The feature id for the '<em><b>Total Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__TOTAL_EFFICIENCY = GENERATING_UNIT__TOTAL_EFFICIENCY;

    /**
     * The feature id for the '<em><b>Variable Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__VARIABLE_COST = GENERATING_UNIT__VARIABLE_COST;

    /**
     * The feature id for the '<em><b>Gross To Net Active Power Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES = GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES;

    /**
     * The feature id for the '<em><b>Rotating Machine</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__ROTATING_MACHINE = GENERATING_UNIT__ROTATING_MACHINE;

    /**
     * The feature id for the '<em><b>Control Area Generating Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT = GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT;

    /**
     * The feature id for the '<em><b>Gen Unit Op Cost Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES = GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES;

    /**
     * The feature id for the '<em><b>Gen Unit Op Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE = GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE;

    /**
     * The feature id for the '<em><b>Wind Gen Unit Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT__WIND_GEN_UNIT_TYPE = GENERATING_UNIT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Wind Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT_FEATURE_COUNT = GENERATING_UNIT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Wind Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WIND_GENERATING_UNIT_OPERATION_COUNT = GENERATING_UNIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Hydro Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE__HYDRO_GENERATING_UNIT = CURVE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Penstock Loss Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Penstock Loss Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PENSTOCK_LOSS_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Drawing Order</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER__DRAWING_ORDER = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Visible Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER__VISIBLE_OBJECTS = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Visibility Layer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Visibility Layer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VISIBILITY_LAYER_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>DC Topological Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND__DC_TOPOLOGICAL_NODES = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>DC Topological Island</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>DC Topological Island</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_ISLAND_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Comb Cycle Plant Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__COMB_CYCLE_PLANT_RATING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Thermal Generating Units</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT__THERMAL_GENERATING_UNITS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Combined Cycle Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Combined Cycle Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBINED_CYCLE_PLANT_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__ID = EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__ALIAS_NAME = EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__DESCRIPTION = EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__MRID = EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__NAME = EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__NAMES = EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__DIAGRAM_OBJECTS = EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__MEASUREMENTS = EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__CONTROLS = EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__OPERATING_SHARE = EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__PSR_TYPE = EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__AGGREGATE = EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__NORMALLY_IN_SERVICE = EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__CONTINGENCY_EQUIPMENT = EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__OPERATIONAL_LIMIT_SET = EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__FAULTS = EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__EQUIPMENT_CONTAINER = EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Composite Switch Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__COMPOSITE_SWITCH_TYPE = EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Switches</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH__SWITCHES = EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Composite Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Composite Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPOSITE_SWITCH_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Is Percentage Limits</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET__IS_PERCENTAGE_LIMITS = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Limit Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Limit Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_SET_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Customer Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__CUSTOMER_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__GROUNDED = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__P = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Pfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__PFIXED = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Pfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__PFIXED_PCT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Phase Connection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__PHASE_CONNECTION = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__Q = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Qfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__QFIXED = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Qfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__QFIXED_PCT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Load Response</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__LOAD_RESPONSE = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Energy Consumer Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__ENERGY_CONSUMER_PHASE = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Power Cut Zone</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER__POWER_CUT_ZONE = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 11;

    /**
     * The number of structural features of the '<em>Energy Consumer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 12;

    /**
     * The number of operations of the '<em>Energy Consumer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__ID = ENERGY_CONSUMER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__ALIAS_NAME = ENERGY_CONSUMER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__DESCRIPTION = ENERGY_CONSUMER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__MRID = ENERGY_CONSUMER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__NAME = ENERGY_CONSUMER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__NAMES = ENERGY_CONSUMER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__DIAGRAM_OBJECTS = ENERGY_CONSUMER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__MEASUREMENTS = ENERGY_CONSUMER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__CONTROLS = ENERGY_CONSUMER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__OPERATING_SHARE = ENERGY_CONSUMER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__PSR_TYPE = ENERGY_CONSUMER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__AGGREGATE = ENERGY_CONSUMER__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__NORMALLY_IN_SERVICE = ENERGY_CONSUMER__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__CONTINGENCY_EQUIPMENT = ENERGY_CONSUMER__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__OPERATIONAL_LIMIT_SET = ENERGY_CONSUMER__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__FAULTS = ENERGY_CONSUMER__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__EQUIPMENT_CONTAINER = ENERGY_CONSUMER__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__PROTECTION_EQUIPMENTS = ENERGY_CONSUMER__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__BASE_VOLTAGE = ENERGY_CONSUMER__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__SV_STATUS = ENERGY_CONSUMER__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__TERMINALS = ENERGY_CONSUMER__TERMINALS;

    /**
     * The feature id for the '<em><b>Customer Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__CUSTOMER_COUNT = ENERGY_CONSUMER__CUSTOMER_COUNT;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__GROUNDED = ENERGY_CONSUMER__GROUNDED;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__P = ENERGY_CONSUMER__P;

    /**
     * The feature id for the '<em><b>Pfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__PFIXED = ENERGY_CONSUMER__PFIXED;

    /**
     * The feature id for the '<em><b>Pfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__PFIXED_PCT = ENERGY_CONSUMER__PFIXED_PCT;

    /**
     * The feature id for the '<em><b>Phase Connection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__PHASE_CONNECTION = ENERGY_CONSUMER__PHASE_CONNECTION;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__Q = ENERGY_CONSUMER__Q;

    /**
     * The feature id for the '<em><b>Qfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__QFIXED = ENERGY_CONSUMER__QFIXED;

    /**
     * The feature id for the '<em><b>Qfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__QFIXED_PCT = ENERGY_CONSUMER__QFIXED_PCT;

    /**
     * The feature id for the '<em><b>Load Response</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__LOAD_RESPONSE = ENERGY_CONSUMER__LOAD_RESPONSE;

    /**
     * The feature id for the '<em><b>Energy Consumer Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__ENERGY_CONSUMER_PHASE = ENERGY_CONSUMER__ENERGY_CONSUMER_PHASE;

    /**
     * The feature id for the '<em><b>Power Cut Zone</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__POWER_CUT_ZONE = ENERGY_CONSUMER__POWER_CUT_ZONE;

    /**
     * The feature id for the '<em><b>Load Group</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD__LOAD_GROUP = ENERGY_CONSUMER_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Non Conform Load</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_FEATURE_COUNT = ENERGY_CONSUMER_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Non Conform Load</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_OPERATION_COUNT = ENERGY_CONSUMER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Bad Reference</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__BAD_REFERENCE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Estimator Replaced</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__ESTIMATOR_REPLACED = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Failure</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__FAILURE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Old Data</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__OLD_DATA = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Operator Blocked</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__OPERATOR_BLOCKED = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Oscillatory</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__OSCILLATORY = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Out Of Range</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__OUT_OF_RANGE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Over Flow</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__OVER_FLOW = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Source</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__SOURCE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Suspect</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__SUSPECT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Test</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__TEST = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Validity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850__VALIDITY = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 11;

    /**
     * The number of structural features of the '<em>Quality61850</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 12;

    /**
     * The number of operations of the '<em>Quality61850</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int QUALITY61850_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Bmag Sat</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__BMAG_SAT = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>End Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__END_NUMBER = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__GROUNDED = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Mag Base U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__MAG_BASE_U = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Mag Sat Flux</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__MAG_SAT_FLUX = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Rground</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__RGROUND = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Xground</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__XGROUND = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__BASE_VOLTAGE = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>To Mesh Impedance</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__TO_MESH_IMPEDANCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Ratio Tap Changer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__RATIO_TAP_CHANGER = IDENTIFIED_OBJECT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__TERMINAL = IDENTIFIED_OBJECT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Star Impedance</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__STAR_IMPEDANCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>From Mesh Impedance</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__FROM_MESH_IMPEDANCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Core Admittance</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__CORE_ADMITTANCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Phase Tap Changer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END__PHASE_TAP_CHANGER = IDENTIFIED_OBJECT_FEATURE_COUNT + 14;

    /**
     * The number of structural features of the '<em>Transformer End</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 15;

    /**
     * The number of operations of the '<em>Transformer End</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_END_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__ID = TRANSFORMER_END__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__ALIAS_NAME = TRANSFORMER_END__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__DESCRIPTION = TRANSFORMER_END__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__MRID = TRANSFORMER_END__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__NAME = TRANSFORMER_END__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__NAMES = TRANSFORMER_END__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__DIAGRAM_OBJECTS = TRANSFORMER_END__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Bmag Sat</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__BMAG_SAT = TRANSFORMER_END__BMAG_SAT;

    /**
     * The feature id for the '<em><b>End Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__END_NUMBER = TRANSFORMER_END__END_NUMBER;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__GROUNDED = TRANSFORMER_END__GROUNDED;

    /**
     * The feature id for the '<em><b>Mag Base U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__MAG_BASE_U = TRANSFORMER_END__MAG_BASE_U;

    /**
     * The feature id for the '<em><b>Mag Sat Flux</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__MAG_SAT_FLUX = TRANSFORMER_END__MAG_SAT_FLUX;

    /**
     * The feature id for the '<em><b>Rground</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__RGROUND = TRANSFORMER_END__RGROUND;

    /**
     * The feature id for the '<em><b>Xground</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__XGROUND = TRANSFORMER_END__XGROUND;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__BASE_VOLTAGE = TRANSFORMER_END__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>To Mesh Impedance</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__TO_MESH_IMPEDANCE = TRANSFORMER_END__TO_MESH_IMPEDANCE;

    /**
     * The feature id for the '<em><b>Ratio Tap Changer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__RATIO_TAP_CHANGER = TRANSFORMER_END__RATIO_TAP_CHANGER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__TERMINAL = TRANSFORMER_END__TERMINAL;

    /**
     * The feature id for the '<em><b>Star Impedance</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__STAR_IMPEDANCE = TRANSFORMER_END__STAR_IMPEDANCE;

    /**
     * The feature id for the '<em><b>From Mesh Impedance</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__FROM_MESH_IMPEDANCE = TRANSFORMER_END__FROM_MESH_IMPEDANCE;

    /**
     * The feature id for the '<em><b>Core Admittance</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__CORE_ADMITTANCE = TRANSFORMER_END__CORE_ADMITTANCE;

    /**
     * The feature id for the '<em><b>Phase Tap Changer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__PHASE_TAP_CHANGER = TRANSFORMER_END__PHASE_TAP_CHANGER;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__PHASES = TRANSFORMER_END_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Transformer Tank</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END__TRANSFORMER_TANK = TRANSFORMER_END_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Transformer Tank End</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END_FEATURE_COUNT = TRANSFORMER_END_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Transformer Tank End</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_END_OPERATION_COUNT = TRANSFORMER_END_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Discrete</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__DISCRETE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__ENABLED = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__MODE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Monitored Phase</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__MONITORED_PHASE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Target Deadband</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__TARGET_DEADBAND = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Target Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__TARGET_VALUE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Target Value Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__TARGET_VALUE_UNIT_MULTIPLIER = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Regulation Schedule</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__REGULATION_SCHEDULE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Regulating Cond Eq</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__REGULATING_COND_EQ = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL__TERMINAL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 9;

    /**
     * The number of structural features of the '<em>Regulating Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 10;

    /**
     * The number of operations of the '<em>Regulating Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_CONTROL_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__ID = REGULATING_CONTROL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__ALIAS_NAME = REGULATING_CONTROL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__DESCRIPTION = REGULATING_CONTROL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__MRID = REGULATING_CONTROL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__NAME = REGULATING_CONTROL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__NAMES = REGULATING_CONTROL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__DIAGRAM_OBJECTS = REGULATING_CONTROL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__MEASUREMENTS = REGULATING_CONTROL__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__CONTROLS = REGULATING_CONTROL__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__OPERATING_SHARE = REGULATING_CONTROL__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__PSR_TYPE = REGULATING_CONTROL__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Discrete</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__DISCRETE = REGULATING_CONTROL__DISCRETE;

    /**
     * The feature id for the '<em><b>Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__ENABLED = REGULATING_CONTROL__ENABLED;

    /**
     * The feature id for the '<em><b>Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__MODE = REGULATING_CONTROL__MODE;

    /**
     * The feature id for the '<em><b>Monitored Phase</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__MONITORED_PHASE = REGULATING_CONTROL__MONITORED_PHASE;

    /**
     * The feature id for the '<em><b>Target Deadband</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__TARGET_DEADBAND = REGULATING_CONTROL__TARGET_DEADBAND;

    /**
     * The feature id for the '<em><b>Target Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__TARGET_VALUE = REGULATING_CONTROL__TARGET_VALUE;

    /**
     * The feature id for the '<em><b>Target Value Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__TARGET_VALUE_UNIT_MULTIPLIER = REGULATING_CONTROL__TARGET_VALUE_UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Regulation Schedule</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__REGULATION_SCHEDULE = REGULATING_CONTROL__REGULATION_SCHEDULE;

    /**
     * The feature id for the '<em><b>Regulating Cond Eq</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__REGULATING_COND_EQ = REGULATING_CONTROL__REGULATING_COND_EQ;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__TERMINAL = REGULATING_CONTROL__TERMINAL;

    /**
     * The feature id for the '<em><b>Limit Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__LIMIT_VOLTAGE = REGULATING_CONTROL_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Line Drop Compensation</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__LINE_DROP_COMPENSATION = REGULATING_CONTROL_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Line Drop R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__LINE_DROP_R = REGULATING_CONTROL_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Line Drop X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__LINE_DROP_X = REGULATING_CONTROL_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Reverse Line Drop R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__REVERSE_LINE_DROP_R = REGULATING_CONTROL_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Reverse Line Drop X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__REVERSE_LINE_DROP_X = REGULATING_CONTROL_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Tap Changer</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL__TAP_CHANGER = REGULATING_CONTROL_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Tap Changer Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL_FEATURE_COUNT = REGULATING_CONTROL_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Tap Changer Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_CHANGER_CONTROL_OPERATION_COUNT = REGULATING_CONTROL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__ID = REMOTE_POINT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__ALIAS_NAME = REMOTE_POINT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__DESCRIPTION = REMOTE_POINT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__MRID = REMOTE_POINT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__NAME = REMOTE_POINT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__NAMES = REMOTE_POINT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__DIAGRAM_OBJECTS = REMOTE_POINT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Remote Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__REMOTE_UNIT = REMOTE_POINT__REMOTE_UNIT;

    /**
     * The feature id for the '<em><b>Actuator Maximum</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__ACTUATOR_MAXIMUM = REMOTE_POINT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Actuator Minimum</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__ACTUATOR_MINIMUM = REMOTE_POINT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Remote Controlled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__REMOTE_CONTROLLED = REMOTE_POINT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL__CONTROL = REMOTE_POINT_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Remote Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL_FEATURE_COUNT = REMOTE_POINT_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Remote Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REMOTE_CONTROL_OPERATION_COUNT = REMOTE_POINT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Combustion Turbine</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE__COMBUSTION_TURBINE = CURVE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>CT Temp Active Power Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>CT Temp Active Power Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CT_TEMP_ACTIVE_POWER_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__ID = BASIC_INTERVAL_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__ALIAS_NAME = BASIC_INTERVAL_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__DESCRIPTION = BASIC_INTERVAL_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__MRID = BASIC_INTERVAL_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__NAME = BASIC_INTERVAL_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__NAMES = BASIC_INTERVAL_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS = BASIC_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__START_TIME = BASIC_INTERVAL_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER = BASIC_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__VALUE1_UNIT = BASIC_INTERVAL_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER = BASIC_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__VALUE2_UNIT = BASIC_INTERVAL_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE__TIME_POINTS = BASIC_INTERVAL_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Irregular Interval Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT = BASIC_INTERVAL_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Irregular Interval Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_INTERVAL_SCHEDULE_OPERATION_COUNT = BASIC_INTERVAL_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__CONTROL_TYPE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Operation In Progress</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__OPERATION_IN_PROGRESS = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__TIME_STAMP = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__UNIT_MULTIPLIER = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__UNIT_SYMBOL = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__POWER_SYSTEM_RESOURCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Remote Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL__REMOTE_CONTROL = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__ID = CONTROL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__ALIAS_NAME = CONTROL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__DESCRIPTION = CONTROL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__MRID = CONTROL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__NAME = CONTROL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__NAMES = CONTROL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__DIAGRAM_OBJECTS = CONTROL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__CONTROL_TYPE = CONTROL__CONTROL_TYPE;

    /**
     * The feature id for the '<em><b>Operation In Progress</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__OPERATION_IN_PROGRESS = CONTROL__OPERATION_IN_PROGRESS;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__TIME_STAMP = CONTROL__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__UNIT_MULTIPLIER = CONTROL__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__UNIT_SYMBOL = CONTROL__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__POWER_SYSTEM_RESOURCE = CONTROL__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>Remote Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__REMOTE_CONTROL = CONTROL__REMOTE_CONTROL;

    /**
     * The feature id for the '<em><b>Max Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__MAX_VALUE = CONTROL_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Min Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__MIN_VALUE = CONTROL_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Analog Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL__ANALOG_VALUE = CONTROL_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Analog Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL_FEATURE_COUNT = CONTROL_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Analog Control</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_CONTROL_OPERATION_COUNT = CONTROL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Operational Limit Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_TYPE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_SET = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Operational Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Operational Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__ID = OPERATIONAL_LIMIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__ALIAS_NAME = OPERATIONAL_LIMIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__DESCRIPTION = OPERATIONAL_LIMIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__MRID = OPERATIONAL_LIMIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__NAME = OPERATIONAL_LIMIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__NAMES = OPERATIONAL_LIMIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__DIAGRAM_OBJECTS = OPERATIONAL_LIMIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Operational Limit Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__OPERATIONAL_LIMIT_TYPE = OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_TYPE;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__OPERATIONAL_LIMIT_SET = OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT__VALUE = OPERATIONAL_LIMIT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Current Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT_FEATURE_COUNT = OPERATIONAL_LIMIT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Current Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_LIMIT_OPERATION_COUNT = OPERATIONAL_LIMIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Air Compressor Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__AIR_COMPRESSOR_RATING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Combustion Turbine</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__COMBUSTION_TURBINE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>CAES Plant</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR__CAES_PLANT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Air Compressor</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Air Compressor</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AIR_COMPRESSOR_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_INJECTION__ID = STATE_VARIABLE__ID;

    /**
     * The feature id for the '<em><b>PInjection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_INJECTION__PINJECTION = STATE_VARIABLE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>QInjection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_INJECTION__QINJECTION = STATE_VARIABLE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_INJECTION__TOPOLOGICAL_NODE = STATE_VARIABLE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Sv Injection</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_INJECTION_FEATURE_COUNT = STATE_VARIABLE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Sv Injection</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_INJECTION_OPERATION_COUNT = STATE_VARIABLE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__ID = ANALOG_CONTROL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__ALIAS_NAME = ANALOG_CONTROL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__DESCRIPTION = ANALOG_CONTROL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__MRID = ANALOG_CONTROL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__NAME = ANALOG_CONTROL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__NAMES = ANALOG_CONTROL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__DIAGRAM_OBJECTS = ANALOG_CONTROL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__CONTROL_TYPE = ANALOG_CONTROL__CONTROL_TYPE;

    /**
     * The feature id for the '<em><b>Operation In Progress</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__OPERATION_IN_PROGRESS = ANALOG_CONTROL__OPERATION_IN_PROGRESS;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__TIME_STAMP = ANALOG_CONTROL__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__UNIT_MULTIPLIER = ANALOG_CONTROL__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__UNIT_SYMBOL = ANALOG_CONTROL__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__POWER_SYSTEM_RESOURCE = ANALOG_CONTROL__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>Remote Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__REMOTE_CONTROL = ANALOG_CONTROL__REMOTE_CONTROL;

    /**
     * The feature id for the '<em><b>Max Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__MAX_VALUE = ANALOG_CONTROL__MAX_VALUE;

    /**
     * The feature id for the '<em><b>Min Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__MIN_VALUE = ANALOG_CONTROL__MIN_VALUE;

    /**
     * The feature id for the '<em><b>Analog Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__ANALOG_VALUE = ANALOG_CONTROL__ANALOG_VALUE;

    /**
     * The feature id for the '<em><b>Normal Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__NORMAL_VALUE = ANALOG_CONTROL_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT__VALUE = ANALOG_CONTROL_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Set Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT_FEATURE_COUNT = ANALOG_CONTROL_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Set Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SET_POINT_OPERATION_COUNT = ANALOG_CONTROL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The number of structural features of the '<em>Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIMIT_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT__ID = LIMIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT__ALIAS_NAME = LIMIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT__DESCRIPTION = LIMIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT__MRID = LIMIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT__NAME = LIMIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT__NAMES = LIMIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT__DIAGRAM_OBJECTS = LIMIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT__VALUE = LIMIT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Limit Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT__LIMIT_SET = LIMIT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Accumulator Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_FEATURE_COUNT = LIMIT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Accumulator Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_OPERATION_COUNT = LIMIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Fuel Allocation End Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__FUEL_ALLOCATION_END_DATE = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Fuel Allocation Start Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__FUEL_ALLOCATION_START_DATE = CURVE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Fuel Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__FUEL_TYPE = CURVE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Max Fuel Allocation</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__MAX_FUEL_ALLOCATION = CURVE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Min Fuel Allocation</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__MIN_FUEL_ALLOCATION = CURVE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Fossil Fuel</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__FOSSIL_FUEL = CURVE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE__THERMAL_GENERATING_UNIT = CURVE_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Fuel Allocation Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Fuel Allocation Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUEL_ALLOCATION_SCHEDULE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__CONTROL_ENABLED = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ__REGULATING_CONTROL = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Regulating Cond Eq</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Regulating Cond Eq</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATING_COND_EQ_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__ID = REGULATING_COND_EQ__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__ALIAS_NAME = REGULATING_COND_EQ__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__DESCRIPTION = REGULATING_COND_EQ__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__MRID = REGULATING_COND_EQ__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__NAME = REGULATING_COND_EQ__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__NAMES = REGULATING_COND_EQ__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__DIAGRAM_OBJECTS = REGULATING_COND_EQ__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__MEASUREMENTS = REGULATING_COND_EQ__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__CONTROLS = REGULATING_COND_EQ__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__OPERATING_SHARE = REGULATING_COND_EQ__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__PSR_TYPE = REGULATING_COND_EQ__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__AGGREGATE = REGULATING_COND_EQ__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__NORMALLY_IN_SERVICE = REGULATING_COND_EQ__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__CONTINGENCY_EQUIPMENT = REGULATING_COND_EQ__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__OPERATIONAL_LIMIT_SET = REGULATING_COND_EQ__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__FAULTS = REGULATING_COND_EQ__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__EQUIPMENT_CONTAINER = REGULATING_COND_EQ__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__PROTECTION_EQUIPMENTS = REGULATING_COND_EQ__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__BASE_VOLTAGE = REGULATING_COND_EQ__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__SV_STATUS = REGULATING_COND_EQ__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__TERMINALS = REGULATING_COND_EQ__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__CONTROL_ENABLED = REGULATING_COND_EQ__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__REGULATING_CONTROL = REGULATING_COND_EQ__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__P = REGULATING_COND_EQ_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__Q = REGULATING_COND_EQ_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Rated Power Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__RATED_POWER_FACTOR = REGULATING_COND_EQ_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Rated S</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__RATED_S = REGULATING_COND_EQ_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Rated U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__RATED_U = REGULATING_COND_EQ_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Hydro Pump</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__HYDRO_PUMP = REGULATING_COND_EQ_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE__GENERATING_UNIT = REGULATING_COND_EQ_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Rotating Machine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE_FEATURE_COUNT = REGULATING_COND_EQ_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Rotating Machine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROTATING_MACHINE_OPERATION_COUNT = REGULATING_COND_EQ_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__ID = ROTATING_MACHINE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__ALIAS_NAME = ROTATING_MACHINE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__DESCRIPTION = ROTATING_MACHINE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__MRID = ROTATING_MACHINE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__NAME = ROTATING_MACHINE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__NAMES = ROTATING_MACHINE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__DIAGRAM_OBJECTS = ROTATING_MACHINE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__MEASUREMENTS = ROTATING_MACHINE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__CONTROLS = ROTATING_MACHINE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__OPERATING_SHARE = ROTATING_MACHINE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__PSR_TYPE = ROTATING_MACHINE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__AGGREGATE = ROTATING_MACHINE__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__NORMALLY_IN_SERVICE = ROTATING_MACHINE__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__CONTINGENCY_EQUIPMENT = ROTATING_MACHINE__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__OPERATIONAL_LIMIT_SET = ROTATING_MACHINE__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__FAULTS = ROTATING_MACHINE__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__EQUIPMENT_CONTAINER = ROTATING_MACHINE__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__PROTECTION_EQUIPMENTS = ROTATING_MACHINE__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__BASE_VOLTAGE = ROTATING_MACHINE__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__SV_STATUS = ROTATING_MACHINE__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__TERMINALS = ROTATING_MACHINE__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__CONTROL_ENABLED = ROTATING_MACHINE__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__REGULATING_CONTROL = ROTATING_MACHINE__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__P = ROTATING_MACHINE__P;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__Q = ROTATING_MACHINE__Q;

    /**
     * The feature id for the '<em><b>Rated Power Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__RATED_POWER_FACTOR = ROTATING_MACHINE__RATED_POWER_FACTOR;

    /**
     * The feature id for the '<em><b>Rated S</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__RATED_S = ROTATING_MACHINE__RATED_S;

    /**
     * The feature id for the '<em><b>Rated U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__RATED_U = ROTATING_MACHINE__RATED_U;

    /**
     * The feature id for the '<em><b>Hydro Pump</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__HYDRO_PUMP = ROTATING_MACHINE__HYDRO_PUMP;

    /**
     * The feature id for the '<em><b>Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__GENERATING_UNIT = ROTATING_MACHINE__GENERATING_UNIT;

    /**
     * The feature id for the '<em><b>AVR To Manual Lag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__AVR_TO_MANUAL_LAG = ROTATING_MACHINE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>AVR To Manual Lead</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__AVR_TO_MANUAL_LEAD = ROTATING_MACHINE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Base Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__BASE_Q = ROTATING_MACHINE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Condenser P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__CONDENSER_P = ROTATING_MACHINE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Coolant Condition</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__COOLANT_CONDITION = ROTATING_MACHINE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Coolant Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__COOLANT_TYPE = ROTATING_MACHINE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Earthing</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__EARTHING = ROTATING_MACHINE_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Earthing Star Point R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__EARTHING_STAR_POINT_R = ROTATING_MACHINE_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Earthing Star Point X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__EARTHING_STAR_POINT_X = ROTATING_MACHINE_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Ikk</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__IKK = ROTATING_MACHINE_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Manual To AVR</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__MANUAL_TO_AVR = ROTATING_MACHINE_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Max Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__MAX_Q = ROTATING_MACHINE_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Max U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__MAX_U = ROTATING_MACHINE_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Min Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__MIN_Q = ROTATING_MACHINE_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Min U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__MIN_U = ROTATING_MACHINE_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Mu</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__MU = ROTATING_MACHINE_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Operating Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__OPERATING_MODE = ROTATING_MACHINE_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>QPercent</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__QPERCENT = ROTATING_MACHINE_FEATURE_COUNT + 17;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__R = ROTATING_MACHINE_FEATURE_COUNT + 18;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__R0 = ROTATING_MACHINE_FEATURE_COUNT + 19;

    /**
     * The feature id for the '<em><b>R2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__R2 = ROTATING_MACHINE_FEATURE_COUNT + 20;

    /**
     * The feature id for the '<em><b>Reference Priority</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__REFERENCE_PRIORITY = ROTATING_MACHINE_FEATURE_COUNT + 21;

    /**
     * The feature id for the '<em><b>Sat Direct Subtrans X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__SAT_DIRECT_SUBTRANS_X = ROTATING_MACHINE_FEATURE_COUNT + 22;

    /**
     * The feature id for the '<em><b>Sat Direct Sync X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__SAT_DIRECT_SYNC_X = ROTATING_MACHINE_FEATURE_COUNT + 23;

    /**
     * The feature id for the '<em><b>Sat Direct Trans X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__SAT_DIRECT_TRANS_X = ROTATING_MACHINE_FEATURE_COUNT + 24;

    /**
     * The feature id for the '<em><b>Short Circuit Rotor Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__SHORT_CIRCUIT_ROTOR_TYPE = ROTATING_MACHINE_FEATURE_COUNT + 25;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__TYPE = ROTATING_MACHINE_FEATURE_COUNT + 26;

    /**
     * The feature id for the '<em><b>Voltage Regulation Range</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__VOLTAGE_REGULATION_RANGE = ROTATING_MACHINE_FEATURE_COUNT + 27;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__X0 = ROTATING_MACHINE_FEATURE_COUNT + 28;

    /**
     * The feature id for the '<em><b>X2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__X2 = ROTATING_MACHINE_FEATURE_COUNT + 29;

    /**
     * The feature id for the '<em><b>Reactive Capability Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__REACTIVE_CAPABILITY_CURVES = ROTATING_MACHINE_FEATURE_COUNT + 30;

    /**
     * The feature id for the '<em><b>Initial Reactive Capability Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__INITIAL_REACTIVE_CAPABILITY_CURVE = ROTATING_MACHINE_FEATURE_COUNT + 31;

    /**
     * The feature id for the '<em><b>Prime Movers</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE__PRIME_MOVERS = ROTATING_MACHINE_FEATURE_COUNT + 32;

    /**
     * The number of structural features of the '<em>Synchronous Machine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE_FEATURE_COUNT = ROTATING_MACHINE_FEATURE_COUNT + 33;

    /**
     * The number of operations of the '<em>Synchronous Machine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHRONOUS_MACHINE_OPERATION_COUNT = ROTATING_MACHINE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__ID = SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__ALIAS_NAME = SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__DESCRIPTION = SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__MRID = SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__NAME = SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__NAMES = SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__DIAGRAM_OBJECTS = SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__MEASUREMENTS = SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__CONTROLS = SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__OPERATING_SHARE = SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__PSR_TYPE = SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__AGGREGATE = SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__NORMALLY_IN_SERVICE = SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__CONTINGENCY_EQUIPMENT = SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__OPERATIONAL_LIMIT_SET = SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__FAULTS = SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__EQUIPMENT_CONTAINER = SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__PROTECTION_EQUIPMENTS = SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__BASE_VOLTAGE = SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__SV_STATUS = SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__TERMINALS = SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__NORMAL_OPEN = SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__OPEN = SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__RATED_CURRENT = SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__RETAINED = SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__SWITCH_ON_COUNT = SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__SWITCH_ON_DATE = SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__COMPOSITE_SWITCH = SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__SWITCH_SCHEDULES = SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER__SWITCH_PHASE = SWITCH__SWITCH_PHASE;

    /**
     * The number of structural features of the '<em>Sectionaliser</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER_FEATURE_COUNT = SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Sectionaliser</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SECTIONALISER_OPERATION_COUNT = SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Connected</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__CONNECTED = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Sequence Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__SEQUENCE_NUMBER = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__MEASUREMENTS = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Bus Name Marker</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__BUS_NAME_MARKER = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL__OPERATIONAL_LIMIT_SET = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>ACDC Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>ACDC Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_TERMINAL_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__ID = ACDC_TERMINAL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__ALIAS_NAME = ACDC_TERMINAL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__DESCRIPTION = ACDC_TERMINAL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__MRID = ACDC_TERMINAL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__NAME = ACDC_TERMINAL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__NAMES = ACDC_TERMINAL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__DIAGRAM_OBJECTS = ACDC_TERMINAL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Connected</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__CONNECTED = ACDC_TERMINAL__CONNECTED;

    /**
     * The feature id for the '<em><b>Sequence Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__SEQUENCE_NUMBER = ACDC_TERMINAL__SEQUENCE_NUMBER;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__MEASUREMENTS = ACDC_TERMINAL__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Bus Name Marker</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__BUS_NAME_MARKER = ACDC_TERMINAL__BUS_NAME_MARKER;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__OPERATIONAL_LIMIT_SET = ACDC_TERMINAL__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>DC Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__DC_NODE = ACDC_TERMINAL_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>DC Topological Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL__DC_TOPOLOGICAL_NODE = ACDC_TERMINAL_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>DC Base Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL_FEATURE_COUNT = ACDC_TERMINAL_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>DC Base Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BASE_TERMINAL_OPERATION_COUNT = ACDC_TERMINAL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REPORTING_SUPER_GROUP__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REPORTING_SUPER_GROUP__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REPORTING_SUPER_GROUP__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REPORTING_SUPER_GROUP__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REPORTING_SUPER_GROUP__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REPORTING_SUPER_GROUP__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REPORTING_SUPER_GROUP__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The number of structural features of the '<em>Reporting Super Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REPORTING_SUPER_GROUP_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Reporting Super Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REPORTING_SUPER_GROUP_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__ID = REGULATING_COND_EQ__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__ALIAS_NAME = REGULATING_COND_EQ__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__DESCRIPTION = REGULATING_COND_EQ__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__MRID = REGULATING_COND_EQ__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__NAME = REGULATING_COND_EQ__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__NAMES = REGULATING_COND_EQ__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__DIAGRAM_OBJECTS = REGULATING_COND_EQ__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__MEASUREMENTS = REGULATING_COND_EQ__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__CONTROLS = REGULATING_COND_EQ__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__OPERATING_SHARE = REGULATING_COND_EQ__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__PSR_TYPE = REGULATING_COND_EQ__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__AGGREGATE = REGULATING_COND_EQ__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__NORMALLY_IN_SERVICE = REGULATING_COND_EQ__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__CONTINGENCY_EQUIPMENT = REGULATING_COND_EQ__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__OPERATIONAL_LIMIT_SET = REGULATING_COND_EQ__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__FAULTS = REGULATING_COND_EQ__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__EQUIPMENT_CONTAINER = REGULATING_COND_EQ__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__PROTECTION_EQUIPMENTS = REGULATING_COND_EQ__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__BASE_VOLTAGE = REGULATING_COND_EQ__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__SV_STATUS = REGULATING_COND_EQ__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__TERMINALS = REGULATING_COND_EQ__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__CONTROL_ENABLED = REGULATING_COND_EQ__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__REGULATING_CONTROL = REGULATING_COND_EQ__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>Max Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__MAX_Q = REGULATING_COND_EQ_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Min Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__MIN_Q = REGULATING_COND_EQ_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__P = REGULATING_COND_EQ_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__Q = REGULATING_COND_EQ_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__R = REGULATING_COND_EQ_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__R0 = REGULATING_COND_EQ_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Rated S</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__RATED_S = REGULATING_COND_EQ_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Rated U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__RATED_U = REGULATING_COND_EQ_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Rn</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__RN = REGULATING_COND_EQ_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__X = REGULATING_COND_EQ_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__X0 = REGULATING_COND_EQ_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Xn</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__XN = REGULATING_COND_EQ_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Power Electronics Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION__POWER_ELECTRONICS_UNIT = REGULATING_COND_EQ_FEATURE_COUNT + 12;

    /**
     * The number of structural features of the '<em>Power Electronics Connection</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION_FEATURE_COUNT = REGULATING_COND_EQ_FEATURE_COUNT + 13;

    /**
     * The number of operations of the '<em>Power Electronics Connection</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_ELECTRONICS_CONNECTION_OPERATION_COUNT = REGULATING_COND_EQ_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_LINE_PARAMETER__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_LINE_PARAMETER__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_LINE_PARAMETER__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_LINE_PARAMETER__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_LINE_PARAMETER__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_LINE_PARAMETER__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_LINE_PARAMETER__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The number of structural features of the '<em>Per Length Line Parameter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_LINE_PARAMETER_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Per Length Line Parameter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_LINE_PARAMETER_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE__ID = PER_LENGTH_LINE_PARAMETER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE__ALIAS_NAME = PER_LENGTH_LINE_PARAMETER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE__DESCRIPTION = PER_LENGTH_LINE_PARAMETER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE__MRID = PER_LENGTH_LINE_PARAMETER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE__NAME = PER_LENGTH_LINE_PARAMETER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE__NAMES = PER_LENGTH_LINE_PARAMETER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE__DIAGRAM_OBJECTS = PER_LENGTH_LINE_PARAMETER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>AC Line Segments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE__AC_LINE_SEGMENTS = PER_LENGTH_LINE_PARAMETER_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Per Length Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE_FEATURE_COUNT = PER_LENGTH_LINE_PARAMETER_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Per Length Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_IMPEDANCE_OPERATION_COUNT = PER_LENGTH_LINE_PARAMETER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__ID = PER_LENGTH_IMPEDANCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__ALIAS_NAME = PER_LENGTH_IMPEDANCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__DESCRIPTION = PER_LENGTH_IMPEDANCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__MRID = PER_LENGTH_IMPEDANCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__NAME = PER_LENGTH_IMPEDANCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__NAMES = PER_LENGTH_IMPEDANCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__DIAGRAM_OBJECTS = PER_LENGTH_IMPEDANCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>AC Line Segments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__AC_LINE_SEGMENTS = PER_LENGTH_IMPEDANCE__AC_LINE_SEGMENTS;

    /**
     * The feature id for the '<em><b>B0ch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__B0CH = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Bch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__BCH = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>G0ch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__G0CH = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Gch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__GCH = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__R = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__R0 = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__X = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE__X0 = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 7;

    /**
     * The number of structural features of the '<em>Per Length Sequence Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE_FEATURE_COUNT = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 8;

    /**
     * The number of operations of the '<em>Per Length Sequence Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_SEQUENCE_IMPEDANCE_OPERATION_COUNT = PER_LENGTH_IMPEDANCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__ID = CONTROL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__ALIAS_NAME = CONTROL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__DESCRIPTION = CONTROL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__MRID = CONTROL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__NAME = CONTROL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__NAMES = CONTROL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__DIAGRAM_OBJECTS = CONTROL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__CONTROL_TYPE = CONTROL__CONTROL_TYPE;

    /**
     * The feature id for the '<em><b>Operation In Progress</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__OPERATION_IN_PROGRESS = CONTROL__OPERATION_IN_PROGRESS;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__TIME_STAMP = CONTROL__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__UNIT_MULTIPLIER = CONTROL__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__UNIT_SYMBOL = CONTROL__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__POWER_SYSTEM_RESOURCE = CONTROL__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>Remote Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__REMOTE_CONTROL = CONTROL__REMOTE_CONTROL;

    /**
     * The feature id for the '<em><b>Normal Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__NORMAL_VALUE = CONTROL_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__VALUE = CONTROL_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Value Alias Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__VALUE_ALIAS_SET = CONTROL_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Discrete Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND__DISCRETE_VALUE = CONTROL_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Command</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND_FEATURE_COUNT = CONTROL_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Command</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMAND_OPERATION_COUNT = CONTROL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__ID = SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__ALIAS_NAME = SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__DESCRIPTION = SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__MRID = SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__NAME = SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__NAMES = SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__DIAGRAM_OBJECTS = SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__MEASUREMENTS = SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__CONTROLS = SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__OPERATING_SHARE = SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__PSR_TYPE = SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__AGGREGATE = SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__NORMALLY_IN_SERVICE = SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__CONTINGENCY_EQUIPMENT = SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__OPERATIONAL_LIMIT_SET = SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__FAULTS = SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__EQUIPMENT_CONTAINER = SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__PROTECTION_EQUIPMENTS = SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__BASE_VOLTAGE = SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__SV_STATUS = SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__TERMINALS = SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__NORMAL_OPEN = SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__OPEN = SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__RATED_CURRENT = SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__RETAINED = SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__SWITCH_ON_COUNT = SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__SWITCH_ON_DATE = SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__COMPOSITE_SWITCH = SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__SWITCH_SCHEDULES = SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE__SWITCH_PHASE = SWITCH__SWITCH_PHASE;

    /**
     * The number of structural features of the '<em>Fuse</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE_FEATURE_COUNT = SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Fuse</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FUSE_OPERATION_COUNT = SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Cut Level1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__CUT_LEVEL1 = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Cut Level2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__CUT_LEVEL2 = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Energy Consumers</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE__ENERGY_CONSUMERS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Power Cut Zone</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Power Cut Zone</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_CUT_ZONE_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Sub Load Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP__SUB_LOAD_AREA = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Load Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Load Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_GROUP_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__ID = LOAD_GROUP__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__ALIAS_NAME = LOAD_GROUP__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__DESCRIPTION = LOAD_GROUP__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__MRID = LOAD_GROUP__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__NAME = LOAD_GROUP__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__NAMES = LOAD_GROUP__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__DIAGRAM_OBJECTS = LOAD_GROUP__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Sub Load Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__SUB_LOAD_AREA = LOAD_GROUP__SUB_LOAD_AREA;

    /**
     * The feature id for the '<em><b>Energy Consumers</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__ENERGY_CONSUMERS = LOAD_GROUP_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Non Conform Load Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP__NON_CONFORM_LOAD_SCHEDULES = LOAD_GROUP_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Non Conform Load Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP_FEATURE_COUNT = LOAD_GROUP_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Non Conform Load Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NON_CONFORM_LOAD_GROUP_OPERATION_COUNT = LOAD_GROUP_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__ID = CONTROL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__ALIAS_NAME = CONTROL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__DESCRIPTION = CONTROL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__MRID = CONTROL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__NAME = CONTROL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__NAMES = CONTROL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__DIAGRAM_OBJECTS = CONTROL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__CONTROL_TYPE = CONTROL__CONTROL_TYPE;

    /**
     * The feature id for the '<em><b>Operation In Progress</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__OPERATION_IN_PROGRESS = CONTROL__OPERATION_IN_PROGRESS;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__TIME_STAMP = CONTROL__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__UNIT_MULTIPLIER = CONTROL__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__UNIT_SYMBOL = CONTROL__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__POWER_SYSTEM_RESOURCE = CONTROL__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>Remote Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__REMOTE_CONTROL = CONTROL__REMOTE_CONTROL;

    /**
     * The feature id for the '<em><b>Accumulator Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET__ACCUMULATOR_VALUE = CONTROL_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Accumulator Reset</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET_FEATURE_COUNT = CONTROL_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Accumulator Reset</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_RESET_OPERATION_COUNT = CONTROL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Kind</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__KIND = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__PHASES = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Impedance</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__IMPEDANCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Fault Cause Types</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__FAULT_CAUSE_TYPES = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Faulty Equipment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT__FAULTY_EQUIPMENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Fault</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Fault</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__ID = FAULT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__ALIAS_NAME = FAULT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__DESCRIPTION = FAULT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__MRID = FAULT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__NAME = FAULT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__NAMES = FAULT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__DIAGRAM_OBJECTS = FAULT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Kind</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__KIND = FAULT__KIND;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__PHASES = FAULT__PHASES;

    /**
     * The feature id for the '<em><b>Impedance</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__IMPEDANCE = FAULT__IMPEDANCE;

    /**
     * The feature id for the '<em><b>Fault Cause Types</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__FAULT_CAUSE_TYPES = FAULT__FAULT_CAUSE_TYPES;

    /**
     * The feature id for the '<em><b>Faulty Equipment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__FAULTY_EQUIPMENT = FAULT__FAULTY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT__TERMINAL = FAULT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Equipment Fault</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT_FEATURE_COUNT = FAULT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Equipment Fault</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIPMENT_FAULT_OPERATION_COUNT = FAULT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Coolant Temperature</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__COOLANT_TEMPERATURE = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Hydrogen Pressure</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__HYDROGEN_PRESSURE = CURVE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Equivalent Injection</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__EQUIVALENT_INJECTION = CURVE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Synchronous Machines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__SYNCHRONOUS_MACHINES = CURVE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Initially Used By Synchronous Machines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE__INITIALLY_USED_BY_SYNCHRONOUS_MACHINES = CURVE_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Reactive Capability Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Reactive Capability Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REACTIVE_CAPABILITY_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Base S</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__BASE_S = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Idc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__IDC = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Idle Loss</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__IDLE_LOSS = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Max Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__MAX_UDC = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Min Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__MIN_UDC = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Number Of Valves</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__NUMBER_OF_VALVES = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__P = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Pole Loss P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__POLE_LOSS_P = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__Q = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Rated Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__RATED_UDC = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Resistive Loss</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__RESISTIVE_LOSS = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Switching Loss</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__SWITCHING_LOSS = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Target Ppcc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__TARGET_PPCC = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Target Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__TARGET_UDC = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Uc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__UC = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__UDC = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Valve U0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__VALVE_U0 = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__DC_TERMINALS = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 17;

    /**
     * The feature id for the '<em><b>Pcc Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER__PCC_TERMINAL = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 18;

    /**
     * The number of structural features of the '<em>ACDC Converter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 19;

    /**
     * The number of operations of the '<em>ACDC Converter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__ID = GENERATING_UNIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__ALIAS_NAME = GENERATING_UNIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__DESCRIPTION = GENERATING_UNIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__MRID = GENERATING_UNIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__NAME = GENERATING_UNIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__NAMES = GENERATING_UNIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__DIAGRAM_OBJECTS = GENERATING_UNIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__MEASUREMENTS = GENERATING_UNIT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__CONTROLS = GENERATING_UNIT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__OPERATING_SHARE = GENERATING_UNIT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__PSR_TYPE = GENERATING_UNIT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__AGGREGATE = GENERATING_UNIT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__NORMALLY_IN_SERVICE = GENERATING_UNIT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__CONTINGENCY_EQUIPMENT = GENERATING_UNIT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__OPERATIONAL_LIMIT_SET = GENERATING_UNIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__FAULTS = GENERATING_UNIT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__EQUIPMENT_CONTAINER = GENERATING_UNIT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Alloc Spin Res P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__ALLOC_SPIN_RES_P = GENERATING_UNIT__ALLOC_SPIN_RES_P;

    /**
     * The feature id for the '<em><b>Auto Cntrl Margin P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__AUTO_CNTRL_MARGIN_P = GENERATING_UNIT__AUTO_CNTRL_MARGIN_P;

    /**
     * The feature id for the '<em><b>Base P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__BASE_P = GENERATING_UNIT__BASE_P;

    /**
     * The feature id for the '<em><b>Control Deadband</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__CONTROL_DEADBAND = GENERATING_UNIT__CONTROL_DEADBAND;

    /**
     * The feature id for the '<em><b>Control Pulse High</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__CONTROL_PULSE_HIGH = GENERATING_UNIT__CONTROL_PULSE_HIGH;

    /**
     * The feature id for the '<em><b>Control Pulse Low</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__CONTROL_PULSE_LOW = GENERATING_UNIT__CONTROL_PULSE_LOW;

    /**
     * The feature id for the '<em><b>Control Response Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__CONTROL_RESPONSE_RATE = GENERATING_UNIT__CONTROL_RESPONSE_RATE;

    /**
     * The feature id for the '<em><b>Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__EFFICIENCY = GENERATING_UNIT__EFFICIENCY;

    /**
     * The feature id for the '<em><b>Gen Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__GEN_CONTROL_MODE = GENERATING_UNIT__GEN_CONTROL_MODE;

    /**
     * The feature id for the '<em><b>Gen Control Source</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__GEN_CONTROL_SOURCE = GENERATING_UNIT__GEN_CONTROL_SOURCE;

    /**
     * The feature id for the '<em><b>Governor MPL</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__GOVERNOR_MPL = GENERATING_UNIT__GOVERNOR_MPL;

    /**
     * The feature id for the '<em><b>Governor SCD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__GOVERNOR_SCD = GENERATING_UNIT__GOVERNOR_SCD;

    /**
     * The feature id for the '<em><b>High Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__HIGH_CONTROL_LIMIT = GENERATING_UNIT__HIGH_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Initial P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__INITIAL_P = GENERATING_UNIT__INITIAL_P;

    /**
     * The feature id for the '<em><b>Long PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__LONG_PF = GENERATING_UNIT__LONG_PF;

    /**
     * The feature id for the '<em><b>Low Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__LOW_CONTROL_LIMIT = GENERATING_UNIT__LOW_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Lower Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__LOWER_RAMP_RATE = GENERATING_UNIT__LOWER_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Max Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__MAX_ECONOMIC_P = GENERATING_UNIT__MAX_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Maximum Allowable Spinning Reserve</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE = GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE;

    /**
     * The feature id for the '<em><b>Max Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__MAX_OPERATING_P = GENERATING_UNIT__MAX_OPERATING_P;

    /**
     * The feature id for the '<em><b>Min Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__MIN_ECONOMIC_P = GENERATING_UNIT__MIN_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Minimum Off Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__MINIMUM_OFF_TIME = GENERATING_UNIT__MINIMUM_OFF_TIME;

    /**
     * The feature id for the '<em><b>Min Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__MIN_OPERATING_P = GENERATING_UNIT__MIN_OPERATING_P;

    /**
     * The feature id for the '<em><b>Model Detail</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__MODEL_DETAIL = GENERATING_UNIT__MODEL_DETAIL;

    /**
     * The feature id for the '<em><b>Nominal P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__NOMINAL_P = GENERATING_UNIT__NOMINAL_P;

    /**
     * The feature id for the '<em><b>Normal PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__NORMAL_PF = GENERATING_UNIT__NORMAL_PF;

    /**
     * The feature id for the '<em><b>Penalty Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__PENALTY_FACTOR = GENERATING_UNIT__PENALTY_FACTOR;

    /**
     * The feature id for the '<em><b>Raise Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__RAISE_RAMP_RATE = GENERATING_UNIT__RAISE_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Rated Gross Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__RATED_GROSS_MAX_P = GENERATING_UNIT__RATED_GROSS_MAX_P;

    /**
     * The feature id for the '<em><b>Rated Gross Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__RATED_GROSS_MIN_P = GENERATING_UNIT__RATED_GROSS_MIN_P;

    /**
     * The feature id for the '<em><b>Rated Net Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__RATED_NET_MAX_P = GENERATING_UNIT__RATED_NET_MAX_P;

    /**
     * The feature id for the '<em><b>Short PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__SHORT_PF = GENERATING_UNIT__SHORT_PF;

    /**
     * The feature id for the '<em><b>Startup Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__STARTUP_COST = GENERATING_UNIT__STARTUP_COST;

    /**
     * The feature id for the '<em><b>Startup Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__STARTUP_TIME = GENERATING_UNIT__STARTUP_TIME;

    /**
     * The feature id for the '<em><b>Tie Line PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__TIE_LINE_PF = GENERATING_UNIT__TIE_LINE_PF;

    /**
     * The feature id for the '<em><b>Total Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__TOTAL_EFFICIENCY = GENERATING_UNIT__TOTAL_EFFICIENCY;

    /**
     * The feature id for the '<em><b>Variable Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__VARIABLE_COST = GENERATING_UNIT__VARIABLE_COST;

    /**
     * The feature id for the '<em><b>Gross To Net Active Power Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES = GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES;

    /**
     * The feature id for the '<em><b>Rotating Machine</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__ROTATING_MACHINE = GENERATING_UNIT__ROTATING_MACHINE;

    /**
     * The feature id for the '<em><b>Control Area Generating Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT = GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT;

    /**
     * The feature id for the '<em><b>Gen Unit Op Cost Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES = GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES;

    /**
     * The feature id for the '<em><b>Gen Unit Op Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE = GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE;

    /**
     * The number of structural features of the '<em>Nuclear Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT_FEATURE_COUNT = GENERATING_UNIT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Nuclear Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NUCLEAR_GENERATING_UNIT_OPERATION_COUNT = GENERATING_UNIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Contingency</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT__CONTINGENCY = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Contingency Element</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Contingency Element</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_ELEMENT_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__ID = CONTINGENCY_ELEMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__ALIAS_NAME = CONTINGENCY_ELEMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__DESCRIPTION = CONTINGENCY_ELEMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__MRID = CONTINGENCY_ELEMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__NAME = CONTINGENCY_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__NAMES = CONTINGENCY_ELEMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__DIAGRAM_OBJECTS = CONTINGENCY_ELEMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Contingency</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__CONTINGENCY = CONTINGENCY_ELEMENT__CONTINGENCY;

    /**
     * The feature id for the '<em><b>Contingent Status</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__CONTINGENT_STATUS = CONTINGENCY_ELEMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Equipment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT__EQUIPMENT = CONTINGENCY_ELEMENT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Contingency Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT_FEATURE_COUNT = CONTINGENCY_ELEMENT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Contingency Equipment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_EQUIPMENT_OPERATION_COUNT = CONTINGENCY_ELEMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_STATUS__ID = STATE_VARIABLE__ID;

    /**
     * The feature id for the '<em><b>In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_STATUS__IN_SERVICE = STATE_VARIABLE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Conducting Equipment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_STATUS__CONDUCTING_EQUIPMENT = STATE_VARIABLE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Sv Status</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_STATUS_FEATURE_COUNT = STATE_VARIABLE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Sv Status</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_STATUS_OPERATION_COUNT = STATE_VARIABLE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__ID = PHASE_TAP_CHANGER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__ALIAS_NAME = PHASE_TAP_CHANGER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__DESCRIPTION = PHASE_TAP_CHANGER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__MRID = PHASE_TAP_CHANGER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__NAME = PHASE_TAP_CHANGER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__NAMES = PHASE_TAP_CHANGER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__DIAGRAM_OBJECTS = PHASE_TAP_CHANGER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__MEASUREMENTS = PHASE_TAP_CHANGER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__CONTROLS = PHASE_TAP_CHANGER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__OPERATING_SHARE = PHASE_TAP_CHANGER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__PSR_TYPE = PHASE_TAP_CHANGER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__CONTROL_ENABLED = PHASE_TAP_CHANGER__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>High Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__HIGH_STEP = PHASE_TAP_CHANGER__HIGH_STEP;

    /**
     * The feature id for the '<em><b>Initial Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__INITIAL_DELAY = PHASE_TAP_CHANGER__INITIAL_DELAY;

    /**
     * The feature id for the '<em><b>Low Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__LOW_STEP = PHASE_TAP_CHANGER__LOW_STEP;

    /**
     * The feature id for the '<em><b>Ltc Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__LTC_FLAG = PHASE_TAP_CHANGER__LTC_FLAG;

    /**
     * The feature id for the '<em><b>Neutral Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__NEUTRAL_STEP = PHASE_TAP_CHANGER__NEUTRAL_STEP;

    /**
     * The feature id for the '<em><b>Neutral U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__NEUTRAL_U = PHASE_TAP_CHANGER__NEUTRAL_U;

    /**
     * The feature id for the '<em><b>Normal Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__NORMAL_STEP = PHASE_TAP_CHANGER__NORMAL_STEP;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__STEP = PHASE_TAP_CHANGER__STEP;

    /**
     * The feature id for the '<em><b>Subsequent Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__SUBSEQUENT_DELAY = PHASE_TAP_CHANGER__SUBSEQUENT_DELAY;

    /**
     * The feature id for the '<em><b>Sv Tap Step</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__SV_TAP_STEP = PHASE_TAP_CHANGER__SV_TAP_STEP;

    /**
     * The feature id for the '<em><b>Tap Changer Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__TAP_CHANGER_CONTROL = PHASE_TAP_CHANGER__TAP_CHANGER_CONTROL;

    /**
     * The feature id for the '<em><b>Tap Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__TAP_SCHEDULES = PHASE_TAP_CHANGER__TAP_SCHEDULES;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__TRANSFORMER_END = PHASE_TAP_CHANGER__TRANSFORMER_END;

    /**
     * The feature id for the '<em><b>Phase Tap Changer Table</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR__PHASE_TAP_CHANGER_TABLE = PHASE_TAP_CHANGER_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Phase Tap Changer Tabular</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR_FEATURE_COUNT = PHASE_TAP_CHANGER_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Phase Tap Changer Tabular</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABULAR_OPERATION_COUNT = PHASE_TAP_CHANGER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Maximum Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__MAXIMUM_SECTIONS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Normal Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__NORMAL_SECTIONS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Phase</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__PHASE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Shunt Compensator</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE__SHUNT_COMPENSATOR = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Shunt Compensator Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Shunt Compensator Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_PHASE_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__ID = LOAD_GROUP__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__ALIAS_NAME = LOAD_GROUP__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__DESCRIPTION = LOAD_GROUP__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__MRID = LOAD_GROUP__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__NAME = LOAD_GROUP__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__NAMES = LOAD_GROUP__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__DIAGRAM_OBJECTS = LOAD_GROUP__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Sub Load Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__SUB_LOAD_AREA = LOAD_GROUP__SUB_LOAD_AREA;

    /**
     * The feature id for the '<em><b>Energy Consumers</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__ENERGY_CONSUMERS = LOAD_GROUP_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Conform Load Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP__CONFORM_LOAD_SCHEDULES = LOAD_GROUP_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Conform Load Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP_FEATURE_COUNT = LOAD_GROUP_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Conform Load Group</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_GROUP_OPERATION_COUNT = LOAD_GROUP_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT__OPERATING_SHARE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Operating Participant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Operating Participant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_PARTICIPANT_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__ID = LIMIT_SET__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__ALIAS_NAME = LIMIT_SET__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__DESCRIPTION = LIMIT_SET__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__MRID = LIMIT_SET__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__NAME = LIMIT_SET__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__NAMES = LIMIT_SET__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__DIAGRAM_OBJECTS = LIMIT_SET__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Is Percentage Limits</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__IS_PERCENTAGE_LIMITS = LIMIT_SET__IS_PERCENTAGE_LIMITS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__MEASUREMENTS = LIMIT_SET_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Limits</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET__LIMITS = LIMIT_SET_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Accumulator Limit Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET_FEATURE_COUNT = LIMIT_SET_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Accumulator Limit Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_LIMIT_SET_OPERATION_COUNT = LIMIT_SET_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>DC Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__DC_EQUIPMENT_CONTAINER = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__DC_TERMINALS = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>DC Topological Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE__DC_TOPOLOGICAL_NODE = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>DC Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>DC Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_NODE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__R = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__R0 = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__X = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__X0 = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE__TRANSFORMER_END = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Transformer Star Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Transformer Star Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_STAR_IMPEDANCE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__ID = STEAM_SUPPLY__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__ALIAS_NAME = STEAM_SUPPLY__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__DESCRIPTION = STEAM_SUPPLY__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__MRID = STEAM_SUPPLY__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__NAME = STEAM_SUPPLY__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__NAMES = STEAM_SUPPLY__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__DIAGRAM_OBJECTS = STEAM_SUPPLY__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__MEASUREMENTS = STEAM_SUPPLY__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__CONTROLS = STEAM_SUPPLY__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__OPERATING_SHARE = STEAM_SUPPLY__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__PSR_TYPE = STEAM_SUPPLY__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Steam Supply Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__STEAM_SUPPLY_RATING = STEAM_SUPPLY__STEAM_SUPPLY_RATING;

    /**
     * The feature id for the '<em><b>Steam Turbines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__STEAM_TURBINES = STEAM_SUPPLY__STEAM_TURBINES;

    /**
     * The feature id for the '<em><b>Aux Power Versus Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_FREQUENCY = STEAM_SUPPLY_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Aux Power Versus Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_VOLTAGE = STEAM_SUPPLY_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Boiler Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__BOILER_CONTROL_MODE = STEAM_SUPPLY_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Control Error Bias P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__CONTROL_ERROR_BIAS_P = STEAM_SUPPLY_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Control IC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__CONTROL_IC = STEAM_SUPPLY_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Control PC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__CONTROL_PC = STEAM_SUPPLY_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Control PEB</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__CONTROL_PEB = STEAM_SUPPLY_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Control PED</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__CONTROL_PED = STEAM_SUPPLY_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Control TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__CONTROL_TC = STEAM_SUPPLY_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Feed Water IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__FEED_WATER_IG = STEAM_SUPPLY_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Feed Water PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__FEED_WATER_PG = STEAM_SUPPLY_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Feed Water TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__FEED_WATER_TC = STEAM_SUPPLY_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Fuel Demand Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__FUEL_DEMAND_LIMIT = STEAM_SUPPLY_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Fuel Supply Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_DELAY = STEAM_SUPPLY_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Fuel Supply TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_TC = STEAM_SUPPLY_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Max Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__MAX_ERROR_RATE_P = STEAM_SUPPLY_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Mech Power Sensor Lag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__MECH_POWER_SENSOR_LAG = STEAM_SUPPLY_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>Min Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__MIN_ERROR_RATE_P = STEAM_SUPPLY_FEATURE_COUNT + 17;

    /**
     * The feature id for the '<em><b>Pressure Ctrl DG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_DG = STEAM_SUPPLY_FEATURE_COUNT + 18;

    /**
     * The feature id for the '<em><b>Pressure Ctrl IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_IG = STEAM_SUPPLY_FEATURE_COUNT + 19;

    /**
     * The feature id for the '<em><b>Pressure Ctrl PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_PG = STEAM_SUPPLY_FEATURE_COUNT + 20;

    /**
     * The feature id for the '<em><b>Pressure Feedback</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__PRESSURE_FEEDBACK = STEAM_SUPPLY_FEATURE_COUNT + 21;

    /**
     * The feature id for the '<em><b>Super Heater1 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__SUPER_HEATER1_CAPACITY = STEAM_SUPPLY_FEATURE_COUNT + 22;

    /**
     * The feature id for the '<em><b>Super Heater2 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__SUPER_HEATER2_CAPACITY = STEAM_SUPPLY_FEATURE_COUNT + 23;

    /**
     * The feature id for the '<em><b>Super Heater Pipe PD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__SUPER_HEATER_PIPE_PD = STEAM_SUPPLY_FEATURE_COUNT + 24;

    /**
     * The feature id for the '<em><b>Throttle Pressure SP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY__THROTTLE_PRESSURE_SP = STEAM_SUPPLY_FEATURE_COUNT + 25;

    /**
     * The number of structural features of the '<em>Fossil Steam Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY_FEATURE_COUNT = STEAM_SUPPLY_FEATURE_COUNT + 26;

    /**
     * The number of operations of the '<em>Fossil Steam Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_STEAM_SUPPLY_OPERATION_COUNT = STEAM_SUPPLY_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__ID = FOSSIL_STEAM_SUPPLY__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__ALIAS_NAME = FOSSIL_STEAM_SUPPLY__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__DESCRIPTION = FOSSIL_STEAM_SUPPLY__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__MRID = FOSSIL_STEAM_SUPPLY__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__NAME = FOSSIL_STEAM_SUPPLY__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__NAMES = FOSSIL_STEAM_SUPPLY__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__DIAGRAM_OBJECTS = FOSSIL_STEAM_SUPPLY__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__MEASUREMENTS = FOSSIL_STEAM_SUPPLY__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__CONTROLS = FOSSIL_STEAM_SUPPLY__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__OPERATING_SHARE = FOSSIL_STEAM_SUPPLY__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__PSR_TYPE = FOSSIL_STEAM_SUPPLY__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Steam Supply Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__STEAM_SUPPLY_RATING = FOSSIL_STEAM_SUPPLY__STEAM_SUPPLY_RATING;

    /**
     * The feature id for the '<em><b>Steam Turbines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__STEAM_TURBINES = FOSSIL_STEAM_SUPPLY__STEAM_TURBINES;

    /**
     * The feature id for the '<em><b>Aux Power Versus Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__AUX_POWER_VERSUS_FREQUENCY = FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_FREQUENCY;

    /**
     * The feature id for the '<em><b>Aux Power Versus Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__AUX_POWER_VERSUS_VOLTAGE = FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_VOLTAGE;

    /**
     * The feature id for the '<em><b>Boiler Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__BOILER_CONTROL_MODE = FOSSIL_STEAM_SUPPLY__BOILER_CONTROL_MODE;

    /**
     * The feature id for the '<em><b>Control Error Bias P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__CONTROL_ERROR_BIAS_P = FOSSIL_STEAM_SUPPLY__CONTROL_ERROR_BIAS_P;

    /**
     * The feature id for the '<em><b>Control IC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__CONTROL_IC = FOSSIL_STEAM_SUPPLY__CONTROL_IC;

    /**
     * The feature id for the '<em><b>Control PC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__CONTROL_PC = FOSSIL_STEAM_SUPPLY__CONTROL_PC;

    /**
     * The feature id for the '<em><b>Control PEB</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__CONTROL_PEB = FOSSIL_STEAM_SUPPLY__CONTROL_PEB;

    /**
     * The feature id for the '<em><b>Control PED</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__CONTROL_PED = FOSSIL_STEAM_SUPPLY__CONTROL_PED;

    /**
     * The feature id for the '<em><b>Control TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__CONTROL_TC = FOSSIL_STEAM_SUPPLY__CONTROL_TC;

    /**
     * The feature id for the '<em><b>Feed Water IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__FEED_WATER_IG = FOSSIL_STEAM_SUPPLY__FEED_WATER_IG;

    /**
     * The feature id for the '<em><b>Feed Water PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__FEED_WATER_PG = FOSSIL_STEAM_SUPPLY__FEED_WATER_PG;

    /**
     * The feature id for the '<em><b>Feed Water TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__FEED_WATER_TC = FOSSIL_STEAM_SUPPLY__FEED_WATER_TC;

    /**
     * The feature id for the '<em><b>Fuel Demand Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__FUEL_DEMAND_LIMIT = FOSSIL_STEAM_SUPPLY__FUEL_DEMAND_LIMIT;

    /**
     * The feature id for the '<em><b>Fuel Supply Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__FUEL_SUPPLY_DELAY = FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_DELAY;

    /**
     * The feature id for the '<em><b>Fuel Supply TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__FUEL_SUPPLY_TC = FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_TC;

    /**
     * The feature id for the '<em><b>Max Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__MAX_ERROR_RATE_P = FOSSIL_STEAM_SUPPLY__MAX_ERROR_RATE_P;

    /**
     * The feature id for the '<em><b>Mech Power Sensor Lag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__MECH_POWER_SENSOR_LAG = FOSSIL_STEAM_SUPPLY__MECH_POWER_SENSOR_LAG;

    /**
     * The feature id for the '<em><b>Min Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__MIN_ERROR_RATE_P = FOSSIL_STEAM_SUPPLY__MIN_ERROR_RATE_P;

    /**
     * The feature id for the '<em><b>Pressure Ctrl DG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__PRESSURE_CTRL_DG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_DG;

    /**
     * The feature id for the '<em><b>Pressure Ctrl IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__PRESSURE_CTRL_IG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_IG;

    /**
     * The feature id for the '<em><b>Pressure Ctrl PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__PRESSURE_CTRL_PG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_PG;

    /**
     * The feature id for the '<em><b>Pressure Feedback</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__PRESSURE_FEEDBACK = FOSSIL_STEAM_SUPPLY__PRESSURE_FEEDBACK;

    /**
     * The feature id for the '<em><b>Super Heater1 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__SUPER_HEATER1_CAPACITY = FOSSIL_STEAM_SUPPLY__SUPER_HEATER1_CAPACITY;

    /**
     * The feature id for the '<em><b>Super Heater2 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__SUPER_HEATER2_CAPACITY = FOSSIL_STEAM_SUPPLY__SUPER_HEATER2_CAPACITY;

    /**
     * The feature id for the '<em><b>Super Heater Pipe PD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__SUPER_HEATER_PIPE_PD = FOSSIL_STEAM_SUPPLY__SUPER_HEATER_PIPE_PD;

    /**
     * The feature id for the '<em><b>Throttle Pressure SP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL__THROTTLE_PRESSURE_SP = FOSSIL_STEAM_SUPPLY__THROTTLE_PRESSURE_SP;

    /**
     * The number of structural features of the '<em>Subcritical</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL_FEATURE_COUNT = FOSSIL_STEAM_SUPPLY_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Subcritical</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBCRITICAL_OPERATION_COUNT = FOSSIL_STEAM_SUPPLY_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__ID = OPERATIONAL_LIMIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__ALIAS_NAME = OPERATIONAL_LIMIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__DESCRIPTION = OPERATIONAL_LIMIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__MRID = OPERATIONAL_LIMIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__NAME = OPERATIONAL_LIMIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__NAMES = OPERATIONAL_LIMIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__DIAGRAM_OBJECTS = OPERATIONAL_LIMIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Operational Limit Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__OPERATIONAL_LIMIT_TYPE = OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_TYPE;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__OPERATIONAL_LIMIT_SET = OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT__VALUE = OPERATIONAL_LIMIT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Active Power Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT_FEATURE_COUNT = OPERATIONAL_LIMIT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Active Power Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACTIVE_POWER_LIMIT_OPERATION_COUNT = OPERATIONAL_LIMIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__ID = SEASON_DAY_TYPE_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__ALIAS_NAME = SEASON_DAY_TYPE_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__DESCRIPTION = SEASON_DAY_TYPE_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__MRID = SEASON_DAY_TYPE_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__NAME = SEASON_DAY_TYPE_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__NAMES = SEASON_DAY_TYPE_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__DIAGRAM_OBJECTS = SEASON_DAY_TYPE_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__START_TIME = SEASON_DAY_TYPE_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__VALUE1_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__VALUE1_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__VALUE2_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__VALUE2_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__END_TIME = SEASON_DAY_TYPE_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__TIME_STEP = SEASON_DAY_TYPE_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__TIME_POINTS = SEASON_DAY_TYPE_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Day Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__DAY_TYPE = SEASON_DAY_TYPE_SCHEDULE__DAY_TYPE;

    /**
     * The feature id for the '<em><b>Season</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__SEASON = SEASON_DAY_TYPE_SCHEDULE__SEASON;

    /**
     * The feature id for the '<em><b>Voltage Control Zones</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__VOLTAGE_CONTROL_ZONES = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE__REGULATING_CONTROL = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Regulation Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE_FEATURE_COUNT = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Regulation Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULATION_SCHEDULE_OPERATION_COUNT = SEASON_DAY_TYPE_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The number of structural features of the '<em>Ground</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Ground</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR__R = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Earth Fault Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Earth Fault Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EARTH_FAULT_COMPENSATOR_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__ID = EARTH_FAULT_COMPENSATOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__ALIAS_NAME = EARTH_FAULT_COMPENSATOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__DESCRIPTION = EARTH_FAULT_COMPENSATOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__MRID = EARTH_FAULT_COMPENSATOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__NAME = EARTH_FAULT_COMPENSATOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__NAMES = EARTH_FAULT_COMPENSATOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__DIAGRAM_OBJECTS = EARTH_FAULT_COMPENSATOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__MEASUREMENTS = EARTH_FAULT_COMPENSATOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__CONTROLS = EARTH_FAULT_COMPENSATOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__OPERATING_SHARE = EARTH_FAULT_COMPENSATOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__PSR_TYPE = EARTH_FAULT_COMPENSATOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__AGGREGATE = EARTH_FAULT_COMPENSATOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__NORMALLY_IN_SERVICE = EARTH_FAULT_COMPENSATOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__CONTINGENCY_EQUIPMENT = EARTH_FAULT_COMPENSATOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__OPERATIONAL_LIMIT_SET = EARTH_FAULT_COMPENSATOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__FAULTS = EARTH_FAULT_COMPENSATOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__EQUIPMENT_CONTAINER = EARTH_FAULT_COMPENSATOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__PROTECTION_EQUIPMENTS = EARTH_FAULT_COMPENSATOR__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__BASE_VOLTAGE = EARTH_FAULT_COMPENSATOR__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__SV_STATUS = EARTH_FAULT_COMPENSATOR__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__TERMINALS = EARTH_FAULT_COMPENSATOR__TERMINALS;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__R = EARTH_FAULT_COMPENSATOR__R;

    /**
     * The feature id for the '<em><b>Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__MODE = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Nominal U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__NOMINAL_U = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Offset Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__OFFSET_CURRENT = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Position Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__POSITION_CURRENT = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>XGround Max</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__XGROUND_MAX = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>XGround Min</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__XGROUND_MIN = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>XGround Nominal</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL__XGROUND_NOMINAL = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Petersen Coil</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL_FEATURE_COUNT = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Petersen Coil</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PETERSEN_COIL_OPERATION_COUNT = EARTH_FAULT_COMPENSATOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE__GENERATING_UNIT = CURVE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Gross To Net Active Power Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Gross To Net Active Power Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROSS_TO_NET_ACTIVE_POWER_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Vs Converter DC Sides</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE__VS_CONVERTER_DC_SIDES = CURVE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Vs Capability Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Vs Capability Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CAPABILITY_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Length From Terminal1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__LENGTH_FROM_TERMINAL1 = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>AC Line Segment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP__AC_LINE_SEGMENT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Clamp</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Clamp</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CLAMP_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>High Level Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__HIGH_LEVEL_LIMIT = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Low Level Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__LOW_LEVEL_LIMIT = CURVE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Reservoir</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE__RESERVOIR = CURVE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Target Level Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Target Level Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TARGET_LEVEL_SCHEDULE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__ID = EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__ALIAS_NAME = EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__DESCRIPTION = EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__MRID = EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__NAME = EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__NAMES = EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__DIAGRAM_OBJECTS = EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__MEASUREMENTS = EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__CONTROLS = EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__OPERATING_SHARE = EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__PSR_TYPE = EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__AGGREGATE = EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__NORMALLY_IN_SERVICE = EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__CONTINGENCY_EQUIPMENT = EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__OPERATIONAL_LIMIT_SET = EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__FAULTS = EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__EQUIPMENT_CONTAINER = EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Power Transformer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__POWER_TRANSFORMER = EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Transformer Tank Ends</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK__TRANSFORMER_TANK_ENDS = EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Transformer Tank</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Transformer Tank</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_TANK_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__ID = REGULAR_INTERVAL_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__ALIAS_NAME = REGULAR_INTERVAL_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__DESCRIPTION = REGULAR_INTERVAL_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__MRID = REGULAR_INTERVAL_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__NAME = REGULAR_INTERVAL_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__NAMES = REGULAR_INTERVAL_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__DIAGRAM_OBJECTS = REGULAR_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__START_TIME = REGULAR_INTERVAL_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__VALUE1_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__VALUE1_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__VALUE2_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__VALUE2_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__END_TIME = REGULAR_INTERVAL_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__TIME_STEP = REGULAR_INTERVAL_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__TIME_POINTS = REGULAR_INTERVAL_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE__GENERATING_UNIT = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Gen Unit Op Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE_FEATURE_COUNT = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Gen Unit Op Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEN_UNIT_OP_SCHEDULE_OPERATION_COUNT = REGULAR_INTERVAL_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__ID = DC_BASE_TERMINAL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__ALIAS_NAME = DC_BASE_TERMINAL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__DESCRIPTION = DC_BASE_TERMINAL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__MRID = DC_BASE_TERMINAL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__NAME = DC_BASE_TERMINAL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__NAMES = DC_BASE_TERMINAL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__DIAGRAM_OBJECTS = DC_BASE_TERMINAL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Connected</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__CONNECTED = DC_BASE_TERMINAL__CONNECTED;

    /**
     * The feature id for the '<em><b>Sequence Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__SEQUENCE_NUMBER = DC_BASE_TERMINAL__SEQUENCE_NUMBER;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__MEASUREMENTS = DC_BASE_TERMINAL__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Bus Name Marker</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__BUS_NAME_MARKER = DC_BASE_TERMINAL__BUS_NAME_MARKER;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__OPERATIONAL_LIMIT_SET = DC_BASE_TERMINAL__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>DC Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__DC_NODE = DC_BASE_TERMINAL__DC_NODE;

    /**
     * The feature id for the '<em><b>DC Topological Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__DC_TOPOLOGICAL_NODE = DC_BASE_TERMINAL__DC_TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Polarity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__POLARITY = DC_BASE_TERMINAL_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>DC Conducting Equipment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL__DC_CONDUCTING_EQUIPMENT = DC_BASE_TERMINAL_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>ACDC Converter DC Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL_FEATURE_COUNT = DC_BASE_TERMINAL_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>ACDC Converter DC Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACDC_CONVERTER_DC_TERMINAL_OPERATION_COUNT = DC_BASE_TERMINAL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Drawing Order</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__DRAWING_ORDER = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Is Polygon</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__IS_POLYGON = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Offset X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__OFFSET_X = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Offset Y</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__OFFSET_Y = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Rotation</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__ROTATION = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Visibility Layers</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__VISIBILITY_LAYERS = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Identified Object</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__IDENTIFIED_OBJECT = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Diagram</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__DIAGRAM = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Diagram Object Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__DIAGRAM_OBJECT_POINTS = IDENTIFIED_OBJECT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Diagram Object Style</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT__DIAGRAM_OBJECT_STYLE = IDENTIFIED_OBJECT_FEATURE_COUNT + 9;

    /**
     * The number of structural features of the '<em>Diagram Object</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 10;

    /**
     * The number of operations of the '<em>Diagram Object</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__ID = DIAGRAM_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__ALIAS_NAME = DIAGRAM_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__DESCRIPTION = DIAGRAM_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__MRID = DIAGRAM_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__NAME = DIAGRAM_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__NAMES = DIAGRAM_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__DIAGRAM_OBJECTS = DIAGRAM_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Drawing Order</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__DRAWING_ORDER = DIAGRAM_OBJECT__DRAWING_ORDER;

    /**
     * The feature id for the '<em><b>Is Polygon</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__IS_POLYGON = DIAGRAM_OBJECT__IS_POLYGON;

    /**
     * The feature id for the '<em><b>Offset X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__OFFSET_X = DIAGRAM_OBJECT__OFFSET_X;

    /**
     * The feature id for the '<em><b>Offset Y</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__OFFSET_Y = DIAGRAM_OBJECT__OFFSET_Y;

    /**
     * The feature id for the '<em><b>Rotation</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__ROTATION = DIAGRAM_OBJECT__ROTATION;

    /**
     * The feature id for the '<em><b>Visibility Layers</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__VISIBILITY_LAYERS = DIAGRAM_OBJECT__VISIBILITY_LAYERS;

    /**
     * The feature id for the '<em><b>Identified Object</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__IDENTIFIED_OBJECT = DIAGRAM_OBJECT__IDENTIFIED_OBJECT;

    /**
     * The feature id for the '<em><b>Diagram</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__DIAGRAM = DIAGRAM_OBJECT__DIAGRAM;

    /**
     * The feature id for the '<em><b>Diagram Object Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__DIAGRAM_OBJECT_POINTS = DIAGRAM_OBJECT__DIAGRAM_OBJECT_POINTS;

    /**
     * The feature id for the '<em><b>Diagram Object Style</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__DIAGRAM_OBJECT_STYLE = DIAGRAM_OBJECT__DIAGRAM_OBJECT_STYLE;

    /**
     * The feature id for the '<em><b>Text</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT__TEXT = DIAGRAM_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Text Diagram Object</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT_FEATURE_COUNT = DIAGRAM_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Text Diagram Object</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TEXT_DIAGRAM_OBJECT_OPERATION_COUNT = DIAGRAM_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_SHUNT_COMPENSATOR_SECTIONS__ID = STATE_VARIABLE__ID;

    /**
     * The feature id for the '<em><b>Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_SHUNT_COMPENSATOR_SECTIONS__SECTIONS = STATE_VARIABLE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Shunt Compensator</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_SHUNT_COMPENSATOR_SECTIONS__SHUNT_COMPENSATOR = STATE_VARIABLE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Sv Shunt Compensator Sections</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_SHUNT_COMPENSATOR_SECTIONS_FEATURE_COUNT = STATE_VARIABLE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Sv Shunt Compensator Sections</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_SHUNT_COMPENSATOR_SECTIONS_OPERATION_COUNT = STATE_VARIABLE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Ignition Fuel Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__IGNITION_FUEL_TYPE = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Startup Model</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE__STARTUP_MODEL = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Start Ign Fuel Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Start Ign Fuel Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_IGN_FUEL_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_POINT__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Sequence Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_POINT__SEQUENCE_NUMBER = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>XPosition</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_POINT__XPOSITION = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>YPosition</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_POINT__YPOSITION = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>ZPosition</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_POINT__ZPOSITION = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Diagram Object</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_POINT__DIAGRAM_OBJECT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Diagram Object Glue Point</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_POINT__DIAGRAM_OBJECT_GLUE_POINT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Diagram Object Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_POINT_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Diagram Object Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_POINT_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_SHARE__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Percentage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_SHARE__PERCENTAGE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_SHARE__POWER_SYSTEM_RESOURCE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Operating Participant</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_SHARE__OPERATING_PARTICIPANT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Operating Share</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_SHARE_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Operating Share</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATING_SHARE_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>B</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT__B = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>B0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT__B0 = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>G</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT__G = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>G0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT__G0 = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Section Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT__SECTION_NUMBER = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Nonlinear Shunt Compensator</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT__NONLINEAR_SHUNT_COMPENSATOR = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Nonlinear Shunt Compensator Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Nonlinear Shunt Compensator Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_POINT_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__ID = LIMIT_SET__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__ALIAS_NAME = LIMIT_SET__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__DESCRIPTION = LIMIT_SET__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__MRID = LIMIT_SET__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__NAME = LIMIT_SET__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__NAMES = LIMIT_SET__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__DIAGRAM_OBJECTS = LIMIT_SET__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Is Percentage Limits</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__IS_PERCENTAGE_LIMITS = LIMIT_SET__IS_PERCENTAGE_LIMITS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__MEASUREMENTS = LIMIT_SET_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Limits</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET__LIMITS = LIMIT_SET_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Analog Limit Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET_FEATURE_COUNT = LIMIT_SET_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Analog Limit Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_SET_OPERATION_COUNT = LIMIT_SET_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Must Study</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY__MUST_STUDY = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Contingency Element</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY__CONTINGENCY_ELEMENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Contingency</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Contingency</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTINGENCY_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__ID = DC_BASE_TERMINAL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__ALIAS_NAME = DC_BASE_TERMINAL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__DESCRIPTION = DC_BASE_TERMINAL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__MRID = DC_BASE_TERMINAL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__NAME = DC_BASE_TERMINAL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__NAMES = DC_BASE_TERMINAL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__DIAGRAM_OBJECTS = DC_BASE_TERMINAL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Connected</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__CONNECTED = DC_BASE_TERMINAL__CONNECTED;

    /**
     * The feature id for the '<em><b>Sequence Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__SEQUENCE_NUMBER = DC_BASE_TERMINAL__SEQUENCE_NUMBER;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__MEASUREMENTS = DC_BASE_TERMINAL__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Bus Name Marker</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__BUS_NAME_MARKER = DC_BASE_TERMINAL__BUS_NAME_MARKER;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__OPERATIONAL_LIMIT_SET = DC_BASE_TERMINAL__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>DC Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__DC_NODE = DC_BASE_TERMINAL__DC_NODE;

    /**
     * The feature id for the '<em><b>DC Topological Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__DC_TOPOLOGICAL_NODE = DC_BASE_TERMINAL__DC_TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>DC Conducting Equipment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL__DC_CONDUCTING_EQUIPMENT = DC_BASE_TERMINAL_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>DC Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL_FEATURE_COUNT = DC_BASE_TERMINAL_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>DC Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TERMINAL_OPERATION_COUNT = DC_BASE_TERMINAL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__ID = PHASE_TAP_CHANGER_NON_LINEAR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__ALIAS_NAME = PHASE_TAP_CHANGER_NON_LINEAR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__DESCRIPTION = PHASE_TAP_CHANGER_NON_LINEAR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__MRID = PHASE_TAP_CHANGER_NON_LINEAR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__NAME = PHASE_TAP_CHANGER_NON_LINEAR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__NAMES = PHASE_TAP_CHANGER_NON_LINEAR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__DIAGRAM_OBJECTS = PHASE_TAP_CHANGER_NON_LINEAR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__MEASUREMENTS = PHASE_TAP_CHANGER_NON_LINEAR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__CONTROLS = PHASE_TAP_CHANGER_NON_LINEAR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__OPERATING_SHARE = PHASE_TAP_CHANGER_NON_LINEAR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__PSR_TYPE = PHASE_TAP_CHANGER_NON_LINEAR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__CONTROL_ENABLED = PHASE_TAP_CHANGER_NON_LINEAR__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>High Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__HIGH_STEP = PHASE_TAP_CHANGER_NON_LINEAR__HIGH_STEP;

    /**
     * The feature id for the '<em><b>Initial Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__INITIAL_DELAY = PHASE_TAP_CHANGER_NON_LINEAR__INITIAL_DELAY;

    /**
     * The feature id for the '<em><b>Low Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__LOW_STEP = PHASE_TAP_CHANGER_NON_LINEAR__LOW_STEP;

    /**
     * The feature id for the '<em><b>Ltc Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__LTC_FLAG = PHASE_TAP_CHANGER_NON_LINEAR__LTC_FLAG;

    /**
     * The feature id for the '<em><b>Neutral Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__NEUTRAL_STEP = PHASE_TAP_CHANGER_NON_LINEAR__NEUTRAL_STEP;

    /**
     * The feature id for the '<em><b>Neutral U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__NEUTRAL_U = PHASE_TAP_CHANGER_NON_LINEAR__NEUTRAL_U;

    /**
     * The feature id for the '<em><b>Normal Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__NORMAL_STEP = PHASE_TAP_CHANGER_NON_LINEAR__NORMAL_STEP;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__STEP = PHASE_TAP_CHANGER_NON_LINEAR__STEP;

    /**
     * The feature id for the '<em><b>Subsequent Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__SUBSEQUENT_DELAY = PHASE_TAP_CHANGER_NON_LINEAR__SUBSEQUENT_DELAY;

    /**
     * The feature id for the '<em><b>Sv Tap Step</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__SV_TAP_STEP = PHASE_TAP_CHANGER_NON_LINEAR__SV_TAP_STEP;

    /**
     * The feature id for the '<em><b>Tap Changer Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__TAP_CHANGER_CONTROL = PHASE_TAP_CHANGER_NON_LINEAR__TAP_CHANGER_CONTROL;

    /**
     * The feature id for the '<em><b>Tap Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__TAP_SCHEDULES = PHASE_TAP_CHANGER_NON_LINEAR__TAP_SCHEDULES;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__TRANSFORMER_END = PHASE_TAP_CHANGER_NON_LINEAR__TRANSFORMER_END;

    /**
     * The feature id for the '<em><b>Voltage Step Increment</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__VOLTAGE_STEP_INCREMENT = PHASE_TAP_CHANGER_NON_LINEAR__VOLTAGE_STEP_INCREMENT;

    /**
     * The feature id for the '<em><b>XMax</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__XMAX = PHASE_TAP_CHANGER_NON_LINEAR__XMAX;

    /**
     * The feature id for the '<em><b>XMin</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL__XMIN = PHASE_TAP_CHANGER_NON_LINEAR__XMIN;

    /**
     * The number of structural features of the '<em>Phase Tap Changer Symmetrical</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL_FEATURE_COUNT = PHASE_TAP_CHANGER_NON_LINEAR_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Phase Tap Changer Symmetrical</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_SYMMETRICAL_OPERATION_COUNT = PHASE_TAP_CHANGER_NON_LINEAR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP_TERMINAL__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Positive Flow In</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP_TERMINAL__POSITIVE_FLOW_IN = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP_TERMINAL__TERMINAL = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Branch Group</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP_TERMINAL__BRANCH_GROUP = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Branch Group Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP_TERMINAL_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Branch Group Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BRANCH_GROUP_TERMINAL_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Sensor Accuracy</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__SENSOR_ACCURACY = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__TIME_STAMP = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Remote Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__REMOTE_SOURCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Measurement Value Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__MEASUREMENT_VALUE_SOURCE = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Measurement Value Quality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE__MEASUREMENT_VALUE_QUALITY = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Measurement Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Measurement Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__ID = MEASUREMENT_VALUE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__ALIAS_NAME = MEASUREMENT_VALUE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__DESCRIPTION = MEASUREMENT_VALUE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__MRID = MEASUREMENT_VALUE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__NAME = MEASUREMENT_VALUE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__NAMES = MEASUREMENT_VALUE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__DIAGRAM_OBJECTS = MEASUREMENT_VALUE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Sensor Accuracy</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__SENSOR_ACCURACY = MEASUREMENT_VALUE__SENSOR_ACCURACY;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__TIME_STAMP = MEASUREMENT_VALUE__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Remote Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__REMOTE_SOURCE = MEASUREMENT_VALUE__REMOTE_SOURCE;

    /**
     * The feature id for the '<em><b>Measurement Value Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__MEASUREMENT_VALUE_SOURCE = MEASUREMENT_VALUE__MEASUREMENT_VALUE_SOURCE;

    /**
     * The feature id for the '<em><b>Measurement Value Quality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__MEASUREMENT_VALUE_QUALITY = MEASUREMENT_VALUE__MEASUREMENT_VALUE_QUALITY;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__VALUE = MEASUREMENT_VALUE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Discrete</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__DISCRETE = MEASUREMENT_VALUE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Command</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE__COMMAND = MEASUREMENT_VALUE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Discrete Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE_FEATURE_COUNT = MEASUREMENT_VALUE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Discrete Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_VALUE_OPERATION_COUNT = MEASUREMENT_VALUE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__ID = REGULATING_COND_EQ__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__ALIAS_NAME = REGULATING_COND_EQ__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__DESCRIPTION = REGULATING_COND_EQ__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__MRID = REGULATING_COND_EQ__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__NAME = REGULATING_COND_EQ__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__NAMES = REGULATING_COND_EQ__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__DIAGRAM_OBJECTS = REGULATING_COND_EQ__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__MEASUREMENTS = REGULATING_COND_EQ__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__CONTROLS = REGULATING_COND_EQ__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__OPERATING_SHARE = REGULATING_COND_EQ__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__PSR_TYPE = REGULATING_COND_EQ__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__AGGREGATE = REGULATING_COND_EQ__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__NORMALLY_IN_SERVICE = REGULATING_COND_EQ__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__CONTINGENCY_EQUIPMENT = REGULATING_COND_EQ__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__OPERATIONAL_LIMIT_SET = REGULATING_COND_EQ__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__FAULTS = REGULATING_COND_EQ__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__EQUIPMENT_CONTAINER = REGULATING_COND_EQ__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__PROTECTION_EQUIPMENTS = REGULATING_COND_EQ__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__BASE_VOLTAGE = REGULATING_COND_EQ__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__SV_STATUS = REGULATING_COND_EQ__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__TERMINALS = REGULATING_COND_EQ__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__CONTROL_ENABLED = REGULATING_COND_EQ__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__REGULATING_CONTROL = REGULATING_COND_EQ__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>Capacitive Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__CAPACITIVE_RATING = REGULATING_COND_EQ_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Inductive Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__INDUCTIVE_RATING = REGULATING_COND_EQ_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__Q = REGULATING_COND_EQ_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Slope</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__SLOPE = REGULATING_COND_EQ_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>SVC Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__SVC_CONTROL_MODE = REGULATING_COND_EQ_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Voltage Set Point</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR__VOLTAGE_SET_POINT = REGULATING_COND_EQ_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Static Var Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR_FEATURE_COUNT = REGULATING_COND_EQ_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Static Var Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATIC_VAR_COMPENSATOR_OPERATION_COUNT = REGULATING_COND_EQ_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_GENERATING_UNIT_MEAS__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Priority</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_GENERATING_UNIT_MEAS__PRIORITY = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Analog Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_GENERATING_UNIT_MEAS__ANALOG_VALUE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Control Area Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_GENERATING_UNIT_MEAS__CONTROL_AREA_GENERATING_UNIT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Alt Generating Unit Meas</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_GENERATING_UNIT_MEAS_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Alt Generating Unit Meas</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ALT_GENERATING_UNIT_MEAS_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__ID = REGULATING_COND_EQ__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__ALIAS_NAME = REGULATING_COND_EQ__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__DESCRIPTION = REGULATING_COND_EQ__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__MRID = REGULATING_COND_EQ__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__NAME = REGULATING_COND_EQ__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__NAMES = REGULATING_COND_EQ__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__DIAGRAM_OBJECTS = REGULATING_COND_EQ__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__MEASUREMENTS = REGULATING_COND_EQ__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__CONTROLS = REGULATING_COND_EQ__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__OPERATING_SHARE = REGULATING_COND_EQ__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__PSR_TYPE = REGULATING_COND_EQ__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__AGGREGATE = REGULATING_COND_EQ__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__NORMALLY_IN_SERVICE = REGULATING_COND_EQ__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__CONTINGENCY_EQUIPMENT = REGULATING_COND_EQ__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__OPERATIONAL_LIMIT_SET = REGULATING_COND_EQ__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__FAULTS = REGULATING_COND_EQ__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__EQUIPMENT_CONTAINER = REGULATING_COND_EQ__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__PROTECTION_EQUIPMENTS = REGULATING_COND_EQ__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__BASE_VOLTAGE = REGULATING_COND_EQ__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__SV_STATUS = REGULATING_COND_EQ__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__TERMINALS = REGULATING_COND_EQ__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__CONTROL_ENABLED = REGULATING_COND_EQ__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__REGULATING_CONTROL = REGULATING_COND_EQ__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>AVR Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__AVR_DELAY = REGULATING_COND_EQ_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__GROUNDED = REGULATING_COND_EQ_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Maximum Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__MAXIMUM_SECTIONS = REGULATING_COND_EQ_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Nom U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__NOM_U = REGULATING_COND_EQ_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Normal Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__NORMAL_SECTIONS = REGULATING_COND_EQ_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Phase Connection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__PHASE_CONNECTION = REGULATING_COND_EQ_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__SECTIONS = REGULATING_COND_EQ_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__SWITCH_ON_COUNT = REGULATING_COND_EQ_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__SWITCH_ON_DATE = REGULATING_COND_EQ_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Voltage Sensitivity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__VOLTAGE_SENSITIVITY = REGULATING_COND_EQ_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Shunt Compensator Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__SHUNT_COMPENSATOR_PHASE = REGULATING_COND_EQ_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Sv Shunt Compensator Sections</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR__SV_SHUNT_COMPENSATOR_SECTIONS = REGULATING_COND_EQ_FEATURE_COUNT + 11;

    /**
     * The number of structural features of the '<em>Shunt Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_FEATURE_COUNT = REGULATING_COND_EQ_FEATURE_COUNT + 12;

    /**
     * The number of operations of the '<em>Shunt Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUNT_COMPENSATOR_OPERATION_COUNT = REGULATING_COND_EQ_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__ID = SHUNT_COMPENSATOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__ALIAS_NAME = SHUNT_COMPENSATOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__DESCRIPTION = SHUNT_COMPENSATOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__MRID = SHUNT_COMPENSATOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__NAME = SHUNT_COMPENSATOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__NAMES = SHUNT_COMPENSATOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__DIAGRAM_OBJECTS = SHUNT_COMPENSATOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__MEASUREMENTS = SHUNT_COMPENSATOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__CONTROLS = SHUNT_COMPENSATOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__OPERATING_SHARE = SHUNT_COMPENSATOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__PSR_TYPE = SHUNT_COMPENSATOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__AGGREGATE = SHUNT_COMPENSATOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__NORMALLY_IN_SERVICE = SHUNT_COMPENSATOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__CONTINGENCY_EQUIPMENT = SHUNT_COMPENSATOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__OPERATIONAL_LIMIT_SET = SHUNT_COMPENSATOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__FAULTS = SHUNT_COMPENSATOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__EQUIPMENT_CONTAINER = SHUNT_COMPENSATOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__PROTECTION_EQUIPMENTS = SHUNT_COMPENSATOR__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__BASE_VOLTAGE = SHUNT_COMPENSATOR__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__SV_STATUS = SHUNT_COMPENSATOR__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__TERMINALS = SHUNT_COMPENSATOR__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__CONTROL_ENABLED = SHUNT_COMPENSATOR__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__REGULATING_CONTROL = SHUNT_COMPENSATOR__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>AVR Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__AVR_DELAY = SHUNT_COMPENSATOR__AVR_DELAY;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__GROUNDED = SHUNT_COMPENSATOR__GROUNDED;

    /**
     * The feature id for the '<em><b>Maximum Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__MAXIMUM_SECTIONS = SHUNT_COMPENSATOR__MAXIMUM_SECTIONS;

    /**
     * The feature id for the '<em><b>Nom U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__NOM_U = SHUNT_COMPENSATOR__NOM_U;

    /**
     * The feature id for the '<em><b>Normal Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__NORMAL_SECTIONS = SHUNT_COMPENSATOR__NORMAL_SECTIONS;

    /**
     * The feature id for the '<em><b>Phase Connection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__PHASE_CONNECTION = SHUNT_COMPENSATOR__PHASE_CONNECTION;

    /**
     * The feature id for the '<em><b>Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__SECTIONS = SHUNT_COMPENSATOR__SECTIONS;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__SWITCH_ON_COUNT = SHUNT_COMPENSATOR__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__SWITCH_ON_DATE = SHUNT_COMPENSATOR__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Voltage Sensitivity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__VOLTAGE_SENSITIVITY = SHUNT_COMPENSATOR__VOLTAGE_SENSITIVITY;

    /**
     * The feature id for the '<em><b>Shunt Compensator Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__SHUNT_COMPENSATOR_PHASE = SHUNT_COMPENSATOR__SHUNT_COMPENSATOR_PHASE;

    /**
     * The feature id for the '<em><b>Sv Shunt Compensator Sections</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__SV_SHUNT_COMPENSATOR_SECTIONS = SHUNT_COMPENSATOR__SV_SHUNT_COMPENSATOR_SECTIONS;

    /**
     * The feature id for the '<em><b>Nonlinear Shunt Compensator Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR__NONLINEAR_SHUNT_COMPENSATOR_POINTS = SHUNT_COMPENSATOR_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Nonlinear Shunt Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_FEATURE_COUNT = SHUNT_COMPENSATOR_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Nonlinear Shunt Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_OPERATION_COUNT = SHUNT_COMPENSATOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__ID = SEASON_DAY_TYPE_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__ALIAS_NAME = SEASON_DAY_TYPE_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__DESCRIPTION = SEASON_DAY_TYPE_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__MRID = SEASON_DAY_TYPE_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__NAME = SEASON_DAY_TYPE_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__NAMES = SEASON_DAY_TYPE_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__DIAGRAM_OBJECTS = SEASON_DAY_TYPE_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__START_TIME = SEASON_DAY_TYPE_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__VALUE1_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__VALUE1_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__VALUE2_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__VALUE2_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__END_TIME = SEASON_DAY_TYPE_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__TIME_STEP = SEASON_DAY_TYPE_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__TIME_POINTS = SEASON_DAY_TYPE_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Day Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__DAY_TYPE = SEASON_DAY_TYPE_SCHEDULE__DAY_TYPE;

    /**
     * The feature id for the '<em><b>Season</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__SEASON = SEASON_DAY_TYPE_SCHEDULE__SEASON;

    /**
     * The feature id for the '<em><b>Conform Load Group</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE__CONFORM_LOAD_GROUP = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Conform Load Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE_FEATURE_COUNT = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Conform Load Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_SCHEDULE_OPERATION_COUNT = SEASON_DAY_TYPE_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Styled Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE__STYLED_OBJECTS = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Diagram Object Style</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Diagram Object Style</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_STYLE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__ID = CONNECTOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__ALIAS_NAME = CONNECTOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__DESCRIPTION = CONNECTOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__MRID = CONNECTOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__NAME = CONNECTOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__NAMES = CONNECTOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__DIAGRAM_OBJECTS = CONNECTOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__MEASUREMENTS = CONNECTOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__CONTROLS = CONNECTOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__OPERATING_SHARE = CONNECTOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__PSR_TYPE = CONNECTOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__AGGREGATE = CONNECTOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__NORMALLY_IN_SERVICE = CONNECTOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__CONTINGENCY_EQUIPMENT = CONNECTOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__OPERATIONAL_LIMIT_SET = CONNECTOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__FAULTS = CONNECTOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__EQUIPMENT_CONTAINER = CONNECTOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__PROTECTION_EQUIPMENTS = CONNECTOR__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__BASE_VOLTAGE = CONNECTOR__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__SV_STATUS = CONNECTOR__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__TERMINALS = CONNECTOR__TERMINALS;

    /**
     * The feature id for the '<em><b>Ip Max</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__IP_MAX = CONNECTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Voltage Control Zone</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION__VOLTAGE_CONTROL_ZONE = CONNECTOR_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Busbar Section</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION_FEATURE_COUNT = CONNECTOR_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Busbar Section</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUSBAR_SECTION_OPERATION_COUNT = CONNECTOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__ID = CONNECTIVITY_NODE_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__ALIAS_NAME = CONNECTIVITY_NODE_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__DESCRIPTION = CONNECTIVITY_NODE_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__MRID = CONNECTIVITY_NODE_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__NAME = CONNECTIVITY_NODE_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__NAMES = CONNECTIVITY_NODE_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__DIAGRAM_OBJECTS = CONNECTIVITY_NODE_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__MEASUREMENTS = CONNECTIVITY_NODE_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__CONTROLS = CONNECTIVITY_NODE_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__OPERATING_SHARE = CONNECTIVITY_NODE_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__PSR_TYPE = CONNECTIVITY_NODE_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__CONNECTIVITY_NODES = CONNECTIVITY_NODE_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__TOPOLOGICAL_NODE = CONNECTIVITY_NODE_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equivalent Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK__EQUIVALENT_EQUIPMENTS = CONNECTIVITY_NODE_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Equivalent Network</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK_FEATURE_COUNT = CONNECTIVITY_NODE_CONTAINER_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Equivalent Network</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_NETWORK_OPERATION_COUNT = CONNECTIVITY_NODE_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__ID = PROTECTION_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__ALIAS_NAME = PROTECTION_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__DESCRIPTION = PROTECTION_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__MRID = PROTECTION_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__NAME = PROTECTION_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__NAMES = PROTECTION_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__DIAGRAM_OBJECTS = PROTECTION_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__MEASUREMENTS = PROTECTION_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__CONTROLS = PROTECTION_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__OPERATING_SHARE = PROTECTION_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__PSR_TYPE = PROTECTION_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__AGGREGATE = PROTECTION_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__NORMALLY_IN_SERVICE = PROTECTION_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__CONTINGENCY_EQUIPMENT = PROTECTION_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__OPERATIONAL_LIMIT_SET = PROTECTION_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__FAULTS = PROTECTION_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__EQUIPMENT_CONTAINER = PROTECTION_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>High Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__HIGH_LIMIT = PROTECTION_EQUIPMENT__HIGH_LIMIT;

    /**
     * The feature id for the '<em><b>Low Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__LOW_LIMIT = PROTECTION_EQUIPMENT__LOW_LIMIT;

    /**
     * The feature id for the '<em><b>Power Direction Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__POWER_DIRECTION_FLAG = PROTECTION_EQUIPMENT__POWER_DIRECTION_FLAG;

    /**
     * The feature id for the '<em><b>Relay Delay Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__RELAY_DELAY_TIME = PROTECTION_EQUIPMENT__RELAY_DELAY_TIME;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__UNIT_MULTIPLIER = PROTECTION_EQUIPMENT__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__UNIT_SYMBOL = PROTECTION_EQUIPMENT__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Conducting Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__CONDUCTING_EQUIPMENTS = PROTECTION_EQUIPMENT__CONDUCTING_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Protected Switches</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__PROTECTED_SWITCHES = PROTECTION_EQUIPMENT__PROTECTED_SWITCHES;

    /**
     * The feature id for the '<em><b>Current Limit1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__CURRENT_LIMIT1 = PROTECTION_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Current Limit2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__CURRENT_LIMIT2 = PROTECTION_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Current Limit3</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__CURRENT_LIMIT3 = PROTECTION_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Inverse Time Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__INVERSE_TIME_FLAG = PROTECTION_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Time Delay1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__TIME_DELAY1 = PROTECTION_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Time Delay2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__TIME_DELAY2 = PROTECTION_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Time Delay3</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY__TIME_DELAY3 = PROTECTION_EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Current Relay</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY_FEATURE_COUNT = PROTECTION_EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Current Relay</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURRENT_RELAY_OPERATION_COUNT = PROTECTION_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Reservoir</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE__RESERVOIR = CURVE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Level Vs Volume Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Level Vs Volume Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LEVEL_VS_VOLUME_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE_AUTHORITY__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE_AUTHORITY__DESCRIPTION = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE_AUTHORITY__NAME = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Name Types</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE_AUTHORITY__NAME_TYPES = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Name Type Authority</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE_AUTHORITY_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Name Type Authority</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE_AUTHORITY_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__ID = EQUIPMENT_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__ALIAS_NAME = EQUIPMENT_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__DESCRIPTION = EQUIPMENT_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__MRID = EQUIPMENT_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__NAME = EQUIPMENT_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__NAMES = EQUIPMENT_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__DIAGRAM_OBJECTS = EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__MEASUREMENTS = EQUIPMENT_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__CONTROLS = EQUIPMENT_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__OPERATING_SHARE = EQUIPMENT_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__PSR_TYPE = EQUIPMENT_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__CONNECTIVITY_NODES = EQUIPMENT_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__TOPOLOGICAL_NODE = EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT__EQUIPMENTS = EQUIPMENT_CONTAINER__EQUIPMENTS;

    /**
     * The number of structural features of the '<em>Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT_FEATURE_COUNT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PLANT_OPERATION_COUNT = EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_DATA__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Xvalue</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_DATA__XVALUE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Y1value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_DATA__Y1VALUE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Y2value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_DATA__Y2VALUE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Y3value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_DATA__Y3VALUE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_DATA__CURVE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Curve Data</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_DATA_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Curve Data</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CURVE_DATA_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__ID = PHASE_TAP_CHANGER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__ALIAS_NAME = PHASE_TAP_CHANGER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__DESCRIPTION = PHASE_TAP_CHANGER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__MRID = PHASE_TAP_CHANGER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__NAME = PHASE_TAP_CHANGER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__NAMES = PHASE_TAP_CHANGER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__DIAGRAM_OBJECTS = PHASE_TAP_CHANGER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__MEASUREMENTS = PHASE_TAP_CHANGER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__CONTROLS = PHASE_TAP_CHANGER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__OPERATING_SHARE = PHASE_TAP_CHANGER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__PSR_TYPE = PHASE_TAP_CHANGER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__CONTROL_ENABLED = PHASE_TAP_CHANGER__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>High Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__HIGH_STEP = PHASE_TAP_CHANGER__HIGH_STEP;

    /**
     * The feature id for the '<em><b>Initial Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__INITIAL_DELAY = PHASE_TAP_CHANGER__INITIAL_DELAY;

    /**
     * The feature id for the '<em><b>Low Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__LOW_STEP = PHASE_TAP_CHANGER__LOW_STEP;

    /**
     * The feature id for the '<em><b>Ltc Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__LTC_FLAG = PHASE_TAP_CHANGER__LTC_FLAG;

    /**
     * The feature id for the '<em><b>Neutral Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__NEUTRAL_STEP = PHASE_TAP_CHANGER__NEUTRAL_STEP;

    /**
     * The feature id for the '<em><b>Neutral U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__NEUTRAL_U = PHASE_TAP_CHANGER__NEUTRAL_U;

    /**
     * The feature id for the '<em><b>Normal Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__NORMAL_STEP = PHASE_TAP_CHANGER__NORMAL_STEP;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__STEP = PHASE_TAP_CHANGER__STEP;

    /**
     * The feature id for the '<em><b>Subsequent Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__SUBSEQUENT_DELAY = PHASE_TAP_CHANGER__SUBSEQUENT_DELAY;

    /**
     * The feature id for the '<em><b>Sv Tap Step</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__SV_TAP_STEP = PHASE_TAP_CHANGER__SV_TAP_STEP;

    /**
     * The feature id for the '<em><b>Tap Changer Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__TAP_CHANGER_CONTROL = PHASE_TAP_CHANGER__TAP_CHANGER_CONTROL;

    /**
     * The feature id for the '<em><b>Tap Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__TAP_SCHEDULES = PHASE_TAP_CHANGER__TAP_SCHEDULES;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__TRANSFORMER_END = PHASE_TAP_CHANGER__TRANSFORMER_END;

    /**
     * The feature id for the '<em><b>Step Phase Shift Increment</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__STEP_PHASE_SHIFT_INCREMENT = PHASE_TAP_CHANGER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>XMax</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__XMAX = PHASE_TAP_CHANGER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>XMin</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR__XMIN = PHASE_TAP_CHANGER_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Phase Tap Changer Linear</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR_FEATURE_COUNT = PHASE_TAP_CHANGER_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Phase Tap Changer Linear</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_LINEAR_OPERATION_COUNT = PHASE_TAP_CHANGER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__ID = ANALOG_CONTROL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__ALIAS_NAME = ANALOG_CONTROL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__DESCRIPTION = ANALOG_CONTROL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__MRID = ANALOG_CONTROL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__NAME = ANALOG_CONTROL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__NAMES = ANALOG_CONTROL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__DIAGRAM_OBJECTS = ANALOG_CONTROL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__CONTROL_TYPE = ANALOG_CONTROL__CONTROL_TYPE;

    /**
     * The feature id for the '<em><b>Operation In Progress</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__OPERATION_IN_PROGRESS = ANALOG_CONTROL__OPERATION_IN_PROGRESS;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__TIME_STAMP = ANALOG_CONTROL__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__UNIT_MULTIPLIER = ANALOG_CONTROL__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__UNIT_SYMBOL = ANALOG_CONTROL__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__POWER_SYSTEM_RESOURCE = ANALOG_CONTROL__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>Remote Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__REMOTE_CONTROL = ANALOG_CONTROL__REMOTE_CONTROL;

    /**
     * The feature id for the '<em><b>Max Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__MAX_VALUE = ANALOG_CONTROL__MAX_VALUE;

    /**
     * The feature id for the '<em><b>Min Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__MIN_VALUE = ANALOG_CONTROL__MIN_VALUE;

    /**
     * The feature id for the '<em><b>Analog Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__ANALOG_VALUE = ANALOG_CONTROL__ANALOG_VALUE;

    /**
     * The feature id for the '<em><b>Value Alias Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND__VALUE_ALIAS_SET = ANALOG_CONTROL_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Raise Lower Command</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND_FEATURE_COUNT = ANALOG_CONTROL_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Raise Lower Command</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RAISE_LOWER_COMMAND_OPERATION_COUNT = ANALOG_CONTROL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__ID = DC_EQUIPMENT_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__ALIAS_NAME = DC_EQUIPMENT_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__DESCRIPTION = DC_EQUIPMENT_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__MRID = DC_EQUIPMENT_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__NAME = DC_EQUIPMENT_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__NAMES = DC_EQUIPMENT_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__DIAGRAM_OBJECTS = DC_EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__MEASUREMENTS = DC_EQUIPMENT_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__CONTROLS = DC_EQUIPMENT_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__OPERATING_SHARE = DC_EQUIPMENT_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__PSR_TYPE = DC_EQUIPMENT_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__CONNECTIVITY_NODES = DC_EQUIPMENT_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__TOPOLOGICAL_NODE = DC_EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__EQUIPMENTS = DC_EQUIPMENT_CONTAINER__EQUIPMENTS;

    /**
     * The feature id for the '<em><b>DC Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__DC_NODES = DC_EQUIPMENT_CONTAINER__DC_NODES;

    /**
     * The feature id for the '<em><b>DC Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__DC_TOPOLOGICAL_NODE = DC_EQUIPMENT_CONTAINER__DC_TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Operation Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__OPERATION_MODE = DC_EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Substation</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT__SUBSTATION = DC_EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>DC Converter Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT_FEATURE_COUNT = DC_EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>DC Converter Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CONVERTER_UNIT_OPERATION_COUNT = DC_EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_TIME_POINT__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Sequence Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_TIME_POINT__SEQUENCE_NUMBER = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Value1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_TIME_POINT__VALUE1 = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Value2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_TIME_POINT__VALUE2 = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Interval Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_TIME_POINT__INTERVAL_SCHEDULE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Regular Time Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_TIME_POINT_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Regular Time Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REGULAR_TIME_POINT_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Values</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__VALUES = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Commands</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__COMMANDS = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Raise Lower Commands</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__RAISE_LOWER_COMMANDS = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Discretes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET__DISCRETES = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Value Alias Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Value Alias Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VALUE_ALIAS_SET_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__ID = MEASUREMENT_VALUE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__ALIAS_NAME = MEASUREMENT_VALUE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__DESCRIPTION = MEASUREMENT_VALUE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__MRID = MEASUREMENT_VALUE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__NAME = MEASUREMENT_VALUE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__NAMES = MEASUREMENT_VALUE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__DIAGRAM_OBJECTS = MEASUREMENT_VALUE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Sensor Accuracy</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__SENSOR_ACCURACY = MEASUREMENT_VALUE__SENSOR_ACCURACY;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__TIME_STAMP = MEASUREMENT_VALUE__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Remote Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__REMOTE_SOURCE = MEASUREMENT_VALUE__REMOTE_SOURCE;

    /**
     * The feature id for the '<em><b>Measurement Value Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__MEASUREMENT_VALUE_SOURCE = MEASUREMENT_VALUE__MEASUREMENT_VALUE_SOURCE;

    /**
     * The feature id for the '<em><b>Measurement Value Quality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__MEASUREMENT_VALUE_QUALITY = MEASUREMENT_VALUE__MEASUREMENT_VALUE_QUALITY;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__VALUE = MEASUREMENT_VALUE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Accumulator</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__ACCUMULATOR = MEASUREMENT_VALUE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Accumulator Reset</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE__ACCUMULATOR_RESET = MEASUREMENT_VALUE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Accumulator Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE_FEATURE_COUNT = MEASUREMENT_VALUE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Accumulator Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_VALUE_OPERATION_COUNT = MEASUREMENT_VALUE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__ID = EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__ALIAS_NAME = EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__DESCRIPTION = EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__MRID = EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__NAME = EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__NAMES = EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__DIAGRAM_OBJECTS = EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__MEASUREMENTS = EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__CONTROLS = EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__OPERATING_SHARE = EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__PSR_TYPE = EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__AGGREGATE = EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__NORMALLY_IN_SERVICE = EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__CONTINGENCY_EQUIPMENT = EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__OPERATIONAL_LIMIT_SET = EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__FAULTS = EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__EQUIPMENT_CONTAINER = EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Pump Disch At Max Head</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__PUMP_DISCH_AT_MAX_HEAD = EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Pump Disch At Min Head</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__PUMP_DISCH_AT_MIN_HEAD = EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Pump Power At Max Head</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__PUMP_POWER_AT_MAX_HEAD = EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Pump Power At Min Head</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__PUMP_POWER_AT_MIN_HEAD = EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Hydro Power Plant</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__HYDRO_POWER_PLANT = EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Hydro Pump Op Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__HYDRO_PUMP_OP_SCHEDULE = EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Rotating Machine</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP__ROTATING_MACHINE = EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Hydro Pump</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Hydro Pump</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__ID = DC_CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__ALIAS_NAME = DC_CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__DESCRIPTION = DC_CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__MRID = DC_CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__NAME = DC_CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__NAMES = DC_CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__DIAGRAM_OBJECTS = DC_CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__MEASUREMENTS = DC_CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__CONTROLS = DC_CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__OPERATING_SHARE = DC_CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__PSR_TYPE = DC_CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__AGGREGATE = DC_CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__NORMALLY_IN_SERVICE = DC_CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__CONTINGENCY_EQUIPMENT = DC_CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__OPERATIONAL_LIMIT_SET = DC_CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__FAULTS = DC_CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__EQUIPMENT_CONTAINER = DC_CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH__DC_TERMINALS = DC_CONDUCTING_EQUIPMENT__DC_TERMINALS;

    /**
     * The number of structural features of the '<em>DC Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH_FEATURE_COUNT = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>DC Switch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SWITCH_OPERATION_COUNT = DC_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_POWER_FLOW__ID = STATE_VARIABLE__ID;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_POWER_FLOW__P = STATE_VARIABLE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_POWER_FLOW__Q = STATE_VARIABLE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_POWER_FLOW__TERMINAL = STATE_VARIABLE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Sv Power Flow</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_POWER_FLOW_FEATURE_COUNT = STATE_VARIABLE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Sv Power Flow</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_POWER_FLOW_OPERATION_COUNT = STATE_VARIABLE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__ID = SEASON_DAY_TYPE_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__ALIAS_NAME = SEASON_DAY_TYPE_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__DESCRIPTION = SEASON_DAY_TYPE_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__MRID = SEASON_DAY_TYPE_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__NAME = SEASON_DAY_TYPE_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__NAMES = SEASON_DAY_TYPE_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__DIAGRAM_OBJECTS = SEASON_DAY_TYPE_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__START_TIME = SEASON_DAY_TYPE_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__VALUE1_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__VALUE1_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__VALUE2_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__VALUE2_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__END_TIME = SEASON_DAY_TYPE_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__TIME_STEP = SEASON_DAY_TYPE_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__TIME_POINTS = SEASON_DAY_TYPE_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Day Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__DAY_TYPE = SEASON_DAY_TYPE_SCHEDULE__DAY_TYPE;

    /**
     * The feature id for the '<em><b>Season</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__SEASON = SEASON_DAY_TYPE_SCHEDULE__SEASON;

    /**
     * The feature id for the '<em><b>Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE__SWITCH = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Switch Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE_FEATURE_COUNT = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Switch Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_SCHEDULE_OPERATION_COUNT = SEASON_DAY_TYPE_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT__ID = TAP_CHANGER_TABLE_POINT__ID;

    /**
     * The feature id for the '<em><b>B</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT__B = TAP_CHANGER_TABLE_POINT__B;

    /**
     * The feature id for the '<em><b>G</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT__G = TAP_CHANGER_TABLE_POINT__G;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT__R = TAP_CHANGER_TABLE_POINT__R;

    /**
     * The feature id for the '<em><b>Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT__RATIO = TAP_CHANGER_TABLE_POINT__RATIO;

    /**
     * The feature id for the '<em><b>Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT__STEP = TAP_CHANGER_TABLE_POINT__STEP;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT__X = TAP_CHANGER_TABLE_POINT__X;

    /**
     * The feature id for the '<em><b>Ratio Tap Changer Table</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT__RATIO_TAP_CHANGER_TABLE = TAP_CHANGER_TABLE_POINT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Ratio Tap Changer Table Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT_FEATURE_COUNT = TAP_CHANGER_TABLE_POINT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Ratio Tap Changer Table Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_POINT_OPERATION_COUNT = TAP_CHANGER_TABLE_POINT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Active Storage Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__ACTIVE_STORAGE_CAPACITY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Energy Storage Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__ENERGY_STORAGE_RATING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Full Supply Level</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__FULL_SUPPLY_LEVEL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Gross Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__GROSS_CAPACITY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Normal Min Operate Level</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__NORMAL_MIN_OPERATE_LEVEL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>River Outlet Works</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__RIVER_OUTLET_WORKS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Spill Travel Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__SPILL_TRAVEL_DELAY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Spillway Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__SPILLWAY_CAPACITY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Spillway Crest Length</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__SPILLWAY_CREST_LENGTH = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Spillway Crest Level</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__SPILLWAY_CREST_LEVEL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Spill Way Gate Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__SPILL_WAY_GATE_TYPE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Upstream From Hydro Power Plants</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__UPSTREAM_FROM_HYDRO_POWER_PLANTS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Spills From Reservoir</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__SPILLS_FROM_RESERVOIR = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Spills Into Reservoirs</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__SPILLS_INTO_RESERVOIRS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Inflow Forecasts</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__INFLOW_FORECASTS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Hydro Power Plants</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__HYDRO_POWER_PLANTS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Level Vs Volume Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__LEVEL_VS_VOLUME_CURVES = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>Target Level Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR__TARGET_LEVEL_SCHEDULE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 17;

    /**
     * The number of structural features of the '<em>Reservoir</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 18;

    /**
     * The number of operations of the '<em>Reservoir</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESERVOIR_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__ID = EQUIVALENT_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__ALIAS_NAME = EQUIVALENT_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__DESCRIPTION = EQUIVALENT_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__MRID = EQUIVALENT_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__NAME = EQUIVALENT_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__NAMES = EQUIVALENT_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__DIAGRAM_OBJECTS = EQUIVALENT_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__MEASUREMENTS = EQUIVALENT_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__CONTROLS = EQUIVALENT_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__OPERATING_SHARE = EQUIVALENT_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__PSR_TYPE = EQUIVALENT_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__AGGREGATE = EQUIVALENT_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__NORMALLY_IN_SERVICE = EQUIVALENT_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__CONTINGENCY_EQUIPMENT = EQUIVALENT_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__OPERATIONAL_LIMIT_SET = EQUIVALENT_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__FAULTS = EQUIVALENT_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__EQUIPMENT_CONTAINER = EQUIVALENT_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__PROTECTION_EQUIPMENTS = EQUIVALENT_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__BASE_VOLTAGE = EQUIVALENT_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__SV_STATUS = EQUIVALENT_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__TERMINALS = EQUIVALENT_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Equivalent Network</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__EQUIVALENT_NETWORK = EQUIVALENT_EQUIPMENT__EQUIVALENT_NETWORK;

    /**
     * The feature id for the '<em><b>B</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__B = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>G</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT__G = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Equivalent Shunt</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT_FEATURE_COUNT = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Equivalent Shunt</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_SHUNT_OPERATION_COUNT = EQUIVALENT_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>End Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__END_DATE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Start Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__START_DATE = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Season Day Type Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON__SEASON_DAY_TYPE_SCHEDULES = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Season</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Season</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SEASON_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__R = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__R0 = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Varistor Present</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__VARISTOR_PRESENT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Varistor Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__VARISTOR_RATED_CURRENT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Varistor Voltage Threshold</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__VARISTOR_VOLTAGE_THRESHOLD = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__X = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR__X0 = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Series Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Series Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SERIES_COMPENSATOR_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__ID = FOSSIL_STEAM_SUPPLY__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__ALIAS_NAME = FOSSIL_STEAM_SUPPLY__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__DESCRIPTION = FOSSIL_STEAM_SUPPLY__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__MRID = FOSSIL_STEAM_SUPPLY__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__NAME = FOSSIL_STEAM_SUPPLY__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__NAMES = FOSSIL_STEAM_SUPPLY__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__DIAGRAM_OBJECTS = FOSSIL_STEAM_SUPPLY__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__MEASUREMENTS = FOSSIL_STEAM_SUPPLY__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__CONTROLS = FOSSIL_STEAM_SUPPLY__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__OPERATING_SHARE = FOSSIL_STEAM_SUPPLY__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__PSR_TYPE = FOSSIL_STEAM_SUPPLY__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Steam Supply Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__STEAM_SUPPLY_RATING = FOSSIL_STEAM_SUPPLY__STEAM_SUPPLY_RATING;

    /**
     * The feature id for the '<em><b>Steam Turbines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__STEAM_TURBINES = FOSSIL_STEAM_SUPPLY__STEAM_TURBINES;

    /**
     * The feature id for the '<em><b>Aux Power Versus Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__AUX_POWER_VERSUS_FREQUENCY = FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_FREQUENCY;

    /**
     * The feature id for the '<em><b>Aux Power Versus Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__AUX_POWER_VERSUS_VOLTAGE = FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_VOLTAGE;

    /**
     * The feature id for the '<em><b>Boiler Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__BOILER_CONTROL_MODE = FOSSIL_STEAM_SUPPLY__BOILER_CONTROL_MODE;

    /**
     * The feature id for the '<em><b>Control Error Bias P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__CONTROL_ERROR_BIAS_P = FOSSIL_STEAM_SUPPLY__CONTROL_ERROR_BIAS_P;

    /**
     * The feature id for the '<em><b>Control IC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__CONTROL_IC = FOSSIL_STEAM_SUPPLY__CONTROL_IC;

    /**
     * The feature id for the '<em><b>Control PC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__CONTROL_PC = FOSSIL_STEAM_SUPPLY__CONTROL_PC;

    /**
     * The feature id for the '<em><b>Control PEB</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__CONTROL_PEB = FOSSIL_STEAM_SUPPLY__CONTROL_PEB;

    /**
     * The feature id for the '<em><b>Control PED</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__CONTROL_PED = FOSSIL_STEAM_SUPPLY__CONTROL_PED;

    /**
     * The feature id for the '<em><b>Control TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__CONTROL_TC = FOSSIL_STEAM_SUPPLY__CONTROL_TC;

    /**
     * The feature id for the '<em><b>Feed Water IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__FEED_WATER_IG = FOSSIL_STEAM_SUPPLY__FEED_WATER_IG;

    /**
     * The feature id for the '<em><b>Feed Water PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__FEED_WATER_PG = FOSSIL_STEAM_SUPPLY__FEED_WATER_PG;

    /**
     * The feature id for the '<em><b>Feed Water TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__FEED_WATER_TC = FOSSIL_STEAM_SUPPLY__FEED_WATER_TC;

    /**
     * The feature id for the '<em><b>Fuel Demand Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__FUEL_DEMAND_LIMIT = FOSSIL_STEAM_SUPPLY__FUEL_DEMAND_LIMIT;

    /**
     * The feature id for the '<em><b>Fuel Supply Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__FUEL_SUPPLY_DELAY = FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_DELAY;

    /**
     * The feature id for the '<em><b>Fuel Supply TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__FUEL_SUPPLY_TC = FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_TC;

    /**
     * The feature id for the '<em><b>Max Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__MAX_ERROR_RATE_P = FOSSIL_STEAM_SUPPLY__MAX_ERROR_RATE_P;

    /**
     * The feature id for the '<em><b>Mech Power Sensor Lag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__MECH_POWER_SENSOR_LAG = FOSSIL_STEAM_SUPPLY__MECH_POWER_SENSOR_LAG;

    /**
     * The feature id for the '<em><b>Min Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__MIN_ERROR_RATE_P = FOSSIL_STEAM_SUPPLY__MIN_ERROR_RATE_P;

    /**
     * The feature id for the '<em><b>Pressure Ctrl DG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__PRESSURE_CTRL_DG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_DG;

    /**
     * The feature id for the '<em><b>Pressure Ctrl IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__PRESSURE_CTRL_IG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_IG;

    /**
     * The feature id for the '<em><b>Pressure Ctrl PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__PRESSURE_CTRL_PG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_PG;

    /**
     * The feature id for the '<em><b>Pressure Feedback</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__PRESSURE_FEEDBACK = FOSSIL_STEAM_SUPPLY__PRESSURE_FEEDBACK;

    /**
     * The feature id for the '<em><b>Super Heater1 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__SUPER_HEATER1_CAPACITY = FOSSIL_STEAM_SUPPLY__SUPER_HEATER1_CAPACITY;

    /**
     * The feature id for the '<em><b>Super Heater2 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__SUPER_HEATER2_CAPACITY = FOSSIL_STEAM_SUPPLY__SUPER_HEATER2_CAPACITY;

    /**
     * The feature id for the '<em><b>Super Heater Pipe PD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__SUPER_HEATER_PIPE_PD = FOSSIL_STEAM_SUPPLY__SUPER_HEATER_PIPE_PD;

    /**
     * The feature id for the '<em><b>Throttle Pressure SP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__THROTTLE_PRESSURE_SP = FOSSIL_STEAM_SUPPLY__THROTTLE_PRESSURE_SP;

    /**
     * The feature id for the '<em><b>Steam Supply Rating2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__STEAM_SUPPLY_RATING2 = FOSSIL_STEAM_SUPPLY_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Combustion Turbines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER__COMBUSTION_TURBINES = FOSSIL_STEAM_SUPPLY_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Heat Recovery Boiler</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER_FEATURE_COUNT = FOSSIL_STEAM_SUPPLY_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Heat Recovery Boiler</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RECOVERY_BOILER_OPERATION_COUNT = FOSSIL_STEAM_SUPPLY_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ExternalNetworkInjectionImpl <em>External Network Injection</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.ExternalNetworkInjectionImpl
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getExternalNetworkInjection()
     * @generated
     */
    int EXTERNAL_NETWORK_INJECTION = 177;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__ID = REGULATING_COND_EQ__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__ALIAS_NAME = REGULATING_COND_EQ__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__DESCRIPTION = REGULATING_COND_EQ__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MRID = REGULATING_COND_EQ__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__NAME = REGULATING_COND_EQ__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__NAMES = REGULATING_COND_EQ__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__DIAGRAM_OBJECTS = REGULATING_COND_EQ__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MEASUREMENTS = REGULATING_COND_EQ__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__CONTROLS = REGULATING_COND_EQ__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__OPERATING_SHARE = REGULATING_COND_EQ__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__PSR_TYPE = REGULATING_COND_EQ__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__AGGREGATE = REGULATING_COND_EQ__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__NORMALLY_IN_SERVICE = REGULATING_COND_EQ__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__CONTINGENCY_EQUIPMENT = REGULATING_COND_EQ__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__OPERATIONAL_LIMIT_SET = REGULATING_COND_EQ__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__FAULTS = REGULATING_COND_EQ__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__EQUIPMENT_CONTAINER = REGULATING_COND_EQ__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__PROTECTION_EQUIPMENTS = REGULATING_COND_EQ__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__BASE_VOLTAGE = REGULATING_COND_EQ__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__SV_STATUS = REGULATING_COND_EQ__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__TERMINALS = REGULATING_COND_EQ__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__CONTROL_ENABLED = REGULATING_COND_EQ__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__REGULATING_CONTROL = REGULATING_COND_EQ__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>Governor SCD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__GOVERNOR_SCD = REGULATING_COND_EQ_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Ik Second</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__IK_SECOND = REGULATING_COND_EQ_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Max Initial Sym Sh CCurrent</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MAX_INITIAL_SYM_SH_CCURRENT = REGULATING_COND_EQ_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MAX_P = REGULATING_COND_EQ_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Max Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MAX_Q = REGULATING_COND_EQ_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Max R0 To X0 Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MAX_R0_TO_X0_RATIO = REGULATING_COND_EQ_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Max R1 To X1 Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MAX_R1_TO_X1_RATIO = REGULATING_COND_EQ_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Max Z0 To Z1 Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MAX_Z0_TO_Z1_RATIO = REGULATING_COND_EQ_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Min Initial Sym Sh CCurrent</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MIN_INITIAL_SYM_SH_CCURRENT = REGULATING_COND_EQ_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MIN_P = REGULATING_COND_EQ_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Min Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MIN_Q = REGULATING_COND_EQ_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Min R0 To X0 Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MIN_R0_TO_X0_RATIO = REGULATING_COND_EQ_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Min R1 To X1 Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MIN_R1_TO_X1_RATIO = REGULATING_COND_EQ_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Min Z0 To Z1 Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__MIN_Z0_TO_Z1_RATIO = REGULATING_COND_EQ_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__P = REGULATING_COND_EQ_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__Q = REGULATING_COND_EQ_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Reference Priority</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__REFERENCE_PRIORITY = REGULATING_COND_EQ_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>Voltage Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION__VOLTAGE_FACTOR = REGULATING_COND_EQ_FEATURE_COUNT + 17;

    /**
     * The number of structural features of the '<em>External Network Injection</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION_FEATURE_COUNT = REGULATING_COND_EQ_FEATURE_COUNT + 18;

    /**
     * The number of operations of the '<em>External Network Injection</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EXTERNAL_NETWORK_INJECTION_OPERATION_COUNT = REGULATING_COND_EQ_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__R = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__R0 = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__X = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__X0 = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>To Transformer End</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__TO_TRANSFORMER_END = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>From Transformer End</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE__FROM_TRANSFORMER_END = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Transformer Mesh Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Transformer Mesh Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TRANSFORMER_MESH_IMPEDANCE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_VOLTAGE__ID = STATE_VARIABLE__ID;

    /**
     * The feature id for the '<em><b>Angle</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_VOLTAGE__ANGLE = STATE_VARIABLE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>V</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_VOLTAGE__V = STATE_VARIABLE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_VOLTAGE__TOPOLOGICAL_NODE = STATE_VARIABLE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Sv Voltage</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_VOLTAGE_FEATURE_COUNT = STATE_VARIABLE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Sv Voltage</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SV_VOLTAGE_OPERATION_COUNT = STATE_VARIABLE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IEC61970CIM_VERSION__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IEC61970CIM_VERSION__DATE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Version</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IEC61970CIM_VERSION__VERSION = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>IEC61970CIM Version</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IEC61970CIM_VERSION_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>IEC61970CIM Version</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IEC61970CIM_VERSION_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__ID = MEASUREMENT_VALUE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__ALIAS_NAME = MEASUREMENT_VALUE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__DESCRIPTION = MEASUREMENT_VALUE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__MRID = MEASUREMENT_VALUE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__NAME = MEASUREMENT_VALUE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__NAMES = MEASUREMENT_VALUE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__DIAGRAM_OBJECTS = MEASUREMENT_VALUE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Sensor Accuracy</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__SENSOR_ACCURACY = MEASUREMENT_VALUE__SENSOR_ACCURACY;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__TIME_STAMP = MEASUREMENT_VALUE__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Remote Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__REMOTE_SOURCE = MEASUREMENT_VALUE__REMOTE_SOURCE;

    /**
     * The feature id for the '<em><b>Measurement Value Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__MEASUREMENT_VALUE_SOURCE = MEASUREMENT_VALUE__MEASUREMENT_VALUE_SOURCE;

    /**
     * The feature id for the '<em><b>Measurement Value Quality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__MEASUREMENT_VALUE_QUALITY = MEASUREMENT_VALUE__MEASUREMENT_VALUE_QUALITY;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__VALUE = MEASUREMENT_VALUE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>String Measurement</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE__STRING_MEASUREMENT = MEASUREMENT_VALUE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>String Measurement Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE_FEATURE_COUNT = MEASUREMENT_VALUE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>String Measurement Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_VALUE_OPERATION_COUNT = MEASUREMENT_VALUE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__ID = MEASUREMENT_VALUE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__ALIAS_NAME = MEASUREMENT_VALUE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__DESCRIPTION = MEASUREMENT_VALUE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__MRID = MEASUREMENT_VALUE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__NAME = MEASUREMENT_VALUE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__NAMES = MEASUREMENT_VALUE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__DIAGRAM_OBJECTS = MEASUREMENT_VALUE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Sensor Accuracy</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__SENSOR_ACCURACY = MEASUREMENT_VALUE__SENSOR_ACCURACY;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__TIME_STAMP = MEASUREMENT_VALUE__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Remote Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__REMOTE_SOURCE = MEASUREMENT_VALUE__REMOTE_SOURCE;

    /**
     * The feature id for the '<em><b>Measurement Value Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__MEASUREMENT_VALUE_SOURCE = MEASUREMENT_VALUE__MEASUREMENT_VALUE_SOURCE;

    /**
     * The feature id for the '<em><b>Measurement Value Quality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__MEASUREMENT_VALUE_QUALITY = MEASUREMENT_VALUE__MEASUREMENT_VALUE_QUALITY;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__VALUE = MEASUREMENT_VALUE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Analog Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__ANALOG_CONTROL = MEASUREMENT_VALUE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Alt Generating Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__ALT_GENERATING_UNIT = MEASUREMENT_VALUE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Analog</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__ANALOG = MEASUREMENT_VALUE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Alt Tie Meas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE__ALT_TIE_MEAS = MEASUREMENT_VALUE_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Analog Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE_FEATURE_COUNT = MEASUREMENT_VALUE_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Analog Value</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_VALUE_OPERATION_COUNT = MEASUREMENT_VALUE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Ratio Tap Changer</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE__RATIO_TAP_CHANGER = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Ratio Tap Changer Table Point</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE__RATIO_TAP_CHANGER_TABLE_POINT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Ratio Tap Changer Table</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Ratio Tap Changer Table</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RATIO_TAP_CHANGER_TABLE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_TIME_POINT__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_TIME_POINT__TIME = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Value1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_TIME_POINT__VALUE1 = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Value2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_TIME_POINT__VALUE2 = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Interval Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_TIME_POINT__INTERVAL_SCHEDULE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Irregular Time Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_TIME_POINT_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Irregular Time Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int IRREGULAR_TIME_POINT_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Phase</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__PHASE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>AC Line Segment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE__AC_LINE_SEGMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>AC Line Segment Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>AC Line Segment Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_PHASE_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__ID = ENERGY_CONSUMER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__ALIAS_NAME = ENERGY_CONSUMER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__DESCRIPTION = ENERGY_CONSUMER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__MRID = ENERGY_CONSUMER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__NAME = ENERGY_CONSUMER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__NAMES = ENERGY_CONSUMER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__DIAGRAM_OBJECTS = ENERGY_CONSUMER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__MEASUREMENTS = ENERGY_CONSUMER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__CONTROLS = ENERGY_CONSUMER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__OPERATING_SHARE = ENERGY_CONSUMER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__PSR_TYPE = ENERGY_CONSUMER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__AGGREGATE = ENERGY_CONSUMER__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__NORMALLY_IN_SERVICE = ENERGY_CONSUMER__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__CONTINGENCY_EQUIPMENT = ENERGY_CONSUMER__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__OPERATIONAL_LIMIT_SET = ENERGY_CONSUMER__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__FAULTS = ENERGY_CONSUMER__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__EQUIPMENT_CONTAINER = ENERGY_CONSUMER__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__PROTECTION_EQUIPMENTS = ENERGY_CONSUMER__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__BASE_VOLTAGE = ENERGY_CONSUMER__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__SV_STATUS = ENERGY_CONSUMER__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__TERMINALS = ENERGY_CONSUMER__TERMINALS;

    /**
     * The feature id for the '<em><b>Customer Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__CUSTOMER_COUNT = ENERGY_CONSUMER__CUSTOMER_COUNT;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__GROUNDED = ENERGY_CONSUMER__GROUNDED;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__P = ENERGY_CONSUMER__P;

    /**
     * The feature id for the '<em><b>Pfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__PFIXED = ENERGY_CONSUMER__PFIXED;

    /**
     * The feature id for the '<em><b>Pfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__PFIXED_PCT = ENERGY_CONSUMER__PFIXED_PCT;

    /**
     * The feature id for the '<em><b>Phase Connection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__PHASE_CONNECTION = ENERGY_CONSUMER__PHASE_CONNECTION;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__Q = ENERGY_CONSUMER__Q;

    /**
     * The feature id for the '<em><b>Qfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__QFIXED = ENERGY_CONSUMER__QFIXED;

    /**
     * The feature id for the '<em><b>Qfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__QFIXED_PCT = ENERGY_CONSUMER__QFIXED_PCT;

    /**
     * The feature id for the '<em><b>Load Response</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__LOAD_RESPONSE = ENERGY_CONSUMER__LOAD_RESPONSE;

    /**
     * The feature id for the '<em><b>Energy Consumer Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__ENERGY_CONSUMER_PHASE = ENERGY_CONSUMER__ENERGY_CONSUMER_PHASE;

    /**
     * The feature id for the '<em><b>Power Cut Zone</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__POWER_CUT_ZONE = ENERGY_CONSUMER__POWER_CUT_ZONE;

    /**
     * The feature id for the '<em><b>Load Group</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD__LOAD_GROUP = ENERGY_CONSUMER_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Conform Load</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_FEATURE_COUNT = ENERGY_CONSUMER_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Conform Load</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONFORM_LOAD_OPERATION_COUNT = ENERGY_CONSUMER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__ID = CONDUCTOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__ALIAS_NAME = CONDUCTOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__DESCRIPTION = CONDUCTOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__MRID = CONDUCTOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__NAME = CONDUCTOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__NAMES = CONDUCTOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__DIAGRAM_OBJECTS = CONDUCTOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__MEASUREMENTS = CONDUCTOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__CONTROLS = CONDUCTOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__OPERATING_SHARE = CONDUCTOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__PSR_TYPE = CONDUCTOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__AGGREGATE = CONDUCTOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__NORMALLY_IN_SERVICE = CONDUCTOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__CONTINGENCY_EQUIPMENT = CONDUCTOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__OPERATIONAL_LIMIT_SET = CONDUCTOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__FAULTS = CONDUCTOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__EQUIPMENT_CONTAINER = CONDUCTOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__PROTECTION_EQUIPMENTS = CONDUCTOR__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__BASE_VOLTAGE = CONDUCTOR__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__SV_STATUS = CONDUCTOR__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__TERMINALS = CONDUCTOR__TERMINALS;

    /**
     * The feature id for the '<em><b>Length</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__LENGTH = CONDUCTOR__LENGTH;

    /**
     * The feature id for the '<em><b>B0ch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__B0CH = CONDUCTOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Bch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__BCH = CONDUCTOR_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>G0ch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__G0CH = CONDUCTOR_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Gch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__GCH = CONDUCTOR_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__R = CONDUCTOR_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__R0 = CONDUCTOR_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Short Circuit End Temperature</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__SHORT_CIRCUIT_END_TEMPERATURE = CONDUCTOR_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__X = CONDUCTOR_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__X0 = CONDUCTOR_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>AC Line Segment Phases</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__AC_LINE_SEGMENT_PHASES = CONDUCTOR_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Per Length Impedance</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__PER_LENGTH_IMPEDANCE = CONDUCTOR_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Cut</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__CUT = CONDUCTOR_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Clamp</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__CLAMP = CONDUCTOR_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Line Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT__LINE_FAULTS = CONDUCTOR_FEATURE_COUNT + 13;

    /**
     * The number of structural features of the '<em>AC Line Segment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_FEATURE_COUNT = CONDUCTOR_FEATURE_COUNT + 14;

    /**
     * The number of operations of the '<em>AC Line Segment</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AC_LINE_SEGMENT_OPERATION_COUNT = CONDUCTOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Fixed Maint Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__FIXED_MAINT_COST = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Hot Standby Heat</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__HOT_STANDBY_HEAT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Incremental Maint Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__INCREMENTAL_MAINT_COST = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Minimum Down Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__MINIMUM_DOWN_TIME = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Minimum Run Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__MINIMUM_RUN_TIME = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Risk Factor Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__RISK_FACTOR_COST = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Startup Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__STARTUP_COST = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Startup Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__STARTUP_DATE = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Startup Priority</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__STARTUP_PRIORITY = IDENTIFIED_OBJECT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Stby Aux P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__STBY_AUX_P = IDENTIFIED_OBJECT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Start Main Fuel Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__START_MAIN_FUEL_CURVE = IDENTIFIED_OBJECT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__THERMAL_GENERATING_UNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Start Ign Fuel Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__START_IGN_FUEL_CURVE = IDENTIFIED_OBJECT_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Start Ramp Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL__START_RAMP_CURVE = IDENTIFIED_OBJECT_FEATURE_COUNT + 13;

    /**
     * The number of structural features of the '<em>Startup Model</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 14;

    /**
     * The number of operations of the '<em>Startup Model</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STARTUP_MODEL_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__ID = EQUIVALENT_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__ALIAS_NAME = EQUIVALENT_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__DESCRIPTION = EQUIVALENT_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__MRID = EQUIVALENT_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__NAME = EQUIVALENT_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__NAMES = EQUIVALENT_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__DIAGRAM_OBJECTS = EQUIVALENT_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__MEASUREMENTS = EQUIVALENT_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__CONTROLS = EQUIVALENT_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__OPERATING_SHARE = EQUIVALENT_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__PSR_TYPE = EQUIVALENT_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__AGGREGATE = EQUIVALENT_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__NORMALLY_IN_SERVICE = EQUIVALENT_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__CONTINGENCY_EQUIPMENT = EQUIVALENT_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__OPERATIONAL_LIMIT_SET = EQUIVALENT_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__FAULTS = EQUIVALENT_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__EQUIPMENT_CONTAINER = EQUIVALENT_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__PROTECTION_EQUIPMENTS = EQUIVALENT_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__BASE_VOLTAGE = EQUIVALENT_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__SV_STATUS = EQUIVALENT_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__TERMINALS = EQUIVALENT_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Equivalent Network</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__EQUIVALENT_NETWORK = EQUIVALENT_EQUIPMENT__EQUIVALENT_NETWORK;

    /**
     * The feature id for the '<em><b>Negative R12</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__NEGATIVE_R12 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Negative R21</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__NEGATIVE_R21 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Negative X12</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__NEGATIVE_X12 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Negative X21</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__NEGATIVE_X21 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Positive R12</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__POSITIVE_R12 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Positive R21</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__POSITIVE_R21 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Positive X12</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__POSITIVE_X12 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Positive X21</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__POSITIVE_X21 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__R = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>R21</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__R21 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__X = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>X21</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__X21 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Zero R12</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__ZERO_R12 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Zero R21</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__ZERO_R21 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Zero X12</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__ZERO_X12 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Zero X21</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH__ZERO_X21 = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 15;

    /**
     * The number of structural features of the '<em>Equivalent Branch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH_FEATURE_COUNT = EQUIVALENT_EQUIPMENT_FEATURE_COUNT + 16;

    /**
     * The number of operations of the '<em>Equivalent Branch</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EQUIVALENT_BRANCH_OPERATION_COUNT = EQUIVALENT_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__ID = EQUIPMENT_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__ALIAS_NAME = EQUIPMENT_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__DESCRIPTION = EQUIPMENT_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__MRID = EQUIPMENT_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__NAME = EQUIPMENT_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__NAMES = EQUIPMENT_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__DIAGRAM_OBJECTS = EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__MEASUREMENTS = EQUIPMENT_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__CONTROLS = EQUIPMENT_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__OPERATING_SHARE = EQUIPMENT_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__PSR_TYPE = EQUIPMENT_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__CONNECTIVITY_NODES = EQUIPMENT_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__TOPOLOGICAL_NODE = EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__EQUIPMENTS = EQUIPMENT_CONTAINER__EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Region</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE__REGION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Line</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FEATURE_COUNT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Line</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_OPERATION_COUNT = EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Priority</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER__PRIORITY = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER__TERMINAL = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Bus Name Marker</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Bus Name Marker</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BUS_NAME_MARKER_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__DC_TERMINALS = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>DC Topological Island</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__DC_TOPOLOGICAL_ISLAND = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>DC Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__DC_EQUIPMENT_CONTAINER = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>DC Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE__DC_NODES = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>DC Topological Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>DC Topological Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_TOPOLOGICAL_NODE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__ID = DC_SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__ALIAS_NAME = DC_SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__DESCRIPTION = DC_SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__MRID = DC_SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__NAME = DC_SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__NAMES = DC_SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__DIAGRAM_OBJECTS = DC_SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__MEASUREMENTS = DC_SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__CONTROLS = DC_SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__OPERATING_SHARE = DC_SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__PSR_TYPE = DC_SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__AGGREGATE = DC_SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__NORMALLY_IN_SERVICE = DC_SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__CONTINGENCY_EQUIPMENT = DC_SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__OPERATIONAL_LIMIT_SET = DC_SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__FAULTS = DC_SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__EQUIPMENT_CONTAINER = DC_SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR__DC_TERMINALS = DC_SWITCH__DC_TERMINALS;

    /**
     * The number of structural features of the '<em>DC Disconnector</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR_FEATURE_COUNT = DC_SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>DC Disconnector</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_DISCONNECTOR_OPERATION_COUNT = DC_SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__ID = DC_CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__ALIAS_NAME = DC_CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__DESCRIPTION = DC_CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__MRID = DC_CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__NAME = DC_CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__NAMES = DC_CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__DIAGRAM_OBJECTS = DC_CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__MEASUREMENTS = DC_CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__CONTROLS = DC_CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__OPERATING_SHARE = DC_CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__PSR_TYPE = DC_CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__AGGREGATE = DC_CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__NORMALLY_IN_SERVICE = DC_CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__CONTINGENCY_EQUIPMENT = DC_CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__OPERATIONAL_LIMIT_SET = DC_CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__FAULTS = DC_CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__EQUIPMENT_CONTAINER = DC_CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__DC_TERMINALS = DC_CONDUCTING_EQUIPMENT__DC_TERMINALS;

    /**
     * The feature id for the '<em><b>Capacitance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__CAPACITANCE = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Rated Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__RATED_UDC = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Resistance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT__RESISTANCE = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>DC Shunt</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT_FEATURE_COUNT = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>DC Shunt</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_SHUNT_OPERATION_COUNT = DC_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_IMPEDANCE_DATA__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>B</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_IMPEDANCE_DATA__B = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_IMPEDANCE_DATA__R = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Sequence Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_IMPEDANCE_DATA__SEQUENCE_NUMBER = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_IMPEDANCE_DATA__X = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Phase Impedance</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_IMPEDANCE_DATA__PHASE_IMPEDANCE = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Phase Impedance Data</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_IMPEDANCE_DATA_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Phase Impedance Data</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_IMPEDANCE_DATA_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Is Net Gross P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__IS_NET_GROSS_P = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE__THERMAL_GENERATING_UNIT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Incremental Heat Rate Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Incremental Heat Rate Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INCREMENTAL_HEAT_RATE_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA__CONTROL_AREA = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Energy Area</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Energy Area</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_AREA_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__ID = ENERGY_AREA__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__ALIAS_NAME = ENERGY_AREA__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__DESCRIPTION = ENERGY_AREA__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__MRID = ENERGY_AREA__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__NAME = ENERGY_AREA__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__NAMES = ENERGY_AREA__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__DIAGRAM_OBJECTS = ENERGY_AREA__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__CONTROL_AREA = ENERGY_AREA__CONTROL_AREA;

    /**
     * The feature id for the '<em><b>Load Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__LOAD_AREA = ENERGY_AREA_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Load Groups</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA__LOAD_GROUPS = ENERGY_AREA_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Sub Load Area</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA_FEATURE_COUNT = ENERGY_AREA_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Sub Load Area</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUB_LOAD_AREA_OPERATION_COUNT = ENERGY_AREA_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Season Day Type Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE__SEASON_DAY_TYPE_SCHEDULES = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Day Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Day Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DAY_TYPE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__ID = PRIME_MOVER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__ALIAS_NAME = PRIME_MOVER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__DESCRIPTION = PRIME_MOVER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__MRID = PRIME_MOVER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__NAME = PRIME_MOVER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__NAMES = PRIME_MOVER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__DIAGRAM_OBJECTS = PRIME_MOVER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__MEASUREMENTS = PRIME_MOVER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__CONTROLS = PRIME_MOVER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__OPERATING_SHARE = PRIME_MOVER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__PSR_TYPE = PRIME_MOVER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Prime Mover Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__PRIME_MOVER_RATING = PRIME_MOVER__PRIME_MOVER_RATING;

    /**
     * The feature id for the '<em><b>Synchronous Machines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__SYNCHRONOUS_MACHINES = PRIME_MOVER__SYNCHRONOUS_MACHINES;

    /**
     * The feature id for the '<em><b>Ambient Temp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__AMBIENT_TEMP = PRIME_MOVER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Aux Power Versus Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__AUX_POWER_VERSUS_FREQUENCY = PRIME_MOVER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Aux Power Versus Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__AUX_POWER_VERSUS_VOLTAGE = PRIME_MOVER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Capability Versus Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__CAPABILITY_VERSUS_FREQUENCY = PRIME_MOVER_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Heat Recovery Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__HEAT_RECOVERY_FLAG = PRIME_MOVER_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Power Variation By Temp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__POWER_VARIATION_BY_TEMP = PRIME_MOVER_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Reference Temp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__REFERENCE_TEMP = PRIME_MOVER_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Time Constant</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__TIME_CONSTANT = PRIME_MOVER_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Air Compressor</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__AIR_COMPRESSOR = PRIME_MOVER_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>CT Temp Active Power Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__CT_TEMP_ACTIVE_POWER_CURVE = PRIME_MOVER_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Heat Recovery Boiler</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE__HEAT_RECOVERY_BOILER = PRIME_MOVER_FEATURE_COUNT + 10;

    /**
     * The number of structural features of the '<em>Combustion Turbine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE_FEATURE_COUNT = PRIME_MOVER_FEATURE_COUNT + 11;

    /**
     * The number of operations of the '<em>Combustion Turbine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMBUSTION_TURBINE_OPERATION_COUNT = PRIME_MOVER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__ID = PROTECTED_SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__ALIAS_NAME = PROTECTED_SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__DESCRIPTION = PROTECTED_SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__MRID = PROTECTED_SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__NAME = PROTECTED_SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__NAMES = PROTECTED_SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__DIAGRAM_OBJECTS = PROTECTED_SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__MEASUREMENTS = PROTECTED_SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__CONTROLS = PROTECTED_SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__OPERATING_SHARE = PROTECTED_SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__PSR_TYPE = PROTECTED_SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__AGGREGATE = PROTECTED_SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__NORMALLY_IN_SERVICE = PROTECTED_SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__CONTINGENCY_EQUIPMENT = PROTECTED_SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__OPERATIONAL_LIMIT_SET = PROTECTED_SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__FAULTS = PROTECTED_SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__EQUIPMENT_CONTAINER = PROTECTED_SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__PROTECTION_EQUIPMENTS = PROTECTED_SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__BASE_VOLTAGE = PROTECTED_SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__SV_STATUS = PROTECTED_SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__TERMINALS = PROTECTED_SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__NORMAL_OPEN = PROTECTED_SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__OPEN = PROTECTED_SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__RATED_CURRENT = PROTECTED_SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__RETAINED = PROTECTED_SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__SWITCH_ON_COUNT = PROTECTED_SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__SWITCH_ON_DATE = PROTECTED_SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__COMPOSITE_SWITCH = PROTECTED_SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__SWITCH_SCHEDULES = PROTECTED_SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__SWITCH_PHASE = PROTECTED_SWITCH__SWITCH_PHASE;

    /**
     * The feature id for the '<em><b>Breaking Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__BREAKING_CAPACITY = PROTECTED_SWITCH__BREAKING_CAPACITY;

    /**
     * The feature id for the '<em><b>Reclose Sequences</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__RECLOSE_SEQUENCES = PROTECTED_SWITCH__RECLOSE_SEQUENCES;

    /**
     * The feature id for the '<em><b>Operated By Protection Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__OPERATED_BY_PROTECTION_EQUIPMENT = PROTECTED_SWITCH__OPERATED_BY_PROTECTION_EQUIPMENT;

    /**
     * The feature id for the '<em><b>In Transit Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER__IN_TRANSIT_TIME = PROTECTED_SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Breaker</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER_FEATURE_COUNT = PROTECTED_SWITCH_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Breaker</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BREAKER_OPERATION_COUNT = PROTECTED_SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Emission Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__EMISSION_TYPE = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Emission Value Source</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__EMISSION_VALUE_SOURCE = CURVE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT__THERMAL_GENERATING_UNIT = CURVE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Emission Account</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT_FEATURE_COUNT = CURVE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Emission Account</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_ACCOUNT_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__ID = ROTATING_MACHINE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__ALIAS_NAME = ROTATING_MACHINE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__DESCRIPTION = ROTATING_MACHINE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__MRID = ROTATING_MACHINE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__NAME = ROTATING_MACHINE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__NAMES = ROTATING_MACHINE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__DIAGRAM_OBJECTS = ROTATING_MACHINE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__MEASUREMENTS = ROTATING_MACHINE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__CONTROLS = ROTATING_MACHINE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__OPERATING_SHARE = ROTATING_MACHINE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__PSR_TYPE = ROTATING_MACHINE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__AGGREGATE = ROTATING_MACHINE__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__NORMALLY_IN_SERVICE = ROTATING_MACHINE__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__CONTINGENCY_EQUIPMENT = ROTATING_MACHINE__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__OPERATIONAL_LIMIT_SET = ROTATING_MACHINE__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__FAULTS = ROTATING_MACHINE__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__EQUIPMENT_CONTAINER = ROTATING_MACHINE__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__PROTECTION_EQUIPMENTS = ROTATING_MACHINE__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__BASE_VOLTAGE = ROTATING_MACHINE__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__SV_STATUS = ROTATING_MACHINE__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__TERMINALS = ROTATING_MACHINE__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__CONTROL_ENABLED = ROTATING_MACHINE__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__REGULATING_CONTROL = ROTATING_MACHINE__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__P = ROTATING_MACHINE__P;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__Q = ROTATING_MACHINE__Q;

    /**
     * The feature id for the '<em><b>Rated Power Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__RATED_POWER_FACTOR = ROTATING_MACHINE__RATED_POWER_FACTOR;

    /**
     * The feature id for the '<em><b>Rated S</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__RATED_S = ROTATING_MACHINE__RATED_S;

    /**
     * The feature id for the '<em><b>Rated U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__RATED_U = ROTATING_MACHINE__RATED_U;

    /**
     * The feature id for the '<em><b>Hydro Pump</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__HYDRO_PUMP = ROTATING_MACHINE__HYDRO_PUMP;

    /**
     * The feature id for the '<em><b>Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__GENERATING_UNIT = ROTATING_MACHINE__GENERATING_UNIT;

    /**
     * The feature id for the '<em><b>Asynchronous Machine Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__ASYNCHRONOUS_MACHINE_TYPE = ROTATING_MACHINE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Converter Fed Drive</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__CONVERTER_FED_DRIVE = ROTATING_MACHINE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__EFFICIENCY = ROTATING_MACHINE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Ia Ir Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__IA_IR_RATIO = ROTATING_MACHINE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Nominal Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__NOMINAL_FREQUENCY = ROTATING_MACHINE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Nominal Speed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__NOMINAL_SPEED = ROTATING_MACHINE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Pole Pair Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__POLE_PAIR_NUMBER = ROTATING_MACHINE_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Rated Mechanical Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__RATED_MECHANICAL_POWER = ROTATING_MACHINE_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Reversible</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__REVERSIBLE = ROTATING_MACHINE_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Rr1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__RR1 = ROTATING_MACHINE_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Rr2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__RR2 = ROTATING_MACHINE_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Rx Locked Rotor Ratio</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__RX_LOCKED_ROTOR_RATIO = ROTATING_MACHINE_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Tpo</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__TPO = ROTATING_MACHINE_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Tppo</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__TPPO = ROTATING_MACHINE_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Xlr1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__XLR1 = ROTATING_MACHINE_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Xlr2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__XLR2 = ROTATING_MACHINE_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Xm</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__XM = ROTATING_MACHINE_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>Xp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__XP = ROTATING_MACHINE_FEATURE_COUNT + 17;

    /**
     * The feature id for the '<em><b>Xpp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__XPP = ROTATING_MACHINE_FEATURE_COUNT + 18;

    /**
     * The feature id for the '<em><b>Xs</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE__XS = ROTATING_MACHINE_FEATURE_COUNT + 19;

    /**
     * The number of structural features of the '<em>Asynchronous Machine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE_FEATURE_COUNT = ROTATING_MACHINE_FEATURE_COUNT + 20;

    /**
     * The number of operations of the '<em>Asynchronous Machine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ASYNCHRONOUS_MACHINE_OPERATION_COUNT = ROTATING_MACHINE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__ID = ENERGY_CONSUMER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__ALIAS_NAME = ENERGY_CONSUMER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__DESCRIPTION = ENERGY_CONSUMER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__MRID = ENERGY_CONSUMER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__NAME = ENERGY_CONSUMER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__NAMES = ENERGY_CONSUMER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__DIAGRAM_OBJECTS = ENERGY_CONSUMER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__MEASUREMENTS = ENERGY_CONSUMER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__CONTROLS = ENERGY_CONSUMER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__OPERATING_SHARE = ENERGY_CONSUMER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__PSR_TYPE = ENERGY_CONSUMER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__AGGREGATE = ENERGY_CONSUMER__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__NORMALLY_IN_SERVICE = ENERGY_CONSUMER__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__CONTINGENCY_EQUIPMENT = ENERGY_CONSUMER__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__OPERATIONAL_LIMIT_SET = ENERGY_CONSUMER__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__FAULTS = ENERGY_CONSUMER__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__EQUIPMENT_CONTAINER = ENERGY_CONSUMER__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__PROTECTION_EQUIPMENTS = ENERGY_CONSUMER__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__BASE_VOLTAGE = ENERGY_CONSUMER__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__SV_STATUS = ENERGY_CONSUMER__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__TERMINALS = ENERGY_CONSUMER__TERMINALS;

    /**
     * The feature id for the '<em><b>Customer Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__CUSTOMER_COUNT = ENERGY_CONSUMER__CUSTOMER_COUNT;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__GROUNDED = ENERGY_CONSUMER__GROUNDED;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__P = ENERGY_CONSUMER__P;

    /**
     * The feature id for the '<em><b>Pfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__PFIXED = ENERGY_CONSUMER__PFIXED;

    /**
     * The feature id for the '<em><b>Pfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__PFIXED_PCT = ENERGY_CONSUMER__PFIXED_PCT;

    /**
     * The feature id for the '<em><b>Phase Connection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__PHASE_CONNECTION = ENERGY_CONSUMER__PHASE_CONNECTION;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__Q = ENERGY_CONSUMER__Q;

    /**
     * The feature id for the '<em><b>Qfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__QFIXED = ENERGY_CONSUMER__QFIXED;

    /**
     * The feature id for the '<em><b>Qfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__QFIXED_PCT = ENERGY_CONSUMER__QFIXED_PCT;

    /**
     * The feature id for the '<em><b>Load Response</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__LOAD_RESPONSE = ENERGY_CONSUMER__LOAD_RESPONSE;

    /**
     * The feature id for the '<em><b>Energy Consumer Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__ENERGY_CONSUMER_PHASE = ENERGY_CONSUMER__ENERGY_CONSUMER_PHASE;

    /**
     * The feature id for the '<em><b>Power Cut Zone</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY__POWER_CUT_ZONE = ENERGY_CONSUMER__POWER_CUT_ZONE;

    /**
     * The number of structural features of the '<em>Station Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY_FEATURE_COUNT = ENERGY_CONSUMER_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Station Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STATION_SUPPLY_OPERATION_COUNT = ENERGY_CONSUMER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__ID = MEASUREMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__ALIAS_NAME = MEASUREMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__DESCRIPTION = MEASUREMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__MRID = MEASUREMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__NAME = MEASUREMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__NAMES = MEASUREMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__DIAGRAM_OBJECTS = MEASUREMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurement Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__MEASUREMENT_TYPE = MEASUREMENT__MEASUREMENT_TYPE;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__PHASES = MEASUREMENT__PHASES;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__UNIT_MULTIPLIER = MEASUREMENT__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__UNIT_SYMBOL = MEASUREMENT__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__TERMINAL = MEASUREMENT__TERMINAL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__POWER_SYSTEM_RESOURCE = MEASUREMENT__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>Max Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__MAX_VALUE = MEASUREMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Limit Sets</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__LIMIT_SETS = MEASUREMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Accumulator Values</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR__ACCUMULATOR_VALUES = MEASUREMENT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Accumulator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_FEATURE_COUNT = MEASUREMENT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Accumulator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ACCUMULATOR_OPERATION_COUNT = MEASUREMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Energy Storage Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__ENERGY_STORAGE_CAPACITY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Rated Capacity P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__RATED_CAPACITY_P = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__THERMAL_GENERATING_UNIT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Air Compressor</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT__AIR_COMPRESSOR = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>CAES Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>CAES Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CAES_PLANT_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__ID = PER_LENGTH_IMPEDANCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__ALIAS_NAME = PER_LENGTH_IMPEDANCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__DESCRIPTION = PER_LENGTH_IMPEDANCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__MRID = PER_LENGTH_IMPEDANCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__NAME = PER_LENGTH_IMPEDANCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__NAMES = PER_LENGTH_IMPEDANCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__DIAGRAM_OBJECTS = PER_LENGTH_IMPEDANCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>AC Line Segments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__AC_LINE_SEGMENTS = PER_LENGTH_IMPEDANCE__AC_LINE_SEGMENTS;

    /**
     * The feature id for the '<em><b>Conductor Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__CONDUCTOR_COUNT = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Phase Impedance Data</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE__PHASE_IMPEDANCE_DATA = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Per Length Phase Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE_FEATURE_COUNT = PER_LENGTH_IMPEDANCE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Per Length Phase Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_PHASE_IMPEDANCE_OPERATION_COUNT = PER_LENGTH_IMPEDANCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__ID = SHUNT_COMPENSATOR_PHASE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__ALIAS_NAME = SHUNT_COMPENSATOR_PHASE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__DESCRIPTION = SHUNT_COMPENSATOR_PHASE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__MRID = SHUNT_COMPENSATOR_PHASE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__NAME = SHUNT_COMPENSATOR_PHASE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__NAMES = SHUNT_COMPENSATOR_PHASE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__DIAGRAM_OBJECTS = SHUNT_COMPENSATOR_PHASE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__MEASUREMENTS = SHUNT_COMPENSATOR_PHASE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__CONTROLS = SHUNT_COMPENSATOR_PHASE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__OPERATING_SHARE = SHUNT_COMPENSATOR_PHASE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__PSR_TYPE = SHUNT_COMPENSATOR_PHASE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Maximum Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__MAXIMUM_SECTIONS = SHUNT_COMPENSATOR_PHASE__MAXIMUM_SECTIONS;

    /**
     * The feature id for the '<em><b>Normal Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__NORMAL_SECTIONS = SHUNT_COMPENSATOR_PHASE__NORMAL_SECTIONS;

    /**
     * The feature id for the '<em><b>Phase</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__PHASE = SHUNT_COMPENSATOR_PHASE__PHASE;

    /**
     * The feature id for the '<em><b>Shunt Compensator</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__SHUNT_COMPENSATOR = SHUNT_COMPENSATOR_PHASE__SHUNT_COMPENSATOR;

    /**
     * The feature id for the '<em><b>BPer Section</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__BPER_SECTION = SHUNT_COMPENSATOR_PHASE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>GPer Section</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE__GPER_SECTION = SHUNT_COMPENSATOR_PHASE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Linear Shunt Compensator Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE_FEATURE_COUNT = SHUNT_COMPENSATOR_PHASE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Linear Shunt Compensator Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_PHASE_OPERATION_COUNT = SHUNT_COMPENSATOR_PHASE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT__ID = LIMIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT__ALIAS_NAME = LIMIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT__DESCRIPTION = LIMIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT__MRID = LIMIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT__NAME = LIMIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT__NAMES = LIMIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT__DIAGRAM_OBJECTS = LIMIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT__VALUE = LIMIT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Limit Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT__LIMIT_SET = LIMIT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Analog Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_FEATURE_COUNT = LIMIT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Analog Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ANALOG_LIMIT_OPERATION_COUNT = LIMIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__ID = SHUNT_COMPENSATOR_PHASE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__ALIAS_NAME = SHUNT_COMPENSATOR_PHASE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__DESCRIPTION = SHUNT_COMPENSATOR_PHASE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__MRID = SHUNT_COMPENSATOR_PHASE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__NAME = SHUNT_COMPENSATOR_PHASE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__NAMES = SHUNT_COMPENSATOR_PHASE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__DIAGRAM_OBJECTS = SHUNT_COMPENSATOR_PHASE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__MEASUREMENTS = SHUNT_COMPENSATOR_PHASE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__CONTROLS = SHUNT_COMPENSATOR_PHASE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__OPERATING_SHARE = SHUNT_COMPENSATOR_PHASE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__PSR_TYPE = SHUNT_COMPENSATOR_PHASE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Maximum Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__MAXIMUM_SECTIONS = SHUNT_COMPENSATOR_PHASE__MAXIMUM_SECTIONS;

    /**
     * The feature id for the '<em><b>Normal Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__NORMAL_SECTIONS = SHUNT_COMPENSATOR_PHASE__NORMAL_SECTIONS;

    /**
     * The feature id for the '<em><b>Phase</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__PHASE = SHUNT_COMPENSATOR_PHASE__PHASE;

    /**
     * The feature id for the '<em><b>Shunt Compensator</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__SHUNT_COMPENSATOR = SHUNT_COMPENSATOR_PHASE__SHUNT_COMPENSATOR;

    /**
     * The feature id for the '<em><b>Nonlinear Shunt Compensator Phase Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE__NONLINEAR_SHUNT_COMPENSATOR_PHASE_POINTS = SHUNT_COMPENSATOR_PHASE_FEATURE_COUNT
            + 0;

    /**
     * The number of structural features of the '<em>Nonlinear Shunt Compensator Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_FEATURE_COUNT = SHUNT_COMPENSATOR_PHASE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Nonlinear Shunt Compensator Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_OPERATION_COUNT = SHUNT_COMPENSATOR_PHASE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Nominal Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__NOMINAL_VOLTAGE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Voltage Level</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__VOLTAGE_LEVEL = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Conducting Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__CONDUCTING_EQUIPMENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Transformer Ends</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__TRANSFORMER_ENDS = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE__TOPOLOGICAL_NODE = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Base Voltage</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Base Voltage</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_VOLTAGE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__ID = SEASON_DAY_TYPE_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__ALIAS_NAME = SEASON_DAY_TYPE_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__DESCRIPTION = SEASON_DAY_TYPE_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__MRID = SEASON_DAY_TYPE_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__NAME = SEASON_DAY_TYPE_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__NAMES = SEASON_DAY_TYPE_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__DIAGRAM_OBJECTS = SEASON_DAY_TYPE_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__START_TIME = SEASON_DAY_TYPE_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__VALUE1_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__VALUE1_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__VALUE2_MULTIPLIER = SEASON_DAY_TYPE_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__VALUE2_UNIT = SEASON_DAY_TYPE_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__END_TIME = SEASON_DAY_TYPE_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__TIME_STEP = SEASON_DAY_TYPE_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__TIME_POINTS = SEASON_DAY_TYPE_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Day Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__DAY_TYPE = SEASON_DAY_TYPE_SCHEDULE__DAY_TYPE;

    /**
     * The feature id for the '<em><b>Season</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__SEASON = SEASON_DAY_TYPE_SCHEDULE__SEASON;

    /**
     * The feature id for the '<em><b>Tap Changer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE__TAP_CHANGER = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Tap Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE_FEATURE_COUNT = SEASON_DAY_TYPE_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Tap Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAP_SCHEDULE_OPERATION_COUNT = SEASON_DAY_TYPE_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__ID = SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__ALIAS_NAME = SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__DESCRIPTION = SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__MRID = SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__NAME = SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__NAMES = SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__DIAGRAM_OBJECTS = SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__MEASUREMENTS = SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__CONTROLS = SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__OPERATING_SHARE = SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__PSR_TYPE = SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__AGGREGATE = SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__NORMALLY_IN_SERVICE = SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__CONTINGENCY_EQUIPMENT = SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__OPERATIONAL_LIMIT_SET = SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__FAULTS = SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__EQUIPMENT_CONTAINER = SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__PROTECTION_EQUIPMENTS = SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__BASE_VOLTAGE = SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__SV_STATUS = SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__TERMINALS = SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__NORMAL_OPEN = SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__OPEN = SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__RATED_CURRENT = SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__RETAINED = SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__SWITCH_ON_COUNT = SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__SWITCH_ON_DATE = SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__COMPOSITE_SWITCH = SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__SWITCH_SCHEDULES = SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR__SWITCH_PHASE = SWITCH__SWITCH_PHASE;

    /**
     * The number of structural features of the '<em>Disconnector</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR_FEATURE_COUNT = SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Disconnector</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCONNECTOR_OPERATION_COUNT = SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__ID = PROTECTION_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__ALIAS_NAME = PROTECTION_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__DESCRIPTION = PROTECTION_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__MRID = PROTECTION_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__NAME = PROTECTION_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__NAMES = PROTECTION_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__DIAGRAM_OBJECTS = PROTECTION_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__MEASUREMENTS = PROTECTION_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__CONTROLS = PROTECTION_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__OPERATING_SHARE = PROTECTION_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__PSR_TYPE = PROTECTION_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__AGGREGATE = PROTECTION_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__NORMALLY_IN_SERVICE = PROTECTION_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__CONTINGENCY_EQUIPMENT = PROTECTION_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__OPERATIONAL_LIMIT_SET = PROTECTION_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__FAULTS = PROTECTION_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__EQUIPMENT_CONTAINER = PROTECTION_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>High Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__HIGH_LIMIT = PROTECTION_EQUIPMENT__HIGH_LIMIT;

    /**
     * The feature id for the '<em><b>Low Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__LOW_LIMIT = PROTECTION_EQUIPMENT__LOW_LIMIT;

    /**
     * The feature id for the '<em><b>Power Direction Flag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__POWER_DIRECTION_FLAG = PROTECTION_EQUIPMENT__POWER_DIRECTION_FLAG;

    /**
     * The feature id for the '<em><b>Relay Delay Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__RELAY_DELAY_TIME = PROTECTION_EQUIPMENT__RELAY_DELAY_TIME;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__UNIT_MULTIPLIER = PROTECTION_EQUIPMENT__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__UNIT_SYMBOL = PROTECTION_EQUIPMENT__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Conducting Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__CONDUCTING_EQUIPMENTS = PROTECTION_EQUIPMENT__CONDUCTING_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Protected Switches</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__PROTECTED_SWITCHES = PROTECTION_EQUIPMENT__PROTECTED_SWITCHES;

    /**
     * The feature id for the '<em><b>Max Angle Diff</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__MAX_ANGLE_DIFF = PROTECTION_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Max Freq Diff</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__MAX_FREQ_DIFF = PROTECTION_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Max Volt Diff</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY__MAX_VOLT_DIFF = PROTECTION_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Synchrocheck Relay</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY_FEATURE_COUNT = PROTECTION_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Synchrocheck Relay</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SYNCHROCHECK_RELAY_OPERATION_COUNT = PROTECTION_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Regions</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION__REGIONS = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Geographical Region</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Geographical Region</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GEOGRAPHICAL_REGION_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Phase Tap Changer Tabular</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE__PHASE_TAP_CHANGER_TABULAR = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Phase Tap Changer Table Point</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE__PHASE_TAP_CHANGER_TABLE_POINT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Phase Tap Changer Table</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Phase Tap Changer Table</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PHASE_TAP_CHANGER_TABLE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Remote Units</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK__REMOTE_UNITS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Communication Link</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Communication Link</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMMUNICATION_LINK_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__ID = REGULATING_COND_EQ__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__ALIAS_NAME = REGULATING_COND_EQ__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__DESCRIPTION = REGULATING_COND_EQ__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__MRID = REGULATING_COND_EQ__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__NAME = REGULATING_COND_EQ__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__NAMES = REGULATING_COND_EQ__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__DIAGRAM_OBJECTS = REGULATING_COND_EQ__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__MEASUREMENTS = REGULATING_COND_EQ__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__CONTROLS = REGULATING_COND_EQ__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__OPERATING_SHARE = REGULATING_COND_EQ__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__PSR_TYPE = REGULATING_COND_EQ__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__AGGREGATE = REGULATING_COND_EQ__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__NORMALLY_IN_SERVICE = REGULATING_COND_EQ__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__CONTINGENCY_EQUIPMENT = REGULATING_COND_EQ__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__OPERATIONAL_LIMIT_SET = REGULATING_COND_EQ__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__FAULTS = REGULATING_COND_EQ__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__EQUIPMENT_CONTAINER = REGULATING_COND_EQ__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__PROTECTION_EQUIPMENTS = REGULATING_COND_EQ__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__BASE_VOLTAGE = REGULATING_COND_EQ__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__SV_STATUS = REGULATING_COND_EQ__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__TERMINALS = REGULATING_COND_EQ__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__CONTROL_ENABLED = REGULATING_COND_EQ__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__REGULATING_CONTROL = REGULATING_COND_EQ__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__FREQUENCY = REGULATING_COND_EQ_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__MAX_P = REGULATING_COND_EQ_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Max U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__MAX_U = REGULATING_COND_EQ_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__MIN_P = REGULATING_COND_EQ_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Min U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER__MIN_U = REGULATING_COND_EQ_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Frequency Converter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER_FEATURE_COUNT = REGULATING_COND_EQ_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Frequency Converter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FREQUENCY_CONVERTER_OPERATION_COUNT = REGULATING_COND_EQ_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Acceptable Duration</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__ACCEPTABLE_DURATION = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Direction</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__DIRECTION = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Operational Limit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE__OPERATIONAL_LIMIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Operational Limit Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Operational Limit Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_TYPE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__ID = QUALITY61850__ID;

    /**
     * The feature id for the '<em><b>Bad Reference</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__BAD_REFERENCE = QUALITY61850__BAD_REFERENCE;

    /**
     * The feature id for the '<em><b>Estimator Replaced</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__ESTIMATOR_REPLACED = QUALITY61850__ESTIMATOR_REPLACED;

    /**
     * The feature id for the '<em><b>Failure</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__FAILURE = QUALITY61850__FAILURE;

    /**
     * The feature id for the '<em><b>Old Data</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__OLD_DATA = QUALITY61850__OLD_DATA;

    /**
     * The feature id for the '<em><b>Operator Blocked</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__OPERATOR_BLOCKED = QUALITY61850__OPERATOR_BLOCKED;

    /**
     * The feature id for the '<em><b>Oscillatory</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__OSCILLATORY = QUALITY61850__OSCILLATORY;

    /**
     * The feature id for the '<em><b>Out Of Range</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__OUT_OF_RANGE = QUALITY61850__OUT_OF_RANGE;

    /**
     * The feature id for the '<em><b>Over Flow</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__OVER_FLOW = QUALITY61850__OVER_FLOW;

    /**
     * The feature id for the '<em><b>Source</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__SOURCE = QUALITY61850__SOURCE;

    /**
     * The feature id for the '<em><b>Suspect</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__SUSPECT = QUALITY61850__SUSPECT;

    /**
     * The feature id for the '<em><b>Test</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__TEST = QUALITY61850__TEST;

    /**
     * The feature id for the '<em><b>Validity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__VALIDITY = QUALITY61850__VALIDITY;

    /**
     * The feature id for the '<em><b>Measurement Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY__MEASUREMENT_VALUE = QUALITY61850_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Measurement Value Quality</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY_FEATURE_COUNT = QUALITY61850_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Measurement Value Quality</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_QUALITY_OPERATION_COUNT = QUALITY61850_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__ID = FOSSIL_STEAM_SUPPLY__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__ALIAS_NAME = FOSSIL_STEAM_SUPPLY__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__DESCRIPTION = FOSSIL_STEAM_SUPPLY__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__MRID = FOSSIL_STEAM_SUPPLY__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__NAME = FOSSIL_STEAM_SUPPLY__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__NAMES = FOSSIL_STEAM_SUPPLY__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__DIAGRAM_OBJECTS = FOSSIL_STEAM_SUPPLY__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__MEASUREMENTS = FOSSIL_STEAM_SUPPLY__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__CONTROLS = FOSSIL_STEAM_SUPPLY__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__OPERATING_SHARE = FOSSIL_STEAM_SUPPLY__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__PSR_TYPE = FOSSIL_STEAM_SUPPLY__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Steam Supply Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__STEAM_SUPPLY_RATING = FOSSIL_STEAM_SUPPLY__STEAM_SUPPLY_RATING;

    /**
     * The feature id for the '<em><b>Steam Turbines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__STEAM_TURBINES = FOSSIL_STEAM_SUPPLY__STEAM_TURBINES;

    /**
     * The feature id for the '<em><b>Aux Power Versus Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__AUX_POWER_VERSUS_FREQUENCY = FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_FREQUENCY;

    /**
     * The feature id for the '<em><b>Aux Power Versus Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__AUX_POWER_VERSUS_VOLTAGE = FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_VOLTAGE;

    /**
     * The feature id for the '<em><b>Boiler Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__BOILER_CONTROL_MODE = FOSSIL_STEAM_SUPPLY__BOILER_CONTROL_MODE;

    /**
     * The feature id for the '<em><b>Control Error Bias P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__CONTROL_ERROR_BIAS_P = FOSSIL_STEAM_SUPPLY__CONTROL_ERROR_BIAS_P;

    /**
     * The feature id for the '<em><b>Control IC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__CONTROL_IC = FOSSIL_STEAM_SUPPLY__CONTROL_IC;

    /**
     * The feature id for the '<em><b>Control PC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__CONTROL_PC = FOSSIL_STEAM_SUPPLY__CONTROL_PC;

    /**
     * The feature id for the '<em><b>Control PEB</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__CONTROL_PEB = FOSSIL_STEAM_SUPPLY__CONTROL_PEB;

    /**
     * The feature id for the '<em><b>Control PED</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__CONTROL_PED = FOSSIL_STEAM_SUPPLY__CONTROL_PED;

    /**
     * The feature id for the '<em><b>Control TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__CONTROL_TC = FOSSIL_STEAM_SUPPLY__CONTROL_TC;

    /**
     * The feature id for the '<em><b>Feed Water IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__FEED_WATER_IG = FOSSIL_STEAM_SUPPLY__FEED_WATER_IG;

    /**
     * The feature id for the '<em><b>Feed Water PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__FEED_WATER_PG = FOSSIL_STEAM_SUPPLY__FEED_WATER_PG;

    /**
     * The feature id for the '<em><b>Feed Water TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__FEED_WATER_TC = FOSSIL_STEAM_SUPPLY__FEED_WATER_TC;

    /**
     * The feature id for the '<em><b>Fuel Demand Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__FUEL_DEMAND_LIMIT = FOSSIL_STEAM_SUPPLY__FUEL_DEMAND_LIMIT;

    /**
     * The feature id for the '<em><b>Fuel Supply Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__FUEL_SUPPLY_DELAY = FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_DELAY;

    /**
     * The feature id for the '<em><b>Fuel Supply TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__FUEL_SUPPLY_TC = FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_TC;

    /**
     * The feature id for the '<em><b>Max Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__MAX_ERROR_RATE_P = FOSSIL_STEAM_SUPPLY__MAX_ERROR_RATE_P;

    /**
     * The feature id for the '<em><b>Mech Power Sensor Lag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__MECH_POWER_SENSOR_LAG = FOSSIL_STEAM_SUPPLY__MECH_POWER_SENSOR_LAG;

    /**
     * The feature id for the '<em><b>Min Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__MIN_ERROR_RATE_P = FOSSIL_STEAM_SUPPLY__MIN_ERROR_RATE_P;

    /**
     * The feature id for the '<em><b>Pressure Ctrl DG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__PRESSURE_CTRL_DG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_DG;

    /**
     * The feature id for the '<em><b>Pressure Ctrl IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__PRESSURE_CTRL_IG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_IG;

    /**
     * The feature id for the '<em><b>Pressure Ctrl PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__PRESSURE_CTRL_PG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_PG;

    /**
     * The feature id for the '<em><b>Pressure Feedback</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__PRESSURE_FEEDBACK = FOSSIL_STEAM_SUPPLY__PRESSURE_FEEDBACK;

    /**
     * The feature id for the '<em><b>Super Heater1 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__SUPER_HEATER1_CAPACITY = FOSSIL_STEAM_SUPPLY__SUPER_HEATER1_CAPACITY;

    /**
     * The feature id for the '<em><b>Super Heater2 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__SUPER_HEATER2_CAPACITY = FOSSIL_STEAM_SUPPLY__SUPER_HEATER2_CAPACITY;

    /**
     * The feature id for the '<em><b>Super Heater Pipe PD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__SUPER_HEATER_PIPE_PD = FOSSIL_STEAM_SUPPLY__SUPER_HEATER_PIPE_PD;

    /**
     * The feature id for the '<em><b>Throttle Pressure SP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL__THROTTLE_PRESSURE_SP = FOSSIL_STEAM_SUPPLY__THROTTLE_PRESSURE_SP;

    /**
     * The number of structural features of the '<em>Supercritical</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL_FEATURE_COUNT = FOSSIL_STEAM_SUPPLY_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Supercritical</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUPERCRITICAL_OPERATION_COUNT = FOSSIL_STEAM_SUPPLY_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Diagram</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE__DIAGRAM = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Diagram Style</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Diagram Style</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_STYLE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Emission Content</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__EMISSION_CONTENT = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Emission Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__EMISSION_TYPE = CURVE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Is Net Gross P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__IS_NET_GROSS_P = CURVE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE__THERMAL_GENERATING_UNIT = CURVE_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Emission Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Emission Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int EMISSION_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Hydro Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE__HYDRO_GENERATING_UNIT = CURVE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Tailbay Loss Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Tailbay Loss Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TAILBAY_LOSS_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__ID = OPERATIONAL_LIMIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__ALIAS_NAME = OPERATIONAL_LIMIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__DESCRIPTION = OPERATIONAL_LIMIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__MRID = OPERATIONAL_LIMIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__NAME = OPERATIONAL_LIMIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__NAMES = OPERATIONAL_LIMIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__DIAGRAM_OBJECTS = OPERATIONAL_LIMIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Operational Limit Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__OPERATIONAL_LIMIT_TYPE = OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_TYPE;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__OPERATIONAL_LIMIT_SET = OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT__VALUE = OPERATIONAL_LIMIT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Apparent Power Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT_FEATURE_COUNT = OPERATIONAL_LIMIT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Apparent Power Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int APPARENT_POWER_LIMIT_OPERATION_COUNT = OPERATIONAL_LIMIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Active Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__ACTIVE_POWER = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Nominal Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__NOMINAL_VOLTAGE = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__R = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__R0 = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Reactive Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__REACTIVE_POWER = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Rn</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__RN = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Voltage Angle</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__VOLTAGE_ANGLE = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Voltage Magnitude</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__VOLTAGE_MAGNITUDE = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__X = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__X0 = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Xn</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE__XN = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 10;

    /**
     * The number of structural features of the '<em>Energy Source</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 11;

    /**
     * The number of operations of the '<em>Energy Source</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_SOURCE_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Orientation</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__ORIENTATION = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>X1 Initial View</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__X1_INITIAL_VIEW = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>X2 Initial View</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__X2_INITIAL_VIEW = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Y1 Initial View</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__Y1_INITIAL_VIEW = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Y2 Initial View</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__Y2_INITIAL_VIEW = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Diagram Style</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__DIAGRAM_STYLE = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Diagram Elements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM__DIAGRAM_ELEMENTS = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Diagram</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Diagram</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__ID = MEASUREMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__ALIAS_NAME = MEASUREMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__DESCRIPTION = MEASUREMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__MRID = MEASUREMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__NAME = MEASUREMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__NAMES = MEASUREMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__DIAGRAM_OBJECTS = MEASUREMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurement Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__MEASUREMENT_TYPE = MEASUREMENT__MEASUREMENT_TYPE;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__PHASES = MEASUREMENT__PHASES;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__UNIT_MULTIPLIER = MEASUREMENT__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__UNIT_SYMBOL = MEASUREMENT__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__TERMINAL = MEASUREMENT__TERMINAL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__POWER_SYSTEM_RESOURCE = MEASUREMENT__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>String Measurement Values</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT__STRING_MEASUREMENT_VALUES = MEASUREMENT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>String Measurement</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_FEATURE_COUNT = MEASUREMENT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>String Measurement</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STRING_MEASUREMENT_OPERATION_COUNT = MEASUREMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Shutdown Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__SHUTDOWN_COST = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Shutdown Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__SHUTDOWN_DATE = CURVE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE__THERMAL_GENERATING_UNIT = CURVE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Shutdown Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Shutdown Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SHUTDOWN_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__ID = REGULAR_INTERVAL_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__ALIAS_NAME = REGULAR_INTERVAL_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__DESCRIPTION = REGULAR_INTERVAL_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__MRID = REGULAR_INTERVAL_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__NAME = REGULAR_INTERVAL_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__NAMES = REGULAR_INTERVAL_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__DIAGRAM_OBJECTS = REGULAR_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__START_TIME = REGULAR_INTERVAL_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__VALUE1_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__VALUE1_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__VALUE2_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__VALUE2_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__END_TIME = REGULAR_INTERVAL_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__TIME_STEP = REGULAR_INTERVAL_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__TIME_POINTS = REGULAR_INTERVAL_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Hydro Pump</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE__HYDRO_PUMP = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Hydro Pump Op Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE_FEATURE_COUNT = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Hydro Pump Op Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_PUMP_OP_SCHEDULE_OPERATION_COUNT = REGULAR_INTERVAL_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Hot Standby Ramp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__HOT_STANDBY_RAMP = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Startup Model</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE__STARTUP_MODEL = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Start Ramp Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Start Ramp Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_RAMP_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__ID = ACDC_CONVERTER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__ALIAS_NAME = ACDC_CONVERTER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__DESCRIPTION = ACDC_CONVERTER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__MRID = ACDC_CONVERTER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__NAME = ACDC_CONVERTER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__NAMES = ACDC_CONVERTER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__DIAGRAM_OBJECTS = ACDC_CONVERTER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__MEASUREMENTS = ACDC_CONVERTER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__CONTROLS = ACDC_CONVERTER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__OPERATING_SHARE = ACDC_CONVERTER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__PSR_TYPE = ACDC_CONVERTER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__AGGREGATE = ACDC_CONVERTER__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__NORMALLY_IN_SERVICE = ACDC_CONVERTER__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__CONTINGENCY_EQUIPMENT = ACDC_CONVERTER__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__OPERATIONAL_LIMIT_SET = ACDC_CONVERTER__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__FAULTS = ACDC_CONVERTER__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__EQUIPMENT_CONTAINER = ACDC_CONVERTER__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__PROTECTION_EQUIPMENTS = ACDC_CONVERTER__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__BASE_VOLTAGE = ACDC_CONVERTER__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__SV_STATUS = ACDC_CONVERTER__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__TERMINALS = ACDC_CONVERTER__TERMINALS;

    /**
     * The feature id for the '<em><b>Base S</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__BASE_S = ACDC_CONVERTER__BASE_S;

    /**
     * The feature id for the '<em><b>Idc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__IDC = ACDC_CONVERTER__IDC;

    /**
     * The feature id for the '<em><b>Idle Loss</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__IDLE_LOSS = ACDC_CONVERTER__IDLE_LOSS;

    /**
     * The feature id for the '<em><b>Max Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__MAX_UDC = ACDC_CONVERTER__MAX_UDC;

    /**
     * The feature id for the '<em><b>Min Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__MIN_UDC = ACDC_CONVERTER__MIN_UDC;

    /**
     * The feature id for the '<em><b>Number Of Valves</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__NUMBER_OF_VALVES = ACDC_CONVERTER__NUMBER_OF_VALVES;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__P = ACDC_CONVERTER__P;

    /**
     * The feature id for the '<em><b>Pole Loss P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__POLE_LOSS_P = ACDC_CONVERTER__POLE_LOSS_P;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__Q = ACDC_CONVERTER__Q;

    /**
     * The feature id for the '<em><b>Rated Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__RATED_UDC = ACDC_CONVERTER__RATED_UDC;

    /**
     * The feature id for the '<em><b>Resistive Loss</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__RESISTIVE_LOSS = ACDC_CONVERTER__RESISTIVE_LOSS;

    /**
     * The feature id for the '<em><b>Switching Loss</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__SWITCHING_LOSS = ACDC_CONVERTER__SWITCHING_LOSS;

    /**
     * The feature id for the '<em><b>Target Ppcc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__TARGET_PPCC = ACDC_CONVERTER__TARGET_PPCC;

    /**
     * The feature id for the '<em><b>Target Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__TARGET_UDC = ACDC_CONVERTER__TARGET_UDC;

    /**
     * The feature id for the '<em><b>Uc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__UC = ACDC_CONVERTER__UC;

    /**
     * The feature id for the '<em><b>Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__UDC = ACDC_CONVERTER__UDC;

    /**
     * The feature id for the '<em><b>Valve U0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__VALVE_U0 = ACDC_CONVERTER__VALVE_U0;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__DC_TERMINALS = ACDC_CONVERTER__DC_TERMINALS;

    /**
     * The feature id for the '<em><b>Pcc Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__PCC_TERMINAL = ACDC_CONVERTER__PCC_TERMINAL;

    /**
     * The feature id for the '<em><b>Delta</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__DELTA = ACDC_CONVERTER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Droop</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__DROOP = ACDC_CONVERTER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Droop Compensation</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__DROOP_COMPENSATION = ACDC_CONVERTER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Max Modulation Index</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__MAX_MODULATION_INDEX = ACDC_CONVERTER_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Max Valve Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__MAX_VALVE_CURRENT = ACDC_CONVERTER_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>PPcc Control</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__PPCC_CONTROL = ACDC_CONVERTER_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>QPcc Control</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__QPCC_CONTROL = ACDC_CONVERTER_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>QShare</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__QSHARE = ACDC_CONVERTER_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Target Qpcc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__TARGET_QPCC = ACDC_CONVERTER_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Target Upcc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__TARGET_UPCC = ACDC_CONVERTER_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Uf</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__UF = ACDC_CONVERTER_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Capability Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER__CAPABILITY_CURVE = ACDC_CONVERTER_FEATURE_COUNT + 11;

    /**
     * The number of structural features of the '<em>Vs Converter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER_FEATURE_COUNT = ACDC_CONVERTER_FEATURE_COUNT + 12;

    /**
     * The number of operations of the '<em>Vs Converter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VS_CONVERTER_OPERATION_COUNT = ACDC_CONVERTER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__ID = GENERATING_UNIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__ALIAS_NAME = GENERATING_UNIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__DESCRIPTION = GENERATING_UNIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__MRID = GENERATING_UNIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__NAME = GENERATING_UNIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__NAMES = GENERATING_UNIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__DIAGRAM_OBJECTS = GENERATING_UNIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__MEASUREMENTS = GENERATING_UNIT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__CONTROLS = GENERATING_UNIT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__OPERATING_SHARE = GENERATING_UNIT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__PSR_TYPE = GENERATING_UNIT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__AGGREGATE = GENERATING_UNIT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__NORMALLY_IN_SERVICE = GENERATING_UNIT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__CONTINGENCY_EQUIPMENT = GENERATING_UNIT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__OPERATIONAL_LIMIT_SET = GENERATING_UNIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__FAULTS = GENERATING_UNIT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__EQUIPMENT_CONTAINER = GENERATING_UNIT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Alloc Spin Res P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__ALLOC_SPIN_RES_P = GENERATING_UNIT__ALLOC_SPIN_RES_P;

    /**
     * The feature id for the '<em><b>Auto Cntrl Margin P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__AUTO_CNTRL_MARGIN_P = GENERATING_UNIT__AUTO_CNTRL_MARGIN_P;

    /**
     * The feature id for the '<em><b>Base P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__BASE_P = GENERATING_UNIT__BASE_P;

    /**
     * The feature id for the '<em><b>Control Deadband</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__CONTROL_DEADBAND = GENERATING_UNIT__CONTROL_DEADBAND;

    /**
     * The feature id for the '<em><b>Control Pulse High</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__CONTROL_PULSE_HIGH = GENERATING_UNIT__CONTROL_PULSE_HIGH;

    /**
     * The feature id for the '<em><b>Control Pulse Low</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__CONTROL_PULSE_LOW = GENERATING_UNIT__CONTROL_PULSE_LOW;

    /**
     * The feature id for the '<em><b>Control Response Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__CONTROL_RESPONSE_RATE = GENERATING_UNIT__CONTROL_RESPONSE_RATE;

    /**
     * The feature id for the '<em><b>Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__EFFICIENCY = GENERATING_UNIT__EFFICIENCY;

    /**
     * The feature id for the '<em><b>Gen Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__GEN_CONTROL_MODE = GENERATING_UNIT__GEN_CONTROL_MODE;

    /**
     * The feature id for the '<em><b>Gen Control Source</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__GEN_CONTROL_SOURCE = GENERATING_UNIT__GEN_CONTROL_SOURCE;

    /**
     * The feature id for the '<em><b>Governor MPL</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__GOVERNOR_MPL = GENERATING_UNIT__GOVERNOR_MPL;

    /**
     * The feature id for the '<em><b>Governor SCD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__GOVERNOR_SCD = GENERATING_UNIT__GOVERNOR_SCD;

    /**
     * The feature id for the '<em><b>High Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__HIGH_CONTROL_LIMIT = GENERATING_UNIT__HIGH_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Initial P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__INITIAL_P = GENERATING_UNIT__INITIAL_P;

    /**
     * The feature id for the '<em><b>Long PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__LONG_PF = GENERATING_UNIT__LONG_PF;

    /**
     * The feature id for the '<em><b>Low Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__LOW_CONTROL_LIMIT = GENERATING_UNIT__LOW_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Lower Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__LOWER_RAMP_RATE = GENERATING_UNIT__LOWER_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Max Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__MAX_ECONOMIC_P = GENERATING_UNIT__MAX_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Maximum Allowable Spinning Reserve</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE = GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE;

    /**
     * The feature id for the '<em><b>Max Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__MAX_OPERATING_P = GENERATING_UNIT__MAX_OPERATING_P;

    /**
     * The feature id for the '<em><b>Min Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__MIN_ECONOMIC_P = GENERATING_UNIT__MIN_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Minimum Off Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__MINIMUM_OFF_TIME = GENERATING_UNIT__MINIMUM_OFF_TIME;

    /**
     * The feature id for the '<em><b>Min Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__MIN_OPERATING_P = GENERATING_UNIT__MIN_OPERATING_P;

    /**
     * The feature id for the '<em><b>Model Detail</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__MODEL_DETAIL = GENERATING_UNIT__MODEL_DETAIL;

    /**
     * The feature id for the '<em><b>Nominal P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__NOMINAL_P = GENERATING_UNIT__NOMINAL_P;

    /**
     * The feature id for the '<em><b>Normal PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__NORMAL_PF = GENERATING_UNIT__NORMAL_PF;

    /**
     * The feature id for the '<em><b>Penalty Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__PENALTY_FACTOR = GENERATING_UNIT__PENALTY_FACTOR;

    /**
     * The feature id for the '<em><b>Raise Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__RAISE_RAMP_RATE = GENERATING_UNIT__RAISE_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Rated Gross Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__RATED_GROSS_MAX_P = GENERATING_UNIT__RATED_GROSS_MAX_P;

    /**
     * The feature id for the '<em><b>Rated Gross Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__RATED_GROSS_MIN_P = GENERATING_UNIT__RATED_GROSS_MIN_P;

    /**
     * The feature id for the '<em><b>Rated Net Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__RATED_NET_MAX_P = GENERATING_UNIT__RATED_NET_MAX_P;

    /**
     * The feature id for the '<em><b>Short PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__SHORT_PF = GENERATING_UNIT__SHORT_PF;

    /**
     * The feature id for the '<em><b>Startup Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__STARTUP_COST = GENERATING_UNIT__STARTUP_COST;

    /**
     * The feature id for the '<em><b>Startup Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__STARTUP_TIME = GENERATING_UNIT__STARTUP_TIME;

    /**
     * The feature id for the '<em><b>Tie Line PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__TIE_LINE_PF = GENERATING_UNIT__TIE_LINE_PF;

    /**
     * The feature id for the '<em><b>Total Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__TOTAL_EFFICIENCY = GENERATING_UNIT__TOTAL_EFFICIENCY;

    /**
     * The feature id for the '<em><b>Variable Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__VARIABLE_COST = GENERATING_UNIT__VARIABLE_COST;

    /**
     * The feature id for the '<em><b>Gross To Net Active Power Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES = GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES;

    /**
     * The feature id for the '<em><b>Rotating Machine</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__ROTATING_MACHINE = GENERATING_UNIT__ROTATING_MACHINE;

    /**
     * The feature id for the '<em><b>Control Area Generating Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT = GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT;

    /**
     * The feature id for the '<em><b>Gen Unit Op Cost Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES = GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES;

    /**
     * The feature id for the '<em><b>Gen Unit Op Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE = GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE;

    /**
     * The feature id for the '<em><b>OM Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__OM_COST = GENERATING_UNIT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Incremental Heat Rate Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__INCREMENTAL_HEAT_RATE_CURVE = GENERATING_UNIT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Cogeneration Plant</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__COGENERATION_PLANT = GENERATING_UNIT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Combined Cycle Plant</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__COMBINED_CYCLE_PLANT = GENERATING_UNIT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Heat Rate Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__HEAT_RATE_CURVE = GENERATING_UNIT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Fossil Fuels</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__FOSSIL_FUELS = GENERATING_UNIT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Heat Input Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__HEAT_INPUT_CURVE = GENERATING_UNIT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Emission Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__EMISSION_CURVES = GENERATING_UNIT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Emmission Accounts</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__EMMISSION_ACCOUNTS = GENERATING_UNIT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>CAES Plant</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__CAES_PLANT = GENERATING_UNIT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Fuel Allocation Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__FUEL_ALLOCATION_SCHEDULES = GENERATING_UNIT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Shutdown Curve</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__SHUTDOWN_CURVE = GENERATING_UNIT_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Startup Model</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT__STARTUP_MODEL = GENERATING_UNIT_FEATURE_COUNT + 12;

    /**
     * The number of structural features of the '<em>Thermal Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT_FEATURE_COUNT = GENERATING_UNIT_FEATURE_COUNT + 13;

    /**
     * The number of operations of the '<em>Thermal Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int THERMAL_GENERATING_UNIT_OPERATION_COUNT = GENERATING_UNIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__ID = DC_SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__ALIAS_NAME = DC_SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__DESCRIPTION = DC_SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__MRID = DC_SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__NAME = DC_SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__NAMES = DC_SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__DIAGRAM_OBJECTS = DC_SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__MEASUREMENTS = DC_SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__CONTROLS = DC_SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__OPERATING_SHARE = DC_SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__PSR_TYPE = DC_SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__AGGREGATE = DC_SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__NORMALLY_IN_SERVICE = DC_SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__CONTINGENCY_EQUIPMENT = DC_SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__OPERATIONAL_LIMIT_SET = DC_SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__FAULTS = DC_SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__EQUIPMENT_CONTAINER = DC_SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER__DC_TERMINALS = DC_SWITCH__DC_TERMINALS;

    /**
     * The number of structural features of the '<em>DC Breaker</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER_FEATURE_COUNT = DC_SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>DC Breaker</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_BREAKER_OPERATION_COUNT = DC_SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Pfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__PFIXED = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Pfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__PFIXED_PCT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Phase</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__PHASE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Qfixed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__QFIXED = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Qfixed Pct</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__QFIXED_PCT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Energy Consumer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE__ENERGY_CONSUMER = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Energy Consumer Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Energy Consumer Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ENERGY_CONSUMER_PHASE_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__ID = AUXILIARY_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__ALIAS_NAME = AUXILIARY_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__DESCRIPTION = AUXILIARY_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__MRID = AUXILIARY_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__NAME = AUXILIARY_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__NAMES = AUXILIARY_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__DIAGRAM_OBJECTS = AUXILIARY_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__MEASUREMENTS = AUXILIARY_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__CONTROLS = AUXILIARY_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__OPERATING_SHARE = AUXILIARY_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__PSR_TYPE = AUXILIARY_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__AGGREGATE = AUXILIARY_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__NORMALLY_IN_SERVICE = AUXILIARY_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__CONTINGENCY_EQUIPMENT = AUXILIARY_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__OPERATIONAL_LIMIT_SET = AUXILIARY_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__FAULTS = AUXILIARY_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__EQUIPMENT_CONTAINER = AUXILIARY_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR__TERMINAL = AUXILIARY_EQUIPMENT__TERMINAL;

    /**
     * The number of structural features of the '<em>Fault Indicator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR_FEATURE_COUNT = AUXILIARY_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Fault Indicator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FAULT_INDICATOR_OPERATION_COUNT = AUXILIARY_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Hydro Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE__HYDRO_GENERATING_UNIT = CURVE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Hydro Generating Efficiency Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Hydro Generating Efficiency Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_GENERATING_EFFICIENCY_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__ID = EQUIPMENT_CONTAINER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__ALIAS_NAME = EQUIPMENT_CONTAINER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__DESCRIPTION = EQUIPMENT_CONTAINER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__MRID = EQUIPMENT_CONTAINER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__NAME = EQUIPMENT_CONTAINER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__NAMES = EQUIPMENT_CONTAINER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__DIAGRAM_OBJECTS = EQUIPMENT_CONTAINER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__MEASUREMENTS = EQUIPMENT_CONTAINER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__CONTROLS = EQUIPMENT_CONTAINER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__OPERATING_SHARE = EQUIPMENT_CONTAINER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__PSR_TYPE = EQUIPMENT_CONTAINER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__CONNECTIVITY_NODES = EQUIPMENT_CONTAINER__CONNECTIVITY_NODES;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__TOPOLOGICAL_NODE = EQUIPMENT_CONTAINER__TOPOLOGICAL_NODE;

    /**
     * The feature id for the '<em><b>Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__EQUIPMENTS = EQUIPMENT_CONTAINER__EQUIPMENTS;

    /**
     * The feature id for the '<em><b>DC Converter Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__DC_CONVERTER_UNIT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Voltage Levels</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__VOLTAGE_LEVELS = EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Bays</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__BAYS = EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Region</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION__REGION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Substation</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION_FEATURE_COUNT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Substation</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SUBSTATION_OPERATION_COUNT = EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Operational Limit Value</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__OPERATIONAL_LIMIT_VALUE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__TERMINAL = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Equipment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET__EQUIPMENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Operational Limit Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Operational Limit Set</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OPERATIONAL_LIMIT_SET_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Discharge Travel Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__DISCHARGE_TRAVEL_DELAY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Gen Rated P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__GEN_RATED_P = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Hydro Plant Storage Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__HYDRO_PLANT_STORAGE_TYPE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Penstock Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__PENSTOCK_TYPE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Plant Discharge Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__PLANT_DISCHARGE_CAPACITY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Plant Rated Head</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__PLANT_RATED_HEAD = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Pump Rated P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__PUMP_RATED_P = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Surge Tank Code</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__SURGE_TANK_CODE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Surge Tank Crest Level</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__SURGE_TANK_CREST_LEVEL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Hydro Pumps</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__HYDRO_PUMPS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Hydro Generating Units</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__HYDRO_GENERATING_UNITS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Gen Source Pump Discharge Reservoir</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__GEN_SOURCE_PUMP_DISCHARGE_RESERVOIR = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Reservoir</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT__RESERVOIR = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 12;

    /**
     * The number of structural features of the '<em>Hydro Power Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 13;

    /**
     * The number of operations of the '<em>Hydro Power Plant</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HYDRO_POWER_PLANT_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__ID = AUXILIARY_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__ALIAS_NAME = AUXILIARY_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__DESCRIPTION = AUXILIARY_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__MRID = AUXILIARY_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__NAME = AUXILIARY_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__NAMES = AUXILIARY_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__DIAGRAM_OBJECTS = AUXILIARY_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__MEASUREMENTS = AUXILIARY_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__CONTROLS = AUXILIARY_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__OPERATING_SHARE = AUXILIARY_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__PSR_TYPE = AUXILIARY_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__AGGREGATE = AUXILIARY_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__NORMALLY_IN_SERVICE = AUXILIARY_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__CONTINGENCY_EQUIPMENT = AUXILIARY_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__OPERATIONAL_LIMIT_SET = AUXILIARY_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__FAULTS = AUXILIARY_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__EQUIPMENT_CONTAINER = AUXILIARY_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER__TERMINAL = AUXILIARY_EQUIPMENT__TERMINAL;

    /**
     * The number of structural features of the '<em>Surge Arrester</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER_FEATURE_COUNT = AUXILIARY_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Surge Arrester</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SURGE_ARRESTER_OPERATION_COUNT = AUXILIARY_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>B0ch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__B0CH = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Distance11</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__DISTANCE11 = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Distance12</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__DISTANCE12 = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Distance21</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__DISTANCE21 = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Distance22</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__DISTANCE22 = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>G0ch</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__G0CH = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__R0 = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__X0 = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Second Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__SECOND_TERMINAL = IDENTIFIED_OBJECT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>First Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING__FIRST_TERMINAL = IDENTIFIED_OBJECT_FEATURE_COUNT + 9;

    /**
     * The number of structural features of the '<em>Mutual Coupling</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 10;

    /**
     * The number of operations of the '<em>Mutual Coupling</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MUTUAL_COUPLING_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_GLUE_POINT__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Diagram Object Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_GLUE_POINT__DIAGRAM_OBJECT_POINTS = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Diagram Object Glue Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_GLUE_POINT_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Diagram Object Glue Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DIAGRAM_OBJECT_GLUE_POINT_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Alt Generating Unit Meas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__ALT_GENERATING_UNIT_MEAS = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Control Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__CONTROL_AREA = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT__GENERATING_UNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Control Area Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Control Area Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONTROL_AREA_GENERATING_UNIT_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Is Net Gross P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__IS_NET_GROSS_P = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE__THERMAL_GENERATING_UNIT = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Heat Rate Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Heat Rate Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_RATE_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__ID = SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__ALIAS_NAME = SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__DESCRIPTION = SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__MRID = SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__NAME = SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__NAMES = SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__DIAGRAM_OBJECTS = SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__MEASUREMENTS = SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__CONTROLS = SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__OPERATING_SHARE = SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__PSR_TYPE = SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__AGGREGATE = SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__NORMALLY_IN_SERVICE = SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__CONTINGENCY_EQUIPMENT = SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__OPERATIONAL_LIMIT_SET = SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__FAULTS = SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__EQUIPMENT_CONTAINER = SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__PROTECTION_EQUIPMENTS = SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__BASE_VOLTAGE = SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__SV_STATUS = SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__TERMINALS = SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__NORMAL_OPEN = SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__OPEN = SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__RATED_CURRENT = SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__RETAINED = SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__SWITCH_ON_COUNT = SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__SWITCH_ON_DATE = SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__COMPOSITE_SWITCH = SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__SWITCH_SCHEDULES = SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER__SWITCH_PHASE = SWITCH__SWITCH_PHASE;

    /**
     * The number of structural features of the '<em>Jumper</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER_FEATURE_COUNT = SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Jumper</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int JUMPER_OPERATION_COUNT = SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__ID = REGULAR_INTERVAL_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__ALIAS_NAME = REGULAR_INTERVAL_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__DESCRIPTION = REGULAR_INTERVAL_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__MRID = REGULAR_INTERVAL_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__NAME = REGULAR_INTERVAL_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__NAMES = REGULAR_INTERVAL_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__DIAGRAM_OBJECTS = REGULAR_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__START_TIME = REGULAR_INTERVAL_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__VALUE1_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__VALUE1_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__VALUE2_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__VALUE2_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__END_TIME = REGULAR_INTERVAL_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__TIME_STEP = REGULAR_INTERVAL_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__TIME_POINTS = REGULAR_INTERVAL_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Reservoir</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST__RESERVOIR = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Inflow Forecast</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST_FEATURE_COUNT = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Inflow Forecast</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int INFLOW_FORECAST_OPERATION_COUNT = REGULAR_INTERVAL_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__ID = SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__ALIAS_NAME = SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__DESCRIPTION = SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__MRID = SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__NAME = SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__NAMES = SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__DIAGRAM_OBJECTS = SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__MEASUREMENTS = SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__CONTROLS = SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__OPERATING_SHARE = SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__PSR_TYPE = SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__AGGREGATE = SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__NORMALLY_IN_SERVICE = SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__CONTINGENCY_EQUIPMENT = SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__OPERATIONAL_LIMIT_SET = SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__FAULTS = SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__EQUIPMENT_CONTAINER = SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__PROTECTION_EQUIPMENTS = SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__BASE_VOLTAGE = SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__SV_STATUS = SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__TERMINALS = SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__NORMAL_OPEN = SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__OPEN = SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__RATED_CURRENT = SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__RETAINED = SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__SWITCH_ON_COUNT = SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__SWITCH_ON_DATE = SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__COMPOSITE_SWITCH = SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__SWITCH_SCHEDULES = SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__SWITCH_PHASE = SWITCH__SWITCH_PHASE;

    /**
     * The feature id for the '<em><b>Length From Terminal1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__LENGTH_FROM_TERMINAL1 = SWITCH_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>AC Line Segment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT__AC_LINE_SEGMENT = SWITCH_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Cut</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT_FEATURE_COUNT = SWITCH_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Cut</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CUT_OPERATION_COUNT = SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__TERMINALS = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Connectivity Node Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__CONNECTIVITY_NODE_CONTAINER = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE__TOPOLOGICAL_NODE = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Connectivity Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Connectivity Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CONNECTIVITY_NODE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>PInjection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__PINJECTION = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>QInjection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__QINJECTION = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__BASE_VOLTAGE = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__TERMINAL = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Sv Injection</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__SV_INJECTION = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Connectivity Node Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__CONNECTIVITY_NODE_CONTAINER = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Connectivity Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__CONNECTIVITY_NODES = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Sv Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__SV_VOLTAGE = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Angle Ref Topological Island</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__ANGLE_REF_TOPOLOGICAL_ISLAND = IDENTIFIED_OBJECT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Topological Island</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE__TOPOLOGICAL_ISLAND = IDENTIFIED_OBJECT_FEATURE_COUNT + 9;

    /**
     * The number of structural features of the '<em>Topological Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 10;

    /**
     * The number of operations of the '<em>Topological Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_NODE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__ID = STEAM_SUPPLY__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__ALIAS_NAME = STEAM_SUPPLY__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__DESCRIPTION = STEAM_SUPPLY__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__MRID = STEAM_SUPPLY__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__NAME = STEAM_SUPPLY__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__NAMES = STEAM_SUPPLY__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__DIAGRAM_OBJECTS = STEAM_SUPPLY__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__MEASUREMENTS = STEAM_SUPPLY__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__CONTROLS = STEAM_SUPPLY__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__OPERATING_SHARE = STEAM_SUPPLY__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__PSR_TYPE = STEAM_SUPPLY__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Steam Supply Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__STEAM_SUPPLY_RATING = STEAM_SUPPLY__STEAM_SUPPLY_RATING;

    /**
     * The feature id for the '<em><b>Steam Turbines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__STEAM_TURBINES = STEAM_SUPPLY__STEAM_TURBINES;

    /**
     * The feature id for the '<em><b>Cold Leg FB Lag TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__COLD_LEG_FB_LAG_TC = STEAM_SUPPLY_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Cold Leg FB Lead TC1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__COLD_LEG_FB_LEAD_TC1 = STEAM_SUPPLY_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Cold Leg FB Lead TC2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__COLD_LEG_FB_LEAD_TC2 = STEAM_SUPPLY_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Cold Leg FG1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__COLD_LEG_FG1 = STEAM_SUPPLY_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Cold Leg FG2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__COLD_LEG_FG2 = STEAM_SUPPLY_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Cold Leg Lag TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__COLD_LEG_LAG_TC = STEAM_SUPPLY_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Core HT Lag TC1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__CORE_HT_LAG_TC1 = STEAM_SUPPLY_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Core HT Lag TC2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__CORE_HT_LAG_TC2 = STEAM_SUPPLY_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Core Neutronics Eff TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__CORE_NEUTRONICS_EFF_TC = STEAM_SUPPLY_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Core Neutronics HT</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__CORE_NEUTRONICS_HT = STEAM_SUPPLY_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Feedback Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__FEEDBACK_FACTOR = STEAM_SUPPLY_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Hot Leg Lag TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__HOT_LEG_LAG_TC = STEAM_SUPPLY_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Hot Leg Steam Gain</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__HOT_LEG_STEAM_GAIN = STEAM_SUPPLY_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Hot Leg To Cold Leg Gain</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__HOT_LEG_TO_COLD_LEG_GAIN = STEAM_SUPPLY_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Pressure CG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__PRESSURE_CG = STEAM_SUPPLY_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Steam Flow FG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__STEAM_FLOW_FG = STEAM_SUPPLY_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Steam Pressure Drop Lag TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__STEAM_PRESSURE_DROP_LAG_TC = STEAM_SUPPLY_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>Steam Pressure FG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__STEAM_PRESSURE_FG = STEAM_SUPPLY_FEATURE_COUNT + 17;

    /**
     * The feature id for the '<em><b>Throttle Pressure Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__THROTTLE_PRESSURE_FACTOR = STEAM_SUPPLY_FEATURE_COUNT + 18;

    /**
     * The feature id for the '<em><b>Throttle Pressure SP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY__THROTTLE_PRESSURE_SP = STEAM_SUPPLY_FEATURE_COUNT + 19;

    /**
     * The number of structural features of the '<em>PWR Steam Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY_FEATURE_COUNT = STEAM_SUPPLY_FEATURE_COUNT + 20;

    /**
     * The number of operations of the '<em>PWR Steam Supply</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PWR_STEAM_SUPPLY_OPERATION_COUNT = STEAM_SUPPLY_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Fossil Fuel Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__FOSSIL_FUEL_TYPE = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Fuel Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__FUEL_COST = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Fuel Dispatch Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__FUEL_DISPATCH_COST = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Fuel Eff Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__FUEL_EFF_FACTOR = IDENTIFIED_OBJECT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Fuel Handling Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__FUEL_HANDLING_COST = IDENTIFIED_OBJECT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Fuel Heat Content</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__FUEL_HEAT_CONTENT = IDENTIFIED_OBJECT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Fuel Mixture</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__FUEL_MIXTURE = IDENTIFIED_OBJECT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Fuel Sulfur</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__FUEL_SULFUR = IDENTIFIED_OBJECT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>High Breakpoint P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__HIGH_BREAKPOINT_P = IDENTIFIED_OBJECT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Low Breakpoint P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__LOW_BREAKPOINT_P = IDENTIFIED_OBJECT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Fuel Allocation Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__FUEL_ALLOCATION_SCHEDULES = IDENTIFIED_OBJECT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL__THERMAL_GENERATING_UNIT = IDENTIFIED_OBJECT_FEATURE_COUNT + 11;

    /**
     * The number of structural features of the '<em>Fossil Fuel</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 12;

    /**
     * The number of operations of the '<em>Fossil Fuel</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOSSIL_FUEL_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__ID = EARTH_FAULT_COMPENSATOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__ALIAS_NAME = EARTH_FAULT_COMPENSATOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__DESCRIPTION = EARTH_FAULT_COMPENSATOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__MRID = EARTH_FAULT_COMPENSATOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__NAME = EARTH_FAULT_COMPENSATOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__NAMES = EARTH_FAULT_COMPENSATOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__DIAGRAM_OBJECTS = EARTH_FAULT_COMPENSATOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__MEASUREMENTS = EARTH_FAULT_COMPENSATOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__CONTROLS = EARTH_FAULT_COMPENSATOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__OPERATING_SHARE = EARTH_FAULT_COMPENSATOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__PSR_TYPE = EARTH_FAULT_COMPENSATOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__AGGREGATE = EARTH_FAULT_COMPENSATOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__NORMALLY_IN_SERVICE = EARTH_FAULT_COMPENSATOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__CONTINGENCY_EQUIPMENT = EARTH_FAULT_COMPENSATOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__OPERATIONAL_LIMIT_SET = EARTH_FAULT_COMPENSATOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__FAULTS = EARTH_FAULT_COMPENSATOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__EQUIPMENT_CONTAINER = EARTH_FAULT_COMPENSATOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__PROTECTION_EQUIPMENTS = EARTH_FAULT_COMPENSATOR__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__BASE_VOLTAGE = EARTH_FAULT_COMPENSATOR__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__SV_STATUS = EARTH_FAULT_COMPENSATOR__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__TERMINALS = EARTH_FAULT_COMPENSATOR__TERMINALS;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__R = EARTH_FAULT_COMPENSATOR__R;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE__X = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Grounding Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE_FEATURE_COUNT = EARTH_FAULT_COMPENSATOR_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Grounding Impedance</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUNDING_IMPEDANCE_OPERATION_COUNT = EARTH_FAULT_COMPENSATOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA__ID = ENERGY_AREA__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA__ALIAS_NAME = ENERGY_AREA__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA__DESCRIPTION = ENERGY_AREA__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA__MRID = ENERGY_AREA__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA__NAME = ENERGY_AREA__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA__NAMES = ENERGY_AREA__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA__DIAGRAM_OBJECTS = ENERGY_AREA__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Area</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA__CONTROL_AREA = ENERGY_AREA__CONTROL_AREA;

    /**
     * The feature id for the '<em><b>Sub Load Areas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA__SUB_LOAD_AREAS = ENERGY_AREA_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Load Area</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA_FEATURE_COUNT = ENERGY_AREA_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Load Area</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAD_AREA_OPERATION_COUNT = ENERGY_AREA_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__ID = GENERATING_UNIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__ALIAS_NAME = GENERATING_UNIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__DESCRIPTION = GENERATING_UNIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__MRID = GENERATING_UNIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__NAME = GENERATING_UNIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__NAMES = GENERATING_UNIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__DIAGRAM_OBJECTS = GENERATING_UNIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__MEASUREMENTS = GENERATING_UNIT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__CONTROLS = GENERATING_UNIT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__OPERATING_SHARE = GENERATING_UNIT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__PSR_TYPE = GENERATING_UNIT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__AGGREGATE = GENERATING_UNIT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__NORMALLY_IN_SERVICE = GENERATING_UNIT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__CONTINGENCY_EQUIPMENT = GENERATING_UNIT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__OPERATIONAL_LIMIT_SET = GENERATING_UNIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__FAULTS = GENERATING_UNIT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__EQUIPMENT_CONTAINER = GENERATING_UNIT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Alloc Spin Res P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__ALLOC_SPIN_RES_P = GENERATING_UNIT__ALLOC_SPIN_RES_P;

    /**
     * The feature id for the '<em><b>Auto Cntrl Margin P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__AUTO_CNTRL_MARGIN_P = GENERATING_UNIT__AUTO_CNTRL_MARGIN_P;

    /**
     * The feature id for the '<em><b>Base P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__BASE_P = GENERATING_UNIT__BASE_P;

    /**
     * The feature id for the '<em><b>Control Deadband</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__CONTROL_DEADBAND = GENERATING_UNIT__CONTROL_DEADBAND;

    /**
     * The feature id for the '<em><b>Control Pulse High</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__CONTROL_PULSE_HIGH = GENERATING_UNIT__CONTROL_PULSE_HIGH;

    /**
     * The feature id for the '<em><b>Control Pulse Low</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__CONTROL_PULSE_LOW = GENERATING_UNIT__CONTROL_PULSE_LOW;

    /**
     * The feature id for the '<em><b>Control Response Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__CONTROL_RESPONSE_RATE = GENERATING_UNIT__CONTROL_RESPONSE_RATE;

    /**
     * The feature id for the '<em><b>Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__EFFICIENCY = GENERATING_UNIT__EFFICIENCY;

    /**
     * The feature id for the '<em><b>Gen Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__GEN_CONTROL_MODE = GENERATING_UNIT__GEN_CONTROL_MODE;

    /**
     * The feature id for the '<em><b>Gen Control Source</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__GEN_CONTROL_SOURCE = GENERATING_UNIT__GEN_CONTROL_SOURCE;

    /**
     * The feature id for the '<em><b>Governor MPL</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__GOVERNOR_MPL = GENERATING_UNIT__GOVERNOR_MPL;

    /**
     * The feature id for the '<em><b>Governor SCD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__GOVERNOR_SCD = GENERATING_UNIT__GOVERNOR_SCD;

    /**
     * The feature id for the '<em><b>High Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__HIGH_CONTROL_LIMIT = GENERATING_UNIT__HIGH_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Initial P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__INITIAL_P = GENERATING_UNIT__INITIAL_P;

    /**
     * The feature id for the '<em><b>Long PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__LONG_PF = GENERATING_UNIT__LONG_PF;

    /**
     * The feature id for the '<em><b>Low Control Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__LOW_CONTROL_LIMIT = GENERATING_UNIT__LOW_CONTROL_LIMIT;

    /**
     * The feature id for the '<em><b>Lower Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__LOWER_RAMP_RATE = GENERATING_UNIT__LOWER_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Max Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__MAX_ECONOMIC_P = GENERATING_UNIT__MAX_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Maximum Allowable Spinning Reserve</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE = GENERATING_UNIT__MAXIMUM_ALLOWABLE_SPINNING_RESERVE;

    /**
     * The feature id for the '<em><b>Max Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__MAX_OPERATING_P = GENERATING_UNIT__MAX_OPERATING_P;

    /**
     * The feature id for the '<em><b>Min Economic P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__MIN_ECONOMIC_P = GENERATING_UNIT__MIN_ECONOMIC_P;

    /**
     * The feature id for the '<em><b>Minimum Off Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__MINIMUM_OFF_TIME = GENERATING_UNIT__MINIMUM_OFF_TIME;

    /**
     * The feature id for the '<em><b>Min Operating P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__MIN_OPERATING_P = GENERATING_UNIT__MIN_OPERATING_P;

    /**
     * The feature id for the '<em><b>Model Detail</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__MODEL_DETAIL = GENERATING_UNIT__MODEL_DETAIL;

    /**
     * The feature id for the '<em><b>Nominal P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__NOMINAL_P = GENERATING_UNIT__NOMINAL_P;

    /**
     * The feature id for the '<em><b>Normal PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__NORMAL_PF = GENERATING_UNIT__NORMAL_PF;

    /**
     * The feature id for the '<em><b>Penalty Factor</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__PENALTY_FACTOR = GENERATING_UNIT__PENALTY_FACTOR;

    /**
     * The feature id for the '<em><b>Raise Ramp Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__RAISE_RAMP_RATE = GENERATING_UNIT__RAISE_RAMP_RATE;

    /**
     * The feature id for the '<em><b>Rated Gross Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__RATED_GROSS_MAX_P = GENERATING_UNIT__RATED_GROSS_MAX_P;

    /**
     * The feature id for the '<em><b>Rated Gross Min P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__RATED_GROSS_MIN_P = GENERATING_UNIT__RATED_GROSS_MIN_P;

    /**
     * The feature id for the '<em><b>Rated Net Max P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__RATED_NET_MAX_P = GENERATING_UNIT__RATED_NET_MAX_P;

    /**
     * The feature id for the '<em><b>Short PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__SHORT_PF = GENERATING_UNIT__SHORT_PF;

    /**
     * The feature id for the '<em><b>Startup Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__STARTUP_COST = GENERATING_UNIT__STARTUP_COST;

    /**
     * The feature id for the '<em><b>Startup Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__STARTUP_TIME = GENERATING_UNIT__STARTUP_TIME;

    /**
     * The feature id for the '<em><b>Tie Line PF</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__TIE_LINE_PF = GENERATING_UNIT__TIE_LINE_PF;

    /**
     * The feature id for the '<em><b>Total Efficiency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__TOTAL_EFFICIENCY = GENERATING_UNIT__TOTAL_EFFICIENCY;

    /**
     * The feature id for the '<em><b>Variable Cost</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__VARIABLE_COST = GENERATING_UNIT__VARIABLE_COST;

    /**
     * The feature id for the '<em><b>Gross To Net Active Power Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES = GENERATING_UNIT__GROSS_TO_NET_ACTIVE_POWER_CURVES;

    /**
     * The feature id for the '<em><b>Rotating Machine</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__ROTATING_MACHINE = GENERATING_UNIT__ROTATING_MACHINE;

    /**
     * The feature id for the '<em><b>Control Area Generating Unit</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT = GENERATING_UNIT__CONTROL_AREA_GENERATING_UNIT;

    /**
     * The feature id for the '<em><b>Gen Unit Op Cost Curves</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES = GENERATING_UNIT__GEN_UNIT_OP_COST_CURVES;

    /**
     * The feature id for the '<em><b>Gen Unit Op Schedule</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE = GENERATING_UNIT__GEN_UNIT_OP_SCHEDULE;

    /**
     * The number of structural features of the '<em>Solar Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT_FEATURE_COUNT = GENERATING_UNIT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Solar Generating Unit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SOLAR_GENERATING_UNIT_OPERATION_COUNT = GENERATING_UNIT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Topological Nodes</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND__TOPOLOGICAL_NODES = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Angle Ref Topological Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND__ANGLE_REF_TOPOLOGICAL_NODE = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Topological Island</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Topological Island</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TOPOLOGICAL_ISLAND_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__ID = COMMAND__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__ALIAS_NAME = COMMAND__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__DESCRIPTION = COMMAND__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__MRID = COMMAND__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__NAME = COMMAND__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__NAMES = COMMAND__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__DIAGRAM_OBJECTS = COMMAND__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Control Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__CONTROL_TYPE = COMMAND__CONTROL_TYPE;

    /**
     * The feature id for the '<em><b>Operation In Progress</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__OPERATION_IN_PROGRESS = COMMAND__OPERATION_IN_PROGRESS;

    /**
     * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__TIME_STAMP = COMMAND__TIME_STAMP;

    /**
     * The feature id for the '<em><b>Unit Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__UNIT_MULTIPLIER = COMMAND__UNIT_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Unit Symbol</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__UNIT_SYMBOL = COMMAND__UNIT_SYMBOL;

    /**
     * The feature id for the '<em><b>Power System Resource</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__POWER_SYSTEM_RESOURCE = COMMAND__POWER_SYSTEM_RESOURCE;

    /**
     * The feature id for the '<em><b>Remote Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__REMOTE_CONTROL = COMMAND__REMOTE_CONTROL;

    /**
     * The feature id for the '<em><b>Normal Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__NORMAL_VALUE = COMMAND__NORMAL_VALUE;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__VALUE = COMMAND__VALUE;

    /**
     * The feature id for the '<em><b>Value Alias Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__VALUE_ALIAS_SET = COMMAND__VALUE_ALIAS_SET;

    /**
     * The feature id for the '<em><b>Discrete Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND__DISCRETE_VALUE = COMMAND__DISCRETE_VALUE;

    /**
     * The number of structural features of the '<em>Discrete Command</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND_FEATURE_COUNT = COMMAND_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Discrete Command</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DISCRETE_COMMAND_OPERATION_COUNT = COMMAND_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_POINT__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>B</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_POINT__B = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>G</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_POINT__G = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Section Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_POINT__SECTION_NUMBER = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Nonlinear Shunt Compensator Phase</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_POINT__NONLINEAR_SHUNT_COMPENSATOR_PHASE = CIM_OBJECT_WITH_ID_FEATURE_COUNT
            + 3;

    /**
     * The number of structural features of the '<em>Nonlinear Shunt Compensator Phase Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_POINT_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Nonlinear Shunt Compensator Phase Point</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NONLINEAR_SHUNT_COMPENSATOR_PHASE_POINT_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurement Values</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE__MEASUREMENT_VALUES = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Measurement Value Source</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Measurement Value Source</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEASUREMENT_VALUE_SOURCE_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__ID = REGULAR_INTERVAL_SCHEDULE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__ALIAS_NAME = REGULAR_INTERVAL_SCHEDULE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__DESCRIPTION = REGULAR_INTERVAL_SCHEDULE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__MRID = REGULAR_INTERVAL_SCHEDULE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__NAME = REGULAR_INTERVAL_SCHEDULE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__NAMES = REGULAR_INTERVAL_SCHEDULE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__DIAGRAM_OBJECTS = REGULAR_INTERVAL_SCHEDULE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Start Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__START_TIME = REGULAR_INTERVAL_SCHEDULE__START_TIME;

    /**
     * The feature id for the '<em><b>Value1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__VALUE1_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__VALUE1_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE1_UNIT;

    /**
     * The feature id for the '<em><b>Value2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__VALUE2_MULTIPLIER = REGULAR_INTERVAL_SCHEDULE__VALUE2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Value2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__VALUE2_UNIT = REGULAR_INTERVAL_SCHEDULE__VALUE2_UNIT;

    /**
     * The feature id for the '<em><b>End Time</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__END_TIME = REGULAR_INTERVAL_SCHEDULE__END_TIME;

    /**
     * The feature id for the '<em><b>Time Step</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__TIME_STEP = REGULAR_INTERVAL_SCHEDULE__TIME_STEP;

    /**
     * The feature id for the '<em><b>Time Points</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__TIME_POINTS = REGULAR_INTERVAL_SCHEDULE__TIME_POINTS;

    /**
     * The feature id for the '<em><b>Cogeneration Plant</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE__COGENERATION_PLANT = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Steam Sendout Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE_FEATURE_COUNT = REGULAR_INTERVAL_SCHEDULE_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Steam Sendout Schedule</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_SENDOUT_SCHEDULE_OPERATION_COUNT = REGULAR_INTERVAL_SCHEDULE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__ID = ACDC_TERMINAL__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__ALIAS_NAME = ACDC_TERMINAL__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__DESCRIPTION = ACDC_TERMINAL__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__MRID = ACDC_TERMINAL__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__NAME = ACDC_TERMINAL__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__NAMES = ACDC_TERMINAL__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__DIAGRAM_OBJECTS = ACDC_TERMINAL__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Connected</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__CONNECTED = ACDC_TERMINAL__CONNECTED;

    /**
     * The feature id for the '<em><b>Sequence Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__SEQUENCE_NUMBER = ACDC_TERMINAL__SEQUENCE_NUMBER;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__MEASUREMENTS = ACDC_TERMINAL__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Bus Name Marker</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__BUS_NAME_MARKER = ACDC_TERMINAL__BUS_NAME_MARKER;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__OPERATIONAL_LIMIT_SET = ACDC_TERMINAL__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__PHASES = ACDC_TERMINAL_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Has Second Mutual Coupling</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__HAS_SECOND_MUTUAL_COUPLING = ACDC_TERMINAL_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Sv Power Flow</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__SV_POWER_FLOW = ACDC_TERMINAL_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Connectivity Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__CONNECTIVITY_NODE = ACDC_TERMINAL_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Has First Mutual Coupling</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__HAS_FIRST_MUTUAL_COUPLING = ACDC_TERMINAL_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Auxiliary Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__AUXILIARY_EQUIPMENT = ACDC_TERMINAL_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__REGULATING_CONTROL = ACDC_TERMINAL_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Converter DC Sides</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__CONVERTER_DC_SIDES = ACDC_TERMINAL_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Topological Node</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__TOPOLOGICAL_NODE = ACDC_TERMINAL_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Conducting Equipment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__CONDUCTING_EQUIPMENT = ACDC_TERMINAL_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Branch Group Terminal</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__BRANCH_GROUP_TERMINAL = ACDC_TERMINAL_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Transformer End</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__TRANSFORMER_END = ACDC_TERMINAL_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Equipment Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__EQUIPMENT_FAULTS = ACDC_TERMINAL_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Tie Flow</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL__TIE_FLOW = ACDC_TERMINAL_FEATURE_COUNT + 13;

    /**
     * The number of structural features of the '<em>Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL_FEATURE_COUNT = ACDC_TERMINAL_FEATURE_COUNT + 14;

    /**
     * The number of operations of the '<em>Terminal</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int TERMINAL_OPERATION_COUNT = ACDC_TERMINAL_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__ID = DC_CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__ALIAS_NAME = DC_CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__DESCRIPTION = DC_CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__MRID = DC_CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__NAME = DC_CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__NAMES = DC_CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__DIAGRAM_OBJECTS = DC_CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__MEASUREMENTS = DC_CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__CONTROLS = DC_CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__OPERATING_SHARE = DC_CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__PSR_TYPE = DC_CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__AGGREGATE = DC_CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__NORMALLY_IN_SERVICE = DC_CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__CONTINGENCY_EQUIPMENT = DC_CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__OPERATIONAL_LIMIT_SET = DC_CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__FAULTS = DC_CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__EQUIPMENT_CONTAINER = DC_CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER__DC_TERMINALS = DC_CONDUCTING_EQUIPMENT__DC_TERMINALS;

    /**
     * The number of structural features of the '<em>DC Chopper</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER_FEATURE_COUNT = DC_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>DC Chopper</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DC_CHOPPER_OPERATION_COUNT = DC_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__ID = FAULT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__ALIAS_NAME = FAULT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__DESCRIPTION = FAULT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__MRID = FAULT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__NAME = FAULT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__NAMES = FAULT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__DIAGRAM_OBJECTS = FAULT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Kind</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__KIND = FAULT__KIND;

    /**
     * The feature id for the '<em><b>Phases</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__PHASES = FAULT__PHASES;

    /**
     * The feature id for the '<em><b>Impedance</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__IMPEDANCE = FAULT__IMPEDANCE;

    /**
     * The feature id for the '<em><b>Fault Cause Types</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__FAULT_CAUSE_TYPES = FAULT__FAULT_CAUSE_TYPES;

    /**
     * The feature id for the '<em><b>Faulty Equipment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__FAULTY_EQUIPMENT = FAULT__FAULTY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Length From Terminal1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__LENGTH_FROM_TERMINAL1 = FAULT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>AC Line Segment</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT__AC_LINE_SEGMENT = FAULT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Line Fault</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT_FEATURE_COUNT = FAULT_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Line Fault</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINE_FAULT_OPERATION_COUNT = FAULT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__ID = ACDC_CONVERTER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__ALIAS_NAME = ACDC_CONVERTER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__DESCRIPTION = ACDC_CONVERTER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MRID = ACDC_CONVERTER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__NAME = ACDC_CONVERTER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__NAMES = ACDC_CONVERTER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__DIAGRAM_OBJECTS = ACDC_CONVERTER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MEASUREMENTS = ACDC_CONVERTER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__CONTROLS = ACDC_CONVERTER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__OPERATING_SHARE = ACDC_CONVERTER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__PSR_TYPE = ACDC_CONVERTER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__AGGREGATE = ACDC_CONVERTER__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__NORMALLY_IN_SERVICE = ACDC_CONVERTER__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__CONTINGENCY_EQUIPMENT = ACDC_CONVERTER__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__OPERATIONAL_LIMIT_SET = ACDC_CONVERTER__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__FAULTS = ACDC_CONVERTER__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__EQUIPMENT_CONTAINER = ACDC_CONVERTER__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__PROTECTION_EQUIPMENTS = ACDC_CONVERTER__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__BASE_VOLTAGE = ACDC_CONVERTER__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__SV_STATUS = ACDC_CONVERTER__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__TERMINALS = ACDC_CONVERTER__TERMINALS;

    /**
     * The feature id for the '<em><b>Base S</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__BASE_S = ACDC_CONVERTER__BASE_S;

    /**
     * The feature id for the '<em><b>Idc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__IDC = ACDC_CONVERTER__IDC;

    /**
     * The feature id for the '<em><b>Idle Loss</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__IDLE_LOSS = ACDC_CONVERTER__IDLE_LOSS;

    /**
     * The feature id for the '<em><b>Max Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MAX_UDC = ACDC_CONVERTER__MAX_UDC;

    /**
     * The feature id for the '<em><b>Min Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MIN_UDC = ACDC_CONVERTER__MIN_UDC;

    /**
     * The feature id for the '<em><b>Number Of Valves</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__NUMBER_OF_VALVES = ACDC_CONVERTER__NUMBER_OF_VALVES;

    /**
     * The feature id for the '<em><b>P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__P = ACDC_CONVERTER__P;

    /**
     * The feature id for the '<em><b>Pole Loss P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__POLE_LOSS_P = ACDC_CONVERTER__POLE_LOSS_P;

    /**
     * The feature id for the '<em><b>Q</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__Q = ACDC_CONVERTER__Q;

    /**
     * The feature id for the '<em><b>Rated Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__RATED_UDC = ACDC_CONVERTER__RATED_UDC;

    /**
     * The feature id for the '<em><b>Resistive Loss</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__RESISTIVE_LOSS = ACDC_CONVERTER__RESISTIVE_LOSS;

    /**
     * The feature id for the '<em><b>Switching Loss</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__SWITCHING_LOSS = ACDC_CONVERTER__SWITCHING_LOSS;

    /**
     * The feature id for the '<em><b>Target Ppcc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__TARGET_PPCC = ACDC_CONVERTER__TARGET_PPCC;

    /**
     * The feature id for the '<em><b>Target Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__TARGET_UDC = ACDC_CONVERTER__TARGET_UDC;

    /**
     * The feature id for the '<em><b>Uc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__UC = ACDC_CONVERTER__UC;

    /**
     * The feature id for the '<em><b>Udc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__UDC = ACDC_CONVERTER__UDC;

    /**
     * The feature id for the '<em><b>Valve U0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__VALVE_U0 = ACDC_CONVERTER__VALVE_U0;

    /**
     * The feature id for the '<em><b>DC Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__DC_TERMINALS = ACDC_CONVERTER__DC_TERMINALS;

    /**
     * The feature id for the '<em><b>Pcc Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__PCC_TERMINAL = ACDC_CONVERTER__PCC_TERMINAL;

    /**
     * The feature id for the '<em><b>Alpha</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__ALPHA = ACDC_CONVERTER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Gamma</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__GAMMA = ACDC_CONVERTER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Max Alpha</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MAX_ALPHA = ACDC_CONVERTER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Max Gamma</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MAX_GAMMA = ACDC_CONVERTER_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Max Idc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MAX_IDC = ACDC_CONVERTER_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Min Alpha</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MIN_ALPHA = ACDC_CONVERTER_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Min Gamma</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MIN_GAMMA = ACDC_CONVERTER_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Min Idc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__MIN_IDC = ACDC_CONVERTER_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Operating Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__OPERATING_MODE = ACDC_CONVERTER_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>PPcc Control</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__PPCC_CONTROL = ACDC_CONVERTER_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Rated Idc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__RATED_IDC = ACDC_CONVERTER_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Target Alpha</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__TARGET_ALPHA = ACDC_CONVERTER_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Target Gamma</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__TARGET_GAMMA = ACDC_CONVERTER_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Target Idc</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER__TARGET_IDC = ACDC_CONVERTER_FEATURE_COUNT + 13;

    /**
     * The number of structural features of the '<em>Cs Converter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER_FEATURE_COUNT = ACDC_CONVERTER_FEATURE_COUNT + 14;

    /**
     * The number of operations of the '<em>Cs Converter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int CS_CONVERTER_OPERATION_COUNT = ACDC_CONVERTER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER__ID = IDENTIFIED_OBJECT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER__ALIAS_NAME = IDENTIFIED_OBJECT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER__DESCRIPTION = IDENTIFIED_OBJECT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER__MRID = IDENTIFIED_OBJECT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER__NAME = IDENTIFIED_OBJECT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER__NAMES = IDENTIFIED_OBJECT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER__DIAGRAM_OBJECTS = IDENTIFIED_OBJECT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Base Power</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER__BASE_POWER = IDENTIFIED_OBJECT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Base Power</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER_FEATURE_COUNT = IDENTIFIED_OBJECT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Base Power</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BASE_POWER_OPERATION_COUNT = IDENTIFIED_OBJECT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__ID = FOSSIL_STEAM_SUPPLY__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__ALIAS_NAME = FOSSIL_STEAM_SUPPLY__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__DESCRIPTION = FOSSIL_STEAM_SUPPLY__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__MRID = FOSSIL_STEAM_SUPPLY__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__NAME = FOSSIL_STEAM_SUPPLY__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__NAMES = FOSSIL_STEAM_SUPPLY__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__DIAGRAM_OBJECTS = FOSSIL_STEAM_SUPPLY__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__MEASUREMENTS = FOSSIL_STEAM_SUPPLY__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__CONTROLS = FOSSIL_STEAM_SUPPLY__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__OPERATING_SHARE = FOSSIL_STEAM_SUPPLY__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__PSR_TYPE = FOSSIL_STEAM_SUPPLY__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Steam Supply Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__STEAM_SUPPLY_RATING = FOSSIL_STEAM_SUPPLY__STEAM_SUPPLY_RATING;

    /**
     * The feature id for the '<em><b>Steam Turbines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__STEAM_TURBINES = FOSSIL_STEAM_SUPPLY__STEAM_TURBINES;

    /**
     * The feature id for the '<em><b>Aux Power Versus Frequency</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__AUX_POWER_VERSUS_FREQUENCY = FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_FREQUENCY;

    /**
     * The feature id for the '<em><b>Aux Power Versus Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__AUX_POWER_VERSUS_VOLTAGE = FOSSIL_STEAM_SUPPLY__AUX_POWER_VERSUS_VOLTAGE;

    /**
     * The feature id for the '<em><b>Boiler Control Mode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__BOILER_CONTROL_MODE = FOSSIL_STEAM_SUPPLY__BOILER_CONTROL_MODE;

    /**
     * The feature id for the '<em><b>Control Error Bias P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__CONTROL_ERROR_BIAS_P = FOSSIL_STEAM_SUPPLY__CONTROL_ERROR_BIAS_P;

    /**
     * The feature id for the '<em><b>Control IC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__CONTROL_IC = FOSSIL_STEAM_SUPPLY__CONTROL_IC;

    /**
     * The feature id for the '<em><b>Control PC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__CONTROL_PC = FOSSIL_STEAM_SUPPLY__CONTROL_PC;

    /**
     * The feature id for the '<em><b>Control PEB</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__CONTROL_PEB = FOSSIL_STEAM_SUPPLY__CONTROL_PEB;

    /**
     * The feature id for the '<em><b>Control PED</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__CONTROL_PED = FOSSIL_STEAM_SUPPLY__CONTROL_PED;

    /**
     * The feature id for the '<em><b>Control TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__CONTROL_TC = FOSSIL_STEAM_SUPPLY__CONTROL_TC;

    /**
     * The feature id for the '<em><b>Feed Water IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__FEED_WATER_IG = FOSSIL_STEAM_SUPPLY__FEED_WATER_IG;

    /**
     * The feature id for the '<em><b>Feed Water PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__FEED_WATER_PG = FOSSIL_STEAM_SUPPLY__FEED_WATER_PG;

    /**
     * The feature id for the '<em><b>Feed Water TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__FEED_WATER_TC = FOSSIL_STEAM_SUPPLY__FEED_WATER_TC;

    /**
     * The feature id for the '<em><b>Fuel Demand Limit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__FUEL_DEMAND_LIMIT = FOSSIL_STEAM_SUPPLY__FUEL_DEMAND_LIMIT;

    /**
     * The feature id for the '<em><b>Fuel Supply Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__FUEL_SUPPLY_DELAY = FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_DELAY;

    /**
     * The feature id for the '<em><b>Fuel Supply TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__FUEL_SUPPLY_TC = FOSSIL_STEAM_SUPPLY__FUEL_SUPPLY_TC;

    /**
     * The feature id for the '<em><b>Max Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__MAX_ERROR_RATE_P = FOSSIL_STEAM_SUPPLY__MAX_ERROR_RATE_P;

    /**
     * The feature id for the '<em><b>Mech Power Sensor Lag</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__MECH_POWER_SENSOR_LAG = FOSSIL_STEAM_SUPPLY__MECH_POWER_SENSOR_LAG;

    /**
     * The feature id for the '<em><b>Min Error Rate P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__MIN_ERROR_RATE_P = FOSSIL_STEAM_SUPPLY__MIN_ERROR_RATE_P;

    /**
     * The feature id for the '<em><b>Pressure Ctrl DG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__PRESSURE_CTRL_DG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_DG;

    /**
     * The feature id for the '<em><b>Pressure Ctrl IG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__PRESSURE_CTRL_IG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_IG;

    /**
     * The feature id for the '<em><b>Pressure Ctrl PG</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__PRESSURE_CTRL_PG = FOSSIL_STEAM_SUPPLY__PRESSURE_CTRL_PG;

    /**
     * The feature id for the '<em><b>Pressure Feedback</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__PRESSURE_FEEDBACK = FOSSIL_STEAM_SUPPLY__PRESSURE_FEEDBACK;

    /**
     * The feature id for the '<em><b>Super Heater1 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__SUPER_HEATER1_CAPACITY = FOSSIL_STEAM_SUPPLY__SUPER_HEATER1_CAPACITY;

    /**
     * The feature id for the '<em><b>Super Heater2 Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__SUPER_HEATER2_CAPACITY = FOSSIL_STEAM_SUPPLY__SUPER_HEATER2_CAPACITY;

    /**
     * The feature id for the '<em><b>Super Heater Pipe PD</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__SUPER_HEATER_PIPE_PD = FOSSIL_STEAM_SUPPLY__SUPER_HEATER_PIPE_PD;

    /**
     * The feature id for the '<em><b>Throttle Pressure SP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__THROTTLE_PRESSURE_SP = FOSSIL_STEAM_SUPPLY__THROTTLE_PRESSURE_SP;

    /**
     * The feature id for the '<em><b>Drum Boiler Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER__DRUM_BOILER_RATING = FOSSIL_STEAM_SUPPLY_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Drum Boiler</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER_FEATURE_COUNT = FOSSIL_STEAM_SUPPLY_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Drum Boiler</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DRUM_BOILER_OPERATION_COUNT = FOSSIL_STEAM_SUPPLY_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__ID = TRANSFORMER_END__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__ALIAS_NAME = TRANSFORMER_END__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__DESCRIPTION = TRANSFORMER_END__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__MRID = TRANSFORMER_END__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__NAME = TRANSFORMER_END__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__NAMES = TRANSFORMER_END__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__DIAGRAM_OBJECTS = TRANSFORMER_END__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Bmag Sat</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__BMAG_SAT = TRANSFORMER_END__BMAG_SAT;

    /**
     * The feature id for the '<em><b>End Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__END_NUMBER = TRANSFORMER_END__END_NUMBER;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__GROUNDED = TRANSFORMER_END__GROUNDED;

    /**
     * The feature id for the '<em><b>Mag Base U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__MAG_BASE_U = TRANSFORMER_END__MAG_BASE_U;

    /**
     * The feature id for the '<em><b>Mag Sat Flux</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__MAG_SAT_FLUX = TRANSFORMER_END__MAG_SAT_FLUX;

    /**
     * The feature id for the '<em><b>Rground</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__RGROUND = TRANSFORMER_END__RGROUND;

    /**
     * The feature id for the '<em><b>Xground</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__XGROUND = TRANSFORMER_END__XGROUND;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__BASE_VOLTAGE = TRANSFORMER_END__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>To Mesh Impedance</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__TO_MESH_IMPEDANCE = TRANSFORMER_END__TO_MESH_IMPEDANCE;

    /**
     * The feature id for the '<em><b>Ratio Tap Changer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__RATIO_TAP_CHANGER = TRANSFORMER_END__RATIO_TAP_CHANGER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__TERMINAL = TRANSFORMER_END__TERMINAL;

    /**
     * The feature id for the '<em><b>Star Impedance</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__STAR_IMPEDANCE = TRANSFORMER_END__STAR_IMPEDANCE;

    /**
     * The feature id for the '<em><b>From Mesh Impedance</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__FROM_MESH_IMPEDANCE = TRANSFORMER_END__FROM_MESH_IMPEDANCE;

    /**
     * The feature id for the '<em><b>Core Admittance</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__CORE_ADMITTANCE = TRANSFORMER_END__CORE_ADMITTANCE;

    /**
     * The feature id for the '<em><b>Phase Tap Changer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__PHASE_TAP_CHANGER = TRANSFORMER_END__PHASE_TAP_CHANGER;

    /**
     * The feature id for the '<em><b>B</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__B = TRANSFORMER_END_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>B0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__B0 = TRANSFORMER_END_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Connection Kind</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__CONNECTION_KIND = TRANSFORMER_END_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>G</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__G = TRANSFORMER_END_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>G0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__G0 = TRANSFORMER_END_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Phase Angle Clock</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__PHASE_ANGLE_CLOCK = TRANSFORMER_END_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>R</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__R = TRANSFORMER_END_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>R0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__R0 = TRANSFORMER_END_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Rated S</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__RATED_S = TRANSFORMER_END_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Rated U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__RATED_U = TRANSFORMER_END_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>X</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__X = TRANSFORMER_END_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>X0</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__X0 = TRANSFORMER_END_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Power Transformer</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END__POWER_TRANSFORMER = TRANSFORMER_END_FEATURE_COUNT + 12;

    /**
     * The number of structural features of the '<em>Power Transformer End</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END_FEATURE_COUNT = TRANSFORMER_END_FEATURE_COUNT + 13;

    /**
     * The number of operations of the '<em>Power Transformer End</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_END_OPERATION_COUNT = TRANSFORMER_END_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__ID = SENSOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__ALIAS_NAME = SENSOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__DESCRIPTION = SENSOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__MRID = SENSOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__NAME = SENSOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__NAMES = SENSOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__DIAGRAM_OBJECTS = SENSOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__MEASUREMENTS = SENSOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__CONTROLS = SENSOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__OPERATING_SHARE = SENSOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__PSR_TYPE = SENSOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__AGGREGATE = SENSOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__NORMALLY_IN_SERVICE = SENSOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__CONTINGENCY_EQUIPMENT = SENSOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__OPERATIONAL_LIMIT_SET = SENSOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__FAULTS = SENSOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__EQUIPMENT_CONTAINER = SENSOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Terminal</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR__TERMINAL = SENSOR__TERMINAL;

    /**
     * The number of structural features of the '<em>Post Line Sensor</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR_FEATURE_COUNT = SENSOR_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Post Line Sensor</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POST_LINE_SENSOR_OPERATION_COUNT = SENSOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__ID = PRIME_MOVER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__ALIAS_NAME = PRIME_MOVER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__DESCRIPTION = PRIME_MOVER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__MRID = PRIME_MOVER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__NAME = PRIME_MOVER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__NAMES = PRIME_MOVER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__DIAGRAM_OBJECTS = PRIME_MOVER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__MEASUREMENTS = PRIME_MOVER__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__CONTROLS = PRIME_MOVER__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__OPERATING_SHARE = PRIME_MOVER__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__PSR_TYPE = PRIME_MOVER__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Prime Mover Rating</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__PRIME_MOVER_RATING = PRIME_MOVER__PRIME_MOVER_RATING;

    /**
     * The feature id for the '<em><b>Synchronous Machines</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__SYNCHRONOUS_MACHINES = PRIME_MOVER__SYNCHRONOUS_MACHINES;

    /**
     * The feature id for the '<em><b>Crossover TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__CROSSOVER_TC = PRIME_MOVER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Reheater1 TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__REHEATER1_TC = PRIME_MOVER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Reheater2 TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__REHEATER2_TC = PRIME_MOVER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Shaft1 Power HP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__SHAFT1_POWER_HP = PRIME_MOVER_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Shaft1 Power IP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__SHAFT1_POWER_IP = PRIME_MOVER_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Shaft1 Power LP1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__SHAFT1_POWER_LP1 = PRIME_MOVER_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Shaft1 Power LP2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__SHAFT1_POWER_LP2 = PRIME_MOVER_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Shaft2 Power HP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__SHAFT2_POWER_HP = PRIME_MOVER_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Shaft2 Power IP</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__SHAFT2_POWER_IP = PRIME_MOVER_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Shaft2 Power LP1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__SHAFT2_POWER_LP1 = PRIME_MOVER_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Shaft2 Power LP2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__SHAFT2_POWER_LP2 = PRIME_MOVER_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>Steam Chest TC</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__STEAM_CHEST_TC = PRIME_MOVER_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Steam Supplys</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE__STEAM_SUPPLYS = PRIME_MOVER_FEATURE_COUNT + 12;

    /**
     * The number of structural features of the '<em>Steam Turbine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE_FEATURE_COUNT = PRIME_MOVER_FEATURE_COUNT + 13;

    /**
     * The number of operations of the '<em>Steam Turbine</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int STEAM_TURBINE_OPERATION_COUNT = PRIME_MOVER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__ID = PROTECTED_SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__ALIAS_NAME = PROTECTED_SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__DESCRIPTION = PROTECTED_SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__MRID = PROTECTED_SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__NAME = PROTECTED_SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__NAMES = PROTECTED_SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__DIAGRAM_OBJECTS = PROTECTED_SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__MEASUREMENTS = PROTECTED_SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__CONTROLS = PROTECTED_SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__OPERATING_SHARE = PROTECTED_SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__PSR_TYPE = PROTECTED_SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__AGGREGATE = PROTECTED_SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__NORMALLY_IN_SERVICE = PROTECTED_SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__CONTINGENCY_EQUIPMENT = PROTECTED_SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__OPERATIONAL_LIMIT_SET = PROTECTED_SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__FAULTS = PROTECTED_SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__EQUIPMENT_CONTAINER = PROTECTED_SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__PROTECTION_EQUIPMENTS = PROTECTED_SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__BASE_VOLTAGE = PROTECTED_SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__SV_STATUS = PROTECTED_SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__TERMINALS = PROTECTED_SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__NORMAL_OPEN = PROTECTED_SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__OPEN = PROTECTED_SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__RATED_CURRENT = PROTECTED_SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__RETAINED = PROTECTED_SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__SWITCH_ON_COUNT = PROTECTED_SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__SWITCH_ON_DATE = PROTECTED_SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__COMPOSITE_SWITCH = PROTECTED_SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__SWITCH_SCHEDULES = PROTECTED_SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__SWITCH_PHASE = PROTECTED_SWITCH__SWITCH_PHASE;

    /**
     * The feature id for the '<em><b>Breaking Capacity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__BREAKING_CAPACITY = PROTECTED_SWITCH__BREAKING_CAPACITY;

    /**
     * The feature id for the '<em><b>Reclose Sequences</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__RECLOSE_SEQUENCES = PROTECTED_SWITCH__RECLOSE_SEQUENCES;

    /**
     * The feature id for the '<em><b>Operated By Protection Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER__OPERATED_BY_PROTECTION_EQUIPMENT = PROTECTED_SWITCH__OPERATED_BY_PROTECTION_EQUIPMENT;

    /**
     * The number of structural features of the '<em>Recloser</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER_FEATURE_COUNT = PROTECTED_SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Recloser</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RECLOSER_OPERATION_COUNT = PROTECTED_SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__ID = POWER_SYSTEM_RESOURCE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__ALIAS_NAME = POWER_SYSTEM_RESOURCE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__DESCRIPTION = POWER_SYSTEM_RESOURCE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__MRID = POWER_SYSTEM_RESOURCE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__NAMES = POWER_SYSTEM_RESOURCE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__DIAGRAM_OBJECTS = POWER_SYSTEM_RESOURCE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__MEASUREMENTS = POWER_SYSTEM_RESOURCE__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__CONTROLS = POWER_SYSTEM_RESOURCE__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__OPERATING_SHARE = POWER_SYSTEM_RESOURCE__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__PSR_TYPE = POWER_SYSTEM_RESOURCE__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Closed</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__CLOSED = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__NORMAL_OPEN = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Phase Side1</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__PHASE_SIDE1 = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Phase Side2</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__PHASE_SIDE2 = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE__SWITCH = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>Switch Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>Switch Phase</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SWITCH_PHASE_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__ID = SWITCH__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__ALIAS_NAME = SWITCH__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__DESCRIPTION = SWITCH__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__MRID = SWITCH__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__NAME = SWITCH__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__NAMES = SWITCH__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__DIAGRAM_OBJECTS = SWITCH__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__MEASUREMENTS = SWITCH__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__CONTROLS = SWITCH__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__OPERATING_SHARE = SWITCH__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__PSR_TYPE = SWITCH__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__AGGREGATE = SWITCH__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__NORMALLY_IN_SERVICE = SWITCH__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__CONTINGENCY_EQUIPMENT = SWITCH__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__OPERATIONAL_LIMIT_SET = SWITCH__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__FAULTS = SWITCH__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__EQUIPMENT_CONTAINER = SWITCH__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__PROTECTION_EQUIPMENTS = SWITCH__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__BASE_VOLTAGE = SWITCH__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__SV_STATUS = SWITCH__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__TERMINALS = SWITCH__TERMINALS;

    /**
     * The feature id for the '<em><b>Normal Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__NORMAL_OPEN = SWITCH__NORMAL_OPEN;

    /**
     * The feature id for the '<em><b>Open</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__OPEN = SWITCH__OPEN;

    /**
     * The feature id for the '<em><b>Rated Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__RATED_CURRENT = SWITCH__RATED_CURRENT;

    /**
     * The feature id for the '<em><b>Retained</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__RETAINED = SWITCH__RETAINED;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__SWITCH_ON_COUNT = SWITCH__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__SWITCH_ON_DATE = SWITCH__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Composite Switch</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__COMPOSITE_SWITCH = SWITCH__COMPOSITE_SWITCH;

    /**
     * The feature id for the '<em><b>Switch Schedules</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__SWITCH_SCHEDULES = SWITCH__SWITCH_SCHEDULES;

    /**
     * The feature id for the '<em><b>Switch Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR__SWITCH_PHASE = SWITCH__SWITCH_PHASE;

    /**
     * The number of structural features of the '<em>Ground Disconnector</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR_FEATURE_COUNT = SWITCH_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Ground Disconnector</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int GROUND_DISCONNECTOR_OPERATION_COUNT = SWITCH_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE__ID = CIM_OBJECT_WITH_ID__ID;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE__DESCRIPTION = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE__NAME = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Name Type Authority</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE__NAME_TYPE_AUTHORITY = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE__NAMES = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Name Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE_FEATURE_COUNT = CIM_OBJECT_WITH_ID_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Name Type</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NAME_TYPE_OPERATION_COUNT = CIM_OBJECT_WITH_ID_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Aux Power Mult</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__AUX_POWER_MULT = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Aux Power Offset</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__AUX_POWER_OFFSET = CURVE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Heat Input Eff</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__HEAT_INPUT_EFF = CURVE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Heat Input Offset</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__HEAT_INPUT_OFFSET = CURVE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Is Net Gross P</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__IS_NET_GROSS_P = CURVE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Thermal Generating Unit</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE__THERMAL_GENERATING_UNIT = CURVE_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>Heat Input Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>Heat Input Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int HEAT_INPUT_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__ID = CURVE__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__ALIAS_NAME = CURVE__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__DESCRIPTION = CURVE__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__MRID = CURVE__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__NAME = CURVE__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__NAMES = CURVE__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__DIAGRAM_OBJECTS = CURVE__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Curve Style</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__CURVE_STYLE = CURVE__CURVE_STYLE;

    /**
     * The feature id for the '<em><b>XMultiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__XMULTIPLIER = CURVE__XMULTIPLIER;

    /**
     * The feature id for the '<em><b>XUnit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__XUNIT = CURVE__XUNIT;

    /**
     * The feature id for the '<em><b>Y1 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__Y1_MULTIPLIER = CURVE__Y1_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y1 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__Y1_UNIT = CURVE__Y1_UNIT;

    /**
     * The feature id for the '<em><b>Y2 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__Y2_MULTIPLIER = CURVE__Y2_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y2 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__Y2_UNIT = CURVE__Y2_UNIT;

    /**
     * The feature id for the '<em><b>Y3 Multiplier</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__Y3_MULTIPLIER = CURVE__Y3_MULTIPLIER;

    /**
     * The feature id for the '<em><b>Y3 Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__Y3_UNIT = CURVE__Y3_UNIT;

    /**
     * The feature id for the '<em><b>Curve Datas</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__CURVE_DATAS = CURVE__CURVE_DATAS;

    /**
     * The feature id for the '<em><b>Main Fuel Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__MAIN_FUEL_TYPE = CURVE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Startup Model</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE__STARTUP_MODEL = CURVE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Start Main Fuel Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE_FEATURE_COUNT = CURVE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Start Main Fuel Curve</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int START_MAIN_FUEL_CURVE_OPERATION_COUNT = CURVE_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__ID = PER_LENGTH_LINE_PARAMETER__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__ALIAS_NAME = PER_LENGTH_LINE_PARAMETER__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__DESCRIPTION = PER_LENGTH_LINE_PARAMETER__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__MRID = PER_LENGTH_LINE_PARAMETER__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__NAME = PER_LENGTH_LINE_PARAMETER__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__NAMES = PER_LENGTH_LINE_PARAMETER__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__DIAGRAM_OBJECTS = PER_LENGTH_LINE_PARAMETER__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Capacitance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__CAPACITANCE = PER_LENGTH_LINE_PARAMETER_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Inductance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__INDUCTANCE = PER_LENGTH_LINE_PARAMETER_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Resistance</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__RESISTANCE = PER_LENGTH_LINE_PARAMETER_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>DC Line Segments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER__DC_LINE_SEGMENTS = PER_LENGTH_LINE_PARAMETER_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Per Length DC Line Parameter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER_FEATURE_COUNT = PER_LENGTH_LINE_PARAMETER_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Per Length DC Line Parameter</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PER_LENGTH_DC_LINE_PARAMETER_OPERATION_COUNT = PER_LENGTH_LINE_PARAMETER_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__ID = CONDUCTING_EQUIPMENT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__ALIAS_NAME = CONDUCTING_EQUIPMENT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__DESCRIPTION = CONDUCTING_EQUIPMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__MRID = CONDUCTING_EQUIPMENT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__NAME = CONDUCTING_EQUIPMENT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__NAMES = CONDUCTING_EQUIPMENT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__DIAGRAM_OBJECTS = CONDUCTING_EQUIPMENT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__MEASUREMENTS = CONDUCTING_EQUIPMENT__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__CONTROLS = CONDUCTING_EQUIPMENT__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__OPERATING_SHARE = CONDUCTING_EQUIPMENT__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__PSR_TYPE = CONDUCTING_EQUIPMENT__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__AGGREGATE = CONDUCTING_EQUIPMENT__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__NORMALLY_IN_SERVICE = CONDUCTING_EQUIPMENT__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__CONTINGENCY_EQUIPMENT = CONDUCTING_EQUIPMENT__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__OPERATIONAL_LIMIT_SET = CONDUCTING_EQUIPMENT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__FAULTS = CONDUCTING_EQUIPMENT__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__EQUIPMENT_CONTAINER = CONDUCTING_EQUIPMENT__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__PROTECTION_EQUIPMENTS = CONDUCTING_EQUIPMENT__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__BASE_VOLTAGE = CONDUCTING_EQUIPMENT__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__SV_STATUS = CONDUCTING_EQUIPMENT__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__TERMINALS = CONDUCTING_EQUIPMENT__TERMINALS;

    /**
     * The feature id for the '<em><b>Before Sh Circuit Highest Operating Current</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__BEFORE_SH_CIRCUIT_HIGHEST_OPERATING_CURRENT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Before Sh Circuit Highest Operating Voltage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__BEFORE_SH_CIRCUIT_HIGHEST_OPERATING_VOLTAGE = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Before Short Circuit Angle Pf</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__BEFORE_SHORT_CIRCUIT_ANGLE_PF = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>High Side Min Operating U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__HIGH_SIDE_MIN_OPERATING_U = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Is Part Of Generator Unit</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__IS_PART_OF_GENERATOR_UNIT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Operational Values Considered</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__OPERATIONAL_VALUES_CONSIDERED = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Vector Group</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__VECTOR_GROUP = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Transformer Tanks</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__TRANSFORMER_TANKS = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Power Transformer End</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER__POWER_TRANSFORMER_END = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 8;

    /**
     * The number of structural features of the '<em>Power Transformer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_FEATURE_COUNT = CONDUCTING_EQUIPMENT_FEATURE_COUNT + 9;

    /**
     * The number of operations of the '<em>Power Transformer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int POWER_TRANSFORMER_OPERATION_COUNT = CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__ID = SHUNT_COMPENSATOR__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__ALIAS_NAME = SHUNT_COMPENSATOR__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__DESCRIPTION = SHUNT_COMPENSATOR__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__MRID = SHUNT_COMPENSATOR__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__NAME = SHUNT_COMPENSATOR__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__NAMES = SHUNT_COMPENSATOR__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__DIAGRAM_OBJECTS = SHUNT_COMPENSATOR__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Measurements</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__MEASUREMENTS = SHUNT_COMPENSATOR__MEASUREMENTS;

    /**
     * The feature id for the '<em><b>Controls</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__CONTROLS = SHUNT_COMPENSATOR__CONTROLS;

    /**
     * The feature id for the '<em><b>Operating Share</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__OPERATING_SHARE = SHUNT_COMPENSATOR__OPERATING_SHARE;

    /**
     * The feature id for the '<em><b>PSR Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__PSR_TYPE = SHUNT_COMPENSATOR__PSR_TYPE;

    /**
     * The feature id for the '<em><b>Aggregate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__AGGREGATE = SHUNT_COMPENSATOR__AGGREGATE;

    /**
     * The feature id for the '<em><b>Normally In Service</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__NORMALLY_IN_SERVICE = SHUNT_COMPENSATOR__NORMALLY_IN_SERVICE;

    /**
     * The feature id for the '<em><b>Contingency Equipment</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__CONTINGENCY_EQUIPMENT = SHUNT_COMPENSATOR__CONTINGENCY_EQUIPMENT;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__OPERATIONAL_LIMIT_SET = SHUNT_COMPENSATOR__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Faults</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__FAULTS = SHUNT_COMPENSATOR__FAULTS;

    /**
     * The feature id for the '<em><b>Equipment Container</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__EQUIPMENT_CONTAINER = SHUNT_COMPENSATOR__EQUIPMENT_CONTAINER;

    /**
     * The feature id for the '<em><b>Protection Equipments</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__PROTECTION_EQUIPMENTS = SHUNT_COMPENSATOR__PROTECTION_EQUIPMENTS;

    /**
     * The feature id for the '<em><b>Base Voltage</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__BASE_VOLTAGE = SHUNT_COMPENSATOR__BASE_VOLTAGE;

    /**
     * The feature id for the '<em><b>Sv Status</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__SV_STATUS = SHUNT_COMPENSATOR__SV_STATUS;

    /**
     * The feature id for the '<em><b>Terminals</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__TERMINALS = SHUNT_COMPENSATOR__TERMINALS;

    /**
     * The feature id for the '<em><b>Control Enabled</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__CONTROL_ENABLED = SHUNT_COMPENSATOR__CONTROL_ENABLED;

    /**
     * The feature id for the '<em><b>Regulating Control</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__REGULATING_CONTROL = SHUNT_COMPENSATOR__REGULATING_CONTROL;

    /**
     * The feature id for the '<em><b>AVR Delay</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__AVR_DELAY = SHUNT_COMPENSATOR__AVR_DELAY;

    /**
     * The feature id for the '<em><b>Grounded</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__GROUNDED = SHUNT_COMPENSATOR__GROUNDED;

    /**
     * The feature id for the '<em><b>Maximum Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__MAXIMUM_SECTIONS = SHUNT_COMPENSATOR__MAXIMUM_SECTIONS;

    /**
     * The feature id for the '<em><b>Nom U</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__NOM_U = SHUNT_COMPENSATOR__NOM_U;

    /**
     * The feature id for the '<em><b>Normal Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__NORMAL_SECTIONS = SHUNT_COMPENSATOR__NORMAL_SECTIONS;

    /**
     * The feature id for the '<em><b>Phase Connection</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__PHASE_CONNECTION = SHUNT_COMPENSATOR__PHASE_CONNECTION;

    /**
     * The feature id for the '<em><b>Sections</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__SECTIONS = SHUNT_COMPENSATOR__SECTIONS;

    /**
     * The feature id for the '<em><b>Switch On Count</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__SWITCH_ON_COUNT = SHUNT_COMPENSATOR__SWITCH_ON_COUNT;

    /**
     * The feature id for the '<em><b>Switch On Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__SWITCH_ON_DATE = SHUNT_COMPENSATOR__SWITCH_ON_DATE;

    /**
     * The feature id for the '<em><b>Voltage Sensitivity</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__VOLTAGE_SENSITIVITY = SHUNT_COMPENSATOR__VOLTAGE_SENSITIVITY;

    /**
     * The feature id for the '<em><b>Shunt Compensator Phase</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__SHUNT_COMPENSATOR_PHASE = SHUNT_COMPENSATOR__SHUNT_COMPENSATOR_PHASE;

    /**
     * The feature id for the '<em><b>Sv Shunt Compensator Sections</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__SV_SHUNT_COMPENSATOR_SECTIONS = SHUNT_COMPENSATOR__SV_SHUNT_COMPENSATOR_SECTIONS;

    /**
     * The feature id for the '<em><b>B0 Per Section</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__B0_PER_SECTION = SHUNT_COMPENSATOR_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>BPer Section</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__BPER_SECTION = SHUNT_COMPENSATOR_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>G0 Per Section</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__G0_PER_SECTION = SHUNT_COMPENSATOR_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>GPer Section</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR__GPER_SECTION = SHUNT_COMPENSATOR_FEATURE_COUNT + 3;

    /**
     * The number of structural features of the '<em>Linear Shunt Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_FEATURE_COUNT = SHUNT_COMPENSATOR_FEATURE_COUNT + 4;

    /**
     * The number of operations of the '<em>Linear Shunt Compensator</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LINEAR_SHUNT_COMPENSATOR_OPERATION_COUNT = SHUNT_COMPENSATOR_OPERATION_COUNT + 0;

    /**
     * The feature id for the '<em><b>ID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__ID = OPERATIONAL_LIMIT__ID;

    /**
     * The feature id for the '<em><b>Alias Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__ALIAS_NAME = OPERATIONAL_LIMIT__ALIAS_NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__DESCRIPTION = OPERATIONAL_LIMIT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>MRID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__MRID = OPERATIONAL_LIMIT__MRID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__NAME = OPERATIONAL_LIMIT__NAME;

    /**
     * The feature id for the '<em><b>Names</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__NAMES = OPERATIONAL_LIMIT__NAMES;

    /**
     * The feature id for the '<em><b>Diagram Objects</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__DIAGRAM_OBJECTS = OPERATIONAL_LIMIT__DIAGRAM_OBJECTS;

    /**
     * The feature id for the '<em><b>Operational Limit Type</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__OPERATIONAL_LIMIT_TYPE = OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_TYPE;

    /**
     * The feature id for the '<em><b>Operational Limit Set</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__OPERATIONAL_LIMIT_SET = OPERATIONAL_LIMIT__OPERATIONAL_LIMIT_SET;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT__VALUE = OPERATIONAL_LIMIT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Voltage Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT_FEATURE_COUNT = OPERATIONAL_LIMIT_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>Voltage Limit</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int VOLTAGE_LIMIT_OPERATION_COUNT = OPERATIONAL_LIMIT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BreakerConfiguration <em>Breaker Configuration</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BreakerConfiguration
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBreakerConfiguration()
     * @generated
     */
    int BREAKER_CONFIGURATION = 345;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SVCControlMode <em>SVC Control Mode</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SVCControlMode
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSVCControlMode()
     * @generated
     */
    int SVC_CONTROL_MODE = 317;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipmentStatusKind <em>Contingency Equipment Status Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipmentStatusKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getContingencyEquipmentStatusKind()
     * @generated
     */
    int CONTINGENCY_EQUIPMENT_STATUS_KIND = 338;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachineOperatingMode <em>Synchronous Machine Operating Mode</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachineOperatingMode
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSynchronousMachineOperatingMode()
     * @generated
     */
    int SYNCHRONOUS_MACHINE_OPERATING_MODE = 306;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGenUnitKind <em>Wind Gen Unit Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGenUnitKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getWindGenUnitKind()
     * @generated
     */
    int WIND_GEN_UNIT_KIND = 308;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnitType <em>Remote Unit Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnitType
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRemoteUnitType()
     * @generated
     */
    int REMOTE_UNIT_TYPE = 340;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformerKind <em>Potential Transformer Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformerKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPotentialTransformerKind()
     * @generated
     */
    int POTENTIAL_TRANSFORMER_KIND = 319;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerControlMode <em>Transformer Control Mode</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerControlMode
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTransformerControlMode()
     * @generated
     */
    int TRANSFORMER_CONTROL_MODE = 320;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseShuntConnectionKind <em>Phase Shunt Connection Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseShuntConnectionKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseShuntConnectionKind()
     * @generated
     */
    int PHASE_SHUNT_CONNECTION_KIND = 342;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratorControlSource <em>Generator Control Source</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratorControlSource
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGeneratorControlSource()
     * @generated
     */
    int GENERATOR_CONTROL_SOURCE = 329;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseCode <em>Phase Code</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseCode
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseCode()
     * @generated
     */
    int PHASE_CODE = 311;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BoilerControlMode <em>Boiler Control Mode</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BoilerControlMode
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBoilerControlMode()
     * @generated
     */
    int BOILER_CONTROL_MODE = 343;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroEnergyConversionKind <em>Hydro Energy Conversion Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroEnergyConversionKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHydroEnergyConversionKind()
     * @generated
     */
    int HYDRO_ENERGY_CONVERSION_KIND = 339;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachineKind <em>Asynchronous Machine Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachineKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getAsynchronousMachineKind()
     * @generated
     */
    int ASYNCHRONOUS_MACHINE_KIND = 324;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Source <em>Source</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Source
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSource()
     * @generated
     */
    int SOURCE = 315;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.UnitSymbol <em>Unit Symbol</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.UnitSymbol
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getUnitSymbol()
     * @generated
     */
    int UNIT_SYMBOL = 307;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseConnectedFaultKind <em>Phase Connected Fault Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseConnectedFaultKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPhaseConnectedFaultKind()
     * @generated
     */
    int PHASE_CONNECTED_FAULT_KIND = 313;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarConfiguration <em>Busbar Configuration</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarConfiguration
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getBusbarConfiguration()
     * @generated
     */
    int BUSBAR_CONFIGURATION = 327;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitDirectionKind <em>Operational Limit Direction Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitDirectionKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getOperationalLimitDirectionKind()
     * @generated
     */
    int OPERATIONAL_LIMIT_DIRECTION_KIND = 318;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratorControlMode <em>Generator Control Mode</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratorControlMode
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getGeneratorControlMode()
     * @generated
     */
    int GENERATOR_CONTROL_MODE = 323;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionValueSource <em>Emission Value Source</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionValueSource
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEmissionValueSource()
     * @generated
     */
    int EMISSION_VALUE_SOURCE = 304;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CoolantType <em>Coolant Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CoolantType
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCoolantType()
     * @generated
     */
    int COOLANT_TYPE = 341;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCPolarityKind <em>DC Polarity Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCPolarityKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCPolarityKind()
     * @generated
     */
    int DC_POLARITY_KIND = 309;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsQpccControlKind <em>Vs Qpcc Control Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsQpccControlKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getVsQpccControlKind()
     * @generated
     */
    int VS_QPCC_CONTROL_KIND = 326;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachineKind <em>Synchronous Machine Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachineKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSynchronousMachineKind()
     * @generated
     */
    int SYNCHRONOUS_MACHINE_KIND = 310;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPlantStorageKind <em>Hydro Plant Storage Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPlantStorageKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getHydroPlantStorageKind()
     * @generated
     */
    int HYDRO_PLANT_STORAGE_KIND = 331;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterOperatingModeKind <em>DC Converter Operating Mode Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterOperatingModeKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getDCConverterOperatingModeKind()
     * @generated
     */
    int DC_CONVERTER_OPERATING_MODE_KIND = 328;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsOperatingModeKind <em>Cs Operating Mode Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsOperatingModeKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCsOperatingModeKind()
     * @generated
     */
    int CS_OPERATING_MODE_KIND = 316;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShortCircuitRotorKind <em>Short Circuit Rotor Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShortCircuitRotorKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getShortCircuitRotorKind()
     * @generated
     */
    int SHORT_CIRCUIT_ROTOR_KIND = 314;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaTypeKind <em>Control Area Type Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaTypeKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getControlAreaTypeKind()
     * @generated
     */
    int CONTROL_AREA_TYPE_KIND = 332;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SinglePhaseKind <em>Single Phase Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SinglePhaseKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getSinglePhaseKind()
     * @generated
     */
    int SINGLE_PHASE_KIND = 321;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsPpccControlKind <em>Cs Ppcc Control Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsPpccControlKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCsPpccControlKind()
     * @generated
     */
    int CS_PPCC_CONTROL_KIND = 312;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoilModeKind <em>Petersen Coil Mode Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoilModeKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getPetersenCoilModeKind()
     * @generated
     */
    int PETERSEN_COIL_MODE_KIND = 334;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionType <em>Emission Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionType
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getEmissionType()
     * @generated
     */
    int EMISSION_TYPE = 322;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsPpccControlKind <em>Vs Ppcc Control Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsPpccControlKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getVsPpccControlKind()
     * @generated
     */
    int VS_PPCC_CONTROL_KIND = 335;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Currency <em>Currency</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Currency
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCurrency()
     * @generated
     */
    int CURRENCY = 344;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelType <em>Fuel Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelType
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getFuelType()
     * @generated
     */
    int FUEL_TYPE = 333;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TurbineType <em>Turbine Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TurbineType
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getTurbineType()
     * @generated
     */
    int TURBINE_TYPE = 336;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Validity <em>Validity</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Validity
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getValidity()
     * @generated
     */
    int VALIDITY = 302;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.UnitMultiplier <em>Unit Multiplier</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.UnitMultiplier
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getUnitMultiplier()
     * @generated
     */
    int UNIT_MULTIPLIER = 303;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OrientationKind <em>Orientation Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OrientationKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getOrientationKind()
     * @generated
     */
    int ORIENTATION_KIND = 325;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveStyle <em>Curve Style</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveStyle
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getCurveStyle()
     * @generated
     */
    int CURVE_STYLE = 337;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindingConnection <em>Winding Connection</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindingConnection
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getWindingConnection()
     * @generated
     */
    int WINDING_CONNECTION = 330;

    /**
     * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControlModeKind <em>Regulating Control Mode Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControlModeKind
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.impl.CimPackageImpl#getRegulatingControlModeKind()
     * @generated
     */
    int REGULATING_CONTROL_MODE_KIND = 305;

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimObjectWithID <em>Object With ID</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Object With ID</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimObjectWithID
     * @generated
     */
    EClass getCimObjectWithID();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimObjectWithID#getID <em>ID</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>ID</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CimObjectWithID#getID()
     * @see #getCimObjectWithID()
     * @generated
     */
    EAttribute getCimObjectWithID_ID();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateTimeInterval <em>Date Time Interval</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Date Time Interval</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateTimeInterval
     * @generated
     */
    EClass getDateTimeInterval();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateTimeInterval#getEnd <em>End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateTimeInterval#getEnd()
     * @see #getDateTimeInterval()
     * @generated
     */
    EAttribute getDateTimeInterval_End();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateTimeInterval#getStart <em>Start</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Start</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateTimeInterval#getStart()
     * @see #getDateTimeInterval()
     * @generated
     */
    EAttribute getDateTimeInterval_Start();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity <em>Integer Quantity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Integer Quantity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity
     * @generated
     */
    EClass getIntegerQuantity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity#getMultiplier <em>Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity#getMultiplier()
     * @see #getIntegerQuantity()
     * @generated
     */
    EAttribute getIntegerQuantity_Multiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity#getUnit <em>Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity#getUnit()
     * @see #getIntegerQuantity()
     * @generated
     */
    EAttribute getIntegerQuantity_Unit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IntegerQuantity#getValue()
     * @see #getIntegerQuantity()
     * @generated
     */
    EAttribute getIntegerQuantity_Value();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TimeInterval <em>Time Interval</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Time Interval</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TimeInterval
     * @generated
     */
    EClass getTimeInterval();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TimeInterval#getEnd <em>End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TimeInterval#getEnd()
     * @see #getTimeInterval()
     * @generated
     */
    EAttribute getTimeInterval_End();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TimeInterval#getStart <em>Start</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Start</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TimeInterval#getStart()
     * @see #getTimeInterval()
     * @generated
     */
    EAttribute getTimeInterval_Start();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance <em>Fault Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Fault Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance
     * @generated
     */
    EClass getFaultImpedance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance#getRGround <em>RGround</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>RGround</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance#getRGround()
     * @see #getFaultImpedance()
     * @generated
     */
    EAttribute getFaultImpedance_RGround();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance#getRLineToLine <em>RLine To Line</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>RLine To Line</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance#getRLineToLine()
     * @see #getFaultImpedance()
     * @generated
     */
    EAttribute getFaultImpedance_RLineToLine();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance#getXGround <em>XGround</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XGround</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance#getXGround()
     * @see #getFaultImpedance()
     * @generated
     */
    EAttribute getFaultImpedance_XGround();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance#getXLineToLine <em>XLine To Line</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XLine To Line</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultImpedance#getXLineToLine()
     * @see #getFaultImpedance()
     * @generated
     */
    EAttribute getFaultImpedance_XLineToLine();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity <em>Decimal Quantity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Decimal Quantity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity
     * @generated
     */
    EClass getDecimalQuantity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity#getCurrency <em>Currency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Currency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity#getCurrency()
     * @see #getDecimalQuantity()
     * @generated
     */
    EAttribute getDecimalQuantity_Currency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity#getMultiplier <em>Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity#getMultiplier()
     * @see #getDecimalQuantity()
     * @generated
     */
    EAttribute getDecimalQuantity_Multiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity#getUnit <em>Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity#getUnit()
     * @see #getDecimalQuantity()
     * @generated
     */
    EAttribute getDecimalQuantity_Unit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DecimalQuantity#getValue()
     * @see #getDecimalQuantity()
     * @generated
     */
    EAttribute getDecimalQuantity_Value();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity <em>String Quantity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>String Quantity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity
     * @generated
     */
    EClass getStringQuantity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity#getMultiplier <em>Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity#getMultiplier()
     * @see #getStringQuantity()
     * @generated
     */
    EAttribute getStringQuantity_Multiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity#getUnit <em>Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity#getUnit()
     * @see #getStringQuantity()
     * @generated
     */
    EAttribute getStringQuantity_Unit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringQuantity#getValue()
     * @see #getStringQuantity()
     * @generated
     */
    EAttribute getStringQuantity_Value();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateInterval <em>Date Interval</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Date Interval</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateInterval
     * @generated
     */
    EClass getDateInterval();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateInterval#getEnd <em>End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateInterval#getEnd()
     * @see #getDateInterval()
     * @generated
     */
    EAttribute getDateInterval_End();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateInterval#getStart <em>Start</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Start</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DateInterval#getStart()
     * @see #getDateInterval()
     * @generated
     */
    EAttribute getDateInterval_Start();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity <em>Float Quantity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Float Quantity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity
     * @generated
     */
    EClass getFloatQuantity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity#getMultiplier <em>Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity#getMultiplier()
     * @see #getFloatQuantity()
     * @generated
     */
    EAttribute getFloatQuantity_Multiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity#getUnit <em>Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity#getUnit()
     * @see #getFloatQuantity()
     * @generated
     */
    EAttribute getFloatQuantity_Unit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FloatQuantity#getValue()
     * @see #getFloatQuantity()
     * @generated
     */
    EAttribute getFloatQuantity_Value();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MonthDayInterval <em>Month Day Interval</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Month Day Interval</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MonthDayInterval
     * @generated
     */
    EClass getMonthDayInterval();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MonthDayInterval#getEnd <em>End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MonthDayInterval#getEnd()
     * @see #getMonthDayInterval()
     * @generated
     */
    EAttribute getMonthDayInterval_End();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MonthDayInterval#getStart <em>Start</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Start</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MonthDayInterval#getStart()
     * @see #getMonthDayInterval()
     * @generated
     */
    EAttribute getMonthDayInterval_Start();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource <em>Power System Resource</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Power System Resource</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource
     * @generated
     */
    EClass getPowerSystemResource();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource#getMeasurements <em>Measurements</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Measurements</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource#getMeasurements()
     * @see #getPowerSystemResource()
     * @generated
     */
    EReference getPowerSystemResource_Measurements();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource#getControls <em>Controls</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Controls</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource#getControls()
     * @see #getPowerSystemResource()
     * @generated
     */
    EReference getPowerSystemResource_Controls();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource#getOperatingShare <em>Operating Share</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Operating Share</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource#getOperatingShare()
     * @see #getPowerSystemResource()
     * @generated
     */
    EReference getPowerSystemResource_OperatingShare();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource#getPSRType <em>PSR Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>PSR Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerSystemResource#getPSRType()
     * @see #getPowerSystemResource()
     * @generated
     */
    EReference getPowerSystemResource_PSRType();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage <em>Sv Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sv Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage
     * @generated
     */
    EClass getSvVoltage();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage#getAngle <em>Angle</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Angle</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage#getAngle()
     * @see #getSvVoltage()
     * @generated
     */
    EAttribute getSvVoltage_Angle();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage#getV <em>V</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>V</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage#getV()
     * @see #getSvVoltage()
     * @generated
     */
    EAttribute getSvVoltage_V();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage#getTopologicalNode <em>Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvVoltage#getTopologicalNode()
     * @see #getSvVoltage()
     * @generated
     */
    EReference getSvVoltage_TopologicalNode();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoad <em>Non Conform Load</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Non Conform Load</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoad
     * @generated
     */
    EClass getNonConformLoad();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoad#getLoadGroup <em>Load Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Load Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoad#getLoadGroup()
     * @see #getNonConformLoad()
     * @generated
     */
    EReference getNonConformLoad_LoadGroup();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion <em>Sub Geographical Region</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sub Geographical Region</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion
     * @generated
     */
    EClass getSubGeographicalRegion();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion#getSubstations <em>Substations</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Substations</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion#getSubstations()
     * @see #getSubGeographicalRegion()
     * @generated
     */
    EReference getSubGeographicalRegion_Substations();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion#getRegion <em>Region</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Region</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion#getRegion()
     * @see #getSubGeographicalRegion()
     * @generated
     */
    EReference getSubGeographicalRegion_Region();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion#getLines <em>Lines</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Lines</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion#getLines()
     * @see #getSubGeographicalRegion()
     * @generated
     */
    EReference getSubGeographicalRegion_Lines();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion#getDCLines <em>DC Lines</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Lines</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubGeographicalRegion#getDCLines()
     * @see #getSubGeographicalRegion()
     * @generated
     */
    EReference getSubGeographicalRegion_DCLines();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue <em>Discrete Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Discrete Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue
     * @generated
     */
    EClass getDiscreteValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue#getValue()
     * @see #getDiscreteValue()
     * @generated
     */
    EAttribute getDiscreteValue_Value();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue#getDiscrete <em>Discrete</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Discrete</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue#getDiscrete()
     * @see #getDiscreteValue()
     * @generated
     */
    EReference getDiscreteValue_Discrete();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue#getCommand <em>Command</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Command</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteValue#getCommand()
     * @see #getDiscreteValue()
     * @generated
     */
    EReference getDiscreteValue_Command();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimitSet <em>Accumulator Limit Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Accumulator Limit Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimitSet
     * @generated
     */
    EClass getAccumulatorLimitSet();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimitSet#getLimits <em>Limits</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Limits</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimitSet#getLimits()
     * @see #getAccumulatorLimitSet()
     * @generated
     */
    EReference getAccumulatorLimitSet_Limits();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimitSet#getMeasurements <em>Measurements</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Measurements</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimitSet#getMeasurements()
     * @see #getAccumulatorLimitSet()
     * @generated
     */
    EReference getAccumulatorLimitSet_Measurements();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir <em>Reservoir</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Reservoir</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir
     * @generated
     */
    EClass getReservoir();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getActiveStorageCapacity <em>Active Storage Capacity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Active Storage Capacity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getActiveStorageCapacity()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_ActiveStorageCapacity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getEnergyStorageRating <em>Energy Storage Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Energy Storage Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getEnergyStorageRating()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_EnergyStorageRating();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getFullSupplyLevel <em>Full Supply Level</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Full Supply Level</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getFullSupplyLevel()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_FullSupplyLevel();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getGrossCapacity <em>Gross Capacity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Gross Capacity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getGrossCapacity()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_GrossCapacity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getNormalMinOperateLevel <em>Normal Min Operate Level</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Min Operate Level</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getNormalMinOperateLevel()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_NormalMinOperateLevel();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getRiverOutletWorks <em>River Outlet Works</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>River Outlet Works</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getRiverOutletWorks()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_RiverOutletWorks();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillTravelDelay <em>Spill Travel Delay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Spill Travel Delay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillTravelDelay()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_SpillTravelDelay();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillwayCapacity <em>Spillway Capacity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Spillway Capacity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillwayCapacity()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_SpillwayCapacity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillwayCrestLength <em>Spillway Crest Length</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Spillway Crest Length</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillwayCrestLength()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_SpillwayCrestLength();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillwayCrestLevel <em>Spillway Crest Level</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Spillway Crest Level</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillwayCrestLevel()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_SpillwayCrestLevel();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillWayGateType <em>Spill Way Gate Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Spill Way Gate Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillWayGateType()
     * @see #getReservoir()
     * @generated
     */
    EAttribute getReservoir_SpillWayGateType();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getUpstreamFromHydroPowerPlants <em>Upstream From Hydro Power Plants</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Upstream From Hydro Power Plants</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getUpstreamFromHydroPowerPlants()
     * @see #getReservoir()
     * @generated
     */
    EReference getReservoir_UpstreamFromHydroPowerPlants();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getLevelVsVolumeCurves <em>Level Vs Volume Curves</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Level Vs Volume Curves</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getLevelVsVolumeCurves()
     * @see #getReservoir()
     * @generated
     */
    EReference getReservoir_LevelVsVolumeCurves();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getHydroPowerPlants <em>Hydro Power Plants</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Hydro Power Plants</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getHydroPowerPlants()
     * @see #getReservoir()
     * @generated
     */
    EReference getReservoir_HydroPowerPlants();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillsIntoReservoirs <em>Spills Into Reservoirs</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Spills Into Reservoirs</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillsIntoReservoirs()
     * @see #getReservoir()
     * @generated
     */
    EReference getReservoir_SpillsIntoReservoirs();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getTargetLevelSchedule <em>Target Level Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Target Level Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getTargetLevelSchedule()
     * @see #getReservoir()
     * @generated
     */
    EReference getReservoir_TargetLevelSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillsFromReservoir <em>Spills From Reservoir</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Spills From Reservoir</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getSpillsFromReservoir()
     * @see #getReservoir()
     * @generated
     */
    EReference getReservoir_SpillsFromReservoir();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getInflowForecasts <em>Inflow Forecasts</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Inflow Forecasts</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Reservoir#getInflowForecasts()
     * @see #getReservoir()
     * @generated
     */
    EReference getReservoir_InflowForecasts();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData <em>Phase Impedance Data</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Phase Impedance Data</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData
     * @generated
     */
    EClass getPhaseImpedanceData();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getB <em>B</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getB()
     * @see #getPhaseImpedanceData()
     * @generated
     */
    EAttribute getPhaseImpedanceData_B();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getR()
     * @see #getPhaseImpedanceData()
     * @generated
     */
    EAttribute getPhaseImpedanceData_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getSequenceNumber <em>Sequence Number</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sequence Number</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getSequenceNumber()
     * @see #getPhaseImpedanceData()
     * @generated
     */
    EAttribute getPhaseImpedanceData_SequenceNumber();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getX()
     * @see #getPhaseImpedanceData()
     * @generated
     */
    EAttribute getPhaseImpedanceData_X();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getPhaseImpedance <em>Phase Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Phase Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseImpedanceData#getPhaseImpedance()
     * @see #getPhaseImpedanceData()
     * @generated
     */
    EReference getPhaseImpedanceData_PhaseImpedance();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSupply <em>Steam Supply</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Steam Supply</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSupply
     * @generated
     */
    EClass getSteamSupply();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSupply#getSteamSupplyRating <em>Steam Supply Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Steam Supply Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSupply#getSteamSupplyRating()
     * @see #getSteamSupply()
     * @generated
     */
    EAttribute getSteamSupply_SteamSupplyRating();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSupply#getSteamTurbines <em>Steam Turbines</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Steam Turbines</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSupply#getSteamTurbines()
     * @see #getSteamSupply()
     * @generated
     */
    EReference getSteamSupply_SteamTurbines();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PSRType <em>PSR Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>PSR Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PSRType
     * @generated
     */
    EClass getPSRType();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PSRType#getPowerSystemResources <em>Power System Resources</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Power System Resources</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PSRType#getPowerSystemResources()
     * @see #getPSRType()
     * @generated
     */
    EReference getPSRType_PowerSystemResources();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvStatus <em>Sv Status</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sv Status</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvStatus
     * @generated
     */
    EClass getSvStatus();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvStatus#getInService <em>In Service</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>In Service</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvStatus#getInService()
     * @see #getSvStatus()
     * @generated
     */
    EAttribute getSvStatus_InService();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvStatus#getConductingEquipment <em>Conducting Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Conducting Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvStatus#getConductingEquipment()
     * @see #getSvStatus()
     * @generated
     */
    EReference getSvStatus_ConductingEquipment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteCommand <em>Discrete Command</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Discrete Command</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiscreteCommand
     * @generated
     */
    EClass getDiscreteCommand();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSendoutSchedule <em>Steam Sendout Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Steam Sendout Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSendoutSchedule
     * @generated
     */
    EClass getSteamSendoutSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSendoutSchedule#getCogenerationPlant <em>Cogeneration Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Cogeneration Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamSendoutSchedule#getCogenerationPlant()
     * @see #getSteamSendoutSchedule()
     * @generated
     */
    EReference getSteamSendoutSchedule_CogenerationPlant();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase <em>Energy Consumer Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Energy Consumer Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase
     * @generated
     */
    EClass getEnergyConsumerPhase();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getPfixed <em>Pfixed</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pfixed</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getPfixed()
     * @see #getEnergyConsumerPhase()
     * @generated
     */
    EAttribute getEnergyConsumerPhase_Pfixed();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getPfixedPct <em>Pfixed Pct</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pfixed Pct</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getPfixedPct()
     * @see #getEnergyConsumerPhase()
     * @generated
     */
    EAttribute getEnergyConsumerPhase_PfixedPct();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getPhase <em>Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getPhase()
     * @see #getEnergyConsumerPhase()
     * @generated
     */
    EAttribute getEnergyConsumerPhase_Phase();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getQfixed <em>Qfixed</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Qfixed</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getQfixed()
     * @see #getEnergyConsumerPhase()
     * @generated
     */
    EAttribute getEnergyConsumerPhase_Qfixed();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getQfixedPct <em>Qfixed Pct</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Qfixed Pct</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getQfixedPct()
     * @see #getEnergyConsumerPhase()
     * @generated
     */
    EAttribute getEnergyConsumerPhase_QfixedPct();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getEnergyConsumer <em>Energy Consumer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Energy Consumer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumerPhase#getEnergyConsumer()
     * @see #getEnergyConsumerPhase()
     * @generated
     */
    EReference getEnergyConsumerPhase_EnergyConsumer();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBusbar <em>DC Busbar</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Busbar</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBusbar
     * @generated
     */
    EClass getDCBusbar();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator <em>Linear Shunt Compensator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Linear Shunt Compensator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator
     * @generated
     */
    EClass getLinearShuntCompensator();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator#getB0PerSection <em>B0 Per Section</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B0 Per Section</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator#getB0PerSection()
     * @see #getLinearShuntCompensator()
     * @generated
     */
    EAttribute getLinearShuntCompensator_B0PerSection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator#getBPerSection <em>BPer Section</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>BPer Section</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator#getBPerSection()
     * @see #getLinearShuntCompensator()
     * @generated
     */
    EAttribute getLinearShuntCompensator_BPerSection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator#getG0PerSection <em>G0 Per Section</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G0 Per Section</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator#getG0PerSection()
     * @see #getLinearShuntCompensator()
     * @generated
     */
    EAttribute getLinearShuntCompensator_G0PerSection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator#getGPerSection <em>GPer Section</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>GPer Section</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensator#getGPerSection()
     * @see #getLinearShuntCompensator()
     * @generated
     */
    EAttribute getLinearShuntCompensator_GPerSection();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter <em>Per Length DC Line Parameter</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Per Length DC Line Parameter</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter
     * @generated
     */
    EClass getPerLengthDCLineParameter();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter#getCapacitance <em>Capacitance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Capacitance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter#getCapacitance()
     * @see #getPerLengthDCLineParameter()
     * @generated
     */
    EAttribute getPerLengthDCLineParameter_Capacitance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter#getInductance <em>Inductance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Inductance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter#getInductance()
     * @see #getPerLengthDCLineParameter()
     * @generated
     */
    EAttribute getPerLengthDCLineParameter_Inductance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter#getResistance <em>Resistance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Resistance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter#getResistance()
     * @see #getPerLengthDCLineParameter()
     * @generated
     */
    EAttribute getPerLengthDCLineParameter_Resistance();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter#getDCLineSegments <em>DC Line Segments</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Line Segments</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthDCLineParameter#getDCLineSegments()
     * @see #getPerLengthDCLineParameter()
     * @generated
     */
    EReference getPerLengthDCLineParameter_DCLineSegments();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimit <em>Operational Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Operational Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimit
     * @generated
     */
    EClass getOperationalLimit();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimit#getOperationalLimitType <em>Operational Limit Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Operational Limit Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimit#getOperationalLimitType()
     * @see #getOperationalLimit()
     * @generated
     */
    EReference getOperationalLimit_OperationalLimitType();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimit#getOperationalLimitSet <em>Operational Limit Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Operational Limit Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimit#getOperationalLimitSet()
     * @see #getOperationalLimit()
     * @generated
     */
    EReference getOperationalLimit_OperationalLimitSet();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SurgeArrester <em>Surge Arrester</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Surge Arrester</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SurgeArrester
     * @generated
     */
    EClass getSurgeArrester();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment <em>AC Line Segment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>AC Line Segment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment
     * @generated
     */
    EClass getACLineSegment();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getB0ch <em>B0ch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B0ch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getB0ch()
     * @see #getACLineSegment()
     * @generated
     */
    EAttribute getACLineSegment_B0ch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getBch <em>Bch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Bch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getBch()
     * @see #getACLineSegment()
     * @generated
     */
    EAttribute getACLineSegment_Bch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getG0ch <em>G0ch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G0ch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getG0ch()
     * @see #getACLineSegment()
     * @generated
     */
    EAttribute getACLineSegment_G0ch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getGch <em>Gch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Gch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getGch()
     * @see #getACLineSegment()
     * @generated
     */
    EAttribute getACLineSegment_Gch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getR()
     * @see #getACLineSegment()
     * @generated
     */
    EAttribute getACLineSegment_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getR0()
     * @see #getACLineSegment()
     * @generated
     */
    EAttribute getACLineSegment_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getShortCircuitEndTemperature <em>Short Circuit End Temperature</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Short Circuit End Temperature</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getShortCircuitEndTemperature()
     * @see #getACLineSegment()
     * @generated
     */
    EAttribute getACLineSegment_ShortCircuitEndTemperature();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getX()
     * @see #getACLineSegment()
     * @generated
     */
    EAttribute getACLineSegment_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getX0()
     * @see #getACLineSegment()
     * @generated
     */
    EAttribute getACLineSegment_X0();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getACLineSegmentPhases <em>AC Line Segment Phases</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>AC Line Segment Phases</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getACLineSegmentPhases()
     * @see #getACLineSegment()
     * @generated
     */
    EReference getACLineSegment_ACLineSegmentPhases();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getPerLengthImpedance <em>Per Length Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Per Length Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getPerLengthImpedance()
     * @see #getACLineSegment()
     * @generated
     */
    EReference getACLineSegment_PerLengthImpedance();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getCut <em>Cut</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Cut</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getCut()
     * @see #getACLineSegment()
     * @generated
     */
    EReference getACLineSegment_Cut();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getClamp <em>Clamp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Clamp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getClamp()
     * @see #getACLineSegment()
     * @generated
     */
    EReference getACLineSegment_Clamp();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getLineFaults <em>Line Faults</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Line Faults</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegment#getLineFaults()
     * @see #getACLineSegment()
     * @generated
     */
    EReference getACLineSegment_LineFaults();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Recloser <em>Recloser</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Recloser</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Recloser
     * @generated
     */
    EClass getRecloser();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageControlZone <em>Voltage Control Zone</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Voltage Control Zone</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageControlZone
     * @generated
     */
    EClass getVoltageControlZone();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageControlZone#getRegulationSchedule <em>Regulation Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Regulation Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageControlZone#getRegulationSchedule()
     * @see #getVoltageControlZone()
     * @generated
     */
    EReference getVoltageControlZone_RegulationSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageControlZone#getBusbarSection <em>Busbar Section</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Busbar Section</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageControlZone#getBusbarSection()
     * @see #getVoltageControlZone()
     * @generated
     */
    EReference getVoltageControlZone_BusbarSection();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGeneratingUnit <em>Wind Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Wind Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGeneratingUnit
     * @generated
     */
    EClass getWindGeneratingUnit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGeneratingUnit#getWindGenUnitType <em>Wind Gen Unit Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Wind Gen Unit Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGeneratingUnit#getWindGenUnitType()
     * @see #getWindGeneratingUnit()
     * @generated
     */
    EAttribute getWindGeneratingUnit_WindGenUnitType();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel <em>Voltage Level</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Voltage Level</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel
     * @generated
     */
    EClass getVoltageLevel();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getHighVoltageLimit <em>High Voltage Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>High Voltage Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getHighVoltageLimit()
     * @see #getVoltageLevel()
     * @generated
     */
    EAttribute getVoltageLevel_HighVoltageLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getLowVoltageLimit <em>Low Voltage Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Low Voltage Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getLowVoltageLimit()
     * @see #getVoltageLevel()
     * @generated
     */
    EAttribute getVoltageLevel_LowVoltageLimit();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getSubstation <em>Substation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Substation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getSubstation()
     * @see #getVoltageLevel()
     * @generated
     */
    EReference getVoltageLevel_Substation();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getBays <em>Bays</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Bays</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getBays()
     * @see #getVoltageLevel()
     * @generated
     */
    EReference getVoltageLevel_Bays();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getBaseVoltage <em>Base Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLevel#getBaseVoltage()
     * @see #getVoltageLevel()
     * @generated
     */
    EReference getVoltageLevel_BaseVoltage();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd <em>Power Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Power Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd
     * @generated
     */
    EClass getPowerTransformerEnd();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getB <em>B</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getB()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_B();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getB0 <em>B0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getB0()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_B0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getConnectionKind <em>Connection Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Connection Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getConnectionKind()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_ConnectionKind();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getG <em>G</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getG()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_G();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getG0 <em>G0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getG0()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_G0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getPhaseAngleClock <em>Phase Angle Clock</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phase Angle Clock</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getPhaseAngleClock()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_PhaseAngleClock();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getR()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getR0()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getRatedS <em>Rated S</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated S</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getRatedS()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_RatedS();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getRatedU <em>Rated U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getRatedU()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_RatedU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getX()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getX0()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EAttribute getPowerTransformerEnd_X0();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getPowerTransformer <em>Power Transformer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Power Transformer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformerEnd#getPowerTransformer()
     * @see #getPowerTransformerEnd()
     * @generated
     */
    EReference getPowerTransformerEnd_PowerTransformer();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IEC61970CIMVersion <em>IEC61970CIM Version</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>IEC61970CIM Version</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IEC61970CIMVersion
     * @generated
     */
    EClass getIEC61970CIMVersion();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IEC61970CIMVersion#getDate <em>Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Date</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IEC61970CIMVersion#getDate()
     * @see #getIEC61970CIMVersion()
     * @generated
     */
    EAttribute getIEC61970CIMVersion_Date();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IEC61970CIMVersion#getVersion <em>Version</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Version</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IEC61970CIMVersion#getVersion()
     * @see #getIEC61970CIMVersion()
     * @generated
     */
    EAttribute getIEC61970CIMVersion_Version();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine <em>Synchronous Machine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Synchronous Machine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine
     * @generated
     */
    EClass getSynchronousMachine();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getAVRToManualLag <em>AVR To Manual Lag</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>AVR To Manual Lag</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getAVRToManualLag()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_AVRToManualLag();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getAVRToManualLead <em>AVR To Manual Lead</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>AVR To Manual Lead</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getAVRToManualLead()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_AVRToManualLead();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getBaseQ <em>Base Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Base Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getBaseQ()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_BaseQ();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getCondenserP <em>Condenser P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Condenser P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getCondenserP()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_CondenserP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getCoolantCondition <em>Coolant Condition</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Coolant Condition</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getCoolantCondition()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_CoolantCondition();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getCoolantType <em>Coolant Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Coolant Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getCoolantType()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_CoolantType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getEarthing <em>Earthing</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Earthing</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getEarthing()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_Earthing();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getEarthingStarPointR <em>Earthing Star Point R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Earthing Star Point R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getEarthingStarPointR()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_EarthingStarPointR();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getEarthingStarPointX <em>Earthing Star Point X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Earthing Star Point X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getEarthingStarPointX()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_EarthingStarPointX();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getIkk <em>Ikk</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ikk</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getIkk()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_Ikk();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getManualToAVR <em>Manual To AVR</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Manual To AVR</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getManualToAVR()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_ManualToAVR();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMaxQ <em>Max Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMaxQ()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_MaxQ();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMaxU <em>Max U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMaxU()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_MaxU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMinQ <em>Min Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMinQ()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_MinQ();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMinU <em>Min U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMinU()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_MinU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMu <em>Mu</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Mu</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getMu()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_Mu();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getOperatingMode <em>Operating Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Operating Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getOperatingMode()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_OperatingMode();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getQPercent <em>QPercent</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QPercent</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getQPercent()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_QPercent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getR()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getR0()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getR2 <em>R2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getR2()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_R2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getReferencePriority <em>Reference Priority</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reference Priority</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getReferencePriority()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_ReferencePriority();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getSatDirectSubtransX <em>Sat Direct Subtrans X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sat Direct Subtrans X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getSatDirectSubtransX()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_SatDirectSubtransX();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getSatDirectSyncX <em>Sat Direct Sync X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sat Direct Sync X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getSatDirectSyncX()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_SatDirectSyncX();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getSatDirectTransX <em>Sat Direct Trans X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sat Direct Trans X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getSatDirectTransX()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_SatDirectTransX();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getShortCircuitRotorType <em>Short Circuit Rotor Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Short Circuit Rotor Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getShortCircuitRotorType()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_ShortCircuitRotorType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getType <em>Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getType()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_Type();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getVoltageRegulationRange <em>Voltage Regulation Range</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Voltage Regulation Range</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getVoltageRegulationRange()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_VoltageRegulationRange();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getX0()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_X0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getX2 <em>X2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getX2()
     * @see #getSynchronousMachine()
     * @generated
     */
    EAttribute getSynchronousMachine_X2();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getReactiveCapabilityCurves <em>Reactive Capability Curves</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Reactive Capability Curves</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getReactiveCapabilityCurves()
     * @see #getSynchronousMachine()
     * @generated
     */
    EReference getSynchronousMachine_ReactiveCapabilityCurves();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getPrimeMovers <em>Prime Movers</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Prime Movers</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getPrimeMovers()
     * @see #getSynchronousMachine()
     * @generated
     */
    EReference getSynchronousMachine_PrimeMovers();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getInitialReactiveCapabilityCurve <em>Initial Reactive Capability Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Initial Reactive Capability Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachine#getInitialReactiveCapabilityCurve()
     * @see #getSynchronousMachine()
     * @generated
     */
    EReference getSynchronousMachine_InitialReactiveCapabilityCurve();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource <em>Energy Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Energy Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource
     * @generated
     */
    EClass getEnergySource();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getActivePower <em>Active Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Active Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getActivePower()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_ActivePower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getNominalVoltage <em>Nominal Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Nominal Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getNominalVoltage()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_NominalVoltage();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getR()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getR0()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getReactivePower <em>Reactive Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reactive Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getReactivePower()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_ReactivePower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getRn <em>Rn</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rn</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getRn()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_Rn();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getVoltageAngle <em>Voltage Angle</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Voltage Angle</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getVoltageAngle()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_VoltageAngle();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getVoltageMagnitude <em>Voltage Magnitude</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Voltage Magnitude</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getVoltageMagnitude()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_VoltageMagnitude();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getX()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getX0()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_X0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getXn <em>Xn</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xn</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergySource#getXn()
     * @see #getEnergySource()
     * @generated
     */
    EAttribute getEnergySource_Xn();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone <em>Power Cut Zone</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Power Cut Zone</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone
     * @generated
     */
    EClass getPowerCutZone();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone#getCutLevel1 <em>Cut Level1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cut Level1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone#getCutLevel1()
     * @see #getPowerCutZone()
     * @generated
     */
    EAttribute getPowerCutZone_CutLevel1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone#getCutLevel2 <em>Cut Level2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cut Level2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone#getCutLevel2()
     * @see #getPowerCutZone()
     * @generated
     */
    EAttribute getPowerCutZone_CutLevel2();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone#getEnergyConsumers <em>Energy Consumers</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Energy Consumers</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerCutZone#getEnergyConsumers()
     * @see #getPowerCutZone()
     * @generated
     */
    EReference getPowerCutZone_EnergyConsumers();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverterDCTerminal <em>ACDC Converter DC Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>ACDC Converter DC Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverterDCTerminal
     * @generated
     */
    EClass getACDCConverterDCTerminal();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverterDCTerminal#getPolarity <em>Polarity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Polarity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverterDCTerminal#getPolarity()
     * @see #getACDCConverterDCTerminal()
     * @generated
     */
    EAttribute getACDCConverterDCTerminal_Polarity();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverterDCTerminal#getDCConductingEquipment <em>DC Conducting Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>DC Conducting Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverterDCTerminal#getDCConductingEquipment()
     * @see #getACDCConverterDCTerminal()
     * @generated
     */
    EReference getACDCConverterDCTerminal_DCConductingEquipment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StateVariable <em>State Variable</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>State Variable</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StateVariable
     * @generated
     */
    EClass getStateVariable();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegmentPhase <em>AC Line Segment Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>AC Line Segment Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegmentPhase
     * @generated
     */
    EClass getACLineSegmentPhase();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegmentPhase#getPhase <em>Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegmentPhase#getPhase()
     * @see #getACLineSegmentPhase()
     * @generated
     */
    EAttribute getACLineSegmentPhase_Phase();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegmentPhase#getACLineSegment <em>AC Line Segment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>AC Line Segment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACLineSegmentPhase#getACLineSegment()
     * @see #getACLineSegmentPhase()
     * @generated
     */
    EReference getACLineSegmentPhase_ACLineSegment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch <em>Protected Switch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Protected Switch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch
     * @generated
     */
    EClass getProtectedSwitch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch#getBreakingCapacity <em>Breaking Capacity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Breaking Capacity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch#getBreakingCapacity()
     * @see #getProtectedSwitch()
     * @generated
     */
    EAttribute getProtectedSwitch_BreakingCapacity();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch#getRecloseSequences <em>Reclose Sequences</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Reclose Sequences</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch#getRecloseSequences()
     * @see #getProtectedSwitch()
     * @generated
     */
    EReference getProtectedSwitch_RecloseSequences();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch#getOperatedByProtectionEquipment <em>Operated By Protection Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Operated By Protection Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectedSwitch#getOperatedByProtectionEquipment()
     * @see #getProtectedSwitch()
     * @generated
     */
    EReference getProtectedSwitch_OperatedByProtectionEquipment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyArea <em>Energy Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Energy Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyArea
     * @generated
     */
    EClass getEnergyArea();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyArea#getControlArea <em>Control Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Control Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyArea#getControlArea()
     * @see #getEnergyArea()
     * @generated
     */
    EReference getEnergyArea_ControlArea();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel <em>Startup Model</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Startup Model</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel
     * @generated
     */
    EClass getStartupModel();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getFixedMaintCost <em>Fixed Maint Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fixed Maint Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getFixedMaintCost()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_FixedMaintCost();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getHotStandbyHeat <em>Hot Standby Heat</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Hot Standby Heat</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getHotStandbyHeat()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_HotStandbyHeat();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getIncrementalMaintCost <em>Incremental Maint Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Incremental Maint Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getIncrementalMaintCost()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_IncrementalMaintCost();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getMinimumDownTime <em>Minimum Down Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Minimum Down Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getMinimumDownTime()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_MinimumDownTime();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getMinimumRunTime <em>Minimum Run Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Minimum Run Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getMinimumRunTime()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_MinimumRunTime();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getRiskFactorCost <em>Risk Factor Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Risk Factor Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getRiskFactorCost()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_RiskFactorCost();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartupCost <em>Startup Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Startup Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartupCost()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_StartupCost();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartupDate <em>Startup Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Startup Date</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartupDate()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_StartupDate();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartupPriority <em>Startup Priority</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Startup Priority</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartupPriority()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_StartupPriority();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStbyAuxP <em>Stby Aux P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Stby Aux P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStbyAuxP()
     * @see #getStartupModel()
     * @generated
     */
    EAttribute getStartupModel_StbyAuxP();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getThermalGeneratingUnit()
     * @see #getStartupModel()
     * @generated
     */
    EReference getStartupModel_ThermalGeneratingUnit();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartMainFuelCurve <em>Start Main Fuel Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Start Main Fuel Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartMainFuelCurve()
     * @see #getStartupModel()
     * @generated
     */
    EReference getStartupModel_StartMainFuelCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartIgnFuelCurve <em>Start Ign Fuel Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Start Ign Fuel Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartIgnFuelCurve()
     * @see #getStartupModel()
     * @generated
     */
    EReference getStartupModel_StartIgnFuelCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartRampCurve <em>Start Ramp Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Start Ramp Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartupModel#getStartRampCurve()
     * @see #getStartupModel()
     * @generated
     */
    EReference getStartupModel_StartRampCurve();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombinedCyclePlant <em>Combined Cycle Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Combined Cycle Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombinedCyclePlant
     * @generated
     */
    EClass getCombinedCyclePlant();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombinedCyclePlant#getCombCyclePlantRating <em>Comb Cycle Plant Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Comb Cycle Plant Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombinedCyclePlant#getCombCyclePlantRating()
     * @see #getCombinedCyclePlant()
     * @generated
     */
    EAttribute getCombinedCyclePlant_CombCyclePlantRating();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombinedCyclePlant#getThermalGeneratingUnits <em>Thermal Generating Units</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Thermal Generating Units</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombinedCyclePlant#getThermalGeneratingUnits()
     * @see #getCombinedCyclePlant()
     * @generated
     */
    EReference getCombinedCyclePlant_ThermalGeneratingUnits();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Plant <em>Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Plant
     * @generated
     */
    EClass getPlant();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet <em>Operational Limit Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Operational Limit Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet
     * @generated
     */
    EClass getOperationalLimitSet();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet#getOperationalLimitValue <em>Operational Limit Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Operational Limit Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet#getOperationalLimitValue()
     * @see #getOperationalLimitSet()
     * @generated
     */
    EReference getOperationalLimitSet_OperationalLimitValue();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet#getTerminal()
     * @see #getOperationalLimitSet()
     * @generated
     */
    EReference getOperationalLimitSet_Terminal();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet#getEquipment <em>Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitSet#getEquipment()
     * @see #getOperationalLimitSet()
     * @generated
     */
    EReference getOperationalLimitSet_Equipment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Contingency <em>Contingency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Contingency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Contingency
     * @generated
     */
    EClass getContingency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Contingency#getMustStudy <em>Must Study</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Must Study</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Contingency#getMustStudy()
     * @see #getContingency()
     * @generated
     */
    EAttribute getContingency_MustStudy();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Contingency#getContingencyElement <em>Contingency Element</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Contingency Element</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Contingency#getContingencyElement()
     * @see #getContingency()
     * @generated
     */
    EReference getContingency_ContingencyElement();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt <em>DC Shunt</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Shunt</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt
     * @generated
     */
    EClass getDCShunt();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt#getCapacitance <em>Capacitance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Capacitance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt#getCapacitance()
     * @see #getDCShunt()
     * @generated
     */
    EAttribute getDCShunt_Capacitance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt#getRatedUdc <em>Rated Udc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Udc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt#getRatedUdc()
     * @see #getDCShunt()
     * @generated
     */
    EAttribute getDCShunt_RatedUdc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt#getResistance <em>Resistance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Resistance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCShunt#getResistance()
     * @see #getDCShunt()
     * @generated
     */
    EAttribute getDCShunt_Resistance();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeasonDayTypeSchedule <em>Season Day Type Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Season Day Type Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeasonDayTypeSchedule
     * @generated
     */
    EClass getSeasonDayTypeSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeasonDayTypeSchedule#getSeason <em>Season</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Season</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeasonDayTypeSchedule#getSeason()
     * @see #getSeasonDayTypeSchedule()
     * @generated
     */
    EReference getSeasonDayTypeSchedule_Season();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeasonDayTypeSchedule#getDayType <em>Day Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Day Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeasonDayTypeSchedule#getDayType()
     * @see #getSeasonDayTypeSchedule()
     * @generated
     */
    EReference getSeasonDayTypeSchedule_DayType();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Line <em>Line</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Line</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Line
     * @generated
     */
    EClass getLine();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Line#getRegion <em>Region</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Region</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Line#getRegion()
     * @see #getLine()
     * @generated
     */
    EReference getLine_Region();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvShuntCompensatorSections <em>Sv Shunt Compensator Sections</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sv Shunt Compensator Sections</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvShuntCompensatorSections
     * @generated
     */
    EClass getSvShuntCompensatorSections();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvShuntCompensatorSections#getSections <em>Sections</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sections</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvShuntCompensatorSections#getSections()
     * @see #getSvShuntCompensatorSections()
     * @generated
     */
    EAttribute getSvShuntCompensatorSections_Sections();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvShuntCompensatorSections#getShuntCompensator <em>Shunt Compensator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Shunt Compensator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvShuntCompensatorSections#getShuntCompensator()
     * @see #getSvShuntCompensatorSections()
     * @generated
     */
    EReference getSvShuntCompensatorSections_ShuntCompensator();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensator <em>Nonlinear Shunt Compensator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Nonlinear Shunt Compensator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensator
     * @generated
     */
    EClass getNonlinearShuntCompensator();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensator#getNonlinearShuntCompensatorPoints <em>Nonlinear Shunt Compensator Points</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Nonlinear Shunt Compensator Points</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensator#getNonlinearShuntCompensatorPoints()
     * @see #getNonlinearShuntCompensator()
     * @generated
     */
    EReference getNonlinearShuntCompensator_NonlinearShuntCompensatorPoints();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement <em>Measurement</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Measurement</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement
     * @generated
     */
    EClass getMeasurement();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getMeasurementType <em>Measurement Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Measurement Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getMeasurementType()
     * @see #getMeasurement()
     * @generated
     */
    EAttribute getMeasurement_MeasurementType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getPhases <em>Phases</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phases</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getPhases()
     * @see #getMeasurement()
     * @generated
     */
    EAttribute getMeasurement_Phases();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getUnitMultiplier <em>Unit Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getUnitMultiplier()
     * @see #getMeasurement()
     * @generated
     */
    EAttribute getMeasurement_UnitMultiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getUnitSymbol <em>Unit Symbol</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit Symbol</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getUnitSymbol()
     * @see #getMeasurement()
     * @generated
     */
    EAttribute getMeasurement_UnitSymbol();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getTerminal()
     * @see #getMeasurement()
     * @generated
     */
    EReference getMeasurement_Terminal();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getPowerSystemResource <em>Power System Resource</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Power System Resource</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Measurement#getPowerSystemResource()
     * @see #getMeasurement()
     * @generated
     */
    EReference getMeasurement_PowerSystemResource();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPumpOpSchedule <em>Hydro Pump Op Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Hydro Pump Op Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPumpOpSchedule
     * @generated
     */
    EClass getHydroPumpOpSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPumpOpSchedule#getHydroPump <em>Hydro Pump</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Hydro Pump</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPumpOpSchedule#getHydroPump()
     * @see #getHydroPumpOpSchedule()
     * @generated
     */
    EReference getHydroPumpOpSchedule_HydroPump();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTablePoint <em>Ratio Tap Changer Table Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Ratio Tap Changer Table Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTablePoint
     * @generated
     */
    EClass getRatioTapChangerTablePoint();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTablePoint#getRatioTapChangerTable <em>Ratio Tap Changer Table</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Ratio Tap Changer Table</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTablePoint#getRatioTapChangerTable()
     * @see #getRatioTapChangerTablePoint()
     * @generated
     */
    EReference getRatioTapChangerTablePoint_RatioTapChangerTable();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal
     * @generated
     */
    EClass getTerminal();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getPhases <em>Phases</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phases</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getPhases()
     * @see #getTerminal()
     * @generated
     */
    EAttribute getTerminal_Phases();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getTieFlow <em>Tie Flow</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Tie Flow</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getTieFlow()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_TieFlow();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getHasFirstMutualCoupling <em>Has First Mutual Coupling</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Has First Mutual Coupling</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getHasFirstMutualCoupling()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_HasFirstMutualCoupling();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getAuxiliaryEquipment <em>Auxiliary Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Auxiliary Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getAuxiliaryEquipment()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_AuxiliaryEquipment();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getBranchGroupTerminal <em>Branch Group Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Branch Group Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getBranchGroupTerminal()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_BranchGroupTerminal();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getConductingEquipment <em>Conducting Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Conducting Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getConductingEquipment()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_ConductingEquipment();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getRegulatingControl <em>Regulating Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Regulating Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getRegulatingControl()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_RegulatingControl();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getConnectivityNode <em>Connectivity Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Connectivity Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getConnectivityNode()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_ConnectivityNode();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getConverterDCSides <em>Converter DC Sides</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Converter DC Sides</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getConverterDCSides()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_ConverterDCSides();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getSvPowerFlow <em>Sv Power Flow</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Sv Power Flow</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getSvPowerFlow()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_SvPowerFlow();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getTransformerEnd <em>Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getTransformerEnd()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_TransformerEnd();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getHasSecondMutualCoupling <em>Has Second Mutual Coupling</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Has Second Mutual Coupling</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getHasSecondMutualCoupling()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_HasSecondMutualCoupling();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getEquipmentFaults <em>Equipment Faults</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Equipment Faults</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getEquipmentFaults()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_EquipmentFaults();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getTopologicalNode <em>Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Terminal#getTopologicalNode()
     * @see #getTerminal()
     * @generated
     */
    EReference getTerminal_TopologicalNode();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance <em>Transformer Star Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Transformer Star Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance
     * @generated
     */
    EClass getTransformerStarImpedance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getR()
     * @see #getTransformerStarImpedance()
     * @generated
     */
    EAttribute getTransformerStarImpedance_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getR0()
     * @see #getTransformerStarImpedance()
     * @generated
     */
    EAttribute getTransformerStarImpedance_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getX()
     * @see #getTransformerStarImpedance()
     * @generated
     */
    EAttribute getTransformerStarImpedance_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getX0()
     * @see #getTransformerStarImpedance()
     * @generated
     */
    EAttribute getTransformerStarImpedance_X0();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getTransformerEnd <em>Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerStarImpedance#getTransformerEnd()
     * @see #getTransformerStarImpedance()
     * @generated
     */
    EReference getTransformerStarImpedance_TransformerEnd();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemotePoint <em>Remote Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Remote Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemotePoint
     * @generated
     */
    EClass getRemotePoint();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemotePoint#getRemoteUnit <em>Remote Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Remote Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemotePoint#getRemoteUnit()
     * @see #getRemotePoint()
     * @generated
     */
    EReference getRemotePoint_RemoteUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchSchedule <em>Switch Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Switch Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchSchedule
     * @generated
     */
    EClass getSwitchSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchSchedule#getSwitch <em>Switch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Switch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchSchedule#getSwitch()
     * @see #getSwitchSchedule()
     * @generated
     */
    EReference getSwitchSchedule_Switch();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog <em>Analog</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Analog</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog
     * @generated
     */
    EClass getAnalog();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getMaxValue <em>Max Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getMaxValue()
     * @see #getAnalog()
     * @generated
     */
    EAttribute getAnalog_MaxValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getMinValue <em>Min Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getMinValue()
     * @see #getAnalog()
     * @generated
     */
    EAttribute getAnalog_MinValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getNormalValue <em>Normal Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getNormalValue()
     * @see #getAnalog()
     * @generated
     */
    EAttribute getAnalog_NormalValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getPositiveFlowIn <em>Positive Flow In</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Positive Flow In</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getPositiveFlowIn()
     * @see #getAnalog()
     * @generated
     */
    EAttribute getAnalog_PositiveFlowIn();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getAnalogValues <em>Analog Values</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Analog Values</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getAnalogValues()
     * @see #getAnalog()
     * @generated
     */
    EReference getAnalog_AnalogValues();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getLimitSets <em>Limit Sets</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Limit Sets</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Analog#getLimitSets()
     * @see #getAnalog()
     * @generated
     */
    EReference getAnalog_LimitSets();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EarthFaultCompensator <em>Earth Fault Compensator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Earth Fault Compensator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EarthFaultCompensator
     * @generated
     */
    EClass getEarthFaultCompensator();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EarthFaultCompensator#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EarthFaultCompensator#getR()
     * @see #getEarthFaultCompensator()
     * @generated
     */
    EAttribute getEarthFaultCompensator_R();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply <em>BWR Steam Supply</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>BWR Steam Supply</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply
     * @generated
     */
    EClass getBWRSteamSupply();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getHighPowerLimit <em>High Power Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>High Power Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getHighPowerLimit()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_HighPowerLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getInCoreThermalTC <em>In Core Thermal TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>In Core Thermal TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getInCoreThermalTC()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_InCoreThermalTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getIntegralGain <em>Integral Gain</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Integral Gain</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getIntegralGain()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_IntegralGain();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowerLimit <em>Lower Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Lower Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowerLimit()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_LowerLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowPowerLimit <em>Low Power Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Low Power Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getLowPowerLimit()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_LowPowerLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureLimit <em>Pressure Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pressure Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureLimit()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_PressureLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointGA <em>Pressure Setpoint GA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pressure Setpoint GA</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointGA()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_PressureSetpointGA();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC1 <em>Pressure Setpoint TC1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pressure Setpoint TC1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC1()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_PressureSetpointTC1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC2 <em>Pressure Setpoint TC2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pressure Setpoint TC2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getPressureSetpointTC2()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_PressureSetpointTC2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getProportionalGain <em>Proportional Gain</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Proportional Gain</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getProportionalGain()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_ProportionalGain();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux1 <em>Rf Aux1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rf Aux1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux1()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RfAux1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux2 <em>Rf Aux2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rf Aux2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux2()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RfAux2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux3 <em>Rf Aux3</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rf Aux3</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux3()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RfAux3();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux4 <em>Rf Aux4</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rf Aux4</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux4()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RfAux4();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux5 <em>Rf Aux5</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rf Aux5</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux5()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RfAux5();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux6 <em>Rf Aux6</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rf Aux6</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux6()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RfAux6();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux7 <em>Rf Aux7</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rf Aux7</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux7()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RfAux7();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux8 <em>Rf Aux8</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rf Aux8</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRfAux8()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RfAux8();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPattern <em>Rod Pattern</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rod Pattern</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPattern()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RodPattern();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPatternConstant <em>Rod Pattern Constant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rod Pattern Constant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getRodPatternConstant()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_RodPatternConstant();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getUpperLimit <em>Upper Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Upper Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BWRSteamSupply#getUpperLimit()
     * @see #getBWRSteamSupply()
     * @generated
     */
    EAttribute getBWRSteamSupply_UpperLimit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply <em>PWR Steam Supply</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>PWR Steam Supply</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply
     * @generated
     */
    EClass getPWRSteamSupply();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLagTC <em>Cold Leg FB Lag TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cold Leg FB Lag TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLagTC()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_ColdLegFBLagTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC1 <em>Cold Leg FB Lead TC1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cold Leg FB Lead TC1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC1()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_ColdLegFBLeadTC1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC2 <em>Cold Leg FB Lead TC2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cold Leg FB Lead TC2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFBLeadTC2()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_ColdLegFBLeadTC2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG1 <em>Cold Leg FG1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cold Leg FG1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG1()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_ColdLegFG1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG2 <em>Cold Leg FG2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cold Leg FG2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegFG2()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_ColdLegFG2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegLagTC <em>Cold Leg Lag TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cold Leg Lag TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getColdLegLagTC()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_ColdLegLagTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC1 <em>Core HT Lag TC1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Core HT Lag TC1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC1()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_CoreHTLagTC1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC2 <em>Core HT Lag TC2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Core HT Lag TC2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreHTLagTC2()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_CoreHTLagTC2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsEffTC <em>Core Neutronics Eff TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Core Neutronics Eff TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsEffTC()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_CoreNeutronicsEffTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsHT <em>Core Neutronics HT</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Core Neutronics HT</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getCoreNeutronicsHT()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_CoreNeutronicsHT();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getFeedbackFactor <em>Feedback Factor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Feedback Factor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getFeedbackFactor()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_FeedbackFactor();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegLagTC <em>Hot Leg Lag TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Hot Leg Lag TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegLagTC()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_HotLegLagTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegSteamGain <em>Hot Leg Steam Gain</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Hot Leg Steam Gain</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegSteamGain()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_HotLegSteamGain();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegToColdLegGain <em>Hot Leg To Cold Leg Gain</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Hot Leg To Cold Leg Gain</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getHotLegToColdLegGain()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_HotLegToColdLegGain();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getPressureCG <em>Pressure CG</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pressure CG</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getPressureCG()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_PressureCG();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamFlowFG <em>Steam Flow FG</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Steam Flow FG</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamFlowFG()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_SteamFlowFG();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureDropLagTC <em>Steam Pressure Drop Lag TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Steam Pressure Drop Lag TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureDropLagTC()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_SteamPressureDropLagTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureFG <em>Steam Pressure FG</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Steam Pressure FG</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getSteamPressureFG()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_SteamPressureFG();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureFactor <em>Throttle Pressure Factor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Throttle Pressure Factor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureFactor()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_ThrottlePressureFactor();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Throttle Pressure SP</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PWRSteamSupply#getThrottlePressureSP()
     * @see #getPWRSteamSupply()
     * @generated
     */
    EAttribute getPWRSteamSupply_ThrottlePressureSP();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramStyle <em>Diagram Style</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Diagram Style</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramStyle
     * @generated
     */
    EClass getDiagramStyle();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramStyle#getDiagram <em>Diagram</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Diagram</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramStyle#getDiagram()
     * @see #getDiagramStyle()
     * @generated
     */
    EReference getDiagramStyle_Diagram();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource <em>Remote Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Remote Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource
     * @generated
     */
    EClass getRemoteSource();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getDeadband <em>Deadband</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Deadband</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getDeadband()
     * @see #getRemoteSource()
     * @generated
     */
    EAttribute getRemoteSource_Deadband();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getScanInterval <em>Scan Interval</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Scan Interval</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getScanInterval()
     * @see #getRemoteSource()
     * @generated
     */
    EAttribute getRemoteSource_ScanInterval();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getSensorMaximum <em>Sensor Maximum</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sensor Maximum</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getSensorMaximum()
     * @see #getRemoteSource()
     * @generated
     */
    EAttribute getRemoteSource_SensorMaximum();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getSensorMinimum <em>Sensor Minimum</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sensor Minimum</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getSensorMinimum()
     * @see #getRemoteSource()
     * @generated
     */
    EAttribute getRemoteSource_SensorMinimum();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getMeasurementValue <em>Measurement Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Measurement Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteSource#getMeasurementValue()
     * @see #getRemoteSource()
     * @generated
     */
    EReference getRemoteSource_MeasurementValue();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasePower <em>Base Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Base Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasePower
     * @generated
     */
    EClass getBasePower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasePower#getBasePower <em>Base Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Base Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasePower#getBasePower()
     * @see #getBasePower()
     * @generated
     */
    EAttribute getBasePower_BasePower();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority <em>Name Type Authority</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Name Type Authority</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority
     * @generated
     */
    EClass getNameTypeAuthority();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority#getDescription <em>Description</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Description</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority#getDescription()
     * @see #getNameTypeAuthority()
     * @generated
     */
    EAttribute getNameTypeAuthority_Description();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority#getName <em>Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Name</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority#getName()
     * @see #getNameTypeAuthority()
     * @generated
     */
    EAttribute getNameTypeAuthority_Name();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority#getNameTypes <em>Name Types</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Name Types</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameTypeAuthority#getNameTypes()
     * @see #getNameTypeAuthority()
     * @generated
     */
    EReference getNameTypeAuthority_NameTypes();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimit <em>Analog Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Analog Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimit
     * @generated
     */
    EClass getAnalogLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimit#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimit#getValue()
     * @see #getAnalogLimit()
     * @generated
     */
    EAttribute getAnalogLimit_Value();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimit#getLimitSet <em>Limit Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Limit Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimit#getLimitSet()
     * @see #getAnalogLimit()
     * @generated
     */
    EReference getAnalogLimit_LimitSet();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCGround <em>DC Ground</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Ground</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCGround
     * @generated
     */
    EClass getDCGround();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCGround#getInductance <em>Inductance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Inductance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCGround#getInductance()
     * @see #getDCGround()
     * @generated
     */
    EAttribute getDCGround_Inductance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCGround#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCGround#getR()
     * @see #getDCGround()
     * @generated
     */
    EAttribute getDCGround_R();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment <em>Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment
     * @generated
     */
    EClass getEquipment();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getAggregate <em>Aggregate</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Aggregate</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getAggregate()
     * @see #getEquipment()
     * @generated
     */
    EAttribute getEquipment_Aggregate();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getNormallyInService <em>Normally In Service</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normally In Service</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getNormallyInService()
     * @see #getEquipment()
     * @generated
     */
    EAttribute getEquipment_NormallyInService();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getContingencyEquipment <em>Contingency Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Contingency Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getContingencyEquipment()
     * @see #getEquipment()
     * @generated
     */
    EReference getEquipment_ContingencyEquipment();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getOperationalLimitSet <em>Operational Limit Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Operational Limit Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getOperationalLimitSet()
     * @see #getEquipment()
     * @generated
     */
    EReference getEquipment_OperationalLimitSet();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getFaults <em>Faults</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Faults</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getFaults()
     * @see #getEquipment()
     * @generated
     */
    EReference getEquipment_Faults();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getEquipmentContainer <em>Equipment Container</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Equipment Container</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Equipment#getEquipmentContainer()
     * @see #getEquipment()
     * @generated
     */
    EReference getEquipment_EquipmentContainer();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation <em>Substation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Substation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation
     * @generated
     */
    EClass getSubstation();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation#getRegion <em>Region</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Region</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation#getRegion()
     * @see #getSubstation()
     * @generated
     */
    EReference getSubstation_Region();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation#getVoltageLevels <em>Voltage Levels</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Voltage Levels</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation#getVoltageLevels()
     * @see #getSubstation()
     * @generated
     */
    EReference getSubstation_VoltageLevels();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation#getBays <em>Bays</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Bays</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation#getBays()
     * @see #getSubstation()
     * @generated
     */
    EReference getSubstation_Bays();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation#getDCConverterUnit <em>DC Converter Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Converter Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Substation#getDCConverterUnit()
     * @see #getSubstation()
     * @generated
     */
    EReference getSubstation_DCConverterUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command <em>Command</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Command</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command
     * @generated
     */
    EClass getCommand();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command#getNormalValue <em>Normal Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command#getNormalValue()
     * @see #getCommand()
     * @generated
     */
    EAttribute getCommand_NormalValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command#getValue()
     * @see #getCommand()
     * @generated
     */
    EAttribute getCommand_Value();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command#getValueAliasSet <em>Value Alias Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Value Alias Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command#getValueAliasSet()
     * @see #getCommand()
     * @generated
     */
    EReference getCommand_ValueAliasSet();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command#getDiscreteValue <em>Discrete Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Discrete Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Command#getDiscreteValue()
     * @see #getCommand()
     * @generated
     */
    EReference getCommand_DiscreteValue();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow <em>Tie Flow</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Tie Flow</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow
     * @generated
     */
    EClass getTieFlow();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow#getPositiveFlowIn <em>Positive Flow In</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Positive Flow In</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow#getPositiveFlowIn()
     * @see #getTieFlow()
     * @generated
     */
    EAttribute getTieFlow_PositiveFlowIn();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow#getControlArea <em>Control Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Control Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow#getControlArea()
     * @see #getTieFlow()
     * @generated
     */
    EReference getTieFlow_ControlArea();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow#getTerminal()
     * @see #getTieFlow()
     * @generated
     */
    EReference getTieFlow_Terminal();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow#getAltTieMeas <em>Alt Tie Meas</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Alt Tie Meas</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TieFlow#getAltTieMeas()
     * @see #getTieFlow()
     * @generated
     */
    EReference getTieFlow_AltTieMeas();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear <em>Phase Tap Changer Linear</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Phase Tap Changer Linear</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear
     * @generated
     */
    EClass getPhaseTapChangerLinear();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear#getStepPhaseShiftIncrement <em>Step Phase Shift Increment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Step Phase Shift Increment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear#getStepPhaseShiftIncrement()
     * @see #getPhaseTapChangerLinear()
     * @generated
     */
    EAttribute getPhaseTapChangerLinear_StepPhaseShiftIncrement();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear#getXMax <em>XMax</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XMax</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear#getXMax()
     * @see #getPhaseTapChangerLinear()
     * @generated
     */
    EAttribute getPhaseTapChangerLinear_XMax();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear#getXMin <em>XMin</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XMin</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerLinear#getXMin()
     * @see #getPhaseTapChangerLinear()
     * @generated
     */
    EAttribute getPhaseTapChangerLinear_XMin();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NuclearGeneratingUnit <em>Nuclear Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Nuclear Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NuclearGeneratingUnit
     * @generated
     */
    EClass getNuclearGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine <em>Hydro Turbine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Hydro Turbine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine
     * @generated
     */
    EClass getHydroTurbine();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getGateRateLimit <em>Gate Rate Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Gate Rate Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getGateRateLimit()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_GateRateLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getGateUpperLimit <em>Gate Upper Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Gate Upper Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getGateUpperLimit()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_GateUpperLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getMaxHeadMaxP <em>Max Head Max P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Head Max P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getMaxHeadMaxP()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_MaxHeadMaxP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getMinHeadMaxP <em>Min Head Max P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Head Max P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getMinHeadMaxP()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_MinHeadMaxP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getSpeedRating <em>Speed Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Speed Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getSpeedRating()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_SpeedRating();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getSpeedRegulation <em>Speed Regulation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Speed Regulation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getSpeedRegulation()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_SpeedRegulation();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getTransientDroopTime <em>Transient Droop Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Transient Droop Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getTransientDroopTime()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_TransientDroopTime();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getTransientRegulation <em>Transient Regulation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Transient Regulation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getTransientRegulation()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_TransientRegulation();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getTurbineRating <em>Turbine Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Turbine Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getTurbineRating()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_TurbineRating();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getTurbineType <em>Turbine Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Turbine Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getTurbineType()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_TurbineType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getWaterStartingTime <em>Water Starting Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Water Starting Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroTurbine#getWaterStartingTime()
     * @see #getHydroTurbine()
     * @generated
     */
    EAttribute getHydroTurbine_WaterStartingTime();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal <em>Branch Group Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Branch Group Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal
     * @generated
     */
    EClass getBranchGroupTerminal();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal#getPositiveFlowIn <em>Positive Flow In</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Positive Flow In</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal#getPositiveFlowIn()
     * @see #getBranchGroupTerminal()
     * @generated
     */
    EAttribute getBranchGroupTerminal_PositiveFlowIn();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal#getBranchGroup <em>Branch Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Branch Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal#getBranchGroup()
     * @see #getBranchGroupTerminal()
     * @generated
     */
    EReference getBranchGroupTerminal_BranchGroup();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroupTerminal#getTerminal()
     * @see #getBranchGroupTerminal()
     * @generated
     */
    EReference getBranchGroupTerminal_Terminal();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBaseTerminal <em>DC Base Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Base Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBaseTerminal
     * @generated
     */
    EClass getDCBaseTerminal();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBaseTerminal#getDCNode <em>DC Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>DC Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBaseTerminal#getDCNode()
     * @see #getDCBaseTerminal()
     * @generated
     */
    EReference getDCBaseTerminal_DCNode();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBaseTerminal#getDCTopologicalNode <em>DC Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>DC Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBaseTerminal#getDCTopologicalNode()
     * @see #getDCBaseTerminal()
     * @generated
     */
    EReference getDCBaseTerminal_DCTopologicalNode();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentLimit <em>Current Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Current Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentLimit
     * @generated
     */
    EClass getCurrentLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentLimit#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentLimit#getValue()
     * @see #getCurrentLimit()
     * @generated
     */
    EAttribute getCurrentLimit_Value();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl <em>Regulating Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Regulating Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl
     * @generated
     */
    EClass getRegulatingControl();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getDiscrete <em>Discrete</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Discrete</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getDiscrete()
     * @see #getRegulatingControl()
     * @generated
     */
    EAttribute getRegulatingControl_Discrete();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getEnabled <em>Enabled</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Enabled</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getEnabled()
     * @see #getRegulatingControl()
     * @generated
     */
    EAttribute getRegulatingControl_Enabled();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getMode <em>Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getMode()
     * @see #getRegulatingControl()
     * @generated
     */
    EAttribute getRegulatingControl_Mode();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getMonitoredPhase <em>Monitored Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Monitored Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getMonitoredPhase()
     * @see #getRegulatingControl()
     * @generated
     */
    EAttribute getRegulatingControl_MonitoredPhase();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getTargetDeadband <em>Target Deadband</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Deadband</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getTargetDeadband()
     * @see #getRegulatingControl()
     * @generated
     */
    EAttribute getRegulatingControl_TargetDeadband();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getTargetValue <em>Target Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getTargetValue()
     * @see #getRegulatingControl()
     * @generated
     */
    EAttribute getRegulatingControl_TargetValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getTargetValueUnitMultiplier <em>Target Value Unit Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Value Unit Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getTargetValueUnitMultiplier()
     * @see #getRegulatingControl()
     * @generated
     */
    EAttribute getRegulatingControl_TargetValueUnitMultiplier();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getTerminal()
     * @see #getRegulatingControl()
     * @generated
     */
    EReference getRegulatingControl_Terminal();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getRegulationSchedule <em>Regulation Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Regulation Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getRegulationSchedule()
     * @see #getRegulatingControl()
     * @generated
     */
    EReference getRegulatingControl_RegulationSchedule();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getRegulatingCondEq <em>Regulating Cond Eq</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Regulating Cond Eq</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControl#getRegulatingCondEq()
     * @see #getRegulatingControl()
     * @generated
     */
    EReference getRegulatingControl_RegulatingCondEq();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubLoadArea <em>Sub Load Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sub Load Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubLoadArea
     * @generated
     */
    EClass getSubLoadArea();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubLoadArea#getLoadArea <em>Load Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Load Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubLoadArea#getLoadArea()
     * @see #getSubLoadArea()
     * @generated
     */
    EReference getSubLoadArea_LoadArea();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubLoadArea#getLoadGroups <em>Load Groups</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Load Groups</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SubLoadArea#getLoadGroups()
     * @see #getSubLoadArea()
     * @generated
     */
    EReference getSubLoadArea_LoadGroups();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseFrequency <em>Base Frequency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Base Frequency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseFrequency
     * @generated
     */
    EClass getBaseFrequency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseFrequency#getFrequency <em>Frequency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Frequency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseFrequency#getFrequency()
     * @see #getBaseFrequency()
     * @generated
     */
    EAttribute getBaseFrequency_Frequency();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TextDiagramObject <em>Text Diagram Object</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Text Diagram Object</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TextDiagramObject
     * @generated
     */
    EClass getTextDiagramObject();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TextDiagramObject#getText <em>Text</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Text</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TextDiagramObject#getText()
     * @see #getTextDiagramObject()
     * @generated
     */
    EAttribute getTextDiagramObject_Text();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartMainFuelCurve <em>Start Main Fuel Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Start Main Fuel Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartMainFuelCurve
     * @generated
     */
    EClass getStartMainFuelCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartMainFuelCurve#getMainFuelType <em>Main Fuel Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Main Fuel Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartMainFuelCurve#getMainFuelType()
     * @see #getStartMainFuelCurve()
     * @generated
     */
    EAttribute getStartMainFuelCurve_MainFuelType();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartMainFuelCurve#getStartupModel <em>Startup Model</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Startup Model</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartMainFuelCurve#getStartupModel()
     * @see #getStartMainFuelCurve()
     * @generated
     */
    EReference getStartMainFuelCurve_StartupModel();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit <em>Control Area Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Control Area Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit
     * @generated
     */
    EClass getControlAreaGeneratingUnit();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit#getControlArea <em>Control Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Control Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit#getControlArea()
     * @see #getControlAreaGeneratingUnit()
     * @generated
     */
    EReference getControlAreaGeneratingUnit_ControlArea();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit#getGeneratingUnit <em>Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit#getGeneratingUnit()
     * @see #getControlAreaGeneratingUnit()
     * @generated
     */
    EReference getControlAreaGeneratingUnit_GeneratingUnit();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit#getAltGeneratingUnitMeas <em>Alt Generating Unit Meas</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Alt Generating Unit Meas</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaGeneratingUnit#getAltGeneratingUnitMeas()
     * @see #getControlAreaGeneratingUnit()
     * @generated
     */
    EReference getControlAreaGeneratingUnit_AltGeneratingUnitMeas();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint <em>Nonlinear Shunt Compensator Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Nonlinear Shunt Compensator Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint
     * @generated
     */
    EClass getNonlinearShuntCompensatorPoint();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getB <em>B</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getB()
     * @see #getNonlinearShuntCompensatorPoint()
     * @generated
     */
    EAttribute getNonlinearShuntCompensatorPoint_B();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getB0 <em>B0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getB0()
     * @see #getNonlinearShuntCompensatorPoint()
     * @generated
     */
    EAttribute getNonlinearShuntCompensatorPoint_B0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getG <em>G</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getG()
     * @see #getNonlinearShuntCompensatorPoint()
     * @generated
     */
    EAttribute getNonlinearShuntCompensatorPoint_G();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getG0 <em>G0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getG0()
     * @see #getNonlinearShuntCompensatorPoint()
     * @generated
     */
    EAttribute getNonlinearShuntCompensatorPoint_G0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getSectionNumber <em>Section Number</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Section Number</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getSectionNumber()
     * @see #getNonlinearShuntCompensatorPoint()
     * @generated
     */
    EAttribute getNonlinearShuntCompensatorPoint_SectionNumber();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getNonlinearShuntCompensator <em>Nonlinear Shunt Compensator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Nonlinear Shunt Compensator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPoint#getNonlinearShuntCompensator()
     * @see #getNonlinearShuntCompensatorPoint()
     * @generated
     */
    EReference getNonlinearShuntCompensatorPoint_NonlinearShuntCompensator();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Disconnector <em>Disconnector</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Disconnector</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Disconnector
     * @generated
     */
    EClass getDisconnector();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint <em>Tap Changer Table Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Tap Changer Table Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint
     * @generated
     */
    EClass getTapChangerTablePoint();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getB <em>B</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getB()
     * @see #getTapChangerTablePoint()
     * @generated
     */
    EAttribute getTapChangerTablePoint_B();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getG <em>G</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getG()
     * @see #getTapChangerTablePoint()
     * @generated
     */
    EAttribute getTapChangerTablePoint_G();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getR()
     * @see #getTapChangerTablePoint()
     * @generated
     */
    EAttribute getTapChangerTablePoint_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getRatio <em>Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getRatio()
     * @see #getTapChangerTablePoint()
     * @generated
     */
    EAttribute getTapChangerTablePoint_Ratio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getStep <em>Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getStep()
     * @see #getTapChangerTablePoint()
     * @generated
     */
    EAttribute getTapChangerTablePoint_Step();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerTablePoint#getX()
     * @see #getTapChangerTablePoint()
     * @generated
     */
    EAttribute getTapChangerTablePoint_X();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Ground <em>Ground</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Ground</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Ground
     * @generated
     */
    EClass getGround();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsWindUnit <em>Power Electronics Wind Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Power Electronics Wind Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsWindUnit
     * @generated
     */
    EClass getPowerElectronicsWindUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl <em>Remote Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Remote Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl
     * @generated
     */
    EClass getRemoteControl();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl#getActuatorMaximum <em>Actuator Maximum</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Actuator Maximum</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl#getActuatorMaximum()
     * @see #getRemoteControl()
     * @generated
     */
    EAttribute getRemoteControl_ActuatorMaximum();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl#getActuatorMinimum <em>Actuator Minimum</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Actuator Minimum</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl#getActuatorMinimum()
     * @see #getRemoteControl()
     * @generated
     */
    EAttribute getRemoteControl_ActuatorMinimum();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl#getRemoteControlled <em>Remote Controlled</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Remote Controlled</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl#getRemoteControlled()
     * @see #getRemoteControl()
     * @generated
     */
    EAttribute getRemoteControl_RemoteControlled();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl#getControl <em>Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteControl#getControl()
     * @see #getRemoteControl()
     * @generated
     */
    EReference getRemoteControl_Control();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTable <em>Phase Tap Changer Table</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Phase Tap Changer Table</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTable
     * @generated
     */
    EClass getPhaseTapChangerTable();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTable#getPhaseTapChangerTablePoint <em>Phase Tap Changer Table Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Phase Tap Changer Table Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTable#getPhaseTapChangerTablePoint()
     * @see #getPhaseTapChangerTable()
     * @generated
     */
    EReference getPhaseTapChangerTable_PhaseTapChangerTablePoint();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTable#getPhaseTapChangerTabular <em>Phase Tap Changer Tabular</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Phase Tap Changer Tabular</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTable#getPhaseTapChangerTabular()
     * @see #getPhaseTapChangerTable()
     * @generated
     */
    EReference getPhaseTapChangerTable_PhaseTapChangerTabular();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalIsland <em>Topological Island</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Topological Island</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalIsland
     * @generated
     */
    EClass getTopologicalIsland();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalIsland#getAngleRefTopologicalNode <em>Angle Ref Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Angle Ref Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalIsland#getAngleRefTopologicalNode()
     * @see #getTopologicalIsland()
     * @generated
     */
    EReference getTopologicalIsland_AngleRefTopologicalNode();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalIsland#getTopologicalNodes <em>Topological Nodes</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Topological Nodes</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalIsland#getTopologicalNodes()
     * @see #getTopologicalIsland()
     * @generated
     */
    EReference getTopologicalIsland_TopologicalNodes();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule <em>Fuel Allocation Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Fuel Allocation Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule
     * @generated
     */
    EClass getFuelAllocationSchedule();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getFuelAllocationEndDate <em>Fuel Allocation End Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Allocation End Date</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getFuelAllocationEndDate()
     * @see #getFuelAllocationSchedule()
     * @generated
     */
    EAttribute getFuelAllocationSchedule_FuelAllocationEndDate();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getFuelAllocationStartDate <em>Fuel Allocation Start Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Allocation Start Date</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getFuelAllocationStartDate()
     * @see #getFuelAllocationSchedule()
     * @generated
     */
    EAttribute getFuelAllocationSchedule_FuelAllocationStartDate();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getFuelType <em>Fuel Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getFuelType()
     * @see #getFuelAllocationSchedule()
     * @generated
     */
    EAttribute getFuelAllocationSchedule_FuelType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getMaxFuelAllocation <em>Max Fuel Allocation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Fuel Allocation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getMaxFuelAllocation()
     * @see #getFuelAllocationSchedule()
     * @generated
     */
    EAttribute getFuelAllocationSchedule_MaxFuelAllocation();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getMinFuelAllocation <em>Min Fuel Allocation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Fuel Allocation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getMinFuelAllocation()
     * @see #getFuelAllocationSchedule()
     * @generated
     */
    EAttribute getFuelAllocationSchedule_MinFuelAllocation();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getThermalGeneratingUnit()
     * @see #getFuelAllocationSchedule()
     * @generated
     */
    EReference getFuelAllocationSchedule_ThermalGeneratingUnit();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getFossilFuel <em>Fossil Fuel</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Fossil Fuel</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelAllocationSchedule#getFossilFuel()
     * @see #getFuelAllocationSchedule()
     * @generated
     */
    EReference getFuelAllocationSchedule_FossilFuel();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvTapStep <em>Sv Tap Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sv Tap Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvTapStep
     * @generated
     */
    EClass getSvTapStep();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvTapStep#getPosition <em>Position</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Position</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvTapStep#getPosition()
     * @see #getSvTapStep()
     * @generated
     */
    EAttribute getSvTapStep_Position();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvTapStep#getTapChanger <em>Tap Changer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Tap Changer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvTapStep#getTapChanger()
     * @see #getSvTapStep()
     * @generated
     */
    EReference getSvTapStep_TapChanger();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimit <em>Accumulator Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Accumulator Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimit
     * @generated
     */
    EClass getAccumulatorLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimit#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimit#getValue()
     * @see #getAccumulatorLimit()
     * @generated
     */
    EAttribute getAccumulatorLimit_Value();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimit#getLimitSet <em>Limit Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Limit Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorLimit#getLimitSet()
     * @see #getAccumulatorLimit()
     * @generated
     */
    EReference getAccumulatorLimit_LimitSet();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Clamp <em>Clamp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Clamp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Clamp
     * @generated
     */
    EClass getClamp();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Clamp#getLengthFromTerminal1 <em>Length From Terminal1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Length From Terminal1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Clamp#getLengthFromTerminal1()
     * @see #getClamp()
     * @generated
     */
    EAttribute getClamp_LengthFromTerminal1();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Clamp#getACLineSegment <em>AC Line Segment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>AC Line Segment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Clamp#getACLineSegment()
     * @see #getClamp()
     * @generated
     */
    EReference getClamp_ACLineSegment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorReset <em>Accumulator Reset</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Accumulator Reset</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorReset
     * @generated
     */
    EClass getAccumulatorReset();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorReset#getAccumulatorValue <em>Accumulator Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Accumulator Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorReset#getAccumulatorValue()
     * @see #getAccumulatorReset()
     * @generated
     */
    EReference getAccumulatorReset_AccumulatorValue();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit <em>Power Electronics Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Power Electronics Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit
     * @generated
     */
    EClass getPowerElectronicsUnit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit#getMaxP <em>Max P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit#getMaxP()
     * @see #getPowerElectronicsUnit()
     * @generated
     */
    EAttribute getPowerElectronicsUnit_MaxP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit#getMinP <em>Min P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit#getMinP()
     * @see #getPowerElectronicsUnit()
     * @generated
     */
    EAttribute getPowerElectronicsUnit_MinP();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit#getPowerElectronicsConnection <em>Power Electronics Connection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Power Electronics Connection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsUnit#getPowerElectronicsConnection()
     * @see #getPowerElectronicsUnit()
     * @generated
     */
    EReference getPowerElectronicsUnit_PowerElectronicsConnection();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PrimeMover <em>Prime Mover</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Prime Mover</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PrimeMover
     * @generated
     */
    EClass getPrimeMover();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PrimeMover#getPrimeMoverRating <em>Prime Mover Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Prime Mover Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PrimeMover#getPrimeMoverRating()
     * @see #getPrimeMover()
     * @generated
     */
    EAttribute getPrimeMover_PrimeMoverRating();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PrimeMover#getSynchronousMachines <em>Synchronous Machines</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Synchronous Machines</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PrimeMover#getSynchronousMachines()
     * @see #getPrimeMover()
     * @generated
     */
    EReference getPrimeMover_SynchronousMachines();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine <em>Asynchronous Machine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Asynchronous Machine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine
     * @generated
     */
    EClass getAsynchronousMachine();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getAsynchronousMachineType <em>Asynchronous Machine Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Asynchronous Machine Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getAsynchronousMachineType()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_AsynchronousMachineType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getConverterFedDrive <em>Converter Fed Drive</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Converter Fed Drive</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getConverterFedDrive()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_ConverterFedDrive();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getEfficiency <em>Efficiency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Efficiency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getEfficiency()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Efficiency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getIaIrRatio <em>Ia Ir Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ia Ir Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getIaIrRatio()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_IaIrRatio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getNominalFrequency <em>Nominal Frequency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Nominal Frequency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getNominalFrequency()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_NominalFrequency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getNominalSpeed <em>Nominal Speed</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Nominal Speed</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getNominalSpeed()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_NominalSpeed();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getPolePairNumber <em>Pole Pair Number</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pole Pair Number</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getPolePairNumber()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_PolePairNumber();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getRatedMechanicalPower <em>Rated Mechanical Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Mechanical Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getRatedMechanicalPower()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_RatedMechanicalPower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getReversible <em>Reversible</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reversible</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getReversible()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Reversible();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getRr1 <em>Rr1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rr1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getRr1()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Rr1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getRr2 <em>Rr2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rr2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getRr2()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Rr2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getRxLockedRotorRatio <em>Rx Locked Rotor Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rx Locked Rotor Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getRxLockedRotorRatio()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_RxLockedRotorRatio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getTpo <em>Tpo</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Tpo</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getTpo()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Tpo();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getTppo <em>Tppo</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Tppo</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getTppo()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Tppo();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXlr1 <em>Xlr1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xlr1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXlr1()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Xlr1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXlr2 <em>Xlr2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xlr2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXlr2()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Xlr2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXm <em>Xm</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xm</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXm()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Xm();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXp <em>Xp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXp()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Xp();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXpp <em>Xpp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xpp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXpp()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Xpp();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXs <em>Xs</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xs</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachine#getXs()
     * @see #getAsynchronousMachine()
     * @generated
     */
    EAttribute getAsynchronousMachine_Xs();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRateCurve <em>Heat Rate Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Heat Rate Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRateCurve
     * @generated
     */
    EClass getHeatRateCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRateCurve#getIsNetGrossP <em>Is Net Gross P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Net Gross P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRateCurve#getIsNetGrossP()
     * @see #getHeatRateCurve()
     * @generated
     */
    EAttribute getHeatRateCurve_IsNetGrossP();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRateCurve#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRateCurve#getThermalGeneratingUnit()
     * @see #getHeatRateCurve()
     * @generated
     */
    EReference getHeatRateCurve_ThermalGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.InflowForecast <em>Inflow Forecast</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Inflow Forecast</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.InflowForecast
     * @generated
     */
    EClass getInflowForecast();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.InflowForecast#getReservoir <em>Reservoir</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Reservoir</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.InflowForecast#getReservoir()
     * @see #getInflowForecast()
     * @generated
     */
    EReference getInflowForecast_Reservoir();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData <em>Curve Data</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Curve Data</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData
     * @generated
     */
    EClass getCurveData();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getXvalue <em>Xvalue</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xvalue</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getXvalue()
     * @see #getCurveData()
     * @generated
     */
    EAttribute getCurveData_Xvalue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getY1value <em>Y1value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y1value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getY1value()
     * @see #getCurveData()
     * @generated
     */
    EAttribute getCurveData_Y1value();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getY2value <em>Y2value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y2value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getY2value()
     * @see #getCurveData()
     * @generated
     */
    EAttribute getCurveData_Y2value();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getY3value <em>Y3value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y3value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getY3value()
     * @see #getCurveData()
     * @generated
     */
    EAttribute getCurveData_Y3value();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getCurve <em>Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveData#getCurve()
     * @see #getCurveData()
     * @generated
     */
    EReference getCurveData_Curve();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLine <em>DC Line</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Line</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLine
     * @generated
     */
    EClass getDCLine();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLine#getRegion <em>Region</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Region</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLine#getRegion()
     * @see #getDCLine()
     * @generated
     */
    EReference getDCLine_Region();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DayType <em>Day Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Day Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DayType
     * @generated
     */
    EClass getDayType();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DayType#getSeasonDayTypeSchedules <em>Season Day Type Schedules</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Season Day Type Schedules</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DayType#getSeasonDayTypeSchedules()
     * @see #getDayType()
     * @generated
     */
    EReference getDayType_SeasonDayTypeSchedules();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthPhaseImpedance <em>Per Length Phase Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Per Length Phase Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthPhaseImpedance
     * @generated
     */
    EClass getPerLengthPhaseImpedance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthPhaseImpedance#getConductorCount <em>Conductor Count</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Conductor Count</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthPhaseImpedance#getConductorCount()
     * @see #getPerLengthPhaseImpedance()
     * @generated
     */
    EAttribute getPerLengthPhaseImpedance_ConductorCount();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthPhaseImpedance#getPhaseImpedanceData <em>Phase Impedance Data</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Phase Impedance Data</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthPhaseImpedance#getPhaseImpedanceData()
     * @see #getPerLengthPhaseImpedance()
     * @generated
     */
    EReference getPerLengthPhaseImpedance_PhaseImpedanceData();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal <em>ACDC Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>ACDC Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal
     * @generated
     */
    EClass getACDCTerminal();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getConnected <em>Connected</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Connected</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getConnected()
     * @see #getACDCTerminal()
     * @generated
     */
    EAttribute getACDCTerminal_Connected();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getSequenceNumber <em>Sequence Number</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sequence Number</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getSequenceNumber()
     * @see #getACDCTerminal()
     * @generated
     */
    EAttribute getACDCTerminal_SequenceNumber();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getBusNameMarker <em>Bus Name Marker</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Bus Name Marker</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getBusNameMarker()
     * @see #getACDCTerminal()
     * @generated
     */
    EReference getACDCTerminal_BusNameMarker();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getMeasurements <em>Measurements</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Measurements</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getMeasurements()
     * @see #getACDCTerminal()
     * @generated
     */
    EReference getACDCTerminal_Measurements();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getOperationalLimitSet <em>Operational Limit Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Operational Limit Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCTerminal#getOperationalLimitSet()
     * @see #getACDCTerminal()
     * @generated
     */
    EReference getACDCTerminal_OperationalLimitSet();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint <em>Diagram Object Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Diagram Object Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint
     * @generated
     */
    EClass getDiagramObjectPoint();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getSequenceNumber <em>Sequence Number</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sequence Number</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getSequenceNumber()
     * @see #getDiagramObjectPoint()
     * @generated
     */
    EAttribute getDiagramObjectPoint_SequenceNumber();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getXPosition <em>XPosition</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XPosition</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getXPosition()
     * @see #getDiagramObjectPoint()
     * @generated
     */
    EAttribute getDiagramObjectPoint_XPosition();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getYPosition <em>YPosition</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>YPosition</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getYPosition()
     * @see #getDiagramObjectPoint()
     * @generated
     */
    EAttribute getDiagramObjectPoint_YPosition();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getZPosition <em>ZPosition</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>ZPosition</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getZPosition()
     * @see #getDiagramObjectPoint()
     * @generated
     */
    EAttribute getDiagramObjectPoint_ZPosition();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getDiagramObject <em>Diagram Object</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Diagram Object</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getDiagramObject()
     * @see #getDiagramObjectPoint()
     * @generated
     */
    EReference getDiagramObjectPoint_DiagramObject();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getDiagramObjectGluePoint <em>Diagram Object Glue Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Diagram Object Glue Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectPoint#getDiagramObjectGluePoint()
     * @see #getDiagramObjectPoint()
     * @generated
     */
    EReference getDiagramObjectPoint_DiagramObjectGluePoint();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator <em>Accumulator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Accumulator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator
     * @generated
     */
    EClass getAccumulator();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator#getMaxValue <em>Max Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator#getMaxValue()
     * @see #getAccumulator()
     * @generated
     */
    EAttribute getAccumulator_MaxValue();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator#getAccumulatorValues <em>Accumulator Values</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Accumulator Values</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator#getAccumulatorValues()
     * @see #getAccumulator()
     * @generated
     */
    EReference getAccumulator_AccumulatorValues();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator#getLimitSets <em>Limit Sets</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Limit Sets</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Accumulator#getLimitSets()
     * @see #getAccumulator()
     * @generated
     */
    EReference getAccumulator_LimitSets();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CommunicationLink <em>Communication Link</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Communication Link</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CommunicationLink
     * @generated
     */
    EClass getCommunicationLink();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CommunicationLink#getRemoteUnits <em>Remote Units</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Remote Units</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CommunicationLink#getRemoteUnits()
     * @see #getCommunicationLink()
     * @generated
     */
    EReference getCommunicationLink_RemoteUnits();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentShunt <em>Equivalent Shunt</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Equivalent Shunt</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentShunt
     * @generated
     */
    EClass getEquivalentShunt();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentShunt#getB <em>B</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentShunt#getB()
     * @see #getEquivalentShunt()
     * @generated
     */
    EAttribute getEquivalentShunt_B();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentShunt#getG <em>G</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentShunt#getG()
     * @see #getEquivalentShunt()
     * @generated
     */
    EAttribute getEquivalentShunt_G();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTable <em>Ratio Tap Changer Table</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Ratio Tap Changer Table</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTable
     * @generated
     */
    EClass getRatioTapChangerTable();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTable#getRatioTapChanger <em>Ratio Tap Changer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Ratio Tap Changer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTable#getRatioTapChanger()
     * @see #getRatioTapChangerTable()
     * @generated
     */
    EReference getRatioTapChangerTable_RatioTapChanger();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTable#getRatioTapChangerTablePoint <em>Ratio Tap Changer Table Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Ratio Tap Changer Table Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChangerTable#getRatioTapChangerTablePoint()
     * @see #getRatioTapChangerTable()
     * @generated
     */
    EReference getRatioTapChangerTable_RatioTapChangerTablePoint();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply <em>Fossil Steam Supply</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Fossil Steam Supply</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply
     * @generated
     */
    EClass getFossilSteamSupply();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusFrequency <em>Aux Power Versus Frequency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Aux Power Versus Frequency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusFrequency()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_AuxPowerVersusFrequency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusVoltage <em>Aux Power Versus Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Aux Power Versus Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getAuxPowerVersusVoltage()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_AuxPowerVersusVoltage();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getBoilerControlMode <em>Boiler Control Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Boiler Control Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getBoilerControlMode()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_BoilerControlMode();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlErrorBiasP <em>Control Error Bias P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control Error Bias P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlErrorBiasP()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_ControlErrorBiasP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlIC <em>Control IC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control IC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlIC()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_ControlIC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPC <em>Control PC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control PC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPC()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_ControlPC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPEB <em>Control PEB</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control PEB</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPEB()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_ControlPEB();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPED <em>Control PED</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control PED</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlPED()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_ControlPED();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlTC <em>Control TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getControlTC()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_ControlTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterIG <em>Feed Water IG</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Feed Water IG</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterIG()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_FeedWaterIG();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterPG <em>Feed Water PG</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Feed Water PG</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterPG()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_FeedWaterPG();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterTC <em>Feed Water TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Feed Water TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFeedWaterTC()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_FeedWaterTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelDemandLimit <em>Fuel Demand Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Demand Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelDemandLimit()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_FuelDemandLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyDelay <em>Fuel Supply Delay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Supply Delay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyDelay()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_FuelSupplyDelay();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyTC <em>Fuel Supply TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Supply TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getFuelSupplyTC()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_FuelSupplyTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMaxErrorRateP <em>Max Error Rate P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Error Rate P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMaxErrorRateP()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_MaxErrorRateP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMechPowerSensorLag <em>Mech Power Sensor Lag</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Mech Power Sensor Lag</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMechPowerSensorLag()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_MechPowerSensorLag();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMinErrorRateP <em>Min Error Rate P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Error Rate P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getMinErrorRateP()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_MinErrorRateP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlDG <em>Pressure Ctrl DG</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pressure Ctrl DG</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlDG()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_PressureCtrlDG();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlIG <em>Pressure Ctrl IG</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pressure Ctrl IG</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlIG()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_PressureCtrlIG();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlPG <em>Pressure Ctrl PG</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pressure Ctrl PG</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureCtrlPG()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_PressureCtrlPG();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureFeedback <em>Pressure Feedback</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pressure Feedback</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getPressureFeedback()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_PressureFeedback();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater1Capacity <em>Super Heater1 Capacity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Super Heater1 Capacity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater1Capacity()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_SuperHeater1Capacity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater2Capacity <em>Super Heater2 Capacity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Super Heater2 Capacity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeater2Capacity()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_SuperHeater2Capacity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeaterPipePD <em>Super Heater Pipe PD</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Super Heater Pipe PD</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getSuperHeaterPipePD()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_SuperHeaterPipePD();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getThrottlePressureSP <em>Throttle Pressure SP</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Throttle Pressure SP</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilSteamSupply#getThrottlePressureSP()
     * @see #getFossilSteamSupply()
     * @generated
     */
    EAttribute getFossilSteamSupply_ThrottlePressureSP();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule <em>Target Level Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Target Level Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule
     * @generated
     */
    EClass getTargetLevelSchedule();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule#getHighLevelLimit <em>High Level Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>High Level Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule#getHighLevelLimit()
     * @see #getTargetLevelSchedule()
     * @generated
     */
    EAttribute getTargetLevelSchedule_HighLevelLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule#getLowLevelLimit <em>Low Level Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Low Level Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule#getLowLevelLimit()
     * @see #getTargetLevelSchedule()
     * @generated
     */
    EAttribute getTargetLevelSchedule_LowLevelLimit();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule#getReservoir <em>Reservoir</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Reservoir</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TargetLevelSchedule#getReservoir()
     * @see #getTargetLevelSchedule()
     * @generated
     */
    EReference getTargetLevelSchedule_Reservoir();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VisibilityLayer <em>Visibility Layer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Visibility Layer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VisibilityLayer
     * @generated
     */
    EClass getVisibilityLayer();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VisibilityLayer#getDrawingOrder <em>Drawing Order</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Drawing Order</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VisibilityLayer#getDrawingOrder()
     * @see #getVisibilityLayer()
     * @generated
     */
    EAttribute getVisibilityLayer_DrawingOrder();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VisibilityLayer#getVisibleObjects <em>Visible Objects</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Visible Objects</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VisibilityLayer#getVisibleObjects()
     * @see #getVisibilityLayer()
     * @generated
     */
    EReference getVisibilityLayer_VisibleObjects();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueQuality <em>Measurement Value Quality</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Measurement Value Quality</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueQuality
     * @generated
     */
    EClass getMeasurementValueQuality();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueQuality#getMeasurementValue <em>Measurement Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Measurement Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueQuality#getMeasurementValue()
     * @see #getMeasurementValueQuality()
     * @generated
     */
    EReference getMeasurementValueQuality_MeasurementValue();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpCostCurve <em>Gen Unit Op Cost Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Gen Unit Op Cost Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpCostCurve
     * @generated
     */
    EClass getGenUnitOpCostCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpCostCurve#getIsNetGrossP <em>Is Net Gross P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Net Gross P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpCostCurve#getIsNetGrossP()
     * @see #getGenUnitOpCostCurve()
     * @generated
     */
    EAttribute getGenUnitOpCostCurve_IsNetGrossP();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpCostCurve#getGeneratingUnit <em>Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpCostCurve#getGeneratingUnit()
     * @see #getGenUnitOpCostCurve()
     * @generated
     */
    EReference getGenUnitOpCostCurve_GeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic <em>Load Response Characteristic</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Load Response Characteristic</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic
     * @generated
     */
    EClass getLoadResponseCharacteristic();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getExponentModel <em>Exponent Model</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Exponent Model</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getExponentModel()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_ExponentModel();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPConstantCurrent <em>PConstant Current</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PConstant Current</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPConstantCurrent()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_PConstantCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPConstantImpedance <em>PConstant Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PConstant Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPConstantImpedance()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_PConstantImpedance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPConstantPower <em>PConstant Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PConstant Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPConstantPower()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_PConstantPower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPFrequencyExponent <em>PFrequency Exponent</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PFrequency Exponent</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPFrequencyExponent()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_PFrequencyExponent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPVoltageExponent <em>PVoltage Exponent</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PVoltage Exponent</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getPVoltageExponent()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_PVoltageExponent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQConstantCurrent <em>QConstant Current</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QConstant Current</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQConstantCurrent()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_QConstantCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQConstantImpedance <em>QConstant Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QConstant Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQConstantImpedance()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_QConstantImpedance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQConstantPower <em>QConstant Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QConstant Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQConstantPower()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_QConstantPower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQFrequencyExponent <em>QFrequency Exponent</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QFrequency Exponent</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQFrequencyExponent()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_QFrequencyExponent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQVoltageExponent <em>QVoltage Exponent</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QVoltage Exponent</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getQVoltageExponent()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EAttribute getLoadResponseCharacteristic_QVoltageExponent();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getEnergyConsumer <em>Energy Consumer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Energy Consumer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadResponseCharacteristic#getEnergyConsumer()
     * @see #getLoadResponseCharacteristic()
     * @generated
     */
    EReference getLoadResponseCharacteristic_EnergyConsumer();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator <em>Static Var Compensator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Static Var Compensator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator
     * @generated
     */
    EClass getStaticVarCompensator();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getCapacitiveRating <em>Capacitive Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Capacitive Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getCapacitiveRating()
     * @see #getStaticVarCompensator()
     * @generated
     */
    EAttribute getStaticVarCompensator_CapacitiveRating();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getInductiveRating <em>Inductive Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Inductive Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getInductiveRating()
     * @see #getStaticVarCompensator()
     * @generated
     */
    EAttribute getStaticVarCompensator_InductiveRating();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getQ <em>Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getQ()
     * @see #getStaticVarCompensator()
     * @generated
     */
    EAttribute getStaticVarCompensator_Q();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getSlope <em>Slope</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Slope</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getSlope()
     * @see #getStaticVarCompensator()
     * @generated
     */
    EAttribute getStaticVarCompensator_Slope();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getSVCControlMode <em>SVC Control Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>SVC Control Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getSVCControlMode()
     * @see #getStaticVarCompensator()
     * @generated
     */
    EAttribute getStaticVarCompensator_SVCControlMode();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getVoltageSetPoint <em>Voltage Set Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Voltage Set Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StaticVarCompensator#getVoltageSetPoint()
     * @see #getStaticVarCompensator()
     * @generated
     */
    EAttribute getStaticVarCompensator_VoltageSetPoint();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment <em>Protection Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Protection Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment
     * @generated
     */
    EClass getProtectionEquipment();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getHighLimit <em>High Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>High Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getHighLimit()
     * @see #getProtectionEquipment()
     * @generated
     */
    EAttribute getProtectionEquipment_HighLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getLowLimit <em>Low Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Low Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getLowLimit()
     * @see #getProtectionEquipment()
     * @generated
     */
    EAttribute getProtectionEquipment_LowLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getPowerDirectionFlag <em>Power Direction Flag</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Power Direction Flag</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getPowerDirectionFlag()
     * @see #getProtectionEquipment()
     * @generated
     */
    EAttribute getProtectionEquipment_PowerDirectionFlag();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getRelayDelayTime <em>Relay Delay Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Relay Delay Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getRelayDelayTime()
     * @see #getProtectionEquipment()
     * @generated
     */
    EAttribute getProtectionEquipment_RelayDelayTime();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getUnitMultiplier <em>Unit Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getUnitMultiplier()
     * @see #getProtectionEquipment()
     * @generated
     */
    EAttribute getProtectionEquipment_UnitMultiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getUnitSymbol <em>Unit Symbol</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit Symbol</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getUnitSymbol()
     * @see #getProtectionEquipment()
     * @generated
     */
    EAttribute getProtectionEquipment_UnitSymbol();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getProtectedSwitches <em>Protected Switches</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Protected Switches</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getProtectedSwitches()
     * @see #getProtectionEquipment()
     * @generated
     */
    EReference getProtectionEquipment_ProtectedSwitches();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getConductingEquipments <em>Conducting Equipments</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Conducting Equipments</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ProtectionEquipment#getConductingEquipments()
     * @see #getProtectionEquipment()
     * @generated
     */
    EReference getProtectionEquipment_ConductingEquipments();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LimitSet <em>Limit Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Limit Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LimitSet
     * @generated
     */
    EClass getLimitSet();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LimitSet#getIsPercentageLimits <em>Is Percentage Limits</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Percentage Limits</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LimitSet#getIsPercentageLimits()
     * @see #getLimitSet()
     * @generated
     */
    EAttribute getLimitSet_IsPercentageLimits();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer <em>Potential Transformer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Potential Transformer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer
     * @generated
     */
    EClass getPotentialTransformer();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer#getAccuracyClass <em>Accuracy Class</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Accuracy Class</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer#getAccuracyClass()
     * @see #getPotentialTransformer()
     * @generated
     */
    EAttribute getPotentialTransformer_AccuracyClass();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer#getNominalRatio <em>Nominal Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Nominal Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer#getNominalRatio()
     * @see #getPotentialTransformer()
     * @generated
     */
    EAttribute getPotentialTransformer_NominalRatio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer#getPtClass <em>Pt Class</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pt Class</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer#getPtClass()
     * @see #getPotentialTransformer()
     * @generated
     */
    EAttribute getPotentialTransformer_PtClass();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer#getType <em>Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformer#getType()
     * @see #getPotentialTransformer()
     * @generated
     */
    EAttribute getPotentialTransformer_Type();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadSchedule <em>Non Conform Load Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Non Conform Load Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadSchedule
     * @generated
     */
    EClass getNonConformLoadSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadSchedule#getNonConformLoadGroup <em>Non Conform Load Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Non Conform Load Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadSchedule#getNonConformLoadGroup()
     * @see #getNonConformLoadSchedule()
     * @generated
     */
    EReference getNonConformLoadSchedule_NonConformLoadGroup();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve <em>Reactive Capability Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Reactive Capability Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve
     * @generated
     */
    EClass getReactiveCapabilityCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getCoolantTemperature <em>Coolant Temperature</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Coolant Temperature</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getCoolantTemperature()
     * @see #getReactiveCapabilityCurve()
     * @generated
     */
    EAttribute getReactiveCapabilityCurve_CoolantTemperature();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getHydrogenPressure <em>Hydrogen Pressure</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Hydrogen Pressure</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getHydrogenPressure()
     * @see #getReactiveCapabilityCurve()
     * @generated
     */
    EAttribute getReactiveCapabilityCurve_HydrogenPressure();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getEquivalentInjection <em>Equivalent Injection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Equivalent Injection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getEquivalentInjection()
     * @see #getReactiveCapabilityCurve()
     * @generated
     */
    EReference getReactiveCapabilityCurve_EquivalentInjection();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getInitiallyUsedBySynchronousMachines <em>Initially Used By Synchronous Machines</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Initially Used By Synchronous Machines</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getInitiallyUsedBySynchronousMachines()
     * @see #getReactiveCapabilityCurve()
     * @generated
     */
    EReference getReactiveCapabilityCurve_InitiallyUsedBySynchronousMachines();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getSynchronousMachines <em>Synchronous Machines</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Synchronous Machines</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReactiveCapabilityCurve#getSynchronousMachines()
     * @see #getReactiveCapabilityCurve()
     * @generated
     */
    EReference getReactiveCapabilityCurve_SynchronousMachines();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhase <em>Nonlinear Shunt Compensator Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Nonlinear Shunt Compensator Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhase
     * @generated
     */
    EClass getNonlinearShuntCompensatorPhase();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhase#getNonlinearShuntCompensatorPhasePoints <em>Nonlinear Shunt Compensator Phase Points</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Nonlinear Shunt Compensator Phase Points</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhase#getNonlinearShuntCompensatorPhasePoints()
     * @see #getNonlinearShuntCompensatorPhase()
     * @generated
     */
    EReference getNonlinearShuntCompensatorPhase_NonlinearShuntCompensatorPhasePoints();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram <em>Diagram</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Diagram</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram
     * @generated
     */
    EClass getDiagram();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getOrientation <em>Orientation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Orientation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getOrientation()
     * @see #getDiagram()
     * @generated
     */
    EAttribute getDiagram_Orientation();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getX1InitialView <em>X1 Initial View</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X1 Initial View</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getX1InitialView()
     * @see #getDiagram()
     * @generated
     */
    EAttribute getDiagram_X1InitialView();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getX2InitialView <em>X2 Initial View</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X2 Initial View</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getX2InitialView()
     * @see #getDiagram()
     * @generated
     */
    EAttribute getDiagram_X2InitialView();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getY1InitialView <em>Y1 Initial View</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y1 Initial View</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getY1InitialView()
     * @see #getDiagram()
     * @generated
     */
    EAttribute getDiagram_Y1InitialView();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getY2InitialView <em>Y2 Initial View</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y2 Initial View</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getY2InitialView()
     * @see #getDiagram()
     * @generated
     */
    EAttribute getDiagram_Y2InitialView();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getDiagramElements <em>Diagram Elements</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Diagram Elements</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getDiagramElements()
     * @see #getDiagram()
     * @generated
     */
    EReference getDiagram_DiagramElements();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getDiagramStyle <em>Diagram Style</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Diagram Style</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Diagram#getDiagramStyle()
     * @see #getDiagram()
     * @generated
     */
    EReference getDiagram_DiagramStyle();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerSymmetrical <em>Phase Tap Changer Symmetrical</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Phase Tap Changer Symmetrical</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerSymmetrical
     * @generated
     */
    EClass getPhaseTapChangerSymmetrical();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CompositeSwitch <em>Composite Switch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Composite Switch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CompositeSwitch
     * @generated
     */
    EClass getCompositeSwitch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CompositeSwitch#getCompositeSwitchType <em>Composite Switch Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Composite Switch Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CompositeSwitch#getCompositeSwitchType()
     * @see #getCompositeSwitch()
     * @generated
     */
    EAttribute getCompositeSwitch_CompositeSwitchType();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CompositeSwitch#getSwitches <em>Switches</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Switches</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CompositeSwitch#getSwitches()
     * @see #getCompositeSwitch()
     * @generated
     */
    EReference getCompositeSwitch_Switches();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay <em>Bay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Bay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay
     * @generated
     */
    EClass getBay();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getBayEnergyMeasFlag <em>Bay Energy Meas Flag</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Bay Energy Meas Flag</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getBayEnergyMeasFlag()
     * @see #getBay()
     * @generated
     */
    EAttribute getBay_BayEnergyMeasFlag();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getBayPowerMeasFlag <em>Bay Power Meas Flag</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Bay Power Meas Flag</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getBayPowerMeasFlag()
     * @see #getBay()
     * @generated
     */
    EAttribute getBay_BayPowerMeasFlag();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getBreakerConfiguration <em>Breaker Configuration</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Breaker Configuration</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getBreakerConfiguration()
     * @see #getBay()
     * @generated
     */
    EAttribute getBay_BreakerConfiguration();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getBusBarConfiguration <em>Bus Bar Configuration</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Bus Bar Configuration</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getBusBarConfiguration()
     * @see #getBay()
     * @generated
     */
    EAttribute getBay_BusBarConfiguration();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getVoltageLevel <em>Voltage Level</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Voltage Level</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getVoltageLevel()
     * @see #getBay()
     * @generated
     */
    EReference getBay_VoltageLevel();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getSubstation <em>Substation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Substation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Bay#getSubstation()
     * @see #getBay()
     * @generated
     */
    EReference getBay_Substation();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ApparentPowerLimit <em>Apparent Power Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Apparent Power Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ApparentPowerLimit
     * @generated
     */
    EClass getApparentPowerLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ApparentPowerLimit#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ApparentPowerLimit#getValue()
     * @see #getApparentPowerLimit()
     * @generated
     */
    EAttribute getApparentPowerLimit_Value();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultIndicator <em>Fault Indicator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Fault Indicator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultIndicator
     * @generated
     */
    EClass getFaultIndicator();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas <em>Alt Generating Unit Meas</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Alt Generating Unit Meas</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas
     * @generated
     */
    EClass getAltGeneratingUnitMeas();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas#getPriority <em>Priority</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Priority</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas#getPriority()
     * @see #getAltGeneratingUnitMeas()
     * @generated
     */
    EAttribute getAltGeneratingUnitMeas_Priority();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas#getControlAreaGeneratingUnit <em>Control Area Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Control Area Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas#getControlAreaGeneratingUnit()
     * @see #getAltGeneratingUnitMeas()
     * @generated
     */
    EReference getAltGeneratingUnitMeas_ControlAreaGeneratingUnit();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas#getAnalogValue <em>Analog Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Analog Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltGeneratingUnitMeas#getAnalogValue()
     * @see #getAltGeneratingUnitMeas()
     * @generated
     */
    EReference getAltGeneratingUnitMeas_AnalogValue();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit <em>Remote Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Remote Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit
     * @generated
     */
    EClass getRemoteUnit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit#getRemoteUnitType <em>Remote Unit Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Remote Unit Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit#getRemoteUnitType()
     * @see #getRemoteUnit()
     * @generated
     */
    EAttribute getRemoteUnit_RemoteUnitType();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit#getRemotePoints <em>Remote Points</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Remote Points</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit#getRemotePoints()
     * @see #getRemoteUnit()
     * @generated
     */
    EReference getRemoteUnit_RemotePoints();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit#getCommunicationLinks <em>Communication Links</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Communication Links</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnit#getCommunicationLinks()
     * @see #getRemoteUnit()
     * @generated
     */
    EReference getRemoteUnit_CommunicationLinks();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadGroup <em>Non Conform Load Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Non Conform Load Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadGroup
     * @generated
     */
    EClass getNonConformLoadGroup();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadGroup#getNonConformLoadSchedules <em>Non Conform Load Schedules</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Non Conform Load Schedules</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadGroup#getNonConformLoadSchedules()
     * @see #getNonConformLoadGroup()
     * @generated
     */
    EReference getNonConformLoadGroup_NonConformLoadSchedules();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadGroup#getEnergyConsumers <em>Energy Consumers</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Energy Consumers</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonConformLoadGroup#getEnergyConsumers()
     * @see #getNonConformLoadGroup()
     * @generated
     */
    EReference getNonConformLoadGroup_EnergyConsumers();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLimit <em>Voltage Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Voltage Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLimit
     * @generated
     */
    EClass getVoltageLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLimit#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VoltageLimit#getValue()
     * @see #getVoltageLimit()
     * @generated
     */
    EAttribute getVoltageLimit_Value();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadGroup <em>Conform Load Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Conform Load Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadGroup
     * @generated
     */
    EClass getConformLoadGroup();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadGroup#getConformLoadSchedules <em>Conform Load Schedules</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Conform Load Schedules</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadGroup#getConformLoadSchedules()
     * @see #getConformLoadGroup()
     * @generated
     */
    EReference getConformLoadGroup_ConformLoadSchedules();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadGroup#getEnergyConsumers <em>Energy Consumers</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Energy Consumers</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadGroup#getEnergyConsumers()
     * @see #getConformLoadGroup()
     * @generated
     */
    EReference getConformLoadGroup_EnergyConsumers();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment <em>DC Line Segment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Line Segment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment
     * @generated
     */
    EClass getDCLineSegment();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getCapacitance <em>Capacitance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Capacitance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getCapacitance()
     * @see #getDCLineSegment()
     * @generated
     */
    EAttribute getDCLineSegment_Capacitance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getInductance <em>Inductance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Inductance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getInductance()
     * @see #getDCLineSegment()
     * @generated
     */
    EAttribute getDCLineSegment_Inductance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getLength <em>Length</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Length</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getLength()
     * @see #getDCLineSegment()
     * @generated
     */
    EAttribute getDCLineSegment_Length();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getResistance <em>Resistance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Resistance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getResistance()
     * @see #getDCLineSegment()
     * @generated
     */
    EAttribute getDCLineSegment_Resistance();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getPerLengthParameter <em>Per Length Parameter</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Per Length Parameter</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCLineSegment#getPerLengthParameter()
     * @see #getDCLineSegment()
     * @generated
     */
    EReference getDCLineSegment_PerLengthParameter();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurement <em>String Measurement</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>String Measurement</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurement
     * @generated
     */
    EClass getStringMeasurement();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurement#getStringMeasurementValues <em>String Measurement Values</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>String Measurement Values</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurement#getStringMeasurementValues()
     * @see #getStringMeasurement()
     * @generated
     */
    EReference getStringMeasurement_StringMeasurementValues();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartIgnFuelCurve <em>Start Ign Fuel Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Start Ign Fuel Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartIgnFuelCurve
     * @generated
     */
    EClass getStartIgnFuelCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartIgnFuelCurve#getIgnitionFuelType <em>Ignition Fuel Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ignition Fuel Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartIgnFuelCurve#getIgnitionFuelType()
     * @see #getStartIgnFuelCurve()
     * @generated
     */
    EAttribute getStartIgnFuelCurve_IgnitionFuelType();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartIgnFuelCurve#getStartupModel <em>Startup Model</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Startup Model</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartIgnFuelCurve#getStartupModel()
     * @see #getStartIgnFuelCurve()
     * @generated
     */
    EReference getStartIgnFuelCurve_StartupModel();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Limit <em>Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Limit
     * @generated
     */
    EClass getLimit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingEfficiencyCurve <em>Hydro Generating Efficiency Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Hydro Generating Efficiency Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingEfficiencyCurve
     * @generated
     */
    EClass getHydroGeneratingEfficiencyCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingEfficiencyCurve#getHydroGeneratingUnit <em>Hydro Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Hydro Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingEfficiencyCurve#getHydroGeneratingUnit()
     * @see #getHydroGeneratingEfficiencyCurve()
     * @generated
     */
    EReference getHydroGeneratingEfficiencyCurve_HydroGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IncrementalHeatRateCurve <em>Incremental Heat Rate Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Incremental Heat Rate Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IncrementalHeatRateCurve
     * @generated
     */
    EClass getIncrementalHeatRateCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IncrementalHeatRateCurve#getIsNetGrossP <em>Is Net Gross P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Net Gross P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IncrementalHeatRateCurve#getIsNetGrossP()
     * @see #getIncrementalHeatRateCurve()
     * @generated
     */
    EAttribute getIncrementalHeatRateCurve_IsNetGrossP();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IncrementalHeatRateCurve#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IncrementalHeatRateCurve#getThermalGeneratingUnit()
     * @see #getIncrementalHeatRateCurve()
     * @generated
     */
    EReference getIncrementalHeatRateCurve_ThermalGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PenstockLossCurve <em>Penstock Loss Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Penstock Loss Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PenstockLossCurve
     * @generated
     */
    EClass getPenstockLossCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PenstockLossCurve#getHydroGeneratingUnit <em>Hydro Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Hydro Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PenstockLossCurve#getHydroGeneratingUnit()
     * @see #getPenstockLossCurve()
     * @generated
     */
    EReference getPenstockLossCurve_HydroGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSwitch <em>DC Switch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Switch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSwitch
     * @generated
     */
    EClass getDCSwitch();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularIntervalSchedule <em>Irregular Interval Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Irregular Interval Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularIntervalSchedule
     * @generated
     */
    EClass getIrregularIntervalSchedule();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularIntervalSchedule#getTimePoints <em>Time Points</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Time Points</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularIntervalSchedule#getTimePoints()
     * @see #getIrregularIntervalSchedule()
     * @generated
     */
    EReference getIrregularIntervalSchedule_TimePoints();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant <em>CAES Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>CAES Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant
     * @generated
     */
    EClass getCAESPlant();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getEnergyStorageCapacity <em>Energy Storage Capacity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Energy Storage Capacity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getEnergyStorageCapacity()
     * @see #getCAESPlant()
     * @generated
     */
    EAttribute getCAESPlant_EnergyStorageCapacity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getRatedCapacityP <em>Rated Capacity P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Capacity P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getRatedCapacityP()
     * @see #getCAESPlant()
     * @generated
     */
    EAttribute getCAESPlant_RatedCapacityP();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getAirCompressor <em>Air Compressor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Air Compressor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getAirCompressor()
     * @see #getCAESPlant()
     * @generated
     */
    EReference getCAESPlant_AirCompressor();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CAESPlant#getThermalGeneratingUnit()
     * @see #getCAESPlant()
     * @generated
     */
    EReference getCAESPlant_ThermalGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject <em>Diagram Object</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Diagram Object</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject
     * @generated
     */
    EClass getDiagramObject();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getDrawingOrder <em>Drawing Order</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Drawing Order</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getDrawingOrder()
     * @see #getDiagramObject()
     * @generated
     */
    EAttribute getDiagramObject_DrawingOrder();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getIsPolygon <em>Is Polygon</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Polygon</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getIsPolygon()
     * @see #getDiagramObject()
     * @generated
     */
    EAttribute getDiagramObject_IsPolygon();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getOffsetX <em>Offset X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Offset X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getOffsetX()
     * @see #getDiagramObject()
     * @generated
     */
    EAttribute getDiagramObject_OffsetX();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getOffsetY <em>Offset Y</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Offset Y</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getOffsetY()
     * @see #getDiagramObject()
     * @generated
     */
    EAttribute getDiagramObject_OffsetY();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getRotation <em>Rotation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rotation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getRotation()
     * @see #getDiagramObject()
     * @generated
     */
    EAttribute getDiagramObject_Rotation();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getDiagramObjectPoints <em>Diagram Object Points</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Diagram Object Points</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getDiagramObjectPoints()
     * @see #getDiagramObject()
     * @generated
     */
    EReference getDiagramObject_DiagramObjectPoints();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getVisibilityLayers <em>Visibility Layers</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Visibility Layers</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getVisibilityLayers()
     * @see #getDiagramObject()
     * @generated
     */
    EReference getDiagramObject_VisibilityLayers();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getDiagram <em>Diagram</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Diagram</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getDiagram()
     * @see #getDiagramObject()
     * @generated
     */
    EReference getDiagramObject_Diagram();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getDiagramObjectStyle <em>Diagram Object Style</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Diagram Object Style</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getDiagramObjectStyle()
     * @see #getDiagramObject()
     * @generated
     */
    EReference getDiagramObject_DiagramObjectStyle();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getIdentifiedObject <em>Identified Object</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Identified Object</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObject#getIdentifiedObject()
     * @see #getDiagramObject()
     * @generated
     */
    EReference getDiagramObject_IdentifiedObject();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil <em>Petersen Coil</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Petersen Coil</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil
     * @generated
     */
    EClass getPetersenCoil();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getMode <em>Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getMode()
     * @see #getPetersenCoil()
     * @generated
     */
    EAttribute getPetersenCoil_Mode();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getNominalU <em>Nominal U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Nominal U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getNominalU()
     * @see #getPetersenCoil()
     * @generated
     */
    EAttribute getPetersenCoil_NominalU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getOffsetCurrent <em>Offset Current</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Offset Current</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getOffsetCurrent()
     * @see #getPetersenCoil()
     * @generated
     */
    EAttribute getPetersenCoil_OffsetCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getPositionCurrent <em>Position Current</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Position Current</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getPositionCurrent()
     * @see #getPetersenCoil()
     * @generated
     */
    EAttribute getPetersenCoil_PositionCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getXGroundMax <em>XGround Max</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XGround Max</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getXGroundMax()
     * @see #getPetersenCoil()
     * @generated
     */
    EAttribute getPetersenCoil_XGroundMax();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getXGroundMin <em>XGround Min</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XGround Min</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getXGroundMin()
     * @see #getPetersenCoil()
     * @generated
     */
    EAttribute getPetersenCoil_XGroundMin();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getXGroundNominal <em>XGround Nominal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XGround Nominal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoil#getXGroundNominal()
     * @see #getPetersenCoil()
     * @generated
     */
    EAttribute getPetersenCoil_XGroundNominal();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode <em>DC Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode
     * @generated
     */
    EClass getDCNode();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode#getDCTopologicalNode <em>DC Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>DC Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode#getDCTopologicalNode()
     * @see #getDCNode()
     * @generated
     */
    EReference getDCNode_DCTopologicalNode();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode#getDCEquipmentContainer <em>DC Equipment Container</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>DC Equipment Container</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode#getDCEquipmentContainer()
     * @see #getDCNode()
     * @generated
     */
    EReference getDCNode_DCEquipmentContainer();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode#getDCTerminals <em>DC Terminals</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Terminals</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCNode#getDCTerminals()
     * @see #getDCNode()
     * @generated
     */
    EReference getDCNode_DCTerminals();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadSchedule <em>Conform Load Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Conform Load Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadSchedule
     * @generated
     */
    EClass getConformLoadSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadSchedule#getConformLoadGroup <em>Conform Load Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Conform Load Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoadSchedule#getConformLoadGroup()
     * @see #getConformLoadSchedule()
     * @generated
     */
    EReference getConformLoadSchedule_ConformLoadGroup();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentFault <em>Equipment Fault</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Equipment Fault</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentFault
     * @generated
     */
    EClass getEquipmentFault();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentFault#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentFault#getTerminal()
     * @see #getEquipmentFault()
     * @generated
     */
    EReference getEquipmentFault_Terminal();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay <em>Synchrocheck Relay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Synchrocheck Relay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay
     * @generated
     */
    EClass getSynchrocheckRelay();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay#getMaxAngleDiff <em>Max Angle Diff</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Angle Diff</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay#getMaxAngleDiff()
     * @see #getSynchrocheckRelay()
     * @generated
     */
    EAttribute getSynchrocheckRelay_MaxAngleDiff();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay#getMaxFreqDiff <em>Max Freq Diff</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Freq Diff</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay#getMaxFreqDiff()
     * @see #getSynchrocheckRelay()
     * @generated
     */
    EAttribute getSynchrocheckRelay_MaxFreqDiff();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay#getMaxVoltDiff <em>Max Volt Diff</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Volt Diff</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchrocheckRelay#getMaxVoltDiff()
     * @see #getSynchrocheckRelay()
     * @generated
     */
    EAttribute getSynchrocheckRelay_MaxVoltDiff();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectStyle <em>Diagram Object Style</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Diagram Object Style</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectStyle
     * @generated
     */
    EClass getDiagramObjectStyle();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectStyle#getStyledObjects <em>Styled Objects</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Styled Objects</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectStyle#getStyledObjects()
     * @see #getDiagramObjectStyle()
     * @generated
     */
    EReference getDiagramObjectStyle_StyledObjects();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850 <em>Quality61850</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Quality61850</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850
     * @generated
     */
    EClass getQuality61850();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getBadReference <em>Bad Reference</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Bad Reference</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getBadReference()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_BadReference();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getEstimatorReplaced <em>Estimator Replaced</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Estimator Replaced</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getEstimatorReplaced()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_EstimatorReplaced();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getFailure <em>Failure</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Failure</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getFailure()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_Failure();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOldData <em>Old Data</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Old Data</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOldData()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_OldData();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOperatorBlocked <em>Operator Blocked</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Operator Blocked</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOperatorBlocked()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_OperatorBlocked();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOscillatory <em>Oscillatory</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Oscillatory</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOscillatory()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_Oscillatory();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOutOfRange <em>Out Of Range</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Out Of Range</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOutOfRange()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_OutOfRange();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOverFlow <em>Over Flow</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Over Flow</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getOverFlow()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_OverFlow();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getSource <em>Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getSource()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_Source();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getSuspect <em>Suspect</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Suspect</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getSuspect()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_Suspect();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getTest <em>Test</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Test</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getTest()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_Test();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getValidity <em>Validity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Validity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Quality61850#getValidity()
     * @see #getQuality61850()
     * @generated
     */
    EAttribute getQuality61850_Validity();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTablePoint <em>Phase Tap Changer Table Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Phase Tap Changer Table Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTablePoint
     * @generated
     */
    EClass getPhaseTapChangerTablePoint();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTablePoint#getAngle <em>Angle</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Angle</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTablePoint#getAngle()
     * @see #getPhaseTapChangerTablePoint()
     * @generated
     */
    EAttribute getPhaseTapChangerTablePoint_Angle();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTablePoint#getPhaseTapChangerTable <em>Phase Tap Changer Table</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Phase Tap Changer Table</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTablePoint#getPhaseTapChangerTable()
     * @see #getPhaseTapChangerTablePoint()
     * @generated
     */
    EReference getPhaseTapChangerTablePoint_PhaseTapChangerTable();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundDisconnector <em>Ground Disconnector</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Ground Disconnector</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundDisconnector
     * @generated
     */
    EClass getGroundDisconnector();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTankEnd <em>Transformer Tank End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Transformer Tank End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTankEnd
     * @generated
     */
    EClass getTransformerTankEnd();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTankEnd#getPhases <em>Phases</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phases</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTankEnd#getPhases()
     * @see #getTransformerTankEnd()
     * @generated
     */
    EAttribute getTransformerTankEnd_Phases();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTankEnd#getTransformerTank <em>Transformer Tank</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Transformer Tank</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTankEnd#getTransformerTank()
     * @see #getTransformerTankEnd()
     * @generated
     */
    EReference getTransformerTankEnd_TransformerTank();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensatorPhase <em>Linear Shunt Compensator Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Linear Shunt Compensator Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensatorPhase
     * @generated
     */
    EClass getLinearShuntCompensatorPhase();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensatorPhase#getBPerSection <em>BPer Section</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>BPer Section</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensatorPhase#getBPerSection()
     * @see #getLinearShuntCompensatorPhase()
     * @generated
     */
    EAttribute getLinearShuntCompensatorPhase_BPerSection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensatorPhase#getGPerSection <em>GPer Section</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>GPer Section</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LinearShuntCompensatorPhase#getGPerSection()
     * @see #getLinearShuntCompensatorPhase()
     * @generated
     */
    EAttribute getLinearShuntCompensatorPhase_GPerSection();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator <em>Shunt Compensator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Shunt Compensator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator
     * @generated
     */
    EClass getShuntCompensator();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getAVRDelay <em>AVR Delay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>AVR Delay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getAVRDelay()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_AVRDelay();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getGrounded <em>Grounded</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Grounded</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getGrounded()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_Grounded();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getMaximumSections <em>Maximum Sections</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Maximum Sections</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getMaximumSections()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_MaximumSections();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getNomU <em>Nom U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Nom U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getNomU()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_NomU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getNormalSections <em>Normal Sections</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Sections</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getNormalSections()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_NormalSections();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getPhaseConnection <em>Phase Connection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phase Connection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getPhaseConnection()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_PhaseConnection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getSections <em>Sections</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sections</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getSections()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_Sections();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getSwitchOnCount <em>Switch On Count</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Switch On Count</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getSwitchOnCount()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_SwitchOnCount();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getSwitchOnDate <em>Switch On Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Switch On Date</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getSwitchOnDate()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_SwitchOnDate();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getVoltageSensitivity <em>Voltage Sensitivity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Voltage Sensitivity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getVoltageSensitivity()
     * @see #getShuntCompensator()
     * @generated
     */
    EAttribute getShuntCompensator_VoltageSensitivity();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getShuntCompensatorPhase <em>Shunt Compensator Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Shunt Compensator Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getShuntCompensatorPhase()
     * @see #getShuntCompensator()
     * @generated
     */
    EReference getShuntCompensator_ShuntCompensatorPhase();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getSvShuntCompensatorSections <em>Sv Shunt Compensator Sections</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Sv Shunt Compensator Sections</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensator#getSvShuntCompensatorSections()
     * @see #getShuntCompensator()
     * @generated
     */
    EReference getShuntCompensator_SvShuntCompensatorSections();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence <em>Reclose Sequence</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Reclose Sequence</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence
     * @generated
     */
    EClass getRecloseSequence();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence#getRecloseDelay <em>Reclose Delay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reclose Delay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence#getRecloseDelay()
     * @see #getRecloseSequence()
     * @generated
     */
    EAttribute getRecloseSequence_RecloseDelay();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence#getRecloseStep <em>Reclose Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reclose Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence#getRecloseStep()
     * @see #getRecloseSequence()
     * @generated
     */
    EAttribute getRecloseSequence_RecloseStep();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence#getProtectedSwitch <em>Protected Switch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Protected Switch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RecloseSequence#getProtectedSwitch()
     * @see #getRecloseSequence()
     * @generated
     */
    EReference getRecloseSequence_ProtectedSwitch();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator <em>Series Compensator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Series Compensator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator
     * @generated
     */
    EClass getSeriesCompensator();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getR()
     * @see #getSeriesCompensator()
     * @generated
     */
    EAttribute getSeriesCompensator_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getR0()
     * @see #getSeriesCompensator()
     * @generated
     */
    EAttribute getSeriesCompensator_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getVaristorPresent <em>Varistor Present</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Varistor Present</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getVaristorPresent()
     * @see #getSeriesCompensator()
     * @generated
     */
    EAttribute getSeriesCompensator_VaristorPresent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getVaristorRatedCurrent <em>Varistor Rated Current</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Varistor Rated Current</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getVaristorRatedCurrent()
     * @see #getSeriesCompensator()
     * @generated
     */
    EAttribute getSeriesCompensator_VaristorRatedCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getVaristorVoltageThreshold <em>Varistor Voltage Threshold</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Varistor Voltage Threshold</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getVaristorVoltageThreshold()
     * @see #getSeriesCompensator()
     * @generated
     */
    EAttribute getSeriesCompensator_VaristorVoltageThreshold();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getX()
     * @see #getSeriesCompensator()
     * @generated
     */
    EAttribute getSeriesCompensator_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SeriesCompensator#getX0()
     * @see #getSeriesCompensator()
     * @generated
     */
    EAttribute getSeriesCompensator_X0();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType <em>Name Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Name Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType
     * @generated
     */
    EClass getNameType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType#getDescription <em>Description</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Description</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType#getDescription()
     * @see #getNameType()
     * @generated
     */
    EAttribute getNameType_Description();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType#getName <em>Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Name</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType#getName()
     * @see #getNameType()
     * @generated
     */
    EAttribute getNameType_Name();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType#getNames <em>Names</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Names</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType#getNames()
     * @see #getNameType()
     * @generated
     */
    EReference getNameType_Names();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType#getNameTypeAuthority <em>Name Type Authority</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Name Type Authority</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NameType#getNameTypeAuthority()
     * @see #getNameType()
     * @generated
     */
    EReference getNameType_NameTypeAuthority();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance <em>Transformer Mesh Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Transformer Mesh Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance
     * @generated
     */
    EClass getTransformerMeshImpedance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getR()
     * @see #getTransformerMeshImpedance()
     * @generated
     */
    EAttribute getTransformerMeshImpedance_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getR0()
     * @see #getTransformerMeshImpedance()
     * @generated
     */
    EAttribute getTransformerMeshImpedance_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getX()
     * @see #getTransformerMeshImpedance()
     * @generated
     */
    EAttribute getTransformerMeshImpedance_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getX0()
     * @see #getTransformerMeshImpedance()
     * @generated
     */
    EAttribute getTransformerMeshImpedance_X0();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getToTransformerEnd <em>To Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>To Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getToTransformerEnd()
     * @see #getTransformerMeshImpedance()
     * @generated
     */
    EReference getTransformerMeshImpedance_ToTransformerEnd();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getFromTransformerEnd <em>From Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>From Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerMeshImpedance#getFromTransformerEnd()
     * @see #getTransformerMeshImpedance()
     * @generated
     */
    EReference getTransformerMeshImpedance_FromTransformerEnd();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DrumBoiler <em>Drum Boiler</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Drum Boiler</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DrumBoiler
     * @generated
     */
    EClass getDrumBoiler();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DrumBoiler#getDrumBoilerRating <em>Drum Boiler Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Drum Boiler Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DrumBoiler#getDrumBoilerRating()
     * @see #getDrumBoiler()
     * @generated
     */
    EAttribute getDrumBoiler_DrumBoilerRating();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue <em>Measurement Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Measurement Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue
     * @generated
     */
    EClass getMeasurementValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getSensorAccuracy <em>Sensor Accuracy</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sensor Accuracy</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getSensorAccuracy()
     * @see #getMeasurementValue()
     * @generated
     */
    EAttribute getMeasurementValue_SensorAccuracy();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getTimeStamp <em>Time Stamp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Time Stamp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getTimeStamp()
     * @see #getMeasurementValue()
     * @generated
     */
    EAttribute getMeasurementValue_TimeStamp();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getRemoteSource <em>Remote Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Remote Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getRemoteSource()
     * @see #getMeasurementValue()
     * @generated
     */
    EReference getMeasurementValue_RemoteSource();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getMeasurementValueSource <em>Measurement Value Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Measurement Value Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getMeasurementValueSource()
     * @see #getMeasurementValue()
     * @generated
     */
    EReference getMeasurementValue_MeasurementValueSource();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getMeasurementValueQuality <em>Measurement Value Quality</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Measurement Value Quality</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValue#getMeasurementValueQuality()
     * @see #getMeasurementValue()
     * @generated
     */
    EReference getMeasurementValue_MeasurementValueQuality();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SetPoint <em>Set Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Set Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SetPoint
     * @generated
     */
    EClass getSetPoint();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SetPoint#getNormalValue <em>Normal Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SetPoint#getNormalValue()
     * @see #getSetPoint()
     * @generated
     */
    EAttribute getSetPoint_NormalValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SetPoint#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SetPoint#getValue()
     * @see #getSetPoint()
     * @generated
     */
    EAttribute getSetPoint_Value();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault <em>Fault</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Fault</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault
     * @generated
     */
    EClass getFault();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getKind <em>Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getKind()
     * @see #getFault()
     * @generated
     */
    EAttribute getFault_Kind();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getPhases <em>Phases</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phases</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getPhases()
     * @see #getFault()
     * @generated
     */
    EAttribute getFault_Phases();

    /**
     * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getImpedance <em>Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference '<em>Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getImpedance()
     * @see #getFault()
     * @generated
     */
    EReference getFault_Impedance();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getFaultCauseTypes <em>Fault Cause Types</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Fault Cause Types</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getFaultCauseTypes()
     * @see #getFault()
     * @generated
     */
    EReference getFault_FaultCauseTypes();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getFaultyEquipment <em>Faulty Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Faulty Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fault#getFaultyEquipment()
     * @see #getFault()
     * @generated
     */
    EReference getFault_FaultyEquipment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine <em>Steam Turbine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Steam Turbine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine
     * @generated
     */
    EClass getSteamTurbine();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getCrossoverTC <em>Crossover TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Crossover TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getCrossoverTC()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_CrossoverTC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getReheater1TC <em>Reheater1 TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reheater1 TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getReheater1TC()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Reheater1TC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getReheater2TC <em>Reheater2 TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reheater2 TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getReheater2TC()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Reheater2TC();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft1PowerHP <em>Shaft1 Power HP</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shaft1 Power HP</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft1PowerHP()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Shaft1PowerHP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft1PowerIP <em>Shaft1 Power IP</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shaft1 Power IP</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft1PowerIP()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Shaft1PowerIP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft1PowerLP1 <em>Shaft1 Power LP1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shaft1 Power LP1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft1PowerLP1()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Shaft1PowerLP1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft1PowerLP2 <em>Shaft1 Power LP2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shaft1 Power LP2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft1PowerLP2()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Shaft1PowerLP2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft2PowerHP <em>Shaft2 Power HP</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shaft2 Power HP</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft2PowerHP()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Shaft2PowerHP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft2PowerIP <em>Shaft2 Power IP</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shaft2 Power IP</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft2PowerIP()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Shaft2PowerIP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft2PowerLP1 <em>Shaft2 Power LP1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shaft2 Power LP1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft2PowerLP1()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Shaft2PowerLP1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft2PowerLP2 <em>Shaft2 Power LP2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shaft2 Power LP2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getShaft2PowerLP2()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_Shaft2PowerLP2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getSteamChestTC <em>Steam Chest TC</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Steam Chest TC</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getSteamChestTC()
     * @see #getSteamTurbine()
     * @generated
     */
    EAttribute getSteamTurbine_SteamChestTC();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getSteamSupplys <em>Steam Supplys</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Steam Supplys</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SteamTurbine#getSteamSupplys()
     * @see #getSteamTurbine()
     * @generated
     */
    EReference getSteamTurbine_SteamSupplys();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine <em>Rotating Machine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Rotating Machine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine
     * @generated
     */
    EClass getRotatingMachine();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getP <em>P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getP()
     * @see #getRotatingMachine()
     * @generated
     */
    EAttribute getRotatingMachine_P();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getQ <em>Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getQ()
     * @see #getRotatingMachine()
     * @generated
     */
    EAttribute getRotatingMachine_Q();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getRatedPowerFactor <em>Rated Power Factor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Power Factor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getRatedPowerFactor()
     * @see #getRotatingMachine()
     * @generated
     */
    EAttribute getRotatingMachine_RatedPowerFactor();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getRatedS <em>Rated S</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated S</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getRatedS()
     * @see #getRotatingMachine()
     * @generated
     */
    EAttribute getRotatingMachine_RatedS();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getRatedU <em>Rated U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getRatedU()
     * @see #getRotatingMachine()
     * @generated
     */
    EAttribute getRotatingMachine_RatedU();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getGeneratingUnit <em>Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getGeneratingUnit()
     * @see #getRotatingMachine()
     * @generated
     */
    EReference getRotatingMachine_GeneratingUnit();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getHydroPump <em>Hydro Pump</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Hydro Pump</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RotatingMachine#getHydroPump()
     * @see #getRotatingMachine()
     * @generated
     */
    EReference getRotatingMachine_HydroPump();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRecoveryBoiler <em>Heat Recovery Boiler</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Heat Recovery Boiler</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRecoveryBoiler
     * @generated
     */
    EClass getHeatRecoveryBoiler();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRecoveryBoiler#getSteamSupplyRating2 <em>Steam Supply Rating2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Steam Supply Rating2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRecoveryBoiler#getSteamSupplyRating2()
     * @see #getHeatRecoveryBoiler()
     * @generated
     */
    EAttribute getHeatRecoveryBoiler_SteamSupplyRating2();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRecoveryBoiler#getCombustionTurbines <em>Combustion Turbines</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Combustion Turbines</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatRecoveryBoiler#getCombustionTurbines()
     * @see #getHeatRecoveryBoiler()
     * @generated
     */
    EReference getHeatRecoveryBoiler_CombustionTurbines();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode <em>Connectivity Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Connectivity Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode
     * @generated
     */
    EClass getConnectivityNode();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode#getConnectivityNodeContainer <em>Connectivity Node Container</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Connectivity Node Container</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode#getConnectivityNodeContainer()
     * @see #getConnectivityNode()
     * @generated
     */
    EReference getConnectivityNode_ConnectivityNodeContainer();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode#getTopologicalNode <em>Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode#getTopologicalNode()
     * @see #getConnectivityNode()
     * @generated
     */
    EReference getConnectivityNode_TopologicalNode();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode#getTerminals <em>Terminals</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Terminals</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNode#getTerminals()
     * @see #getConnectivityNode()
     * @generated
     */
    EReference getConnectivityNode_Terminals();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Cut <em>Cut</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Cut</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Cut
     * @generated
     */
    EClass getCut();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Cut#getLengthFromTerminal1 <em>Length From Terminal1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Length From Terminal1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Cut#getLengthFromTerminal1()
     * @see #getCut()
     * @generated
     */
    EAttribute getCut_LengthFromTerminal1();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Cut#getACLineSegment <em>AC Line Segment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>AC Line Segment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Cut#getACLineSegment()
     * @see #getCut()
     * @generated
     */
    EReference getCut_ACLineSegment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType <em>Operational Limit Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Operational Limit Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType
     * @generated
     */
    EClass getOperationalLimitType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType#getAcceptableDuration <em>Acceptable Duration</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Acceptable Duration</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType#getAcceptableDuration()
     * @see #getOperationalLimitType()
     * @generated
     */
    EAttribute getOperationalLimitType_AcceptableDuration();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType#getDirection <em>Direction</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Direction</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType#getDirection()
     * @see #getOperationalLimitType()
     * @generated
     */
    EAttribute getOperationalLimitType_Direction();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType#getOperationalLimit <em>Operational Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Operational Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitType#getOperationalLimit()
     * @see #getOperationalLimitType()
     * @generated
     */
    EReference getOperationalLimitType_OperationalLimit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint <em>Irregular Time Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Irregular Time Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint
     * @generated
     */
    EClass getIrregularTimePoint();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint#getTime <em>Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint#getTime()
     * @see #getIrregularTimePoint()
     * @generated
     */
    EAttribute getIrregularTimePoint_Time();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint#getValue1 <em>Value1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint#getValue1()
     * @see #getIrregularTimePoint()
     * @generated
     */
    EAttribute getIrregularTimePoint_Value1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint#getValue2 <em>Value2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint#getValue2()
     * @see #getIrregularTimePoint()
     * @generated
     */
    EAttribute getIrregularTimePoint_Value2();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint#getIntervalSchedule <em>Interval Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Interval Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IrregularTimePoint#getIntervalSchedule()
     * @see #getIrregularTimePoint()
     * @generated
     */
    EReference getIrregularTimePoint_IntervalSchedule();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fuse <em>Fuse</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Fuse</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Fuse
     * @generated
     */
    EClass getFuse();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject <em>Identified Object</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Identified Object</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject
     * @generated
     */
    EClass getIdentifiedObject();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getAliasName <em>Alias Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Alias Name</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getAliasName()
     * @see #getIdentifiedObject()
     * @generated
     */
    EAttribute getIdentifiedObject_AliasName();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getDescription <em>Description</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Description</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getDescription()
     * @see #getIdentifiedObject()
     * @generated
     */
    EAttribute getIdentifiedObject_Description();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getMRID <em>MRID</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>MRID</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getMRID()
     * @see #getIdentifiedObject()
     * @generated
     */
    EAttribute getIdentifiedObject_MRID();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getName <em>Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Name</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getName()
     * @see #getIdentifiedObject()
     * @generated
     */
    EAttribute getIdentifiedObject_Name();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getNames <em>Names</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Names</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getNames()
     * @see #getIdentifiedObject()
     * @generated
     */
    EReference getIdentifiedObject_Names();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getDiagramObjects <em>Diagram Objects</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Diagram Objects</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.IdentifiedObject#getDiagramObjects()
     * @see #getIdentifiedObject()
     * @generated
     */
    EReference getIdentifiedObject_DiagramObjects();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment <em>Conducting Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Conducting Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment
     * @generated
     */
    EClass getConductingEquipment();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment#getProtectionEquipments <em>Protection Equipments</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Protection Equipments</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment#getProtectionEquipments()
     * @see #getConductingEquipment()
     * @generated
     */
    EReference getConductingEquipment_ProtectionEquipments();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment#getBaseVoltage <em>Base Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment#getBaseVoltage()
     * @see #getConductingEquipment()
     * @generated
     */
    EReference getConductingEquipment_BaseVoltage();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment#getSvStatus <em>Sv Status</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Sv Status</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment#getSvStatus()
     * @see #getConductingEquipment()
     * @generated
     */
    EReference getConductingEquipment_SvStatus();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment#getTerminals <em>Terminals</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Terminals</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConductingEquipment#getTerminals()
     * @see #getConductingEquipment()
     * @generated
     */
    EReference getConductingEquipment_Terminals();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundingImpedance <em>Grounding Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Grounding Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundingImpedance
     * @generated
     */
    EClass getGroundingImpedance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundingImpedance#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GroundingImpedance#getX()
     * @see #getGroundingImpedance()
     * @generated
     */
    EAttribute getGroundingImpedance_X();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LineFault <em>Line Fault</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Line Fault</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LineFault
     * @generated
     */
    EClass getLineFault();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LineFault#getLengthFromTerminal1 <em>Length From Terminal1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Length From Terminal1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LineFault#getLengthFromTerminal1()
     * @see #getLineFault()
     * @generated
     */
    EAttribute getLineFault_LengthFromTerminal1();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LineFault#getACLineSegment <em>AC Line Segment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>AC Line Segment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LineFault#getACLineSegment()
     * @see #getLineFault()
     * @generated
     */
    EReference getLineFault_ACLineSegment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor <em>Air Compressor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Air Compressor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor
     * @generated
     */
    EClass getAirCompressor();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor#getAirCompressorRating <em>Air Compressor Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Air Compressor Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor#getAirCompressorRating()
     * @see #getAirCompressor()
     * @generated
     */
    EAttribute getAirCompressor_AirCompressorRating();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor#getCombustionTurbine <em>Combustion Turbine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Combustion Turbine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor#getCombustionTurbine()
     * @see #getAirCompressor()
     * @generated
     */
    EReference getAirCompressor_CombustionTurbine();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor#getCAESPlant <em>CAES Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>CAES Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AirCompressor#getCAESPlant()
     * @see #getAirCompressor()
     * @generated
     */
    EReference getAirCompressor_CAESPlant();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusNameMarker <em>Bus Name Marker</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Bus Name Marker</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusNameMarker
     * @generated
     */
    EClass getBusNameMarker();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusNameMarker#getPriority <em>Priority</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Priority</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusNameMarker#getPriority()
     * @see #getBusNameMarker()
     * @generated
     */
    EAttribute getBusNameMarker_Priority();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusNameMarker#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusNameMarker#getTerminal()
     * @see #getBusNameMarker()
     * @generated
     */
    EReference getBusNameMarker_Terminal();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase <em>Shunt Compensator Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Shunt Compensator Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase
     * @generated
     */
    EClass getShuntCompensatorPhase();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase#getMaximumSections <em>Maximum Sections</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Maximum Sections</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase#getMaximumSections()
     * @see #getShuntCompensatorPhase()
     * @generated
     */
    EAttribute getShuntCompensatorPhase_MaximumSections();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase#getNormalSections <em>Normal Sections</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Sections</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase#getNormalSections()
     * @see #getShuntCompensatorPhase()
     * @generated
     */
    EAttribute getShuntCompensatorPhase_NormalSections();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase#getPhase <em>Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase#getPhase()
     * @see #getShuntCompensatorPhase()
     * @generated
     */
    EAttribute getShuntCompensatorPhase_Phase();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase#getShuntCompensator <em>Shunt Compensator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Shunt Compensator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShuntCompensatorPhase#getShuntCompensator()
     * @see #getShuntCompensatorPhase()
     * @generated
     */
    EReference getShuntCompensatorPhase_ShuntCompensator();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyElement <em>Contingency Element</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Contingency Element</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyElement
     * @generated
     */
    EClass getContingencyElement();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyElement#getContingency <em>Contingency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Contingency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyElement#getContingency()
     * @see #getContingencyElement()
     * @generated
     */
    EReference getContingencyElement_Contingency();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingCondEq <em>Regulating Cond Eq</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Regulating Cond Eq</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingCondEq
     * @generated
     */
    EClass getRegulatingCondEq();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingCondEq#getControlEnabled <em>Control Enabled</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control Enabled</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingCondEq#getControlEnabled()
     * @see #getRegulatingCondEq()
     * @generated
     */
    EAttribute getRegulatingCondEq_ControlEnabled();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingCondEq#getRegulatingControl <em>Regulating Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Regulating Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingCondEq#getRegulatingControl()
     * @see #getRegulatingCondEq()
     * @generated
     */
    EReference getRegulatingCondEq_RegulatingControl();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue <em>Analog Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Analog Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue
     * @generated
     */
    EClass getAnalogValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getValue()
     * @see #getAnalogValue()
     * @generated
     */
    EAttribute getAnalogValue_Value();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getAnalogControl <em>Analog Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Analog Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getAnalogControl()
     * @see #getAnalogValue()
     * @generated
     */
    EReference getAnalogValue_AnalogControl();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getAnalog <em>Analog</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Analog</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getAnalog()
     * @see #getAnalogValue()
     * @generated
     */
    EReference getAnalogValue_Analog();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getAltGeneratingUnit <em>Alt Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Alt Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getAltGeneratingUnit()
     * @see #getAnalogValue()
     * @generated
     */
    EReference getAnalogValue_AltGeneratingUnit();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getAltTieMeas <em>Alt Tie Meas</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Alt Tie Meas</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogValue#getAltTieMeas()
     * @see #getAnalogValue()
     * @generated
     */
    EReference getAnalogValue_AltTieMeas();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimitSet <em>Analog Limit Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Analog Limit Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimitSet
     * @generated
     */
    EClass getAnalogLimitSet();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimitSet#getMeasurements <em>Measurements</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Measurements</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimitSet#getMeasurements()
     * @see #getAnalogLimitSet()
     * @generated
     */
    EReference getAnalogLimitSet_Measurements();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimitSet#getLimits <em>Limits</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Limits</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogLimitSet#getLimits()
     * @see #getAnalogLimitSet()
     * @generated
     */
    EReference getAnalogLimitSet_Limits();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay <em>Current Relay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Current Relay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay
     * @generated
     */
    EClass getCurrentRelay();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getCurrentLimit1 <em>Current Limit1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Current Limit1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getCurrentLimit1()
     * @see #getCurrentRelay()
     * @generated
     */
    EAttribute getCurrentRelay_CurrentLimit1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getCurrentLimit2 <em>Current Limit2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Current Limit2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getCurrentLimit2()
     * @see #getCurrentRelay()
     * @generated
     */
    EAttribute getCurrentRelay_CurrentLimit2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getCurrentLimit3 <em>Current Limit3</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Current Limit3</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getCurrentLimit3()
     * @see #getCurrentRelay()
     * @generated
     */
    EAttribute getCurrentRelay_CurrentLimit3();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getInverseTimeFlag <em>Inverse Time Flag</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Inverse Time Flag</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getInverseTimeFlag()
     * @see #getCurrentRelay()
     * @generated
     */
    EAttribute getCurrentRelay_InverseTimeFlag();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getTimeDelay1 <em>Time Delay1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Time Delay1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getTimeDelay1()
     * @see #getCurrentRelay()
     * @generated
     */
    EAttribute getCurrentRelay_TimeDelay1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getTimeDelay2 <em>Time Delay2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Time Delay2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getTimeDelay2()
     * @see #getCurrentRelay()
     * @generated
     */
    EAttribute getCurrentRelay_TimeDelay2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getTimeDelay3 <em>Time Delay3</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Time Delay3</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentRelay#getTimeDelay3()
     * @see #getCurrentRelay()
     * @generated
     */
    EAttribute getCurrentRelay_TimeDelay3();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve <em>Heat Input Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Heat Input Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve
     * @generated
     */
    EClass getHeatInputCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getAuxPowerMult <em>Aux Power Mult</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Aux Power Mult</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getAuxPowerMult()
     * @see #getHeatInputCurve()
     * @generated
     */
    EAttribute getHeatInputCurve_AuxPowerMult();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getAuxPowerOffset <em>Aux Power Offset</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Aux Power Offset</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getAuxPowerOffset()
     * @see #getHeatInputCurve()
     * @generated
     */
    EAttribute getHeatInputCurve_AuxPowerOffset();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getHeatInputEff <em>Heat Input Eff</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Heat Input Eff</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getHeatInputEff()
     * @see #getHeatInputCurve()
     * @generated
     */
    EAttribute getHeatInputCurve_HeatInputEff();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getHeatInputOffset <em>Heat Input Offset</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Heat Input Offset</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getHeatInputOffset()
     * @see #getHeatInputCurve()
     * @generated
     */
    EAttribute getHeatInputCurve_HeatInputOffset();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getIsNetGrossP <em>Is Net Gross P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Net Gross P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getIsNetGrossP()
     * @see #getHeatInputCurve()
     * @generated
     */
    EAttribute getHeatInputCurve_IsNetGrossP();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HeatInputCurve#getThermalGeneratingUnit()
     * @see #getHeatInputCurve()
     * @generated
     */
    EReference getHeatInputCurve_ThermalGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control <em>Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control
     * @generated
     */
    EClass getControl();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getControlType <em>Control Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getControlType()
     * @see #getControl()
     * @generated
     */
    EAttribute getControl_ControlType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getOperationInProgress <em>Operation In Progress</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Operation In Progress</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getOperationInProgress()
     * @see #getControl()
     * @generated
     */
    EAttribute getControl_OperationInProgress();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getTimeStamp <em>Time Stamp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Time Stamp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getTimeStamp()
     * @see #getControl()
     * @generated
     */
    EAttribute getControl_TimeStamp();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getUnitMultiplier <em>Unit Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getUnitMultiplier()
     * @see #getControl()
     * @generated
     */
    EAttribute getControl_UnitMultiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getUnitSymbol <em>Unit Symbol</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Unit Symbol</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getUnitSymbol()
     * @see #getControl()
     * @generated
     */
    EAttribute getControl_UnitSymbol();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getRemoteControl <em>Remote Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Remote Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getRemoteControl()
     * @see #getControl()
     * @generated
     */
    EReference getControl_RemoteControl();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getPowerSystemResource <em>Power System Resource</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Power System Resource</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Control#getPowerSystemResource()
     * @see #getControl()
     * @generated
     */
    EReference getControl_PowerSystemResource();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump <em>Hydro Pump</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Hydro Pump</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump
     * @generated
     */
    EClass getHydroPump();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getPumpDischAtMaxHead <em>Pump Disch At Max Head</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pump Disch At Max Head</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getPumpDischAtMaxHead()
     * @see #getHydroPump()
     * @generated
     */
    EAttribute getHydroPump_PumpDischAtMaxHead();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getPumpDischAtMinHead <em>Pump Disch At Min Head</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pump Disch At Min Head</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getPumpDischAtMinHead()
     * @see #getHydroPump()
     * @generated
     */
    EAttribute getHydroPump_PumpDischAtMinHead();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getPumpPowerAtMaxHead <em>Pump Power At Max Head</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pump Power At Max Head</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getPumpPowerAtMaxHead()
     * @see #getHydroPump()
     * @generated
     */
    EAttribute getHydroPump_PumpPowerAtMaxHead();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getPumpPowerAtMinHead <em>Pump Power At Min Head</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pump Power At Min Head</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getPumpPowerAtMinHead()
     * @see #getHydroPump()
     * @generated
     */
    EAttribute getHydroPump_PumpPowerAtMinHead();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getHydroPowerPlant <em>Hydro Power Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Hydro Power Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getHydroPowerPlant()
     * @see #getHydroPump()
     * @generated
     */
    EReference getHydroPump_HydroPowerPlant();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getHydroPumpOpSchedule <em>Hydro Pump Op Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Hydro Pump Op Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getHydroPumpOpSchedule()
     * @see #getHydroPump()
     * @generated
     */
    EReference getHydroPump_HydroPumpOpSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getRotatingMachine <em>Rotating Machine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Rotating Machine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPump#getRotatingMachine()
     * @see #getHydroPump()
     * @generated
     */
    EReference getHydroPump_RotatingMachine();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AuxiliaryEquipment <em>Auxiliary Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Auxiliary Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AuxiliaryEquipment
     * @generated
     */
    EClass getAuxiliaryEquipment();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AuxiliaryEquipment#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AuxiliaryEquipment#getTerminal()
     * @see #getAuxiliaryEquipment()
     * @generated
     */
    EReference getAuxiliaryEquipment_Terminal();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNodeContainer <em>Connectivity Node Container</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Connectivity Node Container</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNodeContainer
     * @generated
     */
    EClass getConnectivityNodeContainer();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNodeContainer#getTopologicalNode <em>Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNodeContainer#getTopologicalNode()
     * @see #getConnectivityNodeContainer()
     * @generated
     */
    EReference getConnectivityNodeContainer_TopologicalNode();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNodeContainer#getConnectivityNodes <em>Connectivity Nodes</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Connectivity Nodes</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConnectivityNodeContainer#getConnectivityNodes()
     * @see #getConnectivityNodeContainer()
     * @generated
     */
    EReference getConnectivityNodeContainer_ConnectivityNodes();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas <em>Alt Tie Meas</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Alt Tie Meas</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas
     * @generated
     */
    EClass getAltTieMeas();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas#getPriority <em>Priority</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Priority</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas#getPriority()
     * @see #getAltTieMeas()
     * @generated
     */
    EAttribute getAltTieMeas_Priority();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas#getTieFlow <em>Tie Flow</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Tie Flow</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas#getTieFlow()
     * @see #getAltTieMeas()
     * @generated
     */
    EReference getAltTieMeas_TieFlow();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas#getAnalogValue <em>Analog Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Analog Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AltTieMeas#getAnalogValue()
     * @see #getAltTieMeas()
     * @generated
     */
    EReference getAltTieMeas_AnalogValue();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase <em>Switch Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Switch Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase
     * @generated
     */
    EClass getSwitchPhase();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getClosed <em>Closed</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Closed</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getClosed()
     * @see #getSwitchPhase()
     * @generated
     */
    EAttribute getSwitchPhase_Closed();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getNormalOpen <em>Normal Open</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Open</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getNormalOpen()
     * @see #getSwitchPhase()
     * @generated
     */
    EAttribute getSwitchPhase_NormalOpen();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getPhaseSide1 <em>Phase Side1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phase Side1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getPhaseSide1()
     * @see #getSwitchPhase()
     * @generated
     */
    EAttribute getSwitchPhase_PhaseSide1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getPhaseSide2 <em>Phase Side2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phase Side2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getPhaseSide2()
     * @see #getSwitchPhase()
     * @generated
     */
    EAttribute getSwitchPhase_PhaseSide2();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getSwitch <em>Switch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Switch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SwitchPhase#getSwitch()
     * @see #getSwitchPhase()
     * @generated
     */
    EReference getSwitchPhase_Switch();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Supercritical <em>Supercritical</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Supercritical</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Supercritical
     * @generated
     */
    EClass getSupercritical();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultCauseType <em>Fault Cause Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Fault Cause Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultCauseType
     * @generated
     */
    EClass getFaultCauseType();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultCauseType#getFaults <em>Faults</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Faults</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FaultCauseType#getFaults()
     * @see #getFaultCauseType()
     * @generated
     */
    EReference getFaultCauseType_Faults();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer <em>Current Transformer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Current Transformer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer
     * @generated
     */
    EClass getCurrentTransformer();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getAccuracyClass <em>Accuracy Class</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Accuracy Class</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getAccuracyClass()
     * @see #getCurrentTransformer()
     * @generated
     */
    EAttribute getCurrentTransformer_AccuracyClass();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getAccuracyLimit <em>Accuracy Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Accuracy Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getAccuracyLimit()
     * @see #getCurrentTransformer()
     * @generated
     */
    EAttribute getCurrentTransformer_AccuracyLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getCoreBurden <em>Core Burden</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Core Burden</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getCoreBurden()
     * @see #getCurrentTransformer()
     * @generated
     */
    EAttribute getCurrentTransformer_CoreBurden();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getCtClass <em>Ct Class</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ct Class</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getCtClass()
     * @see #getCurrentTransformer()
     * @generated
     */
    EAttribute getCurrentTransformer_CtClass();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getUsage <em>Usage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Usage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurrentTransformer#getUsage()
     * @see #getCurrentTransformer()
     * @generated
     */
    EAttribute getCurrentTransformer_Usage();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsCapabilityCurve <em>Vs Capability Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Vs Capability Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsCapabilityCurve
     * @generated
     */
    EClass getVsCapabilityCurve();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsCapabilityCurve#getVsConverterDCSides <em>Vs Converter DC Sides</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Vs Converter DC Sides</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsCapabilityCurve#getVsConverterDCSides()
     * @see #getVsCapabilityCurve()
     * @generated
     */
    EReference getVsCapabilityCurve_VsConverterDCSides();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint <em>Regular Time Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Regular Time Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint
     * @generated
     */
    EClass getRegularTimePoint();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint#getSequenceNumber <em>Sequence Number</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Sequence Number</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint#getSequenceNumber()
     * @see #getRegularTimePoint()
     * @generated
     */
    EAttribute getRegularTimePoint_SequenceNumber();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint#getValue1 <em>Value1</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value1</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint#getValue1()
     * @see #getRegularTimePoint()
     * @generated
     */
    EAttribute getRegularTimePoint_Value1();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint#getValue2 <em>Value2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint#getValue2()
     * @see #getRegularTimePoint()
     * @generated
     */
    EAttribute getRegularTimePoint_Value2();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint#getIntervalSchedule <em>Interval Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Interval Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularTimePoint#getIntervalSchedule()
     * @see #getRegularTimePoint()
     * @generated
     */
    EReference getRegularTimePoint_IntervalSchedule();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter <em>Frequency Converter</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Frequency Converter</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter
     * @generated
     */
    EClass getFrequencyConverter();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getFrequency <em>Frequency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Frequency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getFrequency()
     * @see #getFrequencyConverter()
     * @generated
     */
    EAttribute getFrequencyConverter_Frequency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getMaxP <em>Max P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getMaxP()
     * @see #getFrequencyConverter()
     * @generated
     */
    EAttribute getFrequencyConverter_MaxP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getMaxU <em>Max U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getMaxU()
     * @see #getFrequencyConverter()
     * @generated
     */
    EAttribute getFrequencyConverter_MaxU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getMinP <em>Min P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getMinP()
     * @see #getFrequencyConverter()
     * @generated
     */
    EAttribute getFrequencyConverter_MinP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getMinU <em>Min U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FrequencyConverter#getMinU()
     * @see #getFrequencyConverter()
     * @generated
     */
    EAttribute getFrequencyConverter_MinU();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoad <em>Conform Load</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Conform Load</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoad
     * @generated
     */
    EClass getConformLoad();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoad#getLoadGroup <em>Load Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Load Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ConformLoad#getLoadGroup()
     * @see #getConformLoad()
     * @generated
     */
    EReference getConformLoad_LoadGroup();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant <em>Hydro Power Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Hydro Power Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant
     * @generated
     */
    EClass getHydroPowerPlant();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getDischargeTravelDelay <em>Discharge Travel Delay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Discharge Travel Delay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getDischargeTravelDelay()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EAttribute getHydroPowerPlant_DischargeTravelDelay();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getGenRatedP <em>Gen Rated P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Gen Rated P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getGenRatedP()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EAttribute getHydroPowerPlant_GenRatedP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getHydroPlantStorageType <em>Hydro Plant Storage Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Hydro Plant Storage Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getHydroPlantStorageType()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EAttribute getHydroPowerPlant_HydroPlantStorageType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getPenstockType <em>Penstock Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Penstock Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getPenstockType()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EAttribute getHydroPowerPlant_PenstockType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getPlantDischargeCapacity <em>Plant Discharge Capacity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Plant Discharge Capacity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getPlantDischargeCapacity()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EAttribute getHydroPowerPlant_PlantDischargeCapacity();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getPlantRatedHead <em>Plant Rated Head</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Plant Rated Head</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getPlantRatedHead()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EAttribute getHydroPowerPlant_PlantRatedHead();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getPumpRatedP <em>Pump Rated P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pump Rated P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getPumpRatedP()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EAttribute getHydroPowerPlant_PumpRatedP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getSurgeTankCode <em>Surge Tank Code</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Surge Tank Code</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getSurgeTankCode()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EAttribute getHydroPowerPlant_SurgeTankCode();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getSurgeTankCrestLevel <em>Surge Tank Crest Level</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Surge Tank Crest Level</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getSurgeTankCrestLevel()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EAttribute getHydroPowerPlant_SurgeTankCrestLevel();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getHydroGeneratingUnits <em>Hydro Generating Units</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Hydro Generating Units</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getHydroGeneratingUnits()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EReference getHydroPowerPlant_HydroGeneratingUnits();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getGenSourcePumpDischargeReservoir <em>Gen Source Pump Discharge Reservoir</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Gen Source Pump Discharge Reservoir</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getGenSourcePumpDischargeReservoir()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EReference getHydroPowerPlant_GenSourcePumpDischargeReservoir();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getReservoir <em>Reservoir</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Reservoir</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getReservoir()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EReference getHydroPowerPlant_Reservoir();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getHydroPumps <em>Hydro Pumps</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Hydro Pumps</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPowerPlant#getHydroPumps()
     * @see #getHydroPowerPlant()
     * @generated
     */
    EReference getHydroPowerPlant_HydroPumps();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GrossToNetActivePowerCurve <em>Gross To Net Active Power Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Gross To Net Active Power Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GrossToNetActivePowerCurve
     * @generated
     */
    EClass getGrossToNetActivePowerCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GrossToNetActivePowerCurve#getGeneratingUnit <em>Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GrossToNetActivePowerCurve#getGeneratingUnit()
     * @see #getGrossToNetActivePowerCurve()
     * @generated
     */
    EReference getGrossToNetActivePowerCurve_GeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel <em>Fossil Fuel</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Fossil Fuel</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel
     * @generated
     */
    EClass getFossilFuel();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFossilFuelType <em>Fossil Fuel Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fossil Fuel Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFossilFuelType()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_FossilFuelType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelCost <em>Fuel Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelCost()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_FuelCost();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelDispatchCost <em>Fuel Dispatch Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Dispatch Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelDispatchCost()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_FuelDispatchCost();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelEffFactor <em>Fuel Eff Factor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Eff Factor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelEffFactor()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_FuelEffFactor();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelHandlingCost <em>Fuel Handling Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Handling Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelHandlingCost()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_FuelHandlingCost();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelHeatContent <em>Fuel Heat Content</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Heat Content</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelHeatContent()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_FuelHeatContent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelMixture <em>Fuel Mixture</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Mixture</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelMixture()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_FuelMixture();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelSulfur <em>Fuel Sulfur</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Fuel Sulfur</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelSulfur()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_FuelSulfur();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getHighBreakpointP <em>High Breakpoint P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>High Breakpoint P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getHighBreakpointP()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_HighBreakpointP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getLowBreakpointP <em>Low Breakpoint P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Low Breakpoint P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getLowBreakpointP()
     * @see #getFossilFuel()
     * @generated
     */
    EAttribute getFossilFuel_LowBreakpointP();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelAllocationSchedules <em>Fuel Allocation Schedules</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Fuel Allocation Schedules</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getFuelAllocationSchedules()
     * @see #getFossilFuel()
     * @generated
     */
    EReference getFossilFuel_FuelAllocationSchedules();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FossilFuel#getThermalGeneratingUnit()
     * @see #getFossilFuel()
     * @generated
     */
    EReference getFossilFuel_ThermalGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueSource <em>Measurement Value Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Measurement Value Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueSource
     * @generated
     */
    EClass getMeasurementValueSource();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueSource#getMeasurementValues <em>Measurement Values</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Measurement Values</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MeasurementValueSource#getMeasurementValues()
     * @see #getMeasurementValueSource()
     * @generated
     */
    EReference getMeasurementValueSource_MeasurementValues();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve <em>Shutdown Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Shutdown Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve
     * @generated
     */
    EClass getShutdownCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve#getShutdownCost <em>Shutdown Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shutdown Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve#getShutdownCost()
     * @see #getShutdownCurve()
     * @generated
     */
    EAttribute getShutdownCurve_ShutdownCost();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve#getShutdownDate <em>Shutdown Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Shutdown Date</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve#getShutdownDate()
     * @see #getShutdownCurve()
     * @generated
     */
    EAttribute getShutdownCurve_ShutdownDate();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShutdownCurve#getThermalGeneratingUnit()
     * @see #getShutdownCurve()
     * @generated
     */
    EReference getShutdownCurve_ThermalGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance <em>Transformer Core Admittance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Transformer Core Admittance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance
     * @generated
     */
    EClass getTransformerCoreAdmittance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getB <em>B</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getB()
     * @see #getTransformerCoreAdmittance()
     * @generated
     */
    EAttribute getTransformerCoreAdmittance_B();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getB0 <em>B0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getB0()
     * @see #getTransformerCoreAdmittance()
     * @generated
     */
    EAttribute getTransformerCoreAdmittance_B0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getG <em>G</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getG()
     * @see #getTransformerCoreAdmittance()
     * @generated
     */
    EAttribute getTransformerCoreAdmittance_G();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getG0 <em>G0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getG0()
     * @see #getTransformerCoreAdmittance()
     * @generated
     */
    EAttribute getTransformerCoreAdmittance_G0();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getTransformerEnd <em>Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerCoreAdmittance#getTransformerEnd()
     * @see #getTransformerCoreAdmittance()
     * @generated
     */
    EReference getTransformerCoreAdmittance_TransformerEnd();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer <em>Energy Consumer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Energy Consumer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer
     * @generated
     */
    EClass getEnergyConsumer();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getCustomerCount <em>Customer Count</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Customer Count</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getCustomerCount()
     * @see #getEnergyConsumer()
     * @generated
     */
    EAttribute getEnergyConsumer_CustomerCount();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getGrounded <em>Grounded</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Grounded</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getGrounded()
     * @see #getEnergyConsumer()
     * @generated
     */
    EAttribute getEnergyConsumer_Grounded();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getP <em>P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getP()
     * @see #getEnergyConsumer()
     * @generated
     */
    EAttribute getEnergyConsumer_P();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getPfixed <em>Pfixed</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pfixed</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getPfixed()
     * @see #getEnergyConsumer()
     * @generated
     */
    EAttribute getEnergyConsumer_Pfixed();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getPfixedPct <em>Pfixed Pct</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pfixed Pct</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getPfixedPct()
     * @see #getEnergyConsumer()
     * @generated
     */
    EAttribute getEnergyConsumer_PfixedPct();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getPhaseConnection <em>Phase Connection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Phase Connection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getPhaseConnection()
     * @see #getEnergyConsumer()
     * @generated
     */
    EAttribute getEnergyConsumer_PhaseConnection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getQ <em>Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getQ()
     * @see #getEnergyConsumer()
     * @generated
     */
    EAttribute getEnergyConsumer_Q();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getQfixed <em>Qfixed</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Qfixed</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getQfixed()
     * @see #getEnergyConsumer()
     * @generated
     */
    EAttribute getEnergyConsumer_Qfixed();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getQfixedPct <em>Qfixed Pct</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Qfixed Pct</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getQfixedPct()
     * @see #getEnergyConsumer()
     * @generated
     */
    EAttribute getEnergyConsumer_QfixedPct();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getLoadResponse <em>Load Response</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Load Response</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getLoadResponse()
     * @see #getEnergyConsumer()
     * @generated
     */
    EReference getEnergyConsumer_LoadResponse();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getEnergyConsumerPhase <em>Energy Consumer Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Energy Consumer Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getEnergyConsumerPhase()
     * @see #getEnergyConsumer()
     * @generated
     */
    EReference getEnergyConsumer_EnergyConsumerPhase();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getPowerCutZone <em>Power Cut Zone</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Power Cut Zone</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EnergyConsumer#getPowerCutZone()
     * @see #getEnergyConsumer()
     * @generated
     */
    EReference getEnergyConsumer_PowerCutZone();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarSection <em>Busbar Section</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Busbar Section</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarSection
     * @generated
     */
    EClass getBusbarSection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarSection#getIpMax <em>Ip Max</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ip Max</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarSection#getIpMax()
     * @see #getBusbarSection()
     * @generated
     */
    EAttribute getBusbarSection_IpMax();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarSection#getVoltageControlZone <em>Voltage Control Zone</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Voltage Control Zone</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarSection#getVoltageControlZone()
     * @see #getBusbarSection()
     * @generated
     */
    EReference getBusbarSection_VoltageControlZone();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentContainer <em>Equipment Container</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Equipment Container</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentContainer
     * @generated
     */
    EClass getEquipmentContainer();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentContainer#getEquipments <em>Equipments</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Equipments</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquipmentContainer#getEquipments()
     * @see #getEquipmentContainer()
     * @generated
     */
    EReference getEquipmentContainer_Equipments();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBreaker <em>DC Breaker</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Breaker</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCBreaker
     * @generated
     */
    EClass getDCBreaker();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurementValue <em>String Measurement Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>String Measurement Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurementValue
     * @generated
     */
    EClass getStringMeasurementValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurementValue#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurementValue#getValue()
     * @see #getStringMeasurementValue()
     * @generated
     */
    EAttribute getStringMeasurementValue_Value();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurementValue#getStringMeasurement <em>String Measurement</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>String Measurement</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StringMeasurementValue#getStringMeasurement()
     * @see #getStringMeasurementValue()
     * @generated
     */
    EReference getStringMeasurementValue_StringMeasurement();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RaiseLowerCommand <em>Raise Lower Command</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Raise Lower Command</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RaiseLowerCommand
     * @generated
     */
    EClass getRaiseLowerCommand();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RaiseLowerCommand#getValueAliasSet <em>Value Alias Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Value Alias Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RaiseLowerCommand#getValueAliasSet()
     * @see #getRaiseLowerCommand()
     * @generated
     */
    EReference getRaiseLowerCommand_ValueAliasSet();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapSchedule <em>Tap Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Tap Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapSchedule
     * @generated
     */
    EClass getTapSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapSchedule#getTapChanger <em>Tap Changer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Tap Changer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapSchedule#getTapChanger()
     * @see #getTapSchedule()
     * @generated
     */
    EReference getTapSchedule_TapChanger();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueToAlias <em>Value To Alias</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Value To Alias</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueToAlias
     * @generated
     */
    EClass getValueToAlias();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueToAlias#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueToAlias#getValue()
     * @see #getValueToAlias()
     * @generated
     */
    EAttribute getValueToAlias_Value();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueToAlias#getValueAliasSet <em>Value Alias Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Value Alias Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueToAlias#getValueAliasSet()
     * @see #getValueToAlias()
     * @generated
     */
    EReference getValueToAlias_ValueAliasSet();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectGluePoint <em>Diagram Object Glue Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Diagram Object Glue Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectGluePoint
     * @generated
     */
    EClass getDiagramObjectGluePoint();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectGluePoint#getDiagramObjectPoints <em>Diagram Object Points</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Diagram Object Points</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DiagramObjectGluePoint#getDiagramObjectPoints()
     * @see #getDiagramObjectGluePoint()
     * @generated
     */
    EReference getDiagramObjectGluePoint_DiagramObjectPoints();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch <em>Switch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Switch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch
     * @generated
     */
    EClass getSwitch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getNormalOpen <em>Normal Open</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Open</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getNormalOpen()
     * @see #getSwitch()
     * @generated
     */
    EAttribute getSwitch_NormalOpen();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getOpen <em>Open</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Open</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getOpen()
     * @see #getSwitch()
     * @generated
     */
    EAttribute getSwitch_Open();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getRatedCurrent <em>Rated Current</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Current</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getRatedCurrent()
     * @see #getSwitch()
     * @generated
     */
    EAttribute getSwitch_RatedCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getRetained <em>Retained</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Retained</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getRetained()
     * @see #getSwitch()
     * @generated
     */
    EAttribute getSwitch_Retained();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getSwitchOnCount <em>Switch On Count</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Switch On Count</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getSwitchOnCount()
     * @see #getSwitch()
     * @generated
     */
    EAttribute getSwitch_SwitchOnCount();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getSwitchOnDate <em>Switch On Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Switch On Date</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getSwitchOnDate()
     * @see #getSwitch()
     * @generated
     */
    EAttribute getSwitch_SwitchOnDate();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getCompositeSwitch <em>Composite Switch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Composite Switch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getCompositeSwitch()
     * @see #getSwitch()
     * @generated
     */
    EReference getSwitch_CompositeSwitch();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getSwitchSchedules <em>Switch Schedules</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Switch Schedules</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getSwitchSchedules()
     * @see #getSwitch()
     * @generated
     */
    EReference getSwitch_SwitchSchedules();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getSwitchPhase <em>Switch Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Switch Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Switch#getSwitchPhase()
     * @see #getSwitch()
     * @generated
     */
    EReference getSwitch_SwitchPhase();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker <em>Breaker</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Breaker</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker
     * @generated
     */
    EClass getBreaker();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker#getInTransitTime <em>In Transit Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>In Transit Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Breaker#getInTransitTime()
     * @see #getBreaker()
     * @generated
     */
    EAttribute getBreaker_InTransitTime();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTerminal <em>DC Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTerminal
     * @generated
     */
    EClass getDCTerminal();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTerminal#getDCConductingEquipment <em>DC Conducting Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>DC Conducting Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTerminal#getDCConductingEquipment()
     * @see #getDCTerminal()
     * @generated
     */
    EReference getDCTerminal_DCConductingEquipment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Sectionaliser <em>Sectionaliser</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sectionaliser</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Sectionaliser
     * @generated
     */
    EClass getSectionaliser();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection <em>Sv Injection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sv Injection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection
     * @generated
     */
    EClass getSvInjection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection#getPInjection <em>PInjection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PInjection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection#getPInjection()
     * @see #getSvInjection()
     * @generated
     */
    EAttribute getSvInjection_PInjection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection#getQInjection <em>QInjection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QInjection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection#getQInjection()
     * @see #getSvInjection()
     * @generated
     */
    EAttribute getSvInjection_QInjection();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection#getTopologicalNode <em>Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvInjection#getTopologicalNode()
     * @see #getSvInjection()
     * @generated
     */
    EReference getSvInjection_TopologicalNode();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpSchedule <em>Gen Unit Op Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Gen Unit Op Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpSchedule
     * @generated
     */
    EClass getGenUnitOpSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpSchedule#getGeneratingUnit <em>Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GenUnitOpSchedule#getGeneratingUnit()
     * @see #getGenUnitOpSchedule()
     * @generated
     */
    EReference getGenUnitOpSchedule_GeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd <em>Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd
     * @generated
     */
    EClass getTransformerEnd();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getBmagSat <em>Bmag Sat</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Bmag Sat</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getBmagSat()
     * @see #getTransformerEnd()
     * @generated
     */
    EAttribute getTransformerEnd_BmagSat();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getEndNumber <em>End Number</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>End Number</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getEndNumber()
     * @see #getTransformerEnd()
     * @generated
     */
    EAttribute getTransformerEnd_EndNumber();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getGrounded <em>Grounded</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Grounded</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getGrounded()
     * @see #getTransformerEnd()
     * @generated
     */
    EAttribute getTransformerEnd_Grounded();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getMagBaseU <em>Mag Base U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Mag Base U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getMagBaseU()
     * @see #getTransformerEnd()
     * @generated
     */
    EAttribute getTransformerEnd_MagBaseU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getMagSatFlux <em>Mag Sat Flux</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Mag Sat Flux</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getMagSatFlux()
     * @see #getTransformerEnd()
     * @generated
     */
    EAttribute getTransformerEnd_MagSatFlux();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getRground <em>Rground</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rground</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getRground()
     * @see #getTransformerEnd()
     * @generated
     */
    EAttribute getTransformerEnd_Rground();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getXground <em>Xground</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xground</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getXground()
     * @see #getTransformerEnd()
     * @generated
     */
    EAttribute getTransformerEnd_Xground();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getCoreAdmittance <em>Core Admittance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Core Admittance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getCoreAdmittance()
     * @see #getTransformerEnd()
     * @generated
     */
    EReference getTransformerEnd_CoreAdmittance();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getPhaseTapChanger <em>Phase Tap Changer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Phase Tap Changer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getPhaseTapChanger()
     * @see #getTransformerEnd()
     * @generated
     */
    EReference getTransformerEnd_PhaseTapChanger();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getRatioTapChanger <em>Ratio Tap Changer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Ratio Tap Changer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getRatioTapChanger()
     * @see #getTransformerEnd()
     * @generated
     */
    EReference getTransformerEnd_RatioTapChanger();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getToMeshImpedance <em>To Mesh Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>To Mesh Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getToMeshImpedance()
     * @see #getTransformerEnd()
     * @generated
     */
    EReference getTransformerEnd_ToMeshImpedance();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getBaseVoltage <em>Base Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getBaseVoltage()
     * @see #getTransformerEnd()
     * @generated
     */
    EReference getTransformerEnd_BaseVoltage();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getStarImpedance <em>Star Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Star Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getStarImpedance()
     * @see #getTransformerEnd()
     * @generated
     */
    EReference getTransformerEnd_StarImpedance();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getFromMeshImpedance <em>From Mesh Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>From Mesh Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getFromMeshImpedance()
     * @see #getTransformerEnd()
     * @generated
     */
    EReference getTransformerEnd_FromMeshImpedance();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerEnd#getTerminal()
     * @see #getTransformerEnd()
     * @generated
     */
    EReference getTransformerEnd_Terminal();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadGroup <em>Load Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Load Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadGroup
     * @generated
     */
    EClass getLoadGroup();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadGroup#getSubLoadArea <em>Sub Load Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Sub Load Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadGroup#getSubLoadArea()
     * @see #getLoadGroup()
     * @generated
     */
    EReference getLoadGroup_SubLoadArea();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl <em>Analog Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Analog Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl
     * @generated
     */
    EClass getAnalogControl();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl#getMaxValue <em>Max Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl#getMaxValue()
     * @see #getAnalogControl()
     * @generated
     */
    EAttribute getAnalogControl_MaxValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl#getMinValue <em>Min Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl#getMinValue()
     * @see #getAnalogControl()
     * @generated
     */
    EAttribute getAnalogControl_MinValue();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl#getAnalogValue <em>Analog Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Analog Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AnalogControl#getAnalogValue()
     * @see #getAnalogControl()
     * @generated
     */
    EReference getAnalogControl_AnalogValue();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterUnit <em>DC Converter Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Converter Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterUnit
     * @generated
     */
    EClass getDCConverterUnit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterUnit#getOperationMode <em>Operation Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Operation Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterUnit#getOperationMode()
     * @see #getDCConverterUnit()
     * @generated
     */
    EAttribute getDCConverterUnit_OperationMode();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterUnit#getSubstation <em>Substation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Substation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterUnit#getSubstation()
     * @see #getDCConverterUnit()
     * @generated
     */
    EReference getDCConverterUnit_Substation();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger <em>Tap Changer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Tap Changer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger
     * @generated
     */
    EClass getTapChanger();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getControlEnabled <em>Control Enabled</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control Enabled</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getControlEnabled()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_ControlEnabled();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getHighStep <em>High Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>High Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getHighStep()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_HighStep();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getInitialDelay <em>Initial Delay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Initial Delay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getInitialDelay()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_InitialDelay();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getLowStep <em>Low Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Low Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getLowStep()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_LowStep();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getLtcFlag <em>Ltc Flag</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ltc Flag</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getLtcFlag()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_LtcFlag();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getNeutralStep <em>Neutral Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Neutral Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getNeutralStep()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_NeutralStep();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getNeutralU <em>Neutral U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Neutral U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getNeutralU()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_NeutralU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getNormalStep <em>Normal Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getNormalStep()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_NormalStep();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getStep <em>Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getStep()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_Step();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getSubsequentDelay <em>Subsequent Delay</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Subsequent Delay</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getSubsequentDelay()
     * @see #getTapChanger()
     * @generated
     */
    EAttribute getTapChanger_SubsequentDelay();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getTapChangerControl <em>Tap Changer Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Tap Changer Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getTapChangerControl()
     * @see #getTapChanger()
     * @generated
     */
    EReference getTapChanger_TapChangerControl();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getTapSchedules <em>Tap Schedules</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Tap Schedules</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getTapSchedules()
     * @see #getTapChanger()
     * @generated
     */
    EReference getTapChanger_TapSchedules();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getSvTapStep <em>Sv Tap Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Sv Tap Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChanger#getSvTapStep()
     * @see #getTapChanger()
     * @generated
     */
    EReference getTapChanger_SvTapStep();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter <em>Cs Converter</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Cs Converter</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter
     * @generated
     */
    EClass getCsConverter();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getAlpha <em>Alpha</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Alpha</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getAlpha()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_Alpha();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getGamma <em>Gamma</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Gamma</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getGamma()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_Gamma();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMaxAlpha <em>Max Alpha</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Alpha</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMaxAlpha()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_MaxAlpha();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMaxGamma <em>Max Gamma</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Gamma</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMaxGamma()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_MaxGamma();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMaxIdc <em>Max Idc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Idc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMaxIdc()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_MaxIdc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMinAlpha <em>Min Alpha</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Alpha</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMinAlpha()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_MinAlpha();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMinGamma <em>Min Gamma</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Gamma</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMinGamma()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_MinGamma();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMinIdc <em>Min Idc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Idc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getMinIdc()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_MinIdc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getOperatingMode <em>Operating Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Operating Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getOperatingMode()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_OperatingMode();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getPPccControl <em>PPcc Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PPcc Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getPPccControl()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_PPccControl();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getRatedIdc <em>Rated Idc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Idc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getRatedIdc()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_RatedIdc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getTargetAlpha <em>Target Alpha</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Alpha</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getTargetAlpha()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_TargetAlpha();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getTargetGamma <em>Target Gamma</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Gamma</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getTargetGamma()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_TargetGamma();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getTargetIdc <em>Target Idc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Idc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsConverter#getTargetIdc()
     * @see #getCsConverter()
     * @generated
     */
    EAttribute getCsConverter_TargetIdc();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet <em>Value Alias Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Value Alias Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet
     * @generated
     */
    EClass getValueAliasSet();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet#getDiscretes <em>Discretes</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Discretes</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet#getDiscretes()
     * @see #getValueAliasSet()
     * @generated
     */
    EReference getValueAliasSet_Discretes();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet#getValues <em>Values</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Values</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet#getValues()
     * @see #getValueAliasSet()
     * @generated
     */
    EReference getValueAliasSet_Values();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet#getRaiseLowerCommands <em>Raise Lower Commands</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Raise Lower Commands</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet#getRaiseLowerCommands()
     * @see #getValueAliasSet()
     * @generated
     */
    EReference getValueAliasSet_RaiseLowerCommands();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet#getCommands <em>Commands</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Commands</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ValueAliasSet#getCommands()
     * @see #getValueAliasSet()
     * @generated
     */
    EReference getValueAliasSet_Commands();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice <em>DC Series Device</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Series Device</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice
     * @generated
     */
    EClass getDCSeriesDevice();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice#getInductance <em>Inductance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Inductance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice#getInductance()
     * @see #getDCSeriesDevice()
     * @generated
     */
    EAttribute getDCSeriesDevice_Inductance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice#getRatedUdc <em>Rated Udc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Udc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice#getRatedUdc()
     * @see #getDCSeriesDevice()
     * @generated
     */
    EAttribute getDCSeriesDevice_RatedUdc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice#getResistance <em>Resistance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Resistance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCSeriesDevice#getResistance()
     * @see #getDCSeriesDevice()
     * @generated
     */
    EAttribute getDCSeriesDevice_Resistance();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WaveTrap <em>Wave Trap</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Wave Trap</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WaveTrap
     * @generated
     */
    EClass getWaveTrap();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name <em>Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Name</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name
     * @generated
     */
    EClass getName_();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name#getName <em>Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Name</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name#getName()
     * @see #getName_()
     * @generated
     */
    EAttribute getName_Name();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name#getNameType <em>Name Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Name Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name#getNameType()
     * @see #getName_()
     * @generated
     */
    EReference getName_NameType();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name#getIdentifiedObject <em>Identified Object</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Identified Object</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Name#getIdentifiedObject()
     * @see #getName_()
     * @generated
     */
    EReference getName_IdentifiedObject();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea <em>Control Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Control Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea
     * @generated
     */
    EClass getControlArea();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getNetInterchange <em>Net Interchange</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Net Interchange</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getNetInterchange()
     * @see #getControlArea()
     * @generated
     */
    EAttribute getControlArea_NetInterchange();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getPTolerance <em>PTolerance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PTolerance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getPTolerance()
     * @see #getControlArea()
     * @generated
     */
    EAttribute getControlArea_PTolerance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getType <em>Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getType()
     * @see #getControlArea()
     * @generated
     */
    EAttribute getControlArea_Type();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getTieFlow <em>Tie Flow</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Tie Flow</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getTieFlow()
     * @see #getControlArea()
     * @generated
     */
    EReference getControlArea_TieFlow();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getControlAreaGeneratingUnit <em>Control Area Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Control Area Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getControlAreaGeneratingUnit()
     * @see #getControlArea()
     * @generated
     */
    EReference getControlArea_ControlAreaGeneratingUnit();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getEnergyArea <em>Energy Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Energy Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlArea#getEnergyArea()
     * @see #getControlArea()
     * @generated
     */
    EReference getControlArea_EnergyArea();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection <em>Equivalent Injection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Equivalent Injection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection
     * @generated
     */
    EClass getEquivalentInjection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getMaxP <em>Max P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getMaxP()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_MaxP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getMaxQ <em>Max Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getMaxQ()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_MaxQ();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getMinP <em>Min P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getMinP()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_MinP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getMinQ <em>Min Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getMinQ()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_MinQ();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getP <em>P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getP()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_P();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getQ <em>Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getQ()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_Q();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getR()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getR0()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getR2 <em>R2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getR2()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_R2();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getRegulationCapability <em>Regulation Capability</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Regulation Capability</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getRegulationCapability()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_RegulationCapability();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getRegulationStatus <em>Regulation Status</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Regulation Status</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getRegulationStatus()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_RegulationStatus();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getRegulationTarget <em>Regulation Target</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Regulation Target</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getRegulationTarget()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_RegulationTarget();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getX()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getX0()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_X0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getX2 <em>X2</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X2</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getX2()
     * @see #getEquivalentInjection()
     * @generated
     */
    EAttribute getEquivalentInjection_X2();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getReactiveCapabilityCurve <em>Reactive Capability Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Reactive Capability Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentInjection#getReactiveCapabilityCurve()
     * @see #getEquivalentInjection()
     * @generated
     */
    EReference getEquivalentInjection_ReactiveCapabilityCurve();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode <em>DC Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode
     * @generated
     */
    EClass getDCTopologicalNode();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode#getDCTopologicalIsland <em>DC Topological Island</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>DC Topological Island</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode#getDCTopologicalIsland()
     * @see #getDCTopologicalNode()
     * @generated
     */
    EReference getDCTopologicalNode_DCTopologicalIsland();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode#getDCNodes <em>DC Nodes</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Nodes</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode#getDCNodes()
     * @see #getDCTopologicalNode()
     * @generated
     */
    EReference getDCTopologicalNode_DCNodes();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode#getDCEquipmentContainer <em>DC Equipment Container</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>DC Equipment Container</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode#getDCEquipmentContainer()
     * @see #getDCTopologicalNode()
     * @generated
     */
    EReference getDCTopologicalNode_DCEquipmentContainer();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode#getDCTerminals <em>DC Terminals</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Terminals</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalNode#getDCTerminals()
     * @see #getDCTopologicalNode()
     * @generated
     */
    EReference getDCTopologicalNode_DCTerminals();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCChopper <em>DC Chopper</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Chopper</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCChopper
     * @generated
     */
    EClass getDCChopper();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance <em>Per Length Sequence Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Per Length Sequence Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance
     * @generated
     */
    EClass getPerLengthSequenceImpedance();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getB0ch <em>B0ch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B0ch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getB0ch()
     * @see #getPerLengthSequenceImpedance()
     * @generated
     */
    EAttribute getPerLengthSequenceImpedance_B0ch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getBch <em>Bch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Bch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getBch()
     * @see #getPerLengthSequenceImpedance()
     * @generated
     */
    EAttribute getPerLengthSequenceImpedance_Bch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getG0ch <em>G0ch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G0ch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getG0ch()
     * @see #getPerLengthSequenceImpedance()
     * @generated
     */
    EAttribute getPerLengthSequenceImpedance_G0ch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getGch <em>Gch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Gch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getGch()
     * @see #getPerLengthSequenceImpedance()
     * @generated
     */
    EAttribute getPerLengthSequenceImpedance_Gch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getR()
     * @see #getPerLengthSequenceImpedance()
     * @generated
     */
    EAttribute getPerLengthSequenceImpedance_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getR0()
     * @see #getPerLengthSequenceImpedance()
     * @generated
     */
    EAttribute getPerLengthSequenceImpedance_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getX()
     * @see #getPerLengthSequenceImpedance()
     * @generated
     */
    EAttribute getPerLengthSequenceImpedance_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthSequenceImpedance#getX0()
     * @see #getPerLengthSequenceImpedance()
     * @generated
     */
    EAttribute getPerLengthSequenceImpedance_X0();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartRampCurve <em>Start Ramp Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Start Ramp Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartRampCurve
     * @generated
     */
    EClass getStartRampCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartRampCurve#getHotStandbyRamp <em>Hot Standby Ramp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Hot Standby Ramp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartRampCurve#getHotStandbyRamp()
     * @see #getStartRampCurve()
     * @generated
     */
    EAttribute getStartRampCurve_HotStandbyRamp();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartRampCurve#getStartupModel <em>Startup Model</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Startup Model</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StartRampCurve#getStartupModel()
     * @see #getStartRampCurve()
     * @generated
     */
    EReference getStartRampCurve_StartupModel();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter <em>ACDC Converter</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>ACDC Converter</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter
     * @generated
     */
    EClass getACDCConverter();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getBaseS <em>Base S</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Base S</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getBaseS()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_BaseS();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getIdc <em>Idc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Idc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getIdc()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_Idc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getIdleLoss <em>Idle Loss</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Idle Loss</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getIdleLoss()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_IdleLoss();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getMaxUdc <em>Max Udc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Udc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getMaxUdc()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_MaxUdc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getMinUdc <em>Min Udc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Udc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getMinUdc()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_MinUdc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getNumberOfValves <em>Number Of Valves</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Number Of Valves</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getNumberOfValves()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_NumberOfValves();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getP <em>P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getP()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_P();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getPoleLossP <em>Pole Loss P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pole Loss P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getPoleLossP()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_PoleLossP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getQ <em>Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getQ()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_Q();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getRatedUdc <em>Rated Udc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Udc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getRatedUdc()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_RatedUdc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getResistiveLoss <em>Resistive Loss</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Resistive Loss</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getResistiveLoss()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_ResistiveLoss();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getSwitchingLoss <em>Switching Loss</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Switching Loss</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getSwitchingLoss()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_SwitchingLoss();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getTargetPpcc <em>Target Ppcc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Ppcc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getTargetPpcc()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_TargetPpcc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getTargetUdc <em>Target Udc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Udc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getTargetUdc()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_TargetUdc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getUc <em>Uc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Uc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getUc()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_Uc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getUdc <em>Udc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Udc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getUdc()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_Udc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getValveU0 <em>Valve U0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Valve U0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getValveU0()
     * @see #getACDCConverter()
     * @generated
     */
    EAttribute getACDCConverter_ValveU0();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getPccTerminal <em>Pcc Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Pcc Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getPccTerminal()
     * @see #getACDCConverter()
     * @generated
     */
    EReference getACDCConverter_PccTerminal();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getDCTerminals <em>DC Terminals</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Terminals</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ACDCConverter#getDCTerminals()
     * @see #getACDCConverter()
     * @generated
     */
    EReference getACDCConverter_DCTerminals();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer <em>Power Transformer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Power Transformer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer
     * @generated
     */
    EClass getPowerTransformer();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getBeforeShCircuitHighestOperatingCurrent <em>Before Sh Circuit Highest Operating Current</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Before Sh Circuit Highest Operating Current</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getBeforeShCircuitHighestOperatingCurrent()
     * @see #getPowerTransformer()
     * @generated
     */
    EAttribute getPowerTransformer_BeforeShCircuitHighestOperatingCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getBeforeShCircuitHighestOperatingVoltage <em>Before Sh Circuit Highest Operating Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Before Sh Circuit Highest Operating Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getBeforeShCircuitHighestOperatingVoltage()
     * @see #getPowerTransformer()
     * @generated
     */
    EAttribute getPowerTransformer_BeforeShCircuitHighestOperatingVoltage();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getBeforeShortCircuitAnglePf <em>Before Short Circuit Angle Pf</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Before Short Circuit Angle Pf</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getBeforeShortCircuitAnglePf()
     * @see #getPowerTransformer()
     * @generated
     */
    EAttribute getPowerTransformer_BeforeShortCircuitAnglePf();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getHighSideMinOperatingU <em>High Side Min Operating U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>High Side Min Operating U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getHighSideMinOperatingU()
     * @see #getPowerTransformer()
     * @generated
     */
    EAttribute getPowerTransformer_HighSideMinOperatingU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getIsPartOfGeneratorUnit <em>Is Part Of Generator Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Part Of Generator Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getIsPartOfGeneratorUnit()
     * @see #getPowerTransformer()
     * @generated
     */
    EAttribute getPowerTransformer_IsPartOfGeneratorUnit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getOperationalValuesConsidered <em>Operational Values Considered</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Operational Values Considered</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getOperationalValuesConsidered()
     * @see #getPowerTransformer()
     * @generated
     */
    EAttribute getPowerTransformer_OperationalValuesConsidered();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getVectorGroup <em>Vector Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Vector Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getVectorGroup()
     * @see #getPowerTransformer()
     * @generated
     */
    EAttribute getPowerTransformer_VectorGroup();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getTransformerTanks <em>Transformer Tanks</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Transformer Tanks</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getTransformerTanks()
     * @see #getPowerTransformer()
     * @generated
     */
    EReference getPowerTransformer_TransformerTanks();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getPowerTransformerEnd <em>Power Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Power Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerTransformer#getPowerTransformerEnd()
     * @see #getPowerTransformer()
     * @generated
     */
    EReference getPowerTransformer_PowerTransformerEnd();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ActivePowerLimit <em>Active Power Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Active Power Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ActivePowerLimit
     * @generated
     */
    EClass getActivePowerLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ActivePowerLimit#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ActivePowerLimit#getValue()
     * @see #getActivePowerLimit()
     * @generated
     */
    EAttribute getActivePowerLimit_Value();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount <em>Emission Account</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Emission Account</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount
     * @generated
     */
    EClass getEmissionAccount();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount#getEmissionType <em>Emission Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Emission Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount#getEmissionType()
     * @see #getEmissionAccount()
     * @generated
     */
    EAttribute getEmissionAccount_EmissionType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount#getEmissionValueSource <em>Emission Value Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Emission Value Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount#getEmissionValueSource()
     * @see #getEmissionAccount()
     * @generated
     */
    EAttribute getEmissionAccount_EmissionValueSource();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionAccount#getThermalGeneratingUnit()
     * @see #getEmissionAccount()
     * @generated
     */
    EReference getEmissionAccount_ThermalGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve <em>Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve
     * @generated
     */
    EClass getCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getCurveStyle <em>Curve Style</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Curve Style</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getCurveStyle()
     * @see #getCurve()
     * @generated
     */
    EAttribute getCurve_CurveStyle();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getXMultiplier <em>XMultiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XMultiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getXMultiplier()
     * @see #getCurve()
     * @generated
     */
    EAttribute getCurve_XMultiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getXUnit <em>XUnit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XUnit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getXUnit()
     * @see #getCurve()
     * @generated
     */
    EAttribute getCurve_XUnit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY1Multiplier <em>Y1 Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y1 Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY1Multiplier()
     * @see #getCurve()
     * @generated
     */
    EAttribute getCurve_Y1Multiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY1Unit <em>Y1 Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y1 Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY1Unit()
     * @see #getCurve()
     * @generated
     */
    EAttribute getCurve_Y1Unit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY2Multiplier <em>Y2 Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y2 Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY2Multiplier()
     * @see #getCurve()
     * @generated
     */
    EAttribute getCurve_Y2Multiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY2Unit <em>Y2 Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y2 Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY2Unit()
     * @see #getCurve()
     * @generated
     */
    EAttribute getCurve_Y2Unit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY3Multiplier <em>Y3 Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y3 Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY3Multiplier()
     * @see #getCurve()
     * @generated
     */
    EAttribute getCurve_Y3Multiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY3Unit <em>Y3 Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Y3 Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getY3Unit()
     * @see #getCurve()
     * @generated
     */
    EAttribute getCurve_Y3Unit();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getCurveDatas <em>Curve Datas</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Curve Datas</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Curve#getCurveDatas()
     * @see #getCurve()
     * @generated
     */
    EReference getCurve_CurveDatas();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection <em>Power Electronics Connection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Power Electronics Connection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection
     * @generated
     */
    EClass getPowerElectronicsConnection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getMaxQ <em>Max Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getMaxQ()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_MaxQ();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getMinQ <em>Min Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getMinQ()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_MinQ();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getP <em>P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getP()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_P();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getQ <em>Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getQ()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_Q();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getR()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getR0()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getRatedS <em>Rated S</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated S</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getRatedS()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_RatedS();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getRatedU <em>Rated U</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated U</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getRatedU()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_RatedU();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getRn <em>Rn</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rn</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getRn()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_Rn();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getX()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getX0()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_X0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getXn <em>Xn</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Xn</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getXn()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EAttribute getPowerElectronicsConnection_Xn();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getPowerElectronicsUnit <em>Power Electronics Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Power Electronics Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PowerElectronicsConnection#getPowerElectronicsUnit()
     * @see #getPowerElectronicsConnection()
     * @generated
     */
    EReference getPowerElectronicsConnection_PowerElectronicsUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LevelVsVolumeCurve <em>Level Vs Volume Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Level Vs Volume Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LevelVsVolumeCurve
     * @generated
     */
    EClass getLevelVsVolumeCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LevelVsVolumeCurve#getReservoir <em>Reservoir</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Reservoir</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LevelVsVolumeCurve#getReservoir()
     * @see #getLevelVsVolumeCurve()
     * @generated
     */
    EReference getLevelVsVolumeCurve_Reservoir();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger <em>Ratio Tap Changer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Ratio Tap Changer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger
     * @generated
     */
    EClass getRatioTapChanger();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger#getStepVoltageIncrement <em>Step Voltage Increment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Step Voltage Increment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger#getStepVoltageIncrement()
     * @see #getRatioTapChanger()
     * @generated
     */
    EAttribute getRatioTapChanger_StepVoltageIncrement();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger#getTculControlMode <em>Tcul Control Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Tcul Control Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger#getTculControlMode()
     * @see #getRatioTapChanger()
     * @generated
     */
    EAttribute getRatioTapChanger_TculControlMode();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger#getTransformerEnd <em>Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger#getTransformerEnd()
     * @see #getRatioTapChanger()
     * @generated
     */
    EReference getRatioTapChanger_TransformerEnd();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger#getRatioTapChangerTable <em>Ratio Tap Changer Table</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Ratio Tap Changer Table</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RatioTapChanger#getRatioTapChangerTable()
     * @see #getRatioTapChanger()
     * @generated
     */
    EReference getRatioTapChanger_RatioTapChangerTable();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit <em>Hydro Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Hydro Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit
     * @generated
     */
    EClass getHydroGeneratingUnit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getEnergyConversionCapability <em>Energy Conversion Capability</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Energy Conversion Capability</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getEnergyConversionCapability()
     * @see #getHydroGeneratingUnit()
     * @generated
     */
    EAttribute getHydroGeneratingUnit_EnergyConversionCapability();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getHydroUnitWaterCost <em>Hydro Unit Water Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Hydro Unit Water Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getHydroUnitWaterCost()
     * @see #getHydroGeneratingUnit()
     * @generated
     */
    EAttribute getHydroGeneratingUnit_HydroUnitWaterCost();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getHydroPowerPlant <em>Hydro Power Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Hydro Power Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getHydroPowerPlant()
     * @see #getHydroGeneratingUnit()
     * @generated
     */
    EReference getHydroGeneratingUnit_HydroPowerPlant();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getHydroGeneratingEfficiencyCurves <em>Hydro Generating Efficiency Curves</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Hydro Generating Efficiency Curves</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getHydroGeneratingEfficiencyCurves()
     * @see #getHydroGeneratingUnit()
     * @generated
     */
    EReference getHydroGeneratingUnit_HydroGeneratingEfficiencyCurves();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getPenstockLossCurve <em>Penstock Loss Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Penstock Loss Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getPenstockLossCurve()
     * @see #getHydroGeneratingUnit()
     * @generated
     */
    EReference getHydroGeneratingUnit_PenstockLossCurve();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getTailbayLossCurve <em>Tailbay Loss Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Tailbay Loss Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroGeneratingUnit#getTailbayLossCurve()
     * @see #getHydroGeneratingUnit()
     * @generated
     */
    EReference getHydroGeneratingUnit_TailbayLossCurve();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingParticipant <em>Operating Participant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Operating Participant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingParticipant
     * @generated
     */
    EClass getOperatingParticipant();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingParticipant#getOperatingShare <em>Operating Share</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Operating Share</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingParticipant#getOperatingShare()
     * @see #getOperatingParticipant()
     * @generated
     */
    EReference getOperatingParticipant_OperatingShare();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthImpedance <em>Per Length Impedance</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Per Length Impedance</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthImpedance
     * @generated
     */
    EClass getPerLengthImpedance();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthImpedance#getACLineSegments <em>AC Line Segments</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>AC Line Segments</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthImpedance#getACLineSegments()
     * @see #getPerLengthImpedance()
     * @generated
     */
    EReference getPerLengthImpedance_ACLineSegments();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage <em>Base Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Base Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage
     * @generated
     */
    EClass getBaseVoltage();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getNominalVoltage <em>Nominal Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Nominal Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getNominalVoltage()
     * @see #getBaseVoltage()
     * @generated
     */
    EAttribute getBaseVoltage_NominalVoltage();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getConductingEquipment <em>Conducting Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Conducting Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getConductingEquipment()
     * @see #getBaseVoltage()
     * @generated
     */
    EReference getBaseVoltage_ConductingEquipment();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getVoltageLevel <em>Voltage Level</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Voltage Level</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getVoltageLevel()
     * @see #getBaseVoltage()
     * @generated
     */
    EReference getBaseVoltage_VoltageLevel();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getTransformerEnds <em>Transformer Ends</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Transformer Ends</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getTransformerEnds()
     * @see #getBaseVoltage()
     * @generated
     */
    EReference getBaseVoltage_TransformerEnds();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getTopologicalNode <em>Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BaseVoltage#getTopologicalNode()
     * @see #getBaseVoltage()
     * @generated
     */
    EReference getBaseVoltage_TopologicalNode();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season <em>Season</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Season</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season
     * @generated
     */
    EClass getSeason();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season#getEndDate <em>End Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>End Date</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season#getEndDate()
     * @see #getSeason()
     * @generated
     */
    EAttribute getSeason_EndDate();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season#getStartDate <em>Start Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Start Date</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season#getStartDate()
     * @see #getSeason()
     * @generated
     */
    EAttribute getSeason_StartDate();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season#getSeasonDayTypeSchedules <em>Season Day Type Schedules</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Season Day Type Schedules</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Season#getSeasonDayTypeSchedules()
     * @see #getSeason()
     * @generated
     */
    EReference getSeason_SeasonDayTypeSchedules();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadArea <em>Load Area</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Load Area</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadArea
     * @generated
     */
    EClass getLoadArea();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadArea#getSubLoadAreas <em>Sub Load Areas</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Sub Load Areas</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadArea#getSubLoadAreas()
     * @see #getLoadArea()
     * @generated
     */
    EReference getLoadArea_SubLoadAreas();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipment <em>Contingency Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Contingency Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipment
     * @generated
     */
    EClass getContingencyEquipment();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipment#getContingentStatus <em>Contingent Status</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Contingent Status</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipment#getContingentStatus()
     * @see #getContingencyEquipment()
     * @generated
     */
    EAttribute getContingencyEquipment_ContingentStatus();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipment#getEquipment <em>Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipment#getEquipment()
     * @see #getContingencyEquipment()
     * @generated
     */
    EReference getContingencyEquipment_Equipment();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine <em>Combustion Turbine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Combustion Turbine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine
     * @generated
     */
    EClass getCombustionTurbine();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getAmbientTemp <em>Ambient Temp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ambient Temp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getAmbientTemp()
     * @see #getCombustionTurbine()
     * @generated
     */
    EAttribute getCombustionTurbine_AmbientTemp();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getAuxPowerVersusFrequency <em>Aux Power Versus Frequency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Aux Power Versus Frequency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getAuxPowerVersusFrequency()
     * @see #getCombustionTurbine()
     * @generated
     */
    EAttribute getCombustionTurbine_AuxPowerVersusFrequency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getAuxPowerVersusVoltage <em>Aux Power Versus Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Aux Power Versus Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getAuxPowerVersusVoltage()
     * @see #getCombustionTurbine()
     * @generated
     */
    EAttribute getCombustionTurbine_AuxPowerVersusVoltage();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getCapabilityVersusFrequency <em>Capability Versus Frequency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Capability Versus Frequency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getCapabilityVersusFrequency()
     * @see #getCombustionTurbine()
     * @generated
     */
    EAttribute getCombustionTurbine_CapabilityVersusFrequency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getHeatRecoveryFlag <em>Heat Recovery Flag</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Heat Recovery Flag</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getHeatRecoveryFlag()
     * @see #getCombustionTurbine()
     * @generated
     */
    EAttribute getCombustionTurbine_HeatRecoveryFlag();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getPowerVariationByTemp <em>Power Variation By Temp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Power Variation By Temp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getPowerVariationByTemp()
     * @see #getCombustionTurbine()
     * @generated
     */
    EAttribute getCombustionTurbine_PowerVariationByTemp();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getReferenceTemp <em>Reference Temp</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reference Temp</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getReferenceTemp()
     * @see #getCombustionTurbine()
     * @generated
     */
    EAttribute getCombustionTurbine_ReferenceTemp();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getTimeConstant <em>Time Constant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Time Constant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getTimeConstant()
     * @see #getCombustionTurbine()
     * @generated
     */
    EAttribute getCombustionTurbine_TimeConstant();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getCTTempActivePowerCurve <em>CT Temp Active Power Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>CT Temp Active Power Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getCTTempActivePowerCurve()
     * @see #getCombustionTurbine()
     * @generated
     */
    EReference getCombustionTurbine_CTTempActivePowerCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getAirCompressor <em>Air Compressor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Air Compressor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getAirCompressor()
     * @see #getCombustionTurbine()
     * @generated
     */
    EReference getCombustionTurbine_AirCompressor();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getHeatRecoveryBoiler <em>Heat Recovery Boiler</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Heat Recovery Boiler</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CombustionTurbine#getHeatRecoveryBoiler()
     * @see #getCombustionTurbine()
     * @generated
     */
    EReference getCombustionTurbine_HeatRecoveryBoiler();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeographicalRegion <em>Geographical Region</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Geographical Region</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeographicalRegion
     * @generated
     */
    EClass getGeographicalRegion();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeographicalRegion#getRegions <em>Regions</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Regions</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeographicalRegion#getRegions()
     * @see #getGeographicalRegion()
     * @generated
     */
    EReference getGeographicalRegion_Regions();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule <em>Basic Interval Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Basic Interval Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule
     * @generated
     */
    EClass getBasicIntervalSchedule();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getStartTime <em>Start Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Start Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getStartTime()
     * @see #getBasicIntervalSchedule()
     * @generated
     */
    EAttribute getBasicIntervalSchedule_StartTime();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getValue1Multiplier <em>Value1 Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value1 Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getValue1Multiplier()
     * @see #getBasicIntervalSchedule()
     * @generated
     */
    EAttribute getBasicIntervalSchedule_Value1Multiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getValue1Unit <em>Value1 Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value1 Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getValue1Unit()
     * @see #getBasicIntervalSchedule()
     * @generated
     */
    EAttribute getBasicIntervalSchedule_Value1Unit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getValue2Multiplier <em>Value2 Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value2 Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getValue2Multiplier()
     * @see #getBasicIntervalSchedule()
     * @generated
     */
    EAttribute getBasicIntervalSchedule_Value2Multiplier();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getValue2Unit <em>Value2 Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value2 Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BasicIntervalSchedule#getValue2Unit()
     * @see #getBasicIntervalSchedule()
     * @generated
     */
    EAttribute getBasicIntervalSchedule_Value2Unit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCDisconnector <em>DC Disconnector</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Disconnector</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCDisconnector
     * @generated
     */
    EClass getDCDisconnector();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant <em>Cogeneration Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Cogeneration Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant
     * @generated
     */
    EClass getCogenerationPlant();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getCogenHPSendoutRating <em>Cogen HP Sendout Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cogen HP Sendout Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getCogenHPSendoutRating()
     * @see #getCogenerationPlant()
     * @generated
     */
    EAttribute getCogenerationPlant_CogenHPSendoutRating();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getCogenHPSteamRating <em>Cogen HP Steam Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cogen HP Steam Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getCogenHPSteamRating()
     * @see #getCogenerationPlant()
     * @generated
     */
    EAttribute getCogenerationPlant_CogenHPSteamRating();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getCogenLPSendoutRating <em>Cogen LP Sendout Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cogen LP Sendout Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getCogenLPSendoutRating()
     * @see #getCogenerationPlant()
     * @generated
     */
    EAttribute getCogenerationPlant_CogenLPSendoutRating();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getCogenLPSteamRating <em>Cogen LP Steam Rating</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Cogen LP Steam Rating</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getCogenLPSteamRating()
     * @see #getCogenerationPlant()
     * @generated
     */
    EAttribute getCogenerationPlant_CogenLPSteamRating();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getRatedP <em>Rated P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getRatedP()
     * @see #getCogenerationPlant()
     * @generated
     */
    EAttribute getCogenerationPlant_RatedP();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getThermalGeneratingUnits <em>Thermal Generating Units</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Thermal Generating Units</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getThermalGeneratingUnits()
     * @see #getCogenerationPlant()
     * @generated
     */
    EReference getCogenerationPlant_ThermalGeneratingUnits();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getSteamSendoutSchedule <em>Steam Sendout Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Steam Sendout Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CogenerationPlant#getSteamSendoutSchedule()
     * @see #getCogenerationPlant()
     * @generated
     */
    EReference getCogenerationPlant_SteamSendoutSchedule();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear <em>Phase Tap Changer Non Linear</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Phase Tap Changer Non Linear</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear
     * @generated
     */
    EClass getPhaseTapChangerNonLinear();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear#getVoltageStepIncrement <em>Voltage Step Increment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Voltage Step Increment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear#getVoltageStepIncrement()
     * @see #getPhaseTapChangerNonLinear()
     * @generated
     */
    EAttribute getPhaseTapChangerNonLinear_VoltageStepIncrement();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear#getXMax <em>XMax</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XMax</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear#getXMax()
     * @see #getPhaseTapChangerNonLinear()
     * @generated
     */
    EAttribute getPhaseTapChangerNonLinear_XMax();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear#getXMin <em>XMin</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>XMin</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerNonLinear#getXMin()
     * @see #getPhaseTapChangerNonLinear()
     * @generated
     */
    EAttribute getPhaseTapChangerNonLinear_XMin();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve <em>Emission Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Emission Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve
     * @generated
     */
    EClass getEmissionCurve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve#getEmissionContent <em>Emission Content</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Emission Content</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve#getEmissionContent()
     * @see #getEmissionCurve()
     * @generated
     */
    EAttribute getEmissionCurve_EmissionContent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve#getEmissionType <em>Emission Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Emission Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve#getEmissionType()
     * @see #getEmissionCurve()
     * @generated
     */
    EAttribute getEmissionCurve_EmissionType();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve#getIsNetGrossP <em>Is Net Gross P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Net Gross P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve#getIsNetGrossP()
     * @see #getEmissionCurve()
     * @generated
     */
    EAttribute getEmissionCurve_IsNetGrossP();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve#getThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionCurve#getThermalGeneratingUnit()
     * @see #getEmissionCurve()
     * @generated
     */
    EReference getEmissionCurve_ThermalGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch <em>Equivalent Branch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Equivalent Branch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch
     * @generated
     */
    EClass getEquivalentBranch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getNegativeR12 <em>Negative R12</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Negative R12</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getNegativeR12()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_NegativeR12();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getNegativeR21 <em>Negative R21</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Negative R21</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getNegativeR21()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_NegativeR21();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getNegativeX12 <em>Negative X12</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Negative X12</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getNegativeX12()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_NegativeX12();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getNegativeX21 <em>Negative X21</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Negative X21</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getNegativeX21()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_NegativeX21();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getPositiveR12 <em>Positive R12</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Positive R12</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getPositiveR12()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_PositiveR12();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getPositiveR21 <em>Positive R21</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Positive R21</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getPositiveR21()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_PositiveR21();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getPositiveX12 <em>Positive X12</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Positive X12</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getPositiveX12()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_PositiveX12();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getPositiveX21 <em>Positive X21</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Positive X21</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getPositiveX21()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_PositiveX21();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getR <em>R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getR()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_R();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getR21 <em>R21</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R21</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getR21()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_R21();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getX <em>X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getX()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_X();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getX21 <em>X21</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X21</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getX21()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_X21();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getZeroR12 <em>Zero R12</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Zero R12</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getZeroR12()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_ZeroR12();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getZeroR21 <em>Zero R21</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Zero R21</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getZeroR21()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_ZeroR21();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getZeroX12 <em>Zero X12</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Zero X12</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getZeroX12()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_ZeroX12();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getZeroX21 <em>Zero X21</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Zero X21</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentBranch#getZeroX21()
     * @see #getEquivalentBranch()
     * @generated
     */
    EAttribute getEquivalentBranch_ZeroX21();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PostLineSensor <em>Post Line Sensor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Post Line Sensor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PostLineSensor
     * @generated
     */
    EClass getPostLineSensor();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulationSchedule <em>Regulation Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Regulation Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulationSchedule
     * @generated
     */
    EClass getRegulationSchedule();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulationSchedule#getRegulatingControl <em>Regulating Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Regulating Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulationSchedule#getRegulatingControl()
     * @see #getRegulationSchedule()
     * @generated
     */
    EReference getRegulationSchedule_RegulatingControl();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulationSchedule#getVoltageControlZones <em>Voltage Control Zones</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Voltage Control Zones</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulationSchedule#getVoltageControlZones()
     * @see #getRegulationSchedule()
     * @generated
     */
    EReference getRegulationSchedule_VoltageControlZones();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit <em>Thermal Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Thermal Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit
     * @generated
     */
    EClass getThermalGeneratingUnit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getOMCost <em>OM Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>OM Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getOMCost()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EAttribute getThermalGeneratingUnit_OMCost();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getCAESPlant <em>CAES Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>CAES Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getCAESPlant()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_CAESPlant();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getIncrementalHeatRateCurve <em>Incremental Heat Rate Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Incremental Heat Rate Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getIncrementalHeatRateCurve()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_IncrementalHeatRateCurve();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getFossilFuels <em>Fossil Fuels</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Fossil Fuels</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getFossilFuels()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_FossilFuels();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getEmissionCurves <em>Emission Curves</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Emission Curves</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getEmissionCurves()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_EmissionCurves();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getHeatRateCurve <em>Heat Rate Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Heat Rate Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getHeatRateCurve()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_HeatRateCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getShutdownCurve <em>Shutdown Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Shutdown Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getShutdownCurve()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_ShutdownCurve();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getEmmissionAccounts <em>Emmission Accounts</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Emmission Accounts</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getEmmissionAccounts()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_EmmissionAccounts();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getStartupModel <em>Startup Model</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Startup Model</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getStartupModel()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_StartupModel();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getCombinedCyclePlant <em>Combined Cycle Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Combined Cycle Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getCombinedCyclePlant()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_CombinedCyclePlant();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getFuelAllocationSchedules <em>Fuel Allocation Schedules</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Fuel Allocation Schedules</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getFuelAllocationSchedules()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_FuelAllocationSchedules();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getCogenerationPlant <em>Cogeneration Plant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Cogeneration Plant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getCogenerationPlant()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_CogenerationPlant();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getHeatInputCurve <em>Heat Input Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Heat Input Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ThermalGeneratingUnit#getHeatInputCurve()
     * @see #getThermalGeneratingUnit()
     * @generated
     */
    EReference getThermalGeneratingUnit_HeatInputCurve();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit <em>Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit
     * @generated
     */
    EClass getGeneratingUnit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getAllocSpinResP <em>Alloc Spin Res P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Alloc Spin Res P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getAllocSpinResP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_AllocSpinResP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getAutoCntrlMarginP <em>Auto Cntrl Margin P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Auto Cntrl Margin P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getAutoCntrlMarginP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_AutoCntrlMarginP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getBaseP <em>Base P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Base P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getBaseP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_BaseP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlDeadband <em>Control Deadband</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control Deadband</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlDeadband()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_ControlDeadband();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlPulseHigh <em>Control Pulse High</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control Pulse High</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlPulseHigh()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_ControlPulseHigh();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlPulseLow <em>Control Pulse Low</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control Pulse Low</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlPulseLow()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_ControlPulseLow();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlResponseRate <em>Control Response Rate</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Control Response Rate</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlResponseRate()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_ControlResponseRate();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getEfficiency <em>Efficiency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Efficiency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getEfficiency()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_Efficiency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGenControlMode <em>Gen Control Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Gen Control Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGenControlMode()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_GenControlMode();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGenControlSource <em>Gen Control Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Gen Control Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGenControlSource()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_GenControlSource();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGovernorMPL <em>Governor MPL</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Governor MPL</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGovernorMPL()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_GovernorMPL();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGovernorSCD <em>Governor SCD</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Governor SCD</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGovernorSCD()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_GovernorSCD();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getHighControlLimit <em>High Control Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>High Control Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getHighControlLimit()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_HighControlLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getInitialP <em>Initial P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Initial P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getInitialP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_InitialP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getLongPF <em>Long PF</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Long PF</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getLongPF()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_LongPF();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getLowControlLimit <em>Low Control Limit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Low Control Limit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getLowControlLimit()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_LowControlLimit();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getLowerRampRate <em>Lower Ramp Rate</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Lower Ramp Rate</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getLowerRampRate()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_LowerRampRate();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMaxEconomicP <em>Max Economic P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Economic P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMaxEconomicP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_MaxEconomicP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMaximumAllowableSpinningReserve <em>Maximum Allowable Spinning Reserve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Maximum Allowable Spinning Reserve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMaximumAllowableSpinningReserve()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_MaximumAllowableSpinningReserve();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMaxOperatingP <em>Max Operating P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Operating P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMaxOperatingP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_MaxOperatingP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMinEconomicP <em>Min Economic P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Economic P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMinEconomicP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_MinEconomicP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMinimumOffTime <em>Minimum Off Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Minimum Off Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMinimumOffTime()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_MinimumOffTime();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMinOperatingP <em>Min Operating P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Operating P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getMinOperatingP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_MinOperatingP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getModelDetail <em>Model Detail</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Model Detail</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getModelDetail()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_ModelDetail();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getNominalP <em>Nominal P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Nominal P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getNominalP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_NominalP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getNormalPF <em>Normal PF</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal PF</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getNormalPF()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_NormalPF();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getPenaltyFactor <em>Penalty Factor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Penalty Factor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getPenaltyFactor()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_PenaltyFactor();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRaiseRampRate <em>Raise Ramp Rate</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Raise Ramp Rate</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRaiseRampRate()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_RaiseRampRate();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRatedGrossMaxP <em>Rated Gross Max P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Gross Max P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRatedGrossMaxP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_RatedGrossMaxP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRatedGrossMinP <em>Rated Gross Min P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Gross Min P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRatedGrossMinP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_RatedGrossMinP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRatedNetMaxP <em>Rated Net Max P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Rated Net Max P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRatedNetMaxP()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_RatedNetMaxP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getShortPF <em>Short PF</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Short PF</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getShortPF()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_ShortPF();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getStartupCost <em>Startup Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Startup Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getStartupCost()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_StartupCost();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getStartupTime <em>Startup Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Startup Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getStartupTime()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_StartupTime();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getTieLinePF <em>Tie Line PF</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Tie Line PF</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getTieLinePF()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_TieLinePF();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getTotalEfficiency <em>Total Efficiency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Total Efficiency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getTotalEfficiency()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_TotalEfficiency();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getVariableCost <em>Variable Cost</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Variable Cost</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getVariableCost()
     * @see #getGeneratingUnit()
     * @generated
     */
    EAttribute getGeneratingUnit_VariableCost();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGenUnitOpSchedule <em>Gen Unit Op Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Gen Unit Op Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGenUnitOpSchedule()
     * @see #getGeneratingUnit()
     * @generated
     */
    EReference getGeneratingUnit_GenUnitOpSchedule();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGrossToNetActivePowerCurves <em>Gross To Net Active Power Curves</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Gross To Net Active Power Curves</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGrossToNetActivePowerCurves()
     * @see #getGeneratingUnit()
     * @generated
     */
    EReference getGeneratingUnit_GrossToNetActivePowerCurves();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlAreaGeneratingUnit <em>Control Area Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Control Area Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getControlAreaGeneratingUnit()
     * @see #getGeneratingUnit()
     * @generated
     */
    EReference getGeneratingUnit_ControlAreaGeneratingUnit();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRotatingMachine <em>Rotating Machine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Rotating Machine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getRotatingMachine()
     * @see #getGeneratingUnit()
     * @generated
     */
    EReference getGeneratingUnit_RotatingMachine();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGenUnitOpCostCurves <em>Gen Unit Op Cost Curves</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Gen Unit Op Cost Curves</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratingUnit#getGenUnitOpCostCurves()
     * @see #getGeneratingUnit()
     * @generated
     */
    EReference getGeneratingUnit_GenUnitOpCostCurves();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl <em>Tap Changer Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Tap Changer Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl
     * @generated
     */
    EClass getTapChangerControl();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getLimitVoltage <em>Limit Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Limit Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getLimitVoltage()
     * @see #getTapChangerControl()
     * @generated
     */
    EAttribute getTapChangerControl_LimitVoltage();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getLineDropCompensation <em>Line Drop Compensation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Line Drop Compensation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getLineDropCompensation()
     * @see #getTapChangerControl()
     * @generated
     */
    EAttribute getTapChangerControl_LineDropCompensation();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getLineDropR <em>Line Drop R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Line Drop R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getLineDropR()
     * @see #getTapChangerControl()
     * @generated
     */
    EAttribute getTapChangerControl_LineDropR();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getLineDropX <em>Line Drop X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Line Drop X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getLineDropX()
     * @see #getTapChangerControl()
     * @generated
     */
    EAttribute getTapChangerControl_LineDropX();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getReverseLineDropR <em>Reverse Line Drop R</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reverse Line Drop R</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getReverseLineDropR()
     * @see #getTapChangerControl()
     * @generated
     */
    EAttribute getTapChangerControl_ReverseLineDropR();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getReverseLineDropX <em>Reverse Line Drop X</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reverse Line Drop X</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getReverseLineDropX()
     * @see #getTapChangerControl()
     * @generated
     */
    EAttribute getTapChangerControl_ReverseLineDropX();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getTapChanger <em>Tap Changer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Tap Changer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TapChangerControl#getTapChanger()
     * @see #getTapChangerControl()
     * @generated
     */
    EReference getTapChangerControl_TapChanger();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentEquipment <em>Equivalent Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Equivalent Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentEquipment
     * @generated
     */
    EClass getEquivalentEquipment();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentEquipment#getEquivalentNetwork <em>Equivalent Network</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Equivalent Network</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentEquipment#getEquivalentNetwork()
     * @see #getEquivalentEquipment()
     * @generated
     */
    EReference getEquivalentEquipment_EquivalentNetwork();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Connector <em>Connector</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Connector</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Connector
     * @generated
     */
    EClass getConnector();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule <em>Regular Interval Schedule</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Regular Interval Schedule</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule
     * @generated
     */
    EClass getRegularIntervalSchedule();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule#getEndTime <em>End Time</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>End Time</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule#getEndTime()
     * @see #getRegularIntervalSchedule()
     * @generated
     */
    EAttribute getRegularIntervalSchedule_EndTime();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule#getTimeStep <em>Time Step</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Time Step</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule#getTimeStep()
     * @see #getRegularIntervalSchedule()
     * @generated
     */
    EAttribute getRegularIntervalSchedule_TimeStep();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule#getTimePoints <em>Time Points</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Time Points</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegularIntervalSchedule#getTimePoints()
     * @see #getRegularIntervalSchedule()
     * @generated
     */
    EReference getRegularIntervalSchedule_TimePoints();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChanger <em>Phase Tap Changer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Phase Tap Changer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChanger
     * @generated
     */
    EClass getPhaseTapChanger();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChanger#getTransformerEnd <em>Transformer End</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Transformer End</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChanger#getTransformerEnd()
     * @see #getPhaseTapChanger()
     * @generated
     */
    EReference getPhaseTapChanger_TransformerEnd();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete <em>Discrete</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Discrete</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete
     * @generated
     */
    EClass getDiscrete();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getMaxValue <em>Max Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getMaxValue()
     * @see #getDiscrete()
     * @generated
     */
    EAttribute getDiscrete_MaxValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getMinValue <em>Min Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getMinValue()
     * @see #getDiscrete()
     * @generated
     */
    EAttribute getDiscrete_MinValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getNormalValue <em>Normal Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Normal Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getNormalValue()
     * @see #getDiscrete()
     * @generated
     */
    EAttribute getDiscrete_NormalValue();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getValueAliasSet <em>Value Alias Set</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Value Alias Set</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getValueAliasSet()
     * @see #getDiscrete()
     * @generated
     */
    EReference getDiscrete_ValueAliasSet();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getDiscreteValues <em>Discrete Values</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Discrete Values</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Discrete#getDiscreteValues()
     * @see #getDiscrete()
     * @generated
     */
    EReference getDiscrete_DiscreteValues();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalIsland <em>DC Topological Island</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Topological Island</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalIsland
     * @generated
     */
    EClass getDCTopologicalIsland();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalIsland#getDCTopologicalNodes <em>DC Topological Nodes</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Topological Nodes</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCTopologicalIsland#getDCTopologicalNodes()
     * @see #getDCTopologicalIsland()
     * @generated
     */
    EReference getDCTopologicalIsland_DCTopologicalNodes();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Sensor <em>Sensor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sensor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Sensor
     * @generated
     */
    EClass getSensor();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow <em>Sv Power Flow</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Sv Power Flow</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow
     * @generated
     */
    EClass getSvPowerFlow();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow#getP <em>P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow#getP()
     * @see #getSvPowerFlow()
     * @generated
     */
    EAttribute getSvPowerFlow_P();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow#getQ <em>Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow#getQ()
     * @see #getSvPowerFlow()
     * @generated
     */
    EAttribute getSvPowerFlow_Q();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SvPowerFlow#getTerminal()
     * @see #getSvPowerFlow()
     * @generated
     */
    EReference getSvPowerFlow_Terminal();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup <em>Branch Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Branch Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup
     * @generated
     */
    EClass getBranchGroup();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMaximumActivePower <em>Maximum Active Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Maximum Active Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMaximumActivePower()
     * @see #getBranchGroup()
     * @generated
     */
    EAttribute getBranchGroup_MaximumActivePower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMaximumReactivePower <em>Maximum Reactive Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Maximum Reactive Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMaximumReactivePower()
     * @see #getBranchGroup()
     * @generated
     */
    EAttribute getBranchGroup_MaximumReactivePower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMinimumActivePower <em>Minimum Active Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Minimum Active Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMinimumActivePower()
     * @see #getBranchGroup()
     * @generated
     */
    EAttribute getBranchGroup_MinimumActivePower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMinimumReactivePower <em>Minimum Reactive Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Minimum Reactive Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMinimumReactivePower()
     * @see #getBranchGroup()
     * @generated
     */
    EAttribute getBranchGroup_MinimumReactivePower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMonitorActivePower <em>Monitor Active Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Monitor Active Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMonitorActivePower()
     * @see #getBranchGroup()
     * @generated
     */
    EAttribute getBranchGroup_MonitorActivePower();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMonitorReactivePower <em>Monitor Reactive Power</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Monitor Reactive Power</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getMonitorReactivePower()
     * @see #getBranchGroup()
     * @generated
     */
    EAttribute getBranchGroup_MonitorReactivePower();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getBranchGroupTerminal <em>Branch Group Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Branch Group Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BranchGroup#getBranchGroupTerminal()
     * @see #getBranchGroup()
     * @generated
     */
    EReference getBranchGroup_BranchGroupTerminal();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode <em>Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode
     * @generated
     */
    EClass getTopologicalNode();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getPInjection <em>PInjection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PInjection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getPInjection()
     * @see #getTopologicalNode()
     * @generated
     */
    EAttribute getTopologicalNode_PInjection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getQInjection <em>QInjection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QInjection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getQInjection()
     * @see #getTopologicalNode()
     * @generated
     */
    EAttribute getTopologicalNode_QInjection();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getAngleRefTopologicalIsland <em>Angle Ref Topological Island</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Angle Ref Topological Island</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getAngleRefTopologicalIsland()
     * @see #getTopologicalNode()
     * @generated
     */
    EReference getTopologicalNode_AngleRefTopologicalIsland();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getConnectivityNodeContainer <em>Connectivity Node Container</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Connectivity Node Container</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getConnectivityNodeContainer()
     * @see #getTopologicalNode()
     * @generated
     */
    EReference getTopologicalNode_ConnectivityNodeContainer();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getBaseVoltage <em>Base Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getBaseVoltage()
     * @see #getTopologicalNode()
     * @generated
     */
    EReference getTopologicalNode_BaseVoltage();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getConnectivityNodes <em>Connectivity Nodes</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Connectivity Nodes</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getConnectivityNodes()
     * @see #getTopologicalNode()
     * @generated
     */
    EReference getTopologicalNode_ConnectivityNodes();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getSvVoltage <em>Sv Voltage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Sv Voltage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getSvVoltage()
     * @see #getTopologicalNode()
     * @generated
     */
    EReference getTopologicalNode_SvVoltage();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getTopologicalIsland <em>Topological Island</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Topological Island</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getTopologicalIsland()
     * @see #getTopologicalNode()
     * @generated
     */
    EReference getTopologicalNode_TopologicalIsland();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getTerminal <em>Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getTerminal()
     * @see #getTopologicalNode()
     * @generated
     */
    EReference getTopologicalNode_Terminal();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getSvInjection <em>Sv Injection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Sv Injection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TopologicalNode#getSvInjection()
     * @see #getTopologicalNode()
     * @generated
     */
    EReference getTopologicalNode_SvInjection();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Subcritical <em>Subcritical</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Subcritical</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Subcritical
     * @generated
     */
    EClass getSubcritical();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue <em>Accumulator Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Accumulator Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue
     * @generated
     */
    EClass getAccumulatorValue();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue#getValue()
     * @see #getAccumulatorValue()
     * @generated
     */
    EAttribute getAccumulatorValue_Value();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue#getAccumulator <em>Accumulator</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Accumulator</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue#getAccumulator()
     * @see #getAccumulatorValue()
     * @generated
     */
    EReference getAccumulatorValue_Accumulator();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue#getAccumulatorReset <em>Accumulator Reset</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Accumulator Reset</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AccumulatorValue#getAccumulatorReset()
     * @see #getAccumulatorValue()
     * @generated
     */
    EReference getAccumulatorValue_AccumulatorReset();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StationSupply <em>Station Supply</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Station Supply</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.StationSupply
     * @generated
     */
    EClass getStationSupply();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentNetwork <em>Equivalent Network</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Equivalent Network</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentNetwork
     * @generated
     */
    EClass getEquivalentNetwork();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentNetwork#getEquivalentEquipments <em>Equivalent Equipments</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Equivalent Equipments</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EquivalentNetwork#getEquivalentEquipments()
     * @see #getEquivalentNetwork()
     * @generated
     */
    EReference getEquivalentNetwork_EquivalentEquipments();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SolarGeneratingUnit <em>Solar Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Solar Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SolarGeneratingUnit
     * @generated
     */
    EClass getSolarGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCEquipmentContainer <em>DC Equipment Container</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Equipment Container</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCEquipmentContainer
     * @generated
     */
    EClass getDCEquipmentContainer();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCEquipmentContainer#getDCNodes <em>DC Nodes</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Nodes</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCEquipmentContainer#getDCNodes()
     * @see #getDCEquipmentContainer()
     * @generated
     */
    EReference getDCEquipmentContainer_DCNodes();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCEquipmentContainer#getDCTopologicalNode <em>DC Topological Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Topological Node</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCEquipmentContainer#getDCTopologicalNode()
     * @see #getDCEquipmentContainer()
     * @generated
     */
    EReference getDCEquipmentContainer_DCTopologicalNode();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConductingEquipment <em>DC Conducting Equipment</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>DC Conducting Equipment</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConductingEquipment
     * @generated
     */
    EClass getDCConductingEquipment();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConductingEquipment#getDCTerminals <em>DC Terminals</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>DC Terminals</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConductingEquipment#getDCTerminals()
     * @see #getDCConductingEquipment()
     * @generated
     */
    EReference getDCConductingEquipment_DCTerminals();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Jumper <em>Jumper</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Jumper</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Jumper
     * @generated
     */
    EClass getJumper();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthLineParameter <em>Per Length Line Parameter</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Per Length Line Parameter</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PerLengthLineParameter
     * @generated
     */
    EClass getPerLengthLineParameter();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerAsymmetrical <em>Phase Tap Changer Asymmetrical</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Phase Tap Changer Asymmetrical</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerAsymmetrical
     * @generated
     */
    EClass getPhaseTapChangerAsymmetrical();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerAsymmetrical#getWindingConnectionAngle <em>Winding Connection Angle</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Winding Connection Angle</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerAsymmetrical#getWindingConnectionAngle()
     * @see #getPhaseTapChangerAsymmetrical()
     * @generated
     */
    EAttribute getPhaseTapChangerAsymmetrical_WindingConnectionAngle();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReportingSuperGroup <em>Reporting Super Group</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Reporting Super Group</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ReportingSuperGroup
     * @generated
     */
    EClass getReportingSuperGroup();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter <em>Vs Converter</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Vs Converter</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter
     * @generated
     */
    EClass getVsConverter();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getDelta <em>Delta</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Delta</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getDelta()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_Delta();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getDroop <em>Droop</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Droop</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getDroop()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_Droop();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getDroopCompensation <em>Droop Compensation</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Droop Compensation</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getDroopCompensation()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_DroopCompensation();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getMaxModulationIndex <em>Max Modulation Index</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Modulation Index</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getMaxModulationIndex()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_MaxModulationIndex();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getMaxValveCurrent <em>Max Valve Current</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Valve Current</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getMaxValveCurrent()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_MaxValveCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getPPccControl <em>PPcc Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>PPcc Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getPPccControl()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_PPccControl();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getQPccControl <em>QPcc Control</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QPcc Control</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getQPccControl()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_QPccControl();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getQShare <em>QShare</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>QShare</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getQShare()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_QShare();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getTargetQpcc <em>Target Qpcc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Qpcc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getTargetQpcc()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_TargetQpcc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getTargetUpcc <em>Target Upcc</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Target Upcc</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getTargetUpcc()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_TargetUpcc();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getUf <em>Uf</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Uf</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getUf()
     * @see #getVsConverter()
     * @generated
     */
    EAttribute getVsConverter_Uf();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getCapabilityCurve <em>Capability Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Capability Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsConverter#getCapabilityCurve()
     * @see #getVsConverter()
     * @generated
     */
    EReference getVsConverter_CapabilityCurve();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CTTempActivePowerCurve <em>CT Temp Active Power Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>CT Temp Active Power Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CTTempActivePowerCurve
     * @generated
     */
    EClass getCTTempActivePowerCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CTTempActivePowerCurve#getCombustionTurbine <em>Combustion Turbine</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Combustion Turbine</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CTTempActivePowerCurve#getCombustionTurbine()
     * @see #getCTTempActivePowerCurve()
     * @generated
     */
    EReference getCTTempActivePowerCurve_CombustionTurbine();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare <em>Operating Share</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Operating Share</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare
     * @generated
     */
    EClass getOperatingShare();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare#getPercentage <em>Percentage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Percentage</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare#getPercentage()
     * @see #getOperatingShare()
     * @generated
     */
    EAttribute getOperatingShare_Percentage();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare#getOperatingParticipant <em>Operating Participant</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Operating Participant</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare#getOperatingParticipant()
     * @see #getOperatingShare()
     * @generated
     */
    EReference getOperatingShare_OperatingParticipant();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare#getPowerSystemResource <em>Power System Resource</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Power System Resource</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperatingShare#getPowerSystemResource()
     * @see #getOperatingShare()
     * @generated
     */
    EReference getOperatingShare_PowerSystemResource();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTabular <em>Phase Tap Changer Tabular</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Phase Tap Changer Tabular</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTabular
     * @generated
     */
    EClass getPhaseTapChangerTabular();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTabular#getPhaseTapChangerTable <em>Phase Tap Changer Table</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Phase Tap Changer Table</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseTapChangerTabular#getPhaseTapChangerTable()
     * @see #getPhaseTapChangerTabular()
     * @generated
     */
    EReference getPhaseTapChangerTabular_PhaseTapChangerTable();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint <em>Nonlinear Shunt Compensator Phase Point</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Nonlinear Shunt Compensator Phase Point</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint
     * @generated
     */
    EClass getNonlinearShuntCompensatorPhasePoint();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint#getB <em>B</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint#getB()
     * @see #getNonlinearShuntCompensatorPhasePoint()
     * @generated
     */
    EAttribute getNonlinearShuntCompensatorPhasePoint_B();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint#getG <em>G</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint#getG()
     * @see #getNonlinearShuntCompensatorPhasePoint()
     * @generated
     */
    EAttribute getNonlinearShuntCompensatorPhasePoint_G();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint#getSectionNumber <em>Section Number</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Section Number</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint#getSectionNumber()
     * @see #getNonlinearShuntCompensatorPhasePoint()
     * @generated
     */
    EAttribute getNonlinearShuntCompensatorPhasePoint_SectionNumber();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint#getNonlinearShuntCompensatorPhase <em>Nonlinear Shunt Compensator Phase</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Nonlinear Shunt Compensator Phase</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.NonlinearShuntCompensatorPhasePoint#getNonlinearShuntCompensatorPhase()
     * @see #getNonlinearShuntCompensatorPhasePoint()
     * @generated
     */
    EReference getNonlinearShuntCompensatorPhasePoint_NonlinearShuntCompensatorPhase();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Junction <em>Junction</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Junction</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Junction
     * @generated
     */
    EClass getJunction();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTank <em>Transformer Tank</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Transformer Tank</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTank
     * @generated
     */
    EClass getTransformerTank();

    /**
     * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTank#getTransformerTankEnds <em>Transformer Tank Ends</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Transformer Tank Ends</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTank#getTransformerTankEnds()
     * @see #getTransformerTank()
     * @generated
     */
    EReference getTransformerTank_TransformerTankEnds();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTank#getPowerTransformer <em>Power Transformer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Power Transformer</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerTank#getPowerTransformer()
     * @see #getTransformerTank()
     * @generated
     */
    EReference getTransformerTank_PowerTransformer();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TailbayLossCurve <em>Tailbay Loss Curve</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Tailbay Loss Curve</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TailbayLossCurve
     * @generated
     */
    EClass getTailbayLossCurve();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TailbayLossCurve#getHydroGeneratingUnit <em>Hydro Generating Unit</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Hydro Generating Unit</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TailbayLossCurve#getHydroGeneratingUnit()
     * @see #getTailbayLossCurve()
     * @generated
     */
    EReference getTailbayLossCurve_HydroGeneratingUnit();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling <em>Mutual Coupling</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Mutual Coupling</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling
     * @generated
     */
    EClass getMutualCoupling();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getB0ch <em>B0ch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>B0ch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getB0ch()
     * @see #getMutualCoupling()
     * @generated
     */
    EAttribute getMutualCoupling_B0ch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getDistance11 <em>Distance11</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Distance11</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getDistance11()
     * @see #getMutualCoupling()
     * @generated
     */
    EAttribute getMutualCoupling_Distance11();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getDistance12 <em>Distance12</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Distance12</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getDistance12()
     * @see #getMutualCoupling()
     * @generated
     */
    EAttribute getMutualCoupling_Distance12();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getDistance21 <em>Distance21</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Distance21</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getDistance21()
     * @see #getMutualCoupling()
     * @generated
     */
    EAttribute getMutualCoupling_Distance21();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getDistance22 <em>Distance22</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Distance22</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getDistance22()
     * @see #getMutualCoupling()
     * @generated
     */
    EAttribute getMutualCoupling_Distance22();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getG0ch <em>G0ch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>G0ch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getG0ch()
     * @see #getMutualCoupling()
     * @generated
     */
    EAttribute getMutualCoupling_G0ch();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getR0 <em>R0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>R0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getR0()
     * @see #getMutualCoupling()
     * @generated
     */
    EAttribute getMutualCoupling_R0();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getX0 <em>X0</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>X0</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getX0()
     * @see #getMutualCoupling()
     * @generated
     */
    EAttribute getMutualCoupling_X0();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getSecond_Terminal <em>Second Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Second Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getSecond_Terminal()
     * @see #getMutualCoupling()
     * @generated
     */
    EReference getMutualCoupling_Second_Terminal();

    /**
     * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getFirst_Terminal <em>First Terminal</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>First Terminal</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.MutualCoupling#getFirst_Terminal()
     * @see #getMutualCoupling()
     * @generated
     */
    EReference getMutualCoupling_First_Terminal();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadBreakSwitch <em>Load Break Switch</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Load Break Switch</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.LoadBreakSwitch
     * @generated
     */
    EClass getLoadBreakSwitch();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Conductor <em>Conductor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Conductor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Conductor
     * @generated
     */
    EClass getConductor();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Conductor#getLength <em>Length</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Length</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Conductor#getLength()
     * @see #getConductor()
     * @generated
     */
    EAttribute getConductor_Length();

    /**
     * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection <em>External Network Injection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>External Network Injection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection
     * @generated
     */
    EClass getExternalNetworkInjection();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getGovernorSCD <em>Governor SCD</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Governor SCD</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getGovernorSCD()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_GovernorSCD();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getIkSecond <em>Ik Second</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ik Second</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getIkSecond()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_IkSecond();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxInitialSymShCCurrent <em>Max Initial Sym Sh CCurrent</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Initial Sym Sh CCurrent</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxInitialSymShCCurrent()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MaxInitialSymShCCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxP <em>Max P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxP()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MaxP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxQ <em>Max Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxQ()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MaxQ();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxR0ToX0Ratio <em>Max R0 To X0 Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max R0 To X0 Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxR0ToX0Ratio()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MaxR0ToX0Ratio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxR1ToX1Ratio <em>Max R1 To X1 Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max R1 To X1 Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxR1ToX1Ratio()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MaxR1ToX1Ratio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxZ0ToZ1Ratio <em>Max Z0 To Z1 Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Max Z0 To Z1 Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMaxZ0ToZ1Ratio()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MaxZ0ToZ1Ratio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinInitialSymShCCurrent <em>Min Initial Sym Sh CCurrent</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Initial Sym Sh CCurrent</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinInitialSymShCCurrent()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MinInitialSymShCCurrent();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinP <em>Min P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinP()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MinP();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinQ <em>Min Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinQ()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MinQ();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinR0ToX0Ratio <em>Min R0 To X0 Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min R0 To X0 Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinR0ToX0Ratio()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MinR0ToX0Ratio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinR1ToX1Ratio <em>Min R1 To X1 Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min R1 To X1 Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinR1ToX1Ratio()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MinR1ToX1Ratio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinZ0ToZ1Ratio <em>Min Z0 To Z1 Ratio</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Min Z0 To Z1 Ratio</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getMinZ0ToZ1Ratio()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_MinZ0ToZ1Ratio();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getP <em>P</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>P</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getP()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_P();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getQ <em>Q</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Q</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getQ()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_Q();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getReferencePriority <em>Reference Priority</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Reference Priority</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getReferencePriority()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_ReferencePriority();

    /**
     * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getVoltageFactor <em>Voltage Factor</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Voltage Factor</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ExternalNetworkInjection#getVoltageFactor()
     * @see #getExternalNetworkInjection()
     * @generated
     */
    EAttribute getExternalNetworkInjection_VoltageFactor();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BreakerConfiguration <em>Breaker Configuration</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Breaker Configuration</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BreakerConfiguration
     * @generated
     */
    EEnum getBreakerConfiguration();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SVCControlMode <em>SVC Control Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>SVC Control Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SVCControlMode
     * @generated
     */
    EEnum getSVCControlMode();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipmentStatusKind <em>Contingency Equipment Status Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Contingency Equipment Status Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ContingencyEquipmentStatusKind
     * @generated
     */
    EEnum getContingencyEquipmentStatusKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachineOperatingMode <em>Synchronous Machine Operating Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Synchronous Machine Operating Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachineOperatingMode
     * @generated
     */
    EEnum getSynchronousMachineOperatingMode();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGenUnitKind <em>Wind Gen Unit Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Wind Gen Unit Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindGenUnitKind
     * @generated
     */
    EEnum getWindGenUnitKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnitType <em>Remote Unit Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Remote Unit Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RemoteUnitType
     * @generated
     */
    EEnum getRemoteUnitType();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformerKind <em>Potential Transformer Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Potential Transformer Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PotentialTransformerKind
     * @generated
     */
    EEnum getPotentialTransformerKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerControlMode <em>Transformer Control Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Transformer Control Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TransformerControlMode
     * @generated
     */
    EEnum getTransformerControlMode();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseShuntConnectionKind <em>Phase Shunt Connection Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Phase Shunt Connection Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseShuntConnectionKind
     * @generated
     */
    EEnum getPhaseShuntConnectionKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratorControlSource <em>Generator Control Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Generator Control Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratorControlSource
     * @generated
     */
    EEnum getGeneratorControlSource();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseCode <em>Phase Code</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Phase Code</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseCode
     * @generated
     */
    EEnum getPhaseCode();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BoilerControlMode <em>Boiler Control Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Boiler Control Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BoilerControlMode
     * @generated
     */
    EEnum getBoilerControlMode();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroEnergyConversionKind <em>Hydro Energy Conversion Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Hydro Energy Conversion Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroEnergyConversionKind
     * @generated
     */
    EEnum getHydroEnergyConversionKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachineKind <em>Asynchronous Machine Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Asynchronous Machine Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.AsynchronousMachineKind
     * @generated
     */
    EEnum getAsynchronousMachineKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Source <em>Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Source
     * @generated
     */
    EEnum getSource();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.UnitSymbol <em>Unit Symbol</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Unit Symbol</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.UnitSymbol
     * @generated
     */
    EEnum getUnitSymbol();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseConnectedFaultKind <em>Phase Connected Fault Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Phase Connected Fault Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PhaseConnectedFaultKind
     * @generated
     */
    EEnum getPhaseConnectedFaultKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarConfiguration <em>Busbar Configuration</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Busbar Configuration</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.BusbarConfiguration
     * @generated
     */
    EEnum getBusbarConfiguration();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitDirectionKind <em>Operational Limit Direction Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Operational Limit Direction Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OperationalLimitDirectionKind
     * @generated
     */
    EEnum getOperationalLimitDirectionKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratorControlMode <em>Generator Control Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Generator Control Mode</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.GeneratorControlMode
     * @generated
     */
    EEnum getGeneratorControlMode();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionValueSource <em>Emission Value Source</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Emission Value Source</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionValueSource
     * @generated
     */
    EEnum getEmissionValueSource();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CoolantType <em>Coolant Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Coolant Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CoolantType
     * @generated
     */
    EEnum getCoolantType();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCPolarityKind <em>DC Polarity Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>DC Polarity Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCPolarityKind
     * @generated
     */
    EEnum getDCPolarityKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsQpccControlKind <em>Vs Qpcc Control Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Vs Qpcc Control Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsQpccControlKind
     * @generated
     */
    EEnum getVsQpccControlKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachineKind <em>Synchronous Machine Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Synchronous Machine Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SynchronousMachineKind
     * @generated
     */
    EEnum getSynchronousMachineKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPlantStorageKind <em>Hydro Plant Storage Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Hydro Plant Storage Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.HydroPlantStorageKind
     * @generated
     */
    EEnum getHydroPlantStorageKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterOperatingModeKind <em>DC Converter Operating Mode Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>DC Converter Operating Mode Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.DCConverterOperatingModeKind
     * @generated
     */
    EEnum getDCConverterOperatingModeKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsOperatingModeKind <em>Cs Operating Mode Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Cs Operating Mode Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsOperatingModeKind
     * @generated
     */
    EEnum getCsOperatingModeKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShortCircuitRotorKind <em>Short Circuit Rotor Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Short Circuit Rotor Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ShortCircuitRotorKind
     * @generated
     */
    EEnum getShortCircuitRotorKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaTypeKind <em>Control Area Type Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Control Area Type Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.ControlAreaTypeKind
     * @generated
     */
    EEnum getControlAreaTypeKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SinglePhaseKind <em>Single Phase Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Single Phase Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.SinglePhaseKind
     * @generated
     */
    EEnum getSinglePhaseKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsPpccControlKind <em>Cs Ppcc Control Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Cs Ppcc Control Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CsPpccControlKind
     * @generated
     */
    EEnum getCsPpccControlKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoilModeKind <em>Petersen Coil Mode Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Petersen Coil Mode Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.PetersenCoilModeKind
     * @generated
     */
    EEnum getPetersenCoilModeKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionType <em>Emission Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Emission Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.EmissionType
     * @generated
     */
    EEnum getEmissionType();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsPpccControlKind <em>Vs Ppcc Control Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Vs Ppcc Control Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.VsPpccControlKind
     * @generated
     */
    EEnum getVsPpccControlKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Currency <em>Currency</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Currency</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Currency
     * @generated
     */
    EEnum getCurrency();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelType <em>Fuel Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Fuel Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.FuelType
     * @generated
     */
    EEnum getFuelType();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TurbineType <em>Turbine Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Turbine Type</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.TurbineType
     * @generated
     */
    EEnum getTurbineType();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Validity <em>Validity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Validity</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.Validity
     * @generated
     */
    EEnum getValidity();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.UnitMultiplier <em>Unit Multiplier</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Unit Multiplier</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.UnitMultiplier
     * @generated
     */
    EEnum getUnitMultiplier();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OrientationKind <em>Orientation Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Orientation Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.OrientationKind
     * @generated
     */
    EEnum getOrientationKind();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveStyle <em>Curve Style</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Curve Style</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.CurveStyle
     * @generated
     */
    EEnum getCurveStyle();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindingConnection <em>Winding Connection</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Winding Connection</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.WindingConnection
     * @generated
     */
    EEnum getWindingConnection();

    /**
     * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControlModeKind <em>Regulating Control Mode Kind</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Regulating Control Mode Kind</em>'.
     * @see fr.centralesupelec.edf.riseclipse.cim.cim16.iec61970cim16v33.cim.RegulatingControlModeKind
     * @generated
     */
    EEnum getRegulatingControlModeKind();

    /**
     * Returns the factory that creates the instances of the model.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the factory that creates the instances of the model.
     * @generated
     */
    CimFactory getCimFactory();

} //CimPackage
